<?php

namespace Easy_Query;

function prepare_insert_query_sql($tableName = '', $data = array()) {
	$keys = array();
	$values = array();

	foreach ($data as $key => $value) {
		//  Add Item to Array
		$keys[] = $key;
		$values[] = "'". \rp_escape_sql($value) . "'";
	}
	$key_string = join(', ', $keys);
	$value_string = join(', ', $values);

	$sql = "INSERT INTO $tableName ($key_string) VALUES ($value_string);";

	return $sql;
}

function insert_transaction($table_name = '', $data = array()) {
	global $rpQuery;
	$results = array();
	$m_ids = array();
	if(isset($rpQuery)) {
		$rpQuery->query('START TRANSACTION');
		if(isset($data[0])) {
			foreach ($data as $_key => $_value) {
				if(isset($_value['m_id'])) {
					if(array_search($_value['m_id'], $m_ids) !== FALSE) {
						continue;
					} else {
						$m_ids[] = $_value['m_id'];
					}
				}
				$prepared_sql = prepare_insert_query_sql($table_name, $_value);
				$results[] = $rpQuery->query($prepared_sql) !== FALSE;
			}
		} else if(!empty($data)) {
			$prepared_sql = prepare_insert_query_sql($table_name, $data);
			$results[] = $rpQuery->query($prepared_sql) !== FALSE;
		} else {

		}
		$rpQuery->query('COMMIT');
	}
	return array_search(FALSE, $results) === FALSE;
}

function select_where($table_name = '', $where = array(), $select = '*', $limit = FALSE) {
	$db = new Select();
	$db->select($select);
	if(!empty($where)) {
		foreach ($where as $_key => $_value) {
			$db->where($_key, $_value);
		}
	} else {
		$db->where('1', '1');
	}
	if($limit !== FALSE && $limit > 0) {
		$db->limit($limit);
	}
	$rows = $db->get($table_name);
	if(!empty($rows)) {
		return $rows;
	}
	return array();
}

function get_where($table_name = '', $where = array(), $limit = FALSE) {
	$db = new Select();
	$db->select('*');
	foreach ($where as $_key => $_value) {
		$db->where($_key, $_value);
	}
	if($limit !== FALSE && $limit > 0) {
		$db->limit($limit);
	}
	$rows = $db->get($table_name);
	if(!empty($rows)) {
		return $rows;
	}
	return array();
}

function array_to_object($array = array()) {
	$objects = array();
	foreach ($array as $key => $value) {
		$object = new \stdClass();
		foreach ($value as $_key => $_value) {
			$object->$_key = $_value;
		}
		$objects[] = $object;
	}
	return $objects;
}

function get_results($sql = '', $object = false) {
	$handler = new Easy_Query();
	$handler->query($sql);
	$handler->execute();
	$rows = $handler->get_results();
	if(!empty($rows)) {
		if($object === false) {
			return $rows;
		} else {
			return array_to_object($rows);
		}
	}
	return null;
}


function get_results_object($sql = '', $object = true) {
	$handler = new Easy_Query();
	$handler->query($sql);
	$handler->execute();
	$rows = $handler->get_results();
	if(!empty($rows)) {
		if($object === false) {
			return $rows;
		} else {
			return array_to_object($rows);
		}
	}
	return null;
}
