<?php

if(!class_exists("RP_DynamicPricingAddon")) {

    class RP_DynamicPricingAddon {

        public $plugin_file=WP_REPAIR_PLUGIN_FILE;

        public $responseObj;

        public $licenseMessage;

        public $showMessage=false;

        public static $constructorCalled = FALSE;

        public static $licenseObject = NULL;

        public function __construct() {

            if (self::$constructorCalled === TRUE) {

                return;

            }

            self::$constructorCalled = TRUE;

            $licenseKey=rp_get_option("Repairplugin_dp_lic_Key","");

            $liceEmail=rp_get_option( "Repairplugin_dp_lic_email","");

            RepairpluginDynamic::addOnDelete(function(){

                rp_delete_option("Repairplugin_dp_lic_Key");

            });

            if(RepairpluginDynamic::CheckWPPlugin($licenseKey,$liceEmail,$this->licenseMessage,$this->responseObj,WP_REPAIR_PLUGIN_FILE)){

                define('WP_REPAIR_DYNAMIC_LICENSE_OBJECT', TRUE);

                self::$licenseObject = $this->responseObj;

            }else{

                define('WP_REPAIR_REQUIRE_DYNAMIC_LICENSE', TRUE);

                if(!empty($licenseKey) && !empty($this->licenseMessage)){

                    define('WP_REPAIR_DYNAMIC_LICENSE_MESSAGE', $this->licenseMessage);

                }

                rp_update_option("Repairplugin_dp_lic_Key","") || rp_add_option("Repairplugin_dp_lic_Key","");

            }

        }

        public static function activate_license( $licenseKey = '', $liceEmail = '' ) {

            if( !self::$constructorCalled ) {

                // call the constructor
                new RP_DynamicPricingAddon();

            }

            if( rp_get_option('Repairplugin_dp_lic_Key', FALSE) === FALSE ) {

                // add
                rp_add_option('Repairplugin_dp_lic_Key', $licenseKey);

            } else {

                // update
                rp_update_option('Repairplugin_dp_lic_Key', $licenseKey);

            }

            if( rp_get_option('Repairplugin_dp_lic_email', FALSE) === FALSE ) {

                // add
                rp_add_option('Repairplugin_dp_lic_email', $liceEmail);

            } else {

                // update
                rp_update_option('Repairplugin_dp_lic_email', $liceEmail);

            }

        }

        public static function deactivate_license() {

            if( !self::$constructorCalled ) {

                // call the constructor
                new RP_DynamicPricingAddon();

            }

            $message="";

            if(RepairpluginDynamic::RemoveLicenseKey(WP_REPAIR_PLUGIN_FILE,$message)){

            }

            rp_update_option("Repairplugin_dp_lic_Key","") || rp_add_option("Repairplugin_dp_lic_Key","");

        }

        public static function is_active() {

            if( !self::$constructorCalled ) {

                // call the constructor
                new RP_DynamicPricingAddon();

            }

            return !defined("WP_REPAIR_REQUIRE_DYNAMIC_LICENSE") && !empty( rp_get_option("Repairplugin_dp_lic_Key","") ) && !empty( self::$licenseObject );

        }

    }

}
