(function(window, document, $, undefined){

	function needToAddActiveClass(currentPage = '', thisPage = '') {
		let x = '';
		if(thisPage === 'device') {
			if(currentPage === 'types' || currentPage === 'brands' || currentPage === 'models') {
				x = ' active';
			} else {
				x = '';
			}
		} else {
			if(currentPage === thisPage) {
				x = 'active';
			} else {
				x = '';
			}
		}
		if((currentPage === thisPage) && currentPage === 'types') {
			x += ' one';
		}
		if(thisPage === 'device') {
			x += ' onee';
		}
		if(thisPage === 'repairs') {
			x += ' two';
		}
		if(thisPage === 'finalize') {
			x += ' three';
		}
		completed = isCompletedStep(currentPage, thisPage);
		if(completed) {
			x += ' completed';
		}
		return x;
	}

	function getAllPages() {
		return ['types', 'brands', 'models', 'repairs', 'finalize', 'thanks'];
	}

	function getProgressPercent(currentPage = '') {
		let allPages = getAllPages();
		if(currentPage === 'types') {
			return 15.75 +'%';
		}
		if(currentPage === 'brands') {
			return 25.5 +'%';
		}
		if(currentPage === 'models') {
			return 35.25 +'%';
		}
		if(currentPage === 'repairs') {
			return 75 +'%';
		}
		if(currentPage === 'finalize') {
			return 100 +'%';
		}
		return (allPages.indexOf(currentPage) * 20) + '%';
	}
	function getProgressPercentMQ7(currentPage = '') {
		let allPages = getAllPages();
		if(currentPage === 'types') {
			return 16.75 +'%';
		}
		if(currentPage === 'brands') {
			return 25.5 +'%';
		}
		if(currentPage === 'models') {
			return 34.25 +'%';
		}
		if(currentPage === 'repairs') {
			return 75 +'%';
		}
		if(currentPage === 'finalize') {
			return 100 +'%';
		}
		return (allPages.indexOf(currentPage) * 20) + '%';
	}
	function getProgressPercentMQ5(currentPage = '') {
		let allPages = getAllPages();
		if(currentPage === 'types') {
			return 16.375 +'%';
		}
		if(currentPage === 'brands') {
			return 25.25 +'%';
		}
		if(currentPage === 'models') {
			return 34.125 +'%';
		}
		if(currentPage === 'repairs') {
			return 75 +'%';
		}
		if(currentPage === 'finalize') {
			return 100 +'%';
		}
		return (allPages.indexOf(currentPage) * 20) + '%';
	}
	function getProgressPercentMQ4(currentPage = '') {
		let allPages = getAllPages();
		if(currentPage === 'types') {
			return 16 +'%';
		}
		if(currentPage === 'brands') {
			return 24 +'%';
		}
		if(currentPage === 'models') {
			return 32 +'%';
		}
		if(currentPage === 'repairs') {
			return 75 +'%';
		}
		if(currentPage === 'finalize') {
			return 100 +'%';
		}
		return (allPages.indexOf(currentPage) * 20) + '%';
	}
	function isCompletedStep(currentPage = '', thisPage = '') {
		let allPages = getAllPages();
		currentPage = currentPage.replace('brands', 'types').replace('models', 'types');
		thisPage = thisPage.replace('device', 'types');
		return allPages.indexOf(currentPage) > allPages.indexOf(thisPage);
	}
	function numOrTick(currentPage = '', thisPage = '') {
		let completed = isCompletedStep(currentPage, thisPage);

		if(completed) {
			return window.rp_svg_load_icon('fa-check', 's-17');
		} else {
			if(thisPage === 'types' || thisPage === 'brands' || thisPage === 'models' || thisPage === 'device') {
				return '1';
			} else if(thisPage === 'repairs') {
				return '2';
			} else if(thisPage === 'finalize') {
				return '3';
			}
		}
	}
	function ucwords (str) {
	    return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
	        return $1.toUpperCase();
	    });
	}
	function easyRepeatDivs(what = '', name = '', currentPage = '') {
		let finalize_OR_select = '';
		let translation_string = '';
		if(name === 'order') {
			finalize_OR_select = window.wp_repair_lang['finalize'];
		} else {
			finalize_OR_select = window.wp_repair_lang['select'];
		}
		if( name === 'order' ) {
			translation_string = window.wp_repair_lang['finalize'];
		} else if(name === 'repair') {
			translation_string = window.wp_repair_lang['repairs'];
		} else {
			if( !( (name + '_mobile') in window.wp_repair_lang ) ) {
				translation_string = window.wp_repair_lang[name];
			} else {
				translation_string = window.wp_repair_lang[(name + '_mobile')];
			}
		}
		let template = `<div class="wp-repair-width-20 ${needToAddActiveClass(currentPage, what)}">
			<span class="step-circle">
				<span class="text">${numOrTick(currentPage, what)}</span>
			</span>
			<div class="breaked-ps">
				<p class="select wp-repair-desktop">${finalize_OR_select}</p>
				<p class="select-actual wp-repair-desktop">${window.wp_repair_lang[name]}</p>
				<p class="select-actual wp-repair-mobile-only">${ucwords(translation_string)}</p>
			</div>
		</div>`;
		return template;
	}
	window.theProgressBarOfWPRepairFrontEnd = function(currentPage = '') {
		let progress_bar = `
		<style type="text/css">
			.wp-repair-fe-types-conatiner .wp-repair-width-100 .p-up-arrow,
			.wp-repair-fe-types-conatiner .wp-repair-width-100 .p-bar-text {
				left: ${getProgressPercent(currentPage)};
			}
			.wp-repair-fe-types-conatiner .wp-repair-width-100 .p-bar .p-complete {
				width: ${getProgressPercent(currentPage)};
			}
			.wp-repair-fe-types-conatiner.repair-mq-7 .wp-repair-width-100 .p-bar .p-complete {
				width: ${getProgressPercentMQ7(currentPage)};
			}
			.wp-repair-fe-types-conatiner.repair-mq-5 .wp-repair-width-100 .p-bar .p-complete {
				width: ${getProgressPercentMQ5(currentPage)};
			}
			.wp-repair-fe-types-conatiner.repair-mq-4 .wp-repair-width-100 .p-bar .p-complete {
				width: ${getProgressPercentMQ4(currentPage)};
			}
			.wp-repair-fe-types-conatiner .wp-repair-progressBarMobile .p-up-arrow,
			.wp-repair-fe-types-conatiner .wp-repair-progressBarMobile .p-bar-text {
				top: ${getProgressPercent(currentPage)};
			}
			.wp-repair-fe-types-conatiner .wp-repair-progressBarMobile .p-bar .p-complete {
				height: ${getProgressPercent(currentPage)};
			}
		</style>
		<div class="wp-repair-progress clearfix" style="margin-top:0px">
			<div class="wp-repair-width-100 do-short desktop">
				${easyRepeatDivs('device', 'device', currentPage)}
				${easyRepeatDivs('repairs', 'repair', currentPage)}
				${easyRepeatDivs('finalize', 'order', currentPage)}
				<span class="p-bar"><div class="p-complete"></div></span>
				<span class="p-bar"><div class="p-complete"></div></span>
			</div>
		</div>`;
		return progress_bar;
	}
}(window, document, jQuery));
