/*
Powered by: RepairPlugin.com
Description: Fast and high converting appointment plugin for repair shop owners
*/
jQuery(document).on("wpRepairReady", function(){
	if (window.matchMedia("(max-width: 700px)").matches) {
		jQuery("head > meta[name='viewport']").remove();
		jQuery("head").prepend('<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">');
	}

	jQuery(".wp-repair-search-box-shortcode-container .wp-repair-search-box input").on("focus keyup", function(){
		jQuery(".wp-repair-search-box-shortcode-container").addClass("opened");
	});
	jQuery(".submit-repair-search").on("click", function(){
		if(!jQuery(".wp-repair-search-box-shortcode-container").hasClass("opened")) {
			jQuery(".wp-repair-search-box-shortcode-container").addClass("opened");
			jQuery(".wp-repair-search-box-shortcode-container input[type='text']").focus();
		} else {
			jQuery(document).trigger('mouseup');
		}
	});
});
jQuery(document).on("mouseup",function(e) 
{
    var container = jQuery(".wp-repair-search-box-shortcode-container .wp-repair-search-box");

    // if the target of the click isn't the container nor a descendant of the container
    if (!container.is(e.target) && container.has(e.target).length === 0) 
    {
        jQuery(".wp-repair-search-box-shortcode-container").removeClass("opened");
    }
});

function has_all_keywords(phrase1 = '', phrase2 = '') {
	let phrase1Splitted = phrase1.split(" ");
	let result = true;
	let phrase2Lower = phrase2.toLowerCase();
	phrase1Splitted.forEach(function(item){
		if(item.trim() !== '') {
			if(phrase2Lower.indexOf(item.toLowerCase().trim()) === -1) {
				result = false;
			}
		}
	});
	return result;
}

function sort_closest_results(search = '', arr = []) {
	let exactMatch = [];
	let closest = [];

	arr.forEach(function(item){
		if((item[0] + " "+ item[1]).toLowerCase().indexOf(search.toLowerCase()) !== -1) {
			exactMatch.push(item);
		} else {
			closest.push(item);
		}
	});

	let newArr = [];
	exactMatch.forEach(function(item){
		newArr.push(item);
	});
	closest.forEach(function(item){
		newArr.push(item);
	});

	return newArr;
}

function get_closest_results(search = '', limit = 40) {
	search = search.toLowerCase().replace('wi-fi', 'wifi');
	let closestResults = [];
	let loopWorked = 0;
	if(search !== '' && (search = search.replaceAll(',', ' ').trim()) !== '') {
		if(window.wp_repair_search_bar_data && window.wp_repair_search_bar_data.brands && window.wp_repair_search_bar_data.models) {
			window.wp_repair_search_bar_data.models.forEach(function(item){
				if(loopWorked >= limit) {
					return closestResults;
				}
				let brandName = '';
				if(item.brand_id_fk && window.wp_repair_search_bar_data.brands[item.brand_id_fk]) {
					brandName = window.wp_repair_search_bar_data.brands[item.brand_id_fk];
				}
				let modelName = item.m_name;
				let modelCode = item.m_code;

				// replace all &quot; with "
				modelName = modelName.replaceAll('&quot;', '"');

				let hasAdded = false;

				if(brandName.toLowerCase().trim() === 'apple') {
					if(has_all_keywords(search, (brandName+' '+modelName).toLowerCase().replace('wi-fi', 'wifi')) || has_all_keywords(search, (brandName+' '+modelName).toLowerCase().replace('wi-fi', 'wifi').replace('iphone x', 'iphone 10'))) {
						closestResults.push([brandName, modelName, item.url]);
						loopWorked++;
						hasAdded = true;
					}
				} else {
					if(has_all_keywords(search, (brandName+' '+modelName).toLowerCase().replace('wi-fi', 'wifi'))) {
						closestResults.push([brandName, modelName, item.url]);
						loopWorked++;
						hasAdded = true;
					}
				}

				if( hasAdded === false ) {

					if(has_all_keywords(search, modelCode.toLowerCase())) {
						closestResults.push([brandName, modelName, item.url]);
						loopWorked++;
						hasAdded = true;
					}

				}
			});
		}
	} else {
		if(window.wp_repair_search_bar_data && window.wp_repair_search_bar_data.brands && window.wp_repair_search_bar_data.models) {
			window.wp_repair_search_bar_data.models.forEach(function(item){
				if(loopWorked >= limit) {
					return closestResults;
				}
				let brandName = '';
				if(item.brand_id_fk && window.wp_repair_search_bar_data.brands[item.brand_id_fk]) {
					brandName = window.wp_repair_search_bar_data.brands[item.brand_id_fk];
				}
				let modelName = item.m_name;
				closestResults.push([brandName, modelName, item.url]);
				loopWorked++;
			});
		}
	}
	return sort_closest_results(search, closestResults);
}
function update_wp_repair_search_contents(results) {
	let html = '';
	results.forEach(function(item){
		let target = '';
		if(item[2] !== '#') {
			target = '';
		} else {
			target = '';
		}
		html += `<li><a href="${item[2]}" ${target}><span class="brand">${item[0]}</span> <span class="model">${item[1]}</span></a></li>`;
	});
	if(html === '') {
		html = `<li><a href="#"><span class="model">${window.wp_repair_lang['no_results_found']}</span></a></li>`;
	}
	jQuery(".wp-repair-search-box-shortcode-container .wp-repair-search-box .search-content ul").html(html);
}

window.search_bar_original_icon = null;

jQuery(document).on("wpRepairReady", function(){

	window.search_bar_original_icon = jQuery(".wp-repair-search-box-shortcode-container .submit-repair-search").html();

	update_wp_repair_search_contents(get_closest_results('', 40));
	let lastSetTimeout = null;
	jQuery(".wp-repair-search-box-shortcode-container .wp-repair-search-box input").on("keyup", function(){
		let searchedVal = jQuery(this).val();
		if(lastSetTimeout) {
			window.clearTimeout(lastSetTimeout);
		}
		if(jQuery(".submit-repair-search").find('.fa-spinner-white').length === 0) {
			jQuery(".submit-repair-search").html(window.rp_svg_load_icon('fa-spinner-white', 's-18 s-14-mq-625'));
		}
		lastSetTimeout = window.setTimeout(function(){
			update_wp_repair_search_contents(get_closest_results(searchedVal, 40));
			jQuery(".submit-repair-search").html(window.search_bar_original_icon);
		}, 600);
	});
	if(jQuery(".wp-repair-search-box-shortcode-container").length > 0 && jQuery(".wp-repair-search-box-shortcode-container").parents('.vc_row').length > 0) {
		jQuery(".wp-repair-search-box-shortcode-container").parents('.vc_row').addClass('rp-z-index-fix');
	}
});