<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

function get_path($path = '') {
    $fileName = WP_REPAIR_PLUGIN_PATH.$path;

    $fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);

    return $fileName;
}

require_once get_path('Easy_Query/load-wp.php');

function autloader( $class_name = '' ) {

	if( strpos( $class_name, "RepairPluginPro\\" ) !== FALSE ) {

		$class_name = str_replace( "RepairPluginPro\\", '', $class_name );

		$class_file = get_path( 'classes/' . $class_name . '.php' );

		if( file_exists( $class_file ) && is_file( $class_file ) ) {

			require_once $class_file;

		}

	}
}

spl_autoload_register( 'RepairPluginPro\autloader' );

function load_all_classes() {
	$files = scandir(get_path('classes/'));

	foreach ($files as $key => $file) {

		if(!is_dir($file) && strpos($file, '.php') !== FALSE) {

			require_once get_path('classes/'.$file);

		}
	}
}

load_all_classes();
