<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class Base_API {

	public function __construct($rpQuery = NULL) {

		$this->wpdb = $rpQuery;

	}
	
	public function fetch( $controller = '', $dataToPass = array(), $fetching_sensitive_data = FALSE ) {

		$license_key = rp_get_option('Repairplugin_dp_lic_Key', '');
		$license_email = rp_get_option('Repairplugin_dp_lic_email', '');
		
		if(empty($license_key)) {
			return array();
		}

		$curl = curl_init( \RP_DP_BASE_SERVER_URL.$controller );

		curl_setopt($curl, CURLOPT_ENCODING, 'gzip');

		$payload = array();

		if( $fetching_sensitive_data === FALSE ) {

			$payload = array('license_key' => $license_key);

		} else {

			$rp_base_class = new \RepairpluginBase(\WP_REPAIR_PLUGIN_FILE);

			$license_app_version = $rp_base_class->getCurrentVersion();

			$domain = $rp_base_class->getDomain();

			$payload = array('license_key' => $license_key, 'license_email' => $license_email, 'license_app_version' => $license_app_version, 'license_domain' => $domain);

		}

		foreach ($dataToPass as $key => $value) {

			$payload[$key] = $value;

		}

		curl_setopt( $curl, CURLOPT_POSTFIELDS, $payload );

		curl_setopt( $curl, CURLOPT_RETURNTRANSFER, true );

		curl_setopt( $curl, CURLOPT_SSL_VERIFYPEER, false );

		curl_setopt( $curl, CURLOPT_SSL_VERIFYHOST, false );

		$response = curl_exec( $curl );

		$info = curl_getinfo( $curl );

		curl_close( $curl );

		$data = array();

		if($info['http_code'] != '200') {
			return $data;
		}

		if(!empty($response)) {
			try {
				$data = json_decode($response);
			} catch (\Exception $e) {

			}
		}
		if(!empty($data) && property_exists($data, 'status') && ($data->status === TRUE || $data->status === 1)) {
			return $data;
		}
		return array();
	}

}
