<?php

namespace RepairPluginPro;

use RepairPluginPro\RP_Request_Handler;
use RepairPluginPro\RP_Apply_Lock;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class RP_Ajax_Handler {

	public static function ajax_for_public( $ajax_action = '', $callback = null ) {

		self::add_action( 'wp_ajax_'.$ajax_action, $callback );

		self::add_action( 'wp_ajax_nopriv_'.$ajax_action, $callback );

	}

	public static function ajax_for_admin( $ajax_action = '', $callback = null ) {

		self::add_action( 'wp_ajax_'.$ajax_action, $callback );

	}

	public static function add_action( $ajax_action = '', $callback = null ) {

		if( strpos( $ajax_action, 'wp_ajax_' ) === FALSE ) {

			throw new \Exception( '[DEV-ERROR] Argument #1 must start with wp_ajax_' );

		}

		if( strpos( $ajax_action, 'wp_ajax_nopriv_' ) !== FALSE ) {

			$action = str_replace('wp_ajax_nopriv_', '', $ajax_action);

			RP_Apply_Lock::$public_actions[] = $action;

		} else {

			$action = str_replace('wp_ajax_', '', $ajax_action);

		}

		if( array_search( $action, RP_Request_Handler::$forms ) === FALSE ) {

			RP_Request_Handler::$forms[] = $action;

		}

		\add_action( $ajax_action, $callback );

	}

}
