<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
      die;
}

class RP_Log_Information  {

      public static $file = '';

      public static $request_id = '';

      public static function init( $file = '' ) {

            if(empty( self::$file )) {

                  self::$request_id = uniqid();

                  self::$file = $file;

            }

      }

      public static function getContent() {

            if( !file_exists( self::$file ) ) {

                  file_put_contents( self::$file, json_encode( array() ) );

            }

            $content = json_decode( file_get_contents( self::$file ), TRUE );

            return $content;

      }

      public static function putContent( $log = array() ) {

            $content = self::getContent();

            if( !isset( $content[ self::$request_id ] ) ) {

                  $content[ self::$request_id ] = array();

            }

            $content[ self::$request_id ][] = $log;

            file_put_contents( self::$file, json_encode( $content ) );

      }

      public static function log( $message = '', $additionalData = array() ) {

            $log = array();

            $log['message'] = $message;

            $log['additional'] = $additionalData;

            self::putContent( $log );

      }

      public static function debug() {

            $content = self::getContent();

            echo "<pre>";

            print_r( $content );

            echo "</pre>";

            exit;

      }

      public static function clear() {

            if( file_exists( self::$file ) ) {

                  @unlink( self::$file );

            }

      }

}
