<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

if( !class_exists( 'RepairPluginPro\RP_Session_Handler' ) ) {

	class RP_Session_Handler {

		public static $readed_cookie = false;

		public static $session_id = null;

		public static $session_id_length = 32;

		public static function create_random_string() {

			$length = self::$session_id_length;

			$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';

			$characters_length = strlen($characters);

			$random_string = '';

			for ($i = 0; $i < $length; $i++) {

				$random_string .= ($characters[rand(0, $characters_length - 1)] ?? '0');

			}

			$random_string .= bin2hex(random_bytes($length));

			$random_string .= uniqid();

			$random_string = md5( trim( $random_string ) );

			// return only $length characters
			return substr(trim($random_string), 0, $length);

		}

		public static function check_if_invalid_session_id( $session_id = '' ) {

			// if length is not self::$session_id_length, then it's an invalid session id
			if( strlen( trim( $session_id ) ) !== self::$session_id_length ) {

				return true;

			}

			// check if session id looks like json
			// If yes, then it's an invalid session id
			$must_have_string = array( '{', '}', ':', ',' );

			foreach ($must_have_string as $key => $value) {
				
				if( strpos( $session_id, $value ) !== false ) {

					return true;

				}

			}

			return false;

		}

		public static function start() {

			if( !isset($_SESSION) ) {

				$_SESSION = array();

			}

			if( self::$readed_cookie === false && isset($_COOKIE) && !empty($_COOKIE) && isset($_COOKIE['wordpress_logged_in_'.md5('rp_cookie')]) ) {

				self::$readed_cookie = true;

				self::$session_id = wp_unslash($_COOKIE['wordpress_logged_in_'.md5('rp_cookie')]);

				$generated_new_session_id = FALSE;

				if( self::check_if_invalid_session_id( self::$session_id ) === TRUE ) {

					$generated_new_session_id = TRUE;

					self::$session_id = self::create_random_string();

				}

				@setcookie('wordpress_logged_in_'.md5('rp_cookie'), self::$session_id, time() + (86400 * 30), "/");

				if( $generated_new_session_id === FALSE ) {

					$decoded  = rp_get_session_data(self::$session_id);

					if( !empty($decoded) ) {

						$_SESSION = array_merge($_SESSION, $decoded);

					}

				}

            } else {

				if( isset($_COOKIE) && !empty($_COOKIE) && isset($_COOKIE['wordpress_logged_in_'.md5('rp_cookie')]) ) {

					// Already have session id!

				} else {

					if( self::$readed_cookie === false ) {

						self::$readed_cookie = true;

						self::$session_id = self::create_random_string();

						@setcookie('wordpress_logged_in_'.md5('rp_cookie'), self::$session_id, time() + (86400 * 30), "/");

					}

				}

			}

		}

		public static function close() {

            if( isset($_SESSION) && !empty($_SESSION) ) {

				rp_save_session_data(self::$session_id, $_SESSION);

            }

		}

		public static function read() {

			// Start the Session to populate
			// $_SESSION array
			self::start();

			// Close the session as we have got
			// $_SESSION array populated
			// and we don't need to write anything
			// back to session
			self::close();

		}

		public static function set($pair = array()) {

			// Start the Session to populate
			// $_SESSION array with Original Values
			self::start();

			if( !isset( $_SESSION ) ) {

				// If something is wrong, prevent
				// the error from happening
				$_SESSION = array();

			}

			// Append the required data to 
			// $_SESSION array
			foreach ($pair as $key => $value) {
				
				$_SESSION[ $key ] = $value;

			}

			// Save and close the session
			self::close();

		}

	}

}
