<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class RP_Trigger_Examples {

    public static function prepare( $action = '' ) {

        if( trim( $action ) === 'deleted' ) {

            $the_status = 'Deleted';

        } else {

            $the_status = 'Pending';

        }

        $result_arr = array(

            'action' => $action,

            'event_start_datetime' => date('Y-m-d', strtotime('+1 day')) . 'T10:00',

            'event_end_datetime' => date('Y-m-d', strtotime('+1 day')) . 'T10:30',

            'delivery_method' => 'Come by our store',

            'appointment_date' => date('m-d-Y', strtotime('+1 day')),

            'appointment_time' => '10:00 AM',

            'appointment_number' => '230810041',

            'appointment_status' => $the_status,

            'created_date' => date('m-d-Y'),

            'created_time' => date('H:i'),

            'customer_name' => 'John Doe',

            'customer_email' => 'johndoe@gmail.com',

            'customer_phone' => '1234567890',

            'customer_house_no' => '',

            'customer_street_address' => '',

            'customer_city' => '',

            'customer_zipcode' => '',

            'customer_notes' => 'This is a test appointment',

            'category' => 'Smartphone',

            'brand' => 'Apple',

            'model' => 'iPhone 11 Pro Max',

            'color' => 'Space Gray',

            'shop_name' => 'Repair Shop',

            'location_name' => 'Shop 1',

            'location_telephone' => '1234567890',

            'location_address' => '123 Main St',

            'location_zipcode_city' => 'New York, NY 10001',

            'reschedule_link' => 'This will be available in original payload',

            'cancel_link' => 'This will be available in original payload'

        );

        $result_arr['items'] = array(

            array(

                'name' => 'LCD Display',

                'type' => 'repair',

                'price' => 30

            ),

            array(

                'name' => 'Screen - Official',

                'type' => 'repair',

                'price' => 0

            ),

            array(

                'name' => 'Wireless Charging Port',

                'type' => 'repair',

                'price' => 50

            ),

            array(

                'name' => 'Mobile Safety Glass US',

                'type' => 'upsale',

                'price' => 19.95

            )

        );

        // $result_arr['delivery_method_translated'] = $result_arr['delivery_method'];

        $result_arr['delivery_method_cost'] = 20;

        $result_arr['sub_total'] = 119.95;

        $result_arr['combo_discount'] = 10;

        $result_arr['coupon_code'] = '20OFFNOW';

        $result_arr['coupon_type'] = 'fixed';

        $result_arr['coupon_amount'] = 20;

        $result_arr['tax_percentage'] = 21;

        $result_arr['excluding_tax_price'] = 74.34;

        $result_arr['tax_price'] = 15.61;

        $result_arr['total_price'] = 89.95;

        return $result_arr;

    }

}
