<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class RP_Trigger_Request {

    public static function create_request_safe( $url = '', $payload = array() ) {

        try {

            return self::create_request( $url, $payload );

        } catch( \Exception $e ) {

            return false;

        }

    }

    public static function create_request( $url = '', $payload = array() ) {

        if( empty( $url ) || empty( $payload ) ) {

            return false;

        }

        // init curl
        $curl = curl_init();
    
        curl_setopt( $curl, CURLOPT_URL, $url );

        // set post
        curl_setopt( $curl, CURLOPT_POST, true );

        // set payload
        curl_setopt( $curl, CURLOPT_POSTFIELDS, json_encode( $payload ) );

        // set timeout 4 seconds
        curl_setopt( $curl, CURLOPT_TIMEOUT, 4 );
    
        // gzip
        curl_setopt( $curl, CURLOPT_ENCODING, "gzip" );
    
        curl_setopt( $curl, CURLOPT_RETURNTRANSFER, true );
    
        curl_setopt( $curl, CURLOPT_SSL_VERIFYPEER, false );
    
        curl_setopt( $curl, CURLOPT_SSL_VERIFYHOST, false );
    
        $response = curl_exec( $curl );
    
        $info = curl_getinfo( $curl );
    
        curl_close( $curl );

        if( $info['http_code'] == 200 && !empty( $response ) ) {

            return json_decode( $response, true );

        }

        return false;

    }

}
