<?php

namespace RepairPluginPro;

use RepairPluginPro\RP_Query_Builder;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class RP_Upsale_Translations {

    protected $rpdb;

    public function __construct() {

        $this->rpdb = new RP_Query_Builder();

    }
    
    public function rp_update_upsale_translations() {

        $keys = $_POST['keys'] ?? array();

        $values = $_POST['values'] ?? array();

        $translation_key = $_POST['translation_key'] ?? '';

        $translation_uqid = $_POST['translation_uqid'] ?? '';

        if( !empty( $translation_key ) && !empty( $keys ) && !empty( $values ) && count( $keys ) === count( $values ) && !empty( $translation_uqid ) ) {

            $default_language = \rp_get_default_language();

            $all_languages = \rp_get_all_languages();

            $all_languages_name = array();

            // get all languages name

            foreach($all_languages as $lang_row) {

                $all_languages_name[] = $lang_row->name;

            }

            // make sure all $keys item is in $all_languages_name

            foreach($keys as $key) {

                if( !in_array( $key, $all_languages_name ) ) {

                    echo json_encode(Array('status'=> false, 'message'  => 'Invalid Request'));

                    exit();

                }

            }

            global $wpdb;

            $wpdb->query("START TRANSACTION");

            $default_translation = '';

            // Check if row exists in rs_translations table
            // where language = $key of $keys array and key = $translation_key

            foreach($keys as $index => $key) {

                if( trim($key) === trim($default_language) ) {

                    $default_translation = $values[$index];

                }

                $this->rpdb->reset_query();
                $this->rpdb->where('key', $translation_uqid. '_' .$translation_key);
                $this->rpdb->where('language', $key);
                $this->rpdb->limit(1);
                $result = $this->rpdb->get('rs_upsale_translations');

                if(!empty($result)) {

                    // update row

                    $this->rpdb->reset_query();
                    $this->rpdb->where('key', $translation_uqid. '_' .$translation_key);
                    $this->rpdb->where('language', $key);
                    $this->rpdb->limit(1);
                    $this->rpdb->update('rs_upsale_translations', array('value' => $values[$index]));

                } else {

                    // insert row

                    $this->rpdb->reset_query();
                    $this->rpdb->insert('rs_upsale_translations', array('key' => $translation_uqid. '_' .$translation_key, 'language' => $key, 'value' => $values[$index]));

                }

            }

            if( !empty($default_translation) ) {

                $what_info = $translation_key;

                $data_to_update = array();
                $data_to_update[$what_info] = $default_translation;

                $this->rpdb->reset_query();
                $this->rpdb->where('upsales_id', $translation_uqid);
                $this->rpdb->limit(1);
                $old_row = $this->rpdb->get('rs_upsales');

                $this->rpdb->reset_query();
                $this->rpdb->where('upsales_id', $translation_uqid);
                $this->rpdb->update('rs_upsales', $data_to_update);

            }

            $wpdb->query('COMMIT');

            // send error message

            echo json_encode(Array('status'=> true, 'message'  => 'Successfully Updated', 'default_translation' => htmlspecialchars($default_translation)));
            
            exit();

        } else {

            // send error message

            echo json_encode(Array('status'=> false, 'message'  => 'Invalid Request'));
            
            exit();

        }

    }

    public function rp_get_upsale_translations() {

        $key = $_POST['key'] ?? '';
        $uqid = $_POST['uqid'] ?? '';

        $translations = array();

        $static_translation = '';
        
        if( !empty( $key ) ) {

            $static_translation = \rp_get_static_translations_of_upsale($key, $uqid);

            $all_languages = \rp_get_all_languages();

            foreach($all_languages as $lang_row) {

                $this->rpdb->reset_query();
                $this->rpdb->where('key', $uqid.'_'.$key);
                $this->rpdb->where('language', $lang_row->name);
                $this->rpdb->limit(1);
                $result = $this->rpdb->get('rs_upsale_translations');

                if(!empty($result)) {
                    $lang_row->t_value = htmlspecialchars($result[0]->value);
                } else {
                    $lang_row->t_value = htmlspecialchars($static_translation);
                }

                $lang_row->image = \rp_fix_language_image($lang_row->image);

                $translations[] = $lang_row;

            }

        }

        echo json_encode(Array('status'=> true, 'translations'  => $translations, 'static_translation' => htmlspecialchars($static_translation)));

        exit();

    }

}
