<?php

namespace RepairPluginPro;

if ( ! defined( 'RP_DP_PLUGIN_PATH' ) ) {
	die;
}

class LongProcessSaveHandler {

    protected $db;

    public function __construct( $dbHandler = NULL ) {
        
        if( $dbHandler !== NULL ) {

            $this->db = $dbHandler;

        }

    }

    public function get_option( $option_name = '' ) {

        $prefix = 'rp_dp_';

        $option_name = $prefix . $option_name;

        return rp_get_option( $option_name, FALSE );

    }

    public function start_transaction() {

        $this->db->query( 'START TRANSACTION' );

    }

    public function commit() {

        $this->db->query( 'COMMIT' );

    }

    public function delete_option_where( $option_name = '' ) {

        $prefix = 'rp_dp_';

        $option_name = $prefix . $option_name;

        // delete where option name like $option_name%
        return rp_delete_option( $option_name );

    }

    public function save_or_update( $option_name = '', $option_value = '' ) {

        $prefix = 'rp_dp_';

        $option_name = $prefix . $option_name;

        if( rp_get_option( $option_name, FALSE ) === FALSE ) {

            return rp_add_option( $option_name, $option_value );

        } else {

            return rp_update_option( $option_name, $option_value );

        }

    }

    public function save_step( $step = '', $page = 1 ) {

        // save in db
        $this->save_or_update( 'long_process_step', json_encode( array( 'step' => $step, 'page' => $page ) ) );
        
    }

    public function get_saved_step() {

        $saved = $this->get_option( 'long_process_step' );

        if( $saved === FALSE ) {

            return array( '', 1 );

        }

        $saved = json_decode( $saved, TRUE );

        return array( $saved['step'], $saved['page'] );

    }

    public function save_last_time($time = 0) {

        // save in db
        $this->save_or_update( 'long_process_last_time', $time );

    }

    public function get_last_time() {
            
        $saved = $this->get_option( 'long_process_last_time' );

        if( $saved === FALSE ) {

            return 0;

        }

        return $saved;

    }

}
