<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}

global $rpQuery;
$coupons = $rpQuery->prefix . "rs_coupons";
$localization = $rpQuery->prefix . "rs_localization";
$coupons_result = $rpQuery->get_results("SELECT * FROM $coupons");
$localization_data = $rpQuery->get_results("SELECT * FROM $localization");

$coupons_result = rp_sanitize_output($coupons_result);
$localization_data = rp_sanitize_output($localization_data);

$decimal = $localization_data[0]->set_decimals;
if (isset($_POST['add_coupon'])) {

	rp_verify_csrf_token_for_simple_form('coupons');

    $c_own_pref        = $_POST['c_own_pref'];
    $coupons_code      = $_POST['coupons_code'];
    $coupons_amount    = $_POST['coupons_amount'];
	$coupons_type 	   = trim(strtolower($_POST['coupons_type'] ?? 'fixed'));
    $coupons_set_limit = $_POST['coupons_set_limit'];
    if(preg_match('/,/',$coupons_amount)) {
		$coupons_amount = str_replace(',','.',$coupons_amount);
	}else{
		$coupons_amount = $coupons_amount;					
	}
    $rpQuery->query("INSERT INTO $coupons(coupons_own_reference,coupons_code,coupons_amount,coupons_type,coupons_set_limit) VALUES('".rp_escape_sql($c_own_pref)."','".rp_escape_sql($coupons_code)."','".rp_escape_sql($coupons_amount)."','".rp_escape_sql($coupons_type)."','".rp_escape_sql($coupons_set_limit)."')");
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=coupons');</script>";
}
if (isset($_POST['update_data'])) {

	rp_verify_csrf_token_for_simple_form('coupons');

    $coupons_id        = $_POST['coupons_id'];
    $c_own_pref        = $_POST['c_own_pref'];
    $coupons_code      = $_POST['coupons_code'];
    $coupons_amount    = $_POST['coupons_amount'];
	$coupons_type    = trim(strtolower($_POST['coupons_type'] ?? 'fixed'));
    $coupons_set_limit = $_POST['coupons_set_limit'];
    $is_active         = $_POST['is_active'] ?? '0';
    if($is_active == 'on'){
    	$is_active = '1';
    }else{
    	$is_active = '0';
    }
	if(preg_match('/,/',$coupons_amount)) {
		$coupons_amount = str_replace(',','.',$coupons_amount);
	}else{
		$coupons_amount = $coupons_amount;					
	}
    $rpQuery->query("UPDATE $coupons SET coupons_own_reference = '".rp_escape_sql($c_own_pref)."', coupons_code = '".rp_escape_sql($coupons_code)."' , coupons_amount = '".rp_escape_sql($coupons_amount)."' , coupons_type = '".rp_escape_sql($coupons_type)."' , coupons_set_limit = '".rp_escape_sql($coupons_set_limit)."' , is_active = '".rp_escape_sql($is_active)."' WHERE coupons_id = '".rp_escape_sql($coupons_id)."'");
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=coupons');</script>";
}
if (isset($_POST['delete_coupons'])) {

	rp_verify_csrf_token_for_simple_form('coupons');

    $coupons_id = $_POST['coupons_id'];
    $rpQuery->query("DELETE FROM $coupons WHERE coupons_id='".rp_escape_sql($coupons_id)."'");
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=coupons');</script>";
}
?>
<style type="text/css">
	.bg-with-border{
		padding: 3% !important;
	}
	.add-coupon button{
	  	font-weight: 700;
	  	font-size: 12px;
		letter-spacing: 1px;
		margin: 0px;
		text-transform: uppercase;
		padding: 10px 10px;
		background: transparent;
		background-color: transparent;
		cursor: pointer;
		color: #1275c2;
		border: 2px solid #1275c2;
		border-radius: 8px;
		display: inline-block;
		top: -2px;
		left: 15px;
	}
	.wp-repair-input-group {
		position: relative;
		color: #61666b;
		margin-top: 20px;
	}
	.wp-repair-input-group label {
		position: absolute;
		font-size: 9px;
		text-transform: uppercase;
		/*font-weight: 600;*/
		letter-spacing: 1.5px;
		top: -5px;
		left: 18px;
		padding: 0px 6px;
		background: #fff;
		font-weight: bold;
	}
	.wp-repair-input-group input ,.wp-brand-input-group select,.wp-repair-input-group textarea {
		height: 42px;
		border: 2px solid #cfcfcf;
		box-shadow: none;
		outline: 0;
		box-sizing: border-box;
		width: 100%;
		font-size: 14px;
	    font-weight: 400 !important;
	    border-radius: 8px;
	    padding: 0px 12px;
	    color: #454545;
	}
	.fs-9{
		font-size: 9px;
	}
	.mb-15{
		margin-bottom: 14px !important;
	}
	.modal-body{
		padding: 20px 0px;
	}
	.c-type{
		text-transform: uppercase;
		margin: 1em 0;
		font-weight: bold;
		letter-spacing: 1.5px;
		text-align: left;
	}
	.table-responsive table.coupon-table {
		width: 100%;
	}
	.table-responsive .wp-repair-input-group input,
	.table-responsive .wp-repair-input-group select {
		font-size: 13px;
		padding: 8px !important;
	}
	.coupons_select {
		font-size: 13px !important;
		padding: 5px 21px 5px 8px !important;
	}
	.table-responsive td.code input, .table-responsive td.reference input {
		min-width: 110px;
	}
	.table-responsive td.amount input {
    min-width: 50px;
    max-width: 70px;
    font-weight: 700;
}
.table-responsive td select.coupon_type {
	width: 87px;
	font-weight: 400 !important;
}
</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('coupons'); ?>
					<div class="wp-repair-col-8 bg-with-border main-section">
						<div class="table-responsive">
							<table class="table" style="width: 100%;">
								<tbody>
									<tr>
										<td style="display: inline-flex;width: 100%;">
											<div class="wp-repair-main-section-heading" style="width:70%">
												<h2>
													<span class="light">All</span>
													<span class="bold">Coupons</span>
												</h2>
												<p class="more-info">Offer specialized discounts to selected customers.</p>
											</div>
											<div class="add-coupon" style="width:30%;text-align: right;">
												<button class="add-category coupon-trigger">New Coupon  <i class="fas fa-plus"></i></button>
												<form method="post" action="">
												<?php
												rp_csrf_token_input_field('coupons');
												?>
													<div class="coupon-modal">
											        	<div class="coupon-modal-content">
															<div class="modal-header">
													            <span class="coupon-close-button">&times;</span>	
															</div>		
															<div class="modal-body">
																<div class="wp-repair-input-group mb-15">
																	<label>Own Referrence</label>
																	<input type="text" name="c_own_pref" class="user-info">
																</div>
																<div class="wp-repair-input-group mb-15">
																	<label>Coupon Code</label>	
																	<input type="text" name="coupons_code" class="user-info">
																</div>
																<div class="wp-repair-input-group mb-15">
																	<label>Coupon Amount</label>			
																	<input type="text" name="coupons_amount" class="user-info">
																</div>
																<div class="wp-brand-input-group">
																	<p class="fs-9 c-type" style="padding-left:4px;">Coupon Type</p>
																	<select class="form-control" name="coupons_type" required>
																		<option value="Fixed">Fixed</option>
																		<option value="Percent">Percent</option>
																	</select>
																</div>
																<div class="wp-brand-input-group">
																	<p class="fs-9 c-type" style="padding-left:4px;">Set Limit</p>
																	<select class="form-control" name="coupons_set_limit" required>
																		<option value="Unlimited">Unlimited</option>
																		<option value="5">5</option>
																		<option value="10">10</option>
																		<option value="15">15</option>
																	</select>
																</div>
															</div>
															<div class="modal-footer">
																<button type="submit" id="add_coupon" class="btn add_coupon" name="add_coupon">Add Coupon</button>
															</div>
											        	</div>
											    	</div>
											    </form>
											</div>
										</td>
										<td>
										</td>
									</tr>
								</tbody>
							</table>
						</div>
						<div class="table-responsive">
							<table class="table coupon-table">
								<thead>
									<tr class="headings">
										<th class="on-off-text">On/Off</th>
										<th style="width:60px;">Own Reference</th>
										<th style="width: 50px;">Code</th>
										<th style="width: 140px;" colspan="2">Amount</th>
										<th style="width: 150px;">Set Limit</th>
										<th></th>
									</tr>
								</thead>
								<tbody>
									<?php foreach($coupons_result as $c){?>
										<form method="post" action="">
										<?php
										rp_csrf_token_input_field('coupons');
										?>
											<tr class="closed">
												<td class="on-off-switch">
													<label class="switch">
													  	<input type="checkbox" <?php if($c->is_active == '1'){echo "checked";}?> name="is_active" id="is_active">
													  	<span class="slider round"></span>
													</label>
												</td>
												<input type="hidden" name="coupons_id" value="<?php echo $c->coupons_id?>" required>
												<td class="reference">
													<div class="wp-repair-input-group">
														<input class="" type="text" name="c_own_pref" value="<?php echo $c->coupons_own_reference?>" required>
													</div>
												</td>
												<td class="code">
													<div class="wp-repair-input-group">
														<input class="" type="text" name="coupons_code" value="<?php echo $c->coupons_code?>" required>
													</div>
												</td>
												<?php 
												if($decimal == 'comma'){
													$coupons_amount = str_replace('.',',',$c->coupons_amount);
												}else{
													$coupons_amount = $c->coupons_amount;					
												}?>
												<td class="amount">
													<div class="wp-repair-input-group">
														<input class="" type="text" name="coupons_amount" value="<?php echo $coupons_amount?>" required>
													</div>
												</td>
												<td>
													<span class="wp-repair-repair-card">
														<select class="coupons_select coupon_type" name="coupons_type" required>
															<option value="Fixed" <?php if($c->coupons_type === 'fixed') { echo 'selected="selected"'; } ?>>Fixed</option>
															<option value="Percent" <?php if($c->coupons_type === 'percent') { echo 'selected="selected"'; } ?>>Percent</option>
														</select>
													</span>
												</td>
												<td>
													<span class="wp-repair-repair-card">
														<select class="coupons_select" name="coupons_set_limit" required>
															<option value="<?php echo $c->coupons_set_limit?>" hidden><?php echo $c->coupons_set_limit?></option>
															<option value="Unlimited">Unlimited</option>
															<option value="5">5</option>
															<option value="10">10</option>
															<option value="15">15</option>
														</select>
													</span>
												</td>
												<td>
													<button type="submit" name="delete_coupons" class="wp-repair-coupon-delete">
														<i class="fas fa-trash-alt"></i>
													</button>
												</td>
												<td>
													<div class="wp-repair-inner-col section-1">
														<div class="sec-3">
															<button type="submit" name="update_data" class="wp-general-info">Update</button>
														</div>
													</div>
												</td>
											</tr>
											<tr class="spacer"><td></td></tr>
										</form>
									<?php }?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
?>
<script type="text/javascript">
	const coupon_modal = document.querySelector(".coupon-modal");
	const coupon_trigger = document.querySelector(".coupon-trigger");
	const couponcloseButton = document.querySelector(".coupon-close-button");

	function togglecouponModal() {
	    coupon_modal.classList.toggle("show-coupon-modal");
	}

	function couponwindowOnClick(event) {
	    if (event.target === coupon_modal) {
	        togglecouponModal();
	    }
	}

	coupon_trigger.addEventListener("click", togglecouponModal);
	couponcloseButton.addEventListener("click", togglecouponModal);
	window.addEventListener("click", couponwindowOnClick);
</script>