<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;


function rp_duration_measure_options() {

	return array('minutes', 'hours', 'days');

}

function rp_render_sort_button( $range = 0, $added_margin_column = FALSE ) {

	?>
	<tr class="justForsort Orderingrepairs draggable ui-state-default">
		<td colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>"><hr><div class="button">Hide under show all .. repairs button ↓</div>
			<input type="hidden" name="default_listing_range" id="default_listing_range" value="<?php echo $range; ?>" />
		</td>
	</tr>
	<?php

}

function rp_duration_measure_options_markup( $selected = '' ) {

	$options = rp_duration_measure_options();

	if( empty( $selected ) ) {

		$selected = 'minutes';

	}

	$selected = trim( strtolower( $selected ) );

	foreach ($options as $option) {

		$option = strtolower( $option );

		if( $option === 'minutes' ) {

			$option_text = 'mins';

		}else if( $option === 'hours' ) {

			$option_text = 'hrs';

		} else {

			$option_text = $option;

		}

		if( $option === $selected ) {

			?>
			<option selected="selected" value="<?php echo $option; ?>"><?php echo strtoupper($option_text); ?></option>
			<?php

		} else {

			?>
			<option value="<?php echo $option; ?>"><?php echo strtoupper($option_text); ?></option>
			<?php

		}

	}

}


global $rpQuery;
$model_table = $rpQuery->prefix . "rs_model";

$category_table = $rpQuery->prefix . "rs_category";
$c_result = $rpQuery->get_results("SELECT * FROM $category_table");

$localization = $rpQuery->prefix . "rs_localization";
$localization_data = $rpQuery->get_results("SELECT * FROM $localization");
$decimal = $localization_data[0]->set_decimals;

$brand_table = $rpQuery->prefix . "rs_brand";
$b_result = $rpQuery->get_results("SELECT * FROM $brand_table GROUP BY b_name");
require_once( ABSPATH . 'wp-admin/includes/file.php' ); // require file.php

$default_repair_table = $rpQuery->prefix . "rs_default_repair";
$repair_table = $rpQuery->prefix . "rs_repair";
$dr_attr_table = $rpQuery->prefix . "rs_default_repair_attr";
$r_attr_table = $rpQuery->prefix . "rs_repair_attr";

if (isset($_POST['add_repair'])) {
	$uploadedfile = $_FILES['r_img'];
	$upload_overrides = array( 'test_form' => false ); 
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
	$r_name       = $_POST['r_name'];
	$r_img        = $movefile["url"];
	$r_price      = $_POST['r_price'];
	$r_duration   = $_POST['r_duration'];
	$r_discription= $_POST['r_discription'];
	$m_id         = $_POST['m_id'];
	$r_uq_id      = uniqid('repair_');
	if(preg_match('/,/',$r_price)) {
		$price = str_replace(',','.',$r_price);
	}else{
		$price = $r_price;					
	}
	$rpQuery->query("INSERT INTO $repair_table(r_name,r_img,r_price,r_duration,r_discription,m_id_fk,r_uq_id) VALUES('".rp_escape_sql($r_name)."','".rp_escape_sql($r_img)."','".rp_escape_sql($price)."','".rp_escape_sql($r_duration)."','".rp_escape_sql($r_discription)."','".rp_escape_sql($m_id)."','".rp_escape_sql($r_uq_id)."')");
}
if (isset($_POST['add_r_attr'])) {
	$ra_name  = $_POST['ra_name'];
	$ra_price = $_POST['ra_price'];
	$dr_id     = $_POST['r_id_fk'];
	$a_uq_id  = uniqid('rattr_');
	if(preg_match('/,/',$ra_price)) {
		$price = str_replace(',','.',$ra_price);
	}else{
		$price = $ra_price;					
	}
	$rpQuery->query("INSERT INTO $r_attr_table(a_name,a_price,r_id_fk,a_uq_id) VALUES('".rp_escape_sql($ra_name)."','".rp_escape_sql($price)."','".rp_escape_sql($dr_id)."','".rp_escape_sql($a_uq_id)."')");
    //echo "<script>location.replace('admin.php?page=wp_repair_default_repairs');</script>";
}

ob_start();
$pagenum = isset( $_GET['pagenum'] ) ? absint( $_GET['pagenum'] ) : 1;

$limit    = 10;
$offset   = ( $pagenum - 1 ) * $limit;

$brand    = $_POST['brand'] ?? '';

$category = $_POST['category'] ?? '';

$get_category = $_GET['category'] ?? '';

$get_brand = $_GET['brand'] ?? '';

if($category != null){
	$category = $category;
}else{
	$category = $get_category;
}
if($brand != null){
	$brand = $brand;
}else{
	$brand = $get_brand;
}

//var_dump($category);
//var_dump($brand);


if (isset($_POST['search'])) {

	$search = "%".$_POST['search_model']."%"; 

	$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table WHERE m_name LIKE '".rp_escape_sql($search)."'");
	$num_of_pages = ceil($count_models / $limit);

	$m_result = $rpQuery->get_results("SELECT m.*,c.c_name,b.b_name FROM $model_table AS m 
		Left Join $category_table AS c ON c.c_id = m.device_type 
		Left Join $brand_table AS b ON b.b_id = m.brand_id_fk WHERE m.m_name LIKE '".rp_escape_sql($search)."' ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

	$search = trim($search,'%');
	$page_links = paginate_links( array(
		'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search='.$search.'&category=&brand=All'),
		'mid_size'  => 9,
		'format' => '',
		'prev_text' => __( '&laquo;', 'text-domain' ),
		'next_text' => __( '&raquo;', 'text-domain' ),
		'total' => $num_of_pages,
		'current' => $pagenum
	));
}else{

	if(isset($_POST['search_mname'])){
		$search = $_POST['search_mname'];
	}else{
		$search = $_GET['search'] ?? '';
	}

	if(($category != null) && ($search == null)) {

		if($brand != 'All'){

			$cat_result = $rpQuery->get_results("SELECT * FROM $category_table WHERE c_name = '".rp_escape_sql($category)."'");
			$c_id = $cat_result[0]->c_id;

			$br_result = $rpQuery->get_results("SELECT * FROM $brand_table WHERE b_name = '".rp_escape_sql($brand)."' AND c_id_fk = '".rp_escape_sql($c_id)."'");
			$b_id = $br_result[0]->b_id;

			$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table AS m WHERE m.device_type = '".rp_escape_sql($c_id)."' AND m.brand_id_fk = '".rp_escape_sql($b_id)."'");
			$num_of_pages = ceil($count_models / $limit);

			$m_result = $rpQuery->get_results("SELECT m.*,b.b_name,c.c_name FROM $model_table AS m Left Join $category_table AS c ON c.c_id = m.device_type Left Join $brand_table AS b ON b.b_id = m.brand_id_fk WHERE m.device_type = '".rp_escape_sql($c_id)."' AND m.brand_id_fk = '".rp_escape_sql($b_id)."' ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

			$page_links = paginate_links( array(
				'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search='.$search.'&category='.$category.'&brand='.$brand),
				'mid_size'  => 9,
				'format' => '',
				'prev_text' => __( '&laquo;', 'text-domain' ),
				'next_text' => __( '&raquo;', 'text-domain' ),
				'total' => $num_of_pages,
				'current' => $pagenum
			));

		}else{

			// var_dump($category);
			// var_dump($brand);

			$cat_result = $rpQuery->get_results("SELECT * FROM $category_table WHERE c_name = '".rp_escape_sql($category)."'");
			$c_id = $cat_result[0]->c_id;
			$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table AS m WHERE m.device_type = '".rp_escape_sql($c_id)."'");
			$num_of_pages = ceil($count_models / $limit);

			$m_result = $rpQuery->get_results("SELECT m.*,b.b_name,c.c_name FROM $model_table AS m Left Join $category_table AS c ON c.c_id = m.device_type Left Join $brand_table AS b ON b.b_id = m.brand_id_fk WHERE m.device_type = '".rp_escape_sql($c_id)."' ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

	        //var_dump($num_of_pages);
	        //var_dump($m_result);

			$page_links = paginate_links( array(
				'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search=&category='.$category.'&brand=All'),
				'mid_size'  => 9,
				'format' => '',
				'prev_text' => __( '&laquo;', 'text-domain' ),
				'next_text' => __( '&raquo;', 'text-domain' ),
				'total' => $num_of_pages,
				'current' => $pagenum
			));
		}
	}else if(($category != null) && ($search != null)) {

		if($brand != 'All'){

			$search   = "%".$search."%";

			$cat_result = $rpQuery->get_results("SELECT * FROM $category_table WHERE c_name = '".rp_escape_sql($category)."'");
			$c_id = $cat_result[0]->c_id;

			$br_result = $rpQuery->get_results("SELECT * FROM $brand_table WHERE b_name = '".rp_escape_sql($brand)."' AND c_id_fk = '".rp_escape_sql($c_id)."'");
			$b_id = $b_result[0]->b_id;

			$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table AS m WHERE m.device_type = '".rp_escape_sql($c_id)."' AND m.brand_id_fk = '".rp_escape_sql($b_id)."' AND m.m_name LIKE '".rp_escape_sql($search)."'");
			$num_of_pages = ceil($count_models / $limit);

			$m_result = $rpQuery->get_results("SELECT m.*,b.b_name,c.c_name FROM $model_table AS m Left Join $category_table AS c ON c.c_id = m.device_type Left Join $brand_table AS b ON b.b_id = m.brand_id_fk WHERE m.device_type = '".rp_escape_sql($c_id)."' AND m.brand_id_fk = '".rp_escape_sql($b_id)."' AND m.m_name LIKE '".rp_escape_sql($search)."' ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

			$search = trim($search,'%');

			$page_links = paginate_links( array(
				'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search='.$search.'&category='.$category.'&brand='.$brand),
				'mid_size'  => 9,
				'format' => '',
				'prev_text' => __( '&laquo;', 'text-domain' ),
				'next_text' => __( '&raquo;', 'text-domain' ),
				'total' => $num_of_pages,
				'current' => $pagenum
			));

		}else{
			$search   = "%".$search."%";

			$cat_result = $rpQuery->get_results("SELECT * FROM $category_table WHERE c_name = '".rp_escape_sql($category)."'");
			$c_id = $cat_result[0]->c_id;

			$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table AS m WHERE m.device_type = '".rp_escape_sql($c_id)."' AND m.m_name LIKE '".rp_escape_sql($search)."'");
			$num_of_pages = ceil($count_models / $limit);

			$m_result = $rpQuery->get_results("SELECT m.*,b.b_name,c.c_name FROM $model_table AS m Left Join $category_table AS c ON c.c_id = m.device_type Left Join $brand_table AS b ON b.b_id = m.brand_id_fk WHERE m.device_type = '".rp_escape_sql($c_id)."' AND m.m_name Like '".rp_escape_sql($search)."' ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

			$search = trim($search,'%');

			$page_links = paginate_links( array(
				'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search='.$search.'&category='.$category.'&brand=All'),
				'mid_size'  => 9,
				'format' => '',
				'prev_text' => __( '&laquo;', 'text-domain' ),
				'next_text' => __( '&raquo;', 'text-domain' ),
				'total' => $num_of_pages,
				'current' => $pagenum
			));
		}
	}else if(($category == null) && ($search != null)) {

		$search   = "%".$search."%";

		$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table WHERE m_name LIKE '".rp_escape_sql($search)."'");

		$num_of_pages = ceil($count_models / $limit);

		$m_result = $rpQuery->get_results("SELECT m.*,c.c_name,b.b_name FROM $model_table AS m Left Join $category_table AS c ON c.c_id = m.device_type 
			Left Join $brand_table AS b ON b.b_id = m.brand_id_fk WHERE m_name LIKE '".rp_escape_sql($search)."' ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

		$search = trim($search,'%');

		$page_links = paginate_links( array(
			'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search='.$search.'&category=&brand=All'),
			'mid_size'  => 9,
			'format' => '',
			'prev_text' => __( '&laquo;', 'text-domain' ),
			'next_text' => __( '&raquo;', 'text-domain' ),
			'total' => $num_of_pages,
			'current' => $pagenum
		));
	}else{
		$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table");

		$num_of_pages = ceil($count_models / $limit);

		$m_result = $rpQuery->get_results("SELECT * FROM $model_table AS m 
			Left Join $category_table AS c ON c.c_id = m.device_type 
			Left Join $brand_table AS b ON b.b_id = m.brand_id_fk ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC LIMIT $offset, $limit");

		$page_links = paginate_links( array(
			'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_default_repairs&search=&category=&brand=All'),
			'mid_size'  => 9,
			'format' => '',
			'prev_text' => __( '&laquo;', 'text-domain' ),
			'next_text' => __( '&raquo;', 'text-domain' ),
			'total' => $num_of_pages,
			'current' => $pagenum
		));
	}
}

$repairs_category_name = trim(str_replace('-', ' ', $_GET['repairs_category']));

$repairs_category_name = rp_sanitize_output($repairs_category_name);

$repairs_category = wp_repair_get_rs_category_by_name( $repairs_category_name );

$repairs_category = $repairs_category[0];

$default_listing_range = rp_get_option( 'rp_default_listing_index_'. strval( $repairs_category->c_id ), 6 );

$default_listing_range = (int) $default_listing_range;

$default_listing_range = rp_round_to_even_number( $default_listing_range );

$added_margin_column = FALSE;
$price_markup = '<th style="width: 75px"><p>Price</p></th>';
$filtered_price_th = apply_filters('rp_default_repair_price_th', $price_markup);
if( $price_markup !== $filtered_price_th ) {
	$added_margin_column = TRUE;
}

?>
<?php wp_repair_admin_setup_tour_nav_html(); ?>
<style type="text/css">
	<?php
	if( $added_margin_column === TRUE ) {
		?>
		.wp-repair-row.editing_page {
			max-width: 1300px;
		}
		.wp-repair-container .table {
			min-width: 1260px;
		}
		<?php
	} else {
		?>
		.wp-repair-row.editing_page {
			max-width: 1200px;
		}
		.wp-repair-container .table {
			min-width: 1160px;
		}
		<?php
	}
	?>
	.wp-repair-container .table tbody tr.manageRepairsParent > td {
		padding-left: 8px !important;
		padding-right: 8px !important;
	}
	tr.justForsort.Orderingrepairs.draggable .button {
		position: absolute;
		cursor: move;
		top: 7px;
		left: 50%;
    	transform: translateX(-50%);
		margin: 0px 2px;
	}

	tr.justForsort.Orderingrepairs.draggable td {
		padding-bottom: 12px !important;
		padding-top: 14px !important;
	}

	.wp-repair_page_wp_repair_manage_models tr.justForsort.Orderingrepairs.draggable td {
		padding-bottom: 5px !important;
	}

	tr.justForsort.Orderingrepairs.draggable .button:before, tr.justForsort.Orderingrepairs.draggable .button:after {
		content: "";
		height: 30px;
		width: 10px;
		background-color: #fbfbfb;
		display: block;
		position: absolute;
		left: -11px;
		top: 0;
	}

	tr.justForsort.Orderingrepairs.draggable .button:after {
		left: auto;
		right: -11px;
	}
	tr.justForsort.Orderingrepairs.draggable {
		border: 0 !important;
		cursor: move;
	}

	tr.justForsort.Orderingrepairs.draggable hr {
		border-width: thick;
		cursor: move;
	}
.add-repair-btn{
	position: relative !important;
	margin-top: 8px !important;
}
	/*.details-container{
		max-height: 36px;
		}*/
		td button{
			cursor: pointer !important;
		}
		.wp-repair-shortcode{
			margin-right: 5px !important;
			margin-left: 8px !important;
		}
		.upsale{
			margin-right: 5px !important;
		}
		.wp-repair_page_wp_repair_default_repairs button img{
			width: 19px;
		}
		.wp-repair-container .table tbody tr{
			background: none;		
		}
		.table-responsive {
			margin-top: 25px !important;
			background: #fbfbfb;
			border-radius: 8px !important;
			padding: 15px 0px !important;
		}
		.wp-repair-container .table tbody .closed td{
			border-top: 2px solid #eeeeee;
			border-bottom: 2px solid #eeeeee;
		}
		.wp-repair-container .type-category tbody tr.closed td:first-child{
			border-left: 2px solid #eeeeee;
		}
		.wp-repair-container .type-category tbody tr.closed .btn-actions{
			border-right: 2px solid #eeeeee;
			border-top-right-radius: 10px;				
			border-bottom-right-radius: 10px;				
		}
		input:checked + .slider{
			background-color: #1275c2;
		}
		.wp-repair-input-group {
			position: relative;
			color: #61666b;
			margin-top: 20px;
		}
		.wp-repair-input-group label {
			position: absolute;
			font-size: 8px;
			text-transform: uppercase;
			font-weight: 600;
			letter-spacing: 1.5px;
			top: -5px;
			left: 18px;
			padding: 0px 6px;
			background: #fff;
		}
		.wp-repair-input-group input ,.wp-brand-input-group select{
			height: 42px;
			border: 2px solid #cfcfcf;
			box-shadow: none;
			outline: 0;
			box-sizing: border-box;
			width: 100%;
			font-size: 14px;
			/*font-weight: 600;*/
			border-radius: 8px;
			padding: 5px 12px;
			color: #454545;
		}
		.wp-repair-input-group textarea {
			height: 42px;
			border: 2px solid #cfcfcf;
			box-shadow: none;
			outline: 0;
			box-sizing: border-box;
			width: 100%;
			font-size: 14px;
			/*font-weight: 600;*/
			border-radius: 8px;
			padding: 12px;
			color: #454545;
		}
		.fs-9{
			font-size: 9px;
		}
		.img{
			text-transform: uppercase;
			margin: 1em 0;
			font-weight: bold;
			letter-spacing: 1.5px;
		}
		.tablenav{
			margin: 6px auto 4px; 
			max-width: 30%;
		}
		.tablenav-pages{
			font-size: 15px !important;
			float: initial !important;
		}
		tr.justForsort,
		.append_attr_data {
			position: relative;
		}
		table.ui-sortable {
			position: relative;
		}
		.justForsort {
			padding: 0px !important;
			margin: 0px !important;
			width: 100% !important;
			background: none !important;
		}
		.ui-sortable-helper {
			display: table;
			width: 100%;
		}
		.OrderingrepairsAttr.ui-sortable-helper {
			display: table;
			width: 100%;
			max-width: 100%;
		}
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td.justForsort,
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .type-category tbody tr.active.more-details td.justForsort {
			padding: 0px !important;
		}
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details .main-repair td, 
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .type-category tbody tr.active.more-details .main-repair td,
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details .main-repair td.justForsort, 
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .type-category tbody tr.active.more-details .main-repair td.justForsort {
			border-top-left-radius: 0px;
			    border-bottom-left-radius: 0px;
			    border-top-right-radius: 0px;
			    border-bottom-right-radius: 0px;
			    border: unset;
		}
		.wp-repair-container .table tbody.justForsort > tr.closed {
			background: none !important;
		}
		.wp-repair-container .table tbody.justForsort > tr.closed > td {
			background: #fafafa;
		}
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td.justForsort, 
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .type-category tbody tr.active.more-details td.justForsort {
			border-top-left-radius: 0px;
			    border-bottom-left-radius: 0px;
			    border-top-right-radius: 0px;
			    border-bottom-right-radius: 0px;
			    border: unset;
		}
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td.justForsort, 
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .type-category tbody tr.more-details td.justForsort,
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td, 
		.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details td,
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.more-details td, 
		.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details td,
		.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details > td,
		.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details tr.OrderingrepairsAttr td, 
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .type-category tbody tr.active.more-details tr.OrderingrepairsAttr td {
			border-top-left-radius: 0px;
			    border-bottom-left-radius: 0px;
			    border-top-right-radius: 0px;
			    border-bottom-right-radius: 0px;
			    border: unset;
		}
		/* SORT BUTTON STYLING
		START
		*/
		.repair-list-sort {
			display: table;
			cursor: pointer;
			position: relative;
			top: 0px;
			float: left;
			    margin-left: 4px;
			    border: 1px solid #adadad;
			    padding: 0px;
			    color: #646464;
			    border-radius: 5px;
		}
		.switch {
			position: relative;
			top: 3px;
			float: left;
		}
		.repair-list-sort i {
			display: table;
			line-height: 12px;
			padding: 0px 4px 0px 4px;
			font-size: 16px;
			cursor: pointer;
		}
		.repair-list-sort i.fa-caret-down {
			padding-bottom: 1px;
		}
		.repair-list-sort i.fa-caret-up {
			padding-top: 1px;
		}
		.repair-list-sort i:hover {
			color: #1275c2;
		}
		/* SORT BUTTON STYLING
		END
		*/
		.OrderingrepairsAttr .repair-list-sort {
			margin-right: 5px;
		}
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td,
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td:nth-child(1) span,
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td:nth-child(1) input,
		.wp-repair_page_wp_repair_default_repairs .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td:nth-child(1) button {
			vertical-align: middle;
		}
			.wp-repair_page_wp_repair_default_repairs .wp-repair-container .wp-repair-inner-col.section-1 tbody.the-additional-repair tr.additional-repair-tr td {
				padding-bottom: 8px !important;
			}
			.img-repair-show {
				width: 32px;
				margin: auto;
				text-align: center;
				float: left;
				position: relative;
				height: 32px;
				display: block;
				margin-left: 8px;
				transition: all 0.3s;
			}
			.img-repair-show img {
				max-width: 32px;
				max-height: 32px;
				position: absolute;
				top: 50%;
				left: 50%;
				transform: translate(-50%, -50%);
			}
			.image-upload-repair-btn {
				margin: 0px 3px !important;
				position: relative;
				top: -1px;
			}
			.image-upload-repair-btn img {
				width: 20.5px !important;
				height: auto !important;
			}
			label.label-upload-image {
				display: inline-table;
				margin-left: 4px;
				position: relative;
				top: -1px;
			}

			#fastDelete {
				display: inline-table;
				margin: 7px 5px 0px 5px;
				width: 200px;
				box-sizing: border-box;
				min-height: 40px;
				background: #fff !important;
				color: #1275c2 !important;
			}
			#fastDelete.active {
				background: #1275c2 !important;
				color: #fff !important;
			}
			.add-repair-btn.update_repair {
				min-width: 148px;
			}

			*, body, button {
				-webkit-font-smoothing: antialiased;
				text-rendering: optimizeLegibility !important;
				-webkit-font-smoothing: antialiased !important;
				-moz-osx-font-smoothing: grayscale !important; 
				-webkit-backface-visibility: hidden;
			}
			.additional-actions button.dropdown,
			.additional-actions .add-more {
				width: 29px !important;
				box-sizing: border-box !important;
			}
			.additional-actions button.dropdown {
				top: 0px !important;
				position: relative !important;
			}

			tr.unsaved td input[type="text"] {
				background: rgb(0 104 255 / 5%) !important;
			}

			tr.unsaved td select {
				background-color: rgb(0 104 255 / 5%) !important;
			}

			tr td select {
				min-height: 28px !important;
		    height: 28px !important;
			}

			button.see-more.unsaved,
			.repair-list-sort.unsaved {
				background: rgb(0 104 255 / 5%) !important;
			}
			button.see-more.unsaved:hover,
			button.see-more.unsaved:active,
			button.see-more.unsaved:focus {
				background: #1275c2 !important;
		    color: #fff !important;
			}

			#saveChanges {
				display: inline-table;
				min-height: 40px;
				width: 175px;
			}
			#saveChanges.hide {
				display: none;
			}
			.details-container tr.closed td {
				border: 0px !important;
			}

			.wp-repair-container ::placeholder { /* Chrome, Firefox, Opera, Safari 10.1+ */
			  color: #646464;
			  opacity: 0.4;
			}

			.wp-repair-container :-ms-input-placeholder { /* Internet Explorer 10-11 */
			  color: #646464;
			  opacity: 0.4;
			}

			.wp-repair-container ::-ms-input-placeholder { /* Microsoft Edge */
			  color: #646464;
			  opacity: 0.4;
			}
			.reset-sort-order {
				background: rgb(18 117 194 / 10%);
				    padding: 15px;
				    margin: 5px 5px 36px 5px;
				    border-radius: 5px;
			}

			.reset-sort-order button,
			.reset-sort-order button:hover,
			.reset-sort-order button:active,
			.reset-sort-order button:focus {
				display: inline-table;
				margin: 7px 5px 0px 5px;
				width: 150px;
				box-sizing: border-box;
				min-height: 40px;
				background: #1275c2 !important;
				color: #fff !important;
				float: unset !important;
			}

			.reset-sort-order ul {
				display: none;
			}

			.reset-sort-order ul,
			.reset-sort-order button,
			.reset-sort-order ul li:nth-last-child(1) {
				margin-bottom: 0px !important;
			}
/*
			.repairsAttrContainer .OrderingrepairsAttr .add-more {
				visibility: hidden;
				opacity: 0;
			}
			.repairsAttrContainer .OrderingrepairsAttr:nth-last-child(1) .add-more {
				visibility: visible;
				opacity: 1;
			}*/
			a.go-back-to-select,
			a.go-back-to-select:hover,
			a.go-back-to-select:active,
			a.go-back-to-select:focus {
				background: #fff !important;
				color: #1275c2;
				border: 2px solid #1275c2;
				padding: 6px 10px;
				font-size: 15px;
				text-decoration: underline;
				outline: 0;
				border-radius: 5px;
				cursor: pointer;
				position: relative;
				top: -5px;
		    	left: 5px;
		    	box-shadow: unset;
			}
			h2.models-heading {
				margin-left: 16px !important;
			}

			.globe-icon-translation {
							cursor: pointer;
							width: calc(100% - 14px);
							height: 28px;
							position: absolute;
							top: 50%;
							transform: translateY(-50%);
						}

						.globe-icon-attr {
							position: relative;
							display: inline-table;
						}

						.main-repair .globe-icon-attr {
							width: 100%;
						}

						.globe-icon-attr .globe-icon-translation {
							width: calc(100% - 2.5px);
						}

						.clearfix {
							display: block;
						}

						.clearfix::after {
							content: "";
							clear: both;
							display: table;
						}

						table tbody tr td {
							position: relative;
						}

						.globe-icon-i {
							position: absolute;
							top: 50%;
							transform: translateY(-50%);
							right: 0px;
							line-height: 0em;
							background: #fff;
    						padding: 0px 6px;
						}
						.wp-repair-input-group input:focus, .wp-repair-input-group input:active, .wp-repair-input-group input:hover, .wp-repair-inner-col input.wp-repair-category-image-url:focus, .wp-repair-inner-col input.wp-repair-category-image-url:active, .wp-repair-inner-col input.wp-repair-category-image-url:hover {
							border: 2px solid #2781c7;
							box-shadow: none;
							outline: 0;
						}
						.wp-repair-input-group:hover label {
							color: #2781c7;
						}

						.wp-repair-container button, .wp-repair-container input, .wp-repair-container textarea, .wp-repair-repair-card, .wp-repair-cselected-item, .checkbox-custom .tick,
						.wp-repair-input-group input:focus, .wp-repair-input-group input:active, .wp-repair-input-group input:hover, .wp-repair-inner-col input.wp-repair-category-image-url:focus, .wp-repair-inner-col input.wp-repair-category-image-url:active, .wp-repair-inner-col input.wp-repair-category-image-url:hover {
							-webkit-transition: 0.4s all !important;
							transition-duration: 0.4s, 0.4s, 0.4s;
							transition-timing-function: ease, ease, ease;
							transition-delay: 0s, 0s, 0s;
							transition-property: border-color, background, transform;
							-moz-transition: 0.4s all !important;
							-o-transition: 0.4s all !important;
							-ms-transition: 0.4s all !important;
							transition: 0.4s all !important;
						}

						.va-full-width-modal-main.trans-modal {
								max-width: 475px;
								max-height: 80%;
								overflow-y: auto;
						}

						.va-full-width-modal-main.trans-modal .wp-repair-input-group {
							margin-top: 10px;
						}

						.va-full-width-modal .flag-img {
							width: 36px;
    						display: inline-block;
							position: relative;
							top: 9px;
						}
						.va-full-width-modal .input-cont {
							width: calc(100% - 40px);
    						display: inline-block;
						}
						.va-full-width-modal .trans-modal .va-button.va-submit {
							margin-top: 12px;
							display: inline-table;
							float: right;
							margin-bottom: 15px;
							position: relative;
							right: 3px;
							min-width: 80px;
						}
						.va-full-width-modal .trans-modal .va-full-width-modal-inner.clearfix .va-button.va-submit {
							margin-bottom: 0px;
						}
						input.repair-additional-desc {
							width: 210px;
							margin-left: 6px;
						}
      input.repair-additional-badge {
       width: 170px;
       margin-left: 6px;
      }
      .ra-duration-fields {
       display: inline-table;
       margin-left: 5px;
      }
      .ra-duration-fields.w55 input {
       width: 55px;
      }
      .ra-duration-fields.w74 input {
       width: 74px;
      }
      .globe-icon-attr input.attr-badge {
       max-width: 160px;
      }
	</style>
	<?php
rp_csrf_token_form_for_ajax('default_repairs');
?>
	<div class="wp-repair-container">
		<?php
		require_once(WP_REPAIR_PLUGIN_PATH.'html/pending_jobs_progress.php');
		?>
		<div class="wp-repair-row editing_page">
			<div class="wp-repair-col-12 type-category">
				<div class="wp-repair-category-header">
					<div class="both-groups">
						<div class="group-1">
							<div class="category_related_data"></div>
							<a class="go-back-to-select" href="<?php echo get_site_url(); ?>/wp-admin/admin.php?page=wp_repair_default_repairs"><i class="fas fa-chevron-left"></i></a>
							<h2 class="models-heading">Default Repairs (<?php echo ucwords($repairs_category_name); ?>)</h2>
						</div>
					</div>
					<div class="actions">
						<button class="add-category active" id="fastDelete" style="margin: 7px 5px 0px 5px;">Confirm Delete (ON) </button>
						<button class="btn btn-reset-sort-model"><i class="fas fa-undo-alt"></i> Reset Sorting</button>
						<button class="add-category hide" id="saveChanges" style="margin: 7px 5px 0px 5px;">Save Changes (0)</button>
					</div>
				</div>
				<div class="table-responsive">
					<table class="table">
						<tbody class="append_models">
							<?php
								$m_id = 999;
								$repairs =  $rpQuery->get_results("SELECT * FROM $default_repair_table WHERE dr_category = '".rp_escape_sql($repairs_category->c_id)."' ORDER BY dr_position ASC, dr_id ASC");
								$repairs = rp_sanitize_output($repairs);
								?>
								<tr class="justForsort manageRepairsParent">
									<td class="justForsort" colspan="6">
										<table class="justForsort">
											<tbody class="justForsort">
												<tr class="more-details more_details<?php echo $m_id; ?> active">
													<td colspan="7">
														<div class="details-container" style="max-height: 100%;" id="details-container<?php echo $m_id; ?>">
															<div class="wp-repair-inner-col section-1">
																<table class="table repairsContainer">
																	<thead>
																		<tr>
																			<th style="width: 125px;">
																				<p>On/Off</p>
																			</th>
																			<th style="width: 175px;">
																				<p>Title</p>
																			</th>
																			<th style="width: 147px;">
																				<p>Duration</p>
																			</th>
																			<th style="width: 225px;">
																				<p>Info</p>
																			</th>
																			<th style="width: 175px;">
																				<p>Badge</p>
																			</th>
																			<?php
																			$price_markup = '<th style="width: 75px"><p>Price</p></th>';
																			$filtered_price_th = apply_filters('rp_default_repair_price_th', $price_markup);
																			echo $filtered_price_th;
																			?>
																			<th style="width: 30px">
																				<p>Free</p>
																			</th>
																			<th style="width: 230px;">
																				<p></p>
																			</th>
																		</tr>
																	</thead>
																	<tbody class="the-additional-repair the-additional-repair<?php echo $m_id; ?>" style="border:none !important">
																		<?php $x=0; 
																		$last_index = count($repairs) - 1;
																		$this_model_default_listing_range = $default_listing_range;
																		if($this_model_default_listing_range > ($last_index + 1)){
																			$this_model_default_listing_range = $last_index + 1;
																		}
																		if( $this_model_default_listing_range == 0 && $last_index !== -1 ) {
																			rp_render_sort_button($this_model_default_listing_range, $added_margin_column);
																		}
																		foreach ($repairs as $r){
																			$dr_id = $r->dr_id;
																			$r_attr = $rpQuery->get_results("SELECT * FROM $dr_attr_table WHERE dr_id_fk = '".rp_escape_sql($dr_id)."' ORDER BY da_position ASC");
																			$r_attr = rp_sanitize_output($r_attr);
																			?>
																			<tr class="justForsort Orderingrepairs ui-state-default ui-state-not-allowed">
																				<td class="justForsort" colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>">
																					<table class="justForsort">
																						<tbody class="justForsort">
																							<tr class="main-repair">
																								<td style="width: 125px;">
																									<label class="switch">
																										<input type="checkbox" <?php if($r->is_active == '1'){echo 'checked';}?> tabindex="-1" name="is_active[]" id="is_active<?php echo $m_id; ?>" value="<?php echo $r->dr_id?>">
																										<span class="slider round"></span>
																									</label>
																									<!-- <div class="category-sort">
																										<i class="fas fa-sort"></i>
																									</div> -->
																									<?php
																									wp_repair_list_sorting_button();
																									?>
																									<input type="hidden" name="rid[]" id="repair-id<?php echo $m_id?>" value="<?php echo $r->dr_id?>">
																									<input type="hidden" name="r_img_link" value="<?php echo $r->dr_img; ?>">
																									<div class="img-repair-show">
																										<img src="<?php echo $r->dr_img; ?>">
																									</div>
																								</td>
																								<td style="width: 175px;">
																									<div class="globe-icon-attr">
																										<input tabindex="-1" class="repair-title rptranslatable" placeholder="Repair Title" id="repair-title<?php echo $m_id?>" type="text" name="rname[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_drepair('repair_name', $r->dr_uq_id)); ?>" required>
																										<div data-trans-selector="input.repair-title.rptranslatable" data-trans-key="repair_name" data-trans-uqid="<?php echo $r->dr_uq_id; ?>" class="globe-icon-translation clearfix">
																											<div class="globe-icon-i">
																												<i class="fas fa-globe"></i>
																											</div>
																										</div>
																									</div>
																								</td>
																								<td style="width: 55px;"><input tabindex="-1" class="repair-mins" placeholder="30" id="repair-mins<?php echo $m_id?>" type="text" name="rduration[]" value="<?php echo $r->dr_duration?>" required></td>
																								<td style="width: 74px;">
																									<select tabindex="-1" class="repair-duration-measure" id="repair-duration-measure<?php echo $m_id?>" name="rdurationmeasure[]" required>
																										<?php rp_duration_measure_options_markup( $r->dr_duration_measure ); ?>
																									</select>
																								</td>
																								<td style="width: 225px;">
																									<div class="globe-icon-attr">
																										<input tabindex="-1" class="repair-info rptranslatable" placeholder="More Information" id="repair-info<?php echo $m_id?>" type="text" name="rdiscription[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_drepair('repair_desc', $r->dr_uq_id)); ?>" required>
																										<div data-trans-selector="input.repair-info.rptranslatable" data-trans-key="repair_desc" data-trans-uqid="<?php echo $r->dr_uq_id; ?>" class="globe-icon-translation clearfix">
																											<div class="globe-icon-i">
																												<i class="fas fa-globe"></i>
																											</div>
																										</div>
																									</div>
																								</td>
																								<td style="width: 175px;">
																									<div class="globe-icon-attr">
																										<input tabindex="-1" class="repair-badge rptranslatable" placeholder="Badge Text" id="repair-badge<?php echo $m_id?>" type="text" name="rbadge[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_drepair('repair_badge', $r->dr_uq_id)); ?>" required>
																										<div data-trans-selector="input.repair-badge.rptranslatable" data-trans-key="repair_badge" data-trans-uqid="<?php echo $r->dr_uq_id; ?>" class="globe-icon-translation clearfix">
																											<div class="globe-icon-i">
																												<i class="fas fa-globe"></i>
																											</div>
																										</div>
																									</div>
																								</td>
																								<?php 
																								if(!empty($r_attr)) {

																									$r->dr_price = rp_get_lowest_default_repair_attribute_price($r->dr_id);

																								}
																								if($decimal == 'comma'){
																									$amount = str_replace('.',',',$r->dr_price);
																								}else{
																									$amount = $r->dr_price;					
																								}
																								$passData = array(
																									'r' => $r,
																									'r_attr' => $r_attr,
																									'decimal' => $decimal,
																									'm_id' => $m_id
																								);
																								$readonly = '';
																								if($r->is_free === '1' || !empty($r_attr)) {
																									$readonly = 'readonly="readonly"';
																								}
																								$to_be_filtered_td = '<td style="width: 75px"><input '.$readonly.' class="repair-price" id="repair-price'.$m_id.'" type="text"  placeholder="99,99" name="rprice[]" value="'.$amount.'" required></td>';
																								$filtered_td = apply_filters('rp_default_repair_price_td', $to_be_filtered_td, $passData);
																								echo $filtered_td;
																								?>
																								<td style="width: 30px;">
																									<input class="repair-free" id="repair-free<?php echo $m_id?>" type="checkbox" name="rfree[]" <?php if($r->is_free === '1') { echo 'checked="checked"'; } ?> required>
																								</td>
																								<td style="width: 230px;" class="additional-actions">
																									<button type="button" data-rid="<?php echo $dr_id?>" class="trash delete_repair" tabindex="-1">
																										<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/garbage.svg'; ?>">
																									</button>
																									<?php
																									if($r_attr){?>
																										<button tabindex="-1" type="button" class="dropdown" data-uid="<?php echo $dr_id; ?>">
																											<i class="fas fa-caret-down"></i>
																										</button>
																									<?php }else{?>
																										<button data-rid="<?php echo $dr_id;?>" type="button" tabindex="-1" class="add-more add-first-repair-attr"><i class="fas fa-plus"></i></button>
																									<?php }?>
																									<label tabindex="-1" class="label-upload-image" for="upload_rimage_<?php echo $dr_id; ?>"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/image.svg'; ?>"></label>
																									<input tabindex="-1" type="file" id="upload_rimage_<?php echo $dr_id; ?>" style="display: none;" name="r_img_X" data-uimage-id="<?php echo $dr_id; ?>">
																									<button data-drname="<?php echo $r->dr_name; ?>" data-total-used="<?php echo rp_get_total_counts_of_used_repairs($r->dr_uq_id, $repairs_category->c_id); ?>" data-drid="<?php echo $r->dr_id; ?>" type="button" class="reset-default-repair" style="margin-left: 5px; font-size: 18px;">Reset Repair</button>
																								</td>
																							</tr>
																							<?php
																							if($r_attr){?>
																								<tr class="sub-repairs-details">
																									<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
																										<div class="special-table">
																											<table class="table repairsAttrContainer">
																												<thead>
																													<tr>
																														<th style="width: 85px;">
																														</th>
																														<th style="width: 175px;">
																														</th>
																														<th style="width: 55px;">
																														</th>
																														<th style="width: 225px;">
																														</th>
																														<th style="width: 75px">
																														</th>
																														<th style="width: 30px">
																														</th>
																														<th style="width: 220px;"></th>
																													</tr>
																												</thead>
																												<tbody class="append_attr_data append_attr_data<?php echo $dr_id; ?>">
																													<?php if($r_attr){ foreach($r_attr as $ra){?>
																														<tr class="additional-repair-tr OrderingrepairsAttr" data-uid="<?php echo $dr_id; ?>">
																															<td colspan="<?php if( $added_margin_column === TRUE ) { echo '4'; } else { echo '5'; } ?>" style="width: 940px;">
																																<div class="repair-more-options">
																																<label class="switch">
																																	<input type="checkbox" <?php if($ra->is_active == '1'){echo 'checked';}?> tabindex="-1" name="is_active_attr[]" value="<?php echo $ra->da_id?>">
																																	<span class="slider round"></span>
																																</label>
																																	<button data-rid="<?php echo $dr_id;?>" tabindex="-1" type="button" class="add-more"><i class="fas fa-plus"></i></button>
																																	<!-- <div class="category-sort">
																																		<i class="fas fa-sort"></i>
																																	</div> -->
																																	<?php
																																	wp_repair_list_sorting_button();
																																	?>
																																	<input type="hidden" id="raid<?php echo $m_id;?>" name="raid[]" value="<?php echo $ra->da_id;?>">
																																	<div class="globe-icon-attr">
																																		<input class="repair-additional-name rptranslatable" id="raname<?php echo $m_id; ?>" type="text" placeholder="Original" name="raname[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_dattr('attr_name', $ra->da_uq_id));?>" required>
																																		<div data-trans-selector="input.repair-additional-name.rptranslatable" data-trans-key="attr_name" data-trans-uqid="<?php echo $ra->da_uq_id; ?>" class="globe-icon-translation clearfix">
																																			<div class="globe-icon-i">
																																				<i class="fas fa-globe"></i>
																																			</div>
																																		</div>
																																	</div>
                                 <div style="width: 55px;" class="ra-duration-fields w55"><input tabindex="-1" class="attr-mins" placeholder="30" id="attr-mins<?php echo $m_id?>" type="text" name="aduration[]" value="<?php echo $ra->da_duration?>" required></div>
                                 <div style="width: 74px;" class="ra-duration-fields w74">
                                  <select tabindex="-1" class="attr-duration-measure" id="attr-duration-measure<?php echo $m_id?>" name="adurationmeasure[]" required>
                                   <?php rp_duration_measure_options_markup( $ra->da_duration_measure ); ?>
                                  </select>
                                 </div>
																																	<div class="globe-icon-attr">
																																		<input class="repair-additional-desc rptranslatable" id="radesc<?php echo $m_id; ?>" type="text" placeholder="More Information" name="radesc[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_dattr('attr_desc', $ra->da_uq_id));?>" required>
																																		<div data-trans-selector="input.repair-additional-desc.rptranslatable" data-trans-key="attr_desc" data-trans-uqid="<?php echo $ra->da_uq_id; ?>" class="globe-icon-translation clearfix">
																																			<div class="globe-icon-i">
																																				<i class="fas fa-globe"></i>
																																			</div>
																																		</div>
																																	</div>
                                 <div class="globe-icon-attr">
																																		<input class="repair-additional-badge rptranslatable" id="rabadge<?php echo $m_id; ?>" type="text" placeholder="Badge Text" name="rabadge[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_dattr('attr_badge', $ra->da_uq_id));?>" required>
																																		<div data-trans-selector="input.repair-additional-badge.rptranslatable" data-trans-key="attr_badge" data-trans-uqid="<?php echo $ra->da_uq_id; ?>" class="globe-icon-translation clearfix">
																																			<div class="globe-icon-i">
																																				<i class="fas fa-globe"></i>
																																			</div>
																																		</div>
																																	</div>
																																</div>
																															</td>
																															<?php 
																															if($decimal == 'comma'){
																																$amount = str_replace('.',',',$ra->da_price);
																															}else{
																																$amount = $ra->da_price;			
																															}
																															$passData = array(
																																'ra' => $ra,
																																'm_id' => $m_id,
																																'decimal' => $decimal
																															);
																															$td_to_be_filtered = '<td style="width: 75px;"><input class="repair-price" type="text" id="raprice'.$m_id.'" placeholder="99,99" name="raprice[]" value="'.$amount.'" required></td>';
																															$td_to_be_filtered = apply_filters('rp_default_repair_attr_price_td', $td_to_be_filtered, $passData);
																															echo $td_to_be_filtered;
																															?>
																															<td style="width: 220px;">
																																<button type="button" data-aid="<?php echo $ra->da_id;?>" tabindex="-1" class="wp-repair-cancel-link ra_delete"><i class="fas fa-times"></i></button>
																															</td>
																														</tr>
																												<?php } }?>
																											</tbody>
																										</table>
																									</div>
																								</td>
																							</tr>
																						<?php } ?>
																						</tbody>
																					</table>
																				</td>
																			</tr>
																		<?php if($x+1 == $this_model_default_listing_range): ?>
																			<?php rp_render_sort_button( $this_model_default_listing_range, $added_margin_column ); ?>
																		<?php endif; ?>
																		<?php $x++; }?>
																		</tbody>
																	</table>
																	<button type="button" data-mid="<?php echo 1;?>" class="add-repair-btn AddRepair">Add Repair <i class="fas fa-plus"></i></button>
																	<button type="button" data-mid="<?php echo 1;?>" class="add-repair-btn update_repair" style="margin-right: 5px">Update Repair <i class="fas fa-edit"></i></button>
																</div>
															</div>
														</td>
													</tr>
											</tbody>
										</table>
									</td>
								</tr>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</form>
		<?php
		wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
		wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
		wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
		?>
		<script type="text/javascript">
			window.rp_set_decimal = '<?php echo $decimal; ?>';
			function uniqid(){
			  return Math.random().toString(16).slice(2)+(new Date()).getTime()+Math.random().toString(16).slice(2);
			}

			function ucwords (str) {
				return str.toUpperCase();
			    return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
			        return $1.toUpperCase();
			    });
			}

			function rp_duration_measure_options_markup( selected = '' ) {

				let options = <?php echo json_encode( rp_duration_measure_options() ); ?>;

				if( selected == '' ) {

					selected = 'minutes';

				}

				selected = selected.toLowerCase().trim();

				let template = '';

				options.forEach(function(option){

					option = option.toLowerCase();

					let option_text = option;

					if( option_text === 'minutes' ) {

						option_text = 'mins';

					}

					if( option_text === 'hours' ) {

						option_text = 'hrs';

					}

					if( option === selected ) {

						template += `<option selected="selected" value="${option}">${ucwords(option_text)}</option>`;

					} else {

						template += `<option value="${option}">${ucwords(option_text)}</option>`;

					}

				});

				return template;

			}

			function add_model_repair_attr_tr(r_id, m_id, ra_id, repair_attr_name, repair_attr_desc, repair_attr_price, da_uq_id, is_active_attr, repair_attr_margin = null, repair_attr_badge = '', attr_min = '', a_duration_measure = '') {
				if( a_duration_measure == '' ) {
					a_duration_measure = 'minutes';
				} 
				if(is_active_attr === '1') {
					is_active_attr = 'checked="checked"';
				} else {
					is_active_attr = '';
				}
				if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
					repair_attr_price = repair_attr_price + '';
					repair_attr_price = repair_attr_price.replace('.', ',');
				}
				let repair_attr_margin_td = '';
				if( repair_attr_margin !== null ) {
					if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
						repair_attr_margin = repair_attr_margin + '';
						repair_attr_margin = repair_attr_margin.replace('.', ',');
					}
					repair_attr_margin_td = `
						<td style="width: 75px;">
							<input class="repair-price" type="text" id="ramargin${m_id}" placeholder="99,99" name="ramargin[]" value="${repair_attr_margin}" required="">
						</td>
					`;
				}
				let tr = `
					<tr class="additional-repair-tr OrderingrepairsAttr" data-uid="${r_id}">
						<td colspan="<?php if( $added_margin_column === TRUE ) { echo '4'; } else { echo '5'; } ?>" style="width: 940px;">
							<div class="repair-more-options">
								<label class="switch">
								<input type="checkbox" ${is_active_attr} tabindex="-1" name="is_active_attr[]" value="${ra_id}">
								<span class="slider round"></span>
								</label>
								<button data-rid="${r_id}" tabindex="-1" type="button" class="add-more"><i class="fas fa-plus"></i></button>
								<span class="repair-list-sort ">
									<i class="fas fa-caret-up ui-sortable-handle" data-which="up"></i>
									<i class="fas fa-caret-down ui-sortable-handle" data-which="down"></i>
								</span>
								<input type="hidden" id="raid${m_id}" name="raid[]" value="${ra_id}">
								<div class="globe-icon-attr">
									<input class="repair-additional-name rptranslatable" id="raname${m_id}" type="text" placeholder="Original" name="raname[]" value="${repair_attr_name}" required="">
									<div data-trans-selector="input.repair-additional-name.rptranslatable" data-trans-key="attr_name" data-trans-uqid="${da_uq_id}" class="globe-icon-translation clearfix">
										<div class="globe-icon-i">
											<i class="fas fa-globe"></i>
										</div>
									</div>
								</div>
        <div class="ra-duration-fields w55" style="width: 55px;"><input tabindex="-1" class="attr-mins" placeholder="30" id="attr-mins${m_id}" type="text" name="aduration[]" value="${attr_min}" required=""></div>
        <div class="ra-duration-fields w74" style="width: 74px;">
         <select tabindex="-1" class="attr-duration-measure" id="attr-duration-measure${m_id}" name="adurationmeasure[]" required>
          ${rp_duration_measure_options_markup(a_duration_measure)}
         </select>
        </div>
								<div class="globe-icon-attr">
									<input class="repair-additional-desc rptranslatable" id="radesc${m_id}" type="text" placeholder="More Information" name="radesc[]" value="${repair_attr_desc}" required="">
									<div data-trans-selector="input.repair-additional-desc.rptranslatable" data-trans-key="attr_desc" data-trans-uqid="${da_uq_id}" class="globe-icon-translation clearfix">
										<div class="globe-icon-i">
											<i class="fas fa-globe"></i>
										</div>
									</div>
								</div>
        <div class="globe-icon-attr">
									<input class="repair-additional-badge rptranslatable" id="rabadge${m_id}" type="text" placeholder="Badge Text" name="rabadge[]" value="${repair_attr_badge}" required="">
									<div data-trans-selector="input.repair-additional-badge.rptranslatable" data-trans-key="attr_badge" data-trans-uqid="${da_uq_id}" class="globe-icon-translation clearfix">
										<div class="globe-icon-i">
											<i class="fas fa-globe"></i>
										</div>
									</div>
								</div>
							</div>
						</td>
						<td style="width: 75px;">
							<input class="repair-price" type="text" id="raprice${m_id}" placeholder="99,99" name="raprice[]" value="${repair_attr_price}" required="">
						</td>
						${repair_attr_margin_td}
						<td style="width: 220px;">
							<button type="button" data-aid="${ra_id}" tabindex="-1" class="wp-repair-cancel-link ra_delete"><i class="fas fa-times"></i>
							</button>
						</td>
					</tr>
				`;
				return tr;
			}

			function add_model_repair_tr(m_id, r_id, r_img, repair_title, repair_min, repair_info, repair_price, is_active, total_used, is_free, r_duration_measure, dr_uq_id, repair_margin = null, repair_badge = '') {
				if(is_active === '1') {
					is_active = 'checked="checked"';
				} else {
					is_active = '';
				}

				let readonly = '';

				if( r_duration_measure == '' ) {

					r_duration_measure = 'minutes';

				} 

				if(is_free === '1') {
					readonly = 'readonly="readonly"';
				}

				if(is_free === '1') {
					is_free = 'checked="checked"';
				} else {
					is_free = '';
				}

				if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
					repair_price = repair_price + '';
					repair_price = repair_price.replace('.', ',');
				}

				let repair_margin_td = '';
				if( repair_margin !== null ) {
					if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
						repair_margin = repair_margin + '';
						repair_margin = repair_margin.replace('.', ',');
					}
					repair_margin_td = `
						<td style="width: 75px;"><input ${readonly} class="repair-price" id="repair-margin${m_id}" type="text" placeholder="99,99" name="rmargin[]" value="${repair_margin}" required=""></td>
					`;
				}

				let tr = `
					<tr class="justForsort Orderingrepairs ui-state-default ui-state-not-allowed adding-model-repair-tr">
						<td class="justForsort" colspan="<?php if( $added_margin_column === TRUE ) { echo '9'; } else { echo '8'; } ?>">
							<table class="justForsort">
								<tbody class="justForsort">
									<tr class="main-repair">
										<td style="width: 125px;">
											<label class="switch">
											<input type="checkbox" ${is_active} tabindex="-1" name="is_active[]" id="is_active${m_id}" value="${r_id}">
											<span class="slider round"></span>
											</label>
											<span class="repair-list-sort ui-sortable-handle">
											<i class="fas fa-caret-up" data-which="up"></i>
											<i class="fas fa-caret-down" data-which="down"></i>
											</span>
											<input type="hidden" name="rid[]" id="repair-id${m_id}" value="${r_id}">
											<input type="hidden" name="r_img_link" value="${r_img}">
											<div class="img-repair-show">
											<img src="${r_img}">
											</div>
										</td>
										<td style="width: 175px;">
											<div class="globe-icon-attr">
												<input tabindex="-1" class="repair-title rptranslatable" placeholder="Repair Title" id="repair-title${m_id}" type="text" name="rname[]" value="${repair_title}" required="">
												<div data-trans-selector="input.repair-title.rptranslatable" data-trans-key="repair_name" data-trans-uqid="${dr_uq_id}" class="globe-icon-translation clearfix">
													<div class="globe-icon-i">
														<i class="fas fa-globe"></i>
													</div>
												</div>
											</div>
										</td>
										<td style="width: 55px;"><input tabindex="-1" class="repair-mins" placeholder="30" id="repair-mins${m_id}" type="text" name="rduration[]" value="${repair_min}" required=""></td>
										<td style="width: 74px;">
											<select tabindex="-1" class="repair-duration-measure" id="repair-duration-measure${m_id}" name="rdurationmeasure[]" required>
												${rp_duration_measure_options_markup(r_duration_measure)}
											</select>
										</td>
										<td style="width: 225px;">
											<div class="globe-icon-attr">
												<input tabindex="-1" class="repair-info rptranslatable" placeholder="More Information" id="repair-info${m_id}" type="text" name="rdiscription[]" value="${repair_info}" required="">
												<div data-trans-selector="input.repair-info.rptranslatable" data-trans-key="repair_desc" data-trans-uqid="${dr_uq_id}" class="globe-icon-translation clearfix">
													<div class="globe-icon-i">
														<i class="fas fa-globe"></i>
													</div>
												</div>
											</div>
										</td>
										<td style="width: 175px;">
											<div class="globe-icon-attr">
												<input tabindex="-1" class="repair-badge rptranslatable" placeholder="Badge Text" id="repair-badge${m_id}" type="text" name="rbadge[]" value="${repair_badge}" required="">
												<div data-trans-selector="input.repair-badge.rptranslatable" data-trans-key="repair_badge" data-trans-uqid="${dr_uq_id}" class="globe-icon-translation clearfix">
													<div class="globe-icon-i">
														<i class="fas fa-globe"></i>
													</div>
												</div>
											</div>
										</td>
										<td style="width: 75px;"><input ${readonly} class="repair-price" id="repair-price${m_id}" type="text" placeholder="99,99" name="rprice[]" value="${repair_price}" required=""></td>
										${repair_margin_td}
										<td style="width: 30px;">
											<input class="repair-free" id="repair-free${m_id}" type="checkbox" name="rfree[]" ${is_free} required>
										</td>
										<td style="width: 230px;" class="additional-actions">
											<button type="button" data-rid="${r_id}" class="trash delete_repair" tabindex="-1">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
											</button>
											<button data-rid="${r_id}" type="button" tabindex="-1" class="add-more add-first-repair-attr"><i class="fas fa-plus"></i></button>
											<label tabindex="-1" class="label-upload-image" for="upload_rimage_${r_id}"><img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/image.svg"></label>
											<input tabindex="-1" type="file" id="upload_rimage_${r_id}" style="display: none;" name="r_img_X" data-uimage-id="${r_id}">
											<button data-drname="${repair_title}" data-total-used="${total_used}" data-drid="${r_id}" type="button" class="reset-default-repair" style="margin-left: 5px; font-size: 18px;">Reset Repair</button>
										</td>
									</tr>
								</tbody>
							</table>
						</td>
					</tr>
				`;
				return tr;
			}

			window.model_repair_attr_tr = `
				<tr class="additional-repair-tr OrderingrepairsAttr  uibyzahran-remove-tr uibyzahran-transition unsaved" data-uid="NEW">
					<td colspan="<?php if( $added_margin_column === TRUE ) { echo '4'; } else { echo '5'; } ?>" style="width:940px;">
						<div class="repair-more-options">
							<label class="switch">
							<input type="checkbox" checked="" tabindex="-1" name="is_active_attr[]" value="NEW">
							<span class="slider round"></span>
							</label>
							<button data-rid="NEW" tabindex="-1" type="button" class="add-more"><i class="fas fa-plus"></i></button>
							<span class="repair-list-sort ">
								<i class="fas fa-caret-up ui-sortable-handle" data-which="up"></i>
								<i class="fas fa-caret-down ui-sortable-handle" data-which="down"></i>
							</span>
							<input type="hidden" name="raid[]" value="NEW">
							<input class="repair-additional-name" type="text" placeholder="Original" name="raname[]" value="" required="">
       <div class="ra-duration-fields w55" style="width: 55px;"><input class="attr-mins" placeholder="30" type="text" name="aduration[]" value="" required=""></div>
       <div class="ra-duration-fields w74" style="width: 74px;">
        <select class="attr-duration-measure" name="adurationmeasure[]" required="required">
         <?php rp_duration_measure_options_markup(); ?>
        </select>
       </div>
							<input class="repair-additional-desc" type="text" placeholder="More Information" name="radesc[]" value="" required="">
       <input class="repair-additional-badge" type="text" placeholder="Badge Text" name="rabadge[]" value="" required="">
						</div>
					</td>
					<td style="width: 75px;">
						<input class="repair-price" type="text" placeholder="99,99" name="raprice[]" value="" required="">
					</td>
					<?php
					if( $added_margin_column === TRUE ) {
						?>
						<td style="width: 75px;">
							<input class="repair-price" type="text" placeholder="99,99" name="ramargin[]" value="" required="">
						</td>
						<?php
					}
					?>
					<td style="width: 220px;">
						<button type="button" data-aid="NEW" tabindex="-1" class="wp-repair-cancel-link ra_delete"><i class="fas fa-times"></i>
						</button>
					</td>
				</tr>
			`;

			window.model_repair_tr = `
				<tr class="justForsort Orderingrepairs ui-state-default ui-state-not-allowed uibyzahran-remove-tr uibyzahran-transition unsaved">
					<td class="justForsort" colspan="<?php if( $added_margin_column === TRUE ) { echo '9'; } else { echo '8'; } ?>">
						<table class="justForsort">
							<tbody class="justForsort">
								<tr class="main-repair">
									<td style="width: 125px;">
										<label class="switch">
										<input type="checkbox" checked="" tabindex="-1" name="is_active[]" value="NEW">
										<span class="slider round"></span>
										</label>
										<span class="repair-list-sort ui-sortable-handle">
										<i class="fas fa-caret-up" data-which="up"></i>
										<i class="fas fa-caret-down" data-which="down"></i>
										</span>
										<input type="hidden" name="rid[]" value="NEW">
										<input type="hidden" name="r_img_link">
										<div class="img-repair-show">
										<img src="">
										</div>
									</td>
									<td style="width: 175px;"><input class="repair-title" placeholder="Repair Title" type="text" name="rname[]" value="" required=""></td>
									<td style="width: 55px;"><input class="repair-mins" placeholder="30" type="text" name="rduration[]" value="" required=""></td>
									<td style="width: 74px;">
										<select class="repair-duration-measure" name="rdurationmeasure[]" required="required">
											<?php rp_duration_measure_options_markup(); ?>
										</select>
									</td>
									<td style="width: 225px;"><input class="repair-info" placeholder="More Information" type="text" name="rdiscription[]" value="" required=""></td>
									<td style="width: 175px;"><input class="repair-badge" placeholder="Badge Text" type="text" name="rbadge[]" value="" required=""></td>
									<td style="width: 75px;"><input class="repair-price" type="text" placeholder="99,99" name="rprice[]" value="" required=""></td>
									<?php
									if( $added_margin_column === TRUE ) {
										?>
										<td style="width: 75px;"><input class="repair-price" type="text" placeholder="99,99" name="rmargin[]" value="" required=""></td>
										<?php
									}
									?>
									<td style="width: 30px;">
										<input class="repair-free" type="checkbox" name="rfree[]" required>
									</td>
									<td style="width: 230px;" class="additional-actions">
										<button type="button" data-rid="NEW" class="trash delete_repair" tabindex="-1">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
										</button>
										<button data-rid="NEW" type="button" tabindex="-1" class="add-more add-first-repair-attr"><i class="fas fa-plus"></i></button>
										<label tabindex="-1" class="label-upload-image" for="upload_rimage_{uqid}">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/image.svg">
										</label> 
										<input tabindex="-1" type="file" id="upload_rimage_{uqid}" style="display: none;" name="r_img_X" data-uimage-id="NEW">
										<button data-drname="" data-total-used="" data-drid="" type="button" class="reset-default-repair preventdefault" style="margin-left: 5px; font-size: 18px;">Reset Repair</button>
									</td>
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
			`;

			jQuery(document).on("click", ".add-repair-btn.AddRepair", function(){

				var np = jQuery(this).parents('.details-container')[0];
				np.style.maxHeight = (np.clientHeight + 300) + "px";

				let parentEl = repairPluginUI.find_parent_by_class(this, 'details-container');
				jQuery(parentEl).find('.repairsContainer tbody.the-additional-repair').append(window.model_repair_tr.replace(/\{uqid\}/gi, uniqid()));
				updateUnsavedManageRepairButton();
				window.setTimeout(function(){
					let firstInput = jQuery('.Orderingrepairs.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".Orderingrepairs.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
					window.setTimeout(function(){
						jQuery(".Orderingrepairs.uibyzahran-transition").removeClass('uibyzahran-transition');
					},500);
				},1);
			});

			let theTimeout = null;
			jQuery(document).on("click", ".repair-more-options .add-more", function(){

				var np = jQuery(this).parents('.details-container')[0];
				np.style.maxHeight = (np.clientHeight + 300) + "px";

				let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
				jQuery(parentEl).find('.repairsAttrContainer tbody.append_attr_data').append(window.model_repair_attr_tr);
				updateUnsavedManageRepairButton();
				window.setTimeout(function(){
					let firstInput = jQuery('.OrderingrepairsAttr.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".OrderingrepairsAttr.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');

					if(theTimeout !== null) {
						window.clearTimeout(theTimeout);
					}
					theTimeout = window.setTimeout(function(){
						jQuery(".OrderingrepairsAttr.uibyzahran-transition").removeClass('uibyzahran-transition');
					},500);

				},1);
			});

			jQuery(document).on("click", ".add-first-repair-attr", function(){

				var np = jQuery(this).parents('.details-container')[0];
				np.style.maxHeight = (np.clientHeight + 300) + "px";

				let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
				jQuery(this).removeClass('add-more add-first-repair-attr');
				jQuery(this).addClass('dropdown').html('<i class="fas fa-caret-down"></i>');
				jQuery(parentEl).find('input[name^="rprice"]').attr('readonly', 'readonly');
				jQuery(parentEl).find('input[name^="rmargin"]').attr('readonly', 'readonly');
				let btn = this;
				let sub_repair_tr = `
					<tr class="sub-repairs-details uibyzahran-remove-tr uibyzahran-transition">
						<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
							<div class="special-table">
								<table class="table repairsAttrContainer ui-sortable">
									<thead>
										<tr>
											<th style="width: 85px;">
											</th>
											<th style="width: 175px;">
											</th>
											<th style="width: 55px;">
											</th>
											<th style="width: 225px;">
											</th>
											<th style="width: 75px">
											</th>
											<th style="width: 30px">
											</th>
											<th style="width: 220px;"></th>
										</tr>
									</thead>
									<tbody class="append_attr_data">

									</tbody>
								</table>
							</div>
						</td>
					</tr>
				`;
				jQuery(parentEl).find('tr.main-repair').after(sub_repair_tr);

				jQuery(parentEl).find(".repairsAttrContainer").each(function(){
					jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
						update_default_listing_range_position(e,ui);
					}, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
				});

				jQuery(parentEl).find('.repairsAttrContainer tbody.append_attr_data').append(window.model_repair_attr_tr);
				jQuery(btn).click();
				updateUnsavedManageRepairButton();
				window.setTimeout(function(){
					let firstInput = jQuery('.sub-repairs-details.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".sub-repairs-details.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
					window.setTimeout(function(){
						jQuery(".sub-repairs-details.uibyzahran-transition").removeClass('uibyzahran-transition');

						window.setTimeout(function(){
							let firstInput = jQuery('.OrderingrepairsAttr.uibyzahran-remove-tr input[type="text"]')[0];
							jQuery(firstInput).focus();
							jQuery(".OrderingrepairsAttr.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
							window.setTimeout(function(){
								jQuery(".OrderingrepairsAttr.uibyzahran-transition").removeClass('uibyzahran-transition');
							},500);
						},1);

					},1);
				},1);
			});


			jQuery(document).on("wpRepairReady", function(){
				var total_count  = jQuery('.total_count').val();
		//console.log(total_count)
		for (let i = 1; i <= total_count; i++) {
			jQuery('.m_shortcode'+i).on('click', function(){
				var copyText = document.getElementById("mInput"+i);
				copyText.select();
				copyText.setSelectionRange(0, 99999); /* For mobile devices */
				navigator.clipboard.writeText(copyText.value);
				alert("Copied To Clipboard: " + copyText.value);
			});
		}
		//------------------------------------------------------------------- add new repair
		// jQuery(".AddRepair").click(function(){
		// 	var mid = jQuery(this).data("mid");
		// 	jQuery(".m_id").val(mid);
		// 	const repair_modal = document.querySelector(".repair-modal");
		// 	repair_modal.classList.toggle("show-repair-modal");
		// });
		// jQuery(".repair-close-button").click(function(){
		// 	const repair_modal = document.querySelector(".repair-modal");
		// 	repair_modal.classList.toggle("show-repair-modal");
		// });
		//--------------------------------------------------- delete repair
		jQuery(document).on('click', '.delete_model_related_repairs', function(){
			if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete all repairs related to this model?')) {
				if(jQuery(this).hasClass("processing")) {
					return;
				}
				jQuery(this).addClass("processing");
				var btn = this;
				var btndata = jQuery(btn).html();
				jQuery(btn).html('<i style="font-size: 18px; position: relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

				var mrid = jQuery(this).data("mrid");
				//console.log(rid)
				repairPluginUI.ajax({
					type:'POST',
					url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {action:'delete_model_related_repairs',mrid:mrid},
					success: function(data) {
						jQuery(btn).html(btndata);
						let parentEl = repairPluginUI.find_parent_by_class(btn, 'manageRepairsParent');
						jQuery(parentEl).find('.Orderingrepairs').each(function(){
							repairPluginUI.removeTableRow(this);
						});

						window.setTimeout(function(){
							updateUnsavedManageRepairButton();
						},600);

						repairPluginUI.alert_success('All repairs related to selected model successfully deleted.');
						jQuery(btn).removeClass("processing");
					},
					error: function(response) {
						jQuery(btn).html(btndata);
						jQuery(btn).removeClass("processing");
						if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
					}
				});
			}
		});
		//--------------------------------------------------- delete all repairs related model
		jQuery(document).on('click', '.delete_repair', function(){
			if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete this repair?')) {

				var rid = jQuery(this).data("rid");

				if(rid === 'NEW') {

					let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
					repairPluginUI.removeTableRow(parentEl, function(){
						updateUnsavedManageRepairButton();
					});

					return;
				}

				if(jQuery(this).hasClass("processing")) {
					return;
				}
				let btn = this;

				var btndata = jQuery(btn).html();
				jQuery(btn).html('<i style="font-size: 20px; position: relative; top: 1px;" class="fas fa-spinner fa-spin"></i>');

				jQuery(btn).addClass("processing");
				//console.log(rid)
				repairPluginUI.ajax({
					type:'POST',
					url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {action:'delete_default_repair',rid:rid,dr_category:<?php echo $repairs_category->c_id; ?>},
					success: function(data) {

						jQuery(btn).html(btndata);
						let parentEl = repairPluginUI.find_parent_by_class(btn, 'Orderingrepairs');
						repairPluginUI.removeTableRow(parentEl, function(){
							updateUnsavedManageRepairButton();
						});

						repairPluginUI.alert_success('Selected repair successfully deleted.');
						jQuery(btn).removeClass("processing");

					},
					error: function(response) {
						jQuery(btn).html(btndata);
						jQuery(btn).removeClass("processing");
						if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
					}
				});
			}
		});
		//--------------------------------------------------- update repair
		jQuery(document).on('click', '.update_repair', function() {
			if(jQuery(this).hasClass("processing")) {
				return;
			}
			jQuery(this).addClass("processing");
			var btn = this;
			var btndata = jQuery(btn).html();
			jQuery(btn).html('<i style="font-size: 13px; position: relative; top: -1px;" class="fas fa-spinner fa-spin"></i>');

			var set_decimal = '<?php echo $decimal; ?>';

			let parentEl = repairPluginUI.find_parent_by_class(this, 'details-container');

			var mid    = jQuery(this).data("mid");
			var rid = [];
			var raid = [];
			var raname = [];
   var raduration = [];
   var radurationmeasure = [];
			var radesc = [];
   var rabadge = [];
			var raprice = [];
			var ramargin = [];
			var raactive = [];

			jQuery(parentEl).find('input[name^="rid["]').each(function(){
				rid.push(jQuery(this).val());

				let orderingrepairsContainer = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
				var a_id = [];
				jQuery(orderingrepairsContainer).find('input[name^="raid["]').each(function(){
					a_id.push(jQuery(this).val());
				});
				raid.push(a_id);

				var a_name = [];
				jQuery(orderingrepairsContainer).find('input[name^="raname["]').each(function(){
					a_name.push(jQuery(this).val());
				});
				raname.push(a_name);

    var a_duration = [];
				jQuery(orderingrepairsContainer).find('input[name^="aduration["]').each(function(){
					a_duration.push(jQuery(this).val());
				});
				raduration.push(a_duration);

    var a_duration_measure = [];
				jQuery(orderingrepairsContainer).find('select[name^="adurationmeasure["]').each(function(){
					a_duration_measure.push(jQuery(this).val());
				});
				radurationmeasure.push(a_duration_measure);

				var a_desc = [];
				jQuery(orderingrepairsContainer).find('input[name^="radesc["]').each(function(){
					a_desc.push(jQuery(this).val());
				});
				radesc.push(a_desc);

    var a_badge = [];
				jQuery(orderingrepairsContainer).find('input[name^="rabadge["]').each(function(){
					a_badge.push(jQuery(this).val());
				});
				rabadge.push(a_badge);

				var a_price = [];
				jQuery(orderingrepairsContainer).find('input[name^="raprice["]').each(function(){
					var element = jQuery(this).val().replace(/,/g, '.');
					a_price.push(element);
				});
				raprice.push(a_price);

				var ra_margin = [];
				jQuery(orderingrepairsContainer).find('input[name^="ramargin["]').each(function(){
					var element = jQuery(this).val().replace(/,/g, '.');
					ra_margin.push(element);
				});
				ramargin.push(ra_margin);

				var a_is_active = [];
				jQuery(orderingrepairsContainer).find('input[name^="is_active_attr["]').each(function(){
					if(jQuery(this).is(':checked')) {
						a_is_active.push(jQuery(this).val());
					} else {
						a_is_active.push(null);
					}
				});
				raactive.push(a_is_active);

			});
			var img_link = [];
			jQuery(parentEl).find('input[name^="r_img_link"]').each(function(){
				img_link.push(jQuery(this).val());
			});
			var title = [];
			jQuery(parentEl).find('input[name^="rname["]').each(function(){
				title.push(jQuery(this).val());
			});
			var mins = [];
			jQuery(parentEl).find('input[name^="rduration["]').each(function(){
				mins.push(jQuery(this).val());
			});
			var duration_measure = [];
			jQuery(parentEl).find('select[name^="rdurationmeasure["]').each(function(){
				duration_measure.push(jQuery(this).val());
			});
			var info = [];
			jQuery(parentEl).find('input[name^="rdiscription["]').each(function(){
				info.push(jQuery(this).val());
			});
   var badge = [];
			jQuery(parentEl).find('input[name^="rbadge["]').each(function(){
				badge.push(jQuery(this).val());
			});
			var rprice = [];
			jQuery(parentEl).find('input[name^="rprice["]').each(function(){
				rprice.push(jQuery(this).val());
			});
			var rmargin = [];
			if(jQuery(parentEl).find('input[name^="rmargin["]').length > 0) {
				jQuery(parentEl).find('input[name^="rmargin["]').each(function(){
					rmargin.push(jQuery(this).val());
				});
			}
			var rfree = [];
			jQuery(parentEl).find('input[name^="rfree["]').each(function(){
				if(jQuery(this).is(':checked')) {
					rfree.push(1);
				} else {
					rfree.push(0);
				}
			});
			var status = [];
			jQuery(parentEl).find('input[name^="is_active["]').each(function(){
				if(jQuery(this).is(':checked')) {
					status.push(jQuery(this).val());
				} else {
					status.push(null);
				}
			});
			var default_listing_range = jQuery('#default_listing_range').val();
			var data_to_pass = {
				action:'update_default_repair',mid:mid,rid:rid,img_link:img_link,title:title,mins:mins,duration_measure:duration_measure,info:info,badge:badge,rprice:rprice,rfree:rfree,status:status,raid:raid,raname:raname,radesc:radesc,rabadge:rabadge,raduration:raduration,radurationmeasure:radurationmeasure,raprice:raprice,raactive:raactive,dr_category:<?php echo $repairs_category->c_id; ?>,default_listing_range:default_listing_range
			};
			if(jQuery(parentEl).find('input[name^="rmargin["]').length > 0) {
				data_to_pass.rmargin = rmargin;
			}
			if(jQuery(parentEl).find('input[name^="ramargin["]').length > 0) {
				data_to_pass.ramargin = ramargin;
			}
    		repairPluginUI.ajax({
    			type:'POST',
    			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
    			data: data_to_pass,
    			success: function(data) {
    						try {
    							data = JSON.parse(data);
    						} catch (e) {

    						}
    						if(data && data.table_rows && data.table_rows.length > 0) {

    							let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
    							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
    							updateUnsavedManageRepairButton();
    							data.table_rows.forEach(function(val, i){
									if( val.listing_range !== undefined && val.listing_range !== null ) {
										let row = '<tr class="justForsort Orderingrepairs draggable ui-state-default""><td colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>"><hr><div class="button">Hide under show all .. repairs button ↓</div><input type="hidden" name="default_listing_range" id="default_listing_range" value="'+ val.listing_range +'"></td></tr>';
										jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(row);	
										return;
									}
										if( val.repair_margin === undefined || val.repair_margin === null ) {
											val.repair_margin = null;
										}
    								let getTr = add_model_repair_tr(val.m_id, val.r_id, val.r_img, val.repair_title, val.repair_min, val.repair_info, val.repair_price, val.is_active, val.total_used, val.is_free, val.dr_duration_measure, val.dr_uq_id, val.repair_margin, val.repair_badge);

    								jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(getTr);
    								let OrderingrepairsCont = jQuery(repairsContainer).find('.Orderingrepairs.adding-model-repair-tr');
    								OrderingrepairsCont.removeClass('adding-model-repair-tr');
    								if(val.attrs != undefined && val.attrs.length > 0) {

    									jQuery(OrderingrepairsCont).find('.add-more.add-first-repair-attr').removeClass('add-more add-first-repair-attr').addClass('dropdown').html('<i class="fas fa-caret-down"></i>');

    									jQuery(OrderingrepairsCont).find('input[name^="rprice"]').attr('readonly', 'readonly');

											jQuery(OrderingrepairsCont).find('input[name^="rmargin"]').attr('readonly', 'readonly');

    									let sub_repair_tr = `
    										<tr class="sub-repairs-details">
    											<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
    												<div class="special-table">
    													<table class="table repairsAttrContainer ui-sortable">
    														<thead>
    															<tr>
    																<th style="width: 85px;">
    																</th>
    																<th style="width: 175px;">
    																</th>
    																<th style="width: 55px;">
    																</th>
    																<th style="width: 225px;">
    																</th>
    																<th style="width: 75px">
    																</th>
    																<th style="width: 30px">
    																</th>
    																<th style="width: 220px;"></th>
    															</tr>
    														</thead>
    														<tbody class="append_attr_data">

    														</tbody>
    													</table>
    												</div>
    											</td>
    										</tr>
    									`;
    									jQuery(OrderingrepairsCont).find('tr.main-repair').after(sub_repair_tr);
    									jQuery(OrderingrepairsCont).find(".repairsAttrContainer").each(function(){
    										jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
												update_default_listing_range_position(e,ui);
											}, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
    									});

    									val.attrs.forEach(function(newVal){
												if( newVal.a_margin === undefined || newVal.a_margin === null ) {
													newVal.a_margin = null;
												}
    										let repairAttrTR = add_model_repair_attr_tr(val.r_id, val.m_id, newVal.a_id, newVal.a_name, newVal.a_desc, newVal.a_price, newVal.da_uq_id, newVal.is_active, newVal.a_margin, newVal.a_badge, newVal.attr_min, newVal.da_duration_measure);
    										jQuery(OrderingrepairsCont).find('.repairsAttrContainer tbody.append_attr_data').append(repairAttrTR);
    									});
    								}
    							});

    						} else {
    							let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
    							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
    							updateUnsavedManageRepairButton();
    						}


          			jQuery(btn).html(btndata);
          			repairPluginUI.alert_success('All repairs for selected model successfully updated.');
          			jQuery(btn).removeClass("processing");
          		},
          		error: function(response) {
          			jQuery(btn).html(btndata);
          			jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
          		}
          	});
    	});
		//--------------------------------------------------- add new repair attr
		// jQuery(".add-more").click(function(){
		// 	var rid = jQuery(this).data("rid");
		// 	jQuery(".r_id_fk").val(rid);
		// 	const ra_modal = document.querySelector(".ra-modal");
		// 	ra_modal.classList.toggle("show-ra-modal");
		// });
		// jQuery(".ra-close-button").click(function(){
		// 	const ra_modal = document.querySelector(".ra-modal");
		// 	ra_modal.classList.toggle("show-ra-modal");
		// });
		//--------------------------------------------------- delete repair attr
		jQuery(document).on('click', '.ra_delete',function(){
			if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete this repair attribute?')) {
				
				var aid = jQuery(this).data("aid");

				let parentEl = repairPluginUI.find_parent_by_class(this, 'OrderingrepairsAttr');
				let parentRepairsAttrContainer = repairPluginUI.find_parent_by_class(parentEl, 'repairsAttrContainer');
				let parentOrderRepairs = repairPluginUI.find_parent_by_class(parentRepairsAttrContainer, 'Orderingrepairs');

				if(aid === 'NEW') {

					repairPluginUI.removeTableRow(parentEl, function(){
						updateUnsavedManageRepairButton();
					});

					window.setTimeout(function(){
						if(jQuery(parentRepairsAttrContainer).find('.OrderingrepairsAttr').length === 0) {

							jQuery(parentOrderRepairs).find('button.dropdown.active').click();
							jQuery(parentOrderRepairs).find('button.dropdown').removeClass('dropdown active').addClass('add-more add-first-repair-attr').html('<i class="fas fa-plus"></i>');
							jQuery(parentOrderRepairs).find('.sub-repairs-details').remove();
							jQuery(parentOrderRepairs).find('input[name^="rprice"]').removeAttr('readonly');
							jQuery(parentOrderRepairs).find('input[name^="rmargin"]').removeAttr('readonly');
						}
					},600);

					return;
				}

				if(jQuery(this).hasClass("processing")) {
					return;
				}
				let btn = this;

				var btndata = jQuery(btn).html();
				jQuery(btn).html('<i style="font-size: 18px; position: relative; top: 0px;" class="fas fa-spinner fa-spin"></i>');

				jQuery(btn).addClass("processing");
				//console.log(aid)
				repairPluginUI.ajax({
					type:'POST',
					url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {
						action:'delete_dr_attr',
						aid:aid,
						dr_category: <?php echo $repairs_category->c_id; ?>
					},
					success: function(data) {
						jQuery(btn).html(btndata);
						repairPluginUI.removeTableRow(parentEl, function(){
							updateUnsavedManageRepairButton();
						});

						window.setTimeout(function(){
							if(jQuery(parentRepairsAttrContainer).find('.OrderingrepairsAttr').length === 0) {

								jQuery(parentOrderRepairs).find('button.dropdown.active').click();
								jQuery(parentOrderRepairs).find('button.dropdown').removeClass('dropdown active').addClass('add-more add-first-repair-attr').html('<i class="fas fa-plus"></i>');
								jQuery(parentOrderRepairs).find('.sub-repairs-details').remove();
								jQuery(parentOrderRepairs).find('input[name^="rprice"]').removeAttr('readonly');
								jQuery(parentOrderRepairs).find('input[name^="rmargin"]').removeAttr('readonly');
							}
						},600);

						repairPluginUI.alert_success('Selected repair attribute successfully deleted.');
						jQuery(btn).removeClass("processing");
					},
					error: function(response) {
						jQuery(btn).html(btndata);
						jQuery(btn).removeClass("processing");
						if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
					}
				});
			}
		});
	});
</script>
<script type="text/javascript">
	jQuery('.choose_category').click(function() {
		jQuery('.category_related_data').html('');
		var c_name = jQuery(this).data('cname');
		var b_name = jQuery('.ui-selectmenu-text').html();
		var search = jQuery('.search_model').val();		
		search = search.trim();
		var inputs = '<input type="hidden" name="category" value="'+c_name+'"><input type="hidden" name="brand" value="'+b_name+'"><input type="hidden" name="search_mname" value="'+search+'">';
		jQuery('.category_related_data').append(inputs);
		jQuery(".submit").submit(); 
	});	
</script>

<script type="text/javascript">
	function readURL(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'" height="100">');
		}
		reader.readAsDataURL(input.files[0]);
	}
}
</script>

<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){
		if(e.which == 13){
			e.preventDefault();
			jQuery("#saverOrder").click();
		}
	});
</script>
<script type="text/javascript">
	jQuery("#fastDelete").on("click", function(){
		if(jQuery(this).hasClass('active')) {
			jQuery(this).removeClass('active');
			jQuery(this).html('Confirm Delete (OFF)');
		} else {
			jQuery(this).addClass('active');
			jQuery(this).html('Confirm Delete (ON)');
		}
	});
	function moveUp(item) {
	    var prev = item.prev();
		var top = 0;
		var handler = '';
		if( prev.hasClass('draggable') ){
			handler = prev;
			top = prev.height();
			prev = prev.prev();
		}
	    if (prev.length == 0)
	        return;
	    prev.css('z-index', 999).css('position','relative').animate({ top: parseInt( item.height() + top ) }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: '-' + parseInt( prev.height() + top ) }, 300, function () {
	        prev.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
			if( handler ){
	        	prev.insertAfter( handler );
	        	item.insertBefore( handler );
			}else{
				item.insertBefore(prev);
			}
	    });
	}
	function moveDown(item) {
	    var next = item.next();
		var top = 0;
		var handler = '';
		if( next.hasClass('draggable') ){
			handler = next;
			top = next.height();
			next = next.next();
		}
	    if (next.length == 0)
	        return;
	    next.css('z-index', 999).css('position', 'relative').animate({ top: '-' + parseInt( item.height() + top ) }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: parseInt( next.height() + top ) }, 300, function () {
	        next.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
			if( handler ){
	        	item.insertAfter( handler );
	        	next.insertBefore( handler );
			}else{
				item.insertAfter(next);
			}
	    });
	}
	jQuery(".repairsContainer").each(function(){
		jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
			update_default_listing_range_position(e,ui);
		}, items: ".Orderingrepairs", distance: 5, handle: ".main-repair .repair-list-sort" });
	});
	jQuery(document).on('click', '.Orderingrepairs .main-repair .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.Orderingrepairs'));
	    else
	        moveDown(btn.parents('.Orderingrepairs'));

	    jQuery(btn).parents('.repairsContainer').find('.main-repair .repair-list-sort').addClass('unsaved');
	    updateUnsavedManageRepairButton();
	});
	jQuery(".repairsAttrContainer").each(function(){
		jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
			update_default_listing_range_position(e,ui);
		}, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
	});
	jQuery(document).on('click', '.OrderingrepairsAttr .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.OrderingrepairsAttr'));
	    else
	        moveDown(btn.parents('.OrderingrepairsAttr'));

	    jQuery(btn).parents('.repairsAttrContainer').find('tr.OrderingrepairsAttr .repair-list-sort').addClass('unsaved');
	    updateUnsavedManageRepairButton();
	});
		jQuery(document).on("change", "input[name='r_img_X']", function(){
			if(jQuery(this).hasClass("processing")) {
				return;
			}
			let btn = this;

			jQuery(btn).addClass("processing");

			let currentInput = this;

			var rid = jQuery(currentInput).data('uimage-id');
			var file_data = jQuery(currentInput).prop('files');
			if(file_data.length > 0) {
				file_data = file_data[0];
			} else {
				file_data = null;
			}
	    var form_data = new FormData();
	    if(file_data) {
	    	form_data.append('file', file_data);
	    }

	    form_data.append('action', 'update_default_repair_img');
	 		form_data.append('rid', rid);
	 		form_data.append('dr_category', <?php echo $repairs_category->c_id; ?>);

	 		if(file_data) {
				repairPluginUI.ajax({
	          type:'POST',
	          url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
	          dataType: 'text', // what to expect back from the server
	          cache: false,
	          contentType: false,
	          processData: false,
	          data: form_data,
	          success: function (response) {
	          		readURLZD(jQuery(currentInput)[0]);

	          		if(rid !== 'NEW') {
	          			repairPluginUI.alert_success('Repair image successfully updated.');
	          		}
	          		jQuery(btn).removeClass("processing");

	          		try {
	          			response = JSON.parse(response);
	          		} catch (e) {

	          		}
	          		if(response && response.logo) {
	          			let mainRepairTr = repairPluginUI.find_parent_by_class(btn, 'main-repair');
	          			jQuery(mainRepairTr).find('input[name^="r_img_link"]').val(response.logo).change();
	          		}
	          },
	          error: function(response) {
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
	          	jQuery(btn).removeClass("processing");
	          }
	      });
	 		}
		});

	function readURLZD(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(input).parent().parent().parent().find(".img-repair-show img").attr('src', e.target.result);

			jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(2.5)', 'z-index': '1000'});

			window.setTimeout(function(){
				jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(1)'});
				window.setTimeout(function(){
					jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(2.5)', 'z-index': '1000'});
					window.setTimeout(function(){
						jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(1)', 'z-index': '1'});
					},300);
				},300);
			},300);
		}
		reader.readAsDataURL(input.files[0]);
	}
}
function trackUnsavedChanges() {
	jQuery(document).on('change', 'tbody.append_models tr.main-repair input[type="text"]', function(){
		jQuery(this).parents('tr.main-repair').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
	jQuery(document).on('change', 'tbody.append_models tr.main-repair select', function(){
		jQuery(this).parents('tr.main-repair').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
	jQuery(document).on('change', 'tbody.append_models tr.sub-repairs-details input[type="text"]', function(){
		jQuery(this).parents('tr.sub-repairs-details').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
 jQuery(document).on('change', 'tbody.append_models tr.sub-repairs-details select', function(){
		jQuery(this).parents('tr.sub-repairs-details').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
	jQuery(document).on('change', 'tbody.append_models tr.main-repair input.repair-free', function(){

		let price_input = jQuery(this).parents('.main-repair').find('input[name^="rprice"]');

		let margin_input = jQuery(this).parents('.main-repair').find('input[name^="rmargin"]');

		let parentEl = jQuery(this).parents('.Orderingrepairs');

		let has_attr = jQuery(parentEl).find('input[name^="raprice"]').length > 0;

		if(jQuery(this).is(':checked')) {

			price_input.attr('readonly', 'readonly');

			price_input.attr('old-value', price_input.val());

			price_input.val('0').change();

			if( jQuery(margin_input).length > 0 ) {

				margin_input.attr('readonly', 'readonly');

				margin_input.attr('old-value', margin_input.val());

				margin_input.val('0').change();

			}

		}	else {

			if(!has_attr) {
				price_input.removeAttr('readonly');
				if( jQuery(margin_input).length > 0 ) {
					margin_input.removeAttr('readonly');
				}
			}

			let old_value = price_input.attr('old-value');

			if(old_value && old_value != null) {

				price_input.val(old_value).change();

			} else {

				price_input.val('').change();

			}

			if(!has_attr) {
				price_input.focus();
			}

			if( jQuery(margin_input).length > 0 ) {

				let old_value_margin = margin_input.attr('old-value');

				if(old_value_margin && old_value_margin != null) {

					margin_input.val(old_value_margin).change();

				} else {

					margin_input.val('').change();

				}

			}

		}

		jQuery(this).parents('tr.main-repair').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
}

jQuery(document).on('change keyup', '.additional-repair-tr input[name^="raprice"], .additional-repair-tr input[name^="ramargin"]', function(e){
	let parentEl = jQuery(this).parents('.Orderingrepairs');
	
	if(!jQuery(parentEl).find('input[name^="rfree"]').is(':checked')) {

		let allPrices = [];

		let allMargins = [];

		jQuery(parentEl).find('input[name^="raprice"]').each(function(){
			
			allPrices.push( jQuery(this).val() );

		});

		jQuery(parentEl).find('input[name^="ramargin"]').each(function(){
			
			allMargins.push( jQuery(this).val() );

		});

		let min_price = false;
		let min_margin = false;

		allPrices.forEach(function(val, i){

			if(val !== '') {

				val = parseFloat( val );

				if( min_price === false ) {
					
					min_price = val;
					min_margin = allMargins[i] ? parseFloat( allMargins[i] ) : 0;

				} else if( min_price > val ) {

					min_price = val;
					min_margin = allMargins[i] ? parseFloat( allMargins[i] ) : 0;

				} else {

					// do nothing

				}

			}

		});

		if( min_price === false ) {

			min_price = 0;

		}

		if( min_margin === false ) {

			min_margin = 0;

		}

		jQuery(parentEl).find('input[name^="rprice"]').val(min_price);
		jQuery(parentEl).find('input[name^="rmargin"]').val(min_margin);

	}

});

trackUnsavedChanges();
window.saveChangesText = 'Save Changes (X)';
function updateUnsavedManageRepairButton() {
	let totalUnsaved = 0;
	jQuery("tr.Orderingrepairs").each(function(){
		if(jQuery(this).find('tr.unsaved').length > 0 || jQuery(this).find('.main-repair .repair-list-sort.unsaved').length > 0 || jQuery(this).find('.sub-repairs-details .repair-list-sort.unsaved').length > 0) {
			totalUnsaved++;
			jQuery(this).find('button.see-more.plus-icon').addClass('unsaved');
		} else {
			jQuery(this).find('button.see-more.plus-icon').removeClass('unsaved');
		}
	});
	if(totalUnsaved > 0) {
		jQuery("#saveChanges").html(window.saveChangesText.replace('(X)', '('+totalUnsaved+')')).removeClass('hide');
	} else {
		window.saveChangesText = 'Save Changes (X)';
		jQuery("#saveChanges").html(window.saveChangesText.replace('(X)', '(0)')).addClass('hide');
	}
}
window._updateUnsavedManageModelButton = function() {
	updateUnsavedManageRepairButton();
};
function update_default_listing_range_position(e, ui) {
	jQuery(".details-container .the-additional-repair").each(function(i, num){

		jQuery(this).find('> tr.Orderingrepairs').each(function(index){

			if( jQuery(this).find('input[name="default_listing_range"]').length > 0 ) {

				jQuery(this).find('input[name="default_listing_range"]').val(index);
				
			}
			
		});

	});
}
function sortingHasUpdated(e,ui) {
	if(jQuery(ui.item[0]).hasClass('OrderingrepairsAttr')) {
		jQuery(ui.item[0]).parents('.repairsAttrContainer').find('tr.OrderingrepairsAttr .repair-list-sort').addClass('unsaved');
		updateUnsavedManageRepairButton();
	} else {
		jQuery(ui.item[0]).parents('.repairsContainer').find('tr.Orderingrepairs .main-repair .repair-list-sort').addClass('unsaved');
		updateUnsavedManageRepairButton();
	}
}
jQuery("#saveChanges").on('click', function(){
	if(jQuery(this).hasClass('processing')) {
		return;
	}
	let lastTime = 1;
	let btn = this;
	jQuery(btn).addClass('processing');
	window.saveChangesText = '<i style="position:relative; top:-1px; font-size: 14px;" class="fas fa-spinner fa-spin"></i>';
	jQuery("#saveChanges").html(window.saveChangesText);

	let needWork = [];
	jQuery("tr.manageRepairsParent").each(function(i){
		let manageRepairsParent = this;

		if(jQuery(this).find('tr.unsaved').length > 0 || jQuery(this).find('.repair-list-sort.unsaved').length > 0) {
			needWork.push(manageRepairsParent);
		}
	});

	let last_index = needWork.length - 1;

	needWork.forEach(function(val, i){
		let manageRepairsParent = val;
		let c_index = i;
		window.setTimeout(function(){
			jQuery(manageRepairsParent).find('button.update_repair').click();
			if(last_index === c_index) {
				jQuery(btn).removeClass('processing');
			}
		}, lastTime);
		lastTime += 300;
	});

	if(needWork.length === 0) {
		jQuery(btn).removeClass('processing');
	}
});

jQuery(".sorting_not_working").on('click', function(e){
	e.preventDefault();
	jQuery(".reset-sort-order ul").toggle();
});

jQuery(document).on("click", "button.btn-reset-order", function(e){

	if (confirm('Are you sure you want to reset sorting?')) {

		var originalHTML = jQuery(this).html();	

		jQuery(this).html('<i class="fas fa-spinner fa-spin"></i>');

		var btn = this ;

		repairPluginUI.ajax({

          	type:'POST',
          	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		      	data: {
		      		action: 'reset_default_sorting',
		      		reset: true,
		      		dr_category: <?php echo $repairs_category->c_id; ?>
		      	},
	      		success: function(data) {

	      			jQuery(btn).html(originalHTML);
	      			
		      		try {
		      			
		      			data = JSON.parse(data);

		      		} catch(e) {

		      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
		      			return;

		      		}

		      		jQuery(btn).parents('.va-full-width-modal-main').find('.va-close-modal').click();

							repairPluginUI.alert_success(data.success);	

						},
						error: function(response) {
							jQuery(btn).html(originalHTML);

							if( response && response.rp_validation_error != '' ) {

							} else {
								repairPluginUI.alert_danger('Something went wrong, please try again later.');
							}
						}

	    });

	}

});

jQuery(document).on("click", "button.va-button-danger.va-submit", function(e){

	if (confirm('Are you sure you want to do this?')) {

		var originalHTML = jQuery(this).html();	

		jQuery(this).html('<i style="position:relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

		var btn = this ;

		let dr_id = jQuery(this).data('drid');

		repairPluginUI.ajax({

          	type:'POST',
          	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		      	data: {
		      		action: 'reset_default_repair_ajax',
		      		reset: true,
		      		dr_id: dr_id,
		      		dr_category: <?php echo $repairs_category->c_id; ?>
		      	},
	      		success: function(data) {

	      			jQuery(btn).html(originalHTML);
	      			
		      		try {
		      			
		      			data = JSON.parse(data);

		      		} catch(e) {

		      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
		      			return;

		      		}

		      		jQuery(btn).parents('.va-full-width-modal-main').find('.va-close-modal').click();

							repairPluginUI.alert_success(data.success);	

						},
						error: function(response) {
							jQuery(btn).html(originalHTML);

							if( response && response.rp_validation_error != '' ) {

							} else {
								repairPluginUI.alert_danger('Something went wrong, please try again later.');
							}
						}

	    });

	}

});

(function($){
	function showFullWidthModal(content = '', additional_cls = '') {
		$(".va-full-width-modal").remove();
		let html = `
			<div class="va-full-width-modal">
				<div class="va-full-width-modal-main ${additional_cls}">
					<div class="va-full-width-modal-inner clearfix">
						${content}
					</div>
					<button class="va-button va-button-default va-close-modal">
						<i class="fas fa-times"></i>
					</button>
				</div>
			</div>
		`;
		$("body").append(html);
		$(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
		$(".va-full-width-modal .va-close-modal").on("click", function(){
			$(this).parent().animate({'top': '-50%'}, 400, function(){
				$(this).parent().remove();
			});
		});
		$(document).on("mouseup", handOutsideClick);
		// $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
	}
	function handOutsideClick(e) {
		var container = $('.va-full-width-modal-main');
		// if the target of the click isn't the container nor a descendant of the container
		if (!container.is(e.target) && container.has(e.target).length === 0) 
		{
		    container.find(".va-close-modal").click();
		    $(document).off("mouseup", handOutsideClick);
		}
	}

	jQuery(document).on("click", "button.btn-reset-sort-model", function(e){
		showFullWidthModal(`
				<p class="va-modal-title blue-color">Reset Sorting</p>
				<p>Use the default sorting on all models. When you click on the Reset sorting button, the sorting on all models will be exactly like the Default Repairs list. After resetting the order, the custom-created repair will show before the default repairs list. You can change the order individually on specific pages if you would like after the reset. You can easily go back to default anytime by resetting the sorting again.</p>
				<button type="button" class="va-button va-button-primary va-submit btn-reset-order">
					Reset Sorting
				</button>
			`);
	});

	jQuery(document).on("click", "button.reset-default-repair", function(e){
		if( jQuery(this).hasClass('preventdefault') ) {
			return;
		}
		let repair_name = jQuery(this).data('drname');
		let repair_id = jQuery(this).data('drid');
		let total_used = jQuery(this).data('total-used');
		showFullWidthModal(`
				<p class="va-modal-title">Reset <b>${repair_name}</b> Repair On All Models</p>
				<p>You are about to reset this default repair on all models that already have this repair individually configured. <br>The price, title, and description from ${repair_name} will reset to this default repair on all ${total_used} models. This change cannot be reverted.</p>
				<input type="hidden" name="alert" value="1">
				<button data-drid="${repair_id}" type="submit" class="va-button va-button-danger va-submit">
					Reset Repair
				</button>
			`);
	});

	jQuery(document).on('click', '.globe-icon-translation', function(){

			if(jQuery('.globe-icon-translation').hasClass("processing")) {
				return;
			}
			let btn = this;

			let trans_key = jQuery(this).data('trans-key');
			let trans_uqid = jQuery(this).data('trans-uqid');

			let trans_selector = jQuery(this).data('trans-selector');

			let rp_action = 'rp_get_dr_translations';

			if(trans_key === 'attr_name' || trans_key === 'attr_desc' || trans_key === 'attr_badge') {

				rp_action = 'rp_get_drattr_translations';

			}

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<div class="globe-icon-i"><i class="fas fa-spinner fa-spin"></i></div>');

			jQuery('.globe-icon-translation').addClass("processing");

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action: rp_action, key: trans_key, uqid: trans_uqid},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery('.globe-icon-translation').removeClass("processing");
					
					try {
		      			
		      			data = JSON.parse(data);

		      		} catch(e) {

		      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
		      			return;

		      		}
					
					let rows = '';

					data.translations.forEach(function(row){

						rows += `
							<tr>
								<td width="300">
									<div class="flag-img">
										<img width="28px" height="28px" src="${row.image}">
									</div>
									<div class="input-cont">
										<div class="wp-repair-input-group">
											<label>${row.alt_name}</label>
											<input type="text" class="user-info" data-lang-name="${row.name}" name="translations[]" value="${row.t_value}" required="">
										</div>
									</div>
								</td>
							</tr>
						`;

					});

					showFullWidthModal(`
						<p class="va-modal-title">Update Translations</p>
						<table style="width:100%;">
							<tbody>
								${rows}
							</tbody>
						</table>
						<input type="hidden" name="alert" value="1">
						<input type="hidden" name="trans_key" value="${trans_key}">
						<input type="hidden" name="trans_uqid" value="${trans_uqid}">
						<input type="hidden" name="trans_selector" value="${trans_selector}">
						<button type="submit" class="va-button va-submit va-trans">
							Update
						</button>
					`, 'trans-modal');

				},
				error: function(response) {
					jQuery(btn).html(btndata);
					jQuery('.globe-icon-translation').removeClass("processing");
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});

	});

	jQuery(document).on('click', '.va-full-width-modal-inner .va-button.va-submit.va-trans', function(){

		if(jQuery(this).hasClass("processing")) {
			return;
		}

		let btn = this;

		jQuery(btn).addClass("processing");

		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i style="position:relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

		let keys = [];
		let values = [];

		let translation_key = jQuery('.va-full-width-modal-inner input[name^="trans_key"]').val();
		let translation_uqid = jQuery('.va-full-width-modal-inner input[name^="trans_uqid"]').val();

		let translation_selector = jQuery('.va-full-width-modal-inner input[name^="trans_selector"]').val();

		let action = 'rp_update_dr_translations';

		if(translation_key === 'attr_name' || translation_key === 'attr_desc' || translation_key === 'attr_badge') {
			action = 'rp_update_drattr_translations';
		} else {
			action = 'rp_update_dr_translations';
		}

		jQuery('.va-full-width-modal-inner input[name^="translations["]').each(function(){
			keys.push(jQuery(this).data('lang-name'));
			values.push(jQuery(this).val());
		});

		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {
				action:action,
				keys:keys,
				values:values,
				translation_key: translation_key,
				translation_uqid: translation_uqid,
				dr_category: <?php echo $repairs_category->c_id; ?>
			},
			success: function(data) {

				jQuery(btn).html(btndata);

				jQuery(btn).removeClass("processing");

				try {
	      			
	      			data = JSON.parse(data);

	      		} catch(e) {

	      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
	      			return;

	      		}

	      		if(data.status == true || data.status == 'true') {
					jQuery(".va-close-modal").click();
					let globe_icon = null;

					jQuery('.globe-icon-translation').each(function(){

						let git_key = jQuery(this).data('trans-key');
						let git_uqid = jQuery(this).data('trans-uqid');

						if(git_key === translation_key && git_uqid === translation_uqid) {
							let _parent = 'tr.main-repair';
							if(git_key === 'attr_name' || git_key === 'attr_desc' || git_key === 'attr_badge') {
								_parent = 'tr.additional-repair-tr';
							}
							jQuery(this).parents(_parent).find(translation_selector).val(data.default_translation);
						}

					});
	      			repairPluginUI.alert_success('Translations updated successfully.');
					jQuery("#rp_processing_pending_jobs").show();
							window.setTimeout(function(){
									if( 'repeatablePendingJobsProcessingAR' in window && window.repeatablePendingJobsProcessingAR === false ) {
											window._repeatablePendingJobsProcessing();
									}
              }, window._getNextSafeSchedule(1));
	      		} else {
	      			repairPluginUI.alert_danger('Something went wrong, please try again later.');
	      		}

			},
			error: function( response ) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});

	});
}(jQuery));

</script>
