<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

global $rpQuery;

$rs_category = $rpQuery->prefix . 'rs_category';

$categories = $rpQuery->get_results("SELECT * FROM `$rs_category` ORDER BY c_position ASC");

$categories = rp_sanitize_output($categories);

?>
<?php wp_repair_admin_setup_tour_nav_html(); ?>
	<div class="wp-repair-container select-category">
		<div class="wp-repair-row">
			<div class="wp-repair-col-12 type-category">
				<div class="wp-repair-row">
					<div class="wp-repair-col-12">
						<h2 class="models-heading">Default Repairs</h2>
					</div>
					<?php
					if(!empty( $categories )) {
						?>
						<div class="wp-repair-col-12">
							<h2 class="category-question">Select the category in which you want to create default repairs:</h2>
						</div>
						<?php
						foreach ($categories as $category) {
							?>
							<div class="wp-repair-col-3">
								<div class="wp-repair-category-box">
									<a href="?page=wp_repair_default_repairs&repairs_category=<?php echo trim(strtolower(str_replace(' ', '-', $category->c_name))); ?>" class="category-box-container">
										<div class="wp-repair-img">
											<img src="<?php echo $category->c_img; ?>" alt="<?php echo $category->c_name; ?>">
										</div>
										<div class="wp-repair-text">
											<?php echo $category->c_name; ?>
										</div>
									</a>
								</div>
							</div>
							<?php
						}

					} else {

						?>
						<div class="wp-repair-col-12">
							<h2 class="category-question">
							Looks like you do not have any created categories, You need to <a href="?page=wp_repair_manage_categories">create a category</a> that contains both a brand and a model before you can create default repairs. Once you have this, you can apply default repairs to all models within that category.
							<br><br>
							If you prefer not to do this manually, you can <a href="?page=wp_repair_download_libraries&section=download_libraries">download over 1900 models</a> from our database, and our import function will automatically create a category and brand associated with each model.
							</h2>
						</div>
						<?php

					}
					?>
				</div>
			</div>
		</div>
	</div>
		<?php
		wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
		wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
		wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
		?>