<?php

// exit if accessed directly
defined('ABSPATH') || exit;

function rp_handle_timeslot_delete() {

    if( !empty( $_POST ?? '' ) && ($_POST['form_type'] ?? '') === 'delete_delivery_timeslot' ) {

        rp_verify_csrf_token_for_simple_form('planning_discount');

        // Array ( [delete_timeslot_id] => 3 [rp_csrf_token] => 8d0748f68d8f70ac91631eb4aee03cd3f62bf3e7c4006197c6158ac9b58f1699 [method] => pickup_service [form_type] => delete_delivery_timeslot )

        if( !empty( $_POST['delete_timeslot_id'] ?? '' ) && !empty( $_POST['method'] ?? '' ) && in_array(($_POST['method'] ?? ''), array('pickup_service', 'repair_on_location')) ) {

            global $rpQuery;

            $rs_delivery_timeslots = $rpQuery->prefix . 'rs_delivery_timeslots';

            $rpQuery->query("DELETE FROM `$rs_delivery_timeslots` WHERE `id` = '".rp_escape_sql($_POST['delete_timeslot_id'])."' AND `delivery_method` = '".rp_escape_sql($_POST['method'])."'");

        }

        echo "<script>window.location.href = 'admin.php?page=wp_repair_settings&section=planning_discount';</script>";

        exit;

    }

}

function rp_handle_timeslot_form() {

    if( !empty( $_POST ?? '' ) && ($_POST['form_type'] ?? '') === 'add_delivery_timeslot' ) {

        rp_verify_csrf_token_for_simple_form('planning_discount');

        if( !empty( $_POST['opening_time'] ?? '' ) && !empty( $_POST['opening_time_am_pm'] ?? '' ) && !empty( $_POST['closing_time'] ?? '' ) && !empty( $_POST['closing_time_am_pm'] ?? '' ) && in_array(($_POST['method'] ?? ''), array('pickup_service', 'repair_on_location')) ) {

            global $rpQuery;

            $rs_delivery_timeslots = $rpQuery->prefix . 'rs_delivery_timeslots';

            $opening_time = $_POST['opening_time'] . ' ' . $_POST['opening_time_am_pm'];
            $closing_time = $_POST['closing_time'] . ' ' . $_POST['closing_time_am_pm'];

            $opening_time = date('H:i', strtotime($opening_time));
            $closing_time = date('H:i', strtotime($closing_time));

            $delivery_method = $_POST['method'];

            $rpQuery->insert($rs_delivery_timeslots, array(
                'delivery_method' => $delivery_method,
                'slot_start' => $opening_time,
                'slot_end' => $closing_time,
            ));


        }

        echo "<script>window.location.href = 'admin.php?page=wp_repair_settings&section=planning_discount';</script>";

        exit;

    }

}

function rp_render_timeslot_form($method = '') {

    global $rpQuery;

    $rs_delivery_timeslots = $rpQuery->prefix . 'rs_delivery_timeslots';

    // get all entries from $rs_delivery_timeslots where delivery_method = $method
    $all_timeslots = $rpQuery->get_results("SELECT * FROM `$rs_delivery_timeslots` WHERE `delivery_method` = '".rp_escape_sql($method)."' ORDER BY `slot_start` ASC");

    // get all times between 12:00 AM and 11:30 PM
    $all_times = array();
    $startTime = strtotime('12:00 AM');
    $endTime = strtotime('11:59 AM');
    $addMins = 30 * 60;

    while ($startTime < $endTime) {
        $all_times[] = date('h:i', $startTime);
        $startTime += $addMins;
    }

    $all_times = array_unique($all_times);

    $all_times = array_values($all_times);

    ?>
    <style type="text/css">
        h2.rp-timeslot-heading {
            font-size: 14px;
            line-height: 1em;
            margin-left: 5px;
            margin-top: 20px;
        }
        button.add_timing_btn {
            width: auto;
            padding: 10px 15px;
            font-size: 12px;
            margin-top: 12px;
            margin-left: 5px;
        }
        .table.coupon-table .wp-repair-repair-card {
            margin-bottom: 0px;
        }
        button.delete_special_timing {
            background: none;
            color: #575757;
            border-radius: 6px;
            padding: 6px 9px;
            padding-right: 0px;
            font-size: 13px;
            cursor: pointer;
            border: 0px;
        }
        .added-timeslots {
            margin-top: 15px;
        }
        .the-timeslot {
            width: auto;
            padding: 8px 12px;
            box-sizing: border-box;
            display: inline-table;
            background: #efefef;
            border-radius: 12px;
            font-weight: 500;
            border: 1px solid #e0e0e0;
            margin: 5px;
        }
        .available-on-days .td-1,
        .available-on-days .td-2,
        .the-timeslot .td-1,
        .the-timeslot .td-2 {
            display: inline-table;
            vertical-align: middle;
        }

        .available-on-days .the-day {
            width: auto;
            padding: 12px;
            box-sizing: border-box;
            display: inline-table;
            background: #fff;
            border-radius: 8px;
            font-weight: 600;
            border: 2px solid #e0e0e0;
            margin: 5px;
            cursor: pointer;
        }
        .available-on-days .the-day.selected {
            border: 1px solid #1275c2 !important;
            box-shadow: 0 0 0 0.5px #1275c2 !important;
        }
        .available-on-days .td-2 {
            margin-left: 5px;
        }
    </style>
    <h2 class="rp-timeslot-heading">Timeslots</h2>
    <form action="" method="POST">
        <?php rp_csrf_token_input_field('planning_discount'); ?>
        <input type="hidden" name="method" value="<?php echo $method; ?>">
        <div class="table-responsive">
            <table class="table coupon-table">
                <tbody>
                    <tr class="closed">
                        <td>
                            <span class="wp-repair-repair-card">
                                <select class="coupons_select coupon_type" name="opening_time">
                                    <option value="">-- Select --</option>
                                    <?php
                                    foreach($all_times as $_time) {
                                        echo '<option value="'.$_time.'">'.$_time.'</option>';
                                    }
                                    ?>
                                </select>
                            </span>
                        </td>
                        <td>
                            <span class="wp-repair-repair-card">
                                <select class="coupons_select coupon_type am_pm w_65" name="opening_time_am_pm">
                                    <?php
                                    foreach(array('AM', 'PM') as $am_pm) {
                                        echo '<option value="'.$am_pm.'">'.$am_pm.'</option>';
                                    }
                                    ?>
                                </select>
                            </span>
                        </td>
                        <td>
                            <span class="wp-repair-repair-card">
                                <select class="coupons_select coupon_type" name="closing_time">
                                    <option value="">-- Select --</option>
                                    <?php
                                    foreach($all_times as $_time) {
                                        echo '<option value="'.$_time.'">'.$_time.'</option>';
                                    }
                                    ?>
                                </select>
                            </span>
                        </td>
                        <td>
                            <span class="wp-repair-repair-card p-right">
                                <select class="coupons_select coupon_type am_pm w_65" name="closing_time_am_pm">
                                    <?php
                                    foreach(array('AM', 'PM') as $am_pm) {
                                        if($am_pm === 'PM') {
                                            echo '<option value="'.$am_pm.'" selected="selected">'.$am_pm.'</option>';
                                        } else {
                                            echo '<option value="'.$am_pm.'">'.$am_pm.'</option>';
                                        }
                                    }
                                    ?>
                                </select>
                            </span>
                        </td>
                    </tr>
                    <tr class="spacer"><td></td></tr>
                </tbody>
            </table>
            <button type="submit" name="add_timing" class="wp-general-info add_timing_btn">
                Add Timeslot <i class="fas fa-chevron-right"></i>
            </button>
        </div>
    </form>
    <div class="added-timeslots">
        <?php
        foreach($all_timeslots as $timeslot_row) {
            $start = date('g:i a', strtotime($timeslot_row->slot_start));
            $end = date('g:i a', strtotime($timeslot_row->slot_end));
            $text = $start.' — '.$end;
            ?>
            <div class="the-timeslot">
                <div class="td-1">
                    <?php echo $text; ?>
                </div>
                <div class="td-2">
                    <form action="" method="POST">
                        <?php rp_csrf_token_input_field('planning_discount'); ?>
                        <input type="hidden" name="method" value="<?php echo $method; ?>">
                        <input type="hidden" name="delete_timeslot_id" value="<?php echo $timeslot_row->id; ?>">
                        <button type="submit" name="delete_special_timing" class="wp-repair-coupon-delete delete_special_timing">
                            <i class="fas fa-times"></i>
                        </button>
                    </form>
                </div>
            </div>
            <?php
        }
        ?>
    </div>
    <h2 class="rp-timeslot-heading">Days</h2>
    <div class="available-on-days">
        <?php
        $days_name = array(
            'Monday',
            'Tuesday',
            'Wednesday',
            'Thursday',
            'Friday',
            'Saturday',
            'Sunday'
        );
        $available_days = json_decode(rp_get_option('rp_'.$method.'_available_days', json_encode(array())), TRUE);
        foreach($days_name as $day_name) {
            $selected = (isset($available_days[strtolower($day_name)]) && $available_days[strtolower($day_name)] == 1) ? 'selected' : '';
            ?>
            <label class="the-day <?php echo $selected; ?>">
                <div class="td-1">
                    <?php echo $day_name; ?>
                </div>
                <div class="td-2">
                    <input type="checkbox" name="<?php echo $method; ?>_available_on_<?php echo strtolower($day_name); ?>" value="<?php echo $day_name; ?>" <?php if( !empty($selected) ) { echo "checked='checked'"; } ?>>
                </div>
            </label>
            <?php
        }
        ?>
    </div>
    <?php
}