<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

$logs = rp_get_option('rp_dp_errors', array());

if( !empty( $logs ) ) {

    // json decode
    $logs = json_decode( $logs, true );

} else {

    $logs = array();

}

$dp_settings_page_image = WP_REPAIR_PLUGIN_URL . 'assets/images/Dynamic-pricing-settings-image.png';

RP_DynamicPricingAddon::is_active();

?><div class="full-width-wp-repair">
    <div class="wp-repair-main-section-heading">
        <h2>
            <span class="light">Dynamic</span>
            <span class="bold">Pricing</span>
            <?php
            if( rp_is_enabled_dynamic_pricing() !== FALSE ) {
                echo '<span class="badge badge-active">Active</span>';
            } else {
                echo '<span class="badge badge-inactive">Inactive</span>';
            }
            ?>
        </h2>
        <p class="more-info">Hassle free, automated pricing for your repair shop</p>
    </div>
    <div class="rp-model-linked-analytics">
        <?php
        list($total_models, $total_linked_models) = rp_get_total_models_linked();
        ?>
        <span class="models-linked"><?php echo $total_linked_models; ?></span> of <span class="total-models"><?php echo $total_models; ?></span>
        <span class="models-linked-text">models linked</span>
    </div>
    <form action="" method="POST">
        <div class="dp-license-activation-form">
            <?php
            if( defined('WP_REPAIR_DYNAMIC_LICENSE_MESSAGE') ) {
                ?>
                <div class="wp-repair-alert error license"><?php echo WP_REPAIR_DYNAMIC_LICENSE_MESSAGE; ?></div>
                <?php
            }
            ?>
            <p>Please fill in your license code or <a target="_blank" href="https://www.repairplugin.com/onboard/dynamic-pricing-month/">purchase a subscription</a></p>
            <div class="wp-repair-input-group">
                <input type="text" class="regular-text code" name="dp_license_key" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
                <button type="submit" class="wp-general-info">Activate</button>
            </div>
        </div>
    </form>
    <img class="dp_settings_page_image" src="<?php echo $dp_settings_page_image; ?>" alt="">
</div>