<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

global $wp_repair_lang;


global $rpQuery;

require_once( ABSPATH . 'wp-admin/includes/file.php' ); // require file.php

$rp_dp_which_price_to_consider = rp_get_option('rp_dp_which_price_to_consider', 'cheapest');

$rp_dp_if_part_is_unavailable = rp_get_option('rp_dp_if_part_is_unavailable', 'use_fallback');

$rp_dp_round_up_method = rp_get_option('rp_dp_round_up_method', 'ceil');

$rp_dp_date_format_front_end = rp_get_option('rp_dp_date_format_front_end', 'd/m/y');

$rp_hide_attribute_if_no_part = rp_get_option('rp_hide_attribute_if_no_part', '0');

// temporary commented to remove this option from settings
// $rp_dp_default_margin_setting = rp_get_option('rp_dp_default_margin_setting', 0);

$rp_which_way_for_processing_datafeed = rp_get_option('rp_which_way_for_processing_datafeed', 'wordpress');

if(RP_DynamicPricingAddon::is_active() && isset( $_POST['deactivate_license'] )) {

	rp_verify_csrf_token_for_simple_form('dynamic_pricing');

	RP_DynamicPricingAddon::deactivate_license();

	echo "<script>location.replace('admin.php?page=wp_repair_settings&section=dynamic_pricing');</script>";

}

if(!RP_DynamicPricingAddon::is_active() && isset( $_POST['dp_license_key'] )) {

	rp_verify_csrf_token_for_simple_form('dynamic_pricing');

	$license_key = sanitize_text_field( $_POST['dp_license_key'] );

	$email = rp_get_option( "Repairplugin_lic_email", get_bloginfo( 'admin_email' ));

	RP_DynamicPricingAddon::activate_license($license_key, $email);

	echo "<script>location.replace('admin.php?page=wp_repair_settings&section=dynamic_pricing');</script>";

}

if (isset($_POST['update_company']) && RP_DynamicPricingAddon::is_active()) {

	rp_verify_csrf_token_for_simple_form('dynamic_pricing');

    // rp_dp_which_price_to_consider
    if(isset($_POST['rp_dp_which_price_to_consider']) && !empty($_POST['rp_dp_which_price_to_consider'])) {
    	if(rp_get_option('rp_dp_which_price_to_consider', FALSE) === FALSE) {
    		rp_add_option('rp_dp_which_price_to_consider', $_POST['rp_dp_which_price_to_consider']);
    	} else {
    		rp_update_option('rp_dp_which_price_to_consider', $_POST['rp_dp_which_price_to_consider']);
    	}
    }

	// rp_which_way_for_processing_datafeed
	if(isset($_POST['rp_which_way_for_processing_datafeed']) && !empty($_POST['rp_which_way_for_processing_datafeed'])) {
		if(rp_get_option('rp_which_way_for_processing_datafeed', FALSE) === FALSE) {
			rp_add_option('rp_which_way_for_processing_datafeed', $_POST['rp_which_way_for_processing_datafeed']);
		} else {
			rp_update_option('rp_which_way_for_processing_datafeed', $_POST['rp_which_way_for_processing_datafeed']);
		}
	}

	// rp_dp_default_margin_setting
	// temporary commented to remove this option from settings
	
	// if(array_key_exists('rp_dp_default_margin_setting', $_POST)) {
	// 	$_POST['rp_dp_default_margin_setting'] = (float) ($_POST['rp_dp_default_margin_setting'] ?? 0);
	// 	if(rp_get_option('rp_dp_default_margin_setting', FALSE) === FALSE) {
	// 		rp_add_option('rp_dp_default_margin_setting', $_POST['rp_dp_default_margin_setting']);
	// 	} else {
	// 		rp_update_option('rp_dp_default_margin_setting', $_POST['rp_dp_default_margin_setting']);
	// 	}
	// }

	// rp_dp_date_format_front_end
    if(isset($_POST['rp_dp_date_format_front_end']) && !empty($_POST['rp_dp_date_format_front_end'])) {
    	if(rp_get_option('rp_dp_date_format_front_end', FALSE) === FALSE) {
    		rp_add_option('rp_dp_date_format_front_end', $_POST['rp_dp_date_format_front_end']);
    	} else {
    		rp_update_option('rp_dp_date_format_front_end', $_POST['rp_dp_date_format_front_end']);
    	}
    }

    // rp_dp_if_part_is_unavailable
    if(isset($_POST['rp_dp_if_part_is_unavailable']) && !empty($_POST['rp_dp_if_part_is_unavailable'])) {
    	if(rp_get_option('rp_dp_if_part_is_unavailable', FALSE) === FALSE) {
    		rp_add_option('rp_dp_if_part_is_unavailable', $_POST['rp_dp_if_part_is_unavailable']);
    	} else {
    		rp_update_option('rp_dp_if_part_is_unavailable', $_POST['rp_dp_if_part_is_unavailable']);
    	}
    }

    // rp_dynamic_pricing_is_enabled (0, 1)
    if(isset($_POST['rp_dynamic_pricing_is_enabled']) && $_POST['rp_dynamic_pricing_is_enabled'] !== NULL && $_POST['rp_dynamic_pricing_is_enabled'] !== '' && in_array($_POST['rp_dynamic_pricing_is_enabled'], array('0', '1'))) {
    	if(rp_get_option('rp_dynamic_pricing_is_enabled', FALSE) === FALSE) {
    		rp_add_option('rp_dynamic_pricing_is_enabled', $_POST['rp_dynamic_pricing_is_enabled']);
    	} else {
    		rp_update_option('rp_dynamic_pricing_is_enabled', $_POST['rp_dynamic_pricing_is_enabled']);
    	}
    }

	// rp_hide_attribute_if_no_part (0, 1)
	if(isset($_POST['rp_hide_attribute_if_no_part']) && $_POST['rp_hide_attribute_if_no_part'] !== NULL && $_POST['rp_hide_attribute_if_no_part'] !== '' && in_array($_POST['rp_hide_attribute_if_no_part'], array('0', '1'))) {
		if(rp_get_option('rp_hide_attribute_if_no_part', FALSE) === FALSE) {
			rp_add_option('rp_hide_attribute_if_no_part', $_POST['rp_hide_attribute_if_no_part']);
		} else {
			rp_update_option('rp_hide_attribute_if_no_part', $_POST['rp_hide_attribute_if_no_part']);
		}
	}

    // rp_dp_round_up_dynamic_price (0, 1)
    if(isset($_POST['rp_dp_round_up_dynamic_price']) && $_POST['rp_dp_round_up_dynamic_price'] !== NULL && $_POST['rp_dp_round_up_dynamic_price'] !== '' && in_array($_POST['rp_dp_round_up_dynamic_price'], array('0', '1'))) {
    	if(rp_get_option('rp_dp_round_up_dynamic_price', FALSE) === FALSE) {
    		rp_add_option('rp_dp_round_up_dynamic_price', $_POST['rp_dp_round_up_dynamic_price']);
    	} else {
    		rp_update_option('rp_dp_round_up_dynamic_price', $_POST['rp_dp_round_up_dynamic_price']);
    	}
    }

    $expected_values = array('ceil', '0', '95', '99', '100');
    if(array_key_exists('rp_dp_round_up_method', $_POST) && $_POST['rp_dp_round_up_method'] !== NULL && $_POST['rp_dp_round_up_method'] !== '' && in_array($_POST['rp_dp_round_up_method'], $expected_values)) {
    	if(rp_get_option('rp_dp_round_up_method', FALSE) === FALSE) {
    		rp_add_option('rp_dp_round_up_method', $_POST['rp_dp_round_up_method']);
    	} else {
    		rp_update_option('rp_dp_round_up_method', $_POST['rp_dp_round_up_method']);
    	}
    }

    // option: rp_dp_enabled_suppliers
    // expected value = array of supplier ids
    if(array_key_exists('rp_dp_enabled_suppliers', $_POST) && $_POST['rp_dp_enabled_suppliers'] !== NULL && $_POST['rp_dp_enabled_suppliers'] !== '' && is_array($_POST['rp_dp_enabled_suppliers'])) {
    	
    } else {
    	$_POST['rp_dp_enabled_suppliers'] = array();
    }

    if(rp_get_option('rp_dp_enabled_suppliers', FALSE) === FALSE) {
        rp_add_option('rp_dp_enabled_suppliers', $_POST['rp_dp_enabled_suppliers']);
    } else {
        rp_update_option('rp_dp_enabled_suppliers', $_POST['rp_dp_enabled_suppliers']);
    }

   
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=dynamic_pricing');</script>";
}
function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}

?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.wp-general-info{
		padding: 15px;
		font-size: 13px;
        margin-top: 25px;
    width: auto;
	}
	.wp-general-info.recaptcha-popup-btn {
		background-color: #fff;
		border: 2px solid #1275c2;
		color: #1275c2;
		width: 240px;
		box-sizing: border-box;
	}
	.wp-general-info.recaptcha-popup-btn.recaptcha-active {
		border-left: 12px solid #008000;
	}
	.wp-general-info.recaptcha-popup-btn img {
		max-width: 24px;
		max-height: 24px;
		vertical-align: middle;
		margin-right: 5px;
	}
	.rp_is_synced {
		margin-bottom: 0px;
	}
	.rp_is_synced small {
		display: table;
		font-size: 10px;
	}
	@media screen and (max-width: 768px) {
		.wp-repair-col-3 .main-section .section-two{
			margin-top: 0px;
			width: 100%;
		}
	}
	.wp-repair-col-3{
		margin-top: 220px;
		float: right;
	}
	.is_closed{
		width: 26px !important;
	}
	.wp-repair-col-4.main-section{
		padding: 20px 20px 20px 20px;
	}
	.wp-repair-col-4.main-section.section-two {
		padding: 20px 20px 30px 20px;
	}
	.days-setting-table input.has-breaktime-error {
		box-shadow: 0 0 0 1px #b12222;
	}
	.wp-repair-alert.error,
	.wp-repair-alert.info {
		margin-top: 0px;
		margin-bottom: 12px;
		background: #f8d7da;
		color: #721c24;
		border-radius: 8px;
		border: 2px solid #f5c6cb;
		padding: 12px;
		font-size: 13px;
		width: calc(100% - 60px);
		line-height: 1.4em;
	}
	.wp-repair-alert.info {
		width: 100%;
		box-sizing: border-box;
		background: rgb(18, 117, 194, 0.2);
		color: #404040;
		border: 0px;
	}
    .wp-repair-main-section-heading {
    height: 45px;
	}
	.clearfix {
		clear: both;
	}
	.clearfix::after {
		content: "";
		display: table;
		clear: both;
	}
	.wp-repair-special-col {
		padding: 0px 20px;
		padding-top: 20px;
		padding-bottom: 30px;
	}
	.nmb-0 {
		margin-bottom: 0px;
	}
	.sec-3.mobile {
		display: none;
	}
	.sec-3.desktop {
		display: block;
	}
	@media(max-width: 424px) {
		.wp-repair-special-col {
			padding-left: 15px;
			padding-right: 15px;
		}
	}
	@media(max-width: 1210px) {
		.sec-3.desktop {
			display: none;
		}
		.sec-3.always-show-cont.desktop {
			display: block;
		}
		.sec-3.mobile {
			display: block;
		}
		.wp-repair-col-4.main-section.section-two > .tax-fields.first.special-mobile {
			margin-top: 5px !important;
		}
		.wp-repair-col-4.main-section.section-two {
			padding-bottom: 0px;
		}
		.wp-repair-special-col {
			padding-top: 0px;
			position: relative;
			top: -20px;
		}
		.wp-repair-special-col h2 {
			margin-top: 0px;
		}
	}
</style>
<style type="text/css">
	.va-full-width-modal-main.trans-modal .wp-repair-input-group {
		margin-top: 10px;
	}
	.va-full-width-modal-main {
		max-width: 475px;
		max-height: 80%;
		overflow-y: auto;
	}
	.va-full-width-modal .flag-img {
		width: 36px;
		display: inline-block;
		position: relative;
		top: 9px;
	}
	.va-full-width-modal .input-cont {
		width: calc(100% - 40px);
		display: inline-block;
	}
	.va-full-width-modal .va-button.va-submit {
		margin-top: 0px;
		display: inline-table;
		float: right;
		margin-bottom: 15px;
		position: relative;
		right: 3px;
		min-width: 80px;
	}
	.va-full-width-modal.recaptcha-popup-modal .va-save-recaptcha {
		float: unset;
		background: #1275c2;
		color: #fff;
		font-weight: 500;
		border: 1px solid #1275c2;
		border-radius: 5px;
		padding: 8px 15px;
		cursor: pointer;
		font-size: 14px;
		margin-top: 25px;
	}
	.globe-icon-translation {
		cursor: pointer;
		width: calc(100% - 2px);
		height: 42px;
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
	}

	.clearfix {
		display: block;
	}

	.clearfix::after {
		content: "";
		clear: both;
		display: table;
	}
	.globe-icon-i {
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
		right: 0px;
		line-height: 0em;
		background: #fff;
		padding: 0px 8px;
	}
.mce-panel.mce-floatpanel .mce-widget.mce-btn.mce-primary.mce-abs-layout-item.mce-first.mce-btn-has-text {
	background-color: #2d8ac7;
}
.mce-btn {
	background-color: #fff;
}
.mce-panel {
	background-color: #fff;
}
.wp-repair-input-group > .mce-panel.mce-container {
	border-width: 2px;
		border-radius: 8px;
		border: 2px solid #cfcfcf !important;
		box-sizing: border-box;
		padding: 0px 2px;
	transition: border-color 0.3s;
}
.mce-path {
	display: none;
}
.mce-statusbar.mce-container {
	border: 0px;
}
.mce-container-body .mce-resizehandle {
	right: 2px;
		bottom: 2px;
}
.mce-container-body.mce-stack-layout {
	padding: 1px;
}
.wp-repair-input-group label {
	z-index: 10;
}
.wp-repair-input-group > .mce-panel.mce-container:hover {
	border: 2px solid #2781c7 !important;
	box-shadow: none;
	outline: 0;
}
.mce-container,
.mce-content-body,
.mce-menubar .mce-menubtn button span,
.mce-menu-item,
.mce-menu-item .mce-ico, .mce-menu-item .mce-text  {
	color: #454545;
}
div.mce-edit-area {
	min-height: 200px;
}
div.mce-edit-area iframe {
	min-height: 200px;
}
/*.mce-container.mce-menubar.mce-toolbar {
	display: none;
}*/
iframe #tinymce {
	background-color: #000;
}
.wp-repair-col-4.pdf-offer.main-section.clearfix {
	padding-bottom: 15px;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	width: 300px;
}
.location-table {
	margin: 0px;
	padding: 15px;
	margin-bottom: 20px;
}
.location-table .ractions-td .switch {
	float: right;
}

.location-table .details-container .wp-repair-inner-col.section-1 {
	float: left;
	width: 55%;
	box-sizing: border-box;
}
.location-table .details-container .wp-repair-inner-col.section-2 {
	float: left;
	width: 45%;
	padding: 0px 20px;
	padding-top: 8px;
	box-sizing: border-box;
}

.location-table td.shortcode-heading {
	font-size: 9px;
	font-weight: 700;
	padding: 3px 0px;
	color: #61666b;
}

.location-table td.actual-shortcode {
	font-size: 9px;
	font-weight: 600;
	padding: 3px 0px;
	color: #61666b;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	font-size: 14px;
}

.table-responsive.location-table button.plus-icon.see-more {
	text-align: left;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	width: 250px;
	vertical-align: middle;
	display: inline-table;
}
.table-responsive.location-table button.plus-icon.see-more .dropicon {
	vertical-align: middle;
}

@media(max-width: 1140px) {
	.location-table .details-container .wp-repair-inner-col.section-1 {
		width: 100%;
	}
	.location-table .details-container .wp-repair-inner-col.section-2 {
		width: 100%;
		padding: 0px;
		padding-top: 8px;
	}
}

@media(max-width: 500px) {
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 200px;
	}
}


@media(max-width: 420px) {
	.table-responsive.location-table .wp-repair-input-group {
	    left: 0px;
	}
	.apply-tax-rate .td.text {
		width: 70%;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 140px;
	}
	.wp-repair-input-group input {
		width: 99%;
	}
}
@media(max-width: 370px) {
	.location-table {
		padding: 10px;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 100px;
		font-size: 13px;
	}
}
/* Customised Modal */


.va-modal-container {
	position: fixed;
	bottom: 85px;
	left: 30px;
	background: rgba(0,0,0,0.3);
	z-index: 99999;
	width: 300px;
}

.va-modal-main {
	border-radius: 8px;
	width: 100%;
	max-width: 450px;
	height: auto;
	background: #fff;
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	box-shadow: 0px 0px 5px rgb(0 0 0 / 30%);
}

.va-modal-container.unsaved .va-modal-main {
	background: #a81019;
}

.va-modal-container.saved .va-modal-main {
	background: var(--west--wales--maincolor);
}

.va-modal-inner {
	padding: 15px;
}

.va-modal-inner p {
	font-size: 18px;
	display: table;
	margin: 0px;
	color: var(--west--wales--maincolor);
	max-width: 240px;
	font-weight: 400;
}

.va-modal-container.unsaved .va-modal-inner p,
.va-modal-container.saved .va-modal-inner p {
	color: #fff;
}

.va-modal-inner a {
	display: table;
	margin-top: 8px;
}

.va-modal-container .va-close-modal,
.va-full-width-modal .va-close-modal {
	position: absolute;
	top: 8px;
	right: 8px;
	background: #efefef;
	padding: 8px;
	line-height: 1em;
	cursor: pointer;
	border: 1px solid #aaaa;
	background: #efefef;
	border-radius: 4px;
	outline: 0 !important;
	box-shadow: unset !important;
	transition: all 0.3s;
}

.va-modal-container .va-close-modal:hover,
.va-modal-container .va-close-modal:active,
.va-modal-container .va-close-modal:focus,
.va-full-width-modal .va-close-modal:hover,
.va-full-width-modal .va-close-modal:active,
.va-full-width-modal .va-close-modal:focus  {
	background: #fafafa;
}

.va-full-width-modal .va-modal-title {
	font-weight: 400;
    max-width: 93%;
    font-size: 18px;
    margin-top: 0px;
    margin-bottom: 10px;
    color: #1275c2;
}

.va-full-width-modal .va-modal-title b {
	font-weight: 700;
}

.va-modal-container.saved .va-modal-inner a:hover,
.va-modal-container.saved .va-modal-inner a:active,
.va-modal-container.saved .va-modal-inner a:focus {
	background: #fafafa;
	color: var(--west--wales--maincolor);
}

.va-container.property-details .va-content-box .call-to-action .va-button-default {
	background: #fafafa;
	border: 1px solid #fafafa;
	color: var(--west--wales--maincolor);
	font-weight: 400;
}

.va-container.property-details .va-content-box .call-to-action .va-button-default:hover,
.va-container.property-details .va-content-box .call-to-action .va-button-default:active,
.va-container.property-details .va-content-box .call-to-action .va-button-default:focus {
	background: #fff;
	color: var(--west--wales--maincolor);
	border: 1px solid #fafafa;
}

.va-container.property-details .va-content-box .call-to-action .va-button.va-fav-icon-details-page.prop-already-saved {
	color: #a81019;
	background: rgb(168 16 25 / 10%);
}

.va-container.property-details .va-content-box .call-to-action .va-button.va-fav-icon-details-page .fa-spinner {
	font-size: 20px;
}

.va-container .set-alert-buttons {
	margin: 0px;
}

.va-col-md-12.alert-btn-cols {
	padding: 15px;
}

.va-full-width-modal {
	position: fixed;
	top: 0px;
	left: 0px;
	width: 100%;
	height: 100%;
	z-index: 10000;
	background: rgba(0,0,0,0.3);
}

.va-full-width-modal-main {
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	background: #fff;
	box-shadow: 0px 0px 5px rgb(0 0 0 / 30%);
	width: 100%;
	max-width: 450px;
	border-radius: 8px;
}

.va-full-width-modal-main p {
	font-size: 14px;
}

.va-full-width-modal-inner {
	padding: 15px; 
}

.va-full-width-modal .va-form-group label {
	display: table;
}

.va-full-width-modal .va-form-group input {
	width: 100%;
	border-radius: 5px;
	display: table;
	margin-bottom: 8px;
}

.va-button.va-submit,
.va-button.va-submit:hover,
.va-button.va-submit:active,
.va-button.va-submit:focus {
	background: #1275c2;
	color: #fff;
	font-weight: 500;
	border: 1px solid #1275c2;
	border-radius: 5px;
	padding: 8px 15px;
	cursor: pointer;
	font-size: 14px;
}

button.va-button-primary,
button.va-button-primary:hover,
button.va-button-primary:active,
button.va-button-primary:focus {
	border-color: #1275c2 !important;
	background: #1275c2 !important;
	background-color: #1275c2 !important;
}

.va-modal-title.blue-color {
	color:  #1275c2 !important;
	font-weight: 500;
}

.full-width-wp-repair {
    box-sizing: border-box;
    display: table;
    width: 100%;
    padding: 20px;
    padding-top: 0px;
	position: relative;
}

.suppliers .apply-tax-rate {
    margin-top: 10px;
}

.badge.badge-inactive {
    background: #aaa;
    color: #fff;
    padding: 5px 8px;
    border-radius: 5px;
    font-size: 12px;
}

.badge.badge-active {
    background: #0fa101;
    color: #fff;
    padding: 5px 8px;
    border-radius: 5px;
    font-size: 12px;
}

.rp-cron-job-info {
		display: table;
		padding: 0px 20px;
		width: 100%;
		box-sizing: border-box;
		margin-bottom: 40px;
	}
	.rp-cron-job-info.command {
		margin-bottom: 10px;
	}
	.rp-cron-job-info .bold {
		display: table;
		width: 100%;
		font-weight: 600;
		margin-bottom: 5px;
	}
	.rp-cron-job-info .light {
		display: table;
		width: 100%;
		padding: 8px 16px;
		background: rgb(18, 117, 194, 0.2);
		box-sizing: border-box;
		border-radius: 8px;
		color: #404040;
		font-weight: 700;
	}

    .rp-dynamic-pricing-settings-nav {
        margin: 20px 0px;
    }

    .rp-dynamic-pricing-settings-nav a,
    .rp-dynamic-pricing-settings-nav a:visited,
    .rp-dynamic-pricing-settings-nav a:hover,
    .rp-dynamic-pricing-settings-nav a:active,
    .rp-dynamic-pricing-settings-nav a:focus {
        display: inline-block;
        padding: 6px 12px;
        background: #fff;
        color: #1275c2;
        border: 1px solid #1275c2;
        border-radius: 5px;
        margin-right: 5px;
        font-size: 12px;
        text-decoration: none;
        outline: 0;
        box-shadow: unset;
    }
    .rp-dynamic-pricing-settings-nav a.active {
        background: #1275c2 !important;
        color: #fff !important;
    }

    table.recent-logs {
        width: 100%;
        border-collapse: collapse;
    }

    table.recent-logs tbody tr {
        border-left: 5px solid #0081d2;
    }

    table.recent-logs.error-logs tbody tr {
        border-left: 5px solid #d20000;
    }

    table.recent-logs .t-left {
        text-align: left;
    }

    table.recent-logs .t-center {
        text-align: center;
    }

    table.recent-logs thead tr th {
        background: #efefef;
    }

    table.recent-logs tr td,
    table.recent-logs tr th {
        background: #fbfbfb;
        padding: 10px;
        border-bottom: 1px solid #ddd;
        vertical-align: middle;
    }

	p.last_synced {
		margin: 0px;
		position: relative;
		top: -6px;
		font-size: 8px;
		text-transform: uppercase;
		font-weight: 600;
		letter-spacing: 1.5px;
	}

	.wp-repair-row .bg-with-border {
		position: relative;
	}

	.rp-model-linked-analytics {
		position: absolute;
		text-align: center;
		line-height: 1.5em;
		width: 150px;
		font-size: 14px;
		background: #fbfbfb;
		box-shadow: 0px 0px 2px rgba(0,0,0,0.2);
		border-radius: 5px;
		right: 20px;
		top: 9px;
		line-height: 1.2em;
		padding: 10px 5px;
		box-sizing: border-box;
		font-weight: 600;
		color: #0fa101;
	}
	.rp-model-linked-analytics .models-linked-text {
		display: block;
		text-transform: uppercase;
		letter-spacing: 2px;
		font-size: 10px;
		font-weight: 500;
		color: #404040;
	}

	@media(max-width: 1160px) {
		.rp-model-linked-analytics {
			position: relative;
			right: unset;
			left: 0px;
			top: unset;
			bottom: unset;
			margin-top: 15px;
			margin-bottom: 15px;
		}
	}

	.wp-repair-repair-card {
		display: table;
		max-width: 400px;
	}

	.wp-repair-input-group.default-margin {
		max-width: 400px;
	}

	img.dp_settings_page_image {
		margin-top: 30px;
		max-width: 500px;
		width: 100%;
	}

	.dp-license-activation-form {
		margin-top: 30px;
	}

	.dp-license-activation-form p {
		font-size: 16px;
		margin-top: 10px;
	}

	.dp-license-activation-form a {
		font-size: 16px;
		text-decoration: underline;
		font-weight: 600;
		color: #1275c2;
		outline: 0;
	}

	.dp-license-activation-form .wp-repair-input-group {
		margin-top: 0px;
	}
	
	.dp-license-activation-form .wp-repair-input-group input {
		display: inline-table;
		width: 330px;
	}

	.dp-license-activation-form .wp-repair-input-group button {
		margin-top: 0px;
		display: inline-table;
		margin-left: 10px;
		padding: 14px;
		height: 42px;
	}

	.wp-repair-alert.error.license {
		width: 100%;
		margin: 0px;
	}

	.table-responsive.dp-license-info {
		margin-top: 30px;
		padding: 30px 15px 25px 15px;
		border: 2px solid #efefef;
		background: #fbfbfd;
		border-radius: 12px;
	}

	.table-responsive.dp-license-info h2 {
		margin-top: 0px;
	}

	.table-responsive.dp-license-info p {
		font-size: 12px;
	}

	.table-responsive.dp-license-info tr th {
		width: 150px;
		padding: 8px 0px;
		text-align: left;
		font-weight: 500;
		font-size: 12px;
	}

	.table-responsive.dp-license-info tr td {
		width: 300px;
		padding: 8px 0px;
		text-align: left;
		font-size: 12px;
		padding-left: 8px;
	}

	.el-blue-btn,
	.el-blue-btn:hover,
	.el-blue-btn:focus,
	.el-blue-btn:active,
	.el-blue-btn:visited {
		padding: 0 5px 2px;
		color: #fff;
		background-color: #20b1d2;
		border-radius: 3px;
		text-decoration: none;
		-webkit-box-shadow: 0 0 3px -1px rgba(0,0,0,0.38);
		-moz-box-shadow: 0 0 3px -1px rgba(0,0,0,0.38);
		box-shadow: 0 0 3px -1px rgba(0,0,0,0.38);
	}

	.badge-active.is-valid {
		background: #8fcc77;
		padding: 3px 6px;
	}

	.wp-general-info.deactivate-btn {
		padding: 10px 12px;
		font-size: 10px;
		margin-top: 25px;
		width: auto;
	}

	.dependant-field {
		overflow: hidden;
		transition: all 0.3s;
	}

	.max-height-0 {
		max-height: 0px;
	}

	a.download-missing-attributes,
	a.download-missing-attributes:hover,
	a.download-missing-attributes:focus,
	a.download-missing-attributes:active,
	a.download-missing-attributes:visited {
		font-size: 10px;
		text-decoration: none;
		box-shadow: unset;
		font-weight: 600;
		outline: 0;
		display: table;
		width: auto;
		color: #fff;
		padding: 9px 12px;
		margin-top: 20px;
	}

	.no-suppliers-found {
		margin-top: 15px;
	}
	.supplier-image img {
		height: 100%;
		width: auto;
	}
	.supplier-image {
		width: 110px;
		height: 110px;
		overflow: hidden;
		border-radius: 12px;
	}

	.suppliers-table.found {
		margin-top: 0px;
	}

	.suppliers-table.found td {
		padding: 8px 12px;
		padding-top: 25px;
	}

	.suppliers-connected-model {
		display: inline-table;
		color: #1275c2;
		margin-left: 12px;
	}

	.suppliers-connected-model.no-a-link {
		margin-left: 0px;
	}

	td.supplier-status {
		vertical-align: top;
		padding-left: 0px !important;
	}

	td.supplier-status .switch {
		top: 40px;
	}

	td.supplier-status.no-image .switch {
		top: 0px;
	}

	td.supplier-image-td {
		vertical-align: top;
	}

	td.supplier-info .supplier-image {
		display: none;
	}

	td.supplier-info {
		vertical-align: top;
		padding-right: 0px !important;
	}
	
	td.supplier-info h2 {
		margin: 0px;
	}

	td.supplier-info .flag-image {
		width: 18px;
		display: inline-table;
		border-radius: 50%;
		overflow: hidden;
		position: relative;
		top: 1px;
		margin-left: 6px;
	}

	td.supplier-info .flag-image img {
		width: 100%;
		height: auto;
	}

	td.supplier-info p {
		display: block;
		margin-bottom: 12px;
		margin-top: 10px;
	}

	td.supplier-info a,
	td.supplier-info a:hover,
	td.supplier-info a:focus,
	td.supplier-info a:active,
	td.supplier-info a:visited {
		padding: 5px 8px;
		background: #1275c2 !important;
		color: #fff;
		text-decoration: none;
		border-radius: 5px;
		font-weight: 600;
		display: inline-table;
		margin-top: 0px;
		outline: 0;
		box-shadow: unset;
		border: 0px;
	}

	.manage-linking {
		padding: 3px 8px;
		background: #fff !important;
		border: 2px solid #1275c2;
		color: #1275c2;
		text-decoration: none;
		border-radius: 5px;
		font-weight: 600;
		display: inline-table;
		margin-top: 0px;
		margin-right: 3px;
		outline: 0;
		box-shadow: unset;
		border: 2px solid #1275c2;
		cursor: pointer;
	}

	.details-container .multicheckboxes {
		background: #f8f8f8;
    	border-radius: 10px;
		padding: 0px 0px 0px 15px;
		margin-left: 0px;
		margin-bottom: 25px;
		overflow: auto;
		height: 330px;
		position: relative;
		top: 10px;
		font-family: 'Montserrat', sans-serif;
	}
	.details-container.clearfix .wp-repair-col-4 {
		display: inline-table;
		width: 100%;
		float: left;
		overflow: hidden;
		box-sizing: border-box;
	}
	.multicheckboxes button.btn-dropdown .chevron.up {
		height: auto;
		line-height: 1em !important;
		display: table;
		position: relative;
		top: -3px;
	}
	.multicheckboxes li span.chevron.down i, .multicheckboxes li span.chevron.up i {
		color: #616161;
		position: relative;
		top: -2px;
		font-size: 10px;
		margin-right: 4px;
		-webkit-transition: 0.3s all;
		-moz-transition: 0.3s all;
		-o-transition: 0.3s all;
		-ms-transition: 0.3s all;
		transition: 0.3s all;
	}
	.multicheckboxes li span.chevron.up i {
		transform: rotate(-180deg);
	}
	.multicheckboxes button.btn-dropdown .chevron.down {
		height: auto;
		line-height: 1em !important;
		display: table;
		position: relative;
		top: -1px;
	}
	.multicheckboxes button.btn-dropdown {
		background: transparent;
		border: 0px;
		padding: 0px;
		margin: 0px;
		cursor: pointer;
		vertical-align: middle;
	}
	.multicheckboxes ul {
		display: block;
		overflow: hidden;
		transition: none;
	}
	.details-container ul {
		padding-left: 30px;
		padding-top: 15px;
	}
	.details-container .multicheckboxes > ul {
		max-width: 225px;
		padding-left: 0px;
		margin-top: 0px;
	}
	.details-container .multicheckboxes > ul li {
		margin-bottom: 8px;
	}
	.checkbox-container {
		display: inline-table;
		position: relative;
		padding-left: 22px;
		cursor: pointer;
		font-size: 22px;
		-webkit-user-select: none;
		-moz-user-select: none;
		-ms-user-select: none;
		user-select: none;
	}
	.checkbox-container .checkmark {
		position: absolute;
		top: 0;
		left: 0;
		height: 16px;
		width: 16px;
		background-color: #fff;
		border: 1px solid #a7a7a7;
		border-radius: 4px;
	}
	.checkbox-container input {
		position: absolute;
		opacity: 0;
		cursor: pointer;
		height: 0;
		width: 0;
		top: 0px;
		left: 0px;
	}

	.checkbox-container input:checked ~ .checkmark {
		background-color: #0b5e97;
		border: 1px solid #0b5e97;
	}

	.checkbox-container .checkmark {
		-webkit-transition: 0.4s all;
		-moz-transition: 0.4s all;
		-o-transition: 0.4s all;
		-ms-transition: 0.4s all;
		transition: 0.4s all;
	}

	.checkbox-container:hover input ~ .checkmark {
  background-color: #ededed;
}
.checkbox-container input:checked ~ .checkmark {
  background-color: #0b5e97;
  border: 1px solid #0b5e97;
}

.checkbox-container .checkmark:after {
	transition: 0.3s transform;
  content: "";
  position: absolute;
  -webkit-transform: rotate(45deg) scale(0);
  -ms-transform: rotate(45deg) scale(0);
  transform: rotate(45deg) scale(0);
}
.checkbox-container input:checked ~ .checkmark:after {
	transition: 0.3s transform;
	-webkit-transform: rotate(45deg) scale(1);
	-ms-transform: rotate(45deg) scale(1);
	transform: rotate(45deg) scale(1);
}
.checkbox-container .checkmark:after {
	transition: 0.3s transform;
  left: 5px;
      top: 1px;
      width: 3px;
      height: 8px;
      border: solid white;
      border-width: 0 2.3px 2.3px 0;
      -webkit-transform: rotate(45deg) scale(0);
      -ms-transform: rotate(45deg) scale(0);
      transform: rotate(45deg) scale(0);
}

.checkbox-container input:checked {
	visibility: hidden;
}

.checkbox-container input[disabled="disabled"]:checked ~ .checkmark{
	background-color: #0b5e97;
	border: 1px solid #0b5e97;
	opacity: 0.45;
}
.multicheckboxes li span.text {
    font-weight: 500;
    color: #616161;
    cursor: pointer;
    position: relative;
    top: -3px;
    font-size: 13px;
    word-break: break-word;
    display: inline;
    left: 2px;
}

	@media(max-width:1140px) {
		.suppliers-connected-model {
			margin-left: 0px;
			display: table;
			margin-top: 15px;
		}
		td.supplier-image-td {
			display: none;
		}
		td.supplier-status .switch {
			top: 0px;
		}
		td.supplier-info .supplier-image {
			display: block;
			margin-top: 15px;
		}
	}

</style>
<form method="post" action="" enctype="multipart/form-data">
<?php
rp_csrf_token_input_field('dynamic_pricing');

$rp_dynamic_pricing_is_enabled = rp_get_option('rp_dynamic_pricing_is_enabled', '1');

list($suppliers, $last_synced) = rp_get_cached_or_download_suppliers();

$rp_dp_enabled_suppliers = rp_get_enabled_suppliers();

?>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('dynamic_pricing'); ?>
					<div class="bg-with-border">
						<?php
						if( RP_DynamicPricingAddon::is_active() ) {
							?>
							<?php
							$missingAttributes = rp_find_missing_repair_attributes();
							if( !empty( $missingAttributes ) ) {
								?>
								<div style="padding: 0px 18px; margin-bottom: 20px;">
									<div class="wp-repair-alert info">
									<i class="fa fa-info-circle"></i>	
									<strong>IMPORTANT!</strong> We have found some repair attributes such as <b style="font-weight: 500;">Screen > Quality B</b> that are not yet imported to your Default Repair List. For consistency, all suppliers are using the same attributes to display connected parts. It is crucial to have these attributes in your Default Repair List for accurate pricing.
									<br>
									<br>
									Do you want to import these attributes to your Default Repair List now?
									<a href="?page=wp_repair_download_libraries&section=repairs&missing_attributes=true" class="btn download-missing-attributes wp-general-info">
										<i class="fa fa-download"></i>
										Download Attributes
									</a>
									</div>
								</div>
								<?php
							}
							?>
							<div class="full-width-wp-repair">
								<div class="wp-repair-main-section-heading">
									<h2>
										<span class="light">Dynamic</span>
										<span class="bold">Pricing</span>
										<?php
										if( rp_is_enabled_dynamic_pricing() !== FALSE ) {
											echo '<span class="badge badge-active">Active</span>';
										} else {
											echo '<span class="badge badge-inactive">Inactive</span>';
										}
										?>
									</h2>
									<p class="more-info">Hassle free, automated pricing for your repair shop</p>
								</div>
								<div class="rp-dynamic-pricing-settings-nav">
									<a href="?page=wp_repair_settings&section=dynamic_pricing&tab=dp_license" <?php if(($_GET['tab'] ?? '') === 'dp_license' ) { echo 'class="active"'; } ?>>License</a>
									<a href="?page=wp_repair_settings&section=dynamic_pricing" <?php if(($_GET['tab'] ?? '') === '' ) { echo 'class="active"'; } ?>>Settings</a>
									<a href="?page=wp_repair_settings&section=dynamic_pricing&tab=recent_logs" <?php if(($_GET['tab'] ?? '') === 'recent_logs' ) { echo 'class="active"'; } ?>>Recent Logs</a>
									<a href="?page=wp_repair_settings&section=dynamic_pricing&tab=error_logs" <?php if(($_GET['tab'] ?? '') === 'error_logs' ) { echo 'class="active"'; } ?>>Error Logs</a>
								</div>
								<div class="rp-model-linked-analytics">
									<?php
									list($total_models, $total_linked_models) = rp_get_total_models_linked();
									?>
									<span class="models-linked"><?php echo $total_linked_models; ?></span> of <span class="total-models"><?php echo $total_models; ?></span>
									<span class="models-linked-text">models linked</span>
								</div>
							<?php
							$tab = $_GET['tab'] ?? 'settings';
							if( $tab !== 'recent_logs' && $tab !== 'error_logs' && $tab !== 'dp_license' ) {
								$fileName = RP_DP_PLUGIN_PATH.'html/settings_tab.php';
								$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
								require_once $fileName;
							} else {
								$fileName = RP_DP_PLUGIN_PATH.'html/'.$tab.'.php';
								$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
								require_once $fileName;
							}
							?>
							</div>
							<?php
							if( $tab !== 'recent_logs' && $tab !== 'error_logs' && $tab !== 'dp_license' ) {
								?>
								<div class="dependant-field cron-job <?php if( $rp_which_way_for_processing_datafeed !== 'cron' ) { echo 'max-height-0'; } ?>">
									<?php
									$bg_process = new RepairPluginPro\RP_Background_Process(WP_REPAIR_PLUGIN_PATH);
									$php_path = str_replace('\\', '/', $bg_process->get_php_path());
									$plugin_path = str_replace('\\', '/', RP_DP_PLUGIN_PATH) . 'cron_dp.php rp > /dev/null 2>&1';
									if( !empty($php_path) ) {
	
										?>
										<p class="rp-cron-job-info command">
											<span class="bold">Please setup CRON Job for dynamic pricing if not already:</span>
											<span class="light"><?php echo $php_path; ?> <?php echo $plugin_path; ?></span>
										</p>
										<p class="rp-cron-job-info duration">
											<span class="bold">Duration (Every Minute)</span>
											<span class="light">* * * * *</span>
										</p>
										<?php
	
									}
									?>
								</div>
								<?php
							}
						} else {
							$fileName = RP_DP_PLUGIN_PATH.'html/dp_license_activation_page.php';
							$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
							require_once $fileName;
						}
						?>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
</form>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>

<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/tinymce.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/jquery.tinymce.min.js"></script>
<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){
		if(e.which == 13){
			e.preventDefault();
		}
	});
	jQuery(document).on('change', 'select[name="rp_which_way_for_processing_datafeed"]', function(){
		let outerHeight = jQuery('.dependant-field.cron-job').data('org-height');
        if(jQuery(this).val() == 'cron') {
			jQuery('.dependant-field.cron-job').css('max-height', outerHeight);
        } else {
			jQuery('.dependant-field.cron-job').css('max-height', '0px');
        }
    });
    jQuery(document).on('change', 'input[name="rp_dp_round_up_dynamic_price"]', function(){
		let outerHeight = jQuery('.dependant-field.round-up').data('org-height');
        if(jQuery(this).is(':checked')) {
			jQuery('.dependant-field.round-up').css('max-height', outerHeight);
        } else {
			jQuery('.dependant-field.round-up').css('max-height', '0px');
        }
    });
	if( jQuery('.dependant-field').length > 0 ) {
		jQuery('.dependant-field').each(function(){
			let outerHeight = jQuery(this).data('org-height');
			if( !outerHeight ) {
				let hadClass = false;
				if( jQuery(this).hasClass('max-height-0') ) {
					jQuery(this).removeClass('max-height-0');
					hadClass = true;
				}
				outerHeight = jQuery(this).outerHeight();
				jQuery(this).data('org-height', outerHeight);
				if( hadClass ) {
					jQuery(this).css('max-height', '0px');
				} else {
					jQuery(this).css('max-height', outerHeight);
				}
			}
		});
	}
</script>

<script type="text/javascript">
	(function(window,document,$,undefined){
		jQuery(document).on("wpRepairReady", function(){
			let colorInputBindTimeout = false;
			jQuery("#select-custom-color input[name='c_theme_color']").on("change", function(){
				if(colorInputBindTimeout === false) {
					colorInputBindTimeout = true;
					jQuery(this).parent().find(".color-text").val(jQuery(this).val()).change();
					window.setTimeout(function(){
						colorInputBindTimeout = false;
					}, 100);
				}
			});
			jQuery("#select-custom-color .color-text").on("change", function(){
				let x = $(this).val();
				if(colorInputBindTimeout === false) {
					colorInputBindTimeout = true;
					jQuery("#select-custom-color input[name='c_theme_color']").val(x).change();
					window.setTimeout(function(){
						colorInputBindTimeout = false;
					}, 100);
				}
			});
			jQuery(".checkbox-custom").each(function(){
				$(this).on("click", function(){
					$(this).toggleClass('active');
				});
			});
			jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
				var parentCont = this;
			    jQuery(this).parent().on("click", function(){
			    	handleShowingOptions(this);
			    });
			    jQuery(this).find("li").on("click", function(){
			    	handleTheSelect(this, parentCont);
			    });
			});
			function closeAllOpenedSelectBoxes() {
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			}
			isCurrentElClicked(['.wp-repair-repair-card'], function(){
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			});
			window.canShowTheOptions = true;
			function canShowTheOptions() {
				if(window.canShowTheOptions === false) {
					window.canShowTheOptions = true;
					return false;
				}
				return true;
			}
			function isCurrentElClicked(el, func) {
				$("body").click(function(event) {
					result = false;
					el.forEach(function(ell){
						if(($(event.target).is(ell) || $(event.target).parents(ell).length !== 0)) {
							result = true;
						}
					});
					if(result === false) {
						func();
					}
				});
			}
			function handleShowingOptions(currentEl) {
				if(canShowTheOptions() === true) {
					jQuery(".wp-repair-repair-card").each(function(){
						if(this !== currentEl) {
							$(this).find(".more-card-options").hide();
						}
					});
					jQuery(currentEl).toggleClass('active');
					jQuery(currentEl).find(".more-card-options").toggle();
				}
			}
			function handleTheDeselect(currentEl, parentCont) {
				$(parentCont).parent().removeClass("active");
				$(parentCont).parent().find('.wp-repair-cselected-item i').remove();
				$(parentCont).parent().find('.wp-repair-cselected-item').append('<i class="fas fa-chevron-down"></i>');
				$(parentCont).parent().find('.text-all .selected-text').remove();
				$(parentCont).hide();
				$(parentCont).find("li").each(function(){
					$(this).removeClass("active");
				});
				window.canShowTheOptions = false;
			}
			function handleTheSelect(currentEl, parentCont) {
				var val = $(currentEl).find(".name").html();
				$(parentCont).parent().find('.wp-repair-cselected-item .name').html(val);
				var color_code = $(currentEl).find(".name .color-hex").html();
				$('.c_theme_color').val();
				$('.c_theme_color').val(color_code);
			}
		});
	}(window,document,jQuery));

	function readURL(input){
		jQuery("#img-input").val('');
		if(input.files && input.files[0]){
			var fi = input.files[0];
			var file_name = fi.name;
			jQuery("#img-input").val(file_name);
			var reader = new FileReader();
			reader.onload = function (e){
			//console.log(img);
			jQuery(".sec-2 .current_img").remove();
			jQuery(".sec-2 img").attr('src',e.target.result);
			}
			reader.readAsDataURL(input.files[0]);
		}
	}

	jQuery('.clear_img_input').on('click', function(){
		jQuery('#img-input').val('');
	});
</script>
<script type="text/javascript">

(function(jQuery){
    jQuery.fn.extend({

        checktree: function(){
            jQuery(this)
                .addClass('checktree-root')
                .on('change', 'input[type="checkbox"]', function(e){
                    e.stopPropagation();
                    e.preventDefault();

                    checkParents(jQuery(this));
                    checkChildren(jQuery(this));
                })
            ;

            var checkParents = function (c)
            {
                var parentLi = c.parents('ul:eq(0)').parents('li:eq(0)');

                if (parentLi.length)
                {
                    var siblingsChecked = parseInt(jQuery('input[type="checkbox"]:checked', c.parents('ul:eq(0)')).length),
                        rootCheckbox = parentLi.find('input[type="checkbox"]:eq(0)')
                    ;

                    if (c.is(':checked'))
                        rootCheckbox.prop('checked', true)
                    else if (siblingsChecked === 0)
                        rootCheckbox.prop('checked', false);

                    checkParents(rootCheckbox);
                }
            }

            var checkChildren = function (c)
            {
                var childLi = jQuery('ul li input[type="checkbox"]', c.parents('li:eq(0)'));

                if (childLi.length)
                    childLi.prop('checked', c.is(':checked'));
            }
        }

    });
	
})(jQuery);

	(function($){

		jQuery("input[name='rp_automatically_fix_mobile_styling']").on('change', function(){
			if(jQuery(this).is(':checked')){
				jQuery("input[name='rp_mobile_side_padding']").parent().hide();
			}else{
				jQuery("input[name='rp_mobile_side_padding']").parent().show();
			}
		});

		function showFullWidthModal(content = '', additional_cls = '') {
			$(".va-full-width-modal").remove();
			let html = `
				<div class="va-full-width-modal">
					<div class="va-full-width-modal-main ${additional_cls}">
						<div class="va-full-width-modal-inner clearfix">
							${content}
						</div>
						<button class="va-button va-button-default va-close-modal">
							<i class="fas fa-times"></i>
						</button>
					</div>
				</div>
			`;
			$("body").append(html);
			$(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
			$(".va-full-width-modal .va-close-modal").on("click", function(){
				$(this).parent().animate({'top': '-50%'}, 400, function(){
					$(this).parent().remove();
				});
			});
			$(document).on("mouseup", handOutsideClick);
			// $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
		}
		function handOutsideClick(e) {
			var container = $('.va-full-width-modal-main');
			// if the target of the click isn't the container nor a descendant of the container
			if (!container.is(e.target) && container.has(e.target).length === 0) 
			{
				container.find(".va-close-modal").click();
				$(document).off("mouseup", handOutsideClick);
			}
		}

		jQuery(document).on('click', '.va-full-width-modal-main .va-button.va-submit', function(e){
			
			e.preventDefault();

			if(jQuery(this).hasClass("processing")) {
				return;
			}

			let btn = this;

			let supplier_id = jQuery(this).parents('.va-full-width-modal-main').find('input[name="supplier_id"').val();

			jQuery(btn).addClass("processing");

			var btndata = jQuery(btn).html();

			let orgBtnWidth = jQuery(btn).outerWidth();

			// round Up
			orgBtnWidth = Math.ceil(orgBtnWidth);

			jQuery(btn).css('width', parseInt(orgBtnWidth) + 'px');

			jQuery(btn).html('<i style="position:relative; top: -1px;" class="fas fa-spinner fa-spin"></i>');

			let b_ids = [];

			jQuery('#tree input[type="checkbox"][name^="b_id"]').each(function(){
				if(jQuery(this).is(':checked')) {
					b_ids.push(jQuery(this).val());
				}
			});

			let action = 'rp_update_dp_supplier_linking';

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {
					action:action,
					supplier_id: supplier_id,
					b_ids: b_ids,
				},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery(btn).removeClass("processing");

					try {
						
						data = JSON.parse(data);

					} catch(e) {

						repairPluginUI.alert_danger('Something went wrong, please try again later.');	
						return;

					}

					if(data.status == true || data.status == 'true') {
						jQuery(".va-close-modal").click();
						repairPluginUI.alert_success('Linking updated successfully.');
					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}

				},
				error: function( response ) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && 'rp_validation_error' in response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});

		});

		jQuery(document).on('click', ".manage-linking", function(e){

			e.preventDefault();

			if(jQuery(this).hasClass("processing")) {
				return;
			}

			let btn = this;

			let supplier_id = jQuery(this).data('supplier-id');

			let supplier_name = jQuery(this).data('supplier-name');

			jQuery(btn).addClass("processing");

			var btndata = jQuery(btn).html();

			let orgBtnWidth = jQuery(btn).outerWidth();

			// round Up
			orgBtnWidth = Math.ceil(orgBtnWidth);

			jQuery(btn).css('width', parseInt(orgBtnWidth) + 'px');

			jQuery(btn).html('<i style="position:relative; top: -1px;" class="fas fa-spinner fa-spin"></i>');

			let action = 'rp_get_manage_dynamic_pricing_linking_markup';

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {
					action:action,
					supplier_id: supplier_id,
					supplier_name: supplier_name,
				},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery(btn).removeClass("processing");

					try {
						
						data = JSON.parse(data);

					} catch(e) {

						repairPluginUI.alert_danger('Something went wrong, please try again later.');	
						return;

					}

					if(data.status == true || data.status == 'true') {

						let update_btn = '';
						if( data.show_update_btn == true ) {
							update_btn = `
							<button type="submit" class="va-button va-submit va-trans">
								Update
							</button>
							`;
						}

						showFullWidthModal(`
							<p class="va-modal-title">Manage Linking</p>
							${data.html_markup}
							${update_btn}
						`, 'trans-modal');

						jQuery('#tree').checktree();
								
					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}

				},
				error: function( response ) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});

		});

	}(jQuery));


</script>
