<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

?>
<div class="table-responsive dp-license-info">
    <?php
    if( RP_EnhancedLocationsAddon::is_active() && !empty( RP_EnhancedLocationsAddon::$licenseObject ) ) {
        $licenseObject = RP_EnhancedLocationsAddon::$licenseObject;
        ?>
        <form action="" method="POST">
        <input type="hidden" name="deactivate_license" value="1">
        <h2>License Info</h2>
        <table class="table">
            <tbody>
                <tr>
                    <th>Status</th>
                    <td>
                        <?php
                        if( property_exists($licenseObject, 'is_valid') && $licenseObject->is_valid == 1 ) {
                            echo ': <span class="badge badge-active is-valid">Valid</span>';
                        } else {
                            echo ': <span class="badge badge-inactive">Invalid</span>';
                        }
                        ?>
                    </td>
                </tr>
                <tr>
                    <th>License Type</th>
                    <td>
                        <?php
                        echo ': ' . $licenseObject->license_title ?? '';
                        ?>
                    </td>
                </tr>
                <tr>
                    <th>License Expired On</th>
                    <td>
                        <?php
                        echo ': ' . $licenseObject->expire_date ?? '';
                        if( property_exists($licenseObject, 'expire_renew_link') && !empty($licenseObject->expire_renew_link) ) {
                            ?>
                            <a target="_blank" class="el-blue-btn" href="<?php echo $licenseObject->expire_renew_link; ?>">Renew</a>
                            <?php
                        }
                        ?>
                    </td>
                </tr>
                <tr>
                    <th>Support Expired On</th>
                    <td>
                        <?php
                        echo ': ' . $licenseObject->support_end ?? '';
                        if( property_exists($licenseObject, 'support_renew_link') && !empty($licenseObject->support_renew_link) ) {
                            ?>
                            <a target="_blank" class="el-blue-btn" href="<?php echo $licenseObject->support_renew_link; ?>">Renew</a>
                            <?php
                        }
                        ?>
                    </td>
                </tr>
                <tr>
                    <th>Your license key</th>
                    <td>
                        <span class="el-license-key"><?php
                        $theLicense = $licenseObject->license_key ?? '';
                        echo ': ' . esc_attr( substr($theLicense,0,9)."XXXXXXXX-XXXXXXXX".substr($theLicense,-9) ); ?></span>
                    </td>
                </tr>
                <tr>
                    <th>Locations Limit</th>
                    <td>
                        <?php
                        $the_limit = RP_EnhancedLocationsAddon::get_limit();
                        if( $the_limit === false ) {
                            $the_limit = 'Unlimited';
                        }
                        echo ': ' . $the_limit;
                        ?>
                    </td>
                </tr>
            </tbody>
        </table>
        <?php
        global $wp_repair_lang;
        if( !empty( $wp_repair_lang['do_you_need_help'] ?? '' ) ) {
            ?>
            <p style="margin-top: 25px; margin-bottom:0px;">
            <?php
                echo $wp_repair_lang['do_you_need_help'] ?? ''; ?>
            </p>
            <?php
        }
        ?>
        <button class="wp-general-info deactivate-btn" type="submit">Deactivate</button>
        </form>
        <?php
    } else {
        ?>
        <table class="table">
            <tbody>
                <tr>
                    <td>Error: License information not found</td>
                </tr>
            </tbody>
        </table>
        <?php
    }
    ?>
</div>