<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

$logs = rp_get_option('rp_dp_errors', array());

if( !empty( $logs ) ) {

    // json decode
    $logs = json_decode( $logs, true );

} else {

    $logs = array();

}

$dp_settings_page_image = WP_REPAIR_PLUGIN_URL . 'assets/images/Dynamic-pricing-settings-image.png';

?><div class="full-width-wp-repair">
    <div class="wp-repair-main-section-heading">
        <h2>
            <span class="light">Enhanced</span>
            <span class="bold">Locations</span>
            <?php
            if( rp_is_active_enhanced_locations_addon() !== FALSE ) {
                echo '<span class="badge badge-active">Active</span>';
            } else {
                echo '<span class="badge badge-inactive">Inactive</span>';
            }
            ?>
        </h2>
        <p class="more-info">Hassle free management for locations and schedules</p>
    </div>
    <form action="" method="POST">
        <div class="dp-license-activation-form">
            <?php
            RP_EnhancedLocationsAddon::is_active();
            if( defined('WP_REPAIR_ENHANCED_LICENSE_MESSAGE') ) {
                ?>
                <div class="wp-repair-alert error license"><?php echo WP_REPAIR_ENHANCED_LICENSE_MESSAGE; ?></div>
                <?php
            }
            ?>
            <p>Please fill in your license code or <a target="_blank" href="https://www.repairplugin.com/onboard/enhanced-locations-month/">purchase a subscription</a></p>
            <div class="wp-repair-input-group">
                <input type="text" class="regular-text code" name="el_license_key" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
                <button type="submit" class="wp-general-info">Activate</button>
            </div>
        </div>
    </form>
</div>