<?php
global $wp_repair_lang;
$default_location_select = rp_get_main_location_id_of_company();
if( isset( $_POST ) && !empty( $_POST ) && isset( $_POST['last_selected'] ) && !empty( $_POST['last_selected'] ) ) {

    $default_location_select = (int) $_POST['last_selected'];

}
if( !empty( $locations ) && count( $locations ) == 1 ) {
    $search_by_location = false;
}

if( $search_by_location === true ) {
    ?>
    <div class="current-location-btn-container">
        <button type="button" class="current-location-icon"><?php
        ?><?php echo $wp_repair_lang['live_location_btn_text']; ?> <img class="gps-img" src="<?php echo WP_REPAIR_PLUGIN_URL . 'assets/images/gps.svg'; ?>" alt="GPS Icon"><?php
        ?></button>
    </div>
    <div class="search-nearest-location wp-repair-search-container">
        <span class="wp-repair-icon-search">
            <?php echo rp_svg_icons_loader('fa-search', 's-19'); ?>
        </span>
        <input type="text" class="search-loc search <?php if( !empty( $formatted_address ) ) { echo 'hasSomeValue'; } ?>" name="search_loc" value="<?php echo $formatted_address; ?>" placeholder="<?php echo $wp_repair_lang['search_for_nearest_location'] ?>" />
        <button type="button" class="icon <?php if( !empty( $formatted_address ) ) { echo 'has-address'; } ?>" <?php if( empty( $formatted_address ) ) { echo 'style="display:none;"'; } ?>><?php
            if( !empty( $formatted_address ) ) {
                echo rp_svg_icons_loader('fa-times', 's-10');
            }
            ?></button>
        <div class="rp-autcomplete-suggestions-container">
            <div class="rp-autcomplete-suggestions">
                <ul class="rp-autcomplete-suggestions-list">
                </ul>
            </div>
        </div>
    </div>
    <?php
} else {
    ?>
    <table class="table location choose-loc">
        <tbody>
            <tr>
                <td colspan="2" class="choose-location-text"><?php echo $wp_repair_lang['choose_location']; ?></td>
            </tr>
        </tbody>
    </table>
    <?php
}
?>
<div class="locations-cont">
<table class="table location">
    <tbody>
        <?php

        if($locations) {

            $org_location = $locations;

            $location_groups = array();

            if(count($locations) % 2 !== 0) {
                $location_groups[] = array($locations[0]);
                unset($locations[0]);
                $locations = array_values($locations);
            }

            $the_group = array();

            if( $rp_el_show_location_image_on_frontend === true || $is_pdf_location_layout === true ) {

                foreach ($locations as $loc_key => $loc) {

                    $location_groups[] = array($loc);
    
                }

            } else {

                foreach ($locations as $loc_key => $loc) {

                    $the_group[] = $loc;
    
                    if(count($the_group) === 2 || $loc_key === (count($locations) - 1)) {
                        $location_groups[] = $the_group;
                        $the_group = array();
                    }
    
                }

            }

            foreach ($location_groups as $group_key => $loc_group) {
                $loc_group_count = count($loc_group);
                echo '<tr>';
                foreach ($loc_group as $loc) {
                    ?>
                    <td colspan="<?php if($loc_group_count === 2) { echo 1; } else { echo 2; } ?>">
                        <button type="button" data-locid="<?php echo $loc->location_id;?>" data-id="<?php echo date('d-m-Y'); ?>" data-dname="<?php echo date('l');?>" class="location-select <?php if($loc->location_id == $default_location_select){echo "selected";}?> <?php if( $rp_el_show_location_image_on_frontend === true ) { echo 'has-location-image'; } ?> <?php if( $is_pdf_location_layout === true ) { echo 'is_pdf_location_layout'; } ?>">
                            <?php
                            if( $rp_el_show_location_image_on_frontend === true ) {
                                $placeholder_img = WP_REPAIR_PLUGIN_URL . 'assets/images/image-upload-4-1.png';
                                if( !empty( $loc->location_image ?? '' ) ) {
                                    $placeholder_img = $loc->location_image;
                                }
                                ?>
                                <div class="loc-img">
                                    <img src="<?php echo $placeholder_img; ?>" width="100%" height="auto" alt="<?php echo $loc->location_name;?> image" />
                                </div>
                                <?php
                            }
                            ?>
                            <div class="text <?php if( $rp_el_show_location_image_on_frontend === true && ( $loc->distance ?? '' ) !== '' ) { echo 'has-distance'; } ?>">
                                <span class="bold"><?php echo $loc->location_name;?>
                                <?php
                                if( $rp_el_show_location_image_on_frontend === true ) {
                                    ?>
                                    <div class="icon next-to-title">
                                        <span class="wp-repair-tooltip" title="<?php
                                        echo $loc->location_address;
                                        ?>"><?php echo rp_svg_icons_loader('fa-info-circle', 's-14'); ?></span>
                                    </div>
                                    <?php
                                }
                                ?>
                                </span>
                                <?php
                                if( rp_is_active_enhanced_locations_addon() === true && !empty( trim($loc->location_telephone ?? '')  ) ) {
                                    ?>
                                    <span class="light rpmb-8"><?php echo ($loc->location_telephone ?? '');?></span>
                                    <?php
                                }
                                ?>
                                <span class="light"><?php echo $loc->location_address;?></span>
                                <span class="light"><?php echo $loc->location_city_district;?></span>
                            </div>
                            <?php
                            if( $rp_el_show_location_image_on_frontend === false ) {
                                ?>
                                <div class="icon">
                                    <span class="wp-repair-tooltip" title="<?php
                                    if( ( $loc->distance ?? '' ) !== '' ) {

                                        if( $loc->distance !== 'N/A' ) {

                                            $rp_el_prefered_distance_unit = rp_get_option('rp_el_prefered_distance_unit', 'km');

                                            $rp_el_prefered_distance_unit_text = $wp_repair_lang['nearest_location_distance_unit_'. $rp_el_prefered_distance_unit] ?? '';

                                            $rp_el_prefered_distance_unit_text_info = $rp_el_prefered_distance_unit_text;

                                            $rp_el_prefered_distance_unit_text_info = ucfirst($rp_el_prefered_distance_unit_text_info);

                                            if( trim($rp_el_prefered_distance_unit_text_info) == 'Km' ) {
                                                $rp_el_prefered_distance_unit_text_info = 'KM';
                                            }

                                            $approx_radius_distance = $wp_repair_lang['approx_radius_distance'];

                                            $approx_radius_distance = str_replace('{distance}', number_format(round( $loc->distance, 2 )) . ' ' .$rp_el_prefered_distance_unit_text_info, $approx_radius_distance);

                                            echo $approx_radius_distance;

                                        } else {

                                            echo 'N/A';

                                        }

                                    } else {
                                        
                                        echo $loc->location_address;

                                    }
                                    ?>"><?php echo rp_svg_icons_loader('fa-info-circle', 's-14'); ?></span>
                                </div>
                                <?php
                            }
                            if( $rp_el_show_location_image_on_frontend === true && ( $loc->distance ?? '' ) !== '' ) {

                                if( $loc->distance !== 'N/A' ) {

                                    $rp_el_prefered_distance_unit = rp_get_option('rp_el_prefered_distance_unit', 'km');

                                    $rp_el_prefered_distance_unit_text = $wp_repair_lang['nearest_location_distance_unit_'. $rp_el_prefered_distance_unit] ?? '';

                                    $rp_el_prefered_distance_unit_text_info = $rp_el_prefered_distance_unit_text;

                                    $rp_el_prefered_distance_unit_text_info = ucfirst($rp_el_prefered_distance_unit_text_info);

                                    if( trim($rp_el_prefered_distance_unit_text_info) == 'Km' ) {
                                        $rp_el_prefered_distance_unit_text_info = 'KM';
                                    }

                                    $approx_radius_distance = $wp_repair_lang['approx_radius_distance'];

                                    $approx_radius_distance = str_replace('{distance}', number_format(round( $loc->distance, 2 )) . ' ' . $rp_el_prefered_distance_unit_text_info, $approx_radius_distance);

                                    ?>
                                    <div class="distance">
                                        <span class="wp-repair-tooltip" title="<?php echo $approx_radius_distance; ?>">
                                            <span class="bold"><?php echo number_format(round( $loc->distance, 2 )); ?></span> <?php echo $rp_el_prefered_distance_unit_text; ?>
                                        </span>
                                    </div>
                                    <?php

                                } else {

                                    ?>
                                    <div class="distance">
                                        <span class="wp-repair-tooltip" title="N/A">
                                            N/A
                                        </span>
                                    </div>
                                    <?php

                                }

                            }
                            ?>
                        </button>
                    </td>
                    <?php
                }
                echo '</tr>';
            }

            $locations = $org_location;

        }

        ?>
    </tbody>
</table>
</div>