<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

$logs = rp_get_option('rp_dp_errors', array());

if( !empty( $logs ) ) {

    // json decode
    $logs = json_decode( $logs, true );

} else {

    $logs = array();

}

?>
<p>Here you can see a maximum of 100 recent logged messages</p>
<div class="table-responsive">
    <table class="table recent-logs error-logs">
        <thead>
            <tr>
                <th class="t-center">Time</th>
                <th class="t-left" style="min-width: 200px">Message</th>
            </tr>
        </thead>
        <tbody>
            <?php

            // Example Input:
            // [2023-06-01 00:58:27] STEP1: Got All Suppliers From Database --- Took 0.0034 Seconds To Complete
            // Pregmatch [2023-06-01 00:58:27] from the above string

            if( !empty( $logs ) ) {
                // sort the logs
                $logs = array_reverse($logs);
                foreach( $logs as $theLog ) {
                    $matched_date = preg_match('/\[(.*?)\]/', $theLog, $date);
                    echo '<tr>';
                    echo '<td class="t-center" style="width: 150px">';
                    $date = $date[1] ?? '';
                    if( !empty( $date ) ) {
                        // replace $date from $theLog
                        $theLog = str_replace( '['.$date.']', '', $theLog );
                        // human readable date (x minutes ago)
                        $diff = rp_dp_human_readable_difference( $date, date('Y-m-d H:i:s', time()) );
                        echo $diff;
                    } else {
                        echo '--';
                    }
                    echo '</td>';
                    echo '<td class="t-left">';
                    echo $theLog;
                    echo '</td>';
                    echo '</tr>';
                }
            } else {
                echo '<tr>';
                echo '<td colspan="2" class="t-left">';
                echo 'No logs found.';
                echo '</td>';
                echo '</tr>';
            }
            ?>
        </tbody>
    </table>
</div>