<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

if($planning_discount[0]->come_our_store == '1'){?>
<span class="wp-repair-repair-card <?php if(rp_which_delivery_method_enable_by_default($planning_discount) == 'come_our_store') { echo 'active'; } ?> come-our-store" onclick="delivery_method(this.id);" id="Come by our store">
    <div class="repair-img">
        <img src="<?php echo getTheImageURL('visitstore.svg'); ?>">
    </div>
    <div class="text-all">
        <p class="repair-name"><?php echo $wp_repair_lang['come_by_our_store']; ?> <?php echo rp_delivery_method_cost_badge('come_our_store', $decimal, $localization, $reschedule_order_id); ?></p>
        <p class="repair-mins"><?php echo $wp_repair_lang['done_while_you_are_waiting']; ?></p>
    </div>
    <div class="wp-repair-action-price" onclick="delivery_method(this.id);" id="Come by our store">
        <?php echo rp_svg_icons_loader('fa-check', 's-14'); ?>
        <div class="wp-repair-select-checkbox"></div>
    </div>
    <div class="more-info-ship-device" <?php if(rp_which_delivery_method_enable_by_default($planning_discount) == 'ship_device') { echo 'style="max-height:100% !important;"'; } ?>>
        <div class="rp_el_location_markup">
            <?php
            rp_el_location_markup();
            ?>
        </div>
        <table class="table date-time">
            <tbody>
                <tr>
                    <td colspan="2" class="choose-location-text"><?php echo $wp_repair_lang['select_date_and_time']; ?></td>
                </tr>
            </tbody>
        </table>
        <div class="date-slider">
            <?php
            $count = 0;
            while ($count < 14) {
                $calc = date('D d', strtotime(date('Y-m-d').' +'.$count.' days'));
                $day  = date('l', strtotime(date('Y-m-d').' +'.$count.' days'));
                $date = date('d-m-Y', strtotime(date('d-m-Y').' +'.$count.' days'));
                $calc = explode(' ', $calc);
                $inactive = '';
                $selected = '';
                if(strtotime(date('Y-m-d').' +'.$count.' days') < strtotime(date('Y-m-d'))) {
                    $inactive = ' inactive';
                }
                if(strtotime(date('Y-m-d').' +'.$count.' days') === strtotime(date('Y-m-d'))) {
                    $selected = ' selected';
                }
                $translation_key = 'translation_of_day_'.trim(strtolower($calc[0]));
                $transalted_day = isset($wp_repair_lang[$translation_key]) ? $wp_repair_lang[$translation_key] : $calc[0];
                ?>
                <div class="wpRepairDateSlide <?php echo $inactive.$selected; ?>">
                    <div class="dayOfWeek"><?php echo $transalted_day; ?></div>
                    <div class="dateOfWeek" data-id="<?php echo $date; ?>" data-dname="<?php echo $day;?>"><span class="num" data-id="<?php echo $date; ?>" data-dname="<?php echo $day;?>"><?php echo $calc[1]; ?></span></div>
                </div>
                <?php
                $count++;
            }
            ?>
        </div>
        <div class="time-slider">
            <table class="table">
                <tbody>
                    <?php 
                    $loc_id = $location[0]->location_id;
                    $slot_print_count = 0;
                    $day  = date('l');
                    $date_ymd = date('Y-m-d');
                    //var_dump($day);
                    $loc_sche = rp_get_special_schedule($loc_id, $day, $date_ymd);
                    $loc_sche = rp_sanitize_output($loc_sche);
                    ?>
                    <tr>
                        <?php 
                        if(!empty($loc_sche) && $loc_sche[0]->is_closed == 0){
                            $time_slots = $planning_discount[0]->booking_slots_length;
                            $time_slots = str_replace(' Minutes (Default)', '', $time_slots);
                            $time_slots = (int) $time_slots;

                            $has_valid_breaktime = TRUE;

                            $valid_break_time_start = preg_match('/(?:\d){1,2}(?:\:){1}(?:\d){1,2}(?:(\sam|\spm)|($))+/i', $loc_sche[0]->cs_breaktime_from);
                            $valid_break_time_end = preg_match('/(?:\d){1,2}(?:\:){1}(?:\d){1,2}(?:(\sam|\spm)|($))+/i', $loc_sche[0]->cs_breaktime_to);
                            if(empty($loc_sche[0]->cs_breaktime_from) || empty($loc_sche[0]->cs_breaktime_to)) {
                                    $has_valid_breaktime = FALSE;
                            }
                            if($valid_break_time_start === 0 || $valid_break_time_end === 0) {
                                    $has_valid_breaktime = FALSE;
                            }

                            if($localization[0]->set_time_format == '24 hours (e.g. 15:00)'){
                                $from_time = date("H:i",strtotime($loc_sche[0]->cs_open_timing));
                                $to_time   = date("H:i",strtotime($loc_sche[0]->cs_close_timing));
                                $minutes =  round(abs(strtotime($to_time) - strtotime($from_time)) / 60,2);

                                if($has_valid_breaktime === TRUE) {
                                    $break_from_time = date("H:i",strtotime($loc_sche[0]->cs_breaktime_from));

                                    $break_to_time   = date("H:i",strtotime($loc_sche[0]->cs_breaktime_to));

                                    $break_minutes =  round(abs(strtotime($break_to_time) - strtotime($break_from_time)) / 60,2);

                                    $break_start_after_x_minutes = (strtotime($loc_sche[0]->cs_breaktime_from) - strtotime($loc_sche[0]->cs_open_timing)) / 60;
                                    $break_ends_after_x_minutes = (strtotime($loc_sche[0]->cs_breaktime_to) - strtotime($loc_sche[0]->cs_open_timing)) / 60;
                                }
                            }else{
                                $from_time = date("g:i a",strtotime($loc_sche[0]->cs_open_timing));
                                $to_time   = date("g:i a",strtotime($loc_sche[0]->cs_close_timing));
                                $minutes =  round(abs(strtotime($to_time) - strtotime($from_time)) / 60,2);

                                if($has_valid_breaktime === TRUE) {
                                    $break_from_time = date("g:i a",strtotime($loc_sche[0]->cs_breaktime_from));

                                    $break_to_time   = date("g:i a",strtotime($loc_sche[0]->cs_breaktime_to));

                                    $break_minutes =  round(abs(strtotime($break_to_time) - strtotime($break_from_time)) / 60,2);

                                    $break_start_after_x_minutes = (strtotime($loc_sche[0]->cs_breaktime_from) - strtotime($loc_sche[0]->cs_open_timing)) / 60;
                                    $break_ends_after_x_minutes = (strtotime($loc_sche[0]->cs_breaktime_to) - strtotime($loc_sche[0]->cs_open_timing)) / 60;
                                }
                            }
                            $break_times = array();

                            if($has_valid_breaktime === TRUE) {
                                if($break_start_after_x_minutes >= 0 && $break_start_after_x_minutes <= $minutes && $break_ends_after_x_minutes >= 0 && $break_ends_after_x_minutes <= $minutes) {

                                } else {
                                    $has_valid_breaktime = FALSE;
                                }
                            }

                            for ($x = 0; $x <= $minutes; $x+=$time_slots) {
                                $add_time = strtotime($from_time)+($x*60);
                                if($localization[0]->set_time_format == '24 hours (e.g. 15:00)'){
                                    $adding = date('H:i',$add_time);
                                    $slot_time[] = $adding;
                                }else{
                                    $adding = date('g:i a',$add_time);
                                    $slot_time[] = $adding;
                                }
                                if($has_valid_breaktime === TRUE) {
                                    if($x >= $break_start_after_x_minutes && $x < $break_ends_after_x_minutes) {
                                            $break_times[] = $adding;
                                    }
                                }
                            }
                            $alreadyAddedBreakTime = FALSE;

                            $last_time = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d').' '.$loc_sche[0]->cs_close_timing . ' -'.$time_slots.' minutes')));

                            $shop_close_time = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d').' '.$loc_sche[0]->cs_close_timing)));

                            $current_time = date('Y-m-d H:i:s');

                            $current_time_str = strtotime($current_time);

                            $booking_must_wait_time = (int) rp_get_option('wp_repair_booking_must_wait_time', 60);

                            $booking_must_wait_time_until = strtotime(date('Y-m-d H:i:s', strtotime($current_time .' +'.$booking_must_wait_time.' minutes')));

                            $time_slots_printed = FALSE;

                            foreach($slot_time as $time){

                                $loop_time = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d').' '.$time)));

                                if($loop_time < $current_time_str) {

                                    continue;

                                }

                                if($loop_time > $last_time) {

                                    continue;

                                }

                                if($loop_time < $booking_must_wait_time_until || (rp_is_available_slot($loc_id, date('Y-m-d', strtotime(date('Y-m-d').' '.$time)), date('H:i:s', strtotime(date('Y-m-d').' '.$time))) === FALSE)) {
                                    
                                } else {
                                    $time_slots_printed = TRUE;
                                }
                            }

                            if($time_slots_printed === FALSE) {
                                if($current_time_str >= $shop_close_time) {
                                    echo '<td class="shop_close"><b>'.$wp_repair_lang['shop_has_closed_for_today'].'</b></td>';
                                } else {
                                    echo '<td class="shop_close"><b>'.$wp_repair_lang['appointment_booking_has_closed_for_today'].'</b></td>';
                                }
                            } else {
                                foreach($slot_time as $time){

                                    $loop_time = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d').' '.$time)));

                                    if($loop_time < $current_time_str) {

                                        continue;

                                    }

                                    if($loop_time > $last_time) {

                                        continue;

                                    }
                                    
                                    $slot_print_count++;

                                    if(rp_is_available_slot($loc_id, date('Y-m-d', strtotime(date('Y-m-d').' '.$time)), date('H:i:s', strtotime(date('Y-m-d').' '.$time))) === FALSE) {
                                        ?>
                                        <td><span class="time-box rp-fully-booked <?php if($localization[0]->set_time_format == '24 hours (e.g. 15:00)') { echo 'hours-24'; }?>" id="<?php echo $time;?>"><?php echo $time;?></span></td>
                                        <?php 
                                    } else if($loop_time < $booking_must_wait_time_until) {
                                        ?>
                                        <td><span class="time-box rp-too-early <?php if($localization[0]->set_time_format == '24 hours (e.g. 15:00)') { echo 'hours-24'; }?>" id="<?php echo $time;?>"><?php echo $time;?></span></td>
                                        <?php 
                                    } else if(in_array($time, $break_times) === FALSE) {
                                        ?>
                                        <td><span class="time-box <?php if($localization[0]->set_time_format == '24 hours (e.g. 15:00)') { echo 'hours-24'; }?>" id="<?php echo $time;?>" onclick="timeRP(this.id);"><?php echo $time;?></span></td>
                                        <?php 
                                    } else {
                                        if($alreadyAddedBreakTime === FALSE) {
                                            $alreadyAddedBreakTime = TRUE;
                                            ?>
                                            <td><span class="time-box break-time" id="breaktime"><?php echo $wp_repair_lang['breaktime'];?></span></td>
                                            <?php 
                                        }
                                    }
                                }
                            }
                        }else{
                            if( !empty( $loc_sche[0]->reminder_name ?? '' ) ) {
                                echo '<td class="shop_close"><b>'.$loc_sche[0]->reminder_name.'</b></td>';
                            } else {
                                echo '<td class="shop_close"><b>'.$wp_repair_lang['shop_is_closed_for_today'].'</b></td>';
                            }
                        }?>
                    </tr>
                </tbody>
            </table>
            <div id="slot_print_count"><?php echo $slot_print_count; ?></div>
        </div>
    </div>
</span>
<?php }?>