<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

function getTheImageURL($str = '') {
	return WP_REPAIR_PLUGIN_URL.'assets/images/'.$str;
}

function rp_delivery_method_cost_badge( $dm_name = '', $decimal = '', $localization = NULL, $reschedule_order_id = 0 ) {

	if( rp_get_option('rp_show_price_label_next_to_dm', '1') == '0' ) {

		return '';

	}

	global $wp_repair_lang;

	global $rpQuery;

	$rs_orders = $rpQuery->prefix . 'rs_orders';

	$delivery_methods = array(
		'come_our_store',
		'ship_device',
		'pickup_service',
		'repair_on_location'
	);

	if( !empty( $reschedule_order_id ) ) {

		$parent_order = $rpQuery->get_row("SELECT * FROM `$rs_orders` WHERE `o_id` = '".rp_escape_sql($reschedule_order_id)."' LIMIT 1");

		$cost = (float) ($parent_order->dm_cost ?? 0);

	} else {

		$dm_cost_key = 'rp_dm_cost_' . $dm_name;

		$cost = rp_get_option($dm_cost_key, 0);

	}

	if( $cost == '' || $cost == 0 || $cost == 0.00 ) {

		return '<span class="rp-dm-price-badge dm-free">'.$wp_repair_lang['free_repair_text'].'</span>';

	} else {

		$cost = (float)$cost;
		$int = ctype_digit($cost);
		if($int == 1){
			$result = rp_handle_currency_position($cost, $localization[0]->set_currency, TRUE);
		}else{
			if($decimal == 'comma'){
				$cost = number_format((float)$cost, 2, '.', '');
				$cost = str_replace('.',',',$cost);
				$result = rp_handle_currency_position($cost, $localization[0]->set_currency, TRUE);
			}else{
				$cost = number_format((float)$cost, 2, '.', '');
				$result = rp_handle_currency_position($cost, $localization[0]->set_currency, TRUE);
			}
		}

		return '<span class="rp-dm-price-badge">'.$result.'</span>';

	}

}

_rp_set_default_tiemzone();

$default_location_select = '1';

if(!empty($location)) {

	$location = rp_sanitize_output($location);

	$default_location_select = $location[0]->location_id;

}

if( isset($ship_device_location) && !empty($ship_device_location) ) {

	$ship_device_location = rp_sanitize_output($ship_device_location);

}

if( isset($color_name) && !empty($color_name) ) {

	$color_name = rp_sanitize_output($color_name);

} else {

	$color_name = '';

}

$wp_repair_lang = rp_sanitize_output($wp_repair_lang);

$models = rp_sanitize_output($models);

$localization = rp_sanitize_output($localization);

function rp_which_delivery_method_enable_by_default($planning_discount = null) {

	$active_items = [];
	
	if( $planning_discount[0]->come_our_store == '1' ) {

		$active_items[] = 'come_our_store';

	}
	
	if ( $planning_discount[0]->ship_device == '1' ) {

		$active_items[] = 'ship_device';

	}
	
	if ( $planning_discount[0]->pickup_service == '1' ) {

		$active_items[] = 'pickup_service';

	}
	
	if ( $planning_discount[0]->repair_on_location == '1' ) {

		$active_items[] = 'repair_on_location';

	}

	if( count( $active_items ) === 1 ) {

		return $active_items[0];

	}

	return '';

}

$reschedule_related_order = null;
$reschedule_delivery_method = null;

$_customer_house_no = '';
$_customer_street_address = '';
$_customer_city = '';
$_customer_zipcode = '';

$reschedule_order_id = '';

if(isset($_GET['reschedule']) && isset($o_id_fk) && !empty($o_id_fk)) {
	$rs_orders = $rpQuery->prefix . 'rs_orders';
	$rs_customer = $rpQuery->prefix . 'rs_customer';
	// get related order where o_id matches with o_id_fk
	$reschedule_related_order = $rpQuery->get_row("SELECT * FROM `$rs_orders` JOIN `$rs_customer` ON `$rs_orders`.`customer_id_fk` = `$rs_customer`.`customer_id` WHERE o_id = '".rp_escape_sql($o_id_fk)."' LIMIT 1");
	if( !empty($reschedule_related_order) ) {
		$reschedule_related_order = rp_sanitize_output($reschedule_related_order);
		$reschedule_delivery_method = str_replace(' ', '_', strtolower(trim($reschedule_related_order->delivery_method)));
		$reschedule_order_id = $reschedule_related_order->o_id;
	}
}

if( !empty($reschedule_delivery_method) ) {
	if( $reschedule_delivery_method == 'come_by_our_store' ) {
		$planning_discount[0]->ship_device = 0;
		$planning_discount[0]->pickup_service = 0;
		$planning_discount[0]->repair_on_location = 0;
	} else if ( $reschedule_delivery_method == 'ship_device' ) {
		$planning_discount[0]->come_our_store = 0;
		$planning_discount[0]->pickup_service = 0;
		$planning_discount[0]->repair_on_location = 0;
	} else if ( $reschedule_delivery_method == 'pickup_service' ) {
		$planning_discount[0]->come_our_store = 0;
		$planning_discount[0]->ship_device = 0;
		$planning_discount[0]->repair_on_location = 0;
	} else if ( $reschedule_delivery_method == 'repair_on_location' ) {
		$planning_discount[0]->come_our_store = 0;
		$planning_discount[0]->ship_device = 0;
		$planning_discount[0]->pickup_service = 0;
	} else {

	}
	$_customer_house_no = trim($reschedule_related_order->customer_house_no ?? '');
	$_customer_street_address = trim($reschedule_related_order->customer_street_address ?? '');
	$_customer_city = trim($reschedule_related_order->customer_city ?? '');
	$_customer_zipcode = trim($reschedule_related_order->customer_zipcode ?? '');
}

?>
<div class="loading-div"></div>
**progressBar**
<br>
<div class="wp-repair-select-container clearfix <?php if(isset($_GET['reschedule']) && isset($o_id_fk) && !empty($o_id_fk)) { echo 'rp_reschedule'; } ?>">
	<form class="submit_form" method="post" action="">
		<div class="wp-repair-col-6" style="position: relative;">
			**BackButton**
			<h1 class="select-heading"><span class="light"><?php echo $wp_repair_lang['finalize']; ?></span> <?php echo $wp_repair_lang['booking']; ?></h1>
			<p class="wp-repair-options-heading ptop"><?php echo $wp_repair_lang['select_delivery_method']; ?></p>
			<div class="wp-repair-width-100">
				<?php

				$sorted_methods = rp_get_option('rp_get_sorted_delivery_methods', json_encode(array(
					'come_our_store',
					'ship_device',
					'pickup_service',
					'repair_on_location'
				)));
				$sorted_methods = json_decode($sorted_methods);

				foreach( $sorted_methods as $theDeliveryMethod ) {

					require_once WP_REPAIR_PLUGIN_PATH . 'html/front_end/'.$theDeliveryMethod.'_html.php';

				}
				?>
			</div>
		</div>
		<div class="wp-repair-col-6 finalize-right">
			<div class="wp-repair-width-100">
				<div class="model-info">
					<div class="model-img">
						<img src="<?php echo $models[0]->m_img?>">
					</div>
					<div class="text">
						<h1 class="select-heading model_name"><?php echo $models[0]->b_name. ' '.$models[0]->m_name?></h1>
						<span class="model-model"><?php echo $wp_repair_lang['repair']; ?></span>
					</div>
				</div>
				<table class="table main">
					<tbody>
						<tr>
							<td style="padding: 0px !important;">
								<div class="col-container <?php if(rp_which_delivery_method_enable_by_default($planning_discount) == 'ship_device') { echo 'ship_device_selected'; } ?>">
									<?php
									echo rp_render_order_summary(
										$models, 
										$color_name ?? '',
										$r_id ?? NULL,
										$o_id_fk ?? NULL,
										$a_id ?? NULL,
										$up_id ?? NULL,
										$coupon ?? NULL,
										$coupon_type ?? NULL,
										$coupon_info ?? NULL,
										$total_price ?? 0,
										$sub_total ?? 0,
										'0',
										'',
										$delivery_method_key ?? '',
										$delivery_method_cost ?? 0,
										$rpCart,
										$combo
									);
									?>
								</div>
								<button type="button" class="view-repair-order-btn">
									<?php echo $wp_repair_lang['finalize_view_order']; ?> <?php echo rp_svg_icons_loader('fa-search-black', 's-12'); ?>
								</button>
							</td>
						</tr>
						<tr>
							<td colspan="2" style="padding: 0px !important;">
								<div class="user-type-select">
									<button type="button" class="user-type active">
										<?php echo rp_svg_icons_loader('fa-check', 's-14'); ?>
										<div class="wp-repair-select-checkbox"></div>
										<span data-text="private"><?php echo $wp_repair_lang['private']; ?></span>
									</button>
									<button type="button" class="user-type">
										<?php echo rp_svg_icons_loader('fa-check', 's-14'); ?>
										<div class="wp-repair-select-checkbox"></div>
										<span data-text="business"><?php echo $wp_repair_lang['business']; ?></span>
									</button>
								</div>
								<div class="wp-repair-input-group width-50-left both">
									<label><?php echo $wp_repair_lang['your_name']; ?> <span class="required-asterisk">*</span></label>
									<input type="text" class="user-info" name="user_name" value="<?php echo $_customer_name; ?>" required>
								</div>
								<div class="wp-repair-input-group width-50-right both">
									<label><?php echo $wp_repair_lang['your_phone_number']; ?> <span class="required-asterisk">*</span></label>
									<input type="text" class="user-info" name="user_phone" value="<?php echo $_customer_phone; ?>" required>
								</div>
								<div class="wp-repair-input-group business width-50-left">
									<label><?php echo $wp_repair_lang['business_name']; ?> <span class="required-asterisk">*</span></label>
									<input type="text" class="user-info" name="business_name" value="<?php echo $_customer_business_name; ?>">
								</div>
								<div class="wp-repair-input-group width-100-right email both">
									<label><?php echo $wp_repair_lang['your_email_address']; ?> <span class="required-asterisk">*</span></label>
									<input type="email" class="user-info" name="user_email" value="<?php echo $_customer_email; ?>" required>
									<input type="hidden" class="user-info" name="color_name" value="<?php echo $color_name;?>">
									<input type="hidden" class="user-info" name="m_id_fk" value="<?php echo $m_id_fk;?>">
									<input type="hidden" class="user-info" name="coupons_id" value="<?php echo ($coupon_id ?? '');?>">
									<input type="hidden" class="user-info" name="pdf_offer" value="<?php echo $pdf_offer;?>">
								</div>
								<div class="wp-repair-input-group both">
									<label><?php echo $wp_repair_lang['notes']; ?></label>
									<textarea class="user-info" name="notes"><?php echo $_customer_notes; ?></textarea>
								</div>
								<?php
								$terms_and_conditions_page = rp_get_option('rp_terms_and_conditions_page_link', '');
								if( !empty( $terms_and_conditions_page ) ) {
									// get everything within <>
									preg_match('/\[(.)*\]/i', $wp_repair_lang['i_accept_terms'], $tags);
									if( !empty($tags) && !empty($tags[0]) ) {
										$tags = $tags[0];
										// replace < and > with nothing
										$only_wording = str_replace('[', '', $tags);
										$only_wording = str_replace(']', '', $only_wording);
										?>
										<button type="button" class="user-type rp-tos">
											<?php echo rp_svg_icons_loader('fa-check', 's-12'); ?>
											<div class="wp-repair-select-checkbox"></div>
											<span class="tos-text"><?php echo str_replace($tags, '<a target="_blank" href="'.$terms_and_conditions_page.'">'.$only_wording.'</a>', $wp_repair_lang['i_accept_terms']); ?></span>
										</button>
										<?php
									} else {
										?>
										<button type="button" class="user-type rp-tos">
											<?php echo rp_svg_icons_loader('fa-check', 's-12'); ?>
											<div class="wp-repair-select-checkbox"></div>
											<span class="tos-text"><?php echo htmlspecialchars($wp_repair_lang['i_accept_terms']); ?></span>
										</button>
										<?php
									}
								}
								?>
							</td>
						</tr>
					</tbody>
				</table>
				<div class="confirm-booking-btn-cont">
					<button type="submit" class="confirm-booking" name="confirm_booking">
						<div class="text">
							<span class="bold"><?php echo $wp_repair_lang['confirm_booking']; ?></span>
							<span class="light"><?php echo $wp_repair_lang['you_can_cancel_anytime']; ?></span>
						</div>
						<div class="confirm-booking-icon">
							<?php echo rp_svg_icons_loader('fa-caret-right', 's-13'); ?>
						</div>
					</button>
				</div>
			</div>
		</div>
	</form>
</div>
<br>