<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

if($planning_discount[0]->repair_on_location == '1'){?>
<span class="wp-repair-repair-card <?php if(rp_which_delivery_method_enable_by_default($planning_discount) == 'repair_on_location') { echo 'active'; } ?> repair-on-location" onclick="delivery_method(this.id);" id="Repair on location">
    <div class="repair-img">
        <img src="<?php echo getTheImageURL('serviceonlocation.svg'); ?>">
    </div>
    <div class="text-all">
        <p class="repair-name"><?php echo $wp_repair_lang['repair_on_your_location']; ?> <?php echo rp_delivery_method_cost_badge('repair_on_location', $decimal, $localization, $reschedule_order_id); ?></p>
        <p class="repair-mins"><?php echo $wp_repair_lang['repair_on_your_location_description']; ?></p>
    </div>
    <div class="wp-repair-action-price" onclick="delivery_method(this.id);" id="Repair on location">
        <?php echo rp_svg_icons_loader('fa-check', 's-14'); ?>
        <div class="wp-repair-select-checkbox"></div>
    </div>
    <div class="more-info-ship-device" <?php if(rp_which_delivery_method_enable_by_default($planning_discount) == 'repair_on_location') { echo 'style="max-height:100% !important;"'; } ?>>
        <table class="table date-time">
            <tbody>
                <tr>
                    <td colspan="2" class="choose-location-text"><?php echo $wp_repair_lang['select_date_and_time']; ?></td>
                </tr>
            </tbody>
        </table>
        <div class="date-slider">
            <?php
            $count = 0;
            while ($count < 14) {
                $calc = date('D d', strtotime(date('Y-m-d').' +'.$count.' days'));
                $day  = date('l', strtotime(date('Y-m-d').' +'.$count.' days'));
                $date = date('d-m-Y', strtotime(date('d-m-Y').' +'.$count.' days'));
                $calc = explode(' ', $calc);
                $inactive = '';
                $selected = '';
                if(strtotime(date('Y-m-d').' +'.$count.' days') < strtotime(date('Y-m-d'))) {
                    $inactive = ' inactive';
                }
                if(strtotime(date('Y-m-d').' +'.$count.' days') === strtotime(date('Y-m-d'))) {
                    $selected = ' selected';
                }
                $translation_key = 'translation_of_day_'.trim(strtolower($calc[0]));
                $transalted_day = isset($wp_repair_lang[$translation_key]) ? $wp_repair_lang[$translation_key] : $calc[0];
                ?>
                <div class="wpRepairDateSlide <?php echo $inactive.$selected; ?>">
                    <div class="dayOfWeek"><?php echo $transalted_day; ?></div>
                    <div class="dateOfWeek" data-id="<?php echo $date; ?>" data-dname="<?php echo $day;?>"><span class="num" data-id="<?php echo $date; ?>" data-dname="<?php echo $day;?>"><?php echo $calc[1]; ?></span></div>
                </div>
                <?php
                $count++;
            }
            ?>
        </div>
        <div class="time-slider">
            <table class="table">
                <tbody>
                    <?php 
                    $slot_print_count = 0;
                    $day  = date('l');
                    $date_ymd = date('Y-m-d');
                    //var_dump($day);
                    $loc_sche = rp_get_special_schedule_new_methods('repair_on_location', $day, $date_ymd);
                    $loc_sche = rp_sanitize_output($loc_sche);
                    ?>
                    <tr>
                        <?php 

                        $delivery_timeslots = rp_get_delivery_timeslots('repair_on_location', $day);

                        if( !empty( $loc_sche ) && !empty( $delivery_timeslots ) ) {

                            // Has special timing!
                            if( $loc_sche[0]->is_closed == 0 ) {

                                $from_time = strtotime($loc_sche[0]->cs_open_timing);
                                $to_time   = strtotime($loc_sche[0]->cs_close_timing);

                                $filtered_delivery_timeslots = array();

                                foreach( $delivery_timeslots as $dt_row ) {

                                    $slot_start = strtotime($dt_row->slot_start);

                                    $slot_end = strtotime($dt_row->slot_end);

                                    if( $slot_start >= $from_time && $slot_end <= $to_time ) {
                                        $filtered_delivery_timeslots[] = $dt_row;
                                    }

                                }

                                $delivery_timeslots = $filtered_delivery_timeslots;

                            } else {
                                $delivery_timeslots = array();
                            }

                        }

                        if( !empty( $delivery_timeslots ) ) {

                            $slot_time = array();

                            $last_time = '';

                            $shop_close_time = '';

                            foreach($delivery_timeslots as $dt_row) {

                                $slot_start = strtotime($dt_row->slot_start);

                                $slot_end = strtotime($dt_row->slot_end);

                                if( $localization[0]->set_time_format == '24 hours (e.g. 15:00)' ) {
                                    $slot_time[] = date('H:i', $slot_start).' — '.date('H:i', $slot_end);
                                } else {
                                    $slot_time[] = date('g:i a', $slot_start).' — '.date('g:i a', $slot_end);
                                }

                                if( empty( $last_time ) ) {

                                    $last_time = $slot_start;

                                } else {

                                    if( $last_time < $slot_start ) {

                                        $last_time = $slot_start;

                                    }

                                }

                                if( empty( $shop_close_time ) ) {
                                    
                                    $shop_close_time = $slot_end;

                                } else {

                                    if( $shop_close_time < $slot_end ) {

                                        $shop_close_time = $slot_end;

                                    }

                                }

                            }

                            $current_time = date('Y-m-d H:i:s');

                            $current_time_str = strtotime($current_time);

                            $booking_must_wait_time = (int) rp_get_option('wp_repair_booking_must_wait_time_rol', 60);

                            $booking_must_wait_time_until = strtotime(date('Y-m-d H:i:s', strtotime($current_time .' +'.$booking_must_wait_time.' minutes')));

                            $time_slots_printed = FALSE;

                            foreach($slot_time as $time){

                                $the_time = explode(' — ', $time)[0];

                                $loop_time = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d').' '.$the_time)));

                                if($loop_time < $current_time_str) {

                                    continue;

                                }

                                if($loop_time > $last_time) {

                                    continue;

                                }

                                if($loop_time < $booking_must_wait_time_until || (rp_is_available_slot_new_delivery_methods('repair_on_location', date('Y-m-d'), $time) === FALSE)) {
                                    
                                } else {
                                    $time_slots_printed = TRUE;
                                }

                            }

                            if($time_slots_printed === FALSE) {
                                if($current_time_str >= $shop_close_time) {
                                    echo '<td class="shop_close"><b>'.$wp_repair_lang['shop_has_closed_for_today'].'</b></td>';
                                } else {
                                    echo '<td class="shop_close"><b>'.$wp_repair_lang['appointment_booking_has_closed_for_today'].'</b></td>';
                                }
                            } else {
                                foreach($slot_time as $time){

                                    $the_time = explode(' — ', $time)[0];

                                    $loop_time = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d').' '.$the_time)));

                                    if($loop_time < $current_time_str) {

                                        continue;

                                    }

                                    if($loop_time > $last_time) {

                                        continue;

                                    }
                                    
                                    $slot_print_count++;

                                    if(rp_is_available_slot_new_delivery_methods('repair_on_location', date('Y-m-d'), $time) === FALSE) {
                                        ?>
                                        <td><span class="time-box rp-fully-booked <?php if($localization[0]->set_time_format == '24 hours (e.g. 15:00)') { echo 'hours-24'; }?>" id="<?php echo $time;?>"><?php echo $time;?></span></td>
                                        <?php 
                                    } else if($loop_time < $booking_must_wait_time_until) {
                                        ?>
                                        <td><span class="time-box rp-too-early <?php if($localization[0]->set_time_format == '24 hours (e.g. 15:00)') { echo 'hours-24'; }?>" id="<?php echo $time;?>"><?php echo $time;?></span></td>
                                        <?php 
                                    } else {
                                        ?>
                                        <td><span class="time-box <?php if($localization[0]->set_time_format == '24 hours (e.g. 15:00)') { echo 'hours-24'; }?>" id="<?php echo $time;?>" onclick="timeRP_new(this.id);"><?php echo $time;?></span></td>
                                        <?php 
                                    }
                                }
                            }

                        } else {
                            if( !empty( $loc_sche ) && !empty( $loc_sche[0]->reminder_name ?? '' ) ) {
                                echo '<td class="shop_close"><b>'.$loc_sche[0]->reminder_name.'</b></td>';
                            } else {
                                echo '<td class="shop_close"><b>'.$wp_repair_lang['shop_is_closed_for_today'].'</b></td>';
                            }
                        }
                        ?>
                    </tr>
                </tbody>
            </table>
            <div id="slot_print_count"><?php echo $slot_print_count; ?></div>
        </div>
        <table class="table location">
            <tbody>
                <tr>
                    <td colspan="2" class="choose-location-text"><?php echo $wp_repair_lang['choose_location']; ?></td>
                </tr>
                <tr>
                    <td class="rp-ptb-0">
                        <div class="wp-repair-input-group both">
                            <label><?php echo $wp_repair_lang['user_location_house_number']; ?> <span class="required-asterisk">*</span></label>
                            <input type="text" class="user-info" name="rol_house_no" value="<?php echo $_customer_house_no; ?>">
                        </div>
                    </td>
                    <td class="rp-ptb-0">
                        <div class="wp-repair-input-group both">
                            <label><?php echo $wp_repair_lang['user_location_street_address']; ?> <span class="required-asterisk">*</span></label>
                            <input type="text" class="user-info" name="rol_street_address" value="<?php echo $_customer_street_address; ?>">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td class="rp-ptb-0">
                        <div class="wp-repair-input-group both">
                            <label><?php echo $wp_repair_lang['user_location_city']; ?> <span class="required-asterisk">*</span></label>
                            <input type="text" class="user-info" name="rol_user_city" value="<?php echo $_customer_city; ?>">
                        </div>
                    </td>
                    <td class="rp-ptb-0">
                        <div class="wp-repair-input-group both">
                            <label><?php echo $wp_repair_lang['user_location_zipcode']; ?> <span class="required-asterisk">*</span></label>
                            <input type="text" class="user-info" name="rol_user_zipcode" value="<?php echo $_customer_zipcode; ?>">
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</span>
<?php }?>