<?php

global $wp_repair_lang;
global $rpQuery;

$wp_repair_lang = rp_sanitize_output($wp_repair_lang);

$company_information = $rpQuery->prefix . "rs_company_information";
$company_results = $rpQuery->get_results("SELECT * FROM $company_information");
$theme_color = $company_results[0]->company_theme_color;

$wp_repair_search_bar = new RepairPluginPro\Search_Bar();
$wp_repair_search_bar_data = $wp_repair_search_bar->get_json();

if(!function_exists('wpRepairGetStyleSheetURLOfSearchBar')) {
	function wpRepairGetStyleSheetURLOfSearchBar() {
		$fileName = WP_REPAIR_PLUGIN_URL.'assets/css/front_end/search_bar_shortcode.css?id='.WP_REPAIR_ASSETS_CACHE_V;
		$fileName = str_replace(array('/', '\\'), '/', $fileName);
		return $fileName;
	}
}
if(!function_exists('wpRepairGetScriptURLOfSearchBarJS')) {
	function wpRepairGetScriptURLOfSearchBarJS() {
		$fileName = WP_REPAIR_PLUGIN_URL.'assets/js/search_bar_shortcode.js?id='.WP_REPAIR_ASSETS_CACHE_V;
		$fileName = str_replace(array('/', '\\'), '/', $fileName);
		return $fileName;
	}
}

?><style>
	:root {
  		--theme: #<?php echo $theme_color;?>;
	}
</style>
<?php
require_once WP_REPAIR_PLUGIN_PATH.'html/front_end/svg_icons.php';
?>
<!-- The appointment system on this site is powered by RepairPlugin.com -->
<link rel="stylesheet" type="text/css" href="<?php echo wpRepairGetStyleSheetURLOfSearchBar(); ?>">
<div class="wp-repair-search-box-shortcode-container">
	<div class="wp-repair-search-box-shortcode-row">
		<div class="wp-repair-search-box-shortcode-col">
			<div class="wp-repair-search-box">
				<div class="repair-search-box">
					<input type="text" placeholder="<?php echo $wp_repair_lang['search_bar_placeholder_text']; ?>">
					<button class="submit-repair-search">
						<?php echo rp_svg_icons_loader('fa-times', 's-15 s-12-mq-625'); ?>
						<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/rp-search-icon.svg'; ?>">
					</button>
				</div>
				<div class="search-content">
					<ul>
						<li><a href="#"><span class="model">Loading Data..</span></a></li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</div>
<script type="text/javascript">
	window.wp_repair_lang = <?php echo json_encode($wp_repair_lang); ?>;
	window.wp_repair_search_bar_data = <?php echo $wp_repair_search_bar_data; ?>;
</script>
<!-- The appointment system on this site is powered by RepairPlugin.com -->
<script type="text/javascript" src="<?php echo wpRepairGetScriptURLOfSearchBarJS(); ?>"></script>