<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;
if(!function_exists('getTheImageURL')) {
	function getTheImageURL($str = '') {
		return WP_REPAIR_PLUGIN_URL.'assets/images/'.$str;
	}
}

$order = rp_sanitize_output($order);

$wp_repair_lang = rp_sanitize_output($wp_repair_lang);

$google_map_link = '';

if(isset($order[0]->google_map_link) && !empty($order[0]->google_map_link)) {

	$google_map_link = $order[0]->google_map_link;

}

global $rpQuery;

$rs_planning_and_discount = $rpQuery->prefix . "rs_planning_and_discount";

$planning_discount = $rpQuery->get_results("SELECT * FROM $rs_planning_and_discount");

$time_slots = $planning_discount[0]->booking_slots_length;

$time_slots = str_replace(strtolower(' Minutes (Default)'), '', strtolower($time_slots));

$time_slots = trim(str_replace('minutes', '', strtolower($time_slots)));

$time_slots = (int) $time_slots;

?>
<div class="loading-div"></div>
**progressBar**
<div class="wp-repair-select-container clearfix">
	<canvas id="confettijs"></canvas>
	<div class="wp-repair-col-12">
		<div class="wp-repair-width-100">
			<div class="align-center">
				<h1 class="thanks-heading"><?php echo $wp_repair_lang['thanks_for_purchasing_from_us!']; ?></h1>
				<p class="thanks-heading-info"><?php echo $wp_repair_lang['you_will_receive_a_confirmation_by_email']; ?></p>
				<?php
				if(isset($order) && !empty($order)) {
					?>
					<div class="order-details">
						<div class="appointment-date">
							<?php
							if(1 === 2) {
								?>
								<p class="come-store"><?php
								$delivery_method = strtolower(trim(str_replace(' ', '_', $order[0]->delivery_method)));
								echo $wp_repair_lang[$delivery_method];
								?></p>
								<?php
							}
							?>
							<?php
							$delivery_method = strtolower(trim(str_replace(' ', '_', $order[0]->delivery_method)));
							if($delivery_method === 'ship_device') {
								?>
								<p class="actual-date"><span class="text-strong"><?php echo $wp_repair_lang['send_device_to']; ?></span></p>
								<?php
							} else {
								if( $delivery_method === 'come_by_our_store' ) {
									?>
									<p class="actual-date"><?php echo $wp_repair_lang['appointment_on']; ?> <span class="text-strong"><?php echo $order[0]->delivery_date; ?></span> <?php echo $wp_repair_lang['thank_you_at']; ?>  <span class="text-strong"><?php echo $order[0]->delivery_time; ?></span></p>
									<?php
								} else {
									?>
									<p class="actual-date"><?php echo $wp_repair_lang['appointment_on']; ?> <span class="text-strong"><?php echo $order[0]->delivery_date; ?></span><br><?php echo $wp_repair_lang['thank_you_at']; ?>  <span class="text-strong"><?php echo $order[0]->delivery_time; ?></span></p>
									<?php
								}
							}
							?>
						</div>
						<div class="address-box">
							<div class="inner-box">
								<div class="shop-address">
									<?php
									if( $delivery_method === 'ship_device' || $delivery_method === 'come_by_our_store' ) {
										?>
										<p class="address-details"><?php echo $wp_repair_lang['thank_you_address_details']; ?></p>
										<p class="name"><?php echo $order[0]->location_name; ?></p>
										<?php
										if( rp_is_active_enhanced_locations_addon() === true && !empty( trim( $order[0]->location_telephone ?? '' ) ) ) {
											?>
											<p class="telephone"><?php echo $order[0]->location_telephone; ?></p>
											<?php
										}
										?>
										<p class="street"><?php echo $order[0]->location_address; ?><br><?php echo $order[0]->location_city_district;?></p>
										<?php
										if(!empty($google_map_link) && !filter_var($google_map_link, FILTER_VALIDATE_URL) === FALSE) {
											?>
											<a href="<?php echo $google_map_link; ?>" target="_blank" class="btn-open-google-maps"><?php echo $wp_repair_lang['open_in_google_maps']; ?> <span>Google Maps</span></a>
											<?php
										}
									} else {
										?>
										<p class="address-details"><?php echo $wp_repair_lang['thank_you_address_details']; ?></p>
										<p class="name"><?php echo $order[0]->customer_name ?? ''; ?></p>
										<p class="street"><?php echo $order[0]->customer_house_no ?? ''; ?><br><?php echo $order[0]->customer_street_address ?? ''; ?><br><?php echo $order[0]->customer_city ?? '';?>, <?php echo $order[0]->customer_zipcode ?? '';?></p>
										<?php
									}
									?>
								</div>
							</div>
						</div>
					</div>
					<?php
				}
				?>
			</div>
			<?php
			if(isset($order) && !empty($order)) {

				$delivery_method = strtolower(trim(str_replace(' ', '_', $order[0]->delivery_method)));

				if($delivery_method !== 'ship_device') {

					$location = str_replace(array('<br>', "\n", "\r"), ', ', $order[0]->location_name . ', ' . $order[0]->location_address . ', ' . $order[0]->location_city_district);

					if( $delivery_method === 'come_by_our_store' ) {
						
						$start_time = date('Y-m-d H:i', strtotime($order[0]->delivery_date . ' '. $order[0]->delivery_time));

						$end_time = date('Y-m-d H:i', strtotime($order[0]->delivery_date . ' '. $order[0]->delivery_time . ' +'.$time_slots.' minutes'));

					} else {

						$exploded_time = explode(' — ', $order[0]->delivery_time);

						$start_time = date('Y-m-d H:i', strtotime($order[0]->delivery_date . ' '. $exploded_time[0]));

						$end_time = date('Y-m-d H:i', strtotime($order[0]->delivery_date . ' '. $exploded_time[1]));

					}

					$site_name = get_bloginfo( 'name' );
					$appointment_details = 'You have an appointment with '.$site_name;

					if(empty($site_name)) {
						$site_name = 'Appointment';
						$appointment_details = 'You have an appointment';
					} else {
						$site_name = 'Appointment with '.$site_name;
					}

					$g_calendar_link = rp_create_google_calendar_link(array(

						'text' => $site_name,

						'details' => $appointment_details,

						'location' => $location,

						'start_time' => $start_time,

						'end_time' => $end_time

					));
					global $wp;
					?>
					<form style="display: none;" id="rp_ical" action="<?php echo home_url($wp->request); ?>/?rp_ics=true" method="POST">
						<?php
						rp_csrf_token_input_field('frontend');
						?>
						<input type="hidden" name="text" value="<?php echo $site_name; ?>">
						<input type="hidden" name="details" value="<?php echo $appointment_details; ?>">
						<input type="hidden" name="location" value="<?php echo $location; ?>">
						<input type="hidden" name="start_time" value="<?php echo $start_time; ?>">
						<input type="hidden" name="end_time" value="<?php echo $end_time; ?>">
					</form>
					<a class="rp-a-normalize" target="_blank" href="<?php echo $g_calendar_link ?>">
						<div class="wp-repair-repair-card">
							<div class="repair-img">
								<img src="<?php echo getTheImageURL('calendar-icon.gif'); ?>">
							</div>
							<div class="text-all">
								<p class="repair-mins"><?php echo $wp_repair_lang['add_to']; ?></p>
								<p class="repair-name">Google <?php echo $wp_repair_lang['calendar']; ?></p>
							</div>
						</div>
					</a>
					<a class="rp-a-normalize rp-ical" href="#">
						<div class="wp-repair-repair-card">
							<div class="repair-img">
								<img src="<?php echo getTheImageURL('calendar-icon.gif'); ?>">
							</div>
							<div class="text-all">
								<p class="repair-mins"><?php echo $wp_repair_lang['add_to']; ?></p>
								<p class="repair-name">Apple <?php echo $wp_repair_lang['calendar']; ?></p>
							</div>
						</div>
					</a>
					<?php

				}

			}
			?>
		</div>
	</div>
</div>
<br>
