<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

global $rpQuery;
$company_information = $rpQuery->prefix . "rs_company_information";
$company_location    = $rpQuery->prefix . "rs_company_location";
$company_schedules   = $rpQuery->prefix . "rs_company_schedules";

require_once( ABSPATH . 'wp-admin/includes/file.php' ); // require file.php

$c_results = $rpQuery->get_results("SELECT * FROM $company_information");

$c_results = rp_sanitize_output($c_results);

$company_id = $c_results[0]->company_id;

$location = $rpQuery->get_results("SELECT * FROM $company_location");

$location = rp_sanitize_output($location);

$count_locations = $rpQuery->get_var("SELECT COUNT(*) FROM $company_location");

$first_location_id = $location[0]->location_id;
$get_schedules = $rpQuery->get_results("SELECT * FROM $company_schedules WHERE location_id_fk = '".rp_escape_sql($first_location_id)."'");


if (isset($_POST['update_company'])) {

    $c_name        = $_POST['c_name'];
    $c_email       = $_POST['c_email'];
    $c_phone       = $_POST['c_phone'];
    $c_reg_no      = $_POST['c_reg_no'];
    $tax_reg_no    = $_POST['tax_reg_no'];

	if( isset( $_POST['terms_and_conditions_page'] ) && !empty( $_POST['terms_and_conditions_page'] ) && filter_var( $_POST['terms_and_conditions_page'], FILTER_VALIDATE_URL ) !== FALSE ) {

		// check if have rp_get_option rp_terms_and_conditions_page_link
		if( rp_get_option( 'rp_terms_and_conditions_page_link', FALSE ) !== FALSE ) {
			rp_update_option( 'rp_terms_and_conditions_page_link', $_POST['terms_and_conditions_page'] );
		} else {
			rp_add_option( 'rp_terms_and_conditions_page_link', $_POST['terms_and_conditions_page'] );
		}

	} else {

		// check if have rp_get_option rp_terms_and_conditions_page_link
		if( rp_get_option( 'rp_terms_and_conditions_page_link', FALSE ) !== FALSE ) {
			rp_update_option( 'rp_terms_and_conditions_page_link', '' );
		}

	}

   
    $rpQuery->query("UPDATE $company_information SET company_name = '".rp_escape_sql($c_name)."',company_email = '".rp_escape_sql($c_email)."',company_phone = '".rp_escape_sql($c_phone)."',company_reg_no = '".rp_escape_sql($c_reg_no)."',tax_reg_no = '".rp_escape_sql($tax_reg_no)."' WHERE company_id='".rp_escape_sql($company_id)."'");
    echo "<script>location.replace('admin.php?page=wp_repair_settings');</script>";
}
function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}

$_rp_company_email = rp_get_settings_company_email();

?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.wp-general-info.save-settings{
		padding: 15px;
		font-size: 13px;
		margin-top: 20px;
		width: auto;
	}
	.rp_is_synced {
		margin-bottom: 0px;
	}
	.rp_is_synced small {
		display: table;
		font-size: 10px;
	}
	@media screen and (max-width: 768px) {
		.wp-repair-col-3 .main-section .section-two{
			margin-top: 0px;
			width: 100%;
		}
	}
	.wp-repair-col-3{
		margin-top: 220px;
		float: right;
	}
	.is_closed{
		width: 26px !important;
	}
	.wp-repair-col-4.main-section{
		padding: 20px 20px 65px 20px;
	}
	.days-setting-table input.has-breaktime-error {
		box-shadow: 0 0 0 1px #b12222;
	}
	.wp-repair-alert.error {
		margin-top: 0px;
		margin-bottom: 12px;
		background: #f8d7da;
		color: #721c24;
		border-radius: 8px;
		border: 2px solid #f5c6cb;
		padding: 12px;
		font-size: 13px;
		width: calc(100% - 60px);
		line-height: 1.4em;
	}
	a.special-timing {
		text-align: left;
		display: block;
		margin: 10px 0px 8px 0px;
	}
	a.special-timing:hover,
	a.special-timing:focus {
		outline: 0;
		box-shadow: unset;
	}
</style>
<?php
rp_csrf_token_form_for_ajax('general_info');
?>
<form method="post" action="" enctype="multipart/form-data">
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('general_info'); ?>
					<div class="bg-with-border">
						<?php
						$breakTimeErrors = get_invalid_breaktimes_errors();
						if(!empty($breakTimeErrors)) {
							?>
							<div class="wp-repair-col-8 main-section">
								<?php
								if(in_array('invalid_break_time', $breakTimeErrors)) {
									?>
									<div class="wp-repair-alert error">Invalid time format for breaktime is detected in one or more locations.<br><b>Hint for fixing this issue:</b> Use <b>01:00 PM</b> or <b>13:00</b></div>
									<?php
								}
								?>
								<?php
								if(in_array('mistake_in_am_pm', $breakTimeErrors)) {
									?>
									<div class="wp-repair-alert error">Invalid use of breaktime is detected for one or more locations.<br><b>Hint for fixing this issue:</b> Breaktime must be between opening and closing hours.</div>
									<?php
								}
								?>
								<?php
								if(in_array('break_start_is_greater', $breakTimeErrors)) {
									?>
									<div class="wp-repair-alert error">Invalid use of breaktime is detected for one or more locations.<br><b>Hint for fixing this issue:</b> Breaktime end must be greater than breaktime start.</div>
									<?php
								}
								?>
							</div>
							<?php
						}
						?>
						<div class="wp-repair-col-4 main-section section-one">
							<div class="wp-repair-main-section-heading">
								<h2>
									<span class="light">General</span>
									<span class="bold">Information</span>
								</h2>
								<p class="more-info">To be displayed on the PDF offers</p>
							</div>
							<div class="wp-repair-input-group">
								<label>Company Name</label>
								<input type="text" class="user-info" name="c_name" value="<?php echo $c_results[0]->company_name?>" required>
							</div>
							<div class="wp-repair-input-group">
								<label>EMail Address</label>
								<input type="text" class="user-info" name="c_email" value="<?php echo $c_results[0]->company_email?>" required>
							</div>
							<div class="wp-repair-input-group">
								<label>Phone number</label>
								<input type="text" class="user-info" name="c_phone" value="<?php echo $c_results[0]->company_phone?>" required>
							</div>
							<div class="wp-repair-input-group">
								<label>Company Registration Number</label>
								<input type="text" class="user-info" name="c_reg_no" value="<?php echo $c_results[0]->company_reg_no?>">
							</div>
							<div class="wp-repair-input-group">
								<label>Tax Registration Number</label>
								<input type="text" class="user-info" name="tax_reg_no" value="<?php echo $c_results[0]->tax_reg_no?>">
							</div>
							<div class="wp-repair-input-group">
								<label>Terms & Condition Page</label>
								<input type="text" class="user-info" name="terms_and_conditions_page" value="<?php echo rp_get_option('rp_terms_and_conditions_page_link', ''); ?>" placeholder="https://site.com/terms_conditions">
							</div>
							<div class="sec-3">
								<button type="button" name="update_company" id="update_company" class="wp-general-info save-settings">Save All Settings</button>
							</div>
						</div>
						<div class="wp-repair-col-4 main-section section-two">
							<div class="wp-repair-main-section-heading">
								<h2>
									<span class="light">Your</span>
									<span class="bold">Location</span>
								</h2>
								<p class="more-info">Main location will be displayed on PDF offers</p>
							</div>
							<?php if(rp_is_active_enhanced_locations_addon() === false) { ?>
							<?php if($location){?>
							<div class="table-responsive location-table">
								<table class="table">
									<tbody>
										<tr class="closed">
											<td>
												<button type="button" class="plus-icon see-more">
													<span class="dropicon">
														<i class="fas fa-plus"></i>
													</span>
													<span class="text">Main Location</span>
												</button>
											</td>
											<td class="ractions-td">
												<button type="button" class="trash delete_location" data-id="<?php echo $location[0]->location_id; ?>"><i class="fas fa-times"></i></button>
											</td>
										</tr>
										<tr class="more-details">
											<td colspan="7">
												<div class="details-container">
													<div class="wp-repair-inner-col section-1">
														<div class="wp-repair-input-group">
															<label>Name</label>
															<input type="text" class="user-info" name="location_name[]" id="location_name<?php echo $location[0]->location_id; ?>" value="<?php echo $location[0]->location_name?>" required>
															<input type="hidden" class="user-info" name="location_id[]" value="<?php echo $location[0]->location_id?>" required>
														</div>
														<div class="wp-repair-input-group">
															<label>Address</label>
															<input type="text" class="user-info" name="location_address[]" id="location_address<?php echo $location[0]->location_id; ?>" value="<?php echo $location[0]->location_address?>">
														</div>
														<div class="wp-repair-input-group">
															<label>Zipcode + City</label>
															<input type="text" class="user-info" name="location_city[]" id="location_city<?php echo $location[0]->location_id; ?>" value="<?php echo $location[0]->location_city_district?>">
														</div>
														<div class="wp-repair-input-group">
															<label>Google Maps Link</label>
															<input type="text" class="user-info" name="google_maps_link[]" id="google_maps_link<?php echo $location[0]->location_id; ?>" value="<?php echo $location[0]->google_map_link?>">
														</div>
														<?php
														$location_email = ($location[0]->location_email ?? '');
														if(empty($location_email)) {
															$location_email = $_rp_company_email;
														}
														$is_synced = empty( $location[0]->location_email ?? '' );
														?>
														<div class="wp-repair-input-group">
															<label>Email Address</label>
															<input id="location_email<?php echo $location[0]->location_id; ?>" type="text" class="user-info" name="location_email[]" value="<?php echo $location_email;?>">
														</div>
														<?php
														if($is_synced !== FALSE) {
															?>
															<p class="rp_is_synced"><small>The email shown above is synchronized with the company email. This email address will be used for all notifications containing dynamic information and to send a copy of the email when the duplication feature is enabled.</small></p>
															<?php
														}
														?>
													</div>
													<div class="wp-repair-inner-col section-1 days-table">
														<table class="days-setting-table table">
															<tbody>
																<tr class="th-inner">
																	<td></td>
																	<td>Open</td>
																	<td>Close</td>
																	<td colspan="2">Breaktime</td>
																	<td>Closed</td>
																</tr>
																<?php foreach($get_schedules as $sch){
																	$breakTimeError = FALSE;
																	if(is_valid_breaktime($sch->cs_day, $location[0]->location_id) !== TRUE) {
																		$breakTimeError = TRUE;
																	}
																	?>
																<tr>
																	<td class="day-name"><?php echo $sch->cs_day?></td>
																	<input type="hidden" name="cs_id[]" id="cs_id<?php echo $location[0]->location_id; ?>" value="<?php echo $sch->cs_id?>" required>
																	<input type="hidden" name="cs_day[]" id="cs_day<?php echo $location[0]->location_id; ?>" value="<?php echo $sch->cs_day?>" required>
																	<td><input type="text" name="cs_open_timing[]" id="cs_open_timing<?php echo $location[0]->location_id; ?>" value="<?php echo $sch->cs_open_timing?>" required></td>
																	<td><input type="text" name="cs_close_timing[]" id="cs_close_timing<?php echo $location[0]->location_id; ?>" value="<?php echo $sch->cs_close_timing?>" required></td>
																	<td><input <?php if($breakTimeError === TRUE) { echo 'class="has-breaktime-error"'; } ?> type="text" name="cs_breaktime_from[]" id="cs_breaktime_from<?php echo $location[0]->location_id; ?>" value="<?php echo $sch->cs_breaktime_from?>"></td>
																	<td><input <?php if($breakTimeError === TRUE) { echo 'class="has-breaktime-error"'; } ?> type="text" name="cs_breaktime_to[]" id="cs_breaktime_to<?php echo $location[0]->location_id; ?>" value="<?php echo $sch->cs_breaktime_to?>"></td>
																	<td>
																		<input type="checkbox" class="is_closed" id="is_closed<?php echo $location[0]->location_id; ?>" name="is_closed[]" value="" <?php if($sch->is_closed == '1'){echo "checked";}?>>
																	</td>
																</tr>
																<?php }?>
																<tr class="more-details">
																	<td colspan="7">
																		<a target="_blank" class="special-timing" href="?page=wp_repair_settings&section=special_opening_times&location_id=<?php echo $location[0]->location_id?>">Set timing for special days</a>
																	</td>
																</tr>
															</tbody>
														</table>
													</div>
												</div>
											</td>
										</tr>
									</tbody>
								</table>
							</div>
							<?php }?>
							<?php if($count_locations > 1){
								if(empty($first_location_id)) {

									$get_location = array();									

								} else {

									$get_location = $rpQuery->get_results("SELECT * FROM $company_location WHERE location_id != '".rp_escape_sql($first_location_id)."'");

								}
								foreach($get_location as $loc){
								$locid = $loc->location_id;
								$schedules = $rpQuery->get_results("SELECT * FROM $company_schedules WHERE location_id_fk = '".rp_escape_sql($locid)."'");
								?>
								<div class="table-responsive location-table">
									<table class="table">
										<tbody>
											<tr class="closed">
												<td>
													<button type="button" class="plus-icon see-more">
														<span class="dropicon">
															<i class="fas fa-plus"></i>
														</span>
														<span class="text">Other Locations</span>
													</button>
												</td>
												<td class="ractions-td">
													<button type="button" class="trash delete_location" data-id="<?php echo $locid; ?>"><i class="fas fa-times"></i></button>
												</td>
											</tr>
											<tr class="more-details">
												<td colspan="7">
													<div class="details-container">
														<div class="wp-repair-inner-col section-1">
															<div class="wp-repair-input-group">
																<label>Name</label>
																<input type="text" class="user-info" id="location_name<?php echo $locid; ?>" name="location_name[]" value="<?php echo $loc->location_name?>" required>
																<input type="hidden" class="user-info" name="location_id[]" value="<?php echo $loc->location_id?>" required>
															</div>
															<div class="wp-repair-input-group">
																<label>Address</label>
																<input type="text" class="user-info" id="location_address<?php echo $locid; ?>" name="location_address[]" value="<?php echo $loc->location_address?>" required>
															</div>
															<div class="wp-repair-input-group">
																<label>Zipcode + City</label>
																<input type="text" class="user-info" id="location_city<?php echo $locid; ?>" name="location_city[]" value="<?php echo $loc->location_city_district?>" required>
															</div>
															<div class="wp-repair-input-group">
																<label>Google Maps Link</label>
																<input type="text" class="user-info" name="google_maps_link[]" id="google_maps_link<?php echo $locid; ?>" value="<?php echo $loc->google_map_link?>">
															</div>
															<?php
															$location_email = ($loc->location_email ?? '');
															if(empty($location_email)) {
																$location_email = $_rp_company_email;
															}
															$is_synced = empty( $loc->location_email ?? '' );
															?>
															<div class="wp-repair-input-group">
																<label>Email Address</label>
																<input id="location_email<?php echo $locid; ?>" type="text" class="user-info" name="location_email[]" value="<?php echo $location_email;?>">
															</div>
															<?php
															if($is_synced !== FALSE) {
																?>
																<p class="rp_is_synced"><small>The email shown above is synchronized with the company email. This email address will be used for all notifications containing dynamic information and to send a copy of the email when the duplication feature is enabled.</small></p>
																<?php
															}
															?>
														</div>
														<div class="wp-repair-inner-col section-1 days-table">
															<table class="days-setting-table table">
																<tbody>
																	<tr class="th-inner">
																		<td></td>
																		<td>Open</td>
																		<td>Close</td>
																		<td colspan="2">Breaktime</td>
																		<td>Closed</td>
																	</tr>
																	<?php foreach($schedules as $sch){
																		$breakTimeError = FALSE;
																		if(is_valid_breaktime($sch->cs_day, $locid) !== TRUE) {
																			$breakTimeError = TRUE;
																		}
																		?>
																	<tr>
																		<td class="day-name"><?php echo $sch->cs_day?></td>
																		<input type="hidden" name="cs_id[]" id="cs_id<?php echo $locid; ?>" value="<?php echo $sch->cs_id?>" required>
																		<input type="hidden" name="cs_day[]" id="cs_day<?php echo $locid; ?>" value="<?php echo $sch->cs_day?>" required>
																		<td><input type="text" name="cs_open_timing[]" id="cs_open_timing<?php echo $locid; ?>" value="<?php echo $sch->cs_open_timing?>" required></td>
																		<td><input type="text" name="cs_close_timing[]" id="cs_close_timing<?php echo $locid; ?>" value="<?php echo $sch->cs_close_timing?>" required></td>
																		<td><input <?php if($breakTimeError === TRUE) { echo 'class="has-breaktime-error"'; } ?> type="text" name="cs_breaktime_from[]" id="cs_breaktime_from<?php echo $locid; ?>" value="<?php echo $sch->cs_breaktime_from?>"></td>
																		<td><input <?php if($breakTimeError === TRUE) { echo 'class="has-breaktime-error"'; } ?> type="text" name="cs_breaktime_to[]" id="cs_breaktime_to<?php echo $locid; ?>" value="<?php echo $sch->cs_breaktime_to?>"></td>
																		<td>
																			<input type="checkbox" class="is_closed" id="is_closed<?php echo $locid; ?>" name="is_closed[]" value="" <?php if($sch->is_closed == '1'){echo "checked";}?>>
																		</td>
																	</tr>
																	<?php }?>
																	<tr class="more-details">
																		<td colspan="7">
																			<a target="_blank" class="special-timing" href="?page=wp_repair_settings&section=special_opening_times&location_id=<?php echo $locid;?>">Set timing for special days</a>
																		</td>
																	</tr>
																</tbody>
															</table>
														</div>
													</div>
												</td>
											</tr>
										</tbody>
									</table>
								</div>
							<?php } }?>
							<div class="table-responsive location-table add-new">
								<table class="table">
									<tbody>
										<tr class="closed">
											<td>
												<button type="button" class="plus-icon see-more">
													<span class="dropicon">
														<i class="fas fa-plus"></i>
													</span>
													<span class="text">Add New Location</span>
												</button>
											</td>
											<td class="ractions-td">
												<button type="button" class="trash"><i class="fas fa-times"></i></button>
											</td>
										</tr>
										<tr class="more-details">
											<td colspan="7">
												<div class="details-container">
													<div class="wp-repair-inner-col section-1">
														<div class="wp-repair-input-group">
															<label>Name</label>
															<input type="text" class="user-info loc_name">
														</div>
														<div class="wp-repair-input-group">
															<label>Address</label>
															<input type="text" class="user-info loc_address">
														</div>
														<div class="wp-repair-input-group">
															<label>City / District</label>
															<input type="text" class="user-info loc_city">
														</div>
														<div class="wp-repair-input-group">
															<label>Google Maps Link</label>
															<input type="text" class="user-info loc_google_map">
														</div>
														<div class="wp-repair-input-group">
															<label>Email Address</label>
															<input type="text" class="user-info loc_email" name="location_email" value="<?php echo $_rp_company_email; ?>">
														</div>
														<?php
														if( !empty( $_rp_company_email ) ) {

															?>
															<p class="rp_is_synced"><small>The email shown above is synchronized with the company email. This email address will be used for all notifications containing dynamic information and to send a copy of the email when the duplication feature is enabled.</small></p>
															<?php

														}
														?>
													</div>
													<div class="wp-repair-inner-col section-1 days-table">
														<table class="days-setting-table table">
															<tbody>
																<tr class="th-inner">
																	<td></td>
																	<td>Open</td>
																	<td>Close</td>
																	<td colspan="2">Breaktime</td>
																	<td>Closed</td>
																</tr>
																<tr>
																	<td class="day-name">Monday</td>
																	<input type="hidden" name="csday[]" value="Monday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr>
																	<td class="day-name">Tuesday</td>
																	<input type="hidden" name="csday[]" value="Tuesday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr>
																	<td class="day-name">Wednesday</td>
																	<input type="hidden" name="csday[]" value="Wednesday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr>
																	<td class="day-name">Thursday</td>
																	<input type="hidden" name="csday[]" value="Thursday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr>
																	<td class="day-name">Friday</td>
																	<input type="hidden" name="csday[]" value="Friday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr>
																	<td class="day-name">Saturday</td>
																	<input type="hidden" name="csday[]" value="Saturday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr>
																	<td class="day-name">Sunday</td>
																	<input type="hidden" name="csday[]" value="Sunday" class="csday">
																	<td><input type="text" name="csopen_timing[]" class="csopen_timing"></td>
																	<td><input type="text" name="csclose_timing[]" class="csclose_timing"></td>
																	<td><input type="text" name="csbreaktime_from[]" class="csbreaktime_from"></td>
																	<td><input type="text" name="csbreaktime_to[]" class="csbreaktime_to"></td>
																	<td>
																		<input type="checkbox" id="is_closed" class="is_closed" name="isclosed[]" value="1">
																	</td>
																</tr>
																<tr class="more-details">
																	<td colspan="7">
																		<div class="sec-3">
																			<button type="button" class="wp-general-info add_location">Add Location</button> 
																		</div>
																	</td>
																</tr>
															</tbody>
														</table>
													</div>
												</div>
											</td>
										</tr>
									</tbody>
								</table>
							</div>
							<?php } else { ?>
							<p>Please use <a href="?page=wp_repair_settings&section=enhanced_locations&tab=locations_crud">Enhanced Locations</a> section to manage locations.</p>
							<?php } ?>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
</form>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>

<script type="text/javascript">
	(function(window,document,$,undefined){
		jQuery(document).on("wpRepairReady", function(){
			let colorInputBindTimeout = false;
			jQuery("#select-custom-color input[name='c_theme_color']").on("change", function(){
				if(colorInputBindTimeout === false) {
					colorInputBindTimeout = true;
					jQuery(this).parent().find(".color-text").val(jQuery(this).val()).change();
					window.setTimeout(function(){
						colorInputBindTimeout = false;
					}, 100);
				}
			});
			jQuery("#select-custom-color .color-text").on("change", function(){
				let x = $(this).val();
				if(colorInputBindTimeout === false) {
					colorInputBindTimeout = true;
					jQuery("#select-custom-color input[name='c_theme_color']").val(x).change();
					window.setTimeout(function(){
						colorInputBindTimeout = false;
					}, 100);
				}
			});
			jQuery(".checkbox-custom").each(function(){
				$(this).on("click", function(){
					$(this).toggleClass('active');
				});
			});
			jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
				var parentCont = this;
			    jQuery(this).parent().on("click", function(){
			    	handleShowingOptions(this);
			    });
			    jQuery(this).find("li").on("click", function(){
			    	handleTheSelect(this, parentCont);
			    });
			});
			function closeAllOpenedSelectBoxes() {
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			}
			isCurrentElClicked(['.wp-repair-repair-card'], function(){
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			});
			window.canShowTheOptions = true;
			function canShowTheOptions() {
				if(window.canShowTheOptions === false) {
					window.canShowTheOptions = true;
					return false;
				}
				return true;
			}
			function isCurrentElClicked(el, func) {
				$("body").click(function(event) {
					result = false;
					el.forEach(function(ell){
						if(($(event.target).is(ell) || $(event.target).parents(ell).length !== 0)) {
							result = true;
						}
					});
					if(result === false) {
						func();
					}
				});
			}
			function handleShowingOptions(currentEl) {
				if(canShowTheOptions() === true) {
					jQuery(".wp-repair-repair-card").each(function(){
						if(this !== currentEl) {
							$(this).find(".more-card-options").hide();
						}
					});
					jQuery(currentEl).toggleClass('active');
					jQuery(currentEl).find(".more-card-options").toggle();
				}
			}
			function handleTheDeselect(currentEl, parentCont) {
				$(parentCont).parent().removeClass("active");
				$(parentCont).parent().find('.wp-repair-cselected-item i').remove();
				$(parentCont).parent().find('.wp-repair-cselected-item').append('<i class="fas fa-chevron-down"></i>');
				$(parentCont).parent().find('.text-all .selected-text').remove();
				$(parentCont).hide();
				$(parentCont).find("li").each(function(){
					$(this).removeClass("active");
				});
				window.canShowTheOptions = false;
			}
			function handleTheSelect(currentEl, parentCont) {
				var val = $(currentEl).find(".name").html();
				$(parentCont).parent().find('.wp-repair-cselected-item .name').html(val);
				var color_code = $(currentEl).find(".name .color-hex").html();
				$('.c_theme_color').val();
				$('.c_theme_color').val(color_code);
			}
		});
	}(window,document,jQuery));

	function readURL(input){
		jQuery("#img-input").val('');
		if(input.files && input.files[0]){
			var fi = input.files[0];
			var file_name = fi.name;
			jQuery("#img-input").val(file_name);
			var reader = new FileReader();
			reader.onload = function (e){
			//console.log(img);
			jQuery(".sec-2 .current_img").remove();
			jQuery(".sec-2 img").attr('src',e.target.result);
			}
			reader.readAsDataURL(input.files[0]);
		}
	}

	jQuery('.clear_img_input').on('click', function(){
		jQuery('#img-input').val('');
	});
</script>
<script type="text/javascript">
	  jQuery(".wp-general-info.save-settings").on('click', function(e){
			e.preventDefault();
			
			if(jQuery(this).hasClass("processing")) {
				return false;
			}

			let btn = this;

			jQuery(btn).addClass("processing");

			let c_name = jQuery("input[name='c_name']").val();
			let c_email = jQuery("input[name='c_email']").val();
			let c_phone = jQuery("input[name='c_phone']").val();
			let c_reg_no = jQuery("input[name='c_reg_no']").val();
			let tax_reg_no = jQuery("input[name='tax_reg_no']").val();
			let terms_and_conditions_page = jQuery("input[name='terms_and_conditions_page']").val();

			let loc_ids = [];
			let cs_ids = [];
			let cs_days = [];
			let cs_open_timings = [];
			let cs_close_timings = [];
			let cs_break_from_times = [];
			let cs_break_to_times = [];
			let cs_closed = [];
			jQuery('input[name^="location_id["]').each(function(){

				let loc_id = jQuery(this).val();

				loc_ids.push(jQuery(this).val());

				var cs_id =[];
				jQuery('input[id^=cs_id'+loc_id+']').each(function(){
					cs_id.push(jQuery(this).val());
				});
				cs_ids.push(cs_id);
				var cs_day =[];
				jQuery('input[id^=cs_day'+loc_id+']').each(function(){
					cs_day.push(jQuery(this).val());
				});
				cs_days.push(cs_day);
				var cs_open_timing =[];
				jQuery('input[id^=cs_open_timing'+loc_id+']').each(function(){
					cs_open_timing.push(jQuery(this).val());
				});
				cs_open_timings.push(cs_open_timing);
				var cs_close_timing =[];
				jQuery('input[id^=cs_close_timing'+loc_id+']').each(function(){
					cs_close_timing.push(jQuery(this).val());
				});
				cs_close_timings.push(cs_close_timing);
				var cs_breaktime_from =[];
				jQuery('input[id^=cs_breaktime_from'+loc_id+']').each(function(){
					cs_breaktime_from.push(jQuery(this).val());
				});
				cs_break_from_times.push(cs_breaktime_from);
				var cs_breaktime_to =[];
				jQuery('input[id^=cs_breaktime_to'+loc_id+']').each(function(){
					cs_breaktime_to.push(jQuery(this).val());
				});
				cs_break_to_times.push(cs_breaktime_to);
				var is_closed =[];
				jQuery('input[id^=is_closed'+loc_id+']').each(function(){
					is_closed.push(jQuery(this).is(':checked')); 
				});
				cs_closed.push(is_closed);

			});
			let location_names = [];
			jQuery('input[name^="location_name["]').each(function(){
				location_names.push(jQuery(this).val());
			});
			let location_addresses = [];
			jQuery('input[name^="location_address["]').each(function(){
				location_addresses.push(jQuery(this).val());
			});
			let location_cities = [];
			jQuery('input[name^="location_city["]').each(function(){
				location_cities.push(jQuery(this).val());
			});
			let google_maps_links = [];
			jQuery('input[name^="google_maps_link["]').each(function(){
				google_maps_links.push(jQuery(this).val());
			});
			let location_emails = [];
			jQuery('input[name^="location_email["]').each(function(){
				location_emails.push(jQuery(this).val());
			});

			let everyThingOkay = true;

			loc_ids.forEach(function(loc_id, index){

				let location_name = location_names[index];
				let location_address = location_addresses[index];
				let location_city = location_cities[index];
				let google_maps_link = google_maps_links[index];
				let location_email = location_emails[index];

				let cs_id = cs_ids[index];
				let cs_day = cs_days[index];
				let cs_open_timing = cs_open_timings[index];
				let cs_close_timing = cs_close_timings[index];
				let cs_breaktime_from = cs_break_from_times[index];
				let cs_breaktime_to = cs_break_to_times[index];
				let is_closed = cs_closed[index];

				let open_time_length = cs_open_timing.length;
				let close_time_length = cs_close_timing.length;

				if(loc_id != '' && location_name != '' && location_address != '' && location_city != '' && cs_id != '' && cs_day != '' && open_time_length == '7' && close_time_length == '7'){
					// Good to go!
				} else {
					everyThingOkay = false;
				}

			});

			if( everyThingOkay === false ) {
				jQuery(this).removeClass('processing');
				alert('Please add location detail and write open and close timings for all days.');
				return false;
			}

			var btndata = jQuery(btn).html();
			// btn width
			var btnwidth = jQuery(btn)[0].clientWidth;
			jQuery(btn).css({'width': btnwidth+'px', 'text-align': 'center'});
			jQuery(btn).html('Saving <i class="fas fa-spinner fa-spin"></i>');

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {
					action:'rp_update_general_info',
					terms_and_conditions_page: terms_and_conditions_page,
					loc_ids: loc_ids,
					location_names: location_names,
					location_addresses: location_addresses,
					location_cities: location_cities,
					google_maps_links: google_maps_links,
					location_emails: location_emails,
					cs_ids: cs_ids,
					cs_days: cs_days,
					cs_open_timings: cs_open_timings,
					cs_close_timings: cs_close_timings,
					cs_break_from_times: cs_break_from_times,
					cs_break_to_times: cs_break_to_times,
					cs_closed: cs_closed,
					c_name: c_name,
					c_email: c_email,
					c_phone: c_phone,
					c_reg_no: c_reg_no,
					tax_reg_no: tax_reg_no
				},
				success: function(data) {
					// success!
					window.location.reload(true);
				}
			});

			return false;

		});
	
  	jQuery(".update_location").click(function(){
			// this code is not in use after V1.5.0
			return false;
		var loc_id           = jQuery(this).data('id');
		var location_name    = jQuery("#location_name"+loc_id).val();
		var location_address = jQuery("#location_address"+loc_id).val();
		var location_city    = jQuery("#location_city"+loc_id).val();
		var google_maps_link    = jQuery("#google_maps_link"+loc_id).val();
		var location_email    = jQuery("#location_email"+loc_id).val();
		var cs_id =[];
	    jQuery('input[id^=cs_id'+loc_id+']').each(function(){
	      cs_id.push(jQuery(this).val());
	    });
		var cs_day =[];
	    jQuery('input[id^=cs_day'+loc_id+']').each(function(){
	      cs_day.push(jQuery(this).val());
	    });
		var cs_open_timing =[];
	    jQuery('input[id^=cs_open_timing'+loc_id+']').each(function(){
	      cs_open_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				open_time_length= cs_open_timing.length;
			}
	    });
		var cs_close_timing =[];
	    jQuery('input[id^=cs_close_timing'+loc_id+']').each(function(){
	      cs_close_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				close_time_length= cs_close_timing.length;
			}
	    });
		var cs_breaktime_from =[];
	    jQuery('input[id^=cs_breaktime_from'+loc_id+']').each(function(){
	      cs_breaktime_from.push(jQuery(this).val());
	    });
		var cs_breaktime_to =[];
	    jQuery('input[id^=cs_breaktime_to'+loc_id+']').each(function(){
	      cs_breaktime_to.push(jQuery(this).val());
	    });
		var is_closed =[];
	    jQuery('input[id^=is_closed'+loc_id+']').each(function(){
	      	is_closed.push(jQuery(this).is(':checked')); 
	    });
	    if(loc_id != '' && location_name != '' && location_address != '' && location_city != '' &&
			cs_id != '' && cs_day != '' && open_time_length > 0 && close_time_length > 0){
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'update_locations',location_name:location_name,location_address:location_address,location_city:location_city,google_maps_link:google_maps_link,location_email:location_email,cs_id:cs_id,cs_day:cs_day,cs_open_timing:cs_open_timing,cs_close_timing:cs_close_timing,cs_breaktime_from:cs_breaktime_from,cs_breaktime_to:cs_breaktime_to,is_closed:is_closed,loc_id:loc_id},
				success: function(data) {
		      		location.reload();
		      	}
			});
		}else{
			alert('Please add location detail and write open and close timings for all days.');
		}
	});
</script>
<script type="text/javascript">
  	jQuery(".add_location").click(function(){
		var loc_name    = jQuery(".loc_name").val();
		var loc_address = jQuery(".loc_address").val();
		var loc_address = jQuery(".loc_address").val();
		var loc_city    = jQuery(".loc_city").val();
		var loc_google_map    = jQuery(".loc_google_map").val();
		var loc_email    = jQuery(".loc_email").val();
		var open_time_length = 0;
		var close_time_length = 0;
		var cs_day =[];
	    jQuery('input[class^=csday]').each(function(){
	      cs_day.push(jQuery(this).val());
	    });
		var cs_open_timing =[];
	    jQuery('input[class^=csopen_timing]').each(function(){
	      cs_open_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				open_time_length= cs_open_timing.length;
			}
	    });
		var cs_close_timing =[];
	    jQuery('input[class^=csclose_timing]').each(function(){
	      cs_close_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				close_time_length= cs_close_timing.length;
			}
	    });
		var cs_breaktime_from =[];
	    jQuery('input[class^=csbreaktime_from]').each(function(){
	      cs_breaktime_from.push(jQuery(this).val());
	    });
		var cs_breaktime_to =[];
	    jQuery('input[class^=csbreaktime_to]').each(function(){
	      cs_breaktime_to.push(jQuery(this).val());
	    });
		var is_closed =[];
	    jQuery('.location-table.add-new input[class^=is_closed]').each(function(){
	      	is_closed.push(jQuery(this).is(':checked')); 
	    });
	    if(loc_name != '' && loc_address != '' && loc_city != '' && cs_day != '' && open_time_length > 0 && close_time_length > 0){
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'add_location',loc_name:loc_name,loc_google_map:loc_google_map,loc_email:loc_email,loc_address:loc_address,loc_city:loc_city,cs_day:cs_day,cs_open_timing:cs_open_timing,cs_close_timing:cs_close_timing,cs_breaktime_from:cs_breaktime_from,cs_breaktime_to:cs_breaktime_to,is_closed:is_closed},
				success: function(data) {
		      		location.reload();
		      	}
			});
		}else{
			alert('Please add location detail and write open and close timings for all days.');
		}
	});
</script>
<script type="text/javascript">
	jQuery(".delete_location").click(function(){
		if(confirm('Are you sure you want to delete this location?')) {
			var loc_id = jQuery(this).data("id");
			repairPluginUI.ajax({
	          	type:'POST',
	          	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		      	data: {action:'delete_location',loc_id:loc_id},
	      		success: function(data) {
		      		location.reload();
		      	}
		    });
		}
	});
	jQuery(document).on('input', '.days-setting-table input.has-breaktime-error', function(){
		jQuery(this).removeClass('has-breaktime-error');
	});
</script>
