<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}

global $rpQuery;
$localization = $rpQuery->prefix . "rs_localization";
$local_result = $rpQuery->get_results("SELECT * FROM $localization");
$local_result = rp_sanitize_output($local_result);
$local_id = $local_result[0]->localization_id;
//--------------------------------------------------------category
if (isset($_POST['update_local'])) {

	rp_verify_csrf_token_for_simple_form('localization');

    $set_language        = $_POST['set_language'] ?? '';
    $set_currency        = $_POST['set_currency'] ?? '';
    $set_price_symbols   = $_POST['set_price_symbols'] ?? '';
    $set_decimals        = $_POST["set_decimals"] ?? '';
    $show_decimals       = '0';
    $set_time_format     = $_POST['set_time_format'] ?? '';
    $is_applied_tax_rate = $_POST['is_applied_tax_rate'] ?? '';
    $show_even_price     = '0';
    $tax                 = $_POST['tax'] ?? '';
    $tax_indicator       = $_POST['tax_indicator'] ?? '';

	$c_options = rp_get_all_currencies();

	// array search $c_options
	$full_currency_name = $set_currency;

	$set_currency = $c_options[$set_currency] ?? '';

	if( empty( $set_currency ) ) {

		$selected_currency = rp_get_selected_currency();

		$full_currency_name = $selected_currency;

		$set_currency = $c_options[$selected_currency] ?? '';

	}

    $rp_enable_language_selector = $_POST['rp_enable_language_selector'] ?? '0';

    if( rp_get_option('rp_enable_language_selector', FALSE) === FALSE ) {

    	rp_add_option('rp_enable_language_selector', $rp_enable_language_selector);

    } else {

    	rp_update_option('rp_enable_language_selector', $rp_enable_language_selector);

    }

	if( rp_get_option('rp_set_price_symbol', FALSE) === FALSE ) {

    	rp_add_option('rp_set_price_symbol', $set_price_symbols);

    } else {

    	rp_update_option('rp_set_price_symbol', $set_price_symbols);

    }

	// Save Full Currency Name
	
	if( rp_get_option('rp_localization_selected_currency', FALSE) === FALSE ) {

		rp_add_option('rp_localization_selected_currency', $full_currency_name);

	} else {

		rp_update_option('rp_localization_selected_currency', $full_currency_name);

	}

	$set_price_symbols = '$ 10';

    $rpQuery->query("UPDATE `$localization` SET set_language = '".rp_escape_sql($set_language)."',set_currency = '".rp_escape_sql($set_currency)."',set_price_symbols = '".rp_escape_sql($set_price_symbols)."',set_decimals = '".rp_escape_sql($set_decimals)."',show_decimals = '".rp_escape_sql($show_decimals)."',set_time_format = '".rp_escape_sql($set_time_format)."',show_even_price = '".rp_escape_sql($show_even_price)."',tax = '".rp_escape_sql($tax)."',tax_indicator = '".rp_escape_sql($tax_indicator)."' WHERE localization_id = '".rp_escape_sql($local_id)."'");
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=localization');</script>";
}

$all_languages = rp_get_all_languages();

$rp_enabled_languages = rp_get_enabled_languages();

$is_enabled_language_selector = FALSE;

if( rp_get_option('rp_enable_language_selector', '1') === '1' ) {

	$is_enabled_language_selector = TRUE;

}

$all_languages = rp_sanitize_output($all_languages);

$rp_enabled_languages = rp_sanitize_output($rp_enabled_languages);

?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.wp-general-info{
		padding: 15px;
		font-size: 13px;
	}
	@media screen and (max-width: 768px) {
		.wp-repair-col-3 .main-section .section-two{
			margin-top: 0px;
			width: 100%;
		}
	}
	.wp-repair-col-3{
		margin-top: 70px;
		float: right;
	}
	label.language-label {
		margin-bottom: 8px;
		display: table;
	}
	label.language-label:nth-child(1) {
		margin-top: 5px;
	}
	label.language-label:nth-last-child(1) {
		margin-bottom: 0px;
	}
	.clearfix {
		clear: both;
	}
	.clearfix::after {
		content: "";
		display: table;
		clear: both;
	}
	.wp-repair-special-col {
		padding: 0px 5px;
		padding-top: 0px;
		padding-bottom: 30px;
	}
	.nmb-0 {
		margin-bottom: 0px;
	}
	@media(max-width: 1210px) {
		.wp-repair-col-3 {
			margin-top: 0px;
		}
		.wp-repair-col-4.main-section.section-two {
			top: 0px;
			padding-bottom: 0px;
		}
		.wp-repair-col-4.main-section {
			padding-bottom: 20px;
		}
		.wp-repair-col-3.main-section.section-two {
			float: left;
			margin-bottom: 30px;
			padding: 0px 20px;
		}
	} 
	@media(max-width: 1000px) {
		.wp-repair-special-col,
		.wp-repair-col-3.main-section.section-two {
			padding-left: 30px;
			padding-right: 30px;
		}
	}
	@media(max-width: 480px) {
		.wp-repair-special-col,
		.wp-repair-col-3.main-section.section-two {
			padding-left: 20px;
			padding-right: 20px;
		}
	}
	@media(max-width: 424px) {
		.wp-repair-special-col,
		.wp-repair-col-3.main-section.section-two {
			padding-left: 15px;
			padding-right: 15px;
		}
	}
</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('localization'); ?>
					<form method="post" action="">
						<?php
						rp_csrf_token_input_field('localization');
						?>
						<div class="bg-with-border">
							<div class="wp-repair-col-4 main-section">
								<div class="wp-repair-main-section-heading">
									<h2>
										<span class="bold">Regional</span>
										<span class="light">Settings</span>
									</h2>
									<p class="more-info">Make sure your visitors see familiar language</p>
								</div>
								<div class="space-fixer"></div>
								<p class="company-logo-theme-color">Set Currency</p>
								<span class="wp-repair-repair-card">
									<select class="coupons_select" name="set_currency" required>
										<?php
										$selected_currency = rp_get_selected_currency();
										$c_options = rp_get_all_currencies();
										foreach($c_options as $c_opt => $symbol) {
											$selected_text = '';
											if( $c_opt === $selected_currency ) {
												$selected_text = 'selected="selected"';
											}
											?>
											<option <?php echo $selected_text; ?> value="<?php echo $c_opt; ?>"><?php echo $c_opt; ?></option>
											<?php
										}
										?>
									</select>
								</span>
								<p class="company-logo-theme-color">Currency Symbol Position</p>
								<span class="wp-repair-repair-card">
									<select class="coupons_select" name="set_price_symbols" required>
										<?php
										$options = array(
											'left' => 'Left ($10)',
											'right' => 'Right (10$)'
										);
										$selected_symbol_position = rp_get_option('rp_set_price_symbol', 'left');
										foreach($options as $opt => $text) {
											$selected_text = '';
											if( $opt === $selected_symbol_position ) {
												$selected_text = 'selected="selected"';
											}
											?>
											<option <?php echo $selected_text; ?> value="<?php echo $opt; ?>"><?php echo $text; ?></option>
											<?php
										}
										?>
									</select>
								</span>
								<!-- <div class="wp-repair-price-decimals"> -->
									<p class="company-logo-theme-color">Decimal Separator</p>
									<span class="wp-repair-repair-card">
										<select class="coupons_select" name="set_decimals" required>
											<!-- <option value="<?php //echo $local_result[0]->set_decimals?>" hidden><?php //if($local_result[0]->set_decimals == '1'){echo "1 (19,9)";}else if($local_result[0]->set_decimals == '2'){echo "2 (19,95)";}else{echo "3 (19,955)";}?></option>
											<option value="1"> 1 (19,9)</option>
											<option value="2"> 2 (19,95)</option>
											<option value="3"> 3 (19,955)</option> -->
											<option value="<?php echo $local_result[0]->set_decimals?>" hidden><?php if($local_result[0]->set_decimals == 'comma'){echo "Comma (19,95)";}else{echo "Point (19.95)";}?></option>
											<option value="comma">Comma (19,95)</option>
											<option value="point">Point (19.95)</option>
										</select>
									</span>
								<!-- </div> -->
								<p class="company-logo-theme-color">Set Time Format</p>
								<span class="wp-repair-repair-card nmb-0">
									<select class="coupons_select" name="set_time_format" required>
										<option value="<?php echo $local_result[0]->set_time_format?>" hidden><?php echo $local_result[0]->set_time_format?></option>
										<option value="24 hours (e.g. 15:00)"> 24 hours (e.g. 15:00)</option>
										<option value="12 hours (e.g. 3:00 PM)"> 12 hours (e.g. 3:00 PM)</option>
									</select>
								</span>
							</div>
							<div class="wp-repair-col-4 main-section section-two">
								<div class="wp-repair-main-section-heading">
									<h2>
										<span class="bold">Tax</span>
										<span class="light">Rules</span>
									</h2>
									<p class="more-info">Main location will be displayed on PDF offers</p>
								</div>
<!-- 								<div class="space-fixer"></div>
								<div class="tax-fields">
									<div class="apply-tax-rate" style="display:flex">
										<label class="switch" style="float:left">
										  <input type="hidden" disabled name="show_even_price" id="show_even_price">
										  <span class="slider round"></span>
										</label>
										<span class="text" style="float:right"><b>Dont show even prices</b></br>(19,- instead of 19,00)</span>
									</div>
									<div class="space-fixer"></div>
									<div class="apply-tax-rate" style="padding-top:10px">
										<label class="switch">
										  <input type="hidden" disabled name="show_decimals" id="show_decimals">
										  <span class="slider round"></span>
										</label>
										<span class="text"><b>Show decimals</b></span>
									</div>
								</div> -->
								<div class="wp-repair-total-price" style="margin: 10px 0px 20px 0px">
									<p class="company-logo-theme-color">Tax (in percentage)</p>
									<div class="number-input">
										<div class="group">
											<input step="any" min="0" value="<?php echo $local_result[0]->tax?>" max="100" type="number" name="tax" required>
											<span class="icon-percent">%</span>
										</div>
										<button type="button" class="up"><i class="fas fa-chevron-up"></i></button>
										<button type="button" class="down"><i class="fas fa-chevron-down"></i></button>
									</div>
								</div>
							</div>
						<div class="wp-repair-col-4 main-section clearfix">
							<div class="wp-repair-main-section-heading">
									<h2>
										<span class="light">Setup</span>
										<span class="bold">Translations</span>
									</h2>
									<p class="more-info">Choose which translations you want to show</p>
								</div>
								<p class="company-logo-theme-color">Default Language</p>
								<span class="wp-repair-repair-card">
									<select class="coupons_select" name="set_language" required>
										<?php
										foreach ($all_languages as $row) {
											$lang_name = $row->name;
											if($local_result[0]->set_language === $lang_name) {
												?>
												<option data-thumbnail="<?php echo WP_REPAIR_PLUGIN_URL . $row->image; ?>" value="<?php echo $lang_name; ?>" selected="selected"><?php echo $lang_name; ?></option>
												<?php
											} else {
												?>
												<option data-thumbnail="<?php echo WP_REPAIR_PLUGIN_URL . $row->image; ?>" value="<?php echo $lang_name; ?>"><?php echo $lang_name; ?></option>
												<?php
											}
										}
										?>
									</select>	
								</span>
								<div class="tax-fields first">
									<div class="apply-tax-rate">
										<div class="td select">
											<label class="switch">
											  <input type="checkbox" name="rp_enable_language_selector" value="1" <?php if( $is_enabled_language_selector === TRUE ) { echo 'checked="checked"'; } ?>>
											  <span class="slider round"></span>
											</label>
										</div>
										<div class="td text">
											<span class="text">Enable Language Selector <br>on Front-End</span>
										</div>
									</div>
								</div>
								
							</div>
							<div class="wp-repair-col-3 main-section section-two">
								<div class="sec-3">
									<button type="submit" name="update_local" class="wp-general-info">Save All Settings</button>
								</div>
							</div>
							<div class="wp-repair-special-col clearfix">
								<?php
								require_once WP_REPAIR_PLUGIN_PATH . 'html/localization-languages.php';
								?>
								<div class="wp-repair_page_wp_repair_globalization">
									<a href="?page=wp_repair_download_libraries" class="add-repair-btn download-languages-pack" style="margin-right: 5px">Download Language Pack</a>
								</div>
							</div>
						</div>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>
<script type="text/javascript">
	(function(window,document,$,undefined){
		window.wpRepairInputMouseIsDown = false;
		window.currentTimeoutCache;


		$(document).on('mousedown mouseup', function(){
			if('wpRepairInputMouseIsDown_UP_BUTTON' in window && window.wpRepairInputMouseIsDown_UP_BUTTON && window.wpRepairInputMouseIsDown_UP_BUTTON !== null) {
				stopIncreasingTheNumber($(window.wpRepairInputMouseIsDown_UP_BUTTON).parent());
				window.wpRepairInputMouseIsDown_UP_BUTTON = null;
			}
			if('wpRepairInputMouseIsDown_DOWN_BUTTON' in window && window.wpRepairInputMouseIsDown_DOWN_BUTTON && window.wpRepairInputMouseIsDown_DOWN_BUTTON !== null) {
				stopIncreasingTheNumber($(window.wpRepairInputMouseIsDown_DOWN_BUTTON).parent());
				window.wpRepairInputMouseIsDown_DOWN_BUTTON = null;
			}
		});

		$(document).on("wpRepairReady", function(){

			$(".number-input").each(function(){
				$(this).find("button.up, button.down").on('click',function(e){
					e.preventDefault();
				});
			});

			$(".number-input").each(function(){
				$(this).find("button.up").on("mousedown touchstart", function(){
					let button_up = $(this);
					var numInput = $(this).parent();
					window.wpRepairInputMouseIsDown = true;
					window.currentTimeoutCache = window.setTimeout(function(){
						if(window.wpRepairInputMouseIsDown === true) {
							window.wpRepairInputMouseIsDown_UP_BUTTON = button_up;
							keepIncreasingTheNumber(numInput);
						}
					},200);
				});
				$(this).find("button.up").on("mouseup touchend", function(){
					stopIncreasingTheNumber($(this).parent());
				});
			});
			$(".number-input").each(function(){
				$(this).find("button.down").on("mousedown touchstart", function(){
					let button_down = $(this);
					var numInput = $(this).parent();
					window.wpRepairInputMouseIsDown = true;
					window.currentTimeoutCache = window.setTimeout(function(){
						if(window.wpRepairInputMouseIsDown === true) {
							window.wpRepairInputMouseIsDown_DOWN_BUTTON = button_down;
							keepDecreasingTheNumber(numInput);
						}
					},200);
				});
				$(this).find("button.down").on("mouseup touchend", function(){
					stopDecreasingTheNumber($(this).parent());
				});
			});
		});
		function stopIncreasingTheNumber(el) {
			incrementNumNow(el);
			window.clearTimeout(window.currentTimeoutCache);
			window.wpRepairInputMouseIsDown = false;
		}
		function stopDecreasingTheNumber(el) {
			DeIncrementNumNow(el);
			window.clearTimeout(window.currentTimeoutCache);
			window.wpRepairInputMouseIsDown = false;
		}
		function keepDecreasingTheNumber(el) {
			window.setTimeout(function(){
				if(window.wpRepairInputMouseIsDown === true) {
					DeIncrementNumNow(el);
					keepDecreasingTheNumber(el);
				}
			}, 120);
		}
		function keepIncreasingTheNumber(el) {
			window.setTimeout(function(){
				if(window.wpRepairInputMouseIsDown === true) {
					incrementNumNow(el);
					keepIncreasingTheNumber(el);
				}
			}, 120);
		}
		function DeIncrementNumNow(el) {
			var currentVal = $(el).find("input").val();
			if(!isNaN(parseFloat(currentVal))) {
				currentVal = parseFloat(currentVal);
			} else {
				currentVal = 0;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			currentVal = parseFloat(currentVal);
			currentVal = currentVal-1;
			if(currentVal > 100) {
				currentVal = 100;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			$(el).find("input").val(currentVal).change();
		}
		function incrementNumNow(el) {
			var currentVal = $(el).find("input").val();
			if(!isNaN(parseFloat(currentVal))) {
				currentVal = parseFloat(currentVal);
			} else {
				currentVal = 0;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			currentVal = parseFloat(currentVal);
			currentVal = currentVal+1;
			if(currentVal > 100) {
				currentVal = 100;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			$(el).find("input").val(currentVal).change();
		}
	}(window,document,jQuery));
</script>
<script type="text/javascript">

			window.rp_default_language_id = parseFloat('<?php echo rp_get_default_language_id(); ?>');

			function uniqid(){
			  return Math.random().toString(16).slice(2)+(new Date()).getTime()+Math.random().toString(16).slice(2);
			}

			function ucwords (str) {
				return str.toUpperCase();
			    return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
			        return $1.toUpperCase();
			    });
			}

			function add_model_repair_tr(m_id, r_id, r_img, repair_title, repair_info, is_active) {
				if(is_active === '1') {
					is_active = 'checked="checked"';
				} else {
					is_active = '';
				}

				let tr = `
					<tr class="justForsort Orderingrepairs adding-model-repair-tr">
						<td class="justForsort" colspan="7">
							<table class="justForsort">
								<tbody class="justForsort">
									<tr class="main-repair">
										<td style="width: 105px;">
											<label class="switch">
											<input type="checkbox" ${is_active} tabindex="-1" name="is_active[]" id="is_active${m_id}" value="${r_id}">
											<span class="slider round"></span>
											</label>
											<span class="repair-list-sort ui-sortable-handle">
											<i class="fas fa-caret-up" data-which="up"></i>
											<i class="fas fa-caret-down" data-which="down"></i>
											</span>
											<input type="hidden" name="rid[]" id="repair-id${m_id}" value="${r_id}">
											<input type="hidden" name="r_img_link" value="${r_img}">
											<div class="img-repair-show">
											<img src="${r_img}">
											</div>
										</td>
										<td style="width: 200px;"><input tabindex="-1" class="repair-title" placeholder="Language Title" id="repair-title${m_id}" type="text" name="lname[]" value="${repair_title}" required=""></td>
										<td style="width: 200px;"><input tabindex="-1" class="repair-info" placeholder="Alternative Name" id="repair-info${m_id}" type="text" name="laltname[]" value="${repair_info}" required=""></td>
										<td style="width: 55px;" class="additional-actions">
											<button type="button" data-rid="${r_id}" class="trash delete_repair" tabindex="-1">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
											</button>
											<label tabindex="-1" class="label-upload-image" for="upload_rimage_${r_id}"><img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/image.svg"></label>
											<input tabindex="-1" type="file" id="upload_rimage_${r_id}" style="display: none;" name="r_img_X" data-uimage-id="${r_id}">
										</td>
									</tr>
								</tbody>
							</table>
						</td>
					</tr>
				`;
				return tr;
			}

			window.model_repair_tr = `
				<tr class="justForsort Orderingrepairs uibyzahran-remove-tr uibyzahran-transition unsaved">
					<td class="justForsort" colspan="7">
						<table class="justForsort">
							<tbody class="justForsort">
								<tr class="main-repair">
									<td style="width: 105px;">
										<label class="switch">
										<input type="checkbox" checked="" tabindex="-1" name="is_active[]" value="NEW">
										<span class="slider round"></span>
										</label>
										<span class="repair-list-sort ui-sortable-handle">
										<i class="fas fa-caret-up" data-which="up"></i>
										<i class="fas fa-caret-down" data-which="down"></i>
										</span>
										<input type="hidden" name="rid[]" value="NEW">
										<input type="hidden" name="r_img_link">
										<div class="img-repair-show">
										<img src="">
										</div>
									</td>
									<td style="width: 200px;"><input class="repair-title" placeholder="Language Title" type="text" name="lname[]" value="" required=""></td>
									<td style="width: 200px;"><input class="repair-info" placeholder="Alternative Name" type="text" name="laltname[]" value="" required=""></td>
									<td style="width: 55px;" class="additional-actions">
										<button type="button" data-rid="NEW" class="trash delete_repair" tabindex="-1">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
										</button>
										<label tabindex="-1" class="label-upload-image" for="upload_rimage_{uqid}">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/image.svg">
										</label> 
										<input tabindex="-1" type="file" id="upload_rimage_{uqid}" style="display: none;" name="r_img_X" data-uimage-id="NEW">
									</td>
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
			`;

			jQuery(document).on("click", ".add-repair-btn.AddRepair", function(){
				let parentEl = repairPluginUI.find_parent_by_class(this, 'details-container');
				jQuery(parentEl).find('.repairsContainer tbody.the-additional-repair').append(window.model_repair_tr.replace(/\{uqid\}/gi, uniqid()));
				updateUnsavedManageRepairButton();
				window.setTimeout(function(){
					let firstInput = jQuery('.Orderingrepairs.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".Orderingrepairs.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
					window.setTimeout(function(){
						jQuery(".Orderingrepairs.uibyzahran-transition").removeClass('uibyzahran-transition');
					},500);
				},1);
			});

			jQuery(document).on("wpRepairReady", function(){
				var total_count  = jQuery('.total_count').val();
		//console.log(total_count)
		for (let i = 1; i <= total_count; i++) {
			jQuery('.m_shortcode'+i).on('click', function(){
				var copyText = document.getElementById("mInput"+i);
				copyText.select();
				copyText.setSelectionRange(0, 99999); /* For mobile devices */
				navigator.clipboard.writeText(copyText.value);
				alert("Copied To Clipboard: " + copyText.value);
			});
		}
		//--------------------------------------------------- delete all repairs related model

		jQuery(document).on('click', 'label.switch input[name^="is_active["]', function(){

			let parent = jQuery(this).parents('tr.main-repair');

			let rid = jQuery(parent).find('button.trash.delete_repair').data("rid");

			if( parseFloat(rid) === window.rp_default_language_id ) {

				alert('Sorry, you cannot deactivate default language.');

				jQuery(this).prop('checked', true);

			}

		});

		jQuery(document).on('click', '.delete_repair', function(){
			var rid = jQuery(this).data("rid");

			if( parseFloat(rid) === window.rp_default_language_id ) {

				alert('Sorry, you cannot delete default language.');
				return;

			}


			if (confirm('Are you sure you want to delete this language?')) {

				if(rid === 'NEW') {

					let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
					repairPluginUI.removeTableRow(parentEl, function(){
						updateUnsavedManageRepairButton();
					});

					return;
				}

				if(jQuery(this).hasClass("processing")) {
					return;
				}
				let btn = this;

				var btndata = jQuery(btn).html();
				jQuery(btn).html('<i style="font-size: 20px; position: relative; top: 1px;" class="fas fa-spinner fa-spin"></i>');

				jQuery(btn).addClass("processing");
				//console.log(rid)
				repairPluginUI.ajax({
					type:'POST',
					url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {action:'rp_delete_language',rid:rid},
					success: function(data) {

						jQuery("#rp_processing_pending_jobs").show();
						window.setTimeout(function(){
							if( 'repeatablePendingJobsProcessingAR' in window && window.repeatablePendingJobsProcessingAR === false ) {
								window._repeatablePendingJobsProcessing();
							}
						}, window._getNextSafeSchedule(1));

						jQuery(btn).html(btndata);
						let parentEl = repairPluginUI.find_parent_by_class(btn, 'Orderingrepairs');
						repairPluginUI.removeTableRow(parentEl, function(){
							updateUnsavedManageRepairButton();
						});

						repairPluginUI.alert_success('Selected language successfully deleted.');
						jQuery(btn).removeClass("processing");

					},
					error: function() {
						jQuery(btn).html(btndata);
						if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
						jQuery(btn).removeClass("processing");
					}
				});
			}
		});
		//--------------------------------------------------- update repair
		jQuery(document).on('click', '.update_repair', function() {
			if(jQuery(this).hasClass("processing")) {
				return;
			}
			jQuery(this).addClass("processing");
			var btn = this;
			var btndata = jQuery(btn).html();
			jQuery(btn).html('<i style="font-size: 13px; position: relative; top: -1px;" class="fas fa-spinner fa-spin"></i>');

			let parentEl = repairPluginUI.find_parent_by_class(this, 'details-container');

			var mid    = jQuery(this).data("mid");
			var rid = [];
			var raid = [];
			var raname = [];
			var raprice = [];

			jQuery(parentEl).find('input[name^="rid["]').each(function(){
				rid.push(jQuery(this).val());
			});
			var img_link = [];
			jQuery(parentEl).find('input[name^="r_img_link"]').each(function(){
				img_link.push(jQuery(this).val());
			});
			var l_name = [];
			jQuery(parentEl).find('input[name^="lname["]').each(function(){
				l_name.push(jQuery(this).val());
			});
			var alt_name = [];
			jQuery(parentEl).find('input[name^="laltname["]').each(function(){
				alt_name.push(jQuery(this).val());
			});
			var status = [];
			jQuery(parentEl).find('input[name^="is_active["]').each(function(){
				if(jQuery(this).is(':checked')) {
					status.push(jQuery(this).val());
				} else {
					status.push(null);
				}
			});
    		repairPluginUI.ajax({
    			type:'POST',
    			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
    			data: {action:'rp_update_languages',mid:mid,rid:rid,img_link:img_link,l_name:l_name,alt_name:alt_name,status:status},
    			success: function(data) {
    						try {
    							data = JSON.parse(data);
    						} catch (e) {

    						}
    						if(data && data.table_rows && data.table_rows.length > 0) {

    							let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
    							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
    							updateUnsavedManageRepairButton();
    							data.table_rows.forEach(function(val, i){
    								let getTr = add_model_repair_tr(val.m_id, val.r_id, val.r_img, val.repair_title, val.repair_info, val.is_active);

    								jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(getTr);
    								let OrderingrepairsCont = jQuery(repairsContainer).find('.Orderingrepairs.adding-model-repair-tr');
    								OrderingrepairsCont.removeClass('adding-model-repair-tr');
    							});

    						} else {
    							let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
    							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
    							updateUnsavedManageRepairButton();
    						}


          			jQuery(btn).html(btndata);
          			repairPluginUI.alert_success('All languages successfully updated.');
          			jQuery(btn).removeClass("processing");
          		},
          		error: function() {
          			jQuery(btn).html(btndata);
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
          			jQuery(btn).removeClass("processing");
          		}
          	});
    	});
	});
</script>

<script type="text/javascript">
	function readURL(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'" height="100">');
		}
		reader.readAsDataURL(input.files[0]);
	}
}
</script>

<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){
		if(e.which == 13){
			e.preventDefault();
			jQuery("#saverOrder").click();
		}
	});
</script>
<script type="text/javascript">
	jQuery("#fastDelete").on("click", function(){
		if(jQuery(this).hasClass('active')) {
			jQuery(this).removeClass('active');
			jQuery(this).html('Confirm Delete (OFF)');
		} else {
			jQuery(this).addClass('active');
			jQuery(this).html('Confirm Delete (ON)');
		}
	});
	function moveUp(item) {
	    var prev = item.prev();
	    if (prev.length == 0)
	        return;
	    prev.css('z-index', 999).css('position','relative').animate({ top: item.height() }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: '-' + prev.height() }, 300, function () {
	        prev.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
	        item.insertBefore(prev);
	    });
	}
	function moveDown(item) {
	    var next = item.next();
	    if (next.length == 0)
	        return;
	    next.css('z-index', 999).css('position', 'relative').animate({ top: '-' + item.height() }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: next.height() }, 300, function () {
	        next.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
	        item.insertAfter(next);
	    });
	}
	jQuery(".repairsContainer").each(function(){
		jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, items: ".Orderingrepairs", distance: 5, handle: ".main-repair .repair-list-sort" });
	});
	jQuery(document).on('click', '.Orderingrepairs .main-repair .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.Orderingrepairs'));
	    else
	        moveDown(btn.parents('.Orderingrepairs'));

	    jQuery(btn).parents('.repairsContainer').find('.main-repair .repair-list-sort').addClass('unsaved');
	    updateUnsavedManageRepairButton();
	});
	jQuery(".repairsAttrContainer").each(function(){
		jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
	});
	jQuery(document).on('click', '.OrderingrepairsAttr .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.OrderingrepairsAttr'));
	    else
	        moveDown(btn.parents('.OrderingrepairsAttr'));

	    jQuery(btn).parents('.repairsAttrContainer').find('tr.OrderingrepairsAttr .repair-list-sort').addClass('unsaved');
	    updateUnsavedManageRepairButton();
	});
		jQuery(document).on("change", "input[name='r_img_X']", function(){
			if(jQuery(this).hasClass("processing")) {
				return;
			}
			let btn = this;

			jQuery(btn).addClass("processing");

			let currentInput = this;

			var rid = jQuery(currentInput).data('uimage-id');
			var file_data = jQuery(currentInput).prop('files');
			if(file_data.length > 0) {
				file_data = file_data[0];
			} else {
				file_data = null;
			}
	    var form_data = new FormData();
	    if(file_data) {
	    	form_data.append('file', file_data);
	    }

	    form_data.append('action', 'rp_update_language_image');
	 		form_data.append('rid', rid);

	 		if(file_data) {
				repairPluginUI.ajax({
	          type:'POST',
	          url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
	          dataType: 'text', // what to expect back from the server
	          cache: false,
	          contentType: false,
	          processData: false,
	          data: form_data,
	          success: function (response) {
	          		readURLZD(jQuery(currentInput)[0]);

	          		if(rid !== 'NEW') {
	          			repairPluginUI.alert_success('Language image successfully updated.');
	          		}
	          		jQuery(btn).removeClass("processing");

	          		try {
	          			response = JSON.parse(response);
	          		} catch (e) {

	          		}
	          		if(response && response.logo) {
	          			let mainRepairTr = repairPluginUI.find_parent_by_class(btn, 'main-repair');
	          			jQuery(mainRepairTr).find('input[name^="r_img_link"]').val(response.logo).change();
	          		}
	          },
	          error: function(response) {
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
	          	jQuery(btn).removeClass("processing");
	          }
	      });
	 		}
		});

	function readURLZD(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(input).parent().parent().parent().find(".img-repair-show img").attr('src', e.target.result);

			jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(2.5)', 'z-index': '1000'});

			window.setTimeout(function(){
				jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(1)'});
				window.setTimeout(function(){
					jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(2.5)', 'z-index': '1000'});
					window.setTimeout(function(){
						jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(1)', 'z-index': '1'});
					},300);
				},300);
			},300);
		}
		reader.readAsDataURL(input.files[0]);
	}
}
function trackUnsavedChanges() {
	jQuery(document).on('change', 'tbody.append_models tr.main-repair input[type="text"]', function(){
		jQuery(this).parents('tr.main-repair').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
	jQuery(document).on('change', 'tbody.append_models tr.main-repair select', function(){
		jQuery(this).parents('tr.main-repair').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
	jQuery(document).on('change', 'tbody.append_models tr.sub-repairs-details input[type="text"]', function(){
		jQuery(this).parents('tr.sub-repairs-details').addClass('unsaved');
		updateUnsavedManageRepairButton();
	});
	
}

trackUnsavedChanges();
window.saveChangesText = 'Save Changes (X)';
function updateUnsavedManageRepairButton() {
	let totalUnsaved = 0;
	jQuery("tr.Orderingrepairs").each(function(){
		if(jQuery(this).find('tr.unsaved').length > 0 || jQuery(this).find('.main-repair .repair-list-sort.unsaved').length > 0 || jQuery(this).find('.sub-repairs-details .repair-list-sort.unsaved').length > 0) {
			totalUnsaved++;
			jQuery(this).find('button.see-more.plus-icon').addClass('unsaved');
		} else {
			jQuery(this).find('button.see-more.plus-icon').removeClass('unsaved');
		}
	});
	if(totalUnsaved > 0) {
		jQuery("#saveChanges").html(window.saveChangesText.replace('(X)', '('+totalUnsaved+')')).removeClass('hide');
	} else {
		window.saveChangesText = 'Save Changes (X)';
		jQuery("#saveChanges").html(window.saveChangesText.replace('(X)', '(0)')).addClass('hide');
	}
}
function sortingHasUpdated(e,ui) {
	if(jQuery(ui.item[0]).hasClass('OrderingrepairsAttr')) {
		jQuery(ui.item[0]).parents('.repairsAttrContainer').find('tr.OrderingrepairsAttr .repair-list-sort').addClass('unsaved');
		updateUnsavedManageRepairButton();
	} else {
		jQuery(ui.item[0]).parents('.repairsContainer').find('tr.Orderingrepairs .main-repair .repair-list-sort').addClass('unsaved');
		updateUnsavedManageRepairButton();
	}
}

jQuery(".sorting_not_working").on('click', function(e){
	e.preventDefault();
	jQuery(".reset-sort-order ul").toggle();
});

(function($){
	function showFullWidthModal(content = '') {
		$(".va-full-width-modal").remove();
		let html = `
			<div class="va-full-width-modal">
				<div class="va-full-width-modal-main">
					<div class="va-full-width-modal-inner">
						${content}
					</div>
					<button class="va-button va-button-default va-close-modal">
						<i class="fas fa-times"></i>
					</button>
				</div>
			</div>
		`;
		$("body").append(html);
		$(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
		$(".va-full-width-modal .va-close-modal").on("click", function(){
			$(this).parent().animate({'top': '-50%'}, 400, function(){
				$(this).parent().remove();
			});
		});
		$(document).on("mouseup", handOutsideClick);
		// $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
	}
	function handOutsideClick(e) {
		var container = $('.va-full-width-modal-main');
		// if the target of the click isn't the container nor a descendant of the container
		if (!container.is(e.target) && container.has(e.target).length === 0) 
		{
		    container.find(".va-close-modal").click();
		    $(document).off("mouseup", handOutsideClick);
		}
	}

}(jQuery));

</script>
