<?php
// Exit if accessed directly

defined( 'ABSPATH' ) || exit;

if(!function_exists('wpRepairGetStyleSheetURLOfrepairTooltipster')) {
	function wpRepairGetStyleSheetURLOfrepairTooltipster() {
		$fileName = WP_REPAIR_PLUGIN_URL.'assets/css/front_end/tooltipster.css?id='.WP_REPAIR_ASSETS_CACHE_V;
		$fileName = str_replace(array('/', '\\'), '/', $fileName);
		return $fileName;
	}
}
if(!function_exists('wpRepairGetJsURLOfrepairTooltipster')) {
	function wpRepairGetJsURLOfrepairTooltipster() {
		$fileName = WP_REPAIR_PLUGIN_URL.'assets/js/jquery.tooltipster.js?id='.WP_REPAIR_ASSETS_CACHE_V;
		$fileName = str_replace(array('/', '\\'), '/', $fileName);
		return $fileName;
	}
}

global $rpQuery;

$rs_planning_and_discount = $rpQuery->prefix . "rs_planning_and_discount";

$planning_discount = $rpQuery->get_results("SELECT * FROM $rs_planning_and_discount");

$time_slots = $planning_discount[0]->booking_slots_length;

$time_slots = str_replace(strtolower(' Minutes (Default)'), '', strtolower($time_slots));

$time_slots = trim(str_replace('minutes', '', strtolower($time_slots)));

$time_slots = (int) $time_slots; // 30

// get all times between 12:00 AM and 11:30 PM
$all_times = array();
$startTime = strtotime('12:00 AM');
$endTime = strtotime('11:59 AM');
$addMins = $time_slots * 60;

while ($startTime < $endTime) {
	$all_times[] = date('h:i', $startTime);
	$startTime += $addMins;
}

$all_times = array_unique($all_times);

$all_times = array_values($all_times);

function rppagination( $current_page = 1, $last_page = 1 ) {

    if( $last_page < 2 ) {

        return '';

    }

    // 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
    $links = array();

    while( $last_page > 0 ) {

        $links[] = $last_page;

        $last_page--;

    }

    $links = array_reverse( $links );

    $html = '<div class="rp-pagination">';

    $html .= '<ul>';

    foreach( $links as $link ) {

        $html .= '<li><a class="' . ( $current_page == $link ? 'active' : '' ) . '" href="?page=wp_repair_settings&section=enhanced_locations&current_page=' . $link . '">' . $link . '</a></li>';

    }

    $html .= '</ul>';

    $html .= '</div>';

    return $html;

}

$current_page = (int) ($_GET['current_page'] ?? 1);

if( $current_page < 1 ) {

    $current_page = 1;

}

$limit = 10;

$total_schedule_groups = rp_get_total_schedule_groups();

if( $total_schedule_groups > 0 ) {

    // last page

    $last_page = ceil( $total_schedule_groups / $limit );

    if( $current_page > $last_page ) {

        $current_page = $last_page;

    }

    $schedule_groups = rp_get_all_schedule_groups( $current_page, $limit );

    $schedule_groups = rp_sanitize_output( $schedule_groups );

    // showing 1 to 10 of 19 entries

    $showing_from = ( $current_page - 1 ) * $limit + 1;

    $showing_to = $current_page * $limit;

    if( $showing_to > $total_schedule_groups ) {

        $showing_to = $total_schedule_groups;

    }

    $showing_entries = "Showing $showing_from to $showing_to of $total_schedule_groups entries";

    $rppagination = rppagination( $current_page, $last_page );

} else {

    $schedule_groups = array();

    $showing_entries = "";

    $rppagination = "";

}

?>
<style>
    .table-action-btn {
        display: inline-table;
        margin-right: 3px;
        padding: 4px 10px;
        font-size: 12px;
        border: unset;
        box-shadow: 0px 0px 2px rgba(0,0,0,0.2);
        outline: 0;
        border-radius: 5px;
        cursor: pointer;
    }
    .table-action-btn.btn-create-new {
        background: #1275c2;
        color: #fff;
        font-weight: 600;
        text-transform: uppercase;
        cursor: pointer;
        border-radius: 5px;
        padding: 6px 10px;
        font-size: 11.5px;
        letter-spacing: 1px;
    }
    .table-action-btn.btn-primary {
        background-color: #008ce4;
        color: #fff;
    }
    .table-action-btn.btn-primary:hover {
        background-color: #0077b3;
        color: #fff;
    }
    .table-action-btn.btn-dark {
        background-color: #343a40;
        color: #fff;
    }
    .table-action-btn.btn-dark:hover {
        background-color: #23272b;
        color: #fff;
    }
    .table-action-btn.btn-light {
        background-color: #efefef;
        color: #212529;
    }
    .table-action-btn.btn-light:hover {
        background-color: #e2e2e2;
        color: #212529;
    }
    .table-action-btn.btn-danger {
        background-color: #dc3545;
        color: #fff;
    }
    .table-action-btn.btn-danger:hover {
        background-color: #c82333;
        color: #fff;
    }
    .rp-pagination ul {
        list-style: none;
        padding: 0;
        margin: 0;
    }
    .rp-pagination ul li {
        display: inline-block;
        margin-right: 5px;
    }
    .rp-pagination ul li a {
        display: inline-table;
    padding: 5px 10px;
    width: 35px;
    box-sizing: border-box;
    border: 1px solid #eee;
    text-decoration: none;
    color: #333;
    box-shadow: unset;
    outline: 0;
    border-radius: 5px;
    background-color: #eee;
    text-align: center;
    }
    .rp-pagination ul li a.active {
        background-color: #0077c2;
        color: #fff;
    }
    table {
        width: 100%;
    }
    table tr th,
    table tr td {
        padding: 5px 5px 5px 5px;
        text-align: left;
        border-bottom: 1px dashed #eee;
    }
    .va-full-width-modal *:not(i) {
        font-family: 'Montserrat', sans-serif;
    }
    .va-full-width-modal .wp-repair-repair-card {
        width: 100%;
        max-width: 100%;
        margin-bottom: 0px !important;
    }
    .va-full-width-modal .wp-repair-repair-card select {
        width: 100%;
        font-size: 13px;
        max-width: 100%;
        font-weight: 400 !important;
        border-radius: 8px !important;
    }
    .va-full-width-modal-main {
        max-height: 90%;
    }
    .va-full-width-modal-main {
        width: 90%;
    }
    .va-full-width-modal-main p.company-logo-theme-color {
        margin-top: 15px;
        font-size: 8px;
        text-transform: uppercase;
        font-weight: 600;
        letter-spacing: 1.5px;
    }
    .wp-repair-location-image-upload-button {
        font-size: 13px;
        width: 170px;
        font-weight: 600;
        text-transform: uppercase;
        border: 2px solid #1275c2;
        background: #fff;
        margin: 0px;
        padding: 3px 8px;
        cursor: pointer;
        margin-top: 5px;
        border-radius: 5px;
        color: #1275c2;
        text-align: left;
    }
    .wp-repair-location-image-upload-button:hover {
        background: #1275c2;
        color: #fff;
    }
    .va-full-width-modal-main p.company-logo-theme-color.recommended-size {
        margin-top: 0px;
    }
    .va-full-width-modal .va-button.va-submit {
        right: unset;
        float: left;
    }
    .wp-repair-input-group label {
        top: -6px;
    }
    .va-full-width-modal .va-button.va-submit {
        margin-bottom: 8px;
    }
    .va-full-width-modal-main.schedule-group-modal {
        max-width: 810px;
    }
    table.timing-table .action-buttons {
        min-width: 110px;
    }
    table.timing-table .action-buttons button {
        display: inline-block;
        padding: 5px 10px;
        font-size: 12px;
        border-radius: 5px;
        cursor: pointer;
        border: 1px solid #eee;
        background: #eee;
        color: #333;
        box-shadow: unset;
        outline: 0;
        margin-right: 5px;
    }
    table.timing-table .action-buttons button:nth-last-child(1) {
        margin-right: 0px;
    }
    select.actual_time.coupons_select  {
        font-size: 12px !important;
        padding: 4px 20px 4px 8px !important;
        width: 70px;
        font-weight: 400 !important;
    }
    select.am_pm.coupons_select  {
        font-size: 12px !important;
        padding: 4px 20px 4px 8px !important;
        width: 55px;
        font-weight: 400 !important;
    }
    table.timing-table {
        margin-top: 0px;
    }
    table.timing-table tr td.day_name {
        font-size: 12px;
    }
    table.timing-table tr td.the-select-td {
        padding-right: 0px !important;
    }
    table.timing-table tr td.the-select-td.alittlegap {
        padding-left: 12px !important;
    }
    table.timing-table tr th {
        padding-left: 16px !important;
        font-size: 8px;
    text-transform: uppercase;
    font-weight: 600;
    letter-spacing: 1.5px;
    }
    table.timing-table tr td,
    table.timing-table tr th {
        border: 0px !important;
    }
    p.when-youre-closed {
        margin-top: 20px;
        margin-bottom: 5px;
    }
    table.timing-table tr td.shop-is-closed {
        text-align: center;
    }
    table.timing-table tr td {
        position: relative;
    }
    /* show line before */
    table.timing-table tr td.shop-is-closed:before {
        content: "";
        position: absolute;
        top: 50%;
        left: 0;
        width: calc(50% - 35px);
        height: 1px;
        background: #ccc;
        z-index: -1;
    }
    table.timing-table tr td.shop-is-closed:after {
        content: "";
        position: absolute;
        top: 50%;
        right: 0;
        width: calc(50% - 35px);
        height: 1px;
        background: #ccc;
        z-index: -1;
    }
    .paste-schedule-row.disabled {
        opacity: 0.5;
    }
    .btn-delete-item-confirm.disabled {
        opacity: 0.5;
    }
    .va-full-width-modal-main.schedule-group-modal-delete .va-modal-title.danger-color.blue-color {
        color: #b50000 !important;
    }
    .va-full-width-modal-main.schedule-group-modal-delete .btn-delete-item-confirm {
        background: #b50000 !important;
        border: 1px solid #b50000 !important;
    }
    .va-full-width-modal-main p.company-logo-theme-color.alternative-schedule-group {
        margin-top: 10px;
    }
    .va-full-width-modal .wp-repair-repair-card select.alternative_schedule_group {
        margin-bottom: 12px;
    }
    .va-full-width-modal .wp-repair-input-group {
        max-width: 100%;
    }
    .full-width-wp-repair {
        display: block;
    }
    .full-width-wp-repair .table-responsive {
        display: block;
        width: 100%;
        overflow-x: auto;
    }
    .full-width-wp-repair .table-responsive table.table {
        width: 100%;
        min-width: 550px;
    }
    .wp-repair-container,
    .wp-repair-row,
    .wp-repair-col-12.settings,
    .repair-dl-rounded-container {
        display: block;
        width: 100%;
        box-sizing: border-box;
    }
    @media(max-width: 600px) {
        .full-width-wp-repair {
            padding: 0px;
        }
        .rp-filters .wp-repair-input-group,
        .rp-filters .wp-repair-repair-card {
            width: 100%;
            display: block;
            margin-bottom: 10px;
            padding: 0px;
            max-width: 100%;
        }
        .rp-filters .wp-repair-repair-card select {
            max-width: 100%;
        }
        .rp-filters .search-button {
            width: 100%;
            padding: 0px;
            text-align: center;
        }
        .rp-filters .search-button button {
            width: 100%;
        }
        .rp-dynamic-pricing-settings-nav a {
            margin: 3px;
        }
    }
</style>
<div class="table-responsive">
    <table class="table">
        <thead>
            <tr>
                <th width="60px">Id</th>
                <th>Group Name</th>
                <th>Used</th>
                <th width="230px"></th>
            </tr>
        </thead>
        <tbody>
            <?php
            if( !empty( $schedule_groups ) ) {

                foreach($schedule_groups as $schedule_group) {
                    ?>
                    <tr>
                        <td><?php echo $schedule_group->id; ?></td>
                        <td><?php echo $schedule_group->name; ?></td>
                        <td><?php
                        echo rp_get_schedule_used_count( $schedule_group->id );
                        ?></td>
                        <td>
                            <button type="button" class="btn table-action-btn btn-dark rp_view_the_schedule btn-sm" data-id="<?php echo $schedule_group->id; ?>" data-name="<?php echo $schedule_group->name; ?>">
                                View Schedule
                            </button>
                            <button type="button" class="btn table-action-btn btn-primary edit-entry btn-sm" data-id="<?php echo $schedule_group->id; ?>" data-name="<?php echo $schedule_group->name; ?>">
                                <i class="fa fa-edit"></i>
                            </button>
                            <button type="button" class="btn table-action-btn btn-light clone-entry btn-sm" data-id="<?php echo $schedule_group->id; ?>" data-name="<?php echo $schedule_group->name; ?>">
                                <!-- clone -->
                                <i class="fa fa-clone"></i>
                            </button>
                            <button type="button" class="btn table-action-btn btn-danger btn-delete-item btn-sm" data-id="<?php echo $schedule_group->id; ?>" data-name="<?php echo $schedule_group->name; ?>">
                                <i class="fa fa-trash-alt"></i>
                            </button>
                        </td>
                    </tr>
                    <?php
                }

            } else {

                ?>
                <tr>
                    <td colspan="4">No schedule groups found.</td>
                </tr>
                <?php

            }
            ?>
        </tbody>
    </table>
</div>
<div class="pagination-cont">
    <div class="showing-x-of-x">
        <p style="margin-bottom: 5px;">
        <?php
        echo $showing_entries;
        ?>
        </p>
    </div>
    <div class="rppagination">
        <?php
        echo $rppagination;
        ?>
    </div>
</div>
<button style="margin-top: 15px;" type="button" class="btn table-action-btn btn-create-new btn-sm">
    Create New
</button>
<link rel="stylesheet" href="<?php echo wpRepairGetStyleSheetURLOfrepairTooltipster(); ?>" type="text/css" media="all" />
<script type="text/javascript" src="<?php echo wpRepairGetJsURLOfrepairTooltipster(); ?>"></script>
<script>

(function($){

    window.rp_all_times = <?php echo json_encode( $all_times ); ?>;

    function showFullWidthModal(content = '', additional_cls = '') {
        $(".va-full-width-modal").remove();
        let html = `
            <div class="va-full-width-modal">
                <div class="va-full-width-modal-main ${additional_cls}">
                    <div class="va-full-width-modal-inner clearfix">
                        ${content}
                    </div>
                    <button class="va-button va-button-default va-close-modal">
                        <i class="fas fa-times"></i>
                    </button>
                </div>
            </div>
        `;
        $("body").append(html);
        $(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
        $(".va-full-width-modal .va-close-modal").on("click", function(){
            $(this).parent().animate({'top': '-50%'}, 400, function(){
                $(this).parent().remove();
            });
        });
        $(document).on("mouseup", handOutsideClick);
        // $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
    }
    function handOutsideClick(e) {
        var container = $('.va-full-width-modal-main');
        if( !$(container).hasClass('justUploadedImage') ) {
         
            // if the target of the click isn't the container nor a descendant of the container
            if (!container.is(e.target) && container.has(e.target).length === 0) 
            {
                container.find(".va-close-modal").click();
                $(document).off("mouseup", handOutsideClick);
            }

        }
    }

    function create_needed_input( key, readable_key, value = '', data = {} ) {
        form_html = '';

        if( key == 'id' ) {

            form_html += '<input type="hidden" name="'+ key +'" value="'+ value +'">';

        } else {

            form_html += '<div class="form-group wp-repair-input-group">';
            form_html += '<label for="location_'+ key +'">'+ readable_key +'</label>';
            form_html += '<input type="text" class="form-control" id="location_'+ key +'" name="'+ key +'" value="'+ value +'">';
            form_html += '</div>';

        }

        return form_html;
    }

    function select_input_actual_time( name = '', value = '' ) {

        // clone the array
        let options = JSON.parse(JSON.stringify(window.rp_all_times));

        // add empty option to the beginning
        options.unshift('');

        let select_html = '<select class="coupons_select coupon_type actual_time" name="'+ name +'[]">';

        options.forEach( function( option ) {

            let selected = '';

            if( option == value ) {

                selected = 'selected';

            }

            select_html += '<option value="'+ option +'" '+ selected +'>'+ option +'</option>';

        });

        select_html += '</select>';

        return select_html;

    }

    function select_input_am_pm( name = '', value = '' ) {

        let options = {};

        options[''] = '';

        options['AM'] = 'AM';

        options['PM'] = 'PM';

        let select_html = '<select class="coupons_select coupon_type am_pm w_65" name="'+ name +'[]">';

        $.each( options, function( key, text ) {

            let selected = '';

            if( key == value ) {

                selected = 'selected';

            }

            select_html += '<option value="'+ key +'" '+ selected +'>'+ text +'</option>';

        });

        select_html += '</select>';

        return select_html;

    }

    function rp_create_schedule_table_tr( tr_row ) {

        let tr = '<tr>';

        tr += '<td class="day_name">'+ tr_row.day +'<input type="hidden" name="day[]" value="'+ tr_row.day +'"></td>';

        tr += '<td class="the-select-td alittlegap">'+ select_input_actual_time('open_timing',tr_row.open_timing) +'</td>';

        tr += '<td class="the-select-td">'+ select_input_am_pm('open_timing_ampm',tr_row.open_timing_ampm) +'</td>';

        tr += '<td class="the-select-td">'+ select_input_actual_time('close_timing',tr_row.close_timing) +'</td>';

        tr += '<td class="the-select-td">'+ select_input_am_pm('close_timing_ampm',tr_row.close_timing_ampm) +'</td>';

        tr += '<td class="the-select-td alittlegap">'+ select_input_actual_time('break_start_timing',tr_row.break_start_timing) +'</td>';

        tr += '<td class="the-select-td">'+ select_input_am_pm('break_start_timing_ampm',tr_row.break_start_timing_ampm) +'</td>';

        tr += '<td class="the-select-td">'+ select_input_actual_time('break_end_timing',tr_row.break_end_timing) +'</td>';

        tr += '<td class="the-select-td">'+ select_input_am_pm('break_end_timing_ampm',tr_row.break_end_timing_ampm) +'</td>';

        // action buttons (copy, paste, clear)
        tr += '<td class="action-buttons">';
        tr += '<button type="button" title="Copy" class="btn btn-default btn-sm copy-schedule-row"><i class="fa fa-copy"></i></button>';
        tr += '<button type="button" title="Paste" class="btn btn-default btn-sm disabled paste-schedule-row"><i class="fa fa-paste"></i></button>';
        tr += '<button type="button" title="Clear" class="btn btn-default btn-sm clear-schedule-row"><i class="fa fa-times"></i></button>';
        tr += '</td>';

        tr += '</tr>';

        return tr;

    }

    function rp_create_schedule_table_tr_only_view( tr_row ) {

        let tr = '<tr>';

        tr += '<td class="day_name">'+ tr_row.day +'</td>';

        if( !tr_row.open_timing || !tr_row.close_timing ) {

            tr += '<td class="shop-is-closed" colspan="4">Closed</td>';

        } else {

            tr += '<td class="the-select-td alittlegap">'+ tr_row.open_timing + ' ' + tr_row.open_timing_ampm + ' –– ' + tr_row.close_timing + ' ' + tr_row.close_timing_ampm + '</td>';

            tr += '<td class="the-select-td alittlegap">'+ tr_row.break_start_timing + ' ' + tr_row.break_start_timing_ampm + ' –– ' + tr_row.break_end_timing + ' ' + tr_row.break_end_timing_ampm + '</td>';

        }

        tr += '</tr>';

        return tr;

    }
    
    function rp_create_timing_table( timings = {} ) {

        let html = '<table class="table timing-table">';

        html += '<thead>';

        html += '<tr>';

        html += '<th></th>';

        html += '<th colspan="4">Hours</th>';

        html += '<th colspan="4">Breaktime</th>';

        // action th
        html += '<th></th>';

        html += '</tr>';
        
        // close thead
        html += '</thead>';

        html += '<tbody>';

        let days = ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'];

        days.forEach(function(day, index){

            let found_row = null;

            timings.forEach(function(row, tindex){

                if( row.day == day ) {
                    found_row = row;
                }

            });

            if( found_row == null ) {
                found_row = {
                    day: day,
                    open_timing: '',
                    open_timing_ampm: 'AM',
                    close_timing: '',
                    close_timing_ampm: 'PM',
                    break_start_timing: '',
                    break_start_timing_ampm: 'PM',
                    break_end_timing: '',
                    break_end_timing_ampm: 'PM',
                };
            }

            html += rp_create_schedule_table_tr( found_row );

        });

        html += '</tbody>';

        html += '</table>';

        return html;

    }

    function rp_create_timing_table_only_view( timings = {} ) {

        let html = '<table class="table timing-table">';

        html += '<thead>';

        html += '<tr>';

        html += '<th></th>';

        html += '<th colspan="1">Hours</th>';

        html += '<th colspan="1">Breaktime</th>';

        html += '</tr>';
        
        // close thead
        html += '</thead>';

        html += '<tbody>';

        let days = ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'];

        days.forEach(function(day, index){

            let found_row = null;

            timings.forEach(function(row, tindex){

                if( row.day == day ) {
                    found_row = row;
                }

            });

            if( found_row == null ) {
                found_row = {
                    day: day,
                    open_timing: '',
                    open_timing_ampm: 'AM',
                    close_timing: '',
                    close_timing_ampm: 'PM',
                    break_start_timing: '',
                    break_start_timing_ampm: 'PM',
                    break_end_timing: '',
                    break_end_timing_ampm: 'PM',
                };
            }

            html += rp_create_schedule_table_tr_only_view( found_row );

        });

        html += '</tbody>';

        html += '</table>';

        return html;

    }

    function create_or_edit_entry(that, id = null, is_clone = false) {

        // check if has class processing
        if( jQuery(that).hasClass('processing') ) {
            return false;
        }

        // add class processing
        jQuery(that).addClass('processing');

        let btn = that;
        let originalHTML = jQuery(that).html();

        // width of button
        let btnWidth = jQuery(that).outerWidth();
        // round
        btnWidth = Math.round(btnWidth);
        // apply width to button
        jQuery(that).css('width', btnWidth);

        // show loading icon
        jQuery(that).html('<i class="fa fa-spinner fa-spin"></i>');

        if(is_clone) {
            is_clone = 1;
        } else {
            is_clone = 0;
        }

        repairPluginUI.ajax({
            type:'POST',
            url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
            data: {action:'rp_get_schedule_data_for_edit',id:id,is_clone:is_clone},
            success: function(data) {

                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");

                // blur
                jQuery(that).blur();

                window.copied_timing_row = null;

                try {
                    data = JSON.parse(data);
                } catch(e) {
                    data = {};
                }
                if( data && data.data && data.timings ) {

                    let form_type = 'create';

                    if( data.data.id != 0 ) {

                        form_type = 'edit';

                    }

                    let modal_heading = 'Create New';
                    let modal_button = 'Create New';

                    if( form_type == 'edit' ) {

                        modal_heading = 'Edit Schedule Group';
                        modal_button = 'Update';

                    }

                    let form_html = '';

                    // multipart
                    form_html += '<form action="" method="POST" enctype="multipart/form-data">';

                    for( var key in data. data ) {

                        let value = data.data[key];

                        let readable_key = key.replace(/_/g, ' ');

                        if( readable_key === 'name' ) {
                            readable_key = 'Schedule Group Name';
                        }

                        // replace _+_ in key with single _
                        key = key.replace(/_\+_/g, '_');

                        // create input
                        form_html += create_needed_input(key, readable_key, value, data.data);

                    }

                    form_html += `<p class="when-youre-closed"><small>When you're closed on certain day, just leave the hours blank.</small></p>`;

                    form_html += rp_create_timing_table(data.timings); 

                    // close
                    form_html += '</form>';

                    showFullWidthModal(`
                        <p class="va-modal-title blue-color">${modal_heading}</p>
                        ${form_html}
                        <button type="button" class="va-button va-button-primary va-submit btn-create-edit-actual">
                            ${modal_button}
                        </button>
                    `, 'schedule-group-modal');

                    jQuery('.schedule-group-modal button[title]').repairtooltipster();

                } else {

                    // something went wrong
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');

                }
            },
            error: function(response) {
                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");
                if( response && response.rp_validation_error != '' ) {
                    
                } else {
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');
                }
            }
        });

    }

    function rp_view_the_schedule(that, id = null) {

        // check if has class processing
        if( jQuery(that).hasClass('processing') ) {
            return false;
        }

        // add class processing
        jQuery(that).addClass('processing');

        let btn = that;
        let originalHTML = jQuery(that).html();

        // width of button
        let btnWidth = jQuery(that).outerWidth();
        // apply width to button
        jQuery(that).css('width', btnWidth);

        // show loading icon
        jQuery(that).html('<i class="fa fa-spinner fa-spin"></i>');

        repairPluginUI.ajax({
            type:'POST',
            url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
            data: {action:'rp_get_timings_of_schedule_group',id:id},
            success: function(data) {

                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");

                // blur
                jQuery(that).blur();

                try {
                    data = JSON.parse(data);
                } catch(e) {
                    data = {};
                }
                if( data && data.data && data.timings ) {

                    let modal_heading = 'View Schedule';

                    let timing_table = rp_create_timing_table_only_view(data.timings); 

                    showFullWidthModal(`
                        <p class="va-modal-title blue-color">${modal_heading}</p>
                        <p>Group Name: <strong>${data.data.name}</strong></p>
                        ${timing_table}
                    `, 'schedule-group-modal-view');

                } else {

                    // something went wrong
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');

                }
            },
            error: function(response) {
                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");
                if( response && response.rp_validation_error != '' ) {
                    
                } else {
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');
                }
            }
        });

    }

    jQuery(document).on('ready', function(){

        jQuery(document).on('click', '.rp_view_the_schedule', function(){

            rp_view_the_schedule(this, jQuery(this).data('id'));

        });

        jQuery(document).on('click', '.btn-create-new', function(){

            create_or_edit_entry(this);

        });

        jQuery(document).on('click', '.table-action-btn.clone-entry', function(){

            create_or_edit_entry(this, jQuery(this).data('id'), true);

        });

        jQuery(document).on('click', '.table-action-btn.edit-entry', function(){

            create_or_edit_entry(this, jQuery(this).data('id'));

        });

        jQuery(document).on('click', '.btn-delete-item', function(){

            // check if has class processing
            if( jQuery(this).hasClass('processing') ) {
                return false;
            }

            let id = jQuery(this).attr('data-id');
            let name = jQuery(this).attr('data-name');

            // add class processing
            jQuery(this).addClass('processing');

            let btn = this;
            let originalHTML = jQuery(this).html();

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                data: {action:'rp_deleting_schedule_group',id:id},
                success: function(data) {
                    try {
                        data = JSON.parse(data);
                    } catch(e) {
                        data = null;
                    }
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    // blur
                    jQuery(btn).blur();
                    if(data && data.status) {
                        let available_schedules = data.available_schedules;
                        let modal_heading = 'Delete Schedule Group';
                        if( 'in_use' in data && data.in_use == 0 && available_schedules.length > 0 ) {
                            showFullWidthModal(`
                                <p class="va-modal-title danger-color blue-color">${modal_heading}</p>
                                <p>This schedule group is not assigned to any location. You can delete it safely if you want.</p>
                                <button data-id="${id}" data-name="${name}" type="submit" class="va-button va-button-danger va-submit btn-delete-item-confirm">
                                    Delete
                                </button>
                            `, 'schedule-group-modal-delete');
                        } else if( available_schedules.length > 0 ) {
                            let select_box = '<p class="company-logo-theme-color alternative-schedule-group">Alternative Schedule Group</p><div class="wp-repair-repair-card"><select class="coupons_select alternative_schedule_group va-select" name="alt_schedule_group_id">';
                            select_box += '<option value="">-- Select --</option>';
                            for(let i = 0; i < available_schedules.length; i++) {
                                select_box += `<option value="${available_schedules[i].id}">${available_schedules[i].name}</option>`;
                            }
                            select_box += '</select></div>';
                            showFullWidthModal(`
                                <p class="va-modal-title danger-color blue-color">${modal_heading}</p>
                                <p>Please select alternative schedule group to assign on those location(s) where this schedule group is assigned.</p>
                                ${select_box}
                                <button data-id="${id}" data-name="${name}" type="submit" class="va-button va-button-danger va-submit btn-delete-item-confirm">
                                    Delete
                                </button>
                            `, 'schedule-group-modal-delete');
                        } else {
                            showFullWidthModal(`
                                <p class="va-modal-title danger-color blue-color">${modal_heading}</p>
                                <p>You must keep at least one schedule group. Please create a new schedule group before deleting this one.</p>
                            `, 'schedule-group-modal-delete');
                        }
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

        jQuery(document).on('click', '.btn-delete-item-confirm', function(){

            // check if has class processing
            if( jQuery(this).hasClass('processing') || jQuery(this).hasClass('disabled') ) {
                return false;
            }

            let alt_schedule_group_id = '';

            // check if has .alternative_schedule_group
            if( jQuery('.alternative_schedule_group').length > 0 ) {
                alt_schedule_group_id = jQuery('.alternative_schedule_group').val();
                if( alt_schedule_group_id == '' ) {
                    alert('Please select alternative schedule group.');
                    return false;
                }
            }

            let id = jQuery(this).attr('data-id');
            let name = jQuery(this).attr('data-name');

            // add class processing
            jQuery(this).addClass('processing');

            let btn = this;
            let originalHTML = jQuery(this).html();

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                data: {action:'rp_delete_schedule_group',id:id,alt_schedule_group_id:alt_schedule_group_id},
                success: function(data) {
                    window.location.reload();
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

        jQuery(document).on('click', '.btn-create-edit-actual', function(){

            // make sure all fields are filled up
            let allFieldsFilledUp = true;

            let parent = jQuery(this).parents('.va-full-width-modal');

            jQuery(parent).find('.wp-repair-input-group').each(function(){
                let input = jQuery(this).find('input');
                // if name === google_map_link, skip
                if( input.attr('type') != 'hidden' ) {
                    
                    if( input.val() == '' ) {
                        allFieldsFilledUp = false;
                    }

                }

            });

            if( !allFieldsFilledUp ) {
                alert('Please fill up all fields.');
                return false;
            }

            // check if has class processing
            if( jQuery(this).hasClass('processing') ) {
                return false;
            }

            // add class processing
            jQuery(this).addClass('processing');

            let btn = this;
            let originalHTML = jQuery(this).html();

            // width of button
            let btnWidth = jQuery(this).outerWidth();
            // apply width to button
            jQuery(this).css('width', btnWidth);

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin" style="position: relative; top: -1px;"></i>');

            let form = jQuery(parent).find('form');

            let form_data = new FormData(form[0]);

            // append action
            form_data.append('action', 'rp_create_or_edit_schedule');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                cache: false,
                contentType: false,
                processData: false,
                data: form_data,
                success: function(data) {
                    window.location.reload();
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

        // tr += '<button type="button" title="Copy" class="btn btn-default btn-sm copy-schedule-row"><i class="fa fa-copy"></i></button>';
        // tr += '<button type="button" title="Paste" class="btn btn-default btn-sm paste-schedule-row"><i class="fa fa-paste"></i></button>';
        // tr += '<button type="button" title="Clear" class="btn btn-default btn-sm clear-schedule-row"><i class="fa fa-times"></i></button>';

        window.copied_timing_row = null;

        jQuery(document).on('click', '.clear-schedule-row', function(){

            let parent = jQuery(this).parents('tr');

            jQuery(parent).find('select').val('');

        });

        jQuery(document).on('click', '.copy-schedule-row', function(){

            let parent = jQuery(this).parents('tr');

            let open_timing = jQuery(parent).find('select[name^="open_timing"]').val();

            let open_timing_ampm = jQuery(parent).find('select[name^="open_timing_ampm"]').val();

            let close_timing = jQuery(parent).find('select[name^="close_timing"]').val();

            let close_timing_ampm = jQuery(parent).find('select[name^="close_timing_ampm"]').val();

            let break_start_timing = jQuery(parent).find('select[name^="break_start_timing"]').val();

            let break_start_timing_ampm = jQuery(parent).find('select[name^="break_start_timing_ampm"]').val();

            let break_end_timing = jQuery(parent).find('select[name^="break_end_timing"]').val();

            let break_end_timing_ampm = jQuery(parent).find('select[name^="break_end_timing_ampm"]').val();

            window.copied_timing_row = {
                open_timing: open_timing,
                open_timing_ampm: open_timing_ampm,
                close_timing: close_timing,
                close_timing_ampm: close_timing_ampm,
                break_start_timing: break_start_timing,
                break_start_timing_ampm: break_start_timing_ampm,
                break_end_timing: break_end_timing,
                break_end_timing_ampm: break_end_timing_ampm,
            };

            jQuery('.paste-schedule-row').removeClass('disabled');

        });

        jQuery(document).on('click', '.paste-schedule-row', function(){

            if( window.copied_timing_row == null || jQuery(this).hasClass('disabled') ) {
                return false;
            }

            let parent = jQuery(this).parents('tr');

            jQuery(parent).find('select[name^="open_timing"]').val(window.copied_timing_row.open_timing);

            jQuery(parent).find('select[name^="open_timing_ampm"]').val(window.copied_timing_row.open_timing_ampm);

            jQuery(parent).find('select[name^="close_timing"]').val(window.copied_timing_row.close_timing);

            jQuery(parent).find('select[name^="close_timing_ampm"]').val(window.copied_timing_row.close_timing_ampm);

            jQuery(parent).find('select[name^="break_start_timing"]').val(window.copied_timing_row.break_start_timing);

            jQuery(parent).find('select[name^="break_start_timing_ampm"]').val(window.copied_timing_row.break_start_timing_ampm);

            jQuery(parent).find('select[name^="break_end_timing"]').val(window.copied_timing_row.break_end_timing);

            jQuery(parent).find('select[name^="break_end_timing_ampm"]').val(window.copied_timing_row.break_end_timing_ampm);

        });

    });

}(jQuery));

</script>