<?php
// Exit if accessed directly

defined( 'ABSPATH' ) || exit;

$main_location_id = rp_get_main_location_id_of_company();

$schedule_groups = rp_get_all_schedule_groups();

$_rp_company_email = rp_get_settings_company_email();

$where_conditions = array();

$where_sql = '';

if( !empty( trim( $_GET['searchbox'] ?? '' ) ) ) {

    // back to original form of searchbox (decode url)
    $_GET['searchbox'] = urldecode( $_GET['searchbox'] );

    $where_conditions[] = "`subquery`.`search_text` LIKE '%" . ( trim( $_GET['searchbox'] ) ) . "%'";

}

if( !empty( trim( $_GET['schedule_group_search'] ?? 0 ) ) ) {

    $where_conditions[] = "`subquery`.`schedule_group_id` = " . (int) $_GET['schedule_group_search'];

}

if( !empty( $where_conditions ) ) {

    $where_sql = 'WHERE ' . implode( ' AND ', $where_conditions );

}

function rppagination( $current_page = 1, $last_page = 1 ) {

    if( $last_page < 2 ) {

        return '';

    }

    // 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
    $links = array();

    while( $last_page > 0 ) {

        $links[] = $last_page;

        $last_page--;

    }

    $links = array_reverse( $links );

    $html = '<div class="rp-pagination">';

    $html .= '<ul>';

    // search fields
    $search_fields = array();

    if( !empty( $_GET['searchbox'] ?? '' ) ) {

        $search_fields[] = 'searchbox=' . urlencode( $_GET['searchbox'] );

    }

    if( !empty( $_GET['schedule_group_search'] ?? 0 ) ) {

        $search_fields[] = 'schedule_group_search=' . (int) $_GET['schedule_group_search'];

    }
    
    if( !empty( $search_fields ) ) {

        $search_fields = '&' . implode( '&', $search_fields );

    } else {

        $search_fields = '';

    }

    foreach( $links as $link ) {

        $html .= '<li><a class="' . ( $current_page == $link ? 'active' : '' ) . '" href="?page=wp_repair_settings&section=enhanced_locations&tab=locations_crud&current_page=' . $link . $search_fields . '">' . $link . '</a></li>';

    }

    $html .= '</ul>';

    $html .= '</div>';

    return $html;

}

$current_page = (int) ($_GET['current_page'] ?? 1);

if( $current_page < 1 ) {

    $current_page = 1;

}

$limit = 10;

$total_locations = rp_get_total_company_locations( $where_sql );

if( $total_locations > 0 ) {

    // last page

    $last_page = ceil( $total_locations / $limit );

    if( $current_page > $last_page ) {

        $current_page = $last_page;

    }

    $locations = rp_get_all_company_locations( $current_page, $limit, $where_sql );

    $locations = rp_sanitize_output( $locations );

    // showing 1 to 10 of 19 entries

    $showing_from = ( $current_page - 1 ) * $limit + 1;

    $showing_to = $current_page * $limit;

    if( $showing_to > $total_locations ) {

        $showing_to = $total_locations;

    }

    $showing_entries = "Showing $showing_from to $showing_to of $total_locations entries";

    $rppagination = rppagination( $current_page, $last_page );

} else {

    $locations = array();

    $showing_entries = "";

    $rppagination = "";

}

?>
<style>
    .table-action-btn {
        display: inline-table;
        margin-right: 3px;
        padding: 4px 10px;
        font-size: 12px;
        border: unset;
        box-shadow: 0px 0px 2px rgba(0,0,0,0.2);
        outline: 0;
        border-radius: 5px;
        cursor: pointer;
    }
    .table-action-btn.btn-create-new {
        background: #1275c2;
        color: #fff;
        font-weight: 600;
        text-transform: uppercase;
        cursor: pointer;
        border-radius: 5px;
        padding: 6px 10px;
        font-size: 11.5px;
        letter-spacing: 1px;
    }
    .table-action-btn.btn-primary {
        background-color: #008ce4;
        color: #fff;
    }
    .table-action-btn.btn-primary:hover {
        background-color: #0077b3;
        color: #fff;
    }
    .table-action-btn.btn-dark {
        background-color: #343a40;
        color: #fff;
    }
    .table-action-btn.btn-dark:hover {
        background-color: #23272b;
        color: #fff;
    }
    .table-action-btn.btn-light {
        background-color: #efefef;
        color: #212529;
    }
    .table-action-btn.btn-light:hover {
        background-color: #e2e2e2;
        color: #212529;
    }
    .table-action-btn.btn-danger {
        background-color: #dc3545;
        color: #fff;
    }
    .table-action-btn.btn-danger:hover {
        background-color: #c82333;
        color: #fff;
    }
    .rp-pagination ul {
        list-style: none;
        padding: 0;
        margin: 0;
    }
    .rp-pagination ul li {
        display: inline-block;
        margin-right: 5px;
    }
    .rp-pagination ul li a {
        display: inline-table;
    padding: 5px 10px;
    width: 35px;
    box-sizing: border-box;
    border: 1px solid #eee;
    text-decoration: none;
    color: #333;
    box-shadow: unset;
    outline: 0;
    border-radius: 5px;
    background-color: #eee;
    text-align: center;
    }
    .rp-pagination ul li a.active {
        background-color: #0077c2;
        color: #fff;
    }
    table {
        width: 100%;
    }
    table tr th,
    table tr td {
        padding: 5px 5px 5px 5px;
        text-align: left;
        vertical-align: top;
        border-bottom: 1px dashed #eee;
    }
    .location-name {
        margin-bottom: 15px;
        font-weight: 600;
    }
    .location-email {
        margin-bottom: 15px;
    }
    .location-address {
        line-height: 1.5em !important;
    }
    .location-photo {
        width: 100px;
        height: 25px;
        overflow: hidden;
        position: relative;
        display: block;
        border-radius: 3px;
    }
    .location-photo img {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 100%;
        height: auto;
    }
    select.schedule-select {
        width: 120px;
        min-height: 28px;
        font-size: 13px;
        font-weight: 400 !important;
        border-radius: 6px !important;
    }
    .va-full-width-modal *:not(i) {
        font-family: 'Montserrat', sans-serif;
    }
    .va-full-width-modal .wp-repair-repair-card {
        width: 100%;
        max-width: 100%;
        margin-bottom: 0px !important;
    }
    .va-full-width-modal .wp-repair-repair-card select {
        width: 100%;
        font-size: 13px;
        max-width: 100%;
        font-weight: 400 !important;
        border-radius: 8px !important;
    }
    .va-full-width-modal-main {
        max-height: 90%;
    }
    .va-full-width-modal-main p.company-logo-theme-color {
        margin-top: 15px;
        font-size: 8px;
        text-transform: uppercase;
        font-weight: 600;
        letter-spacing: 1.5px;
    }
    .wp-repair-location-image-upload-button {
        font-size: 13px;
        width: 170px;
        font-weight: 600;
        text-transform: uppercase;
        border: 2px solid #1275c2;
        background: #fff;
        margin: 0px;
        padding: 3px 8px;
        cursor: pointer;
        margin-top: 5px;
        border-radius: 5px;
        color: #1275c2;
        text-align: left;
    }
    .wp-repair-location-image-upload-button:hover {
        background: #1275c2;
        color: #fff;
    }
    .va-full-width-modal-main p.company-logo-theme-color.recommended-size {
        margin-top: 0px;
    }
    .va-full-width-modal .va-button.va-submit {
        right: unset;
        float: left;
    }
    .wp-repair-input-group label {
        top: -6px;
    }
    .va-full-width-modal .va-button.va-submit {
        margin-bottom: 8px;
    }
    .rp_is_synced {
        margin-top: 6px;
        margin-bottom: 4px;
    }
    .va-full-width-modal-main.location-modal-delete .va-modal-title.danger-color.blue-color {
        color: #b50000 !important;
    }
    .va-full-width-modal-main.location-modal-delete .btn-delete-item-confirm {
        background: #b50000 !important;
        border: 1px solid #b50000 !important;
    }
    .uploaded_img.hasImage {
        display: block;
        position: relative;
        width: 100%;
        height: auto;
        overflow: hidden;
        transition: all 0.2s ease-in-out;
        padding-bottom: 25%;
        border-radius: 8px;
    }
    .uploaded_img.hasImage:hover {
        background: #000;
    }
    .uploaded_img img {
        position: absolute;
        width: 100%;
        height: auto;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        transition: all 0.2s ease-in-out;
    }
    .uploaded_img .remove-uploaded-image {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
    }
    .uploaded_img .remove-uploaded-image .clear-image {
        cursor: pointer;
        background: transparent;
        color: #fff;
        padding: 0px;
        box-shadow: 0px 0px 3px #000000;
        border: 0px;
        font-size: 20px;
        outline: 0;
        box-shadow: unset;
        transition: all 0.2s ease-in-out;
        transform: scale(0);
    }
    .uploaded_img:hover .remove-uploaded-image .clear-image {
        transform: scale(1);
    }
    .uploaded_img:hover img {
        opacity: 0.5;
    }
    .rp-filters {
        margin-bottom: 25px;
    }
    .rp-filters .wp-repair-input-group {
        width: 250px;
        display: inline-table;
    }
    .rp-filters .wp-repair-input-group input {
        height: 32px;
        border-radius: 6px;
        font-size: 13px;
        padding-left: 10px !important;
    }
    .rp-filters .search-button,
    .rp-filters .clear-search-button {
        display: inline-table;
    }
    .rp-filters .search-button,
    .rp-filters .clear-search-button,
    .rp-filters .wp-repair-repair-card {
        padding-left: 5px;
    }

    .rp-filters .btn-search,
    .rp-filters .btn-clear-search {
        background: #efefef;
        color: #404040;
        font-weight: 600;
        text-transform: uppercase;
        cursor: pointer;
        border-radius: 5px;
        padding: 7px 10px;
        font-size: 11.5px;
        letter-spacing: 1px;
        border: 2px solid #d9d9d9;
        text-align: center;
        display: table;
        vertical-align: middle;
        height: 32px;
    }
    .rp-filters .wp-repair-repair-card {
        display: inline-table;
        width: 170px;
    }
    .rp-filters .wp-repair-repair-card select.coupons_select {
        font-size: 13px;
        font-weight: 400 !important;
        padding: 4px 10px !important;
        height: 32px;
        display: table;
        border-radius: 7px !important;
        line-height: 1.15em;
        padding-right: 24px !important;
    }
    .badge-main-location {
        padding: 3px 5px;
        line-height: 1em;
        border-radius: 5px;
        background: #efefef;
        color: #404040;
        font-size: 9px;
    }
    .va-full-width-modal .wp-repair-input-group {
        max-width: 100%;
    }
    .va-full-width-modal-main {
        width: 90%;
    }
    .full-width-wp-repair {
        display: block;
    }
    .full-width-wp-repair .table-responsive {
        display: block;
        width: 100%;
        overflow-x: auto;
    }
    .full-width-wp-repair .table-responsive table.table {
        width: 100%;
        min-width: 635px;
    }
    .wp-repair-container,
    .wp-repair-row,
    .wp-repair-col-12.settings,
    .repair-dl-rounded-container {
        display: block;
        width: 100%;
        box-sizing: border-box;
    }
    .location-phone {
        margin-bottom: 5px;
    }
    @media(max-width: 600px) {
        .rp-dynamic-pricing-settings-nav a {
		margin: 3px;
	}
        .full-width-wp-repair {
            padding: 0px;
        }
        .rp-filters .wp-repair-input-group,
        .rp-filters .wp-repair-repair-card {
            width: 100%;
            display: block;
            margin-bottom: 10px;
            padding: 0px;
            max-width: 100%;
        }
        .rp-filters .wp-repair-repair-card select {
            max-width: 100%;
        }
        .rp-filters .search-button {
            width: 100%;
            padding: 0px;
            text-align: center;
        }
        .rp-filters .search-button button {
            width: 100%;
        }
    }
</style>
<?php
$hasAnySearchInput = false;
$searchable_inputs = array('searchbox', 'schedule_group_search');
foreach ($searchable_inputs as $searchable_input) {
    if (isset($_GET[$searchable_input]) && !empty($_GET[$searchable_input])) {
        $hasAnySearchInput = true;
    }
}

?>
<form method="GET" action="">
    <input type="hidden" name="page" value="wp_repair_settings">
    <input type="hidden" name="section" value="enhanced_locations">
    <input type="hidden" name="tab" value="locations_crud">
    <input type="hidden" name="test" value="1">
    <div class="rp-filters">
        <div class="wp-repair-input-group">
            <input type="text" class="user-info" name="searchbox" required="" placeholder="Search location" value="<?php echo ($_GET['searchbox'] ?? ''); ?>">
        </div>
        <div class="wp-repair-repair-card">
            <select class="form-control coupons_select" name="schedule_group_search">
                <option value="">-- All --</option>
                <?php
                if( !empty( $schedule_groups ) ) {
                    foreach( $schedule_groups as $schedule ) {
                        $selected = "";
                        if( ($_GET['schedule_group_search'] ?? 0) == $schedule->id ) {
                            $selected = 'selected="selected"';
                        }
                        ?>
                        <option <?php echo $selected; ?> value="<?php echo $schedule->id; ?>"><?php echo $schedule->name; ?></option>
                        <?php
                    }
                }
                ?>
            </select>
        </div>
        <div class="search-button">
            <button type="submit" class="btn btn-primary btn-search">
                <i class="fa fa-search"></i>
            </button>
        </div>
        <?php
        if( $hasAnySearchInput === TRUE ) {
            ?>
            <div class="clear-search-button">
                <button type="button" class="btn btn-primary btn-clear-search">
                    <i class="fa fa-times"></i>
                </button>
            </div>
            <?php
        }
        ?>
    </div>
</form>
<div class="table-responsive">
    <table class="table">
        <thead>
            <tr>
                <th width="120px">Photo</th>
                <th width="200px">Details</th>
                <th width="140px">Schedule</th>
                <th width="140px"></th>
            </tr>
        </thead>
        <tbody>
            <?php
            if( !empty( $locations ) ) {

                foreach($locations as $location) {
                    $address_arr = array();
                    if( !empty( $location->location_address ) ) {
                        $address_arr[] = $location->location_address;
                    }
                    if( !empty( $location->location_city_district ) ) {
                        $address_arr[] = $location->location_city_district;
                    }
                    $location_address = implode( "<br>", $address_arr );
                    if( empty( $location_address ) ) {
                        $location_address = "N/A";
                    }
                    if( empty( $location->location_email ) ) {

                        $location->location_email = $_rp_company_email;

                    }
                    // show badge of text "main" if this is the main location ($main_location_id)
                    $main_badge = '';
                    if( (int) $location->location_id == (int) $main_location_id ) {
                        $main_badge = '<span class="badge badge-dark badge-main-location">Main</span>';
                    }
                    ?>
                    <tr>
                        <td>
                            <!-- placeholder image -->
                            <?php
                            $placeholder_img = WP_REPAIR_PLUGIN_URL . 'assets/images/image-upload-4-1.png';
                            if( !empty( $location->location_image ?? '' ) ) {
                                $placeholder_img = $location->location_image;
                            }
                            ?>
                            <div class="location-photo">
                                <img src="<?php echo $placeholder_img; ?>" width="100%" height="auto" alt="location image" />
                            </div>
                        </td>
                        <td>
                            <div class="location-name">
                                <?php echo $location->location_name . ' ' . $main_badge; ?>
                            </div>
                            <?php
                            $telephone = trim($location->location_telephone ?? '');
                            if( !empty( $telephone ) ) {
                                ?>
                                <div class="location-phone">
                                    <?php echo $telephone; ?>
                                </div>
                                <?php
                            }
                            ?>
                            <div class="location-email">
                                <?php echo $location->location_email; ?>
                            </div>
                            <div class="location-address">
                                <?php echo $location_address; ?>
                            </div>
                        </td>
                        <td>
                            <select name="schedule" class="schedule-select" data-id="<?php echo $location->location_id; ?>">
                                <?php
                                $availableScheduleGroups = array();
                                if( !empty( $schedule_groups ) ) {
                                    foreach( $schedule_groups as $schedule ) {
                                        $availableScheduleGroups[] = (int) $schedule->id;
                                    }
                                }
                                $loc_schedule_group = ($location->schedule_group_id ?? 0);
                                if( empty( $loc_schedule_group ) || !in_array( $loc_schedule_group, $availableScheduleGroups ) ) {
                                    ?>
                                    <option value="">-- Select --</option>
                                    <?php
                                }
                                if( !empty( $schedule_groups ) ) {
                                    foreach( $schedule_groups as $schedule ) {
                                        $selected = "";
                                        if( $loc_schedule_group == $schedule->id ) {
                                            $selected = 'selected="selected"';
                                        }
                                        ?>
                                        <option <?php echo $selected; ?> value="<?php echo $schedule->id; ?>"><?php echo $schedule->name; ?></option>
                                        <?php
                                    }
                                }
                                ?>
                            </select>
                        </td>
                        <td>
                            <button type="button" class="btn table-action-btn btn-primary edit-entry btn-sm" data-id="<?php echo $location->location_id; ?>" data-name="<?php echo $location->location_name; ?>">
                                <i class="fa fa-edit"></i>
                            </button>
                            <button type="button" class="btn table-action-btn btn-light clone-entry btn-sm" data-id="<?php echo $location->location_id; ?>" data-name="<?php echo $location->location_name; ?>">
                                <!-- clone -->
                                <i class="fa fa-clone"></i>
                            </button>
                            <button type="button" class="btn table-action-btn btn-danger btn-delete-item btn-sm" data-id="<?php echo $location->location_id; ?>" data-name="<?php echo $location->location_name; ?>">
                                <i class="fa fa-trash-alt"></i>
                            </button>
                        </td>
                    </tr>
                    <?php
                }

            } else {

                ?>
                <tr>
                    <td colspan="3">No locations found.</td>
                </tr>
                <?php

            }
            ?>
        </tbody>
    </table>
</div>
<div class="pagination-cont">
    <div class="showing-x-of-x">
        <p style="margin-bottom: 5px;">
        <?php
        echo $showing_entries;
        ?>
        </p>
    </div>
    <div class="rppagination">
        <?php
        echo $rppagination;
        ?>
    </div>
</div>
<button style="margin-top: 15px;" type="button" class="btn table-action-btn btn-create-new btn-sm">
    Create New
</button>
<script type="text/javascript">
    jQuery(document).on('change', '#upload_location_image', function(){

        jQuery('.va-full-width-modal-main').addClass('justUploadedImage');

        let input = this;

        if(input.files && input.files[0]){
            //console.log(input.files[0]);
            var reader = new FileReader();
            //console.log(reader);
            reader.onload = function (e){
                //console.log(img);
                jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'"><div class="remove-uploaded-image"><button type="button" class="clear-image"><i class="fas fa-times"></i></button></div>').addClass('hasImage');
            }
            reader.readAsDataURL(input.files[0]);
        }

        window.setTimeout(function(){
            jQuery('.va-full-width-modal-main').removeClass('justUploadedImage');
        }, 1000);

    });
</script>
<script>
(function($){
    
    function showFullWidthModal(content = '', additional_cls = '') {
        $(".va-full-width-modal").remove();
        let html = `
            <div class="va-full-width-modal">
                <div class="va-full-width-modal-main ${additional_cls}">
                    <div class="va-full-width-modal-inner clearfix">
                        ${content}
                    </div>
                    <button class="va-button va-button-default va-close-modal">
                        <i class="fas fa-times"></i>
                    </button>
                </div>
            </div>
        `;
        $("body").append(html);
        $(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
        $(".va-full-width-modal .va-close-modal").on("click", function(){
            $(this).parent().animate({'top': '-50%'}, 400, function(){
                $(this).parent().remove();
            });
        });
        $(document).on("mouseup", handOutsideClick);
        // $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
    }
    function handOutsideClick(e) {
        var container = $('.va-full-width-modal-main');
        if( !$(container).hasClass('justUploadedImage') ) {
         
            // if the target of the click isn't the container nor a descendant of the container
            if (!container.is(e.target) && container.has(e.target).length === 0) 
            {
                container.find(".va-close-modal").click();
                $(document).off("mouseup", handOutsideClick);
            }

        }
    }

    function create_needed_input( key, readable_key, value = '', data = {} ) {
        form_html = '';

        if( key == 'id' ) {

            form_html += '<input type="hidden" name="'+ key +'" value="'+ value +'">';

        } else if( key == 'available_schedules' || key == 'is_synced' ) {

            form_html = '';

        } else if( key == 'photo' ) {

            if( !value ) {
                value = '';
            }

            form_html += '<p class="company-logo-theme-color">Location Image</p>';
            form_html += '<div class="upload_btn">';
            form_html += '<label for="upload_location_image" class="wp-repair-location-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>';
            form_html += '<input type="file" id="upload_location_image" style="display: none;" name="location_image">';
            // hidden input old image
            form_html += '<input type="hidden" name="old_location_image" value="'+ value +'">';
            let hasImage = '';
            if(value && value != '') {
                hasImage = 'hasImage';
            }
            form_html += '<div class="uploaded_img '+hasImage+'" style="margin-top:8px">';
            if( value && value != '' ) {
                form_html += '<img class="new_image" src="'+value+'"><div class="remove-uploaded-image"><button type="button" class="clear-image"><i class="fas fa-times"></i></button></div>';
            }
            form_html += '</div>';
            form_html += '</div>';
            // recommended size: 200x150 (4:3)
            form_html += '<p class="company-logo-theme-color recommended-size">Recommended size: 500px x 125px (4:1)</p>';

        } else if( key == 'schedule' ) {

            form_html += '<p class="company-logo-theme-color">'+readable_key+'</p>';
            form_html += '<div class="wp-repair-repair-card">';
            // select
            form_html += '<select class="form-control coupons_select" name="'+ key +'">';
            form_html += '<option value="">-- Select --</option>';
            for( scheduleKey in data.available_schedules ) {
                let selected = '';
                schedule = data.available_schedules[scheduleKey];
                if( schedule.id == value ) {
                    selected = 'selected="selected"';
                }
                form_html += '<option '+selected+' value="'+ schedule.id +'">'+ schedule.name +'</option>';
            }
            form_html += '</select>';
            form_html += '</div>';

        } else if( key == 'email' ) {

            form_html += '<div class="form-group wp-repair-input-group">';
            form_html += '<label for="location_'+ key +'">'+ readable_key +'</label>';
            form_html += '<input type="email" class="form-control" id="location_'+ key +'" name="'+ key +'" value="'+ value +'">';
            form_html += '</div>';
            if(data.is_synced == 1) {
                form_html += `<p class="rp_is_synced"><small>The email shown above is synchronized with the company email. This email address will be used for all notifications containing dynamic information and to send a copy of the email when the duplication feature is enabled.</small></p>`;
            }

        } else {

            form_html += '<div class="form-group wp-repair-input-group">';
            form_html += '<label for="location_'+ key +'">'+ readable_key +'</label>';
            form_html += '<input type="text" class="form-control" id="location_'+ key +'" name="'+ key +'" value="'+ value +'">';
            form_html += '</div>';

        }

        return form_html;
    }

    function create_or_edit_entry(that, id = null, is_clone = false) {

        // check if has class processing
        if( jQuery(that).hasClass('processing') ) {
            return false;
        }

        // add class processing
        jQuery(that).addClass('processing');

        let btn = that;
        let originalHTML = jQuery(that).html();

        // width of button
        let btnWidth = jQuery(that).outerWidth();
        // round
        btnWidth = Math.round(btnWidth);
        // apply width to button
        jQuery(that).css('width', btnWidth);

        // show loading icon
        jQuery(that).html('<i class="fa fa-spinner fa-spin"></i>');

        if(is_clone) {
            is_clone = 1;
        } else {
            is_clone = 0;
        }

        repairPluginUI.ajax({
            type:'POST',
            url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
            data: {action:'rp_get_location_data_for_edit',id:id,is_clone:is_clone},
            success: function(data) {

                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");

                // blur
                jQuery(that).blur();

                try {
                    data = JSON.parse(data);
                } catch(e) {
                    data = {};
                }
                if( data && data.data ) {

                    let form_type = 'create';

                    if( data.data.id != 0 ) {

                        form_type = 'edit';

                    }

                    let modal_heading = 'Create New';
                    let modal_button = 'Create New';

                    if( form_type == 'edit' ) {

                        modal_heading = 'Edit Location';
                        modal_button = 'Update';

                    }

                    let form_html = '';

                    // multipart
                    form_html += '<form action="" method="POST" enctype="multipart/form-data">';

                    for( var key in data. data ) {

                        let value = data.data[key];

                        let readable_key = key.replace(/_/g, ' ');

                        // replace _+_ in key with single _
                        key = key.replace(/_\+_/g, '_');

                        // create input
                        form_html += create_needed_input(key, readable_key, value, data.data);

                    }

                    // close
                    form_html += '</form>';

                    showFullWidthModal(`
                        <p class="va-modal-title blue-color">${modal_heading}</p>
                        ${form_html}
                        <button type="button" class="va-button va-button-primary va-submit btn-create-edit-actual">
                            ${modal_button}
                        </button>
                    `);

                } else {

                    // something went wrong
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');

                }
            },
            error: function(response) {
                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");
                if( response && response.rp_validation_error != '' ) {
                    
                } else {
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');
                }
            }
        });

    }

    jQuery(document).on('ready', function(){

        jQuery(document).on('click', '.btn-delete-item', function(){

            // check if has class processing
            if( jQuery(this).hasClass('processing') ) {
                return false;
            }

            let id = jQuery(this).attr('data-id');
            let name = jQuery(this).attr('data-name');

            // add class processing
            jQuery(this).addClass('processing');

            let btn = this;
            let originalHTML = jQuery(this).html();

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                data: {action:'rp_deleting_location',id:id},
                success: function(data) {
                    try {
                        data = JSON.parse(data);
                    } catch(e) {
                        data = null;
                    }
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    // blur
                    jQuery(btn).blur();
                    if(data && data.status) {
                        let modal_heading = 'Delete Location';
                        if( 'safe_to_delete' in data && data.safe_to_delete == 1 ) {
                            showFullWidthModal(`
                                <p class="va-modal-title danger-color blue-color">${modal_heading}</p>
                                <p>Are you sure you want to delete this location? (<strong>${name}</strong>)</p>
                                <button data-id="${id}" data-name="${name}" type="submit" class="va-button va-button-danger va-submit btn-delete-item-confirm">
                                    Delete
                                </button>
                            `, 'location-modal-delete');
                        } else {
                            showFullWidthModal(`
                                <p class="va-modal-title danger-color blue-color">${modal_heading}</p>
                                <p>You must keep at least one location. Please create a new location before deleting this one.</p>
                            `, 'location-modal-delete');
                        }
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

        jQuery(document).on('click', '.btn-delete-item-confirm', function(){

            // check if has class proccessing
            if( jQuery(this).hasClass('proccessing') ) {
                return false;
            }

            let id = jQuery(this).attr('data-id');
            let name = jQuery(this).attr('data-name');

            // add class proccessing
            jQuery(this).addClass('proccessing');

            let btn = this;
            let originalHTML = jQuery(this).html();

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                data: {action:'rp_delete_enhanced_location',id:id},
                success: function(data) {
                    window.location.reload();
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

        jQuery(document).on('click', '.btn-create-new', function(){

            create_or_edit_entry(this);

        });

        jQuery(document).on('click', '.table-action-btn.clone-entry', function(){

            create_or_edit_entry(this, jQuery(this).data('id'), true);

        });

        jQuery(document).on('click', '.table-action-btn.edit-entry', function(){

            create_or_edit_entry(this, jQuery(this).data('id'));

        });

        jQuery(document).on('click', '.btn-create-edit-actual', function(){

            // make sure all fields are filled up
            let allFieldsFilledUp = true;

            let parent = jQuery(this).parents('.va-full-width-modal');

            jQuery(parent).find('.wp-repair-input-group').each(function(){
                let input = jQuery(this).find('input');
                // if name === google_map_link, skip
                if( input.attr('name') != 'google_map_link' && input.attr('type') != 'hidden' ) {
                    
                    if( input.val() == '' ) {
                        allFieldsFilledUp = false;
                    }

                }

            });

            // make sure select field is selected
            let selectField = jQuery(parent).find('select');
            if( selectField.length > 0 ) {
                if( selectField.val() == '' ) {
                    allFieldsFilledUp = false;
                }
            }

            if( !allFieldsFilledUp ) {
                alert('Please fill up all fields.');
                return false;
            }

            // check if has class processing
            if( jQuery(this).hasClass('processing') ) {
                return false;
            }

            // add class processing
            jQuery(this).addClass('processing');
            
            let btn = this;
            let originalHTML = jQuery(this).html();

            // width of button
            let btnWidth = jQuery(this).outerWidth();
            // apply width to button
            jQuery(this).css('width', btnWidth);

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin" style="position: relative; top: -1px;"></i>');

            let form = jQuery(parent).find('form');

            let form_data = new FormData(form[0]);

            // append action
            form_data.append('action', 'rp_create_or_edit_location');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                cache: false,
                contentType: false,
                processData: false,
                data: form_data,
                success: function(data) {
                    window.location.reload();
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

    });

    jQuery(document).on('click', '.btn-clear-search', function(e){

        e.preventDefault();

        // find closest form
        let form = jQuery(this).parents('form');

        // clear searchbox input
        jQuery(form).find('input[name="searchbox"]').val('');

        // clear schedule_group_search select
        jQuery(form).find('select[name="schedule_group_search"]').val('');

        // show loading icon
        jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

        // trigger click on search button
        jQuery(form).find('.btn-search').addClass('custom-click').trigger('click');
        
    });

    jQuery(document).on('click', '.search-button .btn-search', function(e){

        e.preventDefault();

        if( !jQuery(this).hasClass('custom-click') ) {

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

        }

        // find closest form
        let form = jQuery(this).parents('form');

        // get all inputs , select, textarea
        let inputs = jQuery(form).find('input, select');

        // create url encoded string
        let urlEncodedString = '';

        let needed_fields = ['page', 'section', 'tab', 'searchbox', 'schedule_group_search'];

        // loop through inputs
        jQuery(inputs).each(function(){

            // get name
            let name = jQuery(this).attr('name');

            if( needed_fields.indexOf(name) == -1 ) {
                // skip
                return true;
            }

            // get value
            let value = jQuery(this).val();

            // if name is not empty
            if( name != '' ) {

                // if value is not empty
                if( value != '' ) {

                    // if url encoded string is not empty
                    if( urlEncodedString != '' ) {
                        urlEncodedString += '&';
                    }

                    // append to url encoded string
                    urlEncodedString += name+'='+encodeURIComponent(value);

                }

            }

        });

        // get current url
        let currentUrl = window.location.href;

        // explode current url from ?
        let explodedUrl = currentUrl.split('?');

        // add encoded string to url
        let newUrl = explodedUrl[0]+'?'+urlEncodedString;

        // redirect to new url
        window.location.href = newUrl;

    });

    jQuery(document).on('click', '.uploaded_img .remove-uploaded-image .clear-image', function(){

        let parent = jQuery(this).parents('.uploaded_img');

        jQuery(parent).parents('.upload_btn').find('input[type="hidden"]').val('');

        jQuery(parent).parents('.upload_btn').find('input[type="file"]').val('');

        jQuery(parent).animate({left: '-200%'}, 300, function(){
            jQuery(parent).html('').removeClass('hasImage').css('left', '0px');
        }); // hide image

    });

    jQuery(document).on('change', '.schedule-select', function(){

        let id = jQuery(this).data('id');

        let value = jQuery(this).val();

        if( id != '' && value != '' ) {

            // check if has class processing
            if( jQuery(this).hasClass('processing') ) {
                return false;
            }

            // add class processing
            jQuery(this).addClass('processing');

            let input = this;

            // focus out from this input
            jQuery(input).blur();

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                data: {action:'rp_update_schedule_group_of_location',id:id,value:value},
                success: function(data) {
                    jQuery(input).removeClass('processing');
                    // success
                    try {
                        data = JSON.parse(data);
                    } catch(e) {
                        data = null;
                    }
                    if( data && ( data.status == true || data.status == 1 ) ) {
                        repairPluginUI.alert_success('Schedule updated successfully.');
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                },
                error: function(response) {
                    jQuery(input).removeClass('processing');
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        }

    });

}(jQuery));

</script>