<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;
global $rpQuery;
$category_table = $rpQuery->prefix . "rs_category";
$brand_table = $rpQuery->prefix . "rs_brand";
$model_table = $rpQuery->prefix . "rs_model";

require_once( ABSPATH . 'wp-admin/includes/file.php' ); // require file.php
//--------------------------------------------------------category
if (isset($_POST['add_category'])) {

	rp_verify_csrf_token_for_simple_form('manage_categories');

	$uploadedfile = $_FILES['c_img'];
	$upload_overrides = array( 'test_form' => false ); 
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );

    $cname     = $_POST['c_name'];
    $cimg      = $movefile["url"];
    $unique_id = uniqid('category_');
    $rpQuery->query("INSERT INTO $category_table(c_name,c_img,c_uq_id) VALUES('".rp_escape_sql($cname)."','".rp_escape_sql($cimg)."','".rp_escape_sql($unique_id)."')");
}

if (isset($_POST['delete_cat'])) {

	rp_verify_csrf_token_for_simple_form('manage_categories');

    $del_id = $_POST['c_id'];
    $rpQuery->query("DELETE FROM $category_table WHERE c_id='".rp_escape_sql($del_id)."'");
	rp_remove_category_related_data($del_id);
}

if (isset($_POST['uptsubmit'])) {

	rp_verify_csrf_token_for_simple_form('manage_categories');

	$uploadedfile = $_FILES['upload_image'] ?? null; 
	$upload_overrides = array( 'test_form' => false );
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
    
    if(empty($movefile) || !isset($movefile["url"]) || $movefile["url"] == "" || $movefile["url"] == null ){
		$logo = $_POST["link"];
	}else{
		$logo = $movefile["url"];
	}

    $cid       = $_POST['c_id'];
    $cname     = $_POST['c_name'];
    $is_active = $_POST['is_active'];
    if($is_active == 'on'){
    	$is_active = '1';
    }else{
    	$is_active = '0';
    }
    $c_image   = $logo;
    $rpQuery->query("UPDATE $category_table SET c_name='".rp_escape_sql($cname)."',c_img='".rp_escape_sql($c_image)."',is_active='".rp_escape_sql($is_active)."' WHERE c_id='".rp_escape_sql($cid)."'");

}
//---------------------------------------------------brands
if (isset($_POST['add_brand'])) {

	rp_verify_csrf_token_for_simple_form('manage_categories');

	$b_image = $_FILES['b_img'];
	$upload_overrides = array( 'test_form' => false ); 
	$moveb_img = wp_handle_upload( $b_image, $upload_overrides );

    $bname     = $_POST['b_name'];
    $bimg      = $moveb_img["url"];
    $c_id_fk   = $_POST['c_id_fk'];
    $b_uq_id   = uniqid('brand_');
    $rpQuery->query("INSERT INTO $brand_table(b_name,b_img,c_id_fk,b_uq_id) VALUES('".rp_escape_sql($bname)."','".rp_escape_sql($bimg)."','".rp_escape_sql($c_id_fk)."','".rp_escape_sql($b_uq_id)."')");
}

if (isset($_POST['brandsubmit'])) {

	rp_verify_csrf_token_for_simple_form('manage_categories');

	$uploadedfile = $_FILES['upload_bimage'] ?? null; 
	$upload_overrides = array( 'test_form' => false );
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
    
    if(empty($movefile) || !isset($movefile["url"]) || $movefile["url"] == "" || $movefile["url"] == null ){
		$b_logo = $_POST["brand_link"];
	}else{
		$b_logo = $movefile["url"];
	}

    $bid     = $_POST['b_id'];
    $bname   = $_POST['b_name'];
    $b_image = $b_logo;

    $is_active = $_POST['is_active'];
    if($is_active == 'on'){
    	$is_active = '1';
    }else{
    	$is_active = '0';
    }

    $rpQuery->query("UPDATE $brand_table SET b_name='".rp_escape_sql($bname)."',b_img='".rp_escape_sql($b_image)."',is_active='".rp_escape_sql($is_active)."' WHERE b_id='".rp_escape_sql($bid)."'");
    
}
if (isset($_POST['delete_brand'])) {

	rp_verify_csrf_token_for_simple_form('manage_categories');

    $b_id = $_POST['b_id'];
    $rpQuery->query("DELETE FROM $brand_table WHERE b_id='".rp_escape_sql($b_id)."'");
	rp_delete_brand_related_data($b_id);
}
?>
<style type="text/css">
	.ractions-td span, .ractions-td button img{
		width: 19px;
	}
	.wp-repair-container .table tbody tr{
		background: #fbfbfd;
	}
	.wp-repair-container .table tbody .closed td{
		border-top: 2px solid #eeeeee;
		border-bottom: 2px solid #eeeeee;
	}	
	.wp-repair_page_wp_repair_manage_categories .wp-repair-container .brand-category tbody tr.closed td:first-child,.wp-repair_page_wp_repair_manage_categories .wp-repair-container .type-category tbody tr.closed td:first-child{
		border-left: 2px solid #eeeeee;
		border-top-left-radius: 10px;
		border-bottom-left-radius: 10px;
	}
	.wp-repair_page_wp_repair_manage_categories .wp-repair-container .type-category tbody tr.closed td:last-child,.wp-repair_page_wp_repair_manage_categories .wp-repair-container .brand-category tbody tr.closed td:last-child{
		border-right: 2px solid #eeeeee;
		border-top-right-radius: 10px;
		border-bottom-right-radius: 10px;				
	}
	.spacer td{
		padding: 2px 5px !important;
	}
	input:checked + .slider{
		background-color: #1275c2;
	}
	.wp-repair-input-group {
		position: relative;
		color: #61666b;
		margin-top: 20px;
	}
	.wp-repair-input-group label {
		position: absolute;
		font-size: 8px;
		text-transform: uppercase;
		font-weight: 600;
		letter-spacing: 1.5px;
		top: -5px;
		left: 18px;
		padding: 0px 6px;
		background: #fff;
	}
	.wp-repair-input-group input ,.wp-brand-input-group select {
		height: 42px;
		border: 2px solid #cfcfcf;
		box-shadow: none;
		outline: 0;
		box-sizing: border-box;
		width: 100%;
		font-size: 14px;
	    /*font-weight: 600;*/
	    border-radius: 8px;
	    padding: 0px 12px;
	    color: #454545;
	}
	.fs-9{
		font-size: 9px;
	}
	.cat-img{
		text-transform: uppercase;
		margin: 1em 0;
		font-weight: bold;
		letter-spacing: 1.5px;
	}
	.wp-repair-container .wp-repair-category-header button.add-category{
		position: revert;
		float: right;
	}
	tr.justForsort {
		position: relative;
	}
	table.ui-sortable {
		position: relative;
	}
	.justForsort {
		padding: 0px !important;
		margin: 0px !important;
		width: 100% !important;
		background: none !important;
	}
	.ui-sortable-helper {
	    display: table;
	    width: 100%;
	}

	/* SORT BUTTON STYLING
	START
	*/
	.repair-list-sort {
		display: table;
		cursor: pointer;
		position: relative;
		top: 0px;
	}
	.switch {
		position: relative;
		top: 3px;
	}
	.repair-list-sort i {
		display: table;
		line-height: 14px;
		padding: 0px 5px;
		font-size: 18px;
		cursor: pointer;
	}
	.repair-list-sort i:hover {
		color: #1275c2;
	}
	/* SORT BUTTON STYLING
	END
	*/
	h3.brands-text {
		margin-left: 38px;
		margin-top: 5px;
		margin-bottom: 5px;
		line-height: 1.4em;
		font-size: 12px;
		text-transform: uppercase;
		letter-spacing: 1px;
		font-weight: 700;
		    color: #737373;
	}
	.wp-repair_page_wp_repair_manage_categories .wp-repair-col-12.type-category > .table-responsive {
		width: 100%;
		display: block;
		overflow: auto;
	}
	.wp-repair_page_wp_repair_manage_categories .wp-repair-container .table.categoryContainer {
		width: 100%;
		margin-bottom: 5px;
		min-width: 700px;
	}
	@media(min-width: 1200px) {
		.wp-repair_page_wp_repair_manage_categories .wp-repair-container .category-name-td {
			width: 400px !important;
		}
	}
	@media(max-width: 1200px) {
		.wp-repair_page_wp_repair_manage_categories .wp-repair-category-header button {
			margin-bottom: 20px !important;
		}
	}
</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 type-category">
			<div class="wp-repair-category-header">
				<h2 style="margin-left: 8px;" class="bold">Manage Categories</h2>
				<h2 class="light"></h2>
				<button class="add-category brand-trigger" style="margin: 0px 5px">New Brand <i class="fas fa-plus"></i></button>
				<button class="add-category category-trigger">New Type <i class="fas fa-plus"></i></button>
				<button class="add-category" id="savecOrder" style="margin: 0px 5px">Save Order </button>
				<div class="category-modal">
			        <div class="category-modal-content">
						<div class="modal-header">
				            <span class="category-close-button">&times;</span>	
						</div>	
						<form method="post" action="" enctype="multipart/form-data">	
							<?php
							rp_csrf_token_input_field('manage_categories');
							?>
							<div class="modal-body">
								<div class="wp-repair-input-group">
									<label>Category Name</label>						
									<input type="text" name="c_name" class="user-info" required>
								</div>
								<div class="wp-repair-input-group">
									<p class="fs-9 cat-img">Category Image</p>
									<div class="upload_btn">
										<label for="upload_image" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
	          							<input type="file" onchange="readURL(this)" id="upload_image" style="display: none;" name="c_img">
										<div class="uploaded_img"></div>					
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button type="submit" id="add_category" class="btn add_category" name="add_category">Add Category <i class="fas fa-plus"></i></button>
							</div>
						</form>
			        </div>
			    </div>
			    <div class="brand-modal">
			        <div class="brand-modal-content">
						<div class="modal-header">
				            <span class="brand-close-button">&times;</span>	
						</div>	
						<form method="post" action="" enctype="multipart/form-data">	
							<?php
							rp_csrf_token_input_field('manage_categories');
							?>
							<div class="modal-body">
								<div class="wp-brand-input-group">					
									<p class="fs-9 cat-img">Choose Category</p>						
									<select class="form-control" name="c_id_fk" id="c_id_fk" required>
										<?php 
										global $rpQuery;
										$category_table = $rpQuery->prefix . "rs_category";
										$c_result = $rpQuery->get_results("SELECT * FROM $category_table WHERE is_active = '1'");
										$c_result = rp_sanitize_output($c_result);
										if($c_result){foreach($c_result as $cat){
										?>
										<option value="<?php echo $cat->c_id;?>"><?php echo $cat->c_name;?></option>
										<?php }}?>
									</select>
								</div>	
								<div class="wp-repair-input-group">					
									<label>Brand Name</label>						
									<input type="text" name="b_name" class="user-info" required>
								</div>
								<div class="wp-repair-input-group">
									<p class="fs-9 cat-img">Brand Image</p>
									<div class="upload_btn">
										<label for="upload_bimage" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
	          							<input type="file" onchange="readbURL(this)" id="upload_bimage" style="display: none;" name="b_img">
										<div class="uploaded_bimg"></div>					
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button type="submit" class="btn add_brand" id="add_brand" name="add_brand">Add Brand <i class="fas fa-plus"></i></button>
							</div>
						</form>
			        </div>
			    </div>
			</div>
			<div class="table-responsive">
				<table class="table categoryContainer">
					<tbody>
						<?php $i= 1; 
						$ib = 1;
							$c_result = $rpQuery->get_results("SELECT * FROM $category_table ORDER BY c_position ASC");
							$count_category = $rpQuery->get_var("SELECT COUNT(*) FROM $category_table");
							$count_brands = $rpQuery->get_var("SELECT COUNT(*) FROM $brand_table");

							$c_result = rp_sanitize_output($c_result);

							if($c_result){ foreach ($c_result as $print) {
								$c_id = $print->c_id;
								$total_brands = $rpQuery->get_var("SELECT COUNT(*) FROM $brand_table WHERE c_id_fk = '".rp_escape_sql($c_id)."'");
						?>
							<tr class="Orderingcategory justForsort">
								<td class="justForsort">
									<form method="post" action="" enctype="multipart/form-data">
									<?php
									rp_csrf_token_input_field('manage_categories');
									?>
<table class="justForsort mainCategoryTable">
	<body class="justForsort">
		<tr class="closed" id="<?php echo $c_id; ?>">
								<td style="width: 58px;">
									<label class="switch" style="float: left;">
									  <input type="checkbox" <?php if($print->is_active == '1'){echo 'checked';}?> name="is_active" id="is_active">
									  <span class="slider round"></span>
									</label>
									<!-- <span style="position: relative;top: -2px; float: left;" class="category-sort">
										<i class="fas fa-sort"></i>
									</span> -->
									<?php wp_repair_list_sorting_button(); ?>
								</td>
								<td class="category-name-td">
									<input class="category-name" type="text" name="c_name" value="<?php echo $print->c_name; ?>">
									<input class="total_count" type="hidden" name="" value="<?php echo $count_category; ?>">
									<span class="dark-text font-weight-700 dark-grey category-name"><?php echo $print->c_name; ?></span>
									<span class="light-text category-name">type</span>
								</td>
								<td style="width: 58px;"><span class="light-text"><?php echo $total_brands?> brands</span></td>
								<td style="width: 120px;" class="ractions-td">
									<button type="button" class="plus-icon see-more">Edit</button>
									<input type="text" value="<?php echo $print->c_uq_id?>" id="cInput<?php echo $i;?>" style="display: none;">

									<button type="button" class="wp-repair-shortcode cat_shortcode<?php echo $i;?>">
										<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/web-development.svg'; ?>">
									</button>
									<input class="c_id" type="hidden" name="c_id" value="<?php echo $c_id; ?>">
									<button type="submit" class="trash" name="delete_cat" id="delete_cat" onclick="return confirm('Are you sure to delete this category?')">
										<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/garbage.svg'; ?>">
									</button>
								</td>
							</tr>
							<tr class="more-details">
								<td colspan="7">
									<div class="details-container">
										<div class="wp-repair-inner-col section-1">
											<div class="sec-1">
												<img class="old_img<?php echo $i;?>" src="<?php echo $print->c_img; ?>" height="100">
												<div id="category_image<?php echo $i?>"></div>
											</div>
											<div class="sec-2">
												<div class="tr">
													<p class="heading">Link</p>
												</div>
												<div class="tr">
													<input type="text" name="link" class="wp-repair-category-image-url" id="img-input<?php echo $i;?>" value="<?php echo $print->c_img; ?>" readonly>
													<button type="button" class="wp-repair-cancel-link clear_img_input<?php echo $i;?>"><i class="fas fa-times"></i></button>
													
												</div>
												<div class="tr mt-10">
													<label for="upload_image<?php echo $i?>" class="wp-repair-category-image-upload-button">Upload Picture <i class="fas fa-plus"></i></label>
                  									<input type="file" id="upload_image<?php echo $i?>" style="display: none;" name="upload_image">					
												</div>
												<div class="tr">
													<p class="wp-repair-category-image-text">Image size should not exceed 150 pixels</p>
												</div>
											</div>
										</div>
										<div class="wp-repair-inner-col section-1">
											<div class="sec-3">
												<button type="submit" id="uptsubmit" name="uptsubmit" class="wp-repair-category-image-save-button">Save All Settings</button> 
											</div>
										</div>
									</div> 
								</td>
							</tr>
							<tr class="spacer"><td></td></tr>
						</body>
					</table>
				</form>				
									<?php
									$b_result = $rpQuery->get_results("SELECT * FROM $brand_table WHERE c_id_fk = '".rp_escape_sql($c_id)."' ORDER BY b_position ASC");
									$b_result = rp_sanitize_output($b_result);
									if(!empty($b_result)) {
										?>
										<!-- <h3 class="bold brands-text">Brands</h3> -->
										<?php
									}
									?>
									<table class="table brandContainer">
										<tbody>
											<?php
												if($b_result){foreach ($b_result as $bprint) {
													$b_id = $bprint->b_id;
													$m_results = "SELECT COUNT(*) FROM $model_table WHERE brand_id_fk = '$b_id'";
					    							$total_models = $rpQuery->get_var($m_results);
					    							//echo $total_models;
											?>
												<tr class="Orderingbrand justForsort">
													<td class="justForsort">
														<form method="post" action="" enctype="multipart/form-data">
														<?php
														rp_csrf_token_input_field('manage_categories');
														?>
														<table class="justForsort">
															<tbody class="justForsort">
					<tr class="closed summary" id="<?php echo $b_id; ?>">
													<td style="width: 58px;">
														<label class="switch" style="float: left;">
														  <input type="checkbox" <?php if($bprint->is_active == '1'){echo 'checked';}?> name="is_active" id="is_active">
														  <span class="slider round"></span>
														</label>
														<!-- <span style="position: relative;top: -2px; float: left;" class="category-sort">
															<i class="fas fa-sort"></i>
														</span> -->
														<?php wp_repair_list_sorting_button(); ?>
													</td>
													<td class="category-name-td">
														<input class="category-name" type="text" name="b_name" value="<?php echo $bprint->b_name; ?>">									
														<input class="total_bcount" type="hidden" name="" value="<?php echo $count_brands; ?>">
														<span class="dark-text font-weight-700 dark-grey category-name"><?php echo $bprint->b_name; ?></span> <span class="light-text category-name">brand</span>
													</td>
													<td style="width: 55px"><span class="light-text"><?php echo $total_models?> models</span></td>
													<td style="width: 120px" class="ractions-td">
														<input type="text" value="<?php echo $bprint->b_uq_id?>" id="bInput<?php echo $ib;?>" style="display: none;">

														<button type="button" class="plus-icon see-more">Edit</button>
														<button type="button" class="wp-repair-shortcode b_shortcode<?php echo $ib;?>"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/web-development.svg'; ?>"></button>
														<input class="b_id" type="hidden" name="b_id" value="<?php echo $b_id; ?>">
														<button type="submit" class="trash" name="delete_brand" id="delete_brand" onclick="return confirm('Are you sure to delete this brand?')">
															<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/garbage.svg'; ?>">
														</button>
													</td>
												</tr>
												<tr class="more-details">
													<td colspan="7">
														<div class="details-container">

															<div class="wp-repair-inner-col section-1">
																<div class="sec-1">
																	<img class="old_bimg<?php echo $ib;?>" src="<?php echo $bprint->b_img; ?>" height="100">
																	<div id="brand_image<?php echo $ib;?>"></div>
																</div>
																<div class="sec-2">
																	<div class="tr">
																		<p class="heading">Link</p>
																	</div>
																	<div class="tr">
																		<input type="text" name="brand_link" class="wp-repair-category-image-url" id="img-binput<?php echo $ib;?>" value="<?php echo $bprint->b_img; ?>" readonly>
																		<button type="button" class="wp-repair-cancel-link clear_img_binput<?php echo $ib;?>"><i class="fas fa-times"></i></button>
																	</div>
																	<div class="tr mt-10">
																		<label for="upload_bimage<?php echo $ib;?>" class="wp-repair-category-image-upload-button">Upload Picture <i class="fas fa-plus"></i></label>
					                  									<input type="file" id="upload_bimage<?php echo $ib;?>" style="display: none;" name="upload_bimage">					
																	</div>
																	<div class="tr">
																		<p class="wp-repair-category-image-text">Image size should not exceed 150 pixels</p>
																	</div>
																</div>
															</div>
															<div class="wp-repair-inner-col section-1">
																<div class="sec-3">
																	<button type="submit" id="brandsubmit" name="brandsubmit" class="wp-repair-category-image-save-button">Save All Settings</button>
																</div>
															</div>
														</div>
													</td>
												</tr>
											<tr class="spacer"><td></td></tr>
															</tbody>
														</table>
														</form>
													</td>
												</tr>
											<?php $ib++;} }?>
										</tbody>
									</table>
								</td>
							</tr>
						<?php $i++;} }?>
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>
<script type="text/javascript">
	jQuery(document).on("wpRepairReady", function(){
		var total_count = jQuery('.total_count').val();
		//console.log(total_count);
		for (let i = 1; i <= total_count; i++) {
			jQuery('.clear_img_input'+i).on('click', function(){
				jQuery('#img-input'+i).val('');
			});
			jQuery('.cat_shortcode'+i).on('click', function(){
				var copyText = document.getElementById("cInput"+i);
			  	/* Select the text field */
			  	copyText.select();
			  	copyText.setSelectionRange(0, 99999); /* For mobile devices */
				if(navigator && navigator.clipboard) {
					/* Copy the text inside the text field */
					navigator.clipboard.writeText('[categories code=' +copyText.value+ ']');  
				}
			  	/* Alert the copied text */
			  	alert('Copied To Clipboard: ' + '[categories code=' +copyText.value+ ']');
			});

			function previewImages() {
		  		var preview = document.querySelector('#category_image'+i);
		  		//var preview_input = document.querySelector('#img-input'+i);
			  	if (this.files) {
			    	[].forEach.call(this.files, readAndPreview);
			  	}
		  		function readAndPreview(file) {
		    		// Make sure `file.name` matches our extensions criteria
				    if (!/\.(jpe?g|png|gif)$/i.test(file.name)) {
				      return alert(file.name + " is not an image");
				    } // else...
		    		var reader = new FileReader();
				    reader.addEventListener("load", function() {
				      var image = new Image();
				      image.height = 80;
				      image.width = 80;
				      image.title  = file.name;
				      image.src    = this.result;

				      preview.appendChild(image);
				      document.querySelector('.old_img'+i).remove();
				    });
		    		reader.readAsDataURL(file);
		  		}
			}
			document.querySelector('#upload_image'+i).addEventListener("change", previewImages);
		}

		var total_bcount = jQuery('.total_bcount').val();
		//console.log(total_bcount);
		for (let i = 1; i <= total_bcount; i++) {
			jQuery('.clear_img_binput'+i).on('click', function(){
				jQuery('#img-binput'+i).val('');
			});
			jQuery('.b_shortcode'+i).on('click', function(){
				var copybcode = document.getElementById("bInput"+i);
			  	/* Select the text field */
			  	copybcode.select();
			  	copybcode.setSelectionRange(0, 99999); /* For mobile devices */
				if(navigator && navigator.clipboard) {
					/* Copy the text inside the text field */
					navigator.clipboard.writeText('[brands code='+copybcode.value+']');   
				}
			  	/* Alert the copied text */
			  	alert('Copied To Clipboard: ' + '[brands code='+copybcode.value+']');
			});

			function previewImages() {
		  		var preview = document.querySelector('#brand_image'+i);
		  		//var preview_input = document.querySelector('#img-input'+i);
			  	if (this.files) {
			    	[].forEach.call(this.files, readAndPreview);
			  	}
		  		function readAndPreview(file) {
		    		// Make sure `file.name` matches our extensions criteria
				    if (!/\.(jpe?g|png|gif)$/i.test(file.name)) {
				      return alert(file.name + " is not an image");
				    } // else...
		    		var reader = new FileReader();
				    reader.addEventListener("load", function() {
				      var image = new Image();
				      image.height = 50;
				      image.width = 80;
				      image.title  = file.name;
				      image.src    = this.result;

				      preview.appendChild(image);
				      document.querySelector('.old_bimg'+i).remove();
				    });
		    		reader.readAsDataURL(file);
		  		}
			}
			document.querySelector('#upload_bimage'+i).addEventListener("change", previewImages);
		}
	});


const category_modal = document.querySelector(".category-modal");
const category_trigger = document.querySelector(".category-trigger");
const categorycloseButton = document.querySelector(".category-close-button");

function toggleCategoryModal() {
    category_modal.classList.toggle("show-category-modal");
}

function categorywindowOnClick(event) {
    if (event.target === category_modal) {
        toggleCategoryModal();
    }
}

category_trigger.addEventListener("click", toggleCategoryModal);
categorycloseButton.addEventListener("click", toggleCategoryModal);
window.addEventListener("click", categorywindowOnClick);
	
//------------------------------------------------
const brand_modal = document.querySelector(".brand-modal");
const brand_trigger = document.querySelector(".brand-trigger");
const brand_close_button = document.querySelector(".brand-close-button");

function toggleBrandModal() {
    brand_modal.classList.toggle("show-brand-modal");
}

function brandwindowOnClick(event) {
    if (event.target === brand_modal) {
        toggleBrandModal();
    }
}

brand_trigger.addEventListener("click", toggleBrandModal);
brand_close_button.addEventListener("click", toggleBrandModal);
window.addEventListener("click", brandwindowOnClick);
</script>
<script type="text/javascript">
	function readURL(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'" height="100">');
			}
			reader.readAsDataURL(input.files[0]);
		}
	}
</script>
<script type="text/javascript">
	function readbURL(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(".uploaded_bimg").html('<img class="new_bimage" src="'+e.target.result+'" height="100">');
			}
			reader.readAsDataURL(input.files[0]);
		}
	}
</script>
<script type="text/javascript">
function moveUp(item) {
    var prev = item.prev();
    if (prev.length == 0)
        return;
    prev.css('z-index', 999).css('position','relative').animate({ top: item.height() }, 250);
    item.css('z-index', 1000).css('position', 'relative').animate({ top: '-' + prev.height() }, 300, function () {
        prev.css('z-index', '').css('top', '').css('position', '');
        item.css('z-index', '').css('top', '').css('position', '');
        item.insertBefore(prev);
    });
}
function moveDown(item) {
    var next = item.next();
    if (next.length == 0)
        return;
    next.css('z-index', 999).css('position', 'relative').animate({ top: '-' + item.height() }, 250);
    item.css('z-index', 1000).css('position', 'relative').animate({ top: next.height() }, 300, function () {
        next.css('z-index', '').css('top', '').css('position', '');
        item.css('z-index', '').css('top', '').css('position', '');
        item.insertAfter(next);
    });
}
jQuery('#savecOrder').click(function (e) {
    e.preventDefault();
    var btndata = jQuery(this).html('');
    jQuery(btndata).html('Please Wait');
    var c_position = [];
    jQuery('.categoryContainer .Orderingcategory').each(function(){
    	c_position.push(jQuery(this).find("input[name='c_id']").val());
    });
    var b_position = [];
    jQuery('.brandContainer .Orderingbrand').each(function(){
    	b_position.push(jQuery(this).find("input[name='b_id']").val());
    });
    repairPluginUI.ajax({
    	type:'POST',
      	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
      	data: {action:'update_category_and_brand_position',c_position:c_position,b_position:b_position},
      	success: function(response) {
      		location.reload();
      	}
    });
});
jQuery(".categoryContainer").sortable({ items: ".Orderingcategory", distance: 5, handle: '.mainCategoryTable .repair-list-sort' });
jQuery('.Orderingcategory .mainCategoryTable .repair-list-sort .fas').click(function() { 
    var btn = jQuery(this);
    var val = btn.data('which');
    if (val == 'up')
        moveUp(btn.parents('.Orderingcategory'));
    else
        moveDown(btn.parents('.Orderingcategory'));
});
jQuery(".brandContainer").sortable({ items: ".Orderingbrand", distance: 5, handle: '.repair-list-sort' });
jQuery('.Orderingbrand .repair-list-sort .fas').click(function() { 
    var btn = jQuery(this);
    var val = btn.data('which');
    if (val == 'up')
        moveUp(btn.parents('.Orderingbrand'));
    else
        moveDown(btn.parents('.Orderingbrand'));
});
</script>