<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;
global $rpQuery;

$localization = $rpQuery->prefix . "rs_localization";
$default_repair_table = $rpQuery->prefix . "rs_default_repair";
$repair_table = $rpQuery->prefix . "rs_repair";
$dr_attr_table = $rpQuery->prefix . "rs_default_repair_attr";
$r_attr_table = $rpQuery->prefix . "rs_repair_attr";

$localization_data = $rpQuery->get_results("SELECT * FROM $localization");
$decimal = $localization_data[0]->set_decimals;

$model_table = $rpQuery->prefix . "rs_model";

$m_result = $rpQuery->get_results("SELECT * FROM $model_table");

$default_color_table = $rpQuery->prefix . "rs_default_color";

$modelcolor_table = $rpQuery->prefix . "rs_model_color";

$category_table = $rpQuery->prefix . "rs_category";

$c_result = $rpQuery->get_results("SELECT * FROM $category_table");

$c_result = rp_sanitize_output($c_result);

$brand_table= $rpQuery->prefix . "rs_brand";

$category_table = $rpQuery->prefix . "rs_category";

$b_result = $rpQuery->get_results("SELECT * FROM $brand_table GROUP BY b_name");

$b_result = rp_sanitize_output($b_result);

require_once( ABSPATH . 'wp-admin/includes/file.php' ); // require file.php

require_once( WP_REPAIR_PLUGIN_PATH . 'html/manage_repairs_standalone.php' );

wp_repair_add_colors_to_models_if_needed();

if (isset($_POST['add_repair'])) {
	rp_verify_csrf_token_for_simple_form('manage_models');
	$uploadedfile = $_FILES['r_img'];
	$upload_overrides = array( 'test_form' => false ); 
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
	$r_name       = $_POST['r_name'];
	$r_img        = $movefile["url"];
	$r_price      = $_POST['r_price'];
	$r_duration   = $_POST['r_duration'];
	$r_discription= $_POST['r_discription'];
	$m_id         = $_POST['m_id'];
	$r_uq_id      = uniqid('repair_');
	if(preg_match('/,/',$r_price)) {
		$price = str_replace(',','.',$r_price);
	}else{
		$price = $r_price;					
	}
	$rpQuery->query("INSERT INTO $repair_table(r_name,r_img,r_price,r_duration,r_discription,m_id_fk,r_uq_id) VALUES('".rp_escape_sql($r_name)."','".rp_escape_sql($r_img)."','".rp_escape_sql($price)."','".rp_escape_sql($r_duration)."','".rp_escape_sql($r_discription)."','".rp_escape_sql($m_id)."','".rp_escape_sql($r_uq_id)."')");
}
if (isset($_POST['add_r_attr'])) {
	rp_verify_csrf_token_for_simple_form('manage_models');
	$ra_name  = $_POST['ra_name'];
	$ra_price = $_POST['ra_price'];
	$r_id     = $_POST['r_id_fk'];
	$a_uq_id  = uniqid('rattr_');
	if(preg_match('/,/',$ra_price)) {
		$price = str_replace(',','.',$ra_price);
	}else{
		$price = $ra_price;					
	}
	$rpQuery->query("INSERT INTO $r_attr_table(a_name,a_price,r_id_fk,a_uq_id) VALUES('".rp_escape_sql($ra_name)."','".rp_escape_sql($price)."','".rp_escape_sql($r_id)."','".rp_escape_sql($a_uq_id)."')");
    //echo "<script>location.replace('admin.php?page=wp_repair_manage_repairs');</script>";
}


if (isset($_POST['add_model'])) {
	rp_verify_csrf_token_for_simple_form('manage_models');
	$uploadedfile = $_FILES['m_img'];
	$upload_overrides = array( 'test_form' => false ); 
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
	$m_name       = $_POST['mname'];
	$m_img        = $movefile["url"];
	$m_code       = $_POST['mcode'];
	$release_date = date('Y-m-d', strtotime($_POST['releasedate']));
	$device_type  = $_POST['device_type'];
	$brand_id_fk  = $_POST['brand_id_fk'];
	$m_uq_id      = uniqid('model_');

	$r_ids = rp_get_all_default_repair_ids_of_category($device_type, TRUE);

	$rpQuery->query("INSERT INTO $model_table(m_name,m_img,device_type,brand_id_fk,m_code,release_date,m_uq_id,repair_ids) VALUES('".rp_escape_sql($m_name)."','".rp_escape_sql($m_img)."','".rp_escape_sql($device_type)."','".rp_escape_sql($brand_id_fk)."','".rp_escape_sql($m_code)."','".rp_escape_sql($release_date)."','".rp_escape_sql($m_uq_id)."', '".rp_escape_sql($r_ids)."')");
}

if (isset($_POST['add_color'])) {
	rp_verify_csrf_token_for_simple_form('manage_models');
	$c_name   = $_POST['color_name'];
	$c_code   = $_POST['color_code'];
	$m_id     = $_POST['m_id'];
	$mc_uq_id  = uniqid('modelcolor_');

	$rpQuery->query("INSERT INTO $modelcolor_table(color_name,color_code,mc_uq_id,m_id_fk) VALUES('".rp_escape_sql($c_name)."','".rp_escape_sql($c_code)."','".rp_escape_sql($mc_uq_id)."','".rp_escape_sql($m_id)."')");
	echo "<script>location.replace('admin.php?page=wp_repair_manage_models');</script>";
}
if (isset($_POST['delete_color'])) {
	rp_verify_csrf_token_for_simple_form('manage_models');
	$mc_id = $_POST['mc_id'] ?? null;
	if(!empty($mc_id)) {
		if(is_array($mc_id)) {
			$mc_id = $mc_id[0];
		}
		$rpQuery->query("DELETE FROM $modelcolor_table WHERE mc_id='".rp_escape_sql($mc_id)."'");
	}
	echo "<script>location.replace('admin.php?page=wp_repair_manage_models');</script>";
}


ob_start();
$pagenum = isset( $_GET['pagenum'] ) ? absint( $_GET['pagenum'] ) : 1;

$limit    = 10;
$offset   = ( $pagenum - 1 ) * $limit;


$brand = $_REQUEST['brand'] ?? '';

$category = $_REQUEST['category'] ?? '';

$search_model = $_REQUEST['search_model'] ?? '';

$sort_by = $_REQUEST['sort_by'] ?? '';

$sort_order = $_REQUEST['sort_order'] ?? 'ASC';

$brand = trim($brand);

$category = trim($category);

$search_model = trim($search_model, '%');

$sort_by = trim($sort_by);

// Does $sort_by contains valid / allowed column?

if( !in_array( $sort_by, array( 'm.m_name', 'm.m_code', 'b.b_name', 'c.c_name', 'm.release_date' ) ) ) {

	$sort_by = '';

}

$sort_order = trim($sort_order);


$where = array();
$get_paramters = array();
$order_by_str = 'ORDER BY brand_id_fk ASC, m_position ASC, release_date DESC';

if(!empty($brand) && trim(strtolower($brand)) !== 'all') {
	$where[] = "b.b_name LIKE '$brand'";
	$get_paramters[] = "brand=$brand";
}

if(!empty($category)) {
	$where[] = "c.c_name LIKE '$category'";
	$get_paramters[] = "category=$category";
}

if(!empty($search_model)) {
	$where[] = "(m.m_name LIKE '%$search_model%' OR m.m_code LIKE '%$search_model%')";
	$get_paramters[] = "search_model=".urlencode($search_model);
}

if(!empty($sort_by)) {
	if(strtoupper($sort_order) === 'ASC') {
		$sort_order = 'ASC';
	} else {
		$sort_order = 'DESC';
	}
	if($sort_by === 'm.release_date') {
		$order_by_str = "ORDER BY DATE($sort_by) $sort_order";
	} else {
		$order_by_str = "ORDER BY $sort_by $sort_order";
	}
	$get_paramters[] = "sort_by=$sort_by";
	$get_paramters[] = "sort_order=$sort_order";
}

if(!empty($where)) {
	$where_str = 'WHERE ' . join(' AND ', $where);
} else {
	$where_str = '';
}

if(!empty($get_paramters)) {
	$get_paramters_str = '&'. join('&', $get_paramters);
} else {
	$get_paramters_str = '';
}


$count_models = $rpQuery->get_var("SELECT COUNT(*) FROM $model_table AS m
	Left Join $category_table AS c ON c.c_id = m.device_type 
	Left Join $brand_table AS b ON b.b_id = m.brand_id_fk 
 {$where_str}");

$num_of_pages = ceil($count_models / $limit);

$m_result = $rpQuery->get_results("SELECT m.*,b.b_name,c.c_name FROM $model_table AS m 
	Left Join $category_table AS c ON c.c_id = m.device_type 
	Left Join $brand_table AS b ON b.b_id = m.brand_id_fk 
	{$where_str}
	{$order_by_str} 
	LIMIT $offset, $limit");

$m_result = rp_sanitize_output($m_result);

$page_links = paginate_links( array(
	'base' => add_query_arg( 'pagenum', '%#%' ,'admin.php?page=wp_repair_manage_models'.$get_paramters_str),
	'mid_size'  => 9,
	'format' => '',
	'prev_text' => __( '&laquo;', 'text-domain' ),
	'next_text' => __( '&raquo;', 'text-domain' ),
	'total' => $num_of_pages,
	'current' => $pagenum
));


$category_brand_pair = wp_repair_get_brands_of_category();
$category_brand_pair = rp_sanitize_output($category_brand_pair);
$category_brand_pair = json_encode($category_brand_pair);

global $added_margin_column;
$added_margin_column = FALSE;
$price_markup = '<th style="width: 75px"><p>Price</p></th>';
$filtered_price_th = apply_filters('rp_individual_repair_price_th', $price_markup);
if( $price_markup !== $filtered_price_th ) {
	$added_margin_column = TRUE;
}

?>
<style type="text/css">
	<?php
	if( $added_margin_column === TRUE ) {
		?>
		.wp-repair-container .wp-repair-row {
			max-width: 1275px;
		}
		.wp-repair-container .table {
			min-width: 1240px;
		}
		<?php
	} else {
		?>
		.wp-repair-container .wp-repair-row {
			max-width: 1200px;
		}
		.wp-repair-container .table {
			min-width: 1160px;
		}
		<?php
	}
	?>
	input.repair-badge {
		max-width: 175px;
	}
	tr.justForsort.Orderingrepairs.draggable .button {
		position: absolute;
		cursor: move;
		top: 7px;
		left: 50%;
    	transform: translateX(-50%);
		margin: 0px 2px;
	}

	tr.justForsort.Orderingrepairs.draggable td {
		padding-bottom: 12px !important;
		padding-top: 14px !important;
	}

	.wp-repair_page_wp_repair_manage_models tr.justForsort.Orderingrepairs.draggable td {
		padding-bottom: 5px !important;
	}

	tr.justForsort.Orderingrepairs.draggable .button:before, tr.justForsort.Orderingrepairs.draggable .button:after {
		content: "";
		height: 30px;
		width: 10px;
		background-color: #fbfbfb;
		display: block;
		position: absolute;
		left: -11px;
		top: 0;
	}

	tr.justForsort.Orderingrepairs.draggable .button:after {
		left: auto;
		right: -11px;
	}
	tr.justForsort.Orderingrepairs.draggable {
		border: 0 !important;
		cursor: move;
	}

	tr.justForsort.Orderingrepairs.draggable hr {
		border-width: thick;
		cursor: move;
	}
.wp-repair_page_wp_repair_manage_models .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td,
.wp-repair_page_wp_repair_manage_models .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td:nth-child(1) span,
.wp-repair_page_wp_repair_manage_models .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td:nth-child(1) input,
.wp-repair_page_wp_repair_manage_models .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td:nth-child(1) button {
	vertical-align: middle;
}
	.wp-repair_page_wp_repair_manage_models .wp-repair-container .wp-repair-inner-col.section-1 .OrderingrepairsAttr td input {
		/* min-height: 30px; */
	}
	.wp-repair_page_wp_repair_manage_models .wp-repair-container .wp-repair-inner-col.section-1 tbody.the-additional-repair tr.additional-repair-tr td {
		padding-bottom: 8px !important;
	}
.hidden {
	display: none;
}
.wp-repair-shortcode{
	margin-right: 5px !important;
	margin-left: 8px !important;
}
.upsale{
	margin-right: 5px !important;
}
.add-repair-btn{
	position: relative !important;
	margin-top: 8px !important;
}
.add-repair-btn.update_repair {
	min-width: 148px;
}
.add-repair-btn.delete_model_related_repairs {
	min-width: 178px;
	background: #fff !important;
	color: #b10000 !important;
	padding: 6px 12px;
	border: 2px solid #b10000 !important;
}
.additional-actions button.dropdown,
.additional-actions .add-more {
	width: 29px !important;
	box-sizing: border-box !important;
}
.additional-actions button.dropdown {
	top: 0px !important;
	position: relative !important;
}

.wp-repair-container .type-category tbody tr.closed td:first-child{
	border-left: 2px solid #eeeeee;
}

.OrderingrepairsAttr .repair-list-sort {
	margin-right: 5px;
}

.img-repair-show {
	width: 32px;
	margin: auto;
	text-align: center;
	float: left;
	position: relative;
	height: 32px;
	display: block;
	margin-left: 8px;
	transition: all 0.3s;
}
.img-repair-show img {
	max-width: 32px;
	max-height: 32px;
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
}
.image-upload-repair-btn {
	margin: 0px 3px !important;
	position: relative;
	top: -1px;
}
.image-upload-repair-btn img {
	width: 20.5px !important;
	height: auto !important;
}
label.label-upload-image {
	display: inline-table;
	margin-left: 4px;
	position: relative;
	top: -1px;
}
.wp-repair_page_wp_repair_manage_models button img{
	width: 19px;
}
.wp-repair-container .table tbody tr{
	background: #fbfbfd;		
}
.wp-repair-container .table tbody .closed td{
	border-top: 2px solid #eeeeee;
	border-bottom: 2px solid #eeeeee;
}
.wp-repair_page_wp_repair_manage_models .wp-repair-container .plus-icon.see-more{
	margin-top: 3px !important;
	margin-bottom: 3px !important;
}
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.category td:first-child{
	border-left: 2px solid #eeeeee;
}
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.closed td:last-child{
	border-right: 2px solid #eeeeee;				
}
input:checked + .slider{
	background-color: #1275c2;
}
.wp-repair-input-group {
	position: relative;
	color: #61666b;
	margin-top: 20px;
}
.wp-repair-input-group label {
	position: absolute;
	font-size: 8px;
	text-transform: uppercase;
	font-weight: 600;
	letter-spacing: 1.5px;
	top: -5px;
	left: 18px;
	padding: 0px 6px;
	background: #fff;
}
.wp-repair-input-group input ,.wp-brand-input-group select {
	height: 42px !important;
	border: 2px solid #cfcfcf;
	box-shadow: none;
	outline: 0;
	box-sizing: border-box;
	width: 100%;
	font-size: 14px;
	/*font-weight: 600;*/
	border-radius: 8px;
	padding: 0px 12px;
	color: #454545;
}
.wp-repair-input-group textarea {
	height: 42px;
	border: 2px solid #cfcfcf;
	box-shadow: none;
	outline: 0;
	box-sizing: border-box;
	width: 100%;
	font-size: 14px;
	/*font-weight: 600;*/
	border-radius: 8px;
	padding: 12px;
	color: #454545;
}

.va-full-width-modal-inner .wp-repair-input-group {
	margin-top: 10px;
}

.img{
	text-transform: uppercase;
	margin: 1em 0;
	font-weight: bold;
	letter-spacing: 1.5px;
}
.fs-9{
	font-size: 9px;
}
.cat-img,.b-img{
	text-transform: uppercase;
	margin: 1em 0;
	font-weight: bold;
	letter-spacing: 1.5px;
}
.btn,.submit {
	background-color: #1275c2 !important;
	border: none !important;
	color: white !important;
	padding: 10px !important;
	text-align: center !important;
	text-decoration: none !important;
	display: inline-block !important;
	font-size: 12px !important;
	margin: 4px 0px !important;
	border-radius: 8px !important;
	float: right !important;
	letter-spacing: 1px;
	font-weight: 700;
	cursor: pointer;
}
.wp-repair-container .table tbody .closed td:first-child{
	border-left: 2px solid #eeeeee;
}
.tablenav{
	margin: 6px auto 4px; 
	max-width: 30%;
}
.tablenav-pages{
	font-size: 15px !important;
	float: initial !important;
}
tr.justForsort,
.append_attr_data {
	position: relative;
}
table.ui-sortable {
	position: relative;
}
.justForsort {
	padding: 0px !important;
	margin: 0px !important;
	width: 100% !important;
	background: none !important;
}
.ui-sortable-helper {
	display: table;
	width: 100%;
}
.OrderingrepairsAttr.ui-sortable-helper {
	display: table;
	width: 100%;
	max-width: 100%;
}
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td.justForsort,
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.active.more-details td.justForsort {
	padding: 0px !important;
}
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details .main-repair td, 
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.active.more-details .main-repair td,
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details .main-repair td.justForsort, 
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.active.more-details .main-repair td.justForsort {
	border-top-left-radius: 0px;
	    border-bottom-left-radius: 0px;
	    border-top-right-radius: 0px;
	    border-bottom-right-radius: 0px;
	    border: unset;
}
.wp-repair-container .table tbody.justForsort > tr.closed {
	background: none !important;
}
.wp-repair-container .table tbody.justForsort > tr.closed > td {
	background: #fafafa;
}
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td.justForsort, 
.wp-repair_page_wp_repair_manage_repairs .wp-repair-container .type-category tbody tr.more-details td.justForsort,
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td, 
.wp-repair_page_wp_repair_manage_repairs .wp-repair-container .type-category tbody tr.more-details td,
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.more-details td, 
.wp-repair_page_wp_repair_manage_repairs .wp-repair-container .type-category tbody tr.more-details td,
.wp-repair_page_wp_repair_manage_repairs .wp-repair-container .type-category tbody tr.more-details > td,
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details tr.OrderingrepairsAttr td, 
.wp-repair_page_wp_repair_manage_repairs .wp-repair-container .type-category tbody tr.active.more-details tr.OrderingrepairsAttr td {
	border-top-left-radius: 0px;
	    border-bottom-left-radius: 0px;
	    border-top-right-radius: 0px;
	    border-bottom-right-radius: 0px;
	    border: unset;
}
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td.justForsort, 
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details td.justForsort,
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.active.more-details td, 
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details td,
.wp-repair_page_wp_repair_appointments .wp-repair-container tbody tr.more-details td, 
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details td,
.wp-repair_page_wp_repair_manage_models .wp-repair-container .type-category tbody tr.more-details > td {
	border-top-left-radius: 0px;
	    border-bottom-left-radius: 0px;
	    border-top-right-radius: 0px;
	    border-bottom-right-radius: 0px;
	    border: unset;
}
/* SORT BUTTON STYLING
START
*/
td button{
	cursor: pointer !important;
}
.repair-list-sort {
	display: table;
	cursor: pointer;
	position: relative;
	top: 0px;
	float: left;
	    margin-left: 4px;
	    border: 1px solid #adadad;
	    padding: 0px;
	    color: #646464;
	    border-radius: 5px;
}
.switch {
	position: relative;
	top: 3px;
	float: left;
}
.repair-list-sort i {
	display: table;
	line-height: 12px;
	padding: 0px 4px 0px 4px;
	font-size: 16px;
	cursor: pointer;
}
.repair-list-sort i.fa-caret-down {
	padding-bottom: 1px;
}
.repair-list-sort i.fa-caret-up {
	padding-top: 1px;
}
.repair-list-sort i:hover {
	color: #1275c2;
}
.tr.multirows {
	display: table;
}
.tr.multirows .upload_btn {
	margin-bottom: 0px !important;
	margin-top: 10px !important;
}
/* SORT BUTTON STYLING
END
*/
img.uploaded_img {
	height: auto !important;
	width: auto !important;
	max-height: 80px;
	max-width: 80px;
}


.table.colorContainer {
	overflow: hidden;
}
#savemOrder {
	min-height: 40px;
	display: none;
}
.wp-repair_page_wp_repair_manage_models .add-color-btn {
	min-width: 115px;
}
#fastDelete {
	display: inline-table;
	margin: 7px 5px 0px 5px;
	width: 200px;
	box-sizing: border-box;
	min-height: 40px;
	background: #fff !important;
	color: #1275c2 !important;
}
#fastDelete.active {
	background: #1275c2 !important;
	color: #fff !important;
}
.delete-color-btn {
	height: 100%;
}
.new-model-content .add_model {
	min-width: 135px;
}
*, body, button {
	-webkit-font-smoothing: antialiased;
	text-rendering: optimizeLegibility !important;
	-webkit-font-smoothing: antialiased !important;
	-moz-osx-font-smoothing: grayscale !important; 
	-webkit-backface-visibility: hidden;
}

.details-container tr.closed td {
	border: 0px !important;
}


	tr.unsaved td input[type="text"],
	.sec-sorting.unsaved input[type="text"],
	.tr.unsaved input[type="text"],
	.upload_btn label.unsaved {
		background: rgb(0 104 255 / 5%) !important;
	}

	tr.unsaved td select {
		background-color: rgb(0 104 255 / 5%) !important;
	}

	.upload_btn label.unsaved:hover,
	.upload_btn label.unsaved:active,
	.upload_btn label.unsaved:focus {
		background: #1275c2 !important;
    color: #fff !important;
	}

	a.rp_sortable_link {
		text-decoration: none;
		outline: 0 !important;
		box-shadow: unset !important;
		border: 0px !important;
	}
	a.rp_sortable_link:hover, 
	a.rp_sortable_link:focus, 
	a.rp_sortable_link:active {
		text-decoration: underline;
		outline: 0 !important;
		box-shadow: unset !important;
		border: 0px !important;
	}

		button.see-more.unsaved,
		.repair-list-sort.unsaved {
			background: rgb(0 104 255 / 5%) !important;
		}
		button.see-more.unsaved:hover,
		button.see-more.unsaved:active,
		button.see-more.unsaved:focus {
			background: #1275c2 !important;
	    color: #fff !important;
		}

	#saveChanges {
		display: inline-table;
		width: 175px;
		min-height: 40px;
	}
	#saveChanges.hide {
		display: none;
	}
	.wp-repair-container ::placeholder { /* Chrome, Firefox, Opera, Safari 10.1+ */
	  color: #646464;
	  opacity: 0.4;
	}

	.wp-repair-container :-ms-input-placeholder { /* Internet Explorer 10-11 */
	  color: #646464;
	  opacity: 0.4;
	}

	.wp-repair-container ::-ms-input-placeholder {
	  color: #646464;
	  opacity: 0.4;
	}

	.wp-repair-container .type-category tbody tr.closed .btn-actions{
		border-right: 2px solid #eeeeee;
		border-top-right-radius: 10px;				
		border-bottom-right-radius: 10px;				
	}


	.globe-icon-translation {
							cursor: pointer;
							width: calc(100% - 14px);
							height: 28px;
							position: absolute;
							top: 50%;
							transform: translateY(-50%);
						}

						.globe-icon-attr {
							position: relative;
							display: inline-table;
						}

						.globe-icon-attr .globe-icon-translation {
							width: calc(100% - 2px);
						}

						.clearfix {
							display: block;
						}

						.clearfix::after {
							content: "";
							clear: both;
							display: table;
						}

						table tbody tr td {
							position: relative;
						}

						.globe-icon-i {
							position: absolute;
							top: 50%;
							transform: translateY(-50%);
							right: 1px;
							line-height: 0em;
							background: #fff;
    						padding: 0px 5px;
						}
						.wp-repair-input-group input:focus, .wp-repair-input-group input:active, .wp-repair-input-group input:hover, .wp-repair-inner-col input.wp-repair-category-image-url:focus, .wp-repair-inner-col input.wp-repair-category-image-url:active, .wp-repair-inner-col input.wp-repair-category-image-url:hover {
							border: 2px solid #2781c7;
							box-shadow: none;
							outline: 0;
						}
						.wp-repair-input-group:hover label {
							color: #2781c7;
						}

						.wp-repair-container button, .wp-repair-container input, .wp-repair-container textarea, .wp-repair-repair-card, .wp-repair-cselected-item, .checkbox-custom .tick,
						.wp-repair-input-group input:focus, .wp-repair-input-group input:active, .wp-repair-input-group input:hover, .wp-repair-inner-col input.wp-repair-category-image-url:focus, .wp-repair-inner-col input.wp-repair-category-image-url:active, .wp-repair-inner-col input.wp-repair-category-image-url:hover {
							-webkit-transition: 0.4s all !important;
							transition-duration: 0.4s, 0.4s, 0.4s;
							transition-timing-function: ease, ease, ease;
							transition-delay: 0s, 0s, 0s;
							transition-property: border-color, background, transform;
							-moz-transition: 0.4s all !important;
							-o-transition: 0.4s all !important;
							-ms-transition: 0.4s all !important;
							transition: 0.4s all !important;
						}

						.va-full-width-modal-main {
							max-width: 475px;
							max-height: 80%;
							overflow-y: auto;
						}

						input.repair-additional-desc {
							width: 210px;
							margin-left: 8px;
						}

						.va-full-width-modal .flag-img {
							width: 36px;
    						display: inline-block;
							position: relative;
							top: 9px;
						}
						.va-full-width-modal .input-cont {
							width: calc(100% - 40px);
    						display: inline-block;
						}
						.va-full-width-modal .va-button.va-submit,
						.va-full-width-modal .va-button.va-reset-default-repair {
							margin-top: 12px;
							display: inline-table;
							float: right;
							margin-bottom: 15px;
							position: relative;
							right: 3px;
							min-width: 80px;
						}
						td.is-default-repair > input,
						td.is-default-repair > .repair-more-options > .globe-icon-attr > input {
							background: #fff !important;
						}
						td.is-default-repair .globe-icon-i {
							background: #fff !important;
							color: #888888 !important;
						}

						.reset-default-repair {
							background: #b50000 !important;
							color: #fff !important;
							font-weight: 500 !important;
							border: 1px solid #b10000 !important;
							border-radius: 5px !important;
							padding: 5px 10px !important;
							cursor: pointer !important;
							font-size: 12px !important;
						}
						.reset-default-repair.grayed-out {
							background: #aeaeae !important;
							border: 1px solid #a2a2a2 !important;
						}
						input.repair-additional-desc {
							width: 210px;
							margin-left: 6px;
						}
						input.repair-additional-badge {
						width: 170px;
						margin-left: 6px;
						}
						.ra-duration-fields {
						display: inline-table;
						margin-left: 5px;
						}
						.ra-duration-fields.w55 input {
						width: 55px;
						}
						.ra-duration-fields.w74 input {
						width: 74px;
						}
						.globe-icon-attr input.attr-badge {
						max-width: 160px;
						}

</style>
<div class="wp-repair-container">
	<?php
	require_once(WP_REPAIR_PLUGIN_PATH.'html/pending_jobs_progress.php');
	?>
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 type-category">
			<div class="wp-repair-category-header">
				<form method="GET" action="admin.php?page=wp_repair_manage_models"  class="submit_search">
					<input type="hidden" name="page" value="wp_repair_manage_models">
				<div class="both-groups">
						<div class="group-1">
							<div class="category_related_data">
								<input type="hidden" name="category" value="<?php echo $category; ?>">
							</div>
							<h2 class="models-heading">Brands</h2>
							<div class="filters">
								<div class="custom-select add-category">
									<select name="brand" class="choose_brands">
										<?php if(!empty($brand)){echo '<option value="'.$brand.'">'.$brand.'</option>';}?>
										<option>All</option>
										<?php if($b_result){foreach ($b_result as $b){?>
											<option value="<?php echo $b->b_name?>"><?php echo $b->b_name?></option>
										<?php } }?>
									</select>
								</div>
							</div>
						</div>
						<div class="group-2">
							<?php if($c_result){foreach ($c_result as $print) {?>
								<button type="button" class="type choose_category" data-cid="<?php echo $print->c_id; ?>" data-cname="<?php echo $print->c_name; ?>" name="choose_category" style="<?php if($category == $print->c_name){echo 'border: 1.5px solid #434343;box-shadow: 0 0 0 0.8px #434343';}?>">
									<span class="icon"><img src="<?php echo $print->c_img; ?>"></span>
									<p class="text"><?php echo $print->c_name; ?></p>
								</button>
							<?php } }?>
						</div>
				</div>
				<div class="actions">
						<table class="table">
							<tbody>
								<tr>
									<td class="search-td"><i class="fas fa-search"></i><input type="text" name="search_model" id="search_model" class="search_model" placeholder="Enter Model Name Only" value="<?php echo $search_model; ?>"></td>
									<td class="search-btn"><button type="submit" class="wp-repair-category-save-button" name="search" id="saverOrder">Search Model By Name <i class="fas fa-caret-right"></i></button></td>
									<td class="add-btn-td">
										<button type="button" class="add-btn new-model-trigger"><i class="fas fa-plus"></i> Add New Model</button>
									</td>
								</tr>
							</tbody>
						</table>
					<?php
					if(!empty($get_paramters_str)) {
						?>
						<a class="rp_sortable_link" style="display: table; margin: 10px 15px; font-size: 15px;" href="?page=wp_repair_manage_models"><i class="fas fa-undo-alt"></i> Reset Filters</a>
						<?php
					}
					?>
					<button type="button" class="add-category active" id="fastDelete" style="margin: 7px 5px 0px 5px;">Confirm Delete (ON) </button>
					<button type="button" class="add-category" id="savemOrder" style="margin: 7px 5px 0px 5px;">Save Order </button>
					<button type="button" class="add-category hide" id="saveChanges" style="margin: 7px 5px 0px 5px;">Save Changes (0)</button>
				</div>
				</form>
				<form method="post" action="admin.php?page=wp_repair_manage_models" enctype="multipart/form-data">
				<?php
				rp_csrf_token_input_field('manage_models');
				?>
					<div class="new-model">
						<div class="new-model-content">
							<div class="modal-header">
								<span class="new-model-close-button">&times;</span>
							</div>	
							<div class="modal-body">
								<div class="wp-brand-input-group">					
									<p class="fs-9 cat-img">Choose Category</p>		
									<select class="form-control" name="device_type">
										<?php 
										$ac_result = $rpQuery->get_results("SELECT * FROM $category_table WHERE is_active = '1'");
										if($ac_result){
											$ac_result = rp_sanitize_output($ac_result);
											foreach($ac_result as $cat){
												if(isset($category) && trim(strtolower($category)) === trim(strtolower($cat->c_name))) {
													?>
													<option value="<?php echo $cat->c_id;?>" selected="selected"><?php echo $cat->c_name;?></option>
													<?php
												} else {
													?>
													<option value="<?php echo $cat->c_id;?>"><?php echo $cat->c_name;?></option>
													<?php
												}
											} 
										}?>
									</select>
								</div>
								<div class="wp-brand-input-group">					
									<p class="fs-9 b-img">Choose Brand</p>
									<select class="form-control" name="brand_id_fk">
										<?php 
										$ab_result = $rpQuery->get_results("SELECT * FROM $brand_table WHERE is_active = '1'");
										if($ab_result){
											$ab_result = rp_sanitize_output($ab_result);
											foreach($ab_result as $b){
											?>
											<option value="<?php echo $b->b_id;?>"><?php echo $b->b_name;?></option>
										<?php } }?>
									</select>
								</div>
								<div class="wp-repair-input-group">	
									<label>Enter Name</label>
									<input type="text" name="mname" class="user-info">
								</div>
								<div class="wp-repair-input-group">						
									<label>Enter Model Code</label>
									<input type="text" name="mcode" class="user-info">
								</div>
								<div class="wp-repair-input-group">					
									<label>Release Date</label>
									<input type="date" name="releasedate" class="user-info">
								</div>
								<p class="fs-9 cat-img">Model Image</p>
								<div class="upload_btn">
									<label for="upload_mimage" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
									<input type="file" onchange="readURL(this)" id="upload_mimage" style="display: none;" name="m_img">
									<div class="uploaded_img" style="margin-top:8px"></div>
								</div>
							</div>
							<div class="modal-footer">
								<button type="submit" class="btn add_model" name="add_model" id="add_model">Add New Model</button>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="table-responsive">
				<table class="table modelContainer">
					<thead>
						<tr>
							<th style="width: 85px;">
								<p class="on-off">On/Off</p>
							</th>
							<th style="width: 115px;">
								<p class="name"><?php

								echo rp_create_column_sort_link_manage_models('Type', 'c.c_name');

								?></p>
							</th>
							<th style="width: 80px;">
								<p class="model_code_brand"><?php

								echo rp_create_column_sort_link_manage_models('Brand', 'b.b_name');

								?></p>
							</th>
							<th style="width: 210px;">
								<p class="model"><?php

								echo rp_create_column_sort_link_manage_models('Model Name', 'm.m_name');

								?></p>
							</th>
							<th style="width: 95px;">
								<p class="model_code_brand"><?php

								echo rp_create_column_sort_link_manage_models('Model Code', 'm.m_code');

								?></p>
							</th>
							<th style="width: 115px;">
								<p class="release-date"><?php

								echo rp_create_column_sort_link_manage_models('Release Date', 'm.release_date');

								?></p>
							</th>
							<th style="width: 260px;">
								<p class="upsale">Upsale</p>
							</th>
						</tr>
					</thead>
					<tbody class="modelContainerTbody append_models">
						<?php $i = 0;

						if($m_result){
							foreach ($m_result as $print) {
								$m_id = $print->m_id;
								$m_colors = $rpQuery->get_results("SELECT * FROM $modelcolor_table WHERE m_id_fk = '".rp_escape_sql($m_id)."' ORDER BY mc_position ASC, color_name ASC");

								$count_colors = $rpQuery->get_var("SELECT COUNT(*) FROM $modelcolor_table WHERE m_id_fk = '".rp_escape_sql($m_id)."'");
								$repairs =  $rpQuery->get_results("SELECT * FROM $repair_table WHERE m_id_fk = '".rp_escape_sql($m_id)."' ORDER BY r_position ASC, r_id ASC");
								$repairs = rp_fix_default_repair_sorting($repairs, $m_id);
							//echo count($m_colors);
								$m_colors = rp_sanitize_output($m_colors);
								$repairs = rp_sanitize_output($repairs);
								?>
								<tr class="justForsort Orderingmodel manageRepairsParent">
									<td class="justForsort" colspan="7">
										<table class="justForsort">
											<tbody class="justForsort">
												<tr class="main-model closed category<?php echo str_replace(' ', '', $print->c_name);?> brand<?php echo str_replace(' ', '', $print->b_name);?>" data-cname="<?php echo str_replace(' ', '', $print->c_name);?>" data-bname="<?php echo str_replace(' ', '', $print->b_name);?>" id="<?php echo $m_id; ?>">
														<td style="width: 85px;">
															<label class="switch">
																<input type="checkbox" <?php if($print->is_active == '1'){echo 'checked';}?> name="is_active" id="is_active<?php echo $m_id; ?>">
																<span class="slider round"></span>
															</label>
															<!-- <div class="category-sort">
																<i class="fas fa-sort"></i>
															</div> -->
															<?php
															wp_repair_list_sorting_button();
															?>
															<p class="serial-number"></p>
														</td>
														<td style="width: 115px;" class="type"><?php echo $print->c_name; ?></td>
														<td style="width: 80px;" class="brand"><?php echo $print->b_name; ?></td>
														<td style="width: 220px;"><input class="category-name" id="m_name<?php echo $m_id; ?>" type="text" name="m_name[]" value="<?php echo $print->m_name; ?>"></td>
														<input class="total_count" type="hidden" name="" value="<?php echo count( $m_result ); ?>">
														<td style="width: 90px;"><input class="model-number" id="m_code<?php echo $m_id; ?>" type="text" name="m_code[]" value="<?php echo $print->m_code; ?>"></td>
														<td style="width: 115px;"><input class="release-date" id="r_date<?php echo $m_id; ?>" type="text" name="release_date[]" value="<?php echo $print->release_date; ?>"></td>
														<td style="width: 260px;" class="btn-actions">
															<button type="button" class="plus-icon see-more edit-settings">Model</button>
															<button type="button" class="plus-icon see-more edit-repairs">Repairs</button>
															<input type="text" value="[models code=<?php echo $print->m_uq_id?>]" id="mInput<?php echo $i;?>" style="display: none;" name="m_input_shortcode">
															<button type="button" class="wp-repair-shortcode m_shortcode"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/web-development.svg'; ?>"></button>
															<button type="button" class="upsale"><a href="admin.php?page=wp_repair_manage_upsales"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/business-and-finance.svg'; ?>"></a></button>
															<input class="m_id" type="hidden" name="model_id[]" value="<?php echo $m_id; ?>">
															<button type="submit" class="trash delete_model" id="delete_model" data-mid="<?php echo $m_id; ?>">
																<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/garbage.svg'; ?>">
															</button>
														</td>
													</tr>
													<tr class="more-details model-details">
														<td colspan="7">
															<div class="details-container">
																<div class="wp-repair-inner-col section-1">
																	<div class="sec-sorting" style="padding: 10px 15px; box-sizing: border-box;">
																		<p class="heading">Sort Position</p>
																		<input type="text" name="m_sort[]" class="wp-repair-category-image-url model-sorting-input m_sort<?php echo $m_id; ?>" value="<?php echo $print->m_position; ?>">
																	</div>
																	<div class="sec-1">
																		<img class="uploaded_img old_img<?php echo $i;?>" src="<?php echo $print->m_img; ?>" height="80" width="80">
																		<div id="model_image<?php echo $i;?>"></div>
																	</div>
																	<div class="sec-2">
																		<div class="tr">
																			<p class="heading">Link</p>
																		</div>
																		<div class="tr">
																			<input type="text" name="m_link[]" class="img-input wp-repair-category-image-url m_link<?php echo $m_id; ?>" value="<?php echo $print->m_img; ?>" readonly>
																			<button type="button" class="wp-repair-cancel-link clear_img_input"><i class="fas fa-times"></i></button>
																		</div>
																		<div class="tr multirows">
																			<div class="upload_btn">
																				<label for="upload_mimage_<?php echo $m_id; ?>" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
																				<input type="file" id="upload_mimage_<?php echo $m_id; ?>" style="display: none;" name="m_img_X" data-uimage-id="<?php echo $m_id; ?>">
																			</div>
																		</div>
																	<!-- <div class="tr mt-10">
																		<label for="upload_image<?php //echo $i; ?>" class="wp-repair-category-image-upload-button">Upload Picture <i class="fas fa-plus"></i></label>
					                  									<input type="file" id="upload_image<?php //echo $i; ?>" style="display: none;" name="upload_image<?php //echo $print->m_id; ?>">
					                  									<input type="hidden" name="new_uploaded_img" class="new_uploaded_img">					
					                  								</div> -->
					                  								<div class="tr">
					                  									<p class="wp-repair-category-image-text">Image size should not exceed 150 pixels</p>
					                  								</div>
					                  							</div>
					                  						</div>
					                  						<div class="wp-repair-inner-col section-2">
					                  							<div class="sec-1">
					                  								<table class="table color colorContainer">
					                  									<thead>
					                  										<tr>
					                  											<?php if($m_colors){?>
					                  												<td class="wp-repair-no-padding thead">
					                  													<p class="c-name">Name</p>
					                  													<p class="c-hex">Color</p>
					                  												</td>
					                  											<?php }?>
					                  										</tr>
					                  									</thead>
					                  									<tbody>
					                  										<?php $x = 1;if($m_colors){ foreach($m_colors as $mc){?>
					                  											<tr class="Orderingmodelclr" id="<?php echo $mc->mc_id; ?>">
					                  												<td class="wp-repair-no-padding" style="display: flex;">
					                  													<!-- <div class="category-sort colors-sort">
					                  														<i class="fas fa-sort"></i>
					                  													</div> -->
					                  													<?php
					                  													wp_repair_list_sorting_button('', 'colors-sort-cls');
					                  													?>
					                  													<input class="count_colors<?php echo $i; ?>" type="hidden" name="" value="<?php echo $count_colors; ?>">

					                  													<input class="color-name" id="mc_name<?php echo $m_id; ?>" type="text" name="mc_name[]" value="<?php echo $mc->color_name?>">

					                  													<input class="color-hex" id="mc_code<?php echo $m_id; ?>" type="text" name="mc_code[]" value="<?php echo $mc->color_code?>">

					                  													<input type="color" name="c_code[]" value="<?php echo $mc->color_code?>" disabled style="min-width:27px">
					                  													<form method="post" action="">
					                  														<input type="hidden" id="mc_id<?php echo $m_id; ?>" name="mc_id[]" value="<?php echo $mc->mc_id?>">
					                  														<button type="submit" name="delete_color" class="wp-repair-cancel-link delete-color-btn"><i class="fas fa-times"></i></button>
					                  													</form>
					                  												</td>
					                  											</tr>
					                  											<?php $x++;} }?>
					                  											
					                  										</tbody>
					                  										<tfoot>
					                  											<tr>
					                  												<td>
					                  													<button type="button" class="add-color-btn actual color-trigger<?php echo $i;?>">Add Color <i class="fas fa-plus"></i></button>

					                  													<button type="button" data-mid="<?php echo $m_id; ?>"  class="add-color-btn update_model">Update Model <i class="fas fa-caret-right" style="font-size: 11px !important;"></i></button>

					                  													<div class="modal-color modal-color<?php echo $i;?>">
					                  														<form method="post" action="">
					                  															<div class="modal-color-content">
					                  																<div class="modal-header">
					                  																	<span class="color-close-button color-close-button<?php echo $i;?>">&times;</span>
					                  																</div>	
					                  																<div class="modal-body">
					                  																	<input class="m_id" type="hidden" name="m_id" value="<?php echo $m_id; ?>"><div class="wp-repair-input-group">	
					                  																		<label>Color Name</label>
					                  																		<input type="text" id="color_name" name="color_name" class="user-info">
					                  																	</div>
					                  																	<div class="wp-repair-input-group">
					                  																		<label>Color Code</label>
					                  																		<input type="text" id="color_code" name="color_code" class="user-info">
					                  																	</div>
					                  																</div>
					                  																<div class="modal-footer">
					                  																	<button type="submit" class="btn add_color" name="add_color">Add Color</button>
					                  																</div>
					                  															</div>
					                  														</form>
					                  													</div>
					                  												</td>
					                  											</tr>
					                  										</tfoot>
					                  									</table>
					                  								</div>
					                  							</div>
															<!-- <div class="wp-repair-inner-col section-1">
																<div class="sec-3">
																	<button type="submit" id="update_model" name="update_model" class="wp-repair-category-image-save-button">Update Data <i class="fas fa-caret-right"></i></button>
																</div>
															</div> -->
														</div> 
													</td>
												</tr>
												<?php
												rp_manage_repairs_standalone_markup( $m_id, $repairs, $print, $decimal, $print->device_type );
												?>
												<tr class="spacer"><td></td></tr>
											</tbody>
										</table>
									</td>
								</tr>
							<?php $i++;} }?>
						</tbody>
					</table>
				</div>
				<div class="navigation">
					<?php 
					if ( $page_links ) {
						echo '<div class="tablenav"><div class="tablenav-pages" style="margin: 1em">' . $page_links . '</div></div>';
					}
					;?>
				</div>
			</div>
		</div>
	</div>

	<?php rp_manage_repairs_unused_markup(); ?>

	<?php
	wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
	wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
	wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
	?>

	<?php rp_manage_repairs_easy_copy_js( $decimal ); ?>

	<script type="text/javascript">

		function add_repairs_for_newly_added_model( repairsContainer, table_rows) {

			jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');

			table_rows.forEach(function(val, i){
				let getTr = '';
				if( val.listing_range !== undefined && val.listing_range !== null ){
					getTr = `
						<tr class="justForsort Orderingrepairs draggable ui-state-default">
							<td colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>"><hr><div class="button">Hide under show all .. repairs button ↓</div>
								<input type="hidden" name="default_listing_range" id="default_listing_range" value="${val.listing_range}" />
							</td>
						</tr>
					`;
				}else{
					if( val.repair_margin === undefined || val.repair_margin === null ) {
						val.repair_margin = null;
					}
					getTr = add_model_repair_tr(val.m_id, val.r_id, val.r_img, val.repair_title, val.repair_min, val.repair_info, val.repair_price, val.is_active, val.is_free, val.r_duration_measure, val.r_uq_id, val.is_fully_unchanged, val.repair_margin, val.repair_badge);
				}
				jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(getTr);

				let OrderingrepairsCont = jQuery(repairsContainer).find('.Orderingrepairs.adding-model-repair-tr');

				OrderingrepairsCont.removeClass('adding-model-repair-tr');

				if( val.attrs != undefined && val.attrs.length > 0) {

					jQuery(OrderingrepairsCont).find('.add-more.add-first-repair-attr').removeClass('add-more add-first-repair-attr').addClass('dropdown').html('<i class="fas fa-caret-down"></i>');

					jQuery(OrderingrepairsCont).find('input[name^="rprice"]').attr('readonly', 'readonly');

					jQuery(OrderingrepairsCont).find('input[name^="rmargin"]').attr('readonly', 'readonly');

					let sub_repair_tr = `
						<tr class="sub-repairs-details">
							<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
								<div class="special-table">
									<table class="table repairsAttrContainer ui-sortable">
										<thead>
											<tr>
												<th style="width: 85px;">
												</th>
												<th style="width: 175px;">
												</th>
												<th style="width: 55px;">
												</th>
												<th style="width: 225px;">
												</th>
												<th style="width: 75px">
												</th>
												<th style="width: 30px">
												</th>
												<th style="width: 220px;"></th>
											</tr>
										</thead>
										<tbody class="append_attr_data">

										</tbody>
									</table>
								</div>
							</td>
						</tr>
					`;

					jQuery(OrderingrepairsCont).find('tr.main-repair').after(sub_repair_tr);

					jQuery(OrderingrepairsCont).find(".repairsAttrContainer").each(function(){

						jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){ update_default_listing_range_position(e,ui); }, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });

					});

					val.attrs.forEach(function(newVal){

						if( newVal.a_margin === undefined || newVal.a_margin === null ) {
							newVal.a_margin = null;
						}

						let repairAttrTR = add_model_repair_attr_tr(val.r_id, val.m_id, newVal.a_id, newVal.a_name, newVal.a_desc, newVal.a_price, newVal.a_uq_id, newVal.is_active, newVal.a_margin, newVal.a_badge, newVal.attr_min, newVal.a_duration_measure);
						
						jQuery(OrderingrepairsCont).find('.repairsAttrContainer tbody.append_attr_data').append(repairAttrTR);

					});
				}
			});

		}

		function base_template_for_repairs_tab( m_id = '' ) {

			let template = `<tr class="more-details repairs-details more_details${m_id} active">
				<td colspan="7">
					<div class="details-container" id="details-container${m_id}">
						<div class="wp-repair-inner-col section-1">
							<table class="table repairsContainer ui-sortable">
								<thead>
									<tr class="closed">
										<th style="width: 120px;">
											<p>On/Off</p>
										</th>
										<th style="width: 175px;">
											<p>Title</p>
										</th>
										<th style="width: 147px;">
											<p>Duration</p>
										</th>
										<th style="width: 225px;">
											<p>Info</p>
										</th>
										<th style="width: 200px;">
											<p>Badge</p>
										</th>
										<?php
										$price_markup = '<th style="width: 75px"><p>Price</p></th>';
										$filtered_price_th = apply_filters('rp_individual_repair_price_th', $price_markup);
										echo $filtered_price_th;
										?>
										<th style="width: 45px">
											<p>Free</p>
										</th>
										<th style="width: 160px;">
											<p></p>
										</th>
									</tr>
								</thead>
								<tbody class="the-additional-repair the-additional-repair${m_id}" style="border:none !important"></tbody>
							</table>
							<button type="button" data-mid="${m_id}" class="add-repair-btn AddRepair">Add Repair <i class="fas fa-plus"></i></button>
							<button type="button" data-mid="${m_id}" class="add-repair-btn update_repair" style="margin-right: 5px">Update Repair <i class="fas fa-edit"></i></button>
							<button type="button" data-mid="${m_id}" class="add-repair-btn delete_model_related_repairs" style="margin-right: 5px">Delete All Repairs <i class="fas fa-trash-alt" style="font-size: 11px;"></i></button>
						</div>
					</div>
				</td>
			</tr>`;

			return template;

		}

		function add_model_tr_template(m_id = '', device_type = '', brand = '', model_name = '', model_code = '', release_date = '', m_link = '', model_uq_id = '') {
			if(m_link === '' || !m_link) {
				m_link = '';
			}

			let _base_template_for_repairs_tab = base_template_for_repairs_tab(m_id);

			let tr = `
				<tr class="justForsort Orderingmodel adding-model-tr">
					<td class="justForsort" colspan="7">
						<table class="justForsort">
							<tbody class="justForsort">
								<tr class="main-model closed category${device_type} brand${brand}" data-cname="${device_type}" data-bname="${brand}" id="${m_id}">
									<td style="width: 85px;">
										<label class="switch">
											<input type="checkbox" checked="" name="is_active" id="is_active${m_id}">
											<span class="slider round"></span>
										</label>
										<span class="repair-list-sort ui-sortable-handle">
											<i class="fas fa-caret-up" data-which="up"></i>
											<i class="fas fa-caret-down" data-which="down"></i>
										</span>
										<p class="serial-number"></p>
									</td>
									<td style="width: 115px;" class="type">${device_type}</td>
									<td style="width: 80px;" class="brand">${brand}</td>
									<td style="width: 220px;"><input class="category-name" id="m_name${m_id}" type="text" name="m_name[]" value="${model_name}"></td>
									<td style="width: 90px;"><input class="model-number" id="m_code${m_id}" type="text" name="m_code[]" value="${model_code}"></td>
									<td style="width: 115px;"><input class="release-date" id="r_date${m_id}" type="text" name="release_date[]" value="${release_date}"></td>
									<td style="width: 260px;" class="btn-actions">
										<button type="button" class="plus-icon see-more edit-settings">Model</button>
										<button type="button" class="plus-icon see-more edit-repairs">Repairs</button>
										<input type="text" value="[models code=${model_uq_id}]" name="m_input_shortcode" style="display: none;">
										<button type="button" class="wp-repair-shortcode m_shortcode"><img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/web-development.svg"></button>
										<button type="button" class="upsale"><a href="admin.php?page=wp_repair_manage_upsales"><img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/business-and-finance.svg"></a></button>
										<input class="m_id" type="hidden" name="model_id[]" value="${m_id}">
										<button type="submit" class="trash delete_model" id="delete_model" data-mid="${m_id}">
											<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
										</button>
									</td>
								</tr>
								<tr class="more-details model-details">
									<td colspan="7">
										<div class="details-container">
											<div class="wp-repair-inner-col section-1">
												<div class="sec-sorting" style="padding: 10px 15px; box-sizing: border-box;">
													<p class="heading">Sort Position</p>
													<input type="text" name="m_sort[]" class="wp-repair-category-image-url model-sorting-input m_sort${m_id}" value="0">
												</div>
												<div class="sec-1">
													<img class="uploaded_img old_img0" src="${m_link}" height="80" width="80">
													<div id="model_image0"></div>
												</div>
												<div class="sec-2">
													<div class="tr">
														<p class="heading">Link</p>
													</div>
													<div class="tr">
														<input type="text" name="m_link[]" class="img-input wp-repair-category-image-url m_link${m_id}"  value="${m_link}" readonly="">
														<button type="button" class="wp-repair-cancel-link clear_img_input"><i class="fas fa-times"></i></button>
													</div>
													<div class="tr multirows">
														<div class="upload_btn">
															<label for="upload_mimage_${m_id}" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
															<input type="file" id="upload_mimage_${m_id}" style="display: none;" name="m_img_X" data-uimage-id="${m_id}">
														</div>
													</div>
													<div class="tr">
														<p class="wp-repair-category-image-text">Image size should not exceed 150 pixels</p>
													</div>
												</div>
											</div>
											<div class="wp-repair-inner-col section-2">
												<div class="sec-1">
													<table class="table color colorContainer ui-sortable">
														<thead>
															<tr>
																<td class="wp-repair-no-padding thead">
																	<p class="c-name">Name</p>
																	<p class="c-hex">Color</p>
																</td>
															</tr>
														</thead>
													<tbody>

													</tbody>
													<tfoot>
														<tr>
															<td>
																<button type="button" class="add-color-btn actual color-trigger0">Add Color <i class="fas fa-plus"></i></button>

																<button type="button" data-mid="${m_id}" class="add-color-btn update_model">Update Model <i class="fas fa-caret-right" style="font-size: 11px !important;"></i></button>
															</td>
														</tr>
													</tfoot>
												</table>
											</div>
										</div>
									</div> 
								</td>
							</tr>
							${_base_template_for_repairs_tab}
							<tr class="spacer"><td></td></tr>
						</tbody>
					</table>
				</td>
			</tr>
			`;
			return tr;
		}
		function model_color_tr_template(mc_id, mc_name, mc_code, count_colors) {
				let tr = `<tr class="Orderingmodelclr">
			<td class="wp-repair-no-padding" style="display: flex;">
		      	<span class="repair-list-sort colors-sort-cls ui-sortable-handle">
					<i class="fas fa-caret-up" data-which="up"></i>
					<i class="fas fa-caret-down" data-which="down"></i>
				</span>
				<input class="count_colors" type="hidden" name="" value="${count_colors}">

				<input class="color-name" type="text" name="mc_name[]" value="${mc_name}">

				<input class="color-hex" type="text" name="mc_code[]" value="${mc_code}">

				<input type="color" name="c_code[]" value="${mc_code}" disabled="" style="min-width:27px">
				<form method="post" action="">
					<input type="hidden" name="mc_id[]" value="${mc_id}">
					<button type="submit" name="delete_color" class="wp-repair-cancel-link delete-color-btn"><i class="fas fa-times"></i></button>
				</form>
			</td>
		</tr>			
		`;
		return tr;
		}
		window.model_color_tr = `
		<tr class="Orderingmodelclr uibyzahran-remove-tr uibyzahran-transition unsaved">
			<td class="wp-repair-no-padding" style="display: flex;">
		      	<span class="repair-list-sort colors-sort-cls ui-sortable-handle">
					<i class="fas fa-caret-up" data-which="up"></i>
					<i class="fas fa-caret-down" data-which="down"></i>
				</span>
				<input class="count_colors" type="hidden" name="" value="30">

				<input class="color-name" type="text" name="mc_name[]" value="">

				<input class="color-hex" type="text" name="mc_code[]" value="">

				<input type="color" name="c_code[]" value="#ffffff" disabled="" style="min-width:27px">
				<form method="post" action="">
					<input type="hidden" name="mc_id[]" value="NEW">
					<button type="submit" name="delete_color" class="newlyCreated wp-repair-cancel-link delete-color-btn"><i class="fas fa-times"></i></button>
				</form>
			</td>
		</tr>			
		`;

		jQuery(document).on("click", ".add-color-btn.actual", function(){
			let parentEl = repairPluginUI.find_parent_by_class(this, 'colorContainer');
			jQuery(parentEl).find('tbody').append(window.model_color_tr);
			updateUnsavedManageModelButton();
			window.setTimeout(function(){
				let firstInput = jQuery('.Orderingmodelclr.uibyzahran-remove-tr input[type="text"]')[0];
				jQuery(firstInput).focus();
				jQuery(".Orderingmodelclr.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
				window.setTimeout(function(){
					jQuery(".Orderingmodelclr.uibyzahran-transition").removeClass('uibyzahran-transition');
				},500);
			},1);
		});


		window.rp_category_brand_pair = <?php echo $category_brand_pair; ?>;
		function rp_filter_brands_by_category() {
			let selected_category = jQuery(".new-model-content select[name='device_type']").val();
			let selected_category_brands = window.rp_category_brand_pair[selected_category];

			let newHtml = '';

			selected_category_brands.forEach(function(item){
				newHtml += '<option value="'+item[0]+'">'+item[1]+'</option>';
			});

			jQuery(".new-model-content select[name='brand_id_fk']").html(newHtml).change();
		}

		rp_filter_brands_by_category();

		jQuery(document).on("change", ".new-model-content select[name='device_type']", function(){

			rp_filter_brands_by_category();

		});


		jQuery(".choose_category").on('click', function(e){
			e.preventDefault();
			jQuery('.category_related_data').find('input[name="category"]').remove();
			var c_name = jQuery(this).data('cname');
			jQuery(".category_related_data").append('<input type="hidden" name="category" value="'+c_name+'">');
			jQuery(".submit_search").submit(); 
		});
	</script>
	<script type="text/javascript">
		jQuery(document).on('click', '.clear_img_input', function(){
			jQuery(this).parent().find('.img-input').val('').change();
		});
		jQuery(document).on('click', '.m_shortcode', function(){
			let copyText = jQuery(this).parent().find('input[name="m_input_shortcode"]')[0];
			copyText.select();
			copyText.setSelectionRange(0, 99999); /* For mobile devices */
			navigator.clipboard.writeText(copyText.value);
			alert("Copied To Clipboard: " + copyText.value);
		});
	</script>
<script type="text/javascript">
	//--------------------------------------------------- add new color
	jQuery(document).on("wpRepairReady", function(){
		
		//--------------------------------------------------- add new model
		const new_model = document.querySelector(".new-model");
		const new_model_trigger = document.querySelector(".new-model-trigger");
		const modelcloseButton = document.querySelector(".new-model-close-button");

		function toggleNewModal() {
			new_model.classList.toggle("show-new-model");
		}

		function newModelwindowOnClick(event) {
			if (event.target === new_model) {
				toggleNewModal();
			}
		}

		new_model_trigger.addEventListener("click", toggleNewModal);
		modelcloseButton.addEventListener("click", toggleNewModal);
		window.addEventListener("click", newModelwindowOnClick);
	});
</script>
<script type="text/javascript">
	function readURL(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'" height="100">');
		}
		reader.readAsDataURL(input.files[0]);
	}
}

	jQuery(document).on("change", "input[name='m_img_X']", function(){
		readURLZD(jQuery(this)[0]);
		jQuery(this).parent().find('label').addClass('unsaved');
		updateUnsavedManageModelButton();
	});

	function readURLZD(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			jQuery(input).parent().parent().parent().parent().find(".uploaded_img").attr('src', e.target.result);
		}
		reader.readAsDataURL(input.files[0]);
	}
}
</script>
<script type="text/javascript">
	jQuery(document).on('click', '.delete-color-btn', function(e){
		e.preventDefault();
		if(!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure to delete this color?')) {
			if(jQuery(this).hasClass("processing")) {
				return;
			}

			if(jQuery(this).hasClass('newlyCreated')) {
				let btn = this;

				let parentEl = repairPluginUI.find_parent_by_class(btn, 'Orderingmodelclr');
				repairPluginUI.removeTableRow(parentEl, function(){
					updateUnsavedManageModelButton();
				});

				return;
			}

			let btn = this;

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<i class="fas fa-spinner fa-spin"></i>');

			jQuery(btn).addClass("processing");
			let mc_id = jQuery(btn).parent().find("input[name^='mc_id']").val();
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'delete_model_color',mc_id:mc_id},
				success: function(data) {
					jQuery(btn).html(btndata);
					let parentEl = repairPluginUI.find_parent_by_class(btn, 'Orderingmodelclr');
					repairPluginUI.removeTableRow(parentEl, function(){
						updateUnsavedManageModelButton();
					});

					repairPluginUI.alert_success('Color successfully deleted.');
					jQuery(btn).removeClass("processing");
				},
				error: function(response) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});
		}
	});
	jQuery(document).on('click', '.delete_model', function(){
		if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure to delete this model?')){
			if(jQuery(this).hasClass("processing")) {
				return;
			}
			jQuery(this).addClass("processing");
			var btn = this;

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<i style="font-size: 18px; position: relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

			var mid = jQuery(this).data("mid");
			// console.log(rid)
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'delete_model',mid:mid},
				success: function(data) {
					jQuery(btn).html(btndata);
					let parentEl = repairPluginUI.find_parent_by_class(btn, 'Orderingmodel');
					repairPluginUI.removeTableRow(parentEl, function(){
						updateUnsavedManageModelButton();
					});

					repairPluginUI.alert_success('Model successfully deleted.');
					jQuery(btn).removeClass("processing");
				},
				error: function(response) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});
		}
	});
</script>
<script type="text/javascript">
	jQuery(document).on('click', '.update_model', function() {
		if(jQuery(this).hasClass("processing")) {
			return;
		}
		jQuery(this).addClass("processing");

		var btn = this;
		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i style="font-size: 13px;" class="fas fa-spinner fa-spin"></i>');



		var mid    = jQuery(this).data("mid");
		var m_name = jQuery('#m_name'+mid).val();
		var m_code = jQuery('#m_code'+mid).val();
		var r_date = jQuery('#r_date'+mid).val();
		var m_link = jQuery('.m_link'+mid).val();
		var m_sort = jQuery('.m_sort'+mid).val();
		var status = jQuery("#is_active"+mid).is(':checked'); 

		let colorContainer = repairPluginUI.find_parent_by_class(btn, 'colorContainer');

		if(status == true){
			status = '1';
		}else{
			status = '0';
		}
		var mcid = [];
		jQuery(colorContainer).find('input[name^="mc_id"]').each(function(){
			mcid.push(jQuery(this).val());
		});
		var mc_name = [];
		jQuery(colorContainer).find('input[name^="mc_name"]').each(function(){
			mc_name.push(jQuery(this).val());
		});
		//console.log(mc_name);
		var mc_code = [];
		jQuery(colorContainer).find('input[name^="mc_code"]').each(function(){
			mc_code.push(jQuery(this).val());
		});


		if(!m_sort) {
			m_sort = 0;
		} else {
			m_sort = parseInt(m_sort);
		}
		if(!m_sort) {
			m_sort = 0;
		}

		var file_data = jQuery("input[data-uimage-id='"+mid+"']").prop('files');
		if(file_data.length > 0) {
			file_data = file_data[0];
		} else {
			file_data = null;
		}
    var form_data = new FormData();
    if(file_data) {
    	form_data.append('file', file_data);
    }

    form_data.append('action', 'update_model_img');
 		form_data.append('mid', mid);

		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {action:'update_model',mid:mid,m_name:m_name,m_code:m_code,r_date:r_date,status:status,mcid:mcid,mc_name:mc_name,mc_code:mc_code, m_sort:m_sort, m_link:m_link},
			success: function(data) {
	  			// var response = JSON.parse(data);
	  			// console.log(response);
	  			//var test = "data-123".replace('checked','');
	  			try {
	  				data = JSON.parse(data);
	  			} catch(e) {

	  			}
	  			if(data && data.color_info) {
	  				let colorContainer = repairPluginUI.find_parent_by_class(btn, 'colorContainer');
	  				jQuery(colorContainer).find('tbody').html('');
	  				data.color_info.mc_id.forEach(function(val, i){
	  					let getTr = model_color_tr_template(val, data.color_info.mc_name[i], data.color_info.mc_code[i], data.color_info.mc_id.length);
	  					jQuery(colorContainer).find('tbody').append(getTr);
	  				});
	  			}
					if(file_data) {
						repairPluginUI.ajax({
							type:'POST',
							url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
							dataType: 'text', // what to expect back from the server
							cache: false,
							contentType: false,
							processData: false,
							data: form_data,
							success: function (response) {
								try {
									response = JSON.parse(response);
								} catch(e) {

								}
								jQuery("input[data-uimage-id='"+mid+"']").val('');
								if(response && response.logo && response.logo !== '') {
									jQuery('.m_link'+mid).val(response.logo).change();
								}
								jQuery(btn).html(btndata);
								jQuery(btn).parents('.Orderingmodel').find('.unsaved').removeClass('unsaved');
								updateUnsavedManageModelButton();
								repairPluginUI.alert_success('Model successfully updated.');
								jQuery(btn).removeClass("processing");
								jQuery(btn).blur();
							},
							error: function( response ) {
								jQuery(btn).html(btndata);
								jQuery(btn).removeClass("processing");
								jQuery(btn).blur();
								if( response && response.rp_validation_error != '' ) {

								} else {
									repairPluginUI.alert_danger('Something went wrong, please try again later.');
								}
							}
						});
					} else {
						if(!m_link || m_link === '' || m_link === null) {
							let parentEl = repairPluginUI.find_parent_by_class(jQuery('.m_link'+mid), 'details-container');
							jQuery(parentEl).find('img.uploaded_img').attr('src', '');
						}
						jQuery(btn).html(btndata);
						jQuery(btn).parents('.Orderingmodel').find('.unsaved').removeClass('unsaved');
						updateUnsavedManageModelButton();
			      		repairPluginUI.alert_success('Model successfully updated.');
			      		jQuery(btn).removeClass("processing");
			      		jQuery(btn).blur();
					}
	  		},
	  		error: function(response) {
	  			jQuery(btn).html(btndata);
	  			jQuery(btn).removeClass("processing");
	  			jQuery(btn).blur();
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
	  		}
	  	});
	});
</script>
<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){

		let input_id = jQuery(this).attr('id');

		let is_search_input = false;

		if( input_id && input_id === 'search_model' ) {

			is_search_input = true;

		}

		if(e.which == 13 && !is_search_input){
			e.preventDefault();
		}

	});
</script>
<script type="text/javascript">
	function moveUp(item) {
	    var prev = item.prev();
		var top = 0;
		var handler = '';
		if( prev.hasClass('draggable') ){
			handler = prev;
			top = prev.height();
			prev = prev.prev();
		}
	    if (prev.length == 0)
	        return;
	    prev.css('z-index', 999).css('position','relative').animate({ top: parseInt( item.height() + top ) }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: '-' + parseInt( prev.height() + top ) }, 300, function () {
	        prev.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
			if( handler ){
	        	prev.insertAfter( handler );
	        	item.insertBefore( handler );
			}else{
				item.insertBefore(prev);
			}
	    });
	}
	function moveDown(item) {
	    var next = item.next();
		var top = 0;
		var handler = '';
		if( next.hasClass('draggable') ){
			handler = next;
			top = next.height();
			next = next.next();
		}
	    if (next.length == 0)
	        return;
	    next.css('z-index', 999).css('position', 'relative').animate({ top: '-' + parseInt( item.height() + top ) }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: parseInt( next.height() + top ) }, 300, function () {
	        next.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
			if( handler ){
	        	item.insertAfter( handler );
	        	next.insertBefore( handler );
			}else{
				item.insertAfter(next);
			}
	    });
	}
	jQuery(".modelContainer").each(function(){
		jQuery(this).sortable({ change:function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){ update_default_listing_range_position(e,ui); },items: ".Orderingmodel", distance: 5, handle: ".main-model .repair-list-sort" });
	});
	jQuery(document).on('click', '.Orderingmodel .main-model .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.Orderingmodel'));
	    else
	        moveDown(btn.parents('.Orderingmodel'));

	    jQuery(btn).parents('.modelContainerTbody').find('.Orderingmodel .main-model .repair-list-sort').addClass('unsaved');
	    updateUnsavedManageModelButton();
	});
	jQuery(".colorContainer").each(function(){
		jQuery(this).sortable({ change:function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){ update_default_listing_range_position(e,ui); },items: ".Orderingmodelclr", distance: 5, handle: ".colors-sort-cls.repair-list-sort" });
	});
	jQuery(document).on('click', '.Orderingmodelclr .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.Orderingmodelclr'));
	    else
	        moveDown(btn.parents('.Orderingmodelclr'));

	    jQuery(btn).parents('.colorContainer').find('.Orderingmodelclr .repair-list-sort').addClass('unsaved');
	    updateUnsavedManageModelButton();
	});
	jQuery('#savemOrder').click(function (e) {
	    e.preventDefault();
	    if(jQuery(this).hasClass("processing")) {
	    	return;
	    }
	    jQuery(this).addClass("processing");
	    var btn = jQuery(this);
	    var btndata = jQuery(btn).html();
	    jQuery(btn).html('<i style="font-size: 14px;" class="fas fa-spinner fa-spin"></i>');
	    var m_position = [];
	    jQuery('.modelContainer .Orderingmodel').each(function(){
	    	m_position.push(jQuery(this).find("input[name^='model_id[']").val());
	    });
	    repairPluginUI.ajax({
	    	type:'POST',
	      	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
	      	data: {action:'update_new_model_position',m_position:m_position},
	      	success: function(response) {
	      		jQuery(btn).html(btndata);
	      		repairPluginUI.alert_success('Sort Position Successfully Saved.');
	      		jQuery(btn).removeClass("processing");
	      		jQuery(btn).blur();
	      		try {
	      			response = JSON.parse(response);
	      		} catch(e) {

	      		}
	      		jQuery('.Orderingmodel .main-model .repair-list-sort.unsaved').removeClass('unsaved');
	      		updateUnsavedManageModelButton();
	      		if(response && response.positions) {
	      			jQuery("input[name^='model_id[']").each(function(){
	      				let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingmodel');
	      				jQuery(parentEl).find('input[name^="m_sort"]').val(response.positions[jQuery(this).val()]);
	      			});
	      		}
	      	},
	      	error: function(response) {
	      		jQuery(btn).html(btndata);
	      		jQuery(btn).removeClass("processing");
	      		jQuery(btn).blur();
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
	      	}
	    });
	});
	jQuery("#fastDelete").on("click", function(){
		if(jQuery(this).hasClass('active')) {
			jQuery(this).removeClass('active');
			jQuery(this).html('Confirm Delete (OFF)');
		} else {
			jQuery(this).addClass('active');
			jQuery(this).html('Confirm Delete (ON)');
		}
	});
	function resetAllModelInputs() {
		jQuery('.new-model-content').find('input[type="text"]').val('').change();
		jQuery('.new-model-content').find('input[type="date"]').val('').change();
		jQuery('.new-model-content').find('input[type="file"]').val('').change();
		jQuery('.new-model-content').find('.uploaded_img').html('');
		jQuery('.new-model-content').find('select option').prop("selected", false).trigger( "change" );
	}
	jQuery(document).on('click', '.new-model-content .add_model', function(e){
		e.preventDefault();

		if(jQuery(this).parents('form').find("input[name='mname']").val() == '') {
			alert('All fields are required.');
			return;
		}

		if(jQuery(this).hasClass("processing")) {
			return;
		}
		jQuery(this).addClass("processing");

		var btn = this;
		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i style="font-size: 14px;" class="fas fa-spinner fa-spin"></i>');

		var form_data = new FormData(jQuery(btn).parents('form')[0]);
		form_data.append('action', 'wp_repair_add_model');
		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			dataType: 'text', // what to expect back from the server
			cache: false,
			contentType: false,
			processData: false,
			data: form_data,
			success: function (response) {

				try {
					response = JSON.parse(response);
				} catch(e) {

				}

				if(response && response.message && response.message === 'already_exists') {
					jQuery(btn).html(btndata);
					repairPluginUI.alert_danger('Model already exists.');
					jQuery(btn).removeClass("processing");
					return;
				}

				if(response && response.added_model) {
					jQuery("#rp_processing_pending_jobs").show();
					window.setTimeout(function(){
						if( 'repeatablePendingJobsProcessingAR' in window && window.repeatablePendingJobsProcessingAR === false ) {
							window._repeatablePendingJobsProcessing();
						}
					}, window._getNextSafeSchedule(1));

					let added_tr = add_model_tr_template(response.added_model.m_id, response.added_model.device_type, response.added_model.brand, response.added_model.model_name, response.added_model.model_code, response.added_model.release_date, response.added_model.m_link, response.added_model.model_uq_id);
					let modelContainer = repairPluginUI.find_parent_by_class(btn, 'modelContainer');
					jQuery(modelContainer).find('tbody.modelContainerTbody').prepend(added_tr);

					jQuery(modelContainer).find(".colorContainer").each(function(){
						jQuery(this).sortable({ change:function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){ update_default_listing_range_position(e,ui); },items: ".Orderingmodelclr", distance: 5, handle: ".colors-sort-cls.repair-list-sort" });
					});

					jQuery(modelContainer).find('tr.adding-model-tr').find('.plus-icon.edit-settings').click();
					let btnColor = jQuery(modelContainer).find('tr.adding-model-tr').find('.add-color-btn.actual');
					btnColor.css({'transform':'scale(1.15)'});
					window.setTimeout(function(){
						btnColor.css({'transform':'scale(1)'});
						window.setTimeout(function(){
							btnColor.css({'transform':'scale(1.15)'});
							window.setTimeout(function(){
								btnColor.css({'transform':'scale(1)'});
							}, 300);
						}, 300);
					}, 300);

					let repairsContainerNew = jQuery(modelContainer).find('tr.adding-model-tr .more-details.repairs-details .details-container');

					jQuery(modelContainer).find('tr.adding-model-tr').removeClass('adding-model-tr');

					jQuery('.new-model').addClass('no-transition');

					jQuery('.new-model-content .new-model-close-button').click();

					window.setTimeout(function(){
						jQuery('.new-model').removeClass('no-transition');
					},500);

					if( response.added_model.related_repairs && response.added_model.related_repairs.length > 0 ) {

						add_repairs_for_newly_added_model( repairsContainerNew, response.added_model.related_repairs );

					}

				}

				window.rp_default_repair_classes();

				jQuery(btn).html(btndata);
				repairPluginUI.alert_success('Model successfully added.');
				jQuery(btn).removeClass("processing");
				resetAllModelInputs();
				repairsContainerSortable();
			},
			error: function(response) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});
	});



	function trackUnsavedChanges() {
		jQuery(document).on('change', 'tbody.modelContainerTbody tr.main-model input[type="text"]', function(){
			jQuery(this).parents('tr.main-model').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.modelContainerTbody tr.Orderingmodelclr input[type="text"]', function(){
			jQuery(this).parents('tr.Orderingmodelclr').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.modelContainerTbody .sec-sorting input[type="text"]', function(){
			jQuery(this).parents('.sec-sorting').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'input[name^="m_link["]', function(){
			jQuery(this).parents('.tr').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.append_models tr.main-repair input[type="text"]', function(){
			jQuery(this).parents('tr.main-repair').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.append_models tr.main-repair select', function(){
			jQuery(this).parents('tr.main-repair').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.append_models tr.sub-repairs-details input[type="text"]', function(){
			jQuery(this).parents('tr.sub-repairs-details').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.append_models tr.sub-repairs-details select', function(){
			jQuery(this).parents('tr.sub-repairs-details').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
		jQuery(document).on('change', 'tbody.append_models tr.main-repair input.repair-free', function(){

			let price_input = jQuery(this).parents('.main-repair').find('input[name^="rprice"]');

			let margin_input = jQuery(this).parents('.main-repair').find('input[name^="rmargin"]');

			let parentEl = jQuery(this).parents('.Orderingrepairs');

			let has_attr = jQuery(parentEl).find('input[name^="raprice"]').length > 0;

			if(jQuery(this).is(':checked')) {

				price_input.attr('readonly', 'readonly');

				price_input.attr('old-value', price_input.val());

				price_input.val('0').change();

				if( jQuery(margin_input).length > 0 ) {

					margin_input.attr('readonly', 'readonly');

					margin_input.attr('old-value', margin_input.val());

					margin_input.val('0').change();

				}

			}	else {

				if(!has_attr) {
					price_input.removeAttr('readonly');
					if( jQuery(margin_input).length > 0 ) {
						margin_input.removeAttr('readonly');
					}
				}

				let old_value = price_input.attr('old-value');

				if(old_value && old_value != null) {

					price_input.val(old_value).change();

				} else {

					price_input.val('').change();

				}

				if(!has_attr) {
					price_input.focus();
				}

				if( jQuery(margin_input).length > 0 ) {

					let old_value_margin = margin_input.attr('old-value');

					if(old_value_margin && old_value_margin != null) {

						margin_input.val(old_value_margin).change();

					} else {

						margin_input.val('').change();

					}

				}

			}

			jQuery(this).parents('tr.main-repair').addClass('unsaved');
			updateUnsavedManageModelButton();
		});
	}
	trackUnsavedChanges();
	window.saveChangesText = 'Save Changes (X)';
	function updateUnsavedManageModelButton() {
		let totalUnsaved = 0;
		jQuery("tr.Orderingmodel").each(function(){
			if(jQuery(this).find('tr.unsaved').length > 0 || jQuery(this).find('tr.Orderingmodelclr .repair-list-sort.unsaved').length > 0 || jQuery(this).find('.main-model .repair-list-sort.unsaved').length > 0 || jQuery(this).find('.sec-sorting.unsaved').length > 0 || jQuery(this).find('.tr.unsaved').length > 0 || jQuery(this).find('.wp-repair-category-image-upload-button.unsaved').length > 0 || jQuery(this).find('.Orderingrepairs .repair-list-sort.unsaved').length > 0) {
				totalUnsaved++;
				if(jQuery(this).find('tr.unsaved').length === 0 && jQuery(this).find('.sec-sorting.unsaved').length === 0 && jQuery(this).find('.tr.unsaved').length === 0 && jQuery(this).find('tr.Orderingmodelclr .repair-list-sort.unsaved').length === 0 && jQuery(this).find('.wp-repair-category-image-upload-button.unsaved').length === 0 && jQuery(this).find('.Orderingrepairs .repair-list-sort.unsaved').length === 0) {

				} else {
					jQuery(this).find('button.see-more.plus-icon').addClass('unsaved');
				}
			} else {
				jQuery(this).find('button.see-more.plus-icon').removeClass('unsaved');
			}
		});
		if(totalUnsaved > 0) {
			jQuery("#saveChanges").html(window.saveChangesText.replace('(X)', '('+totalUnsaved+')')).removeClass('hide');
		} else {
			window.saveChangesText = 'Save Changes (X)';
			jQuery("#saveChanges").html(window.saveChangesText.replace('(X)', '(0)')).addClass('hide');
		}
	}
	window._updateUnsavedManageModelButton = function() {
		updateUnsavedManageModelButton();
	};
	function update_default_listing_range_position(e, ui) {
		jQuery(".details-container .the-additional-repair").each(function(i, num){

			jQuery(this).find('> tr.Orderingrepairs').each(function(index){

				if( jQuery(this).find('input[name="default_listing_range"]').length > 0 ) {

					jQuery(this).find('input[name="default_listing_range"]').val(index);
					
				}
				
			});

		});
	}
	function sortingHasUpdated(e,ui) {

		if(jQuery(ui.item[0]).hasClass('Orderingmodelclr')) {
			jQuery(ui.item[0]).parents('.colorContainer').find('tr.Orderingmodelclr .repair-list-sort').addClass('unsaved');
			updateUnsavedManageModelButton();
		} else if(jQuery(ui.item[0]).hasClass('OrderingrepairsAttr')) {
			jQuery(ui.item[0]).parents('.repairsAttrContainer').find('tr.OrderingrepairsAttr .repair-list-sort').addClass('unsaved');
			updateUnsavedManageModelButton();
		} else {
			if( jQuery(ui.item[0]).parents('.repairsContainer').length > 0 ) {

				jQuery(ui.item[0]).parents('.repairsContainer').find('tr.Orderingrepairs .main-repair .repair-list-sort').addClass('unsaved');
				updateUnsavedManageModelButton();

			} else {

				jQuery(ui.item[0]).parents('.modelContainerTbody').find('tr.Orderingmodel .main-model .repair-list-sort').addClass('unsaved');
				updateUnsavedManageModelButton();

			}
		}
	}

	function needToTriggerUpdateModel( Orderingmodel = null ) {

		return (jQuery(Orderingmodel).find('tr.main-model.unsaved').length > 0 || jQuery(Orderingmodel).find('tr.model-details .details-container tr.unsaved').length > 0 || jQuery(Orderingmodel).find('tr.Orderingmodelclr .repair-list-sort.unsaved').length > 0 || jQuery(Orderingmodel).find('.sec-sorting.unsaved').length > 0 || jQuery(Orderingmodel).find('.wp-repair-category-image-upload-button.unsaved').length > 0);

	}

	function needToTriggerUpdateRepair( Orderingmodel = null ) {

		return (jQuery(Orderingmodel).find('.repairs-details .details-container tr.unsaved').length > 0 || jQuery(Orderingmodel).find('tr.main-repair .repair-list-sort.unsaved').length > 0 || jQuery(Orderingmodel).find('tr.sub-repairs-details .repair-list-sort.unsaved').length > 0);

	}

	jQuery("#saveChanges").on('click', function(){
		if(jQuery(this).hasClass('processing')) {
			return;
		}
		let lastTime = 1;
		let btn = this;
		jQuery(btn).addClass('processing');
		window.saveChangesText = '<i style="position:relative; top:-1px; font-size: 14px;" class="fas fa-spinner fa-spin"></i>';
		jQuery("#saveChanges").html(window.saveChangesText);

		if(jQuery('.Orderingmodel .main-model .repair-list-sort.unsaved').length > 0) {
			jQuery("#savemOrder").click();
		}

		let needWork = [];
		jQuery("tr.Orderingmodel").each(function(i){
			let Orderingmodel = this;

			if(jQuery(this).find('tr.unsaved').length > 0 || jQuery(this).find('tr.Orderingmodelclr .repair-list-sort.unsaved').length > 0 || jQuery(this).find('tr.main-repair .repair-list-sort.unsaved').length > 0 || jQuery(this).find('.sec-sorting.unsaved').length > 0 || jQuery(this).find('.tr.unsaved').length > 0 || jQuery(this).find('.wp-repair-category-image-upload-button.unsaved').length > 0 || jQuery(this).find('tr.sub-repairs-details .repair-list-sort.unsaved').length > 0) {
				needWork.push(Orderingmodel);
			}
		});

		let last_index = needWork.length - 1;

		needWork.forEach(function(val, i){
			let Orderingmodel = val;
			let c_index = i;

			window.setTimeout(function(){
				if( needToTriggerUpdateModel( Orderingmodel ) ) {
					jQuery(Orderingmodel).find('button.update_model').click();
				}
				if( needToTriggerUpdateRepair( Orderingmodel ) ) {
					jQuery(Orderingmodel).find('button.update_repair').click();
				}
				if(last_index === c_index) {
					jQuery(btn).removeClass('processing');
				}
			}, lastTime);
			lastTime += 300;

		});


		if(needWork.length === 0) {
			jQuery(btn).removeClass('processing');
		}
	});
</script>
<script type="text/javascript">

(function($){
	function showFullWidthModal(content = '', special_cls = '') {
		$(".va-full-width-modal").remove();
		let html = `
			<div class="va-full-width-modal ${special_cls}">
				<div class="va-full-width-modal-main clearfix">
					<div class="va-full-width-modal-inner">
						${content}
					</div>
					<button class="va-button va-button-default va-close-modal">
						<i class="fas fa-times"></i>
					</button>
				</div>
			</div>
		`;
		$("body").append(html);
		$(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
		$(".va-full-width-modal .va-close-modal").on("click", function(){
			$(this).parent().animate({'top': '-50%'}, 400, function(){
				$(this).parent().remove();
			});
		});
		$(document).on("mouseup", handOutsideClick);
		// $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
	}
	function handOutsideClick(e) {
		var container = $('.va-full-width-modal-main');
		// if the target of the click isn't the container nor a descendant of the container
		if (!container.is(e.target) && container.has(e.target).length === 0) 
		{
		    container.find(".va-close-modal").click();
		    $(document).off("mouseup", handOutsideClick);
		}
	}

	jQuery(document).on('click', '.reset-default-repair.active', function(e){
		e.preventDefault();
		let repair_name = jQuery(this).data('rname');
		let repair_id = jQuery(this).data('drid');
		showFullWidthModal(`
			<p class="va-modal-title va-danger-title">Reset <b>${repair_name}</b> Repair</p>
			<p>Are you sure you want to reset this repair?</p>
			<input type="hidden" name="alert" value="1">
			<button data-drid="${repair_id}" type="submit" class="va-button va-reset-default-repair">
				Reset Repair
			</button>
		`);
	});

	jQuery(document).on('click', '.va-full-width-modal-inner .va-button.va-reset-default-repair', function(){

		if(jQuery(this).hasClass("processing")) {
			return;
		}

		let btn = this;

		jQuery(btn).addClass("processing");

		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i style="position:relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

		let drid = jQuery(this).data('drid');

		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {
				action:'rp_reset_default_repair_individually',
				drid: drid
			},
			success: function(data) {

				jQuery(btn).html(btndata);

				jQuery(btn).removeClass("processing");

				try {
					
					data = JSON.parse(data);

				} catch(e) {

					repairPluginUI.alert_danger('Something went wrong, please try again later.');	
					return;

				}

				if(data.status == true || data.status == 'true') {

					let btn = jQuery("button.reset-default-repair[data-drid='"+drid+"']").parents(".details-container").find('button.update_repair');

					if(data && data.table_rows && data.table_rows.length > 0) {

						let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
						jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
						updateUnsavedManageModelButton();
						data.table_rows.forEach(function(val, i){
							let getTr = '';
							if( val.listing_range !== undefined && val.listing_range !== null ){
								getTr = `
									<tr class="justForsort Orderingrepairs draggable ui-state-default">
										<td colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>"><hr><div class="button">Hide under show all .. repairs button ↓</div>
											<input type="hidden" name="default_listing_range" id="default_listing_range" value="${val.listing_range}" />
										</td>
									</tr>
								`;
							}else{
								if( val.repair_margin === undefined || val.repair_margin === null ) {
									val.repair_margin = null;
								}
							 	getTr = add_model_repair_tr(val.m_id, val.r_id, val.r_img, val.repair_title, val.repair_min, val.repair_info, val.repair_price, val.is_active, val.is_free, val.r_duration_measure, val.r_uq_id, val.is_fully_unchanged, val.repair_margin, val.repair_badge);
							}
							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(getTr);
							let OrderingrepairsCont = jQuery(repairsContainer).find('.Orderingrepairs.adding-model-repair-tr');
							OrderingrepairsCont.removeClass('adding-model-repair-tr');
							if(val.attrs != undefined && val.attrs.length > 0) {

								jQuery(OrderingrepairsCont).find('.add-more.add-first-repair-attr').removeClass('add-more add-first-repair-attr').addClass('dropdown').html('<i class="fas fa-caret-down"></i>');

								jQuery(OrderingrepairsCont).find('input[name^="rprice"]').attr('readonly', 'readonly');

								jQuery(OrderingrepairsCont).find('input[name^="rmargin"]').attr('readonly', 'readonly');

								let sub_repair_tr = `
									<tr class="sub-repairs-details">
										<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
											<div class="special-table">
												<table class="table repairsAttrContainer ui-sortable">
													<thead>
														<tr>
															<th style="width: 85px;">
															</th>
															<th style="width: 175px;">
															</th>
															<th style="width: 55px;">
															</th>
															<th style="width: 225px;">
															</th>
															<th style="width: 75px">
															</th>
															<th style="width: 30px">
															</th>
															<th style="width: 220px;"></th>
														</tr>
													</thead>
													<tbody class="append_attr_data">

													</tbody>
												</table>
											</div>
										</td>
									</tr>
								`;
								jQuery(OrderingrepairsCont).find('tr.main-repair').after(sub_repair_tr);
								jQuery(OrderingrepairsCont).find(".repairsAttrContainer").each(function(){
									jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){ update_default_listing_range_position(e,ui); }, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
								});

								val.attrs.forEach(function(newVal){
									if( newVal.a_margin === undefined || newVal.a_margin === null ) {
										newVal.a_margin = null;
									}
									let repairAttrTR = add_model_repair_attr_tr(val.r_id, val.m_id, newVal.a_id, newVal.a_name, newVal.a_desc, newVal.a_price, newVal.a_uq_id, newVal.is_active, newVal.a_margin, newVal.a_badge, newVal.attr_min, newVal.a_duration_measure);
									jQuery(OrderingrepairsCont).find('.repairsAttrContainer tbody.append_attr_data').append(repairAttrTR);
								});
							}
						});

					} else {
						let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
						jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
						updateUnsavedManageModelButton();
					}

					window.rp_default_repair_classes();






					jQuery(".va-close-modal").click();
					repairPluginUI.alert_success('Repair has been reset successfully.');
				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}

			},
			error: function(response) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});

	});

	jQuery(document).on('click', '.globe-icon-translation', function(){

			if(jQuery(this).hasClass('is-default-repair')) {
				alert('Please go to default repairs page to edit this translation.');
				return;
			}

			if(jQuery('.globe-icon-translation').hasClass("processing")) {
				return;
			}
			let btn = this;

			let trans_key = jQuery(this).data('trans-key');
			let trans_uqid = jQuery(this).data('trans-uqid');

			let trans_selector = jQuery(this).data('trans-selector');

			let trans_connection_id = 0;
			let rp_action = 'rp_get_r_translations';

			if(trans_key === 'attr_name' || trans_key === 'attr_desc' || trans_key === 'attr_badge') {

				trans_connection_id = jQuery(this).data('trans-ridfk');
				rp_action = 'rp_get_rattr_translations';

			} else {

				trans_connection_id = jQuery(this).data('trans-midfk');

			}

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<div class="globe-icon-i"><i class="fas fa-spinner fa-spin"></i></div>');

			jQuery('.globe-icon-translation').addClass("processing");

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action: rp_action, key: trans_key, uqid: trans_uqid, connection_id: trans_connection_id},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery('.globe-icon-translation').removeClass("processing");
					
					try {
		      			
		      			data = JSON.parse(data);

		      		} catch(e) {

		      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
		      			return;

		      		}
					
					let rows = '';

					data.translations.forEach(function(row){

						rows += `
							<tr>
								<td width="300">
									<div class="flag-img">
										<img width="28px" height="28px" src="${row.image}">
									</div>
									<div class="input-cont">
										<div class="wp-repair-input-group">
											<label>${row.alt_name}</label>
											<input type="text" class="user-info" data-lang-name="${row.name}" name="translations[]" value="${row.t_value}" required="">
										</div>
									</div>
								</td>
							</tr>
						`;

					});

					showFullWidthModal(`
						<p class="va-modal-title">Update Translations</p>
						<table style="width:100%;">
							<tbody>
								${rows}
							</tbody>
						</table>
						<input type="hidden" name="alert" value="1">
						<input type="hidden" name="trans_key" value="${trans_key}">
						<input type="hidden" name="trans_uqid" value="${trans_uqid}">
						<input type="hidden" name="trans_connection_id" value="${trans_connection_id}">
						<input type="hidden" name="trans_selector" value="${trans_selector}">
						<button type="submit" class="va-button va-submit">
							Update
						</button>
					`);

				},
				error: function() {
					jQuery(btn).html(btndata);
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
					jQuery('.globe-icon-translation').removeClass("processing");
					jQuery(btn).removeClass("processing");
				}
			});

	});

	jQuery(document).on('click', '.va-full-width-modal-inner .va-button.va-submit', function(){

		if(jQuery(this).hasClass("processing")) {
			return;
		}

		let btn = this;

		jQuery(btn).addClass("processing");

		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i style="position:relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

		let keys = [];
		let values = [];

		let translation_key = jQuery('.va-full-width-modal-inner input[name^="trans_key"]').val();
		let translation_uqid = jQuery('.va-full-width-modal-inner input[name^="trans_uqid"]').val();
		let translation_connection_id = jQuery('.va-full-width-modal-inner input[name^="trans_connection_id"]').val();

		let translation_selector = jQuery('.va-full-width-modal-inner input[name^="trans_selector"]').val();

		let action = 'rp_update_r_translations';

		if(translation_key === 'attr_name' || translation_key === 'attr_desc' || translation_key === 'attr_badge') {
			action = 'rp_update_rattr_translations';
		} else {
			action = 'rp_update_r_translations';
		}

		jQuery('.va-full-width-modal-inner input[name^="translations["]').each(function(){
			keys.push(jQuery(this).data('lang-name'));
			values.push(jQuery(this).val());
		});

		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {
				action:action,
				keys:keys,
				values:values,
				translation_key: translation_key,
				translation_uqid: translation_uqid,
				translation_connection_id: translation_connection_id
			},
			success: function(data) {

				jQuery(btn).html(btndata);

				jQuery(btn).removeClass("processing");

				try {
	      			
	      			data = JSON.parse(data);

	      		} catch(e) {

	      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
	      			return;

	      		}

	      		if(data.status == true || data.status == 'true') {
					jQuery(".va-close-modal").click();
					let globe_icon = null;

					jQuery('.globe-icon-translation').each(function(){

						let git_key = jQuery(this).data('trans-key');
						let git_uqid = jQuery(this).data('trans-uqid');

						let git_connection_id = '';

						if(git_key === 'attr_name' || git_key === 'attr_desc' || git_key === 'attr_badge') {
							git_connection_id = jQuery(this).data('trans-ridfk');
						} else {
							git_connection_id = jQuery(this).data('trans-midfk');
						}

						if(git_key === translation_key && git_uqid === translation_uqid && parseInt(git_connection_id) === parseInt(translation_connection_id)) {
							let _parent = 'tr.main-repair';
							if(git_key === 'attr_name' || git_key === 'attr_desc' || git_key === 'attr_badge') {
								_parent = 'tr.additional-repair-tr';
							}
							jQuery(this).parents(_parent).find(translation_selector).val(data.default_translation);
						}

					});
	      			repairPluginUI.alert_success('Translations updated successfully.');
	      		} else {
	      			repairPluginUI.alert_danger('Something went wrong, please try again later.');
	      		}

			},
			error: function(response) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});

	});

	window.all_dr_uq_ids = <?php echo json_encode(rp_get_all_dr_uq_id_from_rs_default_repair_table()); ?>;
	window.all_da_uq_ids = <?php echo json_encode(rp_get_all_da_uq_id_from_rs_default_repair_attr_table()); ?>;

	function rp_item_in_array(item, array) {
		for(let i = 0; i < array.length; i++) {
			if(array[i] === item) {
				return true;
			}
		}
		return false;
	}

	function rp_default_repair_classes() {
		jQuery("[data-trans-uqid]").each(function(){

		if(jQuery(this).data('trans-uqid') === '') {
			return;
		}

		let trans_uqid = jQuery(this).data('trans-uqid');

		// check if trans uqid is in all_dr_uq_ids
		if(rp_item_in_array(trans_uqid, window.all_dr_uq_ids)) {
			jQuery(this).addClass('is-default-repair');
			jQuery(this).parent().addClass('is-default-repair');
		}

		if(rp_item_in_array(trans_uqid, window.all_da_uq_ids)) {
			jQuery(this).addClass('is-default-repair');
			jQuery(this).parent().parent().parent().addClass('is-default-repair');
		}

		});
	}

	rp_default_repair_classes();

	window.rp_default_repair_classes = function () {
		rp_default_repair_classes();
	}

}(jQuery));

</script>