<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}
global $rpQuery;
$company_information = $rpQuery->prefix ."rs_company_information";
$company_results = $rpQuery->get_results("SELECT * FROM $company_information");
$company_email = '';
if(!empty($company_results)) {
	$company_email = $company_results[0]->company_email;
}
$permission = new RepairPluginPro\Permission();
$allRolesPermissions = $permission->getAllRolesPermissions();
if (isset($_POST['update_data'])) {

	rp_verify_csrf_token_for_simple_form('manage_permission');

	if(!current_user_can('activate_plugins')) {
		echo "<script>location.replace('admin.php?page=wp_repair_settings&section=general_info');</script>";
		exit();
	}
	$_POST['administrator'] = '1';
	foreach ($allRolesPermissions as $role_name => $role_info) {
		if(isset($_POST[$role_name]) && !empty($_POST[$role_name])) {
			$permission->add_permission($role_name);
		} else {
			$permission->remove_permission($role_name);
		}
	}
	echo "<script>location.replace('admin.php?page=wp_repair_settings&section=manage_permission');</script>";
	exit();
}
?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.duplicate-email-settings-container .tax-fields {
		margin-bottom: 12px;
	}
</style>
<form method="post" action="">
	<?php
	rp_csrf_token_input_field('manage_permission');
	?>
	<div class="wp-repair-container">
		<div class="wp-repair-row">
			<div class="wp-repair-col-12 settings">
				<div class="repair-dl-rounded-container">
					<div class="wp-repair-row">
						<?php wpRepairLoadSidebar('manage_permission'); ?>
						<div class="wp-repair-col-8 bg-with-border">
							<div class="wp-repair-col-4 main-section" style="width: 100%;">
								<div class="wp-repair-main-section-heading">
									<h2>
										<span class="bold">Manage</span>
										<span class="light">Permissions</span>
									</h2>
									<p class="more-info">Set which user roles are allowed to manage the plugin</p>
								</div>
							</div>
							<?php
							foreach ($allRolesPermissions as $role => $bool) {
								$role = strtolower($role);
								?>
								<div class="wp-repair-col-4 main-section single-permission">
									<div class="tax-fields first">
										<div class="apply-tax-rate" <?php if($role === 'administrator') { echo 'style="opacity:0.7;";'; } ?>>
											<div class="td select">
												<label class="switch">
												  <input type="hidden" name="<?php echo $role; ?>" value="0">
												  <input type="checkbox" name="<?php echo $role; ?>" <?php if(!empty($bool)){echo 'checked';}?> value="1" <?php if($role === 'administrator') { echo 'disabled="disabled";'; } ?>>
												  <span class="slider round"></span>				
												</label>
											</div>
											<div class="td text">
												<span class="text"><?php echo ucwords(str_replace(array('_', '-'), ' ', $role)); ?></span>
											</div>
										</div>
									</div>
								</div>
								<?php
							}
							?>
							<div class="wp-repair-col-4 main-section" style="width: 100%;">
								<div class="full-width-wp-repair" style="padding: 0px;">
									<div class="wp-repair-inner-col section-1" style="margin-top: 20px;">
										<div class="sec-3">
											<button type="submit" name="update_data" class="wp-general-info">Save Settings</button>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</form>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
?>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/tinymce.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/jquery.tinymce.min.js"></script>

<script>
	function createVariableLook(value) {
		return value;
		value = value.replace('$', '').replace('$', '');
		return '$<span style="border-radius:5px; padding: 2px; background-color: #dbdbdb; color: #333;">'+value+'</span>$';
	}
  tinymce.init({
    selector: '.mytextarea',
    menubar: 'newmenu',
    menu: {
    	newmenu: {title: 'Dynamic Order Information', items: 'customername customeremail customerphone customernotes newmenuitemdeliverydate newmenuitemdeliverytime newmenuitem2 newmenuitem newmenuitemdeliverymethod newmenuitem5 newmenuitem4 newmenuitem3 ordersummary newmenuitem6 newmenuitem7'}
    },
    plugins: ['link'],
    setup: function (editor) {
		editor.addMenuItem('customername', {
	        text:  'Customer Name',
	        context: 'newmenu',
	        onselect: function () { marker =editor.insertContent(createVariableLook('$CustomerName$')); }
	    });
	    editor.addMenuItem('customeremail', {
	        text:  'Customer Email',
	        context: 'newmenu',
	        onselect: function () { editor.insertContent(createVariableLook('$CustomerEmail$')); }
	    });
	    editor.addMenuItem('customerphone', {
	        text:  'Customer Phone',
	        context: 'newmenu',
	        onselect: function () { editor.insertContent(createVariableLook('$CustomerPhone$')); }
	    });
	    editor.addMenuItem('customernotes', {
	        text:  'Customer Notes',
	        context: 'newmenu',
	        onselect: function () { editor.insertContent(createVariableLook('$CustomerNotes$')); }
	    });
    	editor.addMenuItem('newmenuitem', {
            text:  'Created Time',
            context: 'newmenu',
            onselect: function () { editor.insertContent(createVariableLook('$CreatedTime$')); }
        });
		editor.addMenuItem('newmenuitem2', {
			text: 'Created Date',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$CreatedDate$')); }
		});
		editor.addMenuItem('newmenuitem3', {
			text: 'Model',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$Model$')); }
		});
		editor.addMenuItem('newmenuitem4', {
			text: 'Brand',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$Brand$')); }
		});
		editor.addMenuItem('newmenuitem5', {
			text: 'Category',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$Category$')); }
		});
		editor.addMenuItem('ordersummary', {
			text: 'Order Summary',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$OrderSummary$')); }
		});
		editor.addMenuItem('newmenuitem6', {
			text: 'Location Name',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$LocationName$')); }
		});
		editor.addMenuItem('newmenuitemdeliverymethod', {
			text: 'Delivery Method',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$DeliveryMethod$')); }
		});
		editor.addMenuItem('newmenuitemdeliverytime', {
			text: 'Appointment Time',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$AppointmentTime$')); }
		});
		editor.addMenuItem('newmenuitemdeliverydate', {
			text: 'Appointment Date',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$AppointmentDate$')); }
		});
		editor.addMenuItem('newmenuitem7', {
			text: 'Cancel Button',
			context: 'newmenu',
			onselect: function () { editor.insertContent(createVariableLook('$cancel$')); }
		});
      }
  });
  jQuery(window).on("load", function(){
  	jQuery(".mce-container iframe").contents().find("body").css({color: '#454545'});
  });
  (function($){
  	$(document).on("wpRepairReady", function(){
  		$(".duplicate-email-settings-container").each(function(){
  			let cont = this;
  			$(this).find(".switch input").on("change", function(){
  				if($(this).is(':checked')) {
  					$(cont).find(".duplicate_email-email-input").show();
  				} else {
  					$(cont).find(".duplicate_email-email-input").hide();
  				}
  			});
  		});
  	});
  }(jQuery));
</script>
<style type="text/css">

	.mce-btn {
		background-color: #fff;
	}
	.mce-panel {
		background-color: #fff;
	}
	.wp-repair-input-group > .mce-panel.mce-container {
		border-width: 2px;
		    border-radius: 8px;
		    border: 2px solid #cfcfcf !important;
		    box-sizing: border-box;
		    padding: 0px 2px;
		transition: border-color 0.3s;
	}
	.mce-path {
		display: none;
	}
	.mce-statusbar.mce-container {
		border: 0px;
	}
	.mce-container-body .mce-resizehandle {
		right: 2px;
		    bottom: 2px;
	}
	.mce-container-body.mce-stack-layout {
		padding: 1px;
	}
	.wp-repair-input-group label {
		z-index: 10;
	}
	.wp-repair-input-group > .mce-panel.mce-container:hover {
		border: 2px solid #2781c7 !important;
	    box-shadow: none;
	    outline: 0;
	}
	.mce-container,
	.mce-content-body,
	.mce-menubar .mce-menubtn button span,
	.mce-menu-item,
	.mce-menu-item .mce-ico, .mce-menu-item .mce-text  {
		color: #454545;
	}
	div.mce-edit-area {
		min-height: 200px;
	}
	div.mce-edit-area iframe {
		min-height: 200px;
	}
	/*.mce-container.mce-menubar.mce-toolbar {
		display: none;
	}*/
	iframe #tinymce {
		background-color: #000;
	}
</style>