<?php

defined( 'ABSPATH' ) || exit;

function rp_render_sort_button( $range = 0, $added_margin_column = FALSE ) {

	?>
	<tr class="justForsort Orderingrepairs draggable ui-state-default">
		<td colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>"><hr><div class="button">Hide under show all .. repairs button ↓</div>
			<input type="hidden" name="default_listing_range" value="<?php echo $range; ?>" />
		</td>
	</tr>
	<?php

}

function rp_duration_measure_options() {

	return array('minutes', 'hours', 'days');

}

function rp_duration_measure_options_markup( $selected = '' ) {

	$options = rp_duration_measure_options();

	if( empty( $selected ) ) {

		$selected = 'minutes';

	}

	$selected = trim( strtolower( $selected ) );

	foreach ($options as $option) {

		$option = strtolower( $option );

		if( $option === 'minutes' ) {

			$option_text = 'mins';

		}else if( $option === 'hours' ) {

			$option_text = 'hrs';

		} else {

			$option_text = $option;

		}

		if( $option === $selected ) {

			?>
			<option selected="selected" value="<?php echo $option; ?>"><?php echo strtoupper($option_text); ?></option>
			<?php

		} else {

			?>
			<option value="<?php echo $option; ?>"><?php echo strtoupper($option_text); ?></option>
			<?php

		}

	}

}

function rp_manage_repairs_easy_copy_js( $decimal = '' ) {
	global $added_margin_column;
	?>
	<script type="text/javascript">
		window.rp_set_decimal = '<?php echo $decimal; ?>';

		function uniqid(){
		  return Math.random().toString(16).slice(2)+(new Date()).getTime()+Math.random().toString(16).slice(2);
		}

		function ucwords (str) {
			return str.toUpperCase();
		    return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
		        return $1.toUpperCase();
		    });
		}

		function rp_duration_measure_options_markup( selected = '' ) {

			let options = <?php echo json_encode( rp_duration_measure_options() ); ?>;

			if( selected == '' ) {

				selected = 'minutes';

			}

			selected = selected.toLowerCase().trim();

			let template = '';

			options.forEach(function(option){

				option = option.toLowerCase();

				let option_text = option;

				if( option_text === 'minutes' ) {

					option_text = 'mins';

				}

				if( option_text === 'hours' ) {

					option_text = 'hrs';

				}

				if( option === selected ) {

					template += `<option selected="selected" value="${option}">${ucwords(option_text)}</option>`;

				} else {

					template += `<option value="${option}">${ucwords(option_text)}</option>`;

				}

			});

			return template;

		}

		function add_model_repair_attr_tr(r_id, m_id, ra_id, repair_attr_name, repair_attr_desc, repair_attr_price, a_uq_id, is_active_attr, repair_attr_margin = null, repair_attr_badge = '', attr_min = 0, a_duration_measure = '') {
			if( !a_duration_measure || a_duration_measure == '' ) {
				a_duration_measure = 'minutes';
			}
			if(is_active_attr === '1') {
				is_active_attr = 'checked="checked"';
			} else {
				is_active_attr = '';
			}
			if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
				repair_attr_price = repair_attr_price + '';
				repair_attr_price = repair_attr_price.replace('.', ',');
			}
			let repair_attr_margin_td = '';
				if( repair_attr_margin !== null ) {
					if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
						repair_attr_margin = repair_attr_margin + '';
						repair_attr_margin = repair_attr_margin.replace('.', ',');
					}
					repair_attr_margin_td = `
						<td style="width: 75px;">
							<input class="repair-price" type="text" id="ramargin${m_id}" placeholder="99,99" name="ramargin[]" value="${repair_attr_margin}" required="">
						</td>
					`;
				}
			let tr = `
				<tr class="additional-repair-tr OrderingrepairsAttr" data-uid="${r_id}">
					<td style="width:940px;" colspan="<?php if( $added_margin_column === TRUE ) { echo '4'; } else { echo '5'; } ?>">
						<div class="repair-more-options">
							<label class="switch">
							<input type="checkbox" ${is_active_attr} tabindex="-1" name="is_active_attr[]" value="${ra_id}">
							<span class="slider round"></span>
							</label>
							<button data-rid="${r_id}" tabindex="-1" type="button" class="add-more"><i class="fas fa-plus"></i></button>
							<span class="repair-list-sort ">
								<i class="fas fa-caret-up ui-sortable-handle" data-which="up"></i>
								<i class="fas fa-caret-down ui-sortable-handle" data-which="down"></i>
							</span>
							<input type="hidden" id="raid${m_id}" name="raid[]" value="${ra_id}">
							<div class="globe-icon-attr">
								<input class="repair-additional-name rptranslatable" id="raname${m_id}" type="text" placeholder="Original" name="raname[]" value="${repair_attr_name}" required="">
								<div data-trans-selector="input.repair-additional-name.rptranslatable" data-trans-key="attr_name" data-trans-uqid="${a_uq_id}" data-trans-ridfk="${r_id}" class="globe-icon-translation clearfix">
									<div class="globe-icon-i">
										<i class="fas fa-globe"></i>
									</div>
								</div>
							</div>
							<div class="ra-duration-fields w55" style="width: 55px;"><input tabindex="-1" class="attr-mins" placeholder="30" id="attr-mins${m_id}" type="text" name="aduration[]" value="${attr_min}" required=""></div>
        <div class="ra-duration-fields w74" style="width: 74px;">
         <select tabindex="-1" class="attr-duration-measure" id="attr-duration-measure${m_id}" name="adurationmeasure[]" required>
          ${rp_duration_measure_options_markup(a_duration_measure)}
         </select>
        </div>
							<div class="globe-icon-attr">
								<input class="repair-additional-desc rptranslatable" id="radesc${m_id}" type="text" placeholder="More Information" name="radesc[]" value="${repair_attr_desc}" required="">
								<div data-trans-selector="input.repair-additional-desc.rptranslatable" data-trans-key="attr_desc" data-trans-uqid="${a_uq_id}" data-trans-ridfk="${r_id}" class="globe-icon-translation clearfix">
									<div class="globe-icon-i">
										<i class="fas fa-globe"></i>
									</div>
								</div>
							</div>
							<div class="globe-icon-attr">
								<input class="repair-additional-badge rptranslatable" id="rabadge${m_id}" type="text" placeholder="Badge Text" name="rabadge[]" value="${repair_attr_badge}" required="">
								<div data-trans-selector="input.repair-additional-badge.rptranslatable" data-trans-key="attr_badge" data-trans-uqid="${a_uq_id}" data-trans-ridfk="${r_id}" class="globe-icon-translation clearfix">
									<div class="globe-icon-i">
										<i class="fas fa-globe"></i>
									</div>
								</div>
							</div>
						</div>
					</td>
					<td style="width: 75px;">
						<input class="repair-price" type="text" id="raprice${m_id}" placeholder="99,99" name="raprice[]" value="${repair_attr_price}" required="">
					</td>
					${repair_attr_margin_td}
					<td style="width: 220px;">
						<button type="button" data-aid="${ra_id}" tabindex="-1" class="wp-repair-cancel-link ra_delete"><i class="fas fa-times"></i>
						</button>
					</td>
				</tr>
			`;
			return tr;
		}

		function add_model_repair_tr(m_id, r_id, r_img, repair_title, repair_min, repair_info, repair_price, is_active, is_free, r_duration_measure, r_uq_id, is_fully_unchanged = '', repair_margin = null, repair_badge = '') {
			if(is_active === '1') {
				is_active = 'checked="checked"';
			} else {
				is_active = '';
			}

			let readonly = '';

			if( r_duration_measure == '' ) {

				r_duration_measure = 'minutes';

			} 

			if(is_free === '1') {
				readonly = 'readonly="readonly"';
			}

			if(is_free === '1') {
				is_free = 'checked="checked"';
			} else {
				is_free = '';
			}

			if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
				repair_price = repair_price + '';
				repair_price = repair_price.replace('.', ',');
			}

			let repair_margin_td = '';
			if( repair_margin !== null ) {
				if(window.rp_set_decimal && window.rp_set_decimal === 'comma') {
					repair_margin = repair_margin + '';
					repair_margin = repair_margin.replace('.', ',');
				}
				repair_margin_td = `
					<td style="width: 75px;"><input ${readonly} class="repair-price" id="repair-margin${m_id}" type="text" placeholder="99,99" name="rmargin[]" value="${repair_margin}" required=""></td>
				`;
			}

			let reset_repair_btn_markup = '';

			let reset_repair_cls = '';

			if( is_fully_unchanged === '1' ) {

				reset_repair_cls = 'grayed-out';

			} else {

				reset_repair_cls = 'active';

			}

			if(jQuery.inArray(r_uq_id, window.all_dr_uq_ids) !== -1) {

				reset_repair_btn_markup = `<button data-rname="${repair_title}" data-drid="${r_id}" type="button" class="reset-default-repair ${reset_repair_cls}" style="margin-left: 5px; font-size: 16px;">
					<i class="fas fa-redo"></i>
				</button>`;

			}

			let tr = `
				<tr class="justForsort Orderingrepairs adding-model-repair-tr ui-state-default ui-state-not-allowed">
					<td class="justForsort" colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>">
						<table class="justForsort">
							<tbody class="justForsort">
								<tr class="main-repair">
									<td style="width: 120px;">
										<label class="switch">
										<input type="checkbox" ${is_active} tabindex="-1" name="is_active[]" id="is_active${m_id}" value="${r_id}">
										<span class="slider round"></span>
										</label>
										<span class="repair-list-sort ui-sortable-handle">
										<i class="fas fa-caret-up" data-which="up"></i>
										<i class="fas fa-caret-down" data-which="down"></i>
										</span>
										<input type="hidden" name="rid[]" id="repair-id${m_id}" value="${r_id}">
										<input type="hidden" name="r_img_link" value="${r_img}">
										<div class="img-repair-show">
										<img src="${r_img}">
										</div>
									</td>
									<td style="width: 175px;">
										<input tabindex="-1" class="repair-title rptranslatable" placeholder="Repair Title" id="repair-title${m_id}" type="text" name="rname[]" value="${repair_title}" required="">
										<div data-trans-selector="input.repair-title.rptranslatable" data-trans-key="repair_name" data-trans-uqid="${r_uq_id}" data-trans-midfk="${m_id}" class="globe-icon-translation clearfix">
											<div class="globe-icon-i">
												<i class="fas fa-globe"></i>
											</div>
										</div>
									</td>
									<td style="width: 55px;"><input tabindex="-1" class="repair-mins" placeholder="30" id="repair-mins${m_id}" type="text" name="rduration[]" value="${repair_min}" required=""></td>
									<td style="width: 74px;">
										<select tabindex="-1" class="repair-duration-measure" id="repair-duration-measure${m_id}" name="rdurationmeasure[]" required>
											${rp_duration_measure_options_markup(r_duration_measure)}
										</select>
									</td>
									<td style="width: 225px;">
										<input tabindex="-1" class="repair-info rptranslatable" placeholder="More Information" id="repair-info${m_id}" type="text" name="rdiscription[]" value="${repair_info}" required="">
										<div data-trans-selector="input.repair-info.rptranslatable" data-trans-key="repair_desc" data-trans-uqid="${r_uq_id}" data-trans-midfk="${m_id}" class="globe-icon-translation clearfix">
											<div class="globe-icon-i">
												<i class="fas fa-globe"></i>
											</div>
										</div>
									</td>
									<td style="width: 175px;">
										<input tabindex="-1" class="repair-badge rptranslatable" placeholder="Badge Text" id="repair-badge${m_id}" type="text" name="rbadge[]" value="${repair_badge}" required="">
										<div data-trans-selector="input.repair-badge.rptranslatable" data-trans-key="repair_badge" data-trans-uqid="${r_uq_id}" data-trans-midfk="${m_id}" class="globe-icon-translation clearfix">
											<div class="globe-icon-i">
												<i class="fas fa-globe"></i>
											</div>
										</div>
									</td>
									<td style="width: 75px;"><input ${readonly} class="repair-price" id="repair-price${m_id}" type="text" placeholder="99,99" name="rprice[]" value="${repair_price}" required=""></td>
									${repair_margin_td}
									<td style="width: 30px;">
										<input class="repair-free" id="repair-free${m_id}" type="checkbox" name="rfree[]" ${is_free} required>
									</td>
									<td style="width: 160px;" class="additional-actions">
										<button type="button" data-rid="${r_id}" class="trash delete_repair" tabindex="-1">
										<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
										</button>
										<button data-rid="${r_id}" type="button" tabindex="-1" class="add-more add-first-repair-attr"><i class="fas fa-plus"></i></button>
										<label tabindex="-1" class="label-upload-image" for="upload_rimage_${r_id}"><img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/image.svg"></label>
										<input tabindex="-1" type="file" id="upload_rimage_${r_id}" style="display: none;" name="r_img_X" data-uimage-id="${r_id}">
										${reset_repair_btn_markup}
									</td>
								</tr>
							</tbody>
						</table>
					</td>
				</tr>
			`;
			return tr;
		}

		window.model_repair_attr_tr = `
			<tr class="additional-repair-tr OrderingrepairsAttr  uibyzahran-remove-tr uibyzahran-transition unsaved" data-uid="NEW">
				<td style="width:940px;" colspan="<?php if( $added_margin_column === TRUE ) { echo '4'; } else { echo '5'; } ?>">
					<div class="repair-more-options">
						<label class="switch">
						<input type="checkbox" checked="" tabindex="-1" name="is_active_attr[]" value="NEW">
						<span class="slider round"></span>
						</label>
						<button data-rid="NEW" tabindex="-1" type="button" class="add-more"><i class="fas fa-plus"></i></button>
						<span class="repair-list-sort ">
							<i class="fas fa-caret-up ui-sortable-handle" data-which="up"></i>
							<i class="fas fa-caret-down ui-sortable-handle" data-which="down"></i>
						</span>
						<input type="hidden" name="raid[]" value="NEW">
						<input class="repair-additional-name" type="text" placeholder="Original" name="raname[]" value="" required="">
						<div class="ra-duration-fields w55" style="width: 55px;"><input class="attr-mins" placeholder="30" type="text" name="aduration[]" value="" required=""></div>
						<div class="ra-duration-fields w74" style="width: 74px;">
							<select class="attr-duration-measure" name="adurationmeasure[]" required="required">
								<?php rp_duration_measure_options_markup(); ?>
							</select>
						</div>
						<input class="repair-additional-desc" type="text" placeholder="More Information" name="radesc[]" value="" required="">
						<input class="repair-additional-badge" type="text" placeholder="Badge Text" name="rabadge[]" value="" required="">
					</div>
				</td>
				<td style="width: 75px;">
					<input class="repair-price" type="text" placeholder="99,99" name="raprice[]" value="" required="">
				</td>
				<?php
				if( $added_margin_column === TRUE ) {
					?>
					<td style="width: 75px;">
						<input class="repair-price" type="text" placeholder="99,99" name="ramargin[]" value="" required="">
					</td>
					<?php
				}
				?>
				<td style="width: 220px;">
					<button type="button" data-aid="NEW" tabindex="-1" class="wp-repair-cancel-link ra_delete"><i class="fas fa-times"></i>
					</button>
				</td>
			</tr>
		`;

		window.model_repair_tr = `
			<tr class="justForsort Orderingrepairs ui-state-default ui-state-not-allowed uibyzahran-remove-tr uibyzahran-transition unsaved">
				<td class="justForsort" colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>">
					<table class="justForsort">
						<tbody class="justForsort">
							<tr class="main-repair">
								<td style="width: 120px;">
									<label class="switch">
									<input type="checkbox" checked="" tabindex="-1" name="is_active[]" value="NEW">
									<span class="slider round"></span>
									</label>
									<span class="repair-list-sort ui-sortable-handle">
									<i class="fas fa-caret-up" data-which="up"></i>
									<i class="fas fa-caret-down" data-which="down"></i>
									</span>
									<input type="hidden" name="rid[]" value="NEW">
									<input type="hidden" name="r_img_link">
									<div class="img-repair-show">
									<img src="">
									</div>
								</td>
								<td style="width: 175px;"><input class="repair-title" placeholder="Repair Title" type="text" name="rname[]" value="" required=""></td>
								<td style="width: 55px;"><input class="repair-mins" placeholder="30" type="text" name="rduration[]" value="" required=""></td>
								<td style="width: 74px;">
									<select class="repair-duration-measure" name="rdurationmeasure[]" required="required">
										<?php rp_duration_measure_options_markup(); ?>
									</select>
								</td>
								<td style="width: 225px;"><input class="repair-info" placeholder="More Information" type="text" name="rdiscription[]" value="" required=""></td>
								<td style="width: 175px;"><input class="repair-badge" placeholder="Badge Text" type="text" name="rbadge[]" value="" required=""></td>
								<td style="width: 75px;"><input class="repair-price" type="text" placeholder="99,99" name="rprice[]" value="" required=""></td>
								<?php
								if( $added_margin_column === TRUE ) {
									?>
									<td style="width: 75px;"><input class="repair-price" type="text" placeholder="99,99" name="rmargin[]" value="" required=""></td>
									<?php
								}
								?>
								<td style="width: 30px;">
									<input class="repair-free" type="checkbox" name="rfree[]" required>
								</td>
								<td style="width: 160px;" class="additional-actions">
									<button type="button" data-rid="NEW" class="trash delete_repair" tabindex="-1">
										<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/garbage.svg">
									</button>
									<button data-rid="NEW" type="button" tabindex="-1" class="add-more add-first-repair-attr"><i class="fas fa-plus"></i></button>
									<label tabindex="-1" class="label-upload-image" for="upload_rimage_{uqid}">
										<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/image.svg">
									</label> 
									<input tabindex="-1" type="file" id="upload_rimage_{uqid}" style="display: none;" name="r_img_X" data-uimage-id="NEW">
								</td>
							</tr>
						</tbody>
					</table>
				</td>
			</tr>
		`;

	jQuery(document).on("wpRepairReady", function(){

		jQuery(document).on('click', '.delete_model_related_repairs', function(){
			if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete all repairs related to this model?')) {
				if(jQuery(this).hasClass("processing")) {
					return;
				}
				jQuery(this).addClass("processing");
				var btn = this;
				var btndata = jQuery(btn).html();
				jQuery(btn).html('<i style="font-size: 12px; position: relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

				var mrid = jQuery(this).data("mid");
				//console.log(rid)
				repairPluginUI.ajax({
					type:'POST',
					url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {action:'delete_model_related_repairs',mrid:mrid},
					success: function(data) {
						jQuery(btn).html(btndata);
						let parentEl = repairPluginUI.find_parent_by_class(btn, 'manageRepairsParent');
						jQuery(parentEl).find('.Orderingrepairs').each(function(){
							repairPluginUI.removeTableRow(this);
						});

						window.setTimeout(function(){
							updateUnsavedManageModelButton();
						},600);

						repairPluginUI.alert_success('All repairs related to selected model successfully deleted.');
						jQuery(btn).removeClass("processing");
					},
					error: function(response) {
						jQuery(btn).html(btndata);
						jQuery(btn).removeClass("processing");
						if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
					}
				});
			}
		});

		jQuery(document).on('click', '.delete_repair', function(){
			if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete this repair?')) {

				var rid = jQuery(this).data("rid");

				if(rid === 'NEW') {

					let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
					repairPluginUI.removeTableRow(parentEl, function(){
						updateUnsavedManageModelButton();
					});

					return;
				}

				if(jQuery(this).hasClass("processing")) {
					return;
				}
				let btn = this;

				var btndata = jQuery(btn).html();
				jQuery(btn).html('<i style="font-size: 20px; position: relative; top: 1px;" class="fas fa-spinner fa-spin"></i>');

				jQuery(btn).addClass("processing");
				//console.log(rid)
				repairPluginUI.ajax({
					type:'POST',
					url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {action:'delete_repair',rid:rid},
					success: function(data) {

						jQuery(btn).html(btndata);
						let parentEl = repairPluginUI.find_parent_by_class(btn, 'Orderingrepairs');
						repairPluginUI.removeTableRow(parentEl, function(){
							updateUnsavedManageModelButton();
						});

						repairPluginUI.alert_success('Selected repair successfully deleted.');
						jQuery(btn).removeClass("processing");

					},
					error: function(response) {
						jQuery(btn).html(btndata);
						jQuery(btn).removeClass("processing");
						if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
					}
				});
			}
		});

		jQuery(document).on('click', '.update_repair', function() {
			if(jQuery(this).hasClass("processing")) {
				return;
			}
			jQuery(this).addClass("processing");
			var btn = this;
			var btndata = jQuery(btn).html();
			jQuery(btn).html('<i style="font-size: 13px; position: relative; top: -1px;" class="fas fa-spinner fa-spin"></i>');

			var set_decimal = '<?php echo $decimal; ?>';

			let parentEl = repairPluginUI.find_parent_by_class(this, 'details-container');

			let main_sorting_has_changed = jQuery(parentEl).find('.main-repair .repair-list-sort.unsaved').length > 0;

			var mid    = jQuery(this).data("mid");
			var rid = [];
			var raid = [];
			var raname = [];
			var radesc = [];
			var rabadge = [];
			var raduration = [];
			var radurationmeasure = [];
			var raprice = [];
			var ramargin = [];
			var sub_sorting_reset = [];
			let raactive = [];

			jQuery(parentEl).find('input[name^="rid["]').each(function(){
				rid.push(jQuery(this).val());

				let orderingrepairsContainer = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
				var a_id = [];
				jQuery(orderingrepairsContainer).find('input[name^="raid["]').each(function(){
					a_id.push(jQuery(this).val());
				});
				raid.push(a_id);

				var a_name = [];
				jQuery(orderingrepairsContainer).find('input[name^="raname["]').each(function(){
					a_name.push(jQuery(this).val());
				});
				raname.push(a_name);

				var a_desc = [];
				jQuery(orderingrepairsContainer).find('input[name^="radesc["]').each(function(){
					a_desc.push(jQuery(this).val());
				});
				radesc.push(a_desc);

				var a_badge = [];
				jQuery(orderingrepairsContainer).find('input[name^="rabadge["]').each(function(){
					a_badge.push(jQuery(this).val());
				});
				rabadge.push(a_badge);

				var a_duration = [];
				jQuery(orderingrepairsContainer).find('input[name^="aduration["]').each(function(){
					a_duration.push(jQuery(this).val());
				});
				raduration.push(a_duration);

				var a_duration_measure = [];
				jQuery(orderingrepairsContainer).find('select[name^="adurationmeasure["]').each(function(){
					a_duration_measure.push(jQuery(this).val());
				});
				radurationmeasure.push(a_duration_measure);

				var a_price = [];
				jQuery(orderingrepairsContainer).find('input[name^="raprice["]').each(function(){
					var element = jQuery(this).val().replace(/,/g, '.');
					a_price.push(element);
				});
				raprice.push(a_price);

				var ra_margin = [];
				jQuery(orderingrepairsContainer).find('input[name^="ramargin["]').each(function(){
					var element = jQuery(this).val().replace(/,/g, '.');
					ra_margin.push(element);
				});
				ramargin.push(ra_margin);

				var a_is_active = [];
				jQuery(orderingrepairsContainer).find('input[name^="is_active_attr["]').each(function(){
					if(jQuery(this).is(':checked')) {
						a_is_active.push(jQuery(this).val());
					} else {
						a_is_active.push(null);
					}
				});
				raactive.push(a_is_active);

				let sub_sorting_has_changed = jQuery(orderingrepairsContainer).find('.sub-repairs-details .repair-list-sort.unsaved').length > 0;

				sub_sorting_reset.push(sub_sorting_has_changed);
			});
			var img_link = [];
			jQuery(parentEl).find('input[name^="r_img_link"]').each(function(){
				img_link.push(jQuery(this).val());
			});
			var title = [];
			jQuery(parentEl).find('input[name^="rname["]').each(function(){
				title.push(jQuery(this).val());
			});
			var mins = [];
			jQuery(parentEl).find('input[name^="rduration["]').each(function(){
				mins.push(jQuery(this).val());
			});
			var duration_measure = [];
			jQuery(parentEl).find('select[name^="rdurationmeasure["]').each(function(){
				duration_measure.push(jQuery(this).val());
			});
			var info = [];
			jQuery(parentEl).find('input[name^="rdiscription["]').each(function(){
				info.push(jQuery(this).val());
			});
			var badge = [];
			jQuery(parentEl).find('input[name^="rbadge["]').each(function(){
				badge.push(jQuery(this).val());
			});
			var rprice = [];
			jQuery(parentEl).find('input[name^="rprice["]').each(function(){
				rprice.push(jQuery(this).val());
			});
			var rmargin = [];
			if(jQuery(parentEl).find('input[name^="rmargin["]').length > 0) {
				jQuery(parentEl).find('input[name^="rmargin["]').each(function(){
					rmargin.push(jQuery(this).val());
				});
			}
			var rfree = [];
			jQuery(parentEl).find('input[name^="rfree["]').each(function(){
				if(jQuery(this).is(':checked')) {
					rfree.push(1);
				} else {
					rfree.push(0);
				}
			});
			var status = [];
			jQuery(parentEl).find('input[name^="is_active["]').each(function(){
				if(jQuery(this).is(':checked')) {
					status.push(jQuery(this).val());
				} else {
					status.push(null);
				}
			});
			var default_listing_range = jQuery(parentEl).find('input[name="default_listing_range"]').val();
			var data_to_pass = {action:'update_repair',mid:mid,rid:rid,img_link:img_link,title:title,mins:mins,duration_measure:duration_measure,info:info,rprice:rprice,rfree:rfree,status:status,raid:raid,raname:raname, radesc:radesc,raprice:raprice,main_sorting_has_changed:main_sorting_has_changed,sub_sorting_reset:sub_sorting_reset,raactive:raactive,default_listing_range:default_listing_range,badge:badge,rabadge:rabadge,raduration:raduration,radurationmeasure:radurationmeasure};
			if(jQuery(parentEl).find('input[name^="rmargin["]').length > 0) {
				data_to_pass.rmargin = rmargin;
			}
			if(jQuery(parentEl).find('input[name^="ramargin["]').length > 0) {
				data_to_pass.ramargin = ramargin;
			}
    		repairPluginUI.ajax({
    			type:'POST',
    			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
    			data: data_to_pass,
    			success: function(data) {
    						try {
    							data = JSON.parse(data);
    						} catch (e) {

    						}
    						if(data && data.table_rows && data.table_rows.length > 0) {

    							let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
    							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
    							updateUnsavedManageModelButton();
    							data.table_rows.forEach(function(val, i){
									if( val.listing_range !== null && val.listing_range !== undefined ){
										let row = '<tr class="justForsort Orderingrepairs draggable ui-state-default""><td colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>"><hr><div class="button">Hide under show all .. repairs button ↓</div><input type="hidden" name="default_listing_range" id="default_listing_range" value="'+ val.listing_range +'"></td></tr>';
										jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(row);	
										return;
									}

										if( val.repair_margin === undefined || val.repair_margin === null ) {
											val.repair_margin = null;
										}
    								let getTr = add_model_repair_tr(val.m_id, val.r_id, val.r_img, val.repair_title, val.repair_min, val.repair_info, val.repair_price, val.is_active, val.is_free, val.r_duration_measure, val.r_uq_id, val.is_fully_unchanged, val.repair_margin, val.repair_badge);

    								jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').append(getTr);
    								let OrderingrepairsCont = jQuery(repairsContainer).find('.Orderingrepairs.adding-model-repair-tr');
    								OrderingrepairsCont.removeClass('adding-model-repair-tr');
    								if(val.attrs != undefined && val.attrs.length > 0) {

    									jQuery(OrderingrepairsCont).find('.add-more.add-first-repair-attr').removeClass('add-more add-first-repair-attr').addClass('dropdown').html('<i class="fas fa-caret-down"></i>');

    									jQuery(OrderingrepairsCont).find('input[name^="rprice"]').attr('readonly', 'readonly');

										jQuery(OrderingrepairsCont).find('input[name^="rmargin"]').attr('readonly', 'readonly');

    									let sub_repair_tr = `
    										<tr class="sub-repairs-details">
    											<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
    												<div class="special-table">
    													<table class="table repairsAttrContainer ui-sortable">
    														<thead>
    															<tr>
    																<th style="width: 85px;">
    																</th>
    																<th style="width: 175px;">
    																</th>
    																<th style="width: 55px;">
    																</th>
    																<th style="width: 225px;">
    																</th>
    																<th style="width: 75px">
    																</th>
    																<th style="width: 30px">
    																</th>
    																<th style="width: 220px;"></th>
    															</tr>
    														</thead>
    														<tbody class="append_attr_data">

    														</tbody>
    													</table>
    												</div>
    											</td>
    										</tr>
    									`;
    									jQuery(OrderingrepairsCont).find('tr.main-repair').after(sub_repair_tr);
    									jQuery(OrderingrepairsCont).find(".repairsAttrContainer").each(function(){
    										jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
												update_default_listing_range_position(e,ui);
											}, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
    									});

    									val.attrs.forEach(function(newVal){
												if( newVal.a_margin === undefined || newVal.a_margin === null ) {
													newVal.a_margin = null;
												}
    										let repairAttrTR = add_model_repair_attr_tr(val.r_id, val.m_id, newVal.a_id, newVal.a_name, newVal.a_desc, newVal.a_price, newVal.a_uq_id, newVal.is_active, newVal.a_margin, newVal.a_badge, newVal.attr_min, newVal.a_duration_measure);
    										jQuery(OrderingrepairsCont).find('.repairsAttrContainer tbody.append_attr_data').append(repairAttrTR);
    									});
    								}
    							});

    						} else {
    							let repairsContainer = repairPluginUI.find_parent_by_class(btn, 'details-container');
    							jQuery(repairsContainer).find('.repairsContainer tbody.the-additional-repair').html('');
    							updateUnsavedManageModelButton();
    						}

							window.rp_default_repair_classes();


          			jQuery(btn).html(btndata);
          			repairPluginUI.alert_success('All repairs for selected model successfully updated.');
          			jQuery(btn).removeClass("processing");
          		},
          		error: function(response) {
          			jQuery(btn).html(btndata);
          			jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
          		}
          	});
    	});

			jQuery(document).on('click', '.ra_delete',function(){
				if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete this repair attribute?')) {
					
					var aid = jQuery(this).data("aid");

					let parentEl = repairPluginUI.find_parent_by_class(this, 'OrderingrepairsAttr');
					let parentRepairsAttrContainer = repairPluginUI.find_parent_by_class(parentEl, 'repairsAttrContainer');
					let parentOrderRepairs = repairPluginUI.find_parent_by_class(parentRepairsAttrContainer, 'Orderingrepairs');

					if(aid === 'NEW') {

						repairPluginUI.removeTableRow(parentEl, function(){
							updateUnsavedManageModelButton();
						});

						window.setTimeout(function(){
							if(jQuery(parentRepairsAttrContainer).find('.OrderingrepairsAttr').length === 0) {

								jQuery(parentOrderRepairs).find('button.dropdown.active').click();
								jQuery(parentOrderRepairs).find('button.dropdown').removeClass('dropdown active').addClass('add-more add-first-repair-attr').html('<i class="fas fa-plus"></i>');
								jQuery(parentOrderRepairs).find('.sub-repairs-details').remove();
								jQuery(parentOrderRepairs).find('input[name^="rprice"]').removeAttr('readonly');
								jQuery(parentOrderRepairs).find('input[name^="rmargin"]').removeAttr('readonly');
							}
						},700);

						return;
					}

					if(jQuery(this).hasClass("processing")) {
						return;
					}
					let btn = this;

					var btndata = jQuery(btn).html();
					jQuery(btn).html('<i style="font-size: 18px; position: relative; top: 0px;" class="fas fa-spinner fa-spin"></i>');

					jQuery(btn).addClass("processing");
					//console.log(aid)
					repairPluginUI.ajax({
						type:'POST',
						url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
						data: {action:'delete_r_attr',aid:aid},
						success: function(data) {
							jQuery(btn).html(btndata);
							repairPluginUI.removeTableRow(parentEl, function(){
								updateUnsavedManageModelButton();
							});

							window.setTimeout(function(){
								if(jQuery(parentRepairsAttrContainer).find('.OrderingrepairsAttr').length === 0) {

									jQuery(parentOrderRepairs).find('button.dropdown.active').click();
									jQuery(parentOrderRepairs).find('button.dropdown').removeClass('dropdown active').addClass('add-more add-first-repair-attr').html('<i class="fas fa-plus"></i>');
									jQuery(parentOrderRepairs).find('.sub-repairs-details').remove();
									jQuery(parentOrderRepairs).find('input[name^="rprice"]').removeAttr('readonly');
									jQuery(parentOrderRepairs).find('input[name^="rmargin"]').removeAttr('readonly');
								}
							},700);

							repairPluginUI.alert_success('Selected repair attribute successfully deleted.');
							jQuery(btn).removeClass("processing");
						},
						error: function(response) {
							jQuery(btn).html(btndata);
							jQuery(btn).removeClass("processing");
							if( response && response.rp_validation_error != '' ) {

							} else {
								repairPluginUI.alert_danger('Something went wrong, please try again later.');
							}
						}
					});
				}
			});
		});

			function readURLManageRepair(input){
				if(input.files && input.files[0]){
					//console.log(input.files[0]);
					var reader = new FileReader();
					//console.log(reader);
					reader.onload = function (e){
					//console.log(img);
					jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'" height="100">');
				}
				reader.readAsDataURL(input.files[0]);
			}
		}

			function readURLManageRepairZD(input){
				if(input.files && input.files[0]){
					//console.log(input.files[0]);
					var reader = new FileReader();
					//console.log(reader);
					reader.onload = function (e){
					//console.log(img);
					jQuery(input).parent().parent().parent().find(".img-repair-show img").attr('src', e.target.result);

					jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(2.5)', 'z-index': '1000'});

					window.setTimeout(function(){
						jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(1)'});
						window.setTimeout(function(){
							jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(2.5)', 'z-index': '1000'});
							window.setTimeout(function(){
								jQuery(input).parent().parent().parent().find(".img-repair-show").css({'transform': 'scale(1)', 'z-index': '1'});
							},300);
						},300);
					},300);
				}
				reader.readAsDataURL(input.files[0]);
			}
		}

			jQuery(document).on("change", "input[name='r_img_X']", function(){
				if(jQuery(this).hasClass("processing")) {
					return;
				}
				let btn = this;

				jQuery(btn).addClass("processing");

				let currentInput = this;

				var rid = jQuery(currentInput).data('uimage-id');
				var file_data = jQuery(currentInput).prop('files');
				if(file_data.length > 0) {
					file_data = file_data[0];
				} else {
					file_data = null;
				}
		    var form_data = new FormData();
		    if(file_data) {
		    	form_data.append('file', file_data);
		    }

		    form_data.append('action', 'update_repair_img');
		 		form_data.append('rid', rid);

		 		if(file_data) {
					repairPluginUI.ajax({
		          type:'POST',
		          url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		          dataType: 'text', // what to expect back from the server
		          cache: false,
		          contentType: false,
		          processData: false,
		          data: form_data,
		          success: function (response) {
		          		readURLManageRepairZD(jQuery(currentInput)[0]);

		          		if(rid !== 'NEW') {
		          			repairPluginUI.alert_success('Repair image successfully updated.');
		          		}
		          		jQuery(btn).removeClass("processing");

		          		try {
		          			response = JSON.parse(response);
		          		} catch (e) {

		          		}
		          		if(response && response.logo) {
		          			let mainRepairTr = repairPluginUI.find_parent_by_class(btn, 'main-repair');
		          			jQuery(mainRepairTr).find('input[name^="r_img_link"]').val(response.logo).change();
		          		}
		          },
		          error: function(response) {
		          		jQuery(btn).removeClass("processing");
					  	if( response && response.rp_validation_error != '' ) {

						} else {
							repairPluginUI.alert_danger('Something went wrong, please try again later.');
						}
		          }
		      });
		 		}
			});

			jQuery(document).on("click", ".add-first-repair-attr", function(){

				var np = jQuery(this).parents('.details-container')[0];
				np.style.maxHeight = (np.clientHeight + 300) + "px";

				let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
				jQuery(this).removeClass('add-more add-first-repair-attr');
				jQuery(this).addClass('dropdown').html('<i class="fas fa-caret-down"></i>');
				jQuery(parentEl).find('input[name^="rprice"]').attr('readonly', 'readonly');
				jQuery(parentEl).find('input[name^="rmargin"]').attr('readonly', 'readonly');
				let btn = this;
				let sub_repair_tr = `
					<tr class="sub-repairs-details uibyzahran-remove-tr uibyzahran-transition">
						<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
							<div class="special-table">
								<table class="table repairsAttrContainer ui-sortable">
									<thead>
										<tr>
											<th style="width: 85px;">
											</th>
											<th style="width: 175px;">
											</th>
											<th style="width: 55px;">
											</th>
											<th style="width: 225px;">
											</th>
											<th style="width: 75px">
											</th>
											<th style="width: 30px">
											</th>
											<th style="width: 220px;"></th>
										</tr>
									</thead>
									<tbody class="append_attr_data">

									</tbody>
								</table>
							</div>
						</td>
					</tr>
				`;
				jQuery(parentEl).find('tr.main-repair').after(sub_repair_tr);

				jQuery(parentEl).find(".repairsAttrContainer").each(function(){
					jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
						update_default_listing_range_position(e,ui);
					}, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
				});

				jQuery(parentEl).find('.repairsAttrContainer tbody.append_attr_data').append(window.model_repair_attr_tr);
				jQuery(btn).click();
				updateUnsavedManageModelButton();
				window.setTimeout(function(){
					let firstInput = jQuery('.sub-repairs-details.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".sub-repairs-details.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
					window.setTimeout(function(){
						jQuery(".sub-repairs-details.uibyzahran-transition").removeClass('uibyzahran-transition');

						window.setTimeout(function(){
							let firstInput = jQuery('.OrderingrepairsAttr.uibyzahran-remove-tr input[type="text"]')[0];
							jQuery(firstInput).focus();
							jQuery(".OrderingrepairsAttr.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
							window.setTimeout(function(){
								jQuery(".OrderingrepairsAttr.uibyzahran-transition").removeClass('uibyzahran-transition');
							},500);
						},1);

					},1);
				},1);
			});

			jQuery(document).on("click", ".add-repair-btn.AddRepair", function(){

				var np = jQuery(this).parents('.details-container')[0];
				np.style.maxHeight = (np.clientHeight + 300) + "px";

				let parentEl = repairPluginUI.find_parent_by_class(this, 'details-container');
				jQuery(parentEl).find('.repairsContainer tbody.the-additional-repair').append(window.model_repair_tr.replace(/\{uqid\}/gi, uniqid()));

				let panel = jQuery(this).parents('.details-container')[0];

				panel.style.maxHeight = (panel.scrollHeight + 300) + "px";

				updateUnsavedManageModelButton();

				window.setTimeout(function(){
					let firstInput = jQuery('.Orderingrepairs.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".Orderingrepairs.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');
					window.setTimeout(function(){
						jQuery(".Orderingrepairs.uibyzahran-transition").removeClass('uibyzahran-transition');
					},500);
				},1);
			});

			jQuery(document).on('change keyup', '.additional-repair-tr input[name^="raprice"], .additional-repair-tr input[name^="ramargin"]', function(e){
				let parentEl = jQuery(this).parents('.Orderingrepairs');
				
				if(!jQuery(parentEl).find('input[name^="rfree"]').is(':checked')) {

					let allPrices = [];

					let allMargins = [];

					jQuery(parentEl).find('input[name^="raprice"]').each(function(){
						
						allPrices.push( jQuery(this).val() );

					});

					jQuery(parentEl).find('input[name^="ramargin"]').each(function(){
						
						allMargins.push( jQuery(this).val() );

					});

					let min_price = false;
					let min_margin = false;

					allPrices.forEach(function(val, i){

						if(val !== '') {

							val = parseFloat( val );

							if( min_price === false ) {
								
								min_price = val;
								min_margin = allMargins[i] ? parseFloat( allMargins[i] ) : 0;

							} else if( min_price > val ) {

								min_price = val;
								min_margin = allMargins[i] ? parseFloat( allMargins[i] ) : 0;

							} else {

								// do nothing

							}

						}

					});

					if( min_price === false ) {

						min_price = 0;

					}

					if( min_margin === false ) {

						min_margin = 0;

					}

					jQuery(parentEl).find('input[name^="rprice"]').val(min_price);
					jQuery(parentEl).find('input[name^="rmargin"]').val(min_margin);

				}

			});

			let theTimeout = null;
			jQuery(document).on("click", ".repair-more-options .add-more", function(){

				var np = jQuery(this).parents('.details-container')[0];
				np.style.maxHeight = (np.clientHeight + 300) + "px";

				let parentEl = repairPluginUI.find_parent_by_class(this, 'Orderingrepairs');
				jQuery(parentEl).find('.repairsAttrContainer tbody.append_attr_data').append(window.model_repair_attr_tr);
				updateUnsavedManageModelButton();
				window.setTimeout(function(){
					let firstInput = jQuery('.OrderingrepairsAttr.uibyzahran-remove-tr input[type="text"]')[0];
					jQuery(firstInput).focus();
					jQuery(".OrderingrepairsAttr.uibyzahran-remove-tr").removeClass('uibyzahran-remove-tr');

					if(theTimeout !== null) {
						window.clearTimeout(theTimeout);
					}
					theTimeout = window.setTimeout(function(){
						jQuery(".OrderingrepairsAttr.uibyzahran-transition").removeClass('uibyzahran-transition');
					},500);

				},1);
			});

			jQuery(".repairsContainer").each(function(){
				jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
					update_default_listing_range_position(e,ui);
				}, items: ".Orderingrepairs", distance: 5, handle: ".main-repair .repair-list-sort" });
			});
			jQuery(document).on('click', '.Orderingrepairs .main-repair .repair-list-sort .fas', function() { 
			    var btn = jQuery(this);
			    var val = btn.data('which');
			    if (val == 'up')
			        moveUp(btn.parents('.Orderingrepairs'));
			    else
			        moveDown(btn.parents('.Orderingrepairs'));

			    jQuery(btn).parents('.repairsContainer').find('.main-repair .repair-list-sort').addClass('unsaved');
			    updateUnsavedManageModelButton();
			});
			jQuery(".repairsAttrContainer").each(function(){
				jQuery(this).sortable({ change: function(e,ui){ sortingHasUpdated(e,ui); }, stop:function(e,ui){
					update_default_listing_range_position(e,ui);
				}, items: ".OrderingrepairsAttr", distance: 5, handle: ".repair-list-sort" });
			});
			jQuery(document).on('click', '.OrderingrepairsAttr .repair-list-sort .fas', function() { 
			    var btn = jQuery(this);
			    var val = btn.data('which');
			    if (val == 'up')
			        moveUp(btn.parents('.OrderingrepairsAttr'));
			    else
			        moveDown(btn.parents('.OrderingrepairsAttr'));

			    jQuery(btn).parents('.repairsAttrContainer').find('tr.OrderingrepairsAttr .repair-list-sort').addClass('unsaved');
			    updateUnsavedManageModelButton();
			});
	</script>
	<?php
}

function rp_manage_repairs_unused_markup() {

	?>
	<form method="post" action="" enctype="multipart/form-data">
		<?php
		rp_csrf_token_input_field('manage_models');
		?>
		<div class="repair-modal">
			<div class="repair-modal-content">
				<div class="modal-header">
					<span class="repair-close-button">&times;</span>
				</div>	
				<div class="modal-body">
					<input class="m_id" type="hidden" name="m_id" value="">	
					<div class="wp-repair-input-group">
						<label>Name</label>
						<input type="text" id="r_name" name="r_name" class="user-info" required>
					</div>
					<div class="wp-repair-input-group">
						<label>Price</label>
						<input type="text" id="r_price" name="r_price" class="user-info" required>
					</div>
					<div class="wp-repair-input-group">
						<label>Duration (In Minutes)</label>
						<input type="text" id="r_duration" name="r_duration" class="user-info" required>
					</div>
					<div class="wp-repair-input-group">
						<label>Discription</label>
						<textarea class="user-info" row="3" name="r_discription" required></textarea>
					</div>
					<p class="fs-9 img">Choose Image</p>
					<div class="upload_btn">
						<label for="upload_image" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
						<input type="file" onchange="readURLManageRepair(this)" id="upload_image" style="display: none;" name="r_img">
						<div class="uploaded_img"></div>					
					</div>
				</div>
				<div class="modal-footer">
					<button type="submit" class="btn add_repair" name="add_repair">Add Repair</button>
				</div>
			</div>
		</div>
	</form>
	<form method="post" action="">
		<?php
		rp_csrf_token_input_field('manage_models');
		?>
		<div class="ra-modal">
			<div class="ra-content">
				<div class="modal-header">
					<span class="ra-close-button">&times;</span>
				</div>	
				<div class="modal-body">
					<input class="r_id_fk" type="hidden" name="r_id_fk" value="">	
					<div class="wp-repair-input-group">
						<label>Name</label>
						<input type="text" id="ra_name" name="ra_name" class="user-info" required>
					</div>
					<div class="wp-repair-input-group">
						<label>Price</label>
						<input type="text" id="ra_price" name="ra_price" class="user-info" required>
					</div>
				</div>
				<div class="modal-footer">
					<button type="submit" class="btn add_r_attr" name="add_r_attr">Add Details</button>
				</div>
			</div>
		</div>
	</form>
	<?php

}

function rp_manage_repairs_standalone_markup( $m_id = '', $repairs = array(), $print = null, $decimal = '', $device_type = '' ) {

	global $rpQuery;

	global $added_margin_column;

	$r_attr_table = $rpQuery->prefix . "rs_repair_attr";

	$default_listing_range = rp_get_option( 'rp_default_listing_index_model_'. $m_id, FALSE );
	if( $default_listing_range === FALSE ){
		$default_listing_range = rp_get_option( 'rp_default_listing_index_'. $device_type, 6 );
	}
	$default_listing_range = (int) $default_listing_range;

	$default_listing_range = rp_round_to_even_number( $default_listing_range );

	?>
	<tr class="more-details repairs-details more_details<?php echo $m_id; ?>">
		<td colspan="7">
			<div class="details-container" id="details-container<?php echo $m_id; ?>">
				<div class="wp-repair-inner-col section-1">
					<table class="table repairsContainer">
						<thead>
							<tr>
								<th style="width: 120px;">
									<p>On/Off</p>
								</th>
								<th style="width: 175px;">
									<p>Title</p>
								</th>
								<th style="width: 147px;">
									<p>Duration</p>
								</th>
								<th style="width: 225px;">
									<p>Info</p>
								</th>
								<th style="width: 200px;">
									<p>Badge</p>
								</th>
								<?php
								$price_markup = '<th style="width: 75px"><p>Price</p></th>';
								$filtered_price_th = apply_filters('rp_individual_repair_price_th', $price_markup);
								echo $filtered_price_th;
								?>
								<th style="width: 45px">
									<p>Free</p>
								</th>
								<th style="width: 160px;">
									<p></p>
								</th>
							</tr>
						</thead>
						<tbody class="the-additional-repair the-additional-repair<?php echo $m_id; ?>" style="border:none !important">
							<?php $x=0; 
							$last_index = count($repairs) - 1;
							$this_model_default_listing_range = $default_listing_range;
							if($this_model_default_listing_range > ($last_index + 1)){
								$this_model_default_listing_range = $last_index + 1;
							}
							if( $this_model_default_listing_range == 0 && $last_index !== -1 ) {
								rp_render_sort_button($this_model_default_listing_range, $added_margin_column);
							}
							foreach ($repairs as $r){
								$r_id = $r->r_id;
								$r_attr = $rpQuery->get_results("SELECT * FROM $r_attr_table WHERE r_id_fk = '".rp_escape_sql($r_id)."' ORDER BY ra_position ASC");
								$r_attr = rp_fix_default_repair_attr_sorting($r_attr, $m_id);
								$r_attr = rp_sanitize_output($r_attr);
								?>
								<tr class="justForsort Orderingrepairs ui-state-default ui-state-not-allowed">
									<td class="justForsort" colspan="<?php if( $added_margin_column === TRUE ){ echo '9'; } else { echo '8'; } ?>">
										<table class="justForsort">
											<tbody class="justForsort">
												<tr class="main-repair">
													<td style="width: 120px;">
														<label class="switch">
															<input type="checkbox" <?php if($r->is_active == '1'){echo 'checked';}?> tabindex="-1" name="is_active[]" id="is_active<?php echo $m_id; ?>" value="<?php echo $r->r_id?>">
															<span class="slider round"></span>
														</label>
														<?php
														wp_repair_list_sorting_button();
														?>
														<input type="hidden" name="rid[]" id="repair-id<?php echo $m_id?>" value="<?php echo $r->r_id?>">
														<input type="hidden" name="r_img_link" value="<?php echo $r->r_img; ?>">
														<div class="img-repair-show">
															<img src="<?php echo $r->r_img; ?>">
														</div>
													</td>
													<td style="width: 175px;">
														<input tabindex="-1" class="repair-title rptranslatable" placeholder="Repair Title" id="repair-title<?php echo $m_id?>" type="text" name="rname[]" value="<?php 
														$static_repair_name = rp_get_static_translations_of_repair('repair_name', $r->r_uq_id, $m_id);
														echo rp_sanitize_output($static_repair_name); ?>" required>
														<div data-trans-selector="input.repair-title.rptranslatable" data-trans-key="repair_name" data-trans-uqid="<?php echo $r->r_uq_id; ?>" data-trans-midfk="<?php echo $m_id; ?>" class="globe-icon-translation clearfix">
															<div class="globe-icon-i">
																<i class="fas fa-globe"></i>
															</div>
														</div>
													</td>
													<td style="width: 55px;"><input tabindex="-1" class="repair-mins" placeholder="30" id="repair-mins<?php echo $m_id?>" type="text" name="rduration[]" value="<?php echo $r->r_duration?>" required></td>

													<td style="width: 74px;">
														<select tabindex="-1" class="repair-duration-measure" id="repair-duration-measure<?php echo $m_id?>" name="rdurationmeasure[]" required>
															<?php rp_duration_measure_options_markup( $r->r_duration_measure ); ?>
														</select>
													</td>

													<td style="width: 225px;">
														<input tabindex="-1" class="repair-info rptranslatable" placeholder="More Information" id="repair-info<?php echo $m_id?>" type="text" name="rdiscription[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_repair('repair_desc', $r->r_uq_id, $m_id)); ?>" required>
														<div data-trans-selector="input.repair-info.rptranslatable" data-trans-key="repair_desc" data-trans-uqid="<?php echo $r->r_uq_id; ?>" data-trans-midfk="<?php echo $m_id; ?>" class="globe-icon-translation clearfix">
															<div class="globe-icon-i">
																<i class="fas fa-globe"></i>
															</div>
														</div>
													</td>

													<td style="width: 175px;">
														<input tabindex="-1" class="repair-badge rptranslatable" placeholder="Badge Text" id="repair-badge<?php echo $m_id?>" type="text" name="rbadge[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_repair('repair_badge', $r->r_uq_id, $m_id)); ?>" required>
														<div data-trans-selector="input.repair-badge.rptranslatable" data-trans-key="repair_badge" data-trans-uqid="<?php echo $r->r_uq_id; ?>" data-trans-midfk="<?php echo $m_id; ?>" class="globe-icon-translation clearfix">
															<div class="globe-icon-i">
																<i class="fas fa-globe"></i>
															</div>
														</div>
													</td>
													<?php 
													if(!empty($r_attr)) {

														$r->r_price = rp_get_lowest_repair_attribute_price($r->r_id);

													}
													if($decimal == 'comma'){
														$amount = str_replace('.',',',$r->r_price);
													}else{
														$amount = $r->r_price;					
													}
													$passData = array(
														'r' => $r,
														'r_attr' => $r_attr,
														'decimal' => $decimal,
														'm_id' => $m_id
													);
													$readonly = '';
													if($r->is_free === '1' || !empty($r_attr)) {
														$readonly = 'readonly="readonly"';
													}
													$to_be_filtered_td = '<td style="width: 75px"><input '.$readonly.' class="repair-price" id="repair-price'.$m_id.'" type="text"  placeholder="99,99" name="rprice[]" value="'.$amount.'" required></td>';
													$filtered_td = apply_filters('rp_individual_repair_price_td', $to_be_filtered_td, $passData);
													echo $filtered_td;
													?>
													<td style="width: 30px;">
														<input class="repair-free" id="repair-free<?php echo $m_id?>" type="checkbox" name="rfree[]" <?php if($r->is_free === '1') { echo 'checked="checked"'; } ?> required>
													</td>
													<td style="width: 160px;" class="additional-actions">
														<button type="button" data-rid="<?php echo $r_id?>" class="trash delete_repair" tabindex="-1">
															<img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/garbage.svg'; ?>">
														</button>
														<?php
														if($r_attr){?>
															<button tabindex="-1" type="button" class="dropdown" data-uid="<?php echo $r_id; ?>">
																<i class="fas fa-caret-down"></i>
															</button>
														<?php }else{?>
															<button data-rid="<?php echo $r_id;?>" type="button" tabindex="-1" class="add-more add-first-repair-attr"><i class="fas fa-plus"></i></button>
														<?php }?>
														<label tabindex="-1" class="label-upload-image" for="upload_rimage_<?php echo $r_id; ?>"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/image.svg'; ?>"></label>
														<input tabindex="-1" type="file" id="upload_rimage_<?php echo $r_id; ?>" style="display: none;" name="r_img_X" data-uimage-id="<?php echo $r_id; ?>">
														<?php
														if( in_array($r->r_uq_id, rp_get_all_dr_uq_id_from_rs_default_repair_table()) ) {
															?>
															<button data-rname="<?php echo $static_repair_name; ?>" data-drid="<?php echo $r_id; ?>" type="button" class="reset-default-repair <?php if( rp_is_fully_unchanged_default_repair_individually($r_id, $m_id) ) {
																echo 'grayed-out';
															} else {
																echo 'active';
															} ?>" style="margin-left: 5px; font-size: 16px;">
																<i class="fas fa-redo"></i>
															</button>
															<?php
														}
														?>
													</td>
												</tr>
												<?php
												if($r_attr){?>
													<tr class="sub-repairs-details">
														<td colspan="<?php if( $added_margin_column === TRUE ){ echo '10'; } else { echo '9'; } ?>" class="wp-repair-no-padding">
															<div class="special-table">
																<table class="table repairsAttrContainer">
																	<thead>
																		<tr>
																			<th style="width: 85px;">
																			</th>
																			<th style="width: 175px;">
																			</th>
																			<th style="width: 55px;">
																			</th>
																			<th style="width: 225px;">
																			</th>
																			<th style="width: 75px">
																			</th>
																			<th style="width: 30px">
																			</th>
																			<th style="width: 220px;"></th>
																		</tr>
																	</thead>
																	<tbody class="append_attr_data append_attr_data<?php echo $r_id; ?>">
																		<?php if($r_attr){ foreach($r_attr as $ra){?>
																			<tr class="additional-repair-tr OrderingrepairsAttr" data-uid="<?php echo $r_id; ?>">
																				<td style="width:940px;" colspan="<?php if( $added_margin_column === TRUE ) { echo '4'; } else { echo '5'; } ?>">
																					<div class="repair-more-options">
																						<label class="switch">
																							<input type="checkbox" <?php if($ra->is_active == '1'){echo 'checked';}?> tabindex="-1" name="is_active_attr[]" value="<?php echo $ra->a_id?>">
																							<span class="slider round"></span>
																						</label>
																						<button data-rid="<?php echo $r_id;?>" tabindex="-1" type="button" class="add-more"><i class="fas fa-plus"></i></button>
																						<?php
																						wp_repair_list_sorting_button();
																						?>
																						<input type="hidden" id="raid<?php echo $m_id;?>" name="raid[]" value="<?php echo $ra->a_id;?>">
																						<div class="globe-icon-attr">
																							<input class="repair-additional-name rptranslatable" id="raname<?php echo $m_id; ?>" type="text" placeholder="Original" name="raname[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_attr('attr_name', $ra->a_uq_id, $ra->r_id_fk));?>" required>
																							<div data-trans-selector="input.repair-additional-name.rptranslatable" data-trans-key="attr_name" data-trans-uqid="<?php echo $ra->a_uq_id; ?>" data-trans-ridfk="<?php echo $ra->r_id_fk; ?>" class="globe-icon-translation clearfix">
																								<div class="globe-icon-i">
																									<i class="fas fa-globe"></i>
																								</div>
																							</div>
																						</div>
																						<div style="width: 55px;" class="ra-duration-fields w55"><input tabindex="-1" class="attr-mins" placeholder="30" id="attr-mins<?php echo $m_id?>" type="text" name="aduration[]" value="<?php echo $ra->a_duration?>" required></div>
																						<div style="width: 74px;" class="ra-duration-fields w74">
																							<select tabindex="-1" class="attr-duration-measure" id="attr-duration-measure<?php echo $m_id?>" name="adurationmeasure[]" required>
																								<?php rp_duration_measure_options_markup( $ra->a_duration_measure ); ?>
																							</select>
																						</div>
																						<div class="globe-icon-attr">
																							<input class="repair-additional-desc rptranslatable" id="radesc<?php echo $m_id; ?>" type="text" placeholder="Original" name="radesc[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_attr('attr_desc', $ra->a_uq_id, $ra->r_id_fk));?>" required>
																							<div data-trans-selector="input.repair-additional-desc.rptranslatable" data-trans-key="attr_desc" data-trans-uqid="<?php echo $ra->a_uq_id; ?>" data-trans-ridfk="<?php echo $ra->r_id_fk; ?>" class="globe-icon-translation clearfix">
																								<div class="globe-icon-i">
																									<i class="fas fa-globe"></i>
																								</div>
																							</div>
																						</div>
																						<div class="globe-icon-attr">
																							<input class="repair-additional-badge rptranslatable" id="rabadge<?php echo $m_id; ?>" type="text" placeholder="Badge Text" name="rabadge[]" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_attr('attr_badge', $ra->a_uq_id, $ra->r_id_fk));?>" required>
																							<div data-trans-selector="input.repair-additional-badge.rptranslatable" data-trans-key="attr_badge" data-trans-uqid="<?php echo $ra->a_uq_id; ?>" data-trans-ridfk="<?php echo $ra->r_id_fk; ?>" class="globe-icon-translation clearfix">
																								<div class="globe-icon-i">
																									<i class="fas fa-globe"></i>
																								</div>
																							</div>
																						</div>
																					</div>
																				</td>
																				<?php 
																				if($decimal == 'comma'){
																					$amount = str_replace('.',',',$ra->a_price);
																				}else{
																					$amount = $ra->a_price;					
																				}
																				$passData = array(
																					'ra' => $ra,
																					'm_id' => $m_id,
																					'decimal' => $decimal
																				);
																				$td_to_be_filtered = '<td style="width: 75px;"><input class="repair-price" type="text" id="raprice'.$m_id.'" placeholder="99,99" name="raprice[]" value="'.$amount.'" required></td>';
																				$td_to_be_filtered = apply_filters('rp_individual_repair_attr_price_td', $td_to_be_filtered, $passData);
																				echo $td_to_be_filtered;
																				?>
																				<td style="width: 220px;">
																					<button type="button" data-aid="<?php echo $ra->a_id;?>" tabindex="-1" class="wp-repair-cancel-link ra_delete"><i class="fas fa-times"></i></button>
																				</td>
																			</tr>
																		<?php } }?>
																	</tbody>
																</table>
															</div>
														</td>
													</tr>
												<?php } ?>
											</tbody>
										</table>
									</td>
								</tr>
								<?php if($x+1 == $this_model_default_listing_range): ?>
									<?php rp_render_sort_button($this_model_default_listing_range, $added_margin_column); ?>
								<?php endif; ?>
								<?php $x++; }?>
							</tbody>
						</table>
						<button type="button" data-mid="<?php echo $print->m_id;?>" class="add-repair-btn AddRepair">Add Repair <i class="fas fa-plus"></i></button>
						<button type="button" data-mid="<?php echo $print->m_id;?>" class="add-repair-btn update_repair" style="margin-right: 5px">Update Repair <i class="fas fa-edit"></i></button>
						<button type="button" data-mid="<?php echo $print->m_id;?>" class="add-repair-btn delete_model_related_repairs" style="margin-right: 5px">Delete All Repairs <i class="fas fa-trash-alt" style="font-size: 11px;"></i></button>
					</div>
				</div>
			</td>
		</tr>
	<?php

}
