<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

global $rpQuery;

$rs_upsales = $rpQuery->prefix . "rs_upsales";

$rs_category = $rpQuery->prefix . "rs_category";

$rs_model = $rpQuery->prefix . "rs_model";

$rs_upsales_models = $rpQuery->prefix . "rs_upsales_models";

$upsales = $rpQuery->get_results("SELECT * FROM $rs_upsales ORDER BY upsales_position ASC");
$count_upsales = $rpQuery->get_var("SELECT COUNT(*) FROM $rs_upsales");
$c_result = $rpQuery->get_results("SELECT * FROM $rs_category");
$localization = $rpQuery->prefix . "rs_localization";
$localization_data = $rpQuery->get_results("SELECT * FROM $localization");
$decimal = $localization_data[0]->set_decimals;

$upsales = rp_sanitize_output($upsales);
$c_result = rp_sanitize_output($c_result);
$localization_data = rp_sanitize_output($localization_data);

if (isset($_POST['add_upsales'])) {

	rp_verify_csrf_token_for_simple_form('manage_upsales');

	if(isset($_FILES) && !empty($_FILES)) {
		$uploadedfile = $_FILES['u_img'];
		$upload_overrides = array( 'test_form' => false ); 
		$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
		$us_img = $movefile["url"];
	} else {
		$us_img = '';
	}

    $us_name      = $_POST['us_name'];
    $us_info      = $_POST['us_info'];
    $us_text      = $_POST['us_text'];
    $us_old_price = $_POST['us_old_price'];
    $us_new_price = $_POST['us_new_price'];
    if(preg_match('/,/',$us_old_price)) {
		$old_price = str_replace(',','.',$us_old_price);
	}else{
		$old_price = $us_old_price;					
	}
	if(preg_match('/,/',$us_new_price)) {
		$new_price = str_replace(',','.',$us_new_price);
	}else{
		$new_price = $us_new_price;					
	}
    $rpQuery->query("INSERT INTO $rs_upsales(us_name,us_info,us_text,us_old_price,us_new_price,upsales_img) VALUES('".rp_escape_sql($us_name)."','".rp_escape_sql($us_info)."','".rp_escape_sql($us_text)."','".rp_escape_sql($old_price)."','".rp_escape_sql($new_price)."','".rp_escape_sql($us_img)."')");
    echo "<script>location.replace('admin.php?page=wp_repair_manage_upsales');</script>";

}
if (isset($_POST['update_upsales'])) {

	rp_verify_csrf_token_for_simple_form('manage_upsales');

    $upsales_id   = $_POST['upsales_id'];
    $us_name      = $_POST['us_name'];
    $us_info      = $_POST['us_info'];
    $us_text      = $_POST['us_text'];
    $us_old_price = $_POST['us_old_price'];
    $us_new_price = $_POST['us_new_price'];
    $m_id_fk      = $_POST['m_id_fk'] ?? array();
    $is_active    = $_POST['is_active'] ?? '';
    if($is_active == 'on'){
    	$is_active = '1';
    }else{
    	$is_active = '0';
    }
    if(preg_match('/,/',$us_old_price)) {
		$old_price = str_replace(',','.',$us_old_price);
	}else{
		$old_price = $us_old_price;					
	}
	if(preg_match('/,/',$us_new_price)) {
		$new_price = str_replace(',','.',$us_new_price);
	}else{
		$new_price = $us_new_price;					
	}
    $rpQuery->query("UPDATE $rs_upsales SET us_name='".rp_escape_sql($us_name)."',us_info='".rp_escape_sql($us_info)."',us_text='".rp_escape_sql($us_text)."',us_old_price='".rp_escape_sql($old_price)."',us_new_price='".rp_escape_sql($new_price)."',is_active='".rp_escape_sql($is_active)."' WHERE upsales_id='".rp_escape_sql($upsales_id)."'");

	$rpQuery->query("DELETE FROM $rs_upsales_models WHERE upsales_id_fk='".rp_escape_sql($upsales_id)."'");
	//$i = 0;
	foreach($m_id_fk as $m_id){
    	$rpQuery->query("INSERT INTO $rs_upsales_models(m_id_fk,upsales_id_fk) VALUES('".rp_escape_sql($m_id)."','".rp_escape_sql($upsales_id)."')");
    }
    echo "<script>location.replace('admin.php?page=wp_repair_manage_upsales');</script>";
}

if (isset($_POST['delete_upsale'])) {
	rp_verify_csrf_token_for_simple_form('manage_upsales');
    $upsales_id = $_POST['upsales_id'];
    $rpQuery->query("DELETE FROM $rs_upsales WHERE upsales_id='".rp_escape_sql($upsales_id)."'");
    echo "<script>location.replace('admin.php?page=wp_repair_manage_upsales');</script>";
}

?>
<?php wp_repair_admin_setup_tour_nav_html(); ?>
<style type="text/css">
	.wp-repair_page_wp_repair_manage_upsales button img{
		width: 19px;
	}
	.wp-repair-container .table tbody tr{
		background: #fbfbfd;		
	}
	.wp-repair-container .table tbody .closed td{
		border-top: 2px solid #eeeeee;
		border-bottom: 2px solid #eeeeee;
	}
	.wp-repair-container .type-category tbody tr.closed td:first-child{
		border-left: 2px solid #eeeeee;
	}
	.wp-repair-container .type-category tbody tr.closed .btn-actions{
		border-right: 2px solid #eeeeee;
	}
	input:checked + .slider{
		background-color: #1275c2;
	}
	.wp-repair-input-group {
		position: relative;
		color: #61666b;
		margin-top: 20px;
	}
	.wp-repair-input-group label {
		position: absolute;
		font-size: 9px;
		text-transform: uppercase;
		/*font-weight: 600;*/
		letter-spacing: 1.5px;
		top: -5px;
		left: 18px;
		padding: 0px 6px;
		background: #fff;
		font-weight: bold;
	}
	.wp-repair-input-group input ,.wp-brand-input-group select,.wp-repair-input-group textarea {
		height: 42px;
		border: 2px solid #cfcfcf;
		box-shadow: none;
		outline: 0;
		box-sizing: border-box;
		width: 100%;
		font-size: 14px;
	    /*font-weight: 600;*/
	    border-radius: 8px;
	    padding: 0px 12px;
	    color: #454545;
	}
	.va-full-width-modal .wp-repair-input-group label {
		position: absolute;
		font-size: 8px;
		text-transform: uppercase;
		font-weight: 600;
		letter-spacing: 1.5px;
		top: -5px;
		left: 18px;
		padding: 0px 6px;
		background: #fff;
	}
	.va-full-width-modal .wp-repair-input-group input{
		height: 42px;
		border: 2px solid #cfcfcf;
		box-shadow: none;
		outline: 0;
		box-sizing: border-box;
		width: 100%;
		font-size: 14px;
		/*font-weight: 600;*/
		border-radius: 8px;
		padding: 5px 12px;
		color: #454545;
	}
	.wp-repair-input-group input {
		-webkit-transition: 0.4s all !important;
		transition-duration: 0.4s, 0.4s, 0.4s;
		transition-timing-function: ease, ease, ease;
		transition-delay: 0s, 0s, 0s;
		transition-property: border-color, background, transform;
		-moz-transition: 0.4s all !important;
		-o-transition: 0.4s all !important;
		-ms-transition: 0.4s all !important;
		transition: 0.4s all !important;
	}
	.wp-repair-input-group input:focus,
	.wp-repair-input-group input:active,
	.wp-repair-input-group input:hover {
		border: 2px solid #2781c7;
		box-shadow: none;
		outline: 0;
	}
	.fs-9{
		font-size: 9px;
	}
	tr.justForsort {
		position: relative;
	}
	table.ui-sortable {
		position: relative;
	}
	.justForsort {
		padding: 0px !important;
		margin: 0px !important;
		width: 100% !important;
		background: none !important;
	}
	.ui-sortable-helper {
	    display: table;
	    width: 100%;
	}
	.wp-repair_page_wp_repair_manage_upsales .wp-repair-container tbody tr td.justForsort, 
	.wp-repair_page_wp_repair_manage_upsales .wp-repair-container .category-brand .table tbody tr td.justForsort {
		padding: 0px !important;
	}
	/* SORT BUTTON STYLING
	START
	*/
	.repair-list-sort {
		display: table;
		cursor: pointer;
		position: relative;
		top: 0px;
		float: left;
		    margin-left: 4px;
		    border: 1px solid #adadad;
		    padding: 0px;
		    color: #646464;
		    border-radius: 5px;
	}
	.switch {
		position: relative;
		top: 3px;
		float: left;
	}
	.repair-list-sort i {
		display: table;
		line-height: 12px;
		padding: 0px 4px 0px 4px;
		font-size: 16px;
		cursor: pointer;
	}
	.repair-list-sort i.fa-caret-down {
		padding-bottom: 1px;
	}
	.repair-list-sort i.fa-caret-up {
		padding-top: 1px;
	}
	.repair-list-sort i:hover {
		color: #1275c2;
	}
	/* SORT BUTTON STYLING
	END
	*/

	.transition {
		transform: translateX(0px);
		transition: all 0.3s;
	}
	.hide-on-page {
		transform: translateX(-100%);
	}

	table.upsale {
		overflow: hidden;
	}

	#fastDelete {
		display: inline-table;
		margin: 7px 5px 0px 5px;
		width: 200px;
		box-sizing: border-box;
		min-height: 40px;
		background: #fff !important;
		color: #1275c2 !important;
	}
	#fastDelete.active {
		background: #1275c2 !important;
		color: #fff !important;
	}

	#fastDelete {
		margin: 15px 0px 7px 0px;
		position: relative;
		-webkit-transition: 0.4s all;
		-moz-transition: 0.4s all;
		-o-transition: 0.4s all;
		-ms-transition: 0.4s all;
		transition: 0.4s all;
		left: 0px;
	}
	.table.upsale {
		max-width: 100%;
	    overflow: hidden;
	    width: 65%;
	    min-width: auto;
	}
	.upsale-group-2 img {
		width: 165px;
		position: relative;
		height: auto;
		left: 15px;
		margin: 5px;
	}
	.cat-img, .b-img {
	    text-transform: uppercase;
	    margin: 1em 0;
	    font-weight: bold;
	    letter-spacing: 1.5px;
	}
	.cat-img {
		margin-left: 3px;
	}
	.recommended-image-ratio {
		max-width: 165px;
		position: relative;
		left: 20px;
		font-size: 13px;
	}
	.recommended-image-ratio.add-new {
	    max-width: 100%;
	    position: relative;
	    left: 0px;
	    top: -5px;
	    font-size: 13px;
	}
	.scroll-table {
		max-height: 385px;
	    overflow-y: auto;
	    width: 70%;
	}
	.scroll-table .table.upsale {
		max-width: 100%;
		width: 100%;
	}
	.multicheckboxes button.btn-dropdown .chevron.up {
		height: auto;
    line-height: 1em !important;
    display: table;
    position: relative;
    top: -3px;
	}
	.multicheckboxes button.btn-dropdown .chevron.down {
		height: auto;
    line-height: 1em !important;
    display: table;
    position: relative;
    top: -1px;
	}
	.globe-icon-translation {
		cursor: pointer;
		width: calc(100% - 14px);
		height: 28px;
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
	}

	.globe-icon-attr {
		position: relative;
		display: inline-table;
	}

	.main-repair .globe-icon-attr {
		width: 100%;
	}

	.globe-icon-attr .globe-icon-translation {
		width: calc(100% - 2px);
	}

	.clearfix {
		display: block;
	}

	.clearfix::after {
		content: "";
		clear: both;
		display: table;
	}

	.globe-icon-i {
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
		right: 0px;
		line-height: 0em;
		background: #fff;
		padding: 0px 6px;
	}
	.wp-repair-container .table tbody tr.upsales_table_tr.closed, 
	.wp-repair-container .table tbody tr.upsales_table_tr.closed td {
		border: unset !important;
	}

	.va-full-width-modal-main.trans-modal {
			max-width: 475px;
			max-height: 80%;
			overflow-y: auto;
	}

	.va-full-width-modal-main.trans-modal .wp-repair-input-group {
		margin-top: 10px;
	}

	.va-full-width-modal .flag-img {
		width: 36px;
		display: inline-block;
		position: relative;
		top: 9px;
	}
	.va-full-width-modal .input-cont {
		width: calc(100% - 40px);
		display: inline-block;
	}
	.va-full-width-modal .trans-modal .va-button.va-submit {
		margin-top: 12px;
		display: inline-table;
		float: right;
		margin-bottom: 15px;
		position: relative;
		right: 3px;
		min-width: 80px;
	}
	.va-full-width-modal .trans-modal .va-full-width-modal-inner.clearfix .va-button.va-submit {
		margin-bottom: 0px;
	}
</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 type-category">
			<div class="wp-repair-category-header">
				<h2 class="bold"><?php echo $count_upsales; ?></h2>
				<h2 class="light">UPSALES</h2>
				<button class="add-category upsales-trigger">New Upsale <i class="fas fa-plus"></i></button>
				<button class="add-category" id="saveupOrder" style="margin: 0px 5px">Save Order </button>
				<div class="upsales-modal">
			        <div class="upsales-modal-content">
						<form method="post" action="" enctype="multipart/form-data">
							<?php
							rp_csrf_token_input_field('manage_upsales');
							?>
							<div class="modal-header">
					            <span class="upsales-close-button">&times;</span>	
							</div>		
							<div class="modal-body">
								<div class="wp-repair-input-group">
									<label>Name</label>						
									<input type="text" name="us_name" class="user-info" required>
								</div>
								<div class="wp-repair-input-group">
									<label>Info</label>						
									<input type="text" name="us_info" class="user-info" required>
								</div>
								<div class="wp-repair-input-group">
									<label>Text</label>						
									<input type="text" name="us_text" class="user-info" required>
								</div>
								<div class="wp-repair-input-group">
									<label>Old Price</label>						
									<input type="text" name="us_old_price" class="user-info" required>
								</div>
								<div class="wp-repair-input-group">
									<label>New Price</label>						
									<input type="text" name="us_new_price" class="user-info" required>
								</div>
								<p class="fs-9 cat-img">Upsale Image</p>
								<div class="upload_btn">
									<label for="upload_mimage" class="wp-repair-category-image-upload-button">Upload Image <i class="fas fa-plus"></i></label>
									<input type="file" onchange="readURL(this)" id="upload_mimage" style="display: none;" name="u_img">
									<div class="uploaded_img" style="margin-top:8px"></div>
									<p class="recommended-image-ratio add-new">Recommended Image Size: 500x375 (4:3)</p>
								</div>
							</div>
							<div class="modal-footer">
								<button type="submit" id="add_upsales" class="btn add_upsales" name="add_upsales">Add Upsale</button>
							</div>
						</form>
			        </div>
			    </div>
			</div>
			<div class="wp-repair-category-header">
				<button class="add-category active" id="fastDelete">Confirm Delete (ON) </button>
			</div>
			<div class="table-responsive">
				<table class="table upsaleContainer">
					<thead>
						<tr>
							<th style="width: 70px;">
								<p class="on-off">On/Off</p>
							</th>
							<th style="width: 160px;">
								<p class="name">Name</p>
							</th>
							<th style="width: 160px;">
								<p class="model">Text</p>
							</th>
							<th style="width: 160px;">
								<p class="release-date">Info</p>
							</th>
							<th style="width: 65px;">
								<p class="release-date">Old</p>
							</th>
							<th style="width: 65px;">
								<p class="release-date">New</p>
							</th>
							<th style="width: 160px;">
								<p class="actions"></p>
							</th>
						</tr>
					</thead>
					<tbody>
						<?php if($upsales){foreach($upsales as $up_sales){
							if(!isset($up_sales->upsales_img) || empty($up_sales->upsales_img)) {
								$up_sales->upsales_img = WP_REPAIR_PLUGIN_URL.'assets/images/image-upload.png';
							}

							$upsales_id = $up_sales->upsales_id;
						?>
			<tr class="justForsort Orderingupsale">
				<td class="justForsort" colspan="7">
					<form method="post" action="">
					<?php
					rp_csrf_token_input_field('manage_upsales');
					?>
					<table class="justForsort">
						<tbody class="justForsort">
								<tr class="closed main-upsale-tr" id="<?php echo $upsales_id; ?>">
									<td style="width: 70px;">
										<label class="switch">
										  	<input type="checkbox" <?php if($up_sales->is_active == '1'){echo 'checked';}?> name="is_active" id="is_active">
										  	<span class="slider round"></span>
										</label>
										<!-- <div class="category-sort">
											<i class="fas fa-sort"></i>
										</div> -->
										<?php
										wp_repair_list_sorting_button();
										?>
									</td>
									<td style="width: 160px;">
										<div class="globe-icon-attr">
											<input tabindex="-1" class="upsale-title category-name rptranslatable" placeholder="Upsale Title" id="upsaleid-title<?php echo $up_sales->upsales_id;?>" type="text" name="us_name" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_upsale('us_name', $up_sales->upsales_id)); ?>" required>
											<div data-trans-selector="input.upsale-title.rptranslatable" data-trans-key="us_name" data-trans-uqid="<?php echo $up_sales->upsales_id; ?>" class="globe-icon-translation clearfix">
												<div class="globe-icon-i">
													<i class="fas fa-globe"></i>
												</div>
											</div>
										</div>
									</td>
									<input type="hidden" name="upsales_id" value="<?php echo $up_sales->upsales_id?>">
									<td style="width: 160px;">
										<div class="globe-icon-attr">
											<input tabindex="-1" class="upsale-text category-name rptranslatable" placeholder="Upsale Text" id="upsaleid-text<?php echo $up_sales->upsales_id;?>" type="text" name="us_text" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_upsale('us_text', $up_sales->upsales_id)); ?>" required>
											<div data-trans-selector="input.upsale-text.rptranslatable" data-trans-key="us_text" data-trans-uqid="<?php echo $up_sales->upsales_id; ?>" class="globe-icon-translation clearfix">
												<div class="globe-icon-i">
													<i class="fas fa-globe"></i>
												</div>
											</div>
										</div>
									</td>
									<td style="width: 160px;">
										<div class="globe-icon-attr">
											<input tabindex="-1" class="upsale-info category-name rptranslatable" placeholder="Upsale Info" id="upsaleid-info<?php echo $up_sales->upsales_id;?>" type="text" name="us_info" value="<?php echo rp_sanitize_output(rp_get_static_translations_of_upsale('us_info', $up_sales->upsales_id)); ?>" required>
											<div data-trans-selector="input.upsale-info.rptranslatable" data-trans-key="us_info" data-trans-uqid="<?php echo $up_sales->upsales_id; ?>" class="globe-icon-translation clearfix">
												<div class="globe-icon-i">
													<i class="fas fa-globe"></i>
												</div>
											</div>
										</div>
									</td>
									<?php 
									if($decimal == 'comma'){
										$old_price = str_replace('.',',',$up_sales->us_old_price);
										$new_price = str_replace('.',',',$up_sales->us_new_price);
									}else{
										$old_price = $up_sales->us_old_price;					
										$new_price = $up_sales->us_new_price;					
									}?>
									<td style="width: 70px;"><input class="release-date" type="text" name="us_old_price" value="<?php echo $old_price; ?>"></td>
									<td style="width: 70px;"><input class="release-date" type="text" name="us_new_price" value="<?php echo $new_price; ?>"></td>
									<td style="width: 160px;" class="btn-actions">
										<button type="button" class="plus-icon see-more">Add To Item</button>
										<button type="button" class="wp-repair-shortcode uimage-upload"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/image.svg'; ?>"></button>
										<button type="submit" name="delete_upsale" id="delete_upsale" class="trash"><img src="<?php echo WP_REPAIR_PLUGIN_URL.'assets/images/garbage.svg'; ?>"></button>
										<input type="file" name="u_img_X" style="display: none;" data-uimage-id="<?php echo $up_sales->upsales_id; ?>">
									</td>
								</tr>
								<tr class="more-details"></tr>
								<tr class="spacer"><td></td></tr>
						</tbody>
					</table>
					</form>
				</td>
			</tr>
						<?php } }?>
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
?>
<script type="text/javascript">
	const upsales_modal = document.querySelector(".upsales-modal");
	const upsales_trigger = document.querySelector(".upsales-trigger");
	const upsalescloseButton = document.querySelector(".upsales-close-button");
	function toggleupsalesModal() {
	    upsales_modal.classList.toggle("show-upsales-modal");
	}
	function upsaleswindowOnClick(event) {
	    if (event.target === upsales_modal) {
	        toggleupsalesModal();
	    }
	}
	upsales_trigger.addEventListener("click", toggleupsalesModal);
	upsalescloseButton.addEventListener("click", toggleupsalesModal);
	window.addEventListener("click", upsaleswindowOnClick);
</script>
<script type="text/javascript">
	function readURL(input){
		if(input.files && input.files[0]){
			//console.log(input.files[0]);
			var reader = new FileReader();
			//console.log(reader);
			reader.onload = function (e){
			//console.log(img);
			if( jQuery(".uploaded_img").length > 0 ) {
				jQuery(".uploaded_img").html('<img class="new_image" src="'+e.target.result+'" height="100">');
			}
		}
		reader.readAsDataURL(input.files[0]);
	}
}
</script>
<script type="text/javascript">
	jQuery(document).on('change', 'input[type=checkbox]', function (e) {
	  	var checked = jQuery(this).prop('checked');
	  	var isParent = !!jQuery(this).closest('li').find(' > ul').length;
	  	if (isParent) {
		    // if a parent level checkbox is changed, locate all children
		    var children = jQuery(this).closest('li').find('ul input[type=checkbox]');
		    children.prop({
		      checked
		    }); // all children will have what parent has
	  	} else {
		    // if a child checkbox is changed, locate parent and all children
		    var parent = jQuery(this).closest('ul').closest('li').find('>label input[type=checkbox]');
		    var children = jQuery(this).closest('ul').find('input[type=checkbox]');
		    if (children.filter(':checked').length === 0) {
		      	// if all children are unchecked
		      	parent.prop({ checked: false, indeterminate: false });
		    } else if (children.length === children.filter(':checked').length) {
		      	// if all children are checked
		      	parent.prop({ checked: true, indeterminate: false });
		    } else {
		      	// if some of the children are checked
		      	parent.prop({ checked: true, indeterminate: true });
		    }	
	  	}
	});
</script>
<script type="text/javascript">

	window._more_details_open_handler = function( $, panel, btn ) {

		$(".more-details .details-container").each(function(i){
			if($(this)[0] !== panel) {
				let newPanel = $(this)[0];
				if (newPanel.style.maxHeight) {
					newPanel.style.maxHeight = null;
					$(btn).toggleClass('active');
				}
				$(newPanel).parent().parent().removeClass('active');
				let parentTable = $(newPanel).parent().parent().parent().find('tr:nth-child(1)');
				$(parentTable).removeClass('active');
				$(parentTable).addClass('closed');
			}
		});

		if (panel.style.maxHeight) {
			panel.style.maxHeight = null;
			$(panel).parent().parent().removeClass('active');
			$(btn).parent().parent().removeClass("active");
			$(btn).parent().parent().addClass("closed");
		} else {
			$(panel).parent().parent().addClass('active');
			$(btn).parent().parent().addClass("active");
			$(btn).parent().parent().removeClass("closed");
			panel.style.maxHeight = panel.scrollHeight + "px";

			window.setTimeout(function(){
				panel.style.maxHeight = panel.scrollHeight +300 + "px";
			},300);
		}

		window.setTimeout(function(){
			jQuery('tr.more-details').each(function(){
				if(!jQuery(this).hasClass('active')) {
					jQuery(this).html('');
				}
			});
		}, 300);

	}

	// AJAX MORE DETAILS

	jQuery(".btn-actions .plus-icon.see-more").on("click",function(){

		if( jQuery(this).parents('.main-upsale-tr').hasClass('active') ) {

			window._more_details_open_handler( jQuery, jQuery(this).parents('.main-upsale-tr').find('.more-details .details-container')[0], this );

			return false;

		}

		jQuery(".more-details .details-container").each(function(i){
			let newPanel = jQuery(this)[0];
			if (newPanel.style.maxHeight) {
				newPanel.style.maxHeight = null;
				jQuery(btn).toggleClass('active');
			}
			jQuery(newPanel).parent().parent().removeClass('active');
			let parentTable = jQuery(newPanel).parent().parent().parent().find('tr:nth-child(1)');
			jQuery(parentTable).removeClass('active');
			jQuery(parentTable).addClass('closed');
		});

		var parent = jQuery(this).parents(".Orderingupsale"); 
			
		var upsales_id = parent.find('input[name="upsales_id"]').val();

		var originalHTML = jQuery(this).html();	

		// set min width to outerWidth
		jQuery(this).css('width', parseInt(jQuery(this).outerWidth()) + 'px');

		jQuery(this).html('<i class="fas fa-spinner fa-spin" style="font-size: 12px;"></i>');

		var btn = this;

		repairPluginUI.ajax({

						type:'POST',
						url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
					data: {
						action: 'rp_manage_upsales_more_details',
						upsales_id: upsales_id
					},
					success: function(data) {

						jQuery(btn).html(originalHTML).css('width', 'auto');

						data = JSON.parse(data);

						if( data && data.status && data.status == true ) {

							let more_details = jQuery(parent).find('tr.more-details');

							jQuery(more_details).html(data.more_details);

							window._more_details_open_handler(jQuery, jQuery(more_details).find('.details-container')[0], btn);

						} else {
							
							repairPluginUI.alert_danger('Something went wrong, please try again later.');

						}
						
			},

			error: function(response) {
				jQuery(btn).html(originalHTML).css('width', 'auto');
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}

		});

	});

	jQuery("#fastDelete").on("click", function(){
		if(jQuery(this).hasClass('active')) {
			jQuery(this).removeClass('active');
			jQuery(this).html('Confirm Delete (OFF)');
		} else {
			jQuery(this).addClass('active');
			jQuery(this).html('Confirm Delete (ON)');
		}
	});

	jQuery(".btn-actions button[name='delete_upsale']").on("click", function(e){

		e.preventDefault();

		if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete this upsale?')) {

			jQuery(this).parents('form').append('<input type="hidden" name="delete_upsale" value="1">');

			jQuery(this).parents('form').submit();

		}

	});

	
	jQuery(document).on("click", ".delete_model_upsales", function(){

		if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to delete this item?')) {

			var parent_ordering_upsale = jQuery(this).parents(".Orderingupsale"); 

			var parent = jQuery(this).parents(".upsales_table_tr");

			var up_model_id = jQuery(this).data("up_model_id");

			var model_id = jQuery(this).data("model-id");

			var originalHTML = jQuery(this).html();	

			jQuery(this).html('<i class="fas fa-spinner fa-spin"></i>');

			var btn = this ;
			

			repairPluginUI.ajax({

	          	type:'POST',
	          	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		      	data: {
		      		action: 'delete_upsales_model',
		      		up_model_id: up_model_id, 
		      		delete: true
		      	},
	      		success: function(data) {

	      			jQuery(btn).html(originalHTML);
	      			
		      		data = JSON.parse(data);

		      		if(data.error){

		      			repairPluginUI.alert_danger(data.error);	

		      			return;				
		      		}	

		      		jQuery(parent_ordering_upsale).find("input[name='m_id_fk[]']").each(function(){
		      			if(parseInt(jQuery(this).val()) === parseInt(model_id)) {
		      				if(jQuery(this).is(':checked')) {
		      					jQuery(this).prop('checked', false).change();
		      				}
		      			}
		      		});

		      		jQuery(parent).addClass('transition');
					window.setTimeout(function(){
						jQuery(parent).addClass('hide-on-page');
						window.setTimeout(function(){
							jQuery(parent).remove();
						},300);
					},60);


					repairPluginUI.alert_success(data.success);	
				},

				error: function(response) {
					jQuery(btn).html(originalHTML);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}

		    });

		}

	});


	// AJAX RESET //

	jQuery(document).on("click", ".reset-upsale",function(){

		if (!jQuery("#fastDelete").hasClass('active') || confirm('Are you sure you want to reset this upsale?')) {

			var parent = jQuery(this).parents(".Orderingupsale"); 
			
			var upsales_reset_id = parent.find('input[name="upsales_id"]').val();

			var originalHTML = jQuery(this).html();	

			jQuery(this).html('<i class="fas fa-spinner fa-spin"></i>');

			var btn = this;

			repairPluginUI.ajax({

	          	type:'POST',
	          	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		      	data: {
		      		action: 'reset_upsales',
		      		upsales_reset_id: upsales_reset_id,
		      		reset: true
		      	},
	      		success: function(data) {

	      			jQuery(btn).html(originalHTML);

		      		data = JSON.parse(data);

		      		if(data.error){

						repairPluginUI.alert_danger(data.error);

		      			return;
						
		      		}

		      		jQuery(parent).find("input[name='m_id_fk[]']").each(function(){
		      			if(jQuery(this).is(':checked')) {
		      				jQuery(this).prop('checked', false).change();
		      			}
		      		});

		      		jQuery(parent).find(".upsales_table_tr").each(function(){
		      			let currentTr = this;
			      		jQuery(this).addClass('transition');
						window.setTimeout(function(){
							jQuery(currentTr).addClass('hide-on-page');
							window.setTimeout(function(){
								jQuery(currentTr).remove();
							},300);
						},60);
		      		});


					repairPluginUI.alert_success(data.success);

		      		
				},

				error: function(response) {
					jQuery(btn).html(originalHTML);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}

		    });

		}

	});

	jQuery(".btn-actions button.uimage-upload").on("click", function(e){

		e.preventDefault();

		jQuery(this).parent().find('input[name="u_img_X"]').click();

	});

	jQuery(document).on("change", "input[name='u_img_X']", function(){
		if(jQuery(this).hasClass("processing")) {
			return;
		}
		let btn = this;

		jQuery(btn).addClass("processing");

		var parent = jQuery(this).parents(".Orderingupsale"); 

		let actualBtn = jQuery(this).parent().find('button.uimage-upload');

		var btndata = jQuery(actualBtn).html();
		jQuery(actualBtn).html('<i style="font-size: 19px; position: relative; top: 0px;" class="fas fa-spinner fa-spin"></i>');

		let currentInput = this;

		var uid = jQuery(currentInput).data('uimage-id');
		var file_data = jQuery(currentInput).prop('files');
		if(file_data.length > 0) {
			file_data = file_data[0];
		} else {
			file_data = null;
		}
		var form_data = new FormData();
		if(file_data) {
			form_data.append('file', file_data);
		}

    	form_data.append('action', 'update_upsales_img');
 		form_data.append('uid', uid);

 		if(file_data) {
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				dataType: 'text', // what to expect back from the server
				cache: false,
				contentType: false,
				processData: false,
				data: form_data,
				success: function (response) {
					jQuery(btn).removeClass("processing");
					jQuery(actualBtn).html(btndata);
	          		try {
	          			response = JSON.parse(response);
	          		} catch (e) {

	          		}
	          		if(response && response.success) {
									if( jQuery(parent).find('.upsale-group-2 img').length > 0 ) {
										jQuery(parent).find('.upsale-group-2 img').attr('src', response.logo);
									}
	          			if(uid !== 'NEW') {
	          				repairPluginUI.alert_success('Repair image successfully updated.');
	          			}
	          		} else {
	          			if(uid !== 'NEW') {
	          				repairPluginUI.alert_danger('Something went wrong, please try again later.');
	          			}
	          		}
				},
				error: function(response) {
					jQuery(btn).removeClass("processing");
					jQuery(actualBtn).html(btndata);
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
      		});
 		}
	});

</script>
<script type="text/javascript">
	function moveUp(item) {
	    var prev = item.prev();
	    if (prev.length == 0)
	        return;
	    prev.css('z-index', 999).css('position','relative').animate({ top: item.height() }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: '-' + prev.height() }, 300, function () {
	        prev.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
	        item.insertBefore(prev);
	    });
	}
	function moveDown(item) {
	    var next = item.next();
	    if (next.length == 0)
	        return;
	    next.css('z-index', 999).css('position', 'relative').animate({ top: '-' + item.height() }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: next.height() }, 300, function () {
	        next.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
	        item.insertAfter(next);
	    });
	}
	jQuery('#saveupOrder').click(function (e) {
		if(jQuery(this).hasClass("processing")) {
			return;
		}
		let btn = this;
		jQuery(btn).addClass("processing");
		let originalHTML = jQuery(btn).html();
		var btndata = jQuery(this).html('');
		jQuery(btndata).html('Please Wait');
	    e.preventDefault();
	    var up_position = [];
	    jQuery('.upsaleContainer .Orderingupsale').each(function(){
	    	up_position.push(jQuery(this).find("input[name='upsales_id']").val());
	    });
	    repairPluginUI.ajax({
	    	type:'POST',
	      	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
	      	data: {action:'update_upsales_position',up_position:up_position},
	      	success: function(response) {
	      		location.reload();
	      	},
			error: function(response) {
				jQuery(btn).html(originalHTML);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
	    });
	});
	jQuery(".upsaleContainer").sortable({ items: ".Orderingupsale", distance: 5, handle: '.repair-list-sort' });
	jQuery('.Orderingupsale .repair-list-sort .fas').click(function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up')
	        moveUp(btn.parents('.Orderingupsale'));
	    else
	        moveDown(btn.parents('.Orderingupsale'));
	});

	(function($){

		function showFullWidthModal(content = '', additional_cls = '') {
			$(".va-full-width-modal").remove();
			let html = `
				<div class="va-full-width-modal">
					<div class="va-full-width-modal-main ${additional_cls}">
						<div class="va-full-width-modal-inner clearfix">
							${content}
						</div>
						<button class="va-button va-button-default va-close-modal">
							<i class="fas fa-times"></i>
						</button>
					</div>
				</div>
			`;
			$("body").append(html);
			$(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
			$(".va-full-width-modal .va-close-modal").on("click", function(){
				$(this).parent().animate({'top': '-50%'}, 400, function(){
					$(this).parent().remove();
				});
			});
			$(document).on("mouseup", handOutsideClick);
			// $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
		}
		function handOutsideClick(e) {
			var container = $('.va-full-width-modal-main');
			// if the target of the click isn't the container nor a descendant of the container
			if (!container.is(e.target) && container.has(e.target).length === 0) 
			{
				container.find(".va-close-modal").click();
				$(document).off("mouseup", handOutsideClick);
			}
		}

		jQuery(document).on('click', '.globe-icon-translation', function(){

			if(jQuery('.globe-icon-translation').hasClass("processing")) {
				return;
			}
			let btn = this;

			let trans_key = jQuery(this).data('trans-key');
			let trans_uqid = jQuery(this).data('trans-uqid');

			let trans_selector = jQuery(this).data('trans-selector');

			let rp_action = 'rp_get_upsale_translations';

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<div class="globe-icon-i"><i class="fas fa-spinner fa-spin"></i></div>');

			jQuery('.globe-icon-translation').addClass("processing");

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action: rp_action, key: trans_key, uqid: trans_uqid},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery('.globe-icon-translation').removeClass("processing");
					
					try {
						
						data = JSON.parse(data);

					} catch(e) {

						repairPluginUI.alert_danger('Something went wrong, please try again later.');	
						return;

					}
					
					let rows = '';

					data.translations.forEach(function(row){

						rows += `
							<tr>
								<td width="300">
									<div class="flag-img">
										<img width="28px" height="28px" src="${row.image}">
									</div>
									<div class="input-cont">
										<div class="wp-repair-input-group">
											<label>${row.alt_name}</label>
											<input type="text" class="user-info" data-lang-name="${row.name}" name="translations[]" value="${row.t_value}" required="">
										</div>
									</div>
								</td>
							</tr>
						`;

					});

					showFullWidthModal(`
						<p class="va-modal-title">Update Translations</p>
						<table style="width:100%;">
							<tbody>
								${rows}
							</tbody>
						</table>
						<input type="hidden" name="alert" value="1">
						<input type="hidden" name="trans_key" value="${trans_key}">
						<input type="hidden" name="trans_uqid" value="${trans_uqid}">
						<input type="hidden" name="trans_selector" value="${trans_selector}">
						<button type="submit" class="va-button va-submit va-trans">
							Update
						</button>
					`, 'trans-modal');

				},
				error: function(response) {
					jQuery(btn).html(btndata);
					jQuery('.globe-icon-translation').removeClass("processing");
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});

		});

		jQuery(document).on('click', '.va-full-width-modal-inner .va-button.va-submit.va-trans', function(){

			if(jQuery(this).hasClass("processing")) {
				return;
			}

			let btn = this;

			jQuery(btn).addClass("processing");

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<i style="position:relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

			let keys = [];
			let values = [];

			let translation_key = jQuery('.va-full-width-modal-inner input[name^="trans_key"]').val();
			let translation_uqid = jQuery('.va-full-width-modal-inner input[name^="trans_uqid"]').val();

			let translation_selector = jQuery('.va-full-width-modal-inner input[name^="trans_selector"]').val();

			let action = 'rp_update_upsale_translations';

			jQuery('.va-full-width-modal-inner input[name^="translations["]').each(function(){
				keys.push(jQuery(this).data('lang-name'));
				values.push(jQuery(this).val());
			});

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {
					action:action,
					keys:keys,
					values:values,
					translation_key: translation_key,
					translation_uqid: translation_uqid
				},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery(btn).removeClass("processing");

					try {
						
						data = JSON.parse(data);

					} catch(e) {

						repairPluginUI.alert_danger('Something went wrong, please try again later.');	
						return;

					}

					if(data.status == true || data.status == 'true') {
						jQuery(".va-close-modal").click();
						let globe_icon = null;

						jQuery('.globe-icon-translation').each(function(){

							let git_key = jQuery(this).data('trans-key');
							let git_uqid = jQuery(this).data('trans-uqid');

							if(git_key === translation_key && git_uqid == translation_uqid) {
								let _parent = 'tr.main-upsale-tr';
								jQuery(this).parents(_parent).find(translation_selector).val(data.default_translation);
							}

						});
						repairPluginUI.alert_success('Translations updated successfully.');
					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}

				},
				error: function( response ) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});

		});

	}(jQuery));
</script>