<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

global $wp_repair_lang;

$category_based = rp_get_static_translations_based_on_category();

$english_translations = rp_get_static_translations_of_language('English (United States)');

function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}
global $rpQuery;
$company_information = $rpQuery->prefix ."rs_company_information";
$company_results = $rpQuery->get_results("SELECT * FROM $company_information");
$company_email = '';
if(!empty($company_results)) {
	$company_email = $company_results[0]->company_email;
}
$notification_types = $rpQuery->prefix . "rs_notification_types";
$notification_offers = $rpQuery->prefix . "rs_notifications_and_offers";
$n_types = rp_get_sorted_noti_types();



if (isset($_POST['update_data'])) {

	rp_verify_csrf_token_for_simple_form('notification_offer');

	if(isset($_POST['rp_expire_offer_after_x_days'])) {
    	if((int) $_POST['rp_expire_offer_after_x_days'] > 365) {
    		$_POST['rp_expire_offer_after_x_days'] = 365;
    	}
    	if(rp_get_option('rp_expire_offer_after_x_days', FALSE) === FALSE) {
    		rp_add_option('rp_expire_offer_after_x_days', (int) $_POST['rp_expire_offer_after_x_days']);
    	} else {
    		rp_update_option('rp_expire_offer_after_x_days', (int) $_POST['rp_expire_offer_after_x_days']);
    	}
    }

    $noti_id          = ['1','2','3','6','9','10','4','5','7','8'];
    $type_id          = ['1','2','3','6','9','10','4','5','7','8'];
    $is_active        = $_POST['is_active'] ?? '';
    $isactive         = $_POST['isactive'] ?? '';

    $use_customer_details = $_POST['use_customer_details'] ?? '0';

    if(rp_get_option('rp_use_customer_info_for_duplicate_email', FALSE) === FALSE) {
    	rp_add_option('rp_use_customer_info_for_duplicate_email', $use_customer_details);
    } else {
    	rp_update_option('rp_use_customer_info_for_duplicate_email', $use_customer_details);
    }

		$rp_x_hours_before_appointment = $_POST['rp_x_hours_before_appointment'] ?? NULL;

		if($rp_x_hours_before_appointment !== NULL && is_numeric($rp_x_hours_before_appointment)) {
			$rp_x_hours_before_appointment = (int) $rp_x_hours_before_appointment;
			if($rp_x_hours_before_appointment > 0) {
				if(rp_get_option('rp_x_hours_before_appointment', FALSE) === FALSE) {
					rp_add_option('rp_x_hours_before_appointment', $rp_x_hours_before_appointment);
				} else {
					rp_update_option('rp_x_hours_before_appointment', $rp_x_hours_before_appointment);
				}
			}
		}

		$rp_x_hours_after_appointment = $_POST['rp_x_hours_after_appointment'] ?? NULL;

		if($rp_x_hours_after_appointment !== NULL && is_numeric($rp_x_hours_after_appointment)) {
			$rp_x_hours_after_appointment = (int) $rp_x_hours_after_appointment;
			if($rp_x_hours_after_appointment > 0) {
				if(rp_get_option('rp_x_hours_after_appointment', FALSE) === FALSE) {
					rp_add_option('rp_x_hours_after_appointment', $rp_x_hours_after_appointment);
				} else {
					rp_update_option('rp_x_hours_after_appointment', $rp_x_hours_after_appointment);
				}
			}
		}

    $duplicate_status_prefix = 'wp_repair_admin_duplicate_email_status_';
    $duplicate_1	= $_POST[$duplicate_status_prefix.'1'] ?? '';
    $duplicate_2	= $_POST[$duplicate_status_prefix.'2'] ?? '';
    $duplicate_3	= $_POST[$duplicate_status_prefix.'3'] ?? '';
    $duplicate_4	= $_POST[$duplicate_status_prefix.'4'] ?? '';
	$duplicate_5	= $_POST[$duplicate_status_prefix.'5'] ?? '';
	$duplicate_6	= $_POST[$duplicate_status_prefix.'6'] ?? '';
	$duplicate_7	= $_POST[$duplicate_status_prefix.'7'] ?? '';
	$duplicate_8	= $_POST[$duplicate_status_prefix.'8'] ?? '';
	$duplicate_9	= $_POST[$duplicate_status_prefix.'9'] ?? '';
	$duplicate_10	= $_POST[$duplicate_status_prefix.'10'] ?? '';

    $email_statuses = array(1,2,3,4,5,6,9,10,7,8);

    // rp_get_settings_placeholder_email
    
    foreach ($email_statuses as $single_status) {

    	$admin_check_duplicate_key = $duplicate_status_prefix.$single_status; // wp_repair_admin_duplicate_email_status_X

    	$checked_duplicate = $_POST[$duplicate_status_prefix.$single_status] ?? ''; // If is checked, value = 1... Else empty string...

    	if(!empty($checked_duplicate)) {
    		// Is Enabled!
    		// Enable the duplicate
    		if(rp_get_option($admin_check_duplicate_key, FALSE) === FALSE) {
    			rp_add_option($admin_check_duplicate_key, '1');
    		} else {
    			rp_update_option($admin_check_duplicate_key, '1');
    		}

    	} else {
    		// Is Disabled!
    		// Disable the Duplicate...
    		if(rp_get_option($admin_check_duplicate_key, FALSE) === FALSE) {
    			rp_add_option($admin_check_duplicate_key, '0');
    		} else {
    			rp_update_option($admin_check_duplicate_key, '0');
    		}
    	}
    }
    // var_dump($isactive);
    // var_dump($is_active);
    // die();
    foreach($type_id as $x => $id){
    	if( $id == 3 || $id == 5 || $id == 6 || $id == 7 || $id == 8 || $id == 9 || $id == 10 ) {
    		continue;
    	}
    	$status = $_POST['is_active'.$id];    
    	$rpQuery->query("UPDATE $notification_types SET is_active='".rp_escape_sql($status)."' WHERE noti_type_id='".rp_escape_sql($id)."'");
    }
    foreach($noti_id as $i => $id){
    	$status = $_POST['isactive'.$id];    
    	$rpQuery->query("UPDATE $notification_offers SET is_active='".rp_escape_sql($status)."' WHERE noti_id='".rp_escape_sql($id)."'");
    }
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=notification_offer');</script>";
}
?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.duplicate-email-settings-container .tax-fields {
		margin-bottom: 12px;
	}
	.mce-panel.mce-floatpanel .mce-widget.mce-btn.mce-primary.mce-abs-layout-item.mce-first.mce-btn-has-text {
		background-color: #2d8ac7;
	}
	p.duplicate_email-email-input {
		margin-top: 0px;
		margin-bottom: 0px;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 300px;
	}
	.rp-cron-job-info {
		display: table;
		padding: 0px 20px;
		width: 100%;
		box-sizing: border-box;
		margin-bottom: 40px;
	}
	.rp-cron-job-info.command {
		margin-bottom: 10px;
	}
	.rp-cron-job-info .bold {
		display: table;
		width: 100%;
		font-weight: 600;
		margin-bottom: 5px;
	}
	.rp-cron-job-info .light {
		display: table;
		width: 100%;
		padding: 8px 16px;
		background: rgb(18, 117, 194, 0.2);
		box-sizing: border-box;
		border-radius: 8px;
		color: #404040;
		font-weight: 700;
	}
	.clearfix {
		clear: both;
	}
	.clearfix::after {
		content: "";
		display: table;
		clear: both;
	}
	.wp-repair-special-col {
		padding: 0px 20px;
		padding-top: 0px;
		padding-bottom: 30px;
	}
	.nmb-0 {
		margin-bottom: 0px;
	}
	.wp-repair-col-3{
		margin-top: 70px;
		float: right;
	}
	.wp-repair-col-4.w-100.main-section {
		width: 100%;
	}
	.wp-repair-col-4.pdf-offer.main-section h2 {
		margin-top: 0px;
	}
	@media(max-width: 1140px) {
		.wp-repair-col-3 {
			float: left;
			margin-bottom: 30px;
			padding: 0px 20px;
			margin-top: 0px;
		}
	}
	@media(max-width: 480px) {
		.wp-repair-special-col,
		.wp-repair-col-3.main-section.section-two {
			padding-left: 20px;
			padding-right: 20px;
		}
	}
	@media(max-width: 424px) {
		.wp-repair-special-col,
		.wp-repair-col-3.main-section.section-two {
			padding-left: 15px;
			padding-right: 15px;
		}
	}
</style>
<style type="text/css">
	.va-full-width-modal-main.trans-modal .wp-repair-input-group {
		margin-top: 10px;
	}
	.va-full-width-modal-main {
		max-width: 475px;
		max-height: 80%;
		overflow-y: auto;
	}
	.va-full-width-modal .flag-img {
		width: 36px;
		display: inline-block;
		position: relative;
		top: 9px;
	}
	.va-full-width-modal .input-cont {
		width: calc(100% - 40px);
		display: inline-block;
	}
	.va-full-width-modal .va-button.va-submit {
		margin-top: 12px;
		display: inline-table;
		float: right;
		margin-bottom: 15px;
		position: relative;
		right: 3px;
		min-width: 80px;
	}
	.globe-icon-translation {
		cursor: pointer;
		width: calc(100% - 2px);
		height: 42px;
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
	}

	.clearfix {
		display: block;
	}

	.clearfix::after {
		content: "";
		clear: both;
		display: table;
	}
	.globe-icon-i {
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
		right: 0px;
		line-height: 0em;
		background: #fff;
		padding: 0px 8px;
	}
.mce-panel.mce-floatpanel .mce-widget.mce-btn.mce-primary.mce-abs-layout-item.mce-first.mce-btn-has-text {
	background-color: #2d8ac7;
}
.mce-btn {
	background-color: #fff;
}
.mce-panel {
	background-color: #fff;
}
.wp-repair-input-group > .mce-panel.mce-container {
	border-width: 2px;
		border-radius: 8px;
		border: 2px solid #cfcfcf !important;
		box-sizing: border-box;
		padding: 0px 2px;
	transition: border-color 0.3s;
}
.mce-path {
	display: none;
}
.mce-statusbar.mce-container {
	border: 0px;
}
.mce-container-body .mce-resizehandle {
	right: 2px;
		bottom: 2px;
}
.mce-container-body.mce-stack-layout {
	padding: 1px;
}
.wp-repair-input-group label {
	z-index: 10;
}
.wp-repair-input-group > .mce-panel.mce-container:hover {
	border: 2px solid #2781c7 !important;
	box-shadow: none;
	outline: 0;
}
.mce-container,
.mce-content-body,
.mce-menubar .mce-menubtn button span,
.mce-menu-item,
.mce-menu-item .mce-ico, .mce-menu-item .mce-text  {
	color: #454545;
}
div.mce-edit-area {
	min-height: 200px;
}
div.mce-edit-area iframe {
	min-height: 200px;
}
/*.mce-container.mce-menubar.mce-toolbar {
	display: none;
}*/
iframe #tinymce {
	background-color: #000;
}
.wp-repair-col-4.pdf-offer.main-section.clearfix {
	padding-bottom: 15px;
}
.save-notification-offer button {
	width: auto;
    float: right;
    margin-top: 25px;
    margin-bottom: 15px;
}
.wp-repair-col-4.main-section.section-twoo {
	margin-top: 48px;
}
@media (max-width: 1140px) {
	.wp-repair-col-4.main-section.section-twoo {
		margin-top: 0px !important;
		padding-top: 0px !important;
	}
}
</style>
<form method="post" action="">
<?php
rp_csrf_token_input_field('notification_offer');
?>
<input type="hidden" name="is_active1" value="1">
<input type="hidden" name="is_active4" value="1">
	<div class="wp-repair-container">
		<div class="wp-repair-row">
			<div class="wp-repair-col-12 settings">
				<div class="repair-dl-rounded-container">
					<div class="wp-repair-row">
						<?php wpRepairLoadSidebar('notification_offer'); ?>
						<div class="wp-repair-col-8 bg-with-border">
							<div class="wp-repair-col-4 main-section w-100">
								<div class="wp-repair-main-section-heading">
									<h2>
										<span class="bold">Email</span>
										<span class="light">Notifications</span>
									</h2>
									<p class="more-info">Make sure your visitors see familiar language</p>
								</div>
								<div class="tax-fields first"  style="display:grid">
									<div class="apply-tax-rate">
										<div class="td select">
											<label class="switch">
											  <input type="hidden" name="use_customer_details" value="0">
											  <input type="checkbox" <?php if(rp_get_option('rp_use_customer_info_for_duplicate_email', '0') === '1' ) { echo 'checked'; } ?> name="use_customer_details" value="1">
											  <span class="slider round"></span>
											</label>
										</div>
										<div class="td text">
											<span class="text">Use customer details as a sender while sending duplicate email</span>
										</div>
									</div>
								</div>
							</div>
							<div class="full-width-wp-repair">
								<div class="table-responsive location-table">
									<table class="table">
										<tbody>
											<tr class="closed">
												<td colspan="2">
													<button type="button" class="plus-icon see-more">
														<span class="dropicon">
															<i class="fas fa-plus"></i>
														</span>
														<span class="text">Email Translations</span>
													</button>
												</td>
											</tr>
											<tr class="more-details">
												<td colspan="7">
													<div class="details-container">
														<div class="wp-repair-inner-col">
															<?php
															foreach($category_based as $category => $keys) {
																if( $category !== 'Emails' ) {
																	continue;
																}
																foreach($keys as $lang_key) {
																	$lang_value = $english_translations[$lang_key] ?? '';
																	$lang_value_translated = $wp_repair_lang[$lang_key] ?? '';
																	$lang_value_translated = str_replace('&quot;', '"', $lang_value_translated);
																	?>
																	<div class="wp-repair-input-group">
																		<label><?php echo $lang_value; ?></label>
																		<input type="text" class="user-info" name="laltname[]" value="<?php echo htmlspecialchars($lang_value_translated);?>">
																		<div data-lang-key="<?php echo $lang_key; ?>" class="globe-icon-translation clearfix">
																			<div class="globe-icon-i">
																				<i class="fas fa-globe"></i>
																			</div>
																		</div>
																	</div>
																	<?php
																}
															}
															?>
														</div>
													</div>
												</td>
											</tr>
										</tbody>
									</table>
								</div>
								<?php if($n_types){foreach($n_types as $type){
									$ntype_id = $type->noti_type_id;
									$email_translation_key = get_translation_key_by_noti_type_id($ntype_id);
									$n_offers = $rpQuery->get_results("SELECT * FROM $notification_offers WHERE noti_type_id_fk = '".rp_escape_sql($ntype_id)."'");
									 ?>
									<div class="table-responsive location-table">
										<table class="table">
											<tbody>
												<tr class="closed">
													<td>
														<button type="button" class="plus-icon see-more">
															<span class="dropicon">
																<i class="fas fa-plus"></i>
															</span>
															<span class="text"><?php 
															if($ntype_id == 3) {
																echo 'Booking Approved (Come by our store)';
															} else {
																echo $type->noti_type;
															}
															?></span>
														</button>
													</td>
													<td class="ractions-td">
														<label class="switch">
											  				<input type="hidden" name="isactive<?php echo $n_offers[0]->noti_id; ?>" value="0">
														  	<input type="checkbox" <?php if($n_offers[0]->is_active == '1'){echo "checked";}?> name="isactive<?php echo $n_offers[0]->noti_id; ?>" id="is_active" value="1">
														  	<span class="slider round"></span>
														</label>
													</td>
												</tr>
												<tr class="more-details">
													<td colspan="7">
														<div class="details-container">
															<div class="wp-repair-inner-col">
																<div class="wp-repair-input-group">
																	<label>EMAIL SUBJECT</label>
																	<input type="text" class="user-info" name="laltname[]" value="<?php echo htmlspecialchars($wp_repair_lang[$email_translation_key.'_email_subject']);?>">
																	<div data-lang-key="<?php echo $email_translation_key.'_email_subject'; ?>" class="globe-icon-translation clearfix">
																		<div class="globe-icon-i">
																			<i class="fas fa-globe"></i>
																		</div>
																	</div>
																</div>
																<div class="wp-repair-input-group">
																	<label>EMAIL MESSAGE</label>
																	<input type="text" class="user-info" name="laltname[]" value="<?php echo htmlspecialchars($wp_repair_lang[$email_translation_key.'_email_template']);?>">
																	<div data-lang-key="<?php echo $email_translation_key.'_email_template'; ?>" class="globe-icon-translation clearfix">
																		<div class="globe-icon-i">
																			<i class="fas fa-globe"></i>
																		</div>
																	</div>
																</div>
																
<div class="duplicate-email-settings-container">
	<div class="tax-fields first"  style="display:grid">
		<?php
		$admin_duplicate_check = rp_get_option('wp_repair_admin_duplicate_email_status_'.$type->noti_type_id, NULL);
		if($admin_duplicate_check !== '1') {
			$admin_duplicate_check = NULL;
		}
		?>
		<div class="apply-tax-rate">
			<div class="td select">
				<label class="switch">
				  <input type="checkbox" name="<?php echo 'wp_repair_admin_duplicate_email_status_'.$type->noti_type_id; ?>" <?php 
				  if(!empty($admin_duplicate_check)){
				  	echo 'checked';
				}?> value="1">
				  <span class="slider round"></span>
				</label>
			</div>
			<div class="td text">
				<span class="text">Send Duplicate</span>
			</div>
		</div>
	</div>
	<p class="duplicate_email-email-input" <?php if(empty($admin_duplicate_check)) { echo 'style="display:none;"'; } ?>><small>The duplicate email will be sent to the related location email.</small></p>
	<?php
	if($type->noti_type_id == 7) {
		?>
		<table style="margin-top: 10px;">
			<tbody>
				<tr>
					<th style="width: 85%; text-align:left;">Send it X hours before the appointment time</th>
					<td style="width: 15%;"><input type="number" name="rp_x_hours_before_appointment" value="<?php echo rp_get_option('rp_x_hours_before_appointment', '2'); ?>"></td>
				</tr>
			</tbody>
		</table>
		<?php
	}
	if($type->noti_type_id == 8) {
		?>
		<table style="margin-top: 10px;">
			<tbody>
				<tr>
					<th style="width: 85%; text-align:left;">Send it X hours after the appointment time</th>
					<td style="width: 15%;"><input type="number" name="rp_x_hours_after_appointment" value="<?php echo rp_get_option('rp_x_hours_after_appointment', '2'); ?>"></td>
				</tr>
			</tbody>
		</table>
		<?php
	}
	?>
</div>
															</div>
															<!-- <div class="wp-repair-inner-col section-2">
																<h3 class="available-shortcode">AVAILABLE SHORTCODES</h3>
																<table class="table">
																	<tbody>
																		<tr>
																			<td class="shortcode-heading">Customer's Name</td>
																			<td class="actual-shortcode">$customer$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Booking Date</td>
																			<td class="actual-shortcode">$date$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Booking Time</td>
																			<td class="actual-shortcode">$time$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Order Summary</td>
																			<td class="actual-shortcode">$order$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Service Duration</td>
																			<td class="actual-shortcode">$duration$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Location</td>
																			<td class="actual-shortcode">$location$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Your Company</td>
																			<td class="actual-shortcode">$company$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Your Phone</td>
																			<td class="actual-shortcode">$phone$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Your Email</td>
																			<td class="actual-shortcode">$email$</td>
																		</tr>
																		<tr>
																			<td class="shortcode-heading">Company Address</td>
																			<td class="actual-shortcode">$address$</td>
																		</tr>
																	</tbody>
																</table>
															</div> -->
														</div>
													</td>
												</tr>
											</tbody>
										</table>
									</div>
								<?php } }?>
							</div>
							<div>
								<?php
								$bg_process = new RepairPluginPro\RP_Background_Process(WP_REPAIR_PLUGIN_PATH);
								$php_path = str_replace('\\', '/', $bg_process->get_php_path());
								$plugin_path = str_replace('\\', '/', WP_REPAIR_PLUGIN_PATH) . 'cron.php rp > /dev/null 2>&1';
								if( !empty($php_path) ) {

									?>
									<p class="rp-cron-job-info command">
										<span class="bold">You need to setup CRON Job for reminder and aftersales email:</span>
										<span class="light"><?php echo $php_path; ?> <?php echo $plugin_path; ?></span>
									</p>
									<p class="rp-cron-job-info duration">
										<span class="bold">Duration (Every Five Minutes)</span>
										<span class="light">*/5 * * * *</span>
									</p>
									<?php

								}
								?>
							</div>
							<div class="wp-repair-col-4 pdf-offer main-section clearfix">
								<div class="wp-repair-main-section-heading">
									<h2>
										<span class="bold">PDF</span>
										<span class="light">Offers</span>
									</h2>
									<p class="more-info">Allow visitors to request an offer before booking</p>
								</div>
								<div class="tax-fields">
									<div class="apply-tax-rate">
										<div class="td select">
											<label class="switch">
											  <input type="hidden" name="is_active2" value="0">
											  <input type="checkbox" name="is_active2" <?php if($n_types[1]->is_active == '1'){echo 'checked';}?> value="1">
											  <span class="slider round"></span>
											</label>
										</div>
										<div class="td text">
											<span class="text">Send personalized price offers to your prospects in PDF format</span>
										</div>
									</div>
								</div>
							</div>
							<div class="wp-repair-col-4 main-section section-twoo">
								<div class="wp-repair-input-group" style="margin-top: 0px;">
									<p class="company-logo-theme-color">Expire offer in X days</p>
									<input type="number" min="1" max="365" class="user-info" name="rp_expire_offer_after_x_days" value="<?php echo rp_get_option('rp_expire_offer_after_x_days', 14); ?>" required>
								</div>
								<div class="sec-3 clearfix save-notification-offer">
									<button type="submit" name="update_data" class="wp-general-info">Save Settings</button>
								</div>
							</div>
							<div class="wp-repair-special-col clearfix">
							<?php
							$allowed = array('Offer PDF', 'Offer PDF Filename');
							foreach($category_based as $category => $keys) {
								if( !in_array($category, $allowed) ) {
									continue;
								}
							?>
								<div class="table-responsive location-table">
										<table class="table">
											<tbody>
												<tr class="closed">
													<td colspan="2">
														<button type="button" class="plus-icon see-more">
															<span class="dropicon">
																<i class="fas fa-plus"></i>
															</span>
															<span class="text"><?php echo $category; ?></span>
														</button>
													</td>
												</tr>
												<tr class="more-details">
													<td colspan="7">
														<div class="details-container">
															<div class="wp-repair-inner-col">
																<?php
																	foreach($keys as $lang_key) {
																		$lang_value = $english_translations[$lang_key] ?? '';
																		$lang_value_translated = $wp_repair_lang[$lang_key] ?? '';

																		$lang_value_translated = str_replace('&quot;', '"', $lang_value_translated);

																		// limit $lang_value to only 8 words and add ... if more than 8 words
																		$words = explode(' ', $lang_value);
																		if( count($words) > 8 ) {
																			$words = array_slice($words, 0, 8);
																			$lang_value = implode(' ', $words) . '...';
																		}
																		

																		?>
																		<div class="wp-repair-input-group">
																			<label><?php echo $lang_value; ?></label>
																			<input type="text" class="user-info" name="laltname[]" value="<?php echo htmlspecialchars($lang_value_translated);?>">
																			<div data-lang-key="<?php echo $lang_key; ?>" class="globe-icon-translation clearfix">
																				<div class="globe-icon-i">
																					<i class="fas fa-globe"></i>
																				</div>
																			</div>
																		</div>
																		<?php
																	}
																?>
															</div>
														</div>
													</td>
												</tr>
											</tbody>
										</table>
									</div>
								<?php
								}
								?>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</form>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/tinymce.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/jquery.tinymce.min.js"></script>
<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){
		if(e.which == 13){
			e.preventDefault();
		}
	});
</script>

<?php
require_once WP_REPAIR_PLUGIN_PATH . 'html/translation-js.php';
?>

<script>
  jQuery(window).on("load", function(){
  	jQuery(".mce-container iframe").contents().find("body").css({color: '#454545'});
  });
  (function($){
  	$(document).on("wpRepairReady", function(){
  		$(".duplicate-email-settings-container").each(function(){
  			let cont = this;
  			$(this).find(".switch input").on("change", function(){
  				if($(this).is(':checked')) {
  					$(cont).find(".duplicate_email-email-input").show();
  				} else {
  					$(cont).find(".duplicate_email-email-input").hide();
  				}
  			});
  		});
  	});
  }(jQuery));
</script>