<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

require_once WP_REPAIR_PLUGIN_PATH . 'html/delivery_method_timeslots.php';

global $wp_repair_lang;

rp_handle_timeslot_form();

rp_handle_timeslot_delete();

$category_based = rp_get_static_translations_based_on_category();

$english_translations = rp_get_static_translations_of_language('English (United States)');

function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}
if(!function_exists('getTheImageURL')) {
	function getTheImageURL($str = '') {
		return WP_REPAIR_PLUGIN_URL.'assets/images/'.$str.'.gif';
	}
}
global $rpQuery;
$discounts = $rpQuery->prefix . "rs_planning_and_discount";
$d_result = $rpQuery->get_results("SELECT * FROM $discounts");

$company_location    = $rpQuery->prefix . "rs_company_location";
$location = $rpQuery->get_results("SELECT * FROM $company_location");

$location = rp_sanitize_output($location);

$localization = $rpQuery->prefix . "rs_localization";
$local_result = $rpQuery->get_row("SELECT `set_currency` FROM `$localization` LIMIT 1;");

$currency_symbol = '$';

$n_types = rp_get_sorted_noti_types();

$must_wait_options = array(
	'0.5 hour' => 30,
	'1 hour' => 60,
	'1.5 hours' => 90,
	'2 hours' => 120,
	'3 hours' => 180,
	'4 hours' => 240,
	'5 hours' => 300,
	'6 hours' => 360,
	'7 hours' => 420,
	'8 hours' => 480,
	'9 hours' => 540,
	'10 hours' => 600,
	'11 hours' => 660,
	'12 hours' => 720,
	'13 hours' => 780,
	'14 hours' => 840,
	'15 hours' => 900,
	'16 hours' => 960,
	'17 hours' => 1020,
	'18 hours' => 1080,
	'19 hours' => 1140,
	'20 hours' => 1200,
	'21 hours' => 1260,
	'22 hours' => 1320,
	'23 hours' => 1380,
	'24 hours' => 1440
);

if(!empty($local_result)) {
	$currency_symbol = $local_result->set_currency;
}

if (isset($_POST['uptsubmit'])) {

	rp_verify_csrf_token_for_simple_form('planning_discount');

    $pd_id          = $_POST['pd_id'];
    $booking_slot   = $_POST['booking_slots_length'];
    $booking_amount = $_POST['booking_amount_per_slot'];
    $combo_discount = $_POST['is_combo_discount'] ?? '';
    $amount         = $_POST['amount'];
    $max_amount     = 'None (Default)';
    $come_store     = $_POST['come_our_store'] ?? '';
    $ship_device    = $_POST['ship_device'] ?? '';
		$pickup_service    = $_POST['pickup_service'] ?? '';
		$repair_on_location    = $_POST['repair_on_location'] ?? '';
    if($ship_device == 'on'){
    	$ship_device = '1';
    }else{
    	$ship_device = '0';
    }

    if($come_store == 'on'){
    	$come_store = '1';
    }else{
    	$come_store = '0';
    }

		if($pickup_service == 'on'){
    	$pickup_service = '1';
    }else{
    	$pickup_service = '0';
    }

		if($repair_on_location == 'on'){
    	$repair_on_location = '1';
    }else{
    	$repair_on_location = '0';
    }

    if($combo_discount == 'on'){
    	$combo_discount = '1';
    }else{
    	$combo_discount = '0';
    }
    $rpQuery->query("UPDATE $discounts SET booking_slots_length = '".rp_escape_sql($booking_slot)."', booking_amount_per_slot = '".rp_escape_sql($booking_amount)."' , is_combo_discount = '".rp_escape_sql($combo_discount)."' , amount = '".rp_escape_sql($amount)."' , max_amount = '".rp_escape_sql($max_amount)."' , come_our_store = '".rp_escape_sql($come_store)."' , ship_device = '".rp_escape_sql($ship_device)."' , pickup_service = '".rp_escape_sql($pickup_service)."' , repair_on_location = '".rp_escape_sql($repair_on_location)."' WHERE pd_id = '".rp_escape_sql($pd_id)."'");

    if(isset($_POST['location_for_ship_device']) && !empty($_POST['location_for_ship_device'])) {
    	$location_for_ship_device = (int) $_POST['location_for_ship_device'];
    	if(rp_get_option('wp_repair_ship_device_location_id', FALSE) === FALSE) {
    		rp_add_option('wp_repair_ship_device_location_id', $location_for_ship_device);
    	} else {
    		rp_update_option('wp_repair_ship_device_location_id', $location_for_ship_device);
    	}
    }

    if(isset($_POST['booking_must_wait_time']) && !empty($_POST['booking_must_wait_time'])) {
    	$booking_must_wait_time = (int) $_POST['booking_must_wait_time'];
    	if(rp_get_option('wp_repair_booking_must_wait_time', FALSE) === FALSE) {
    		rp_add_option('wp_repair_booking_must_wait_time', $booking_must_wait_time);
    	} else {
    		rp_update_option('wp_repair_booking_must_wait_time', $booking_must_wait_time);
    	}
    }

	if(isset($_POST['booking_amount_per_slot_ps']) && !empty($_POST['booking_amount_per_slot_ps'])) {
		if( strpos(strtolower($_POST['booking_amount_per_slot_ps']), 'unlimited') === FALSE ) {
			$booking_amount_per_slot_ps = (int) $_POST['booking_amount_per_slot_ps'];
		} else {
			$booking_amount_per_slot_ps = 'Unlimited';
		}
    	if(rp_get_option('wp_repair_booking_amount_per_slot_ps', FALSE) === FALSE) {
    		rp_add_option('wp_repair_booking_amount_per_slot_ps', $booking_amount_per_slot_ps);
    	} else {
    		rp_update_option('wp_repair_booking_amount_per_slot_ps', $booking_amount_per_slot_ps);
    	}
    }

	if(isset($_POST['rp_combo_discount_type']) && !empty($_POST['rp_combo_discount_type'])) {
		$rp_combo_discount_type = $_POST['rp_combo_discount_type'] ?? '';
		if( !in_array( $rp_combo_discount_type, array('Fixed', 'Percentage') ) ) {
			$rp_combo_discount_type = 'Fixed';
		}
    	if(rp_get_option('rp_combo_discount_type', FALSE) === FALSE) {
    		rp_add_option('rp_combo_discount_type', $rp_combo_discount_type);
    	} else {
    		rp_update_option('rp_combo_discount_type', $rp_combo_discount_type);
    	}
    }

	if(isset($_POST['booking_must_wait_time_ps']) && !empty($_POST['booking_must_wait_time_ps'])) {
    	$booking_must_wait_time_ps = (int) $_POST['booking_must_wait_time_ps'];
    	if(rp_get_option('wp_repair_booking_must_wait_time_ps', FALSE) === FALSE) {
    		rp_add_option('wp_repair_booking_must_wait_time_ps', $booking_must_wait_time_ps);
    	} else {
    		rp_update_option('wp_repair_booking_must_wait_time_ps', $booking_must_wait_time_ps);
    	}
    }

	if(isset($_POST['booking_must_wait_time_rol']) && !empty($_POST['booking_must_wait_time_rol'])) {
    	$booking_must_wait_time_rol = (int) $_POST['booking_must_wait_time_rol'];
    	if(rp_get_option('wp_repair_booking_must_wait_time_rol', FALSE) === FALSE) {
    		rp_add_option('wp_repair_booking_must_wait_time_rol', $booking_must_wait_time_rol);
    	} else {
    		rp_update_option('wp_repair_booking_must_wait_time_rol', $booking_must_wait_time_rol);
    	}
    }

	if(isset($_POST['booking_amount_per_slot_rol']) && !empty($_POST['booking_amount_per_slot_rol'])) {
		if( strpos(strtolower($_POST['booking_amount_per_slot_rol']), 'unlimited') === FALSE ) {
			$booking_amount_per_slot_rol = (int) $_POST['booking_amount_per_slot_rol'];
		} else {
			$booking_amount_per_slot_rol = 'Unlimited';
		}
    	if(rp_get_option('wp_repair_booking_amount_per_slot_rol', FALSE) === FALSE) {
    		rp_add_option('wp_repair_booking_amount_per_slot_rol', $booking_amount_per_slot_rol);
    	} else {
    		rp_update_option('wp_repair_booking_amount_per_slot_rol', $booking_amount_per_slot_rol);
    	}
    }

	$days = array(
		'monday',
		'tuesday',
		'wednesday',
		'thursday',
		'friday',
		'saturday',
		'sunday'
	);

	foreach(array('pickup_service', 'repair_on_location') as $arrItem) {
		$values = array();
		foreach($days as $day_name) {
			if( isset($_POST[$arrItem.'_available_on_'.$day_name]) && !empty($_POST[$arrItem.'_available_on_'.$day_name]) ) {
				$values[$day_name] = 1;
			} else {
				$values[$day_name] = 0;
			}
		}
		if(rp_get_option('rp_'.$arrItem.'_available_days', FALSE) === FALSE) {
			rp_add_option('rp_'.$arrItem.'_available_days', json_encode($values));
		} else {
			rp_update_option('rp_'.$arrItem.'_available_days', json_encode($values));
		}
	}

	$delivery_methods = array(
		'come_our_store',
		'ship_device',
		'pickup_service',
		'repair_on_location'
	);

	foreach( $delivery_methods as $delivery_method ) {

		$dm_cost_key = 'rp_dm_cost_' . $delivery_method;

		if( isset( $_POST[ $dm_cost_key ] ) ) {
			if( empty( $_POST[ $dm_cost_key ] ) ) {
				$dm_cost = '';
			} else {
				$dm_cost = (int) $_POST[ $dm_cost_key ];
			}
			if(rp_get_option($dm_cost_key, FALSE) === FALSE) {
				rp_add_option($dm_cost_key, $dm_cost);
			} else {
				rp_update_option($dm_cost_key, $dm_cost);
			}
		}

	}

	$dm_sort = $_POST['dm_sort'] ?? array();

	if( !empty( $dm_sort ) && is_array( $dm_sort ) ) {

		if( rp_get_option('rp_get_sorted_delivery_methods', FALSE) === FALSE ) {
			rp_add_option('rp_get_sorted_delivery_methods', json_encode($dm_sort));
		} else {
			rp_update_option('rp_get_sorted_delivery_methods', json_encode($dm_sort));
		}

	}

	$aab_status = $_POST['is_active3'] ?? '0';
	if( $aab_status != '1' ) {
		$aab_status = '0';
	}
	$notification_types = $rpQuery->prefix . "rs_notification_types";
	$rpQuery->query("UPDATE $notification_types SET is_active='".rp_escape_sql($aab_status)."' WHERE noti_type_id='3'");

    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=planning_discount');</script>";
}
?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.wp-general-info{
		padding: 15px;
		font-size: 13px;
	}
	.which-location-to-use {
		width: 100%;
		margin-left: 0px;
	}
	@media (max-width: 540px) {
		.which-location-to-use {
			width: 261px;
		}
	}
	@media (max-width: 420px) {
		.which-location-to-use {
			margin-left: 0px;
		}
	}
	@media (max-width: 370px) {
		.which-location-to-use {
			width: 100%;
		}
	}
</style>
<style type="text/css">
	.va-full-width-modal-main.trans-modal .wp-repair-input-group {
		margin-top: 10px;
	}
	.va-full-width-modal-main {
		max-width: 475px;
		max-height: 80%;
		overflow-y: auto;
	}
	.va-full-width-modal .flag-img {
		width: 36px;
		display: inline-block;
		position: relative;
		top: 9px;
	}
	.va-full-width-modal .input-cont {
		width: calc(100% - 40px);
		display: inline-block;
	}
	.va-full-width-modal .va-button.va-submit {
		margin-top: 12px;
		display: inline-table;
		float: right;
		margin-bottom: 15px;
		position: relative;
		right: 3px;
		min-width: 80px;
	}
	.globe-icon-translation {
		cursor: pointer;
		width: calc(100% - 2px);
		height: 42px;
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
	}

	.clearfix {
		display: block;
	}

	.clearfix::after {
		content: "";
		clear: both;
		display: table;
	}
	.globe-icon-i {
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
		right: 0px;
		line-height: 0em;
		background: #fff;
		padding: 0px 8px;
	}
.mce-panel.mce-floatpanel .mce-widget.mce-btn.mce-primary.mce-abs-layout-item.mce-first.mce-btn-has-text {
	background-color: #2d8ac7;
}
.mce-btn {
	background-color: #fff;
}
.mce-panel {
	background-color: #fff;
}
.wp-repair-input-group > .mce-panel.mce-container {
	border-width: 2px;
		border-radius: 8px;
		border: 2px solid #cfcfcf !important;
		box-sizing: border-box;
		padding: 0px 2px;
	transition: border-color 0.3s;
}
.mce-path {
	display: none;
}
.mce-statusbar.mce-container {
	border: 0px;
}
.mce-container-body .mce-resizehandle {
	right: 2px;
		bottom: 2px;
}
.mce-container-body.mce-stack-layout {
	padding: 1px;
}
.wp-repair-input-group label {
	z-index: 10;
}
.wp-repair-input-group > .mce-panel.mce-container:hover {
	border: 2px solid #2781c7 !important;
	box-shadow: none;
	outline: 0;
}
.mce-container,
.mce-content-body,
.mce-menubar .mce-menubtn button span,
.mce-menu-item,
.mce-menu-item .mce-ico, .mce-menu-item .mce-text  {
	color: #454545;
}
div.mce-edit-area {
	min-height: 200px;
}
div.mce-edit-area iframe {
	min-height: 200px;
}
/*.mce-container.mce-menubar.mce-toolbar {
	display: none;
}*/
iframe #tinymce {
	background-color: #000;
}
.wp-repair-col-4.pdf-offer.main-section.clearfix {
	padding-bottom: 15px;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	width: 300px;
}
.location-table {
	margin: 0px;
	padding: 15px;
	margin-bottom: 20px;
}
.location-table .ractions-td .switch {
	float: right;
}

.location-table .details-container .wp-repair-inner-col.section-1 {
	float: left;
	width: 55%;
	box-sizing: border-box;
}
.location-table .details-container .wp-repair-inner-col.section-2 {
	float: left;
	width: 45%;
	padding: 0px 20px;
	padding-top: 8px;
	box-sizing: border-box;
}

.location-table td.shortcode-heading {
	font-size: 9px;
	font-weight: 700;
	padding: 3px 0px;
	color: #61666b;
}

.location-table td.actual-shortcode {
	font-size: 9px;
	font-weight: 600;
	padding: 3px 0px;
	color: #61666b;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	font-size: 14px;
}

.table-responsive.location-table button.plus-icon.see-more {
	text-align: left;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	width: 250px;
	vertical-align: middle;
	display: inline-table;
}
.table-responsive.location-table button.plus-icon.see-more .dropicon {
	vertical-align: middle;
}

@media(max-width: 1140px) {
	.location-table .details-container .wp-repair-inner-col.section-1 {
		width: 100%;
	}
	.location-table .details-container .wp-repair-inner-col.section-2 {
		width: 100%;
		padding: 0px;
		padding-top: 8px;
	}
}

@media(max-width: 500px) {
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 200px;
	}
}


@media(max-width: 420px) {
	.table-responsive.location-table .wp-repair-input-group {
	    left: 0px;
	}
	.apply-tax-rate .td.text {
		width: 70%;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 140px;
	}
	.wp-repair-input-group input {
		width: 99%;
	}
}
@media(max-width: 370px) {
	.location-table {
		padding: 10px;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 100px;
		font-size: 13px;
	}
}
/* Customised Modal */


.va-modal-container {
	position: fixed;
	bottom: 85px;
	left: 30px;
	background: rgba(0,0,0,0.3);
	z-index: 99999;
	width: 300px;
}

.va-modal-main {
	border-radius: 8px;
	width: 100%;
	max-width: 450px;
	height: auto;
	background: #fff;
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	box-shadow: 0px 0px 5px rgb(0 0 0 / 30%);
}

.va-modal-container.unsaved .va-modal-main {
	background: #a81019;
}

.va-modal-container.saved .va-modal-main {
	background: var(--west--wales--maincolor);
}

.va-modal-inner {
	padding: 15px;
}

.va-modal-inner p {
	font-size: 18px;
	display: table;
	margin: 0px;
	color: var(--west--wales--maincolor);
	max-width: 240px;
	font-weight: 400;
}

.va-modal-container.unsaved .va-modal-inner p,
.va-modal-container.saved .va-modal-inner p {
	color: #fff;
}

.va-modal-inner a {
	display: table;
	margin-top: 8px;
}

.va-modal-container .va-close-modal,
.va-full-width-modal .va-close-modal {
	position: absolute;
	top: 8px;
	right: 8px;
	background: #efefef;
	padding: 8px;
	line-height: 1em;
	cursor: pointer;
	border: 1px solid #aaaa;
	background: #efefef;
	border-radius: 4px;
	outline: 0 !important;
	box-shadow: unset !important;
	transition: all 0.3s;
}

.va-modal-container .va-close-modal:hover,
.va-modal-container .va-close-modal:active,
.va-modal-container .va-close-modal:focus,
.va-full-width-modal .va-close-modal:hover,
.va-full-width-modal .va-close-modal:active,
.va-full-width-modal .va-close-modal:focus  {
	background: #fafafa;
}

.va-full-width-modal .va-modal-title {
	font-weight: 400;
    max-width: 93%;
    font-size: 18px;
    margin-top: 0px;
    margin-bottom: 10px;
    color: #1275c2;
}

.va-full-width-modal .va-modal-title b {
	font-weight: 700;
}

.va-modal-container.saved .va-modal-inner a:hover,
.va-modal-container.saved .va-modal-inner a:active,
.va-modal-container.saved .va-modal-inner a:focus {
	background: #fafafa;
	color: var(--west--wales--maincolor);
}

.va-container.property-details .va-content-box .call-to-action .va-button-default {
	background: #fafafa;
	border: 1px solid #fafafa;
	color: var(--west--wales--maincolor);
	font-weight: 400;
}

.va-container.property-details .va-content-box .call-to-action .va-button-default:hover,
.va-container.property-details .va-content-box .call-to-action .va-button-default:active,
.va-container.property-details .va-content-box .call-to-action .va-button-default:focus {
	background: #fff;
	color: var(--west--wales--maincolor);
	border: 1px solid #fafafa;
}

.va-container.property-details .va-content-box .call-to-action .va-button.va-fav-icon-details-page.prop-already-saved {
	color: #a81019;
	background: rgb(168 16 25 / 10%);
}

.va-container.property-details .va-content-box .call-to-action .va-button.va-fav-icon-details-page .fa-spinner {
	font-size: 20px;
}

.va-container .set-alert-buttons {
	margin: 0px;
}

.va-col-md-12.alert-btn-cols {
	padding: 15px;
}

.va-full-width-modal {
	position: fixed;
	top: 0px;
	left: 0px;
	width: 100%;
	height: 100%;
	z-index: 10000;
	background: rgba(0,0,0,0.3);
}

.va-full-width-modal-main {
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	background: #fff;
	box-shadow: 0px 0px 5px rgb(0 0 0 / 30%);
	width: 100%;
	max-width: 450px;
	border-radius: 8px;
}

.va-full-width-modal-main p {
	font-size: 14px;
}

.va-full-width-modal-inner {
	padding: 15px; 
}

.va-full-width-modal .va-form-group label {
	display: table;
}

.va-full-width-modal .va-form-group input {
	width: 100%;
	border-radius: 5px;
	display: table;
	margin-bottom: 8px;
}

.va-button.va-submit,
.va-button.va-submit:hover,
.va-button.va-submit:active,
.va-button.va-submit:focus {
	background: #1275c2;
	color: #fff;
	font-weight: 500;
	border: 1px solid #1275c2;
	border-radius: 5px;
	padding: 8px 15px;
	cursor: pointer;
	font-size: 14px;
}

button.va-button-primary,
button.va-button-primary:hover,
button.va-button-primary:active,
button.va-button-primary:focus {
	border-color: #1275c2 !important;
	background: #1275c2 !important;
	background-color: #1275c2 !important;
}

.va-modal-title.blue-color {
	color:  #1275c2 !important;
	font-weight: 500;
}

.more-details .wp-repair-repair-card {
	margin-bottom: 10px;
}

.more-details select {
	max-width: 100%;
}

.tax-fields.automatically-approve-booking {
	margin-bottom: 50px !important;
}

.repair-list-sort {
	display: table;
    cursor: pointer;
    position: relative;
    top: 0px;
    float: left;
    margin-left: 4px;
    border: 1px solid #adadad;
    padding: 0px;
    color: #646464;
    border-radius: 5px;
		margin-right: 0px;
}

.repair-list-sort i {
	display: table;
	line-height: 12px;
	padding: 0px 4px 0px 4px;
	font-size: 16px;
	border-spacing: 0;
	cursor: pointer;
}

.repair-list-sort i.fa-caret-up {
	padding-top: 1px;
}

.repair-list-sort i:hover {
    color: #1275c2;
}

.location-table {
	background: #fff;
	transition: none !important;
}

</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('planning_discount'); ?>
					<form method="post" action="">
					<?php
					rp_csrf_token_input_field('planning_discount');
					?>
					<div class="wp-repair-col-8 bg-with-border">
						<div class="wp-repair-col-4 main-section pb0-1210">
							<div class="wp-repair-main-section-heading">
								<h2>
									<span class="bold">Combo</span><span class="light">Discount<span class="tm">™</span></span>
								</h2>
								<p class="more-info">The gamechanger in your checkout</p>
								<input type="hidden" name="pd_id" value="<?php echo $d_result[0]->pd_id?>">
							</div>
							<div class="tax-fields">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  	<input type="checkbox" <?php if($d_result[0]->is_combo_discount == '1'){echo "checked";}?> name="is_combo_discount" id="is_combo_discount">
										  	<span class="slider round"></span>
										</label>
									</div>
									<div class="td text">
										<span class="text">Apply Combo Discount to Every Additional Repair</span>
									</div>
								</div>
							</div>
							<p class="company-logo-theme-color">Discount Type</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="rp_combo_discount_type" required>
									<?php

									$options_arr = array('Fixed', 'Percentage');
									$selected_opt = trim(rp_get_option('rp_combo_discount_type', 'Fixed'));
									$rp_combo_discount_type = $selected_opt;

									if(strpos(strtolower($selected_opt), 'fixed') !== FALSE) {
										$selected_opt = 'Fixed';
									}

									if(empty($selected_opt)) {
										$selected_opt = 'Fixed';
									}

									foreach ($options_arr as $_opt) {
										if($_opt == $selected_opt) {
											echo '<option selected="selected" value="'.$_opt.'">'.$_opt.'</option>';
										} else {
											echo '<option value="'.$_opt.'">'.$_opt.'</option>';
										}
									}

									?>
								</select>
							</span>
						</div>
						<div class="wp-repair-col-4 main-section pt0-1210">
							<div class="wp-repair-main-section-heading hide-below-1210" style="visibility:hidden;">
								<h2>
									<span class="bold">Combo</span><span class="light">Discount<span class="tm">™</span></span>
								</h2>
								<p class="more-info">The gamechanger in your checkout</p>
								<input type="hidden" name="pd_id" value="<?php echo $d_result[0]->pd_id?>">
							</div>
							<div class="wp-repair-tax-indicator">
								<p class="company-logo-theme-color">Amount</p>
								<div class="number-input">
									<div class="group">
										<input min="0" value="<?php echo $d_result[0]->amount?>" max="100" type="number" name="amount" required>
										<?php
										if( $rp_combo_discount_type == 'Fixed' ) {
											?>
											<span class="icon-percent"><?php echo $currency_symbol; ?></span>
											<?php
										} else {
											?>
											<span class="icon-percent">%</span>
											<?php
										}
										?>
									</div>
									<button type="button" class="up"><i class="fas fa-chevron-up"></i></button>
									<button type="button" class="down"><i class="fas fa-chevron-down"></i></button>
								</div>
							</div>
						</div>
						<div class="wp-repair-full">
							<div class="wp-repair-main-section-heading" style="margin-bottom: 20px;">
								<h2>
									<span class="bold">Delivery</span>
									<span class="light">Methods</span>
								</h2>
								<p class="more-info">We've already optmized the delivery methods for you</p>
							</div>
							<div class="tax-fields first automatically-approve-booking" style="padding-top:5px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
											<input type="hidden" name="is_active3" value="0">
											<input type="checkbox" name="is_active3" <?php if($n_types[2]->is_active == '1'){echo 'checked';}?> value="1">
											<span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Automatically Approve Bookings</span>
									</div>
								</div>
							</div>
							<div class="orderingdm-container">
							<?php
							$sorted_methods = rp_get_option('rp_get_sorted_delivery_methods', json_encode(array(
								'come_our_store',
								'ship_device',
								'pickup_service',
								'repair_on_location'
							)));
							$sorted_methods = json_decode($sorted_methods);
							$sorted_category_based = array();
							$allowed = array();
							foreach( $sorted_methods as $theMethod ) {
								if( $theMethod == 'come_our_store' ) {
									$theMethod = 'Come By Our Store';
								}
								if($theMethod == 'ship_device') {
									$theMethod = 'Ship Device';
								}
								if($theMethod == 'pickup_service') {
									$theMethod = 'Pickup Service';
								}
								if($theMethod == 'repair_on_location') {
									$theMethod = 'Repair on your location';
								}
								$allowed[] = $theMethod;
							}
							foreach($allowed as $category) {
								if( isset( $category_based[$category] ) ) {
									$sorted_category_based[$category] = $category_based[$category];
								}
							}
							$category_based = $sorted_category_based;
							foreach($category_based as $category => $keys) {
								if( !in_array($category, $allowed) ) {
									continue;
								}
								if( $category == 'Come By Our Store' ) {
									$delivery_method = 'come_our_store';
								} else if( $category == 'Ship Device' ) {
									$delivery_method = 'ship_device';
								} else if( $category == 'Pickup Service' ) {
									$delivery_method = 'pickup_service';
								} else if( $category == 'Repair on your location' ) {
									$delivery_method = 'repair_on_location';
								} else {
									$delivery_method = '';
								}
							?>
								<div class="table-responsive orderingdm ui-state-default location-table">
										<input type="hidden" name="dm_sort[]" value="<?php echo $delivery_method; ?>">
										<table class="table">
											<tbody>
												<tr class="closed">
													<td style="width: 35px;">
													<span class="repair-list-sort ">
														<i class="fas fa-caret-up ui-sortable-handle" data-which="up"></i>
														<i class="fas fa-caret-down ui-sortable-handle" data-which="down"></i>
													</span>
													</td>
													<td>
														<button type="button" class="plus-icon see-more">
															<span class="dropicon">
																<i class="fas fa-plus"></i>
															</span>
															<span class="text"><?php echo $category; ?></span>
														</button>
													</td>
													<td class="ractions-td">
														<label class="switch">
															<input type="checkbox" <?php if($d_result[0]->{$delivery_method} == '1'){echo "checked";}?> name="<?php echo $delivery_method; ?>" id="<?php echo $delivery_method; ?>" class="delivery_method">
															<span class="slider round"></span>
														</label>
													</td>
												</tr>
												<tr class="more-details">
													<td colspan="7">
														<div class="details-container">
															<div class="wp-repair-inner-col">
																<?php
																	foreach($keys as $lang_key) {
																		$lang_value = $english_translations[$lang_key] ?? '';
																		$lang_value_translated = $wp_repair_lang[$lang_key] ?? '';

																		$lang_value_translated = str_replace('&quot;', '"', $lang_value_translated);

																		// limit $lang_value to only 8 words and add ... if more than 8 words
																		$words = explode(' ', $lang_value);
																		if( count($words) > 8 ) {
																			$words = array_slice($words, 0, 8);
																			$lang_value = implode(' ', $words) . '...';
																		}

																		if( $lang_value == '$ShipDeviceAddress$' ) {
																			$lang_value = 'Ship Device Terms';
																		}

																		?>
																		<div class="wp-repair-input-group">
																			<label><?php echo $lang_value; ?></label>
																			<input type="text" class="user-info" name="laltname[]" value="<?php echo htmlspecialchars($lang_value_translated);?>">
																			<div data-lang-key="<?php echo $lang_key; ?>" class="globe-icon-translation clearfix">
																				<div class="globe-icon-i">
																					<i class="fas fa-globe"></i>
																				</div>
																			</div>
																		</div>
																		<?php
																	}
																?>
																<?php
																if( $delivery_method == 'pickup_service' ) {
																	rp_render_timeslot_form('pickup_service');
																	?>
						<div style="margin-top: 10px;">
							<p class="company-logo-theme-color">Max amount of booking per slot</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_amount_per_slot_ps" required>
									<?php

									$options_arr = array('1','2','3','4','5','Unlimited');
									$selected_opt = trim(rp_get_option('wp_repair_booking_amount_per_slot_ps', 'Unlimited'));

									if(strpos(strtolower($selected_opt), 'unlimited') !== FALSE) {
										$selected_opt = 'Unlimited';
									}

									if(empty($selected_opt)) {
										$selected_opt = 'Unlimited';
									}

									foreach ($options_arr as $_opt) {
										if($_opt == $selected_opt) {
											echo '<option selected="selected" value="'.$_opt.'">'.$_opt.'</option>';
										} else {
											echo '<option value="'.$_opt.'">'.$_opt.'</option>';
										}
									}

									?>
								</select>
							</span>
							<p class="company-logo-theme-color">Block users from making appointment the first:</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_must_wait_time_ps" required>
									<?php
									$booking_must_wait_time_ps = (int) rp_get_option('wp_repair_booking_must_wait_time_ps', 60);
									
									foreach ($must_wait_options as $mwo_key => $mwo_value) {
										if($mwo_value === $booking_must_wait_time_ps) {
											?>
											<option selected="selected" value="<?php echo $mwo_value; ?>"><?php echo $mwo_key; ?></option>
											<?php
										} else {
											?>
											<option value="<?php echo $mwo_value; ?>"><?php echo $mwo_key; ?></option>
											<?php
										}
									}
									?>
								</select>
							</span>
						</div>
																	<?php
																}
																?>
																<?php
																if( $delivery_method == 'repair_on_location' ) {
																	rp_render_timeslot_form('repair_on_location');
																	?>
						<div style="margin-top: 10px;">
							<p class="company-logo-theme-color">Max amount of booking per slot</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_amount_per_slot_rol" required>
									<?php

									$options_arr = array('1','2','3','4','5','Unlimited');
									$selected_opt = trim(rp_get_option('wp_repair_booking_amount_per_slot_rol', 'Unlimited'));

									if(strpos(strtolower($selected_opt), 'unlimited') !== FALSE) {
										$selected_opt = 'Unlimited';
									}

									if(empty($selected_opt)) {
										$selected_opt = 'Unlimited';
									}

									foreach ($options_arr as $_opt) {
										if($_opt == $selected_opt) {
											echo '<option selected="selected" value="'.$_opt.'">'.$_opt.'</option>';
										} else {
											echo '<option value="'.$_opt.'">'.$_opt.'</option>';
										}
									}

									?>
								</select>
							</span>
							<p class="company-logo-theme-color">Block users from making appointment the first:</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_must_wait_time_rol" required>
									<?php
									$booking_must_wait_time_rol = (int) rp_get_option('wp_repair_booking_must_wait_time_rol', 60);
									foreach ($must_wait_options as $mwo_key => $mwo_value) {
										if($mwo_value === $booking_must_wait_time_rol) {
											?>
											<option selected="selected" value="<?php echo $mwo_value; ?>"><?php echo $mwo_key; ?></option>
											<?php
										} else {
											?>
											<option value="<?php echo $mwo_value; ?>"><?php echo $mwo_key; ?></option>
											<?php
										}
									}
									?>
								</select>
							</span>
						</div>
																	<?php
																}
																?>
																<?php
																if( $delivery_method == 'come_our_store' ) {
																	?>
						<div style="margin-top: 10px;">
							<p class="company-logo-theme-color">Length of Booking Slot</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_slots_length" required>
									<option value="<?php echo $d_result[0]->booking_slots_length;?>" hidden><?php echo $d_result[0]->booking_slots_length.' Minutes';?></option>
									<option value="20">20 Minutes</option>
									<option value="30">30 Minutes</option>
									<option value="45">45 Minutes</option>
									<option value="60">60 Minutes</option>
								</select>
							</span>
							<p class="company-logo-theme-color">Max amount of booking per slot</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_amount_per_slot" required>
									<?php

									$options_arr = array('1','2','3','4','5','Unlimited');
									$selected_opt = trim($d_result[0]->booking_amount_per_slot);

									if(strpos(strtolower($selected_opt), 'unlimited') !== FALSE) {
										$selected_opt = 'Unlimited';
									}

									if(empty($selected_opt)) {
										$selected_opt = 'Unlimited';
									}

									foreach ($options_arr as $_opt) {
										if($_opt == $selected_opt) {
											echo '<option selected="selected" value="'.$_opt.'">'.$_opt.'</option>';
										} else {
											echo '<option value="'.$_opt.'">'.$_opt.'</option>';
										}
									}

									?>
								</select>
							</span>
							<p class="company-logo-theme-color">Block users from making appointment the first:</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="booking_must_wait_time" required>
									<?php
									$booking_must_wait_time = (int) rp_get_option('wp_repair_booking_must_wait_time', 60);
									foreach ($must_wait_options as $mwo_key => $mwo_value) {
										if($mwo_value === $booking_must_wait_time) {
											?>
											<option selected="selected" value="<?php echo $mwo_value; ?>"><?php echo $mwo_key; ?></option>
											<?php
										} else {
											?>
											<option value="<?php echo $mwo_value; ?>"><?php echo $mwo_key; ?></option>
											<?php
										}
									}
									?>
								</select>
							</span>
						</div>
																	<?php
																}
																?>
																<?php
																if( $delivery_method == 'ship_device' ) {
																	?>
								<div style="margin-top: 10px;">
									<div class="which-location-to-use">
										<p class="company-logo-theme-color">Select A Location for Ship Device Method</p>
										<span class="wp-repair-repair-card">
											<select class="coupons_select" name="location_for_ship_device" required>
												<?php
												$shipDeviceLocation = rp_get_option('wp_repair_ship_device_location_id', '');
												foreach ($location as $loc) {
													if($loc->location_id == $shipDeviceLocation) {
														?>
														<option selected="selected" value="<?php echo $loc->location_id; ?>"><?php echo $loc->location_name; ?></option>
														<?php
													} else {
														?>
														<option value="<?php echo $loc->location_id; ?>"><?php echo $loc->location_name; ?></option>
														<?php
													}
												}
												?>
											</select>
										</span>
									</div>
								</div>
																	<?php
																}
																$dm_cost_key = 'rp_dm_cost_'. $delivery_method;
																?>
																<div class="wp-repair-input-group">
																	<label>Additional Cost</label>
																	<input type="number" class="user-info" name="<?php echo $dm_cost_key; ?>" value="<?php echo rp_get_option($dm_cost_key, ''); ?>">
																</div>
															</div>
														</div>
													</td>
												</tr>
											</tbody>
										</table>
									</div>
								<?php
								}
								?>
							</div>
							<div class="wp-repair-inner-col section-1" style="float: right;padding-top: 20px;">
								<div class="sec-3">
									<button type="submit" id="uptsubmit" name="uptsubmit" class="wp-general-info">Save All Settings</button> 
								</div>
							</div>
						</div>
					</div>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>

<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/tinymce.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/jquery.tinymce.min.js"></script>
<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){
		if(e.which == 13){
			e.preventDefault();
		}
	});
</script>

<?php
require_once WP_REPAIR_PLUGIN_PATH . 'html/translation-js.php';
?>
<script type="text/javascript">
	(function(window,document,$,undefined){
		jQuery(document).on('change', 'select[name="rp_combo_discount_type"]', function(){
			let val = $(this).val();
			if( val == 'Fixed' ) {
				$(".number-input .icon-percent").html('<?php echo $currency_symbol; ?>');
			} else {
				$(".number-input .icon-percent").html('%');
			}
		});
		jQuery(document).on("wpRepairReady", function(){
			jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
				var parentCont = this;
			    jQuery(this).parent().on("click", function(){
			    	handleShowingOptions(this);
			    });
			    jQuery(this).find("li").on("click", function(){
			    	handleTheSelect(this, parentCont);
			    });
			});
			function closeAllOpenedSelectBoxes() {
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			}
			isCurrentElClicked(['.wp-repair-repair-card'], function(){
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			});
			window.canShowTheOptions = true;
			function canShowTheOptions() {
				if(window.canShowTheOptions === false) {
					window.canShowTheOptions = true;
					return false;
				}
				return true;
			}
			function isCurrentElClicked(el, func) {
				$("body").click(function(event) {
					result = false;
					el.forEach(function(ell){
						if(($(event.target).is(ell) || $(event.target).parents(ell).length !== 0)) {
							result = true;
						}
					});
					if(result === false) {
						func();
					}
				});
			}
			function handleShowingOptions(currentEl) {
				if(canShowTheOptions() === true) {
					jQuery(".wp-repair-repair-card").each(function(){
						if(this !== currentEl) {
							$(this).find(".more-card-options").hide();
						}
					});
					jQuery(currentEl).toggleClass('active');
					jQuery(currentEl).find(".more-card-options").toggle();
				}
			}
			function handleTheDeselect(currentEl, parentCont) {
				$(parentCont).parent().removeClass("active");
				$(parentCont).parent().find('.wp-repair-cselected-item i').remove();
				$(parentCont).parent().find('.wp-repair-cselected-item').append('<i class="fas fa-chevron-down"></i>');
				$(parentCont).parent().find('.text-all .selected-text').remove();
				$(parentCont).hide();
				$(parentCont).find("li").each(function(){
					$(this).removeClass("active");
				});
				window.canShowTheOptions = false;
			}
			function handleTheSelect(currentEl, parentCont) {
				var val = $(currentEl).find(".name").html();
				$(parentCont).parent().find('.wp-repair-cselected-item .name').html(val);
			}
		});
	}(window,document,jQuery));
</script>

<script type="text/javascript">
	(function(window,document,$,undefined){
		window.wpRepairInputMouseIsDown = false;
		window.currentTimeoutCache;

		// find width of
		let widthOfText = $(".icon-percent").width();

		widthOfText = (widthOfText - 15);

		if(widthOfText > 0) {
			$(".wp-repair-tax-indicator .number-input").css({'width': (110+widthOfText)+'px'});
		}


		$(document).on('mousedown mouseup', function(){
			if('wpRepairInputMouseIsDown_UP_BUTTON' in window && window.wpRepairInputMouseIsDown_UP_BUTTON && window.wpRepairInputMouseIsDown_UP_BUTTON !== null) {
				stopIncreasingTheNumber($(window.wpRepairInputMouseIsDown_UP_BUTTON).parent());
				window.wpRepairInputMouseIsDown_UP_BUTTON = null;
			}
			if('wpRepairInputMouseIsDown_DOWN_BUTTON' in window && window.wpRepairInputMouseIsDown_DOWN_BUTTON && window.wpRepairInputMouseIsDown_DOWN_BUTTON !== null) {
				stopIncreasingTheNumber($(window.wpRepairInputMouseIsDown_DOWN_BUTTON).parent());
				window.wpRepairInputMouseIsDown_DOWN_BUTTON = null;
			}
		});

		$(document).on("wpRepairReady", function(){

			$(".number-input").each(function(){
				$(this).find("button.up, button.down").on('click',function(e){
					e.preventDefault();
				});
			});

			$(".number-input").each(function(){
				$(this).find("button.up").on("mousedown touchstart", function(){
					let button_up = $(this);
					var numInput = $(this).parent();
					window.wpRepairInputMouseIsDown = true;
					window.currentTimeoutCache = window.setTimeout(function(){
						if(window.wpRepairInputMouseIsDown === true) {
							window.wpRepairInputMouseIsDown_UP_BUTTON = button_up;
							keepIncreasingTheNumber(numInput);
						}
					},200);
				});
				$(this).find("button.up").on("mouseup touchend", function(){
					stopIncreasingTheNumber($(this).parent());
				});
			});
			$(".number-input").each(function(){
				$(this).find("button.down").on("mousedown touchstart", function(){
					let button_down = $(this);
					var numInput = $(this).parent();
					window.wpRepairInputMouseIsDown = true;
					window.currentTimeoutCache = window.setTimeout(function(){
						if(window.wpRepairInputMouseIsDown === true) {
							window.wpRepairInputMouseIsDown_DOWN_BUTTON = button_down;
							keepDecreasingTheNumber(numInput);
						}
					},200);
				});
				$(this).find("button.down").on("mouseup touchend", function(){
					stopDecreasingTheNumber($(this).parent());
				});
			});
		});
		function stopIncreasingTheNumber(el) {
			incrementNumNow(el);
			window.clearTimeout(window.currentTimeoutCache);
			window.wpRepairInputMouseIsDown = false;
		}
		function stopDecreasingTheNumber(el) {
			DeIncrementNumNow(el);
			window.clearTimeout(window.currentTimeoutCache);
			window.wpRepairInputMouseIsDown = false;
		}
		function keepDecreasingTheNumber(el) {
			window.setTimeout(function(){
				if(window.wpRepairInputMouseIsDown === true) {
					DeIncrementNumNow(el);
					keepDecreasingTheNumber(el);
				}
			}, 120);
		}
		function keepIncreasingTheNumber(el) {
			window.setTimeout(function(){
				if(window.wpRepairInputMouseIsDown === true) {
					incrementNumNow(el);
					keepIncreasingTheNumber(el);
				}
			}, 120);
		}
		function DeIncrementNumNow(el) {
			var currentVal = $(el).find("input").val();
			if(!isNaN(parseFloat(currentVal))) {
				currentVal = parseFloat(currentVal);
			} else {
				currentVal = 0;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			currentVal = parseFloat(currentVal);
			currentVal = currentVal-1;
			if(currentVal > 100) {
				currentVal = 100;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			$(el).find("input").val(currentVal).change();
		}
		function incrementNumNow(el) {
			var currentVal = $(el).find("input").val();
			if(!isNaN(parseFloat(currentVal))) {
				currentVal = parseFloat(currentVal);
			} else {
				currentVal = 0;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			currentVal = parseFloat(currentVal);
			currentVal = currentVal+1;
			if(currentVal > 100) {
				currentVal = 100;
			}
			if(currentVal < 0) {
				currentVal = 0;
			}
			$(el).find("input").val(currentVal).change();
		}
	}(window,document,jQuery));
</script>
<script>
	jQuery(document).on('ready', function(){
		jQuery('.available-on-days input').on('change', function(){
			if(jQuery(this).is(':checked')) {
				jQuery(this).parent().parent().addClass('selected');
			} else {
				jQuery(this).parent().parent().removeClass('selected');
			}
		});
	});
	jQuery(document).on('click', 'button.add_timing_btn', function(e){
		e.preventDefault();
		// create a new form and submit it
		var form = jQuery('<form id="rp_unique_track_id" style="display:none;"></form>');
		form.attr("method", "post");
		form.attr("action", "");
		let parent = jQuery(this).parents('.wp-repair-inner-col');
		let opening_time = jQuery(parent).find('select[name="opening_time"]');
		let opening_time_am_pm = jQuery(parent).find('select[name="opening_time_am_pm"]');
		let closing_time = jQuery(parent).find('select[name="closing_time"]');
		let closing_time_am_pm = jQuery(parent).find('select[name="closing_time_am_pm"]');
		let rp_csrf_token = jQuery(parent).find('input[name="rp_csrf_token"]');
		let method = jQuery(parent).find('input[name="method"]');

		// check if opening time and closing time is empty
		if(opening_time.val() == '' || closing_time.val() == '') {
			alert('Please select opening and closing time');
			return false;
		}

		form.append('<input type="hidden" name="opening_time" value="'+opening_time.val()+'">');
		form.append('<input type="hidden" name="opening_time_am_pm" value="'+opening_time_am_pm.val()+'">');
		form.append('<input type="hidden" name="closing_time" value="'+closing_time.val()+'">');
		form.append('<input type="hidden" name="closing_time_am_pm" value="'+closing_time_am_pm.val()+'">');
		form.append('<input type="hidden" name="rp_csrf_token" value="'+rp_csrf_token.val()+'">');
		form.append('<input type="hidden" name="method" value="'+method.val()+'">');
		form.append('<input type="hidden" name="form_type" value="add_delivery_timeslot">');
		jQuery('body').append(form);
		form.submit();
	});
	jQuery(document).on('click', 'button.delete_special_timing', function(e){
		e.preventDefault();
		// create a new form and submit it

		var form = jQuery('<form id="rp_unique_track_delete_id" style="display:none;"></form>');
		form.attr("method", "post");
		form.attr("action", "");
		let parent = jQuery(this).parents('.td-2');
		let delete_timeslot_id = jQuery(parent).find('input[name="delete_timeslot_id"]');
		let rp_csrf_token = jQuery(parent).find('input[name="rp_csrf_token"]');
		let method = jQuery(parent).find('input[name="method"]');

		form.append('<input type="hidden" name="delete_timeslot_id" value="'+delete_timeslot_id.val()+'">');
		form.append('<input type="hidden" name="rp_csrf_token" value="'+rp_csrf_token.val()+'">');
		form.append('<input type="hidden" name="method" value="'+method.val()+'">');
		form.append('<input type="hidden" name="form_type" value="delete_delivery_timeslot">');
		jQuery('body').append(form);
		form.submit();
	});
	function moveUp(item) {
	    var prev = item.prev();
			console.log(prev);
		var top = 0;
		var handler = '';
		if( prev.hasClass('draggable') ){
			handler = prev;
			top = prev.height();
			prev = prev.prev();
		}
	    if (prev.length == 0)
	        return;
	    prev.css('z-index', 999).css('position','relative').animate({ top: parseInt( item.outerHeight() + 20 + top ) }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: '-' + parseInt( prev.outerHeight() + 20 + top ) }, 300, function () {
	        prev.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
			if( handler ){
	        	prev.insertAfter( handler );
	        	item.insertBefore( handler );
			}else{
				item.insertBefore(prev);
			}
	    });
	}
	function moveDown(item) {
	    var next = item.next();
		var top = 0;
		var handler = '';
		if( next.hasClass('draggable') ){
			handler = next;
			top = next.height();
			next = next.next();
		}
	    if (next.length == 0)
	        return;
	    next.css('z-index', 999).css('position', 'relative').animate({ top: '-' + parseInt( item.outerHeight() + 20 + top ) }, 250);
	    item.css('z-index', 1000).css('position', 'relative').animate({ top: parseInt( next.outerHeight() + 20 + top ) }, 300, function () {
	        next.css('z-index', '').css('top', '').css('position', '');
	        item.css('z-index', '').css('top', '').css('position', '');
			if( handler ){
	        	item.insertAfter( handler );
	        	next.insertBefore( handler );
			}else{
				item.insertAfter(next);
			}
	    });
	}
	jQuery(document).on('click', '.orderingdm .repair-list-sort .fas', function() { 
	    var btn = jQuery(this);
	    var val = btn.data('which');
	    if (val == 'up') {
	        moveUp(btn.parents('.orderingdm'));
			} else {
				moveDown(btn.parents('.orderingdm'));
			}
	});
	jQuery('.orderingdm-container').css({'min-height': (jQuery('.orderingdm-container').outerHeight() + 20) + 'px'});
	jQuery('.orderingdm-container').sortable({ items: ".orderingdm", distance: 5, handle: ".repair-list-sort" });
</script>