<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;
global $rpQuery;
function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}


if(isset($_POST) && isset($_POST['permalink'])){

	rp_verify_csrf_token_for_simple_form('plugin_shortcode');

	$permalink = $_POST['permalink'] ?? '';

	if( rp_get_option('rp_search_box_redirect_option', FALSE) == FALSE ) {

		rp_add_option('rp_search_box_redirect_option', $permalink);

	}
	else {

		rp_update_option('rp_search_box_redirect_option', $permalink);

	}

	$customlink = $_POST['customlink'] ?? '';
																	
	if( rp_get_option('rp_search_box_custom_redirect_link', FALSE) === FALSE ) {

		rp_add_option('rp_search_box_custom_redirect_link', $customlink);

	}
	else {

		rp_update_option('rp_search_box_custom_redirect_link', $customlink);

	}

	echo "<script>location.replace('admin.php?page=wp_repair_settings&section=plugin_shortcode');</script>";
																	
}


function rp_get_all_redirect_options() {

	return array(
		'Find It Automatically',
		'Use My Custom Link'
	);

}


function rp_print_all_redirect_options( $selected = '' ) {

	$options = rp_get_all_redirect_options();

	if( empty( $selected ) ) {

		$selected = 'Find It Automatically';

	}

	foreach ($options as $option) {

		if( $option === $selected ) {

			?>
				<option selected="selected" value="<?php echo $option; ?>"><?php echo $option ; ?></option>
			<?php

		}else{
			?>
				<option  value="<?php echo $option; ?>"><?php echo $option ; ?></option>
			<?php
		}

	}

}


?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.form-link{
		margin-top:50px; 
		width: 300px; 
		height:auto;
		background: #fff;
		padding: 10px;
		border-radius:10px;
		border:2px solid #1275C2;
	}
	.wp-repair-input-group.link{
		position: relative;
   	 	color: #61666b;
		margin-top: 50px !important;
	}
	.wp-repair-input-group .select_permalink{
		height: 42px;
		border: 2px solid #cfcfcf;
		box-shadow: none;
		outline: 0;
		box-sizing: border-box;
		width: 100%;
		font-size: 14px;
		/* font-weight: 600; */
		border-radius: 8px;
		padding: 0px 12px;
		color: #454545;
	}

	.wp-repair-input-group .select_permalink:focus{
		border: 2px solid #2781c7;
		box-shadow: none;
		outline: 0;
	}
	
</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('plugin_shortcode'); ?>
					<div class="bg-with-border">
						<div class="wp-repair-col-4 main-section section-one">
							<div class="wp-repair-main-section-heading">
								<h2>
									<span class="light">Plugin</span>
									<span class="bold">Shortcode</span>
								</h2>
								<p class="more-info"> You can copy it on any page.</p>
							</div>
							<div class="wp-repair-input-group">
								<label>All Steps Shortcode</label>
								<input type="text" class="user-info" id="shortcode" name="shortcode" value="[Repair_All]" disabled>
							</div>
							<div class="sec-3 mt-10">
								<button type="button" onclick="myFunction()" class="wp-general-info">Copy to clipboard</button> 
							</div>
							<div class="wp-repair-input-group" style="margin-top: 50px;">
								<label>Search Box Shortcode</label>
								<input type="text" class="user-info" id="shortcode_2" name="shortcode" value="[Repair_Search_Box]" disabled>
							</div>
							<div class="sec-3 mt-10">
								<button type="button" onclick="myFunction_2()" class="wp-general-info">Copy to clipboard</button> 
							</div>
							<!-- <p>Update Permalink</p> -->
							<div class="wp-repair-input-group link">		
								<form action="" method="POST">
								<?php
								rp_csrf_token_input_field('plugin_shortcode');
								?>
									<label>Search Box Redirect Link</label>
									<select name="permalink" class="select_permalink" id="search_box_redirect">
										<?php 

											$value = rp_get_option('rp_search_box_custom_redirect_link', '');
											$option = rp_get_option('rp_search_box_redirect_option', FALSE);
										
											rp_print_all_redirect_options($option);								
										?>	

									</select>
									<input type="text" name="customlink" value="<?php echo $value ?>" class="user-info" placeholder="<?php echo get_site_url(); ?>/" id="link" style="display:none; margin-top:10px; transition:2s; " >
							
									<div class="sec-3 mt-10">
										<button type="submit" name="btn" id="custom_link_button" class="wp-general-info">Update</button> 
									</div>
								</form>			
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
?>
<script type="text/javascript">
	jQuery(document).ready(function($){
		$('#search_box_redirect').on('change', function() {
			var search_box_redirect = $(this).val();
			if(search_box_redirect == 'Use My Custom Link'){

				$('#link').css("display", "block");

			}else{	
				$('#link').css("display", "none");
			}
		});

		var search_box_redirect = $('#search_box_redirect').val();
		if(search_box_redirect == 'Use My Custom Link'){

			$('#link').css("display", "block");

		}else{	
			$('#link').css("display", "none");
		}
	});


	function myFunction(){
		/* Get the text field */
  		var copyText = document.getElementById("shortcode");

  		/* Select the text field */
  		copyText.select();
  		copyText.setSelectionRange(0, 99999); /* For mobile devices */

   		/* Copy the text inside the text field */
  		navigator.clipboard.writeText(copyText.value);

  		/* Alert the copied text */
  		alert("Copied the text: " + copyText.value);
	}
		function myFunction_2(){
			/* Get the text field */
	  		var copyText = document.getElementById("shortcode_2");

	  		/* Select the text field */
	  		copyText.select();
	  		copyText.setSelectionRange(0, 99999); /* For mobile devices */

	   		/* Copy the text inside the text field */
	  		navigator.clipboard.writeText(copyText.value);

	  		/* Alert the copied text */
	  		alert("Copied the text: " + copyText.value);
		}
</script>