<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

function theProgressBarofWPRepairFrontEnd($currentPage = '') {
	function needToAddActiveClass($currentPage = '', $thisPage = '') {
		$x = $currentPage === $thisPage ? ' active' : '';
		if(($currentPage === $thisPage) && $currentPage === 'types') {
			$x .= ' one';
		}
		if($thisPage === 'repairs') {
			$x .= ' four';
		}
		echo $x;
	}
	function getAllPages() {
		return array('types', 'brands', 'models', 'repairs', 'finalize');
	}
	function getProgressPercent($currentPage = '') {
		$allPages = getAllPages();
		return (array_search($currentPage, $allPages) * 20) . '%';
	}
	function isCompletedStep($currentPage = '', $thisPage = '') {
		$allPages = getAllPages();
		return array_search($currentPage, $allPages) > array_search($thisPage, $allPages);
	}
	function numOrTick($currentPage = '', $thisPage = '') {
		$completed = isCompletedStep($currentPage, $thisPage);
		if($completed !== FALSE) {
			echo '<i class="fas fa-check"></i>';
		} else {
			$allPages = getAllPages();
			echo array_search($thisPage, $allPages) + 1;
		}
	}
	function easyRepeatDivs($what = '', $name = '', $currentPage = '') {
		?>
		<div class="wp-repair-width-20<?php needToAddActiveClass($currentPage, $what); ?>">
			<span class="step-circle">
				<span class="text"><?php numOrTick($currentPage, $what); ?></span>
				<span class="line"></span>
			</span>
			<div class="breaked-ps">
				<p class="select"><?php
				if($name === 'order') {
					echo 'Finalize';
				} else {
					echo 'Select';
				}
				?></p>
				<p class="select-actual"><?php echo $name; ?></p>
			</div>
		</div>
		<?php
	}
	?>
	<style type="text/css">
		.wp-repair-fe-types-conatiner .wp-repair-width-100 .p-up-arrow,
		.wp-repair-fe-types-conatiner .wp-repair-width-100 .p-bar-text {
			left: <?php echo getProgressPercent($currentPage); ?>;
		}
		.wp-repair-fe-types-conatiner .wp-repair-width-100 .p-bar .p-complete {
			width: <?php echo getProgressPercent($currentPage); ?>;
		}
		.wp-repair-fe-types-conatiner .wp-repair-progressBarMobile .p-up-arrow,
		.wp-repair-fe-types-conatiner .wp-repair-progressBarMobile .p-bar-text {
			top: <?php echo getProgressPercent($currentPage); ?>;
		}
		.wp-repair-fe-types-conatiner .wp-repair-progressBarMobile .p-bar .p-complete {
			height: <?php echo getProgressPercent($currentPage); ?>;
		}
	</style>
	<style type="text/css">
		.navigation-zd a {
			border: 2px solid #000;
			padding: 8px;
			margin-top: 8px;
			display: inline-block;
		}
		.navigation-zd a:after {
			content: '';
			display: inline-block;
			margin: 5px;
			background: #000;
		}
	</style>
	<div class="navigation-zd" style="margin-bottom: 50px;">
		<h2>Review All Pages</h2>
		<a href="?selected=types">Types</a>
		<a href="?selected=brands">Brands</a>
		<a href="?selected=models">Models</a>
		<a href="?selected=repairs">Repairs</a>
		<a href="?selected=finalize">Finalize Order</a>
		<a href="?selected=thanks">Thank You Page</a>
	</div>
	<div class="wp-repair-progress clearfix">
		<div class="wp-repair-progressBarMobile">
			<span class="p-bar"><div class="p-complete"><span class="p-bar-pad"></span></div></span>
			<span class="p-up-arrow"></span>
			<span class="p-bar-text">
				<?php echo getProgressPercent($currentPage); ?>
			</span>
		</div>
		<?php easyRepeatDivs('types', 'type', $currentPage); ?>
		<?php easyRepeatDivs('brands', 'brand', $currentPage); ?>
		<?php easyRepeatDivs('models', 'model', $currentPage); ?>
		<?php easyRepeatDivs('repairs', 'repair', $currentPage); ?>
		<?php easyRepeatDivs('finalize', 'order', $currentPage); ?>
		<div class="wp-repair-width-100 desktop">
			<span class="p-bar"><div class="p-complete"><span class="p-bar-pad"></span></div></span>
			<span class="p-up-arrow"></span>
			<span class="p-bar-text">
				<?php echo getProgressPercent($currentPage); ?>
			</span>
		</div>
	</div>
	<?php
}

