<?php
// Exit if accessed directly

defined( 'ABSPATH' ) || exit;

?>
<div class="tax-fields first" style="margin-top: 25px;">
    <div class="apply-tax-rate">
        <div class="td select">
            <label class="switch">
                <input type="hidden" name="rp_dynamic_pricing_is_enabled" value="0">
                <input type="checkbox" name="rp_dynamic_pricing_is_enabled" <?php if($rp_dynamic_pricing_is_enabled === '1') { echo 'checked="checked"'; } ?> value="1">
                <span class="slider round"></span>				
            </label>
        </div>
        <div class="td text">
            <span class="text">Enable dynamic pricing</span>
        </div>
    </div>
</div>
<h2 style="margin-top:40px;">Suppliers</h2>
<p class="last_synced"><?php

echo 'Last synced: '. rp_dp_x_minutes_ago($last_synced);

?></p>
<div class="tax-fields first suppliers" style="margin-top: 0px;">
    <?php
    $oldVersion = TRUE;
    foreach($suppliers as $supplier) {
        if( property_exists($supplier, 'flag_image') ) {
            // New version
            $oldVersion = FALSE;
        }
    }
    if( $oldVersion === TRUE ) {
        foreach($suppliers as $supplier) {
            ?>
            <div class="apply-tax-rate">
                <div class="td select">
                    <label class="switch">
                        <input type="checkbox" name="rp_dp_enabled_suppliers[]" <?php if(in_array($supplier->id, $rp_dp_enabled_suppliers)) { echo 'checked="checked"'; } ?> value="<?php echo $supplier->id; ?>">
                        <span class="slider round"></span>	
                    </label>
                </div>
                <div class="td text">
                    <span class="text"><?php echo $supplier->name; ?></span>
                </div>
            </div>
            <?php
        }
    } else {
        if( !empty( $suppliers ) ) {
            ?>
            <table class="suppliers-table found">
                <tbody>
            <?php
            foreach($suppliers as $supplier) {
                ?>
                <tr>
                    <td class="supplier-status <?php if( empty( $supplier->image ) ) { echo 'no-image'; } ?>">
                        <label class="switch">
                            <input type="checkbox" name="rp_dp_enabled_suppliers[]" <?php if(in_array($supplier->id, $rp_dp_enabled_suppliers)) { echo 'checked="checked"'; } ?> value="<?php echo $supplier->id; ?>">
                            <span class="slider round"></span>	
                        </label>
                    </td>
                    <?php
                    if( !empty( $supplier->image ) ) {
                        ?>
                        <td class="supplier-image-td">
                            <div class="supplier-image">
                                <img src="<?php echo trim($supplier->image); ?>" alt="<?php echo trim($supplier->name); ?> Image">
                            </div>
                        </td>
                        <?php
                    }
                    ?>
                    <td class="supplier-info">
                        <h2><?php echo trim($supplier->name); ?><?php
                        if( !empty($supplier->flag_image) ) {
                            ?>
                            <span class="flag-image"><img src="<?php echo trim($supplier->flag_image); ?>" alt="Flag Image"></span>
                            <?php
                        }
                        ?></h2>
                        <div class="supplier-image">
                            <img src="<?php echo trim($supplier->image); ?>" alt="<?php echo trim($supplier->name); ?> Image">
                        </div>
                        <p>
                            <?php echo trim($supplier->description); ?>
                        </p>
                        <div>
                            <?php
                            if( !empty( $supplier->cta_link ) && !empty( $supplier->cta_name ) ) {
                                ?>
                                <button type="button" class="manage-linking" data-supplier-name="<?php echo $supplier->name; ?>" data-supplier-id="<?php echo $supplier->id; ?>">Manage Linking</button>
                                <a target="_blank" href="<?php echo $supplier->cta_link; ?>"><?php echo trim($supplier->cta_name); ?></a>
                                <span class="suppliers-connected-model"><b><?php echo ((int) ($supplier->connected_models ?? 0)); ?></b> models connected</span>
                                <?php
                            } else {
                                ?>
                                <button type="button" class="manage-linking" data-supplier-name="<?php echo $supplier->name; ?>" data-supplier-id="<?php echo $supplier->id; ?>">Manage Linking</button>
                                <span class="suppliers-connected-model no-a-link"><b><?php echo ((int) ($supplier->connected_models ?? 0)); ?></b> models connected</span>
                                <?php
                            }
                            ?>
                        </div>
                    </td>
                </tr>
                <?php
            }

            ?>
                </tbody>
            </table>
            <?php

        } else {
            
            ?>
            <table class="suppliers-table no-suppliers-found">
                <tbody>
                    <tr>
                        <td colspan="3">
                            No suppliers found.
                        </td>
                    </tr>
                </tbody>
            </table>
            <?php

        }
    }
    ?>
</div>
<div style="margin-top: 25px; white-space: nowrap;"> </div>
<p class="company-logo-theme-color">Which price to consider when part is available through more than one supplier?</p>
<span class="wp-repair-repair-card">
    <select class="coupons_select" name="rp_dp_which_price_to_consider" required>
        <?php
        $subTextoptions = array(
            'cheapest' => 'Cheapest (In Stock)',
            'most_expensive' => 'Most Expensive (In Stock)',
            'average' => 'Average (In Stock)'
        );
        foreach ($subTextoptions as $optKey => $optValue) {
            ?>
            <option <?php if(trim($rp_dp_which_price_to_consider) === $optKey) { echo 'selected="selected"'; } ?> value="<?php echo $optKey; ?>"><?php echo $optValue; ?></option>
            <?php
        }
        ?>
    </select>
</span>
<p class="company-logo-theme-color">What if item is not linked or not in stock?</p>
<span class="wp-repair-repair-card">
    <select class="coupons_select" name="rp_dp_if_part_is_unavailable" required>
        <?php
        $subTextoptions = array(
            'use_fallback' => 'Use Fallback Price',
            'use_price_on_request' => 'Use Price on Request'
        );
        foreach ($subTextoptions as $optKey => $optValue) {
            ?>
            <option <?php if(trim($rp_dp_if_part_is_unavailable) === $optKey) { echo 'selected="selected"'; } ?> value="<?php echo $optKey; ?>"><?php echo $optValue; ?></option>
            <?php
        }
        ?>
    </select>
</span>
<div class="tax-fields first" style="margin-top: 25px; margin-bottom: 10px;">
    <div class="apply-tax-rate">
        <div class="td select">
            <label class="switch">
                <input type="hidden" name="rp_dp_round_up_dynamic_price" value="0">
                <input type="checkbox" name="rp_dp_round_up_dynamic_price" <?php if(rp_get_option('rp_dp_round_up_dynamic_price', '1') === '1') { echo 'checked="checked"'; } ?> value="1">
                <span class="slider round"></span>				
            </label>
        </div>
        <div class="td text">
            <span class="text">Round Up Dynamic Price</span>
        </div>
    </div>
</div>
<div class="dependant-field round-up <?php if( rp_get_option('rp_dp_round_up_dynamic_price', '1') == '0' ) { echo 'max-height-0'; } ?>">
    <br>
    <p class="company-logo-theme-color">If price is $95.63 round it up like:</p>
    <span class="wp-repair-repair-card">
        <select class="coupons_select" name="rp_dp_round_up_method" required>
            <?php
            $subTextoptions = array(
                'ceil' => '$96',
                '0' => '$99',
                '95' => '$99.95',
                '99' => '$99.99',
                '100' => '$100'
            );
            foreach ($subTextoptions as $optKey => $optValue) {
                ?>
                <option <?php if(trim($rp_dp_round_up_method) == $optKey) { echo 'selected="selected"'; } ?> value="<?php echo $optKey; ?>"><?php echo $optValue; ?></option>
                <?php
            }
            ?>
        </select>
    </span>
    <p class="company-logo-theme-color">Example of rounding based on your selected option ($<?php echo rp_round_up_nearest_five(95.63, $rp_dp_round_up_method) ?>):</p>
    <table class="rp-rounding-examples">
        <tbody>
            <?php
            $example_values = array(47.12, 34.48, 66.36, 56, 99);
            foreach ($example_values as $example_value) {
                ?>
                <tr>
                    <td>$<?php echo $example_value; ?></td>
                    <th style="width: 50px">></td>
                    <td>$<?php echo rp_round_up_nearest_five($example_value, $rp_dp_round_up_method); ?></td>
                </tr>
                <?php
            }
            ?>
        </tbody>
    </table>
</div>
<p class="company-logo-theme-color" style="margin-top: 25px;">Format for last price updated date on Front-End</p>
<span class="wp-repair-repair-card">
    <select class="coupons_select" name="rp_dp_date_format_front_end" required>
        <?php
        $subTextoptions = array(
            'd/m/y' => 'd/m/y > 01/01/23',
            'y/m/d' => 'y/m/d > 23/01/01'
        );
        foreach ($subTextoptions as $optKey => $optValue) {
            ?>
            <option <?php if(trim($rp_dp_date_format_front_end) === $optKey) { echo 'selected="selected"'; } ?> value="<?php echo $optKey; ?>"><?php echo $optValue; ?></option>
            <?php
        }
        ?>
    </select>
</span>
<div class="tax-fields first" style="margin-top: 25px;">
    <div class="apply-tax-rate">
        <div class="td select">
            <label class="switch">
                <input type="hidden" name="rp_hide_attribute_if_no_part" value="0">
                <input type="checkbox" name="rp_hide_attribute_if_no_part" <?php if(rp_get_option('rp_hide_attribute_if_no_part', '0') === '1') { echo 'checked="checked"'; } ?> value="1">
                <span class="slider round"></span>				
            </label>
        </div>
        <div class="td text">
            <span class="text">Hide repair attribute if no part is available or price is 0</span>
        </div>
    </div>
</div>
<?php
$removeThisFunctionality = TRUE;
if( $removeThisFunctionality === FALSE ) {
    ?>
    <div class="wp-repair-input-group default-margin">
        <p class="company-logo-theme-color">Default margin to use when margin is not configured</p>
        <input type="number" min="0" step="any" class="user-info" name="rp_dp_default_margin_setting" value="<?php echo ( (float) rp_get_option('rp_dp_default_margin_setting', 0) ); ?>" required>
    </div>
    <?php
} else {
    echo '<br>';
}
?>
<p class="company-logo-theme-color" style="margin-top: 25px;">Synchronize dynamic pricing data using:</p>
<span class="wp-repair-repair-card">
    <select class="coupons_select" name="rp_which_way_for_processing_datafeed" required>
        <?php
        $subTextoptions = array(
            'wordpress' => 'WordPress (Affects Performance)',
            'cron' => 'CRON Job (Seamless Experience)'
        );
        foreach ($subTextoptions as $optKey => $optValue) {
            ?>
            <option <?php if(trim($rp_which_way_for_processing_datafeed) === $optKey) { echo 'selected="selected"'; } ?> value="<?php echo $optKey; ?>"><?php echo $optValue; ?></option>
            <?php
        }
        ?>
    </select>
</span>
<div class="sec-3 desktop always-show-cont">
    <button type="submit" name="update_company" id="update_company" class="wp-general-info">Save All Settings</button>
</div>