<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

if(!function_exists('wp_repair_admin_settings_sidebar')) {
	function wp_repair_admin_settings_sidebar($active_link = '') {
		function createTheLink($link) {
			return '?page='.$_GET['page'].'&section='.$link;
		}
		$sidebar_menu_items = array(
			'general_info' => array(
				'title' => 'Company Information',
				'icon' => 'fas fa-building',
				'link' => createTheLink('general_info'),
				'render_condition' => true,
				'position' => 10
			),
			'special_opening_times' => array(
				'title' => 'Special Opening Hours',
				'icon' => 'fas fa-umbrella-beach',
				'link' => createTheLink('special_opening_times'),
				'render_condition' => true,
				'position' => 20
			),
			'localization' => array(
				'title' => 'Localization',
				'icon' => 'far fa-clock',
				'link' => createTheLink('localization'),
				'render_condition' => true,
				'position' => 30
			),
			'styling' => array(
				'title' => 'Front-End Steps',
				'icon' => 'fas fa-list-ol',
				'link' => createTheLink('styling'),
				'render_condition' => true,
				'position' => 40
			),
			'planning_discount' => array(
				'title' => 'Planning & Discount',
				'icon' => 'far fa-calendar-alt',
				'link' => createTheLink('planning_discount'),
				'render_condition' => true,
				'position' => 50
			),
			'notification_offer' => array(
				'title' => 'Notifications & Offers',
				'icon' => 'fas fa-bell',
				'link' => createTheLink('notification_offer'),
				'render_condition' => true,
				'position' => 60
			),
			'coupons' => array(
				'title' => 'Coupons',
				'icon' => 'fas fa-tag',
				'link' => createTheLink('coupons'),
				'render_condition' => true,
				'position' => 70
			),
			'manage_permission' => array(
				'title' => 'Permissions',
				'icon' => 'fa fa-user-secret',
				'link' => createTheLink('manage_permission'),
				'render_condition' => current_user_can('activate_plugins'),
				'position' => 80
			),
			'plugin_shortcode' => array(
				'title' => 'Plugin Shortcode',
				'icon' => 'fas fa-code',
				'link' => createTheLink('plugin_shortcode'),
				'render_condition' => true,
				'position' => 90
			),
			'webhooks' => array(
				'title' => 'Webhooks',
				'icon' => 'fas fa-link',
				'link' => createTheLink('webhooks'),
				'render_condition' => true,
				'position' => 100
			)
		);
		$sidebar_menu_items = apply_filters('rp_admin_settings_sidebar_items', $sidebar_menu_items);
		?>
		<div class="wp-repair-col-4 wp-repair-sidebar">
			<div class="wp-repair-heading-section">
				<div class="wp-repair-icon"><i class="fas fa-cog"></i></div>
				<h1 class="settings-heading">Settings</h1>
			</div>
			<div class="wp-repair-links">
				<?php
				// sort by position
				uasort($sidebar_menu_items, function($a, $b) {
					return $a['position'] <=> $b['position'];
				});
				foreach( $sidebar_menu_items as $item => $info ) {

					if( $info['render_condition'] ) {
						?>
						<a href="<?php echo $info['link']; ?>" class="<?php if($active_link === $item) { echo 'active'; } ?>">
							<div class="wp-repair-icon"><i class="<?php echo $info['icon']; ?>"></i></div>
							<span><?php echo $info['title']; ?></span>
						</a>
						<?php
					}

				}
				?>
			</div>
		</div>
		<?php
	}
}

?>
