<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}

function rp_get_short_names_of_months() {
	$months = array(
		'Jan' => 'January',
		'Feb' => 'February',
		'Mar' => 'March',
		'Apr' => 'April',
		'May' => 'May',
		'Jun' => 'June',
		'Jul' => 'July',
		'Aug' => 'August',
		'Sep' => 'September',
		'Oct' => 'October',
		'Nov' => 'November',
		'Dec' => 'December'
	);
	return $months;
}

function rp_get_usual_days_of_month($month = 'Jan') {
	$days = array();
	$days['Jan'] = 31;
	$days['Feb'] = 29;
	$days['Mar'] = 31;
	$days['Apr'] = 30;
	$days['May'] = 31;
	$days['Jun'] = 30;
	$days['Jul'] = 31;
	$days['Aug'] = 31;
	$days['Sep'] = 30;
	$days['Oct'] = 31;
	$days['Nov'] = 30;
	$days['Dec'] = 31;
	return $days[$month];
}

global $rpQuery;

$rs_planning_and_discount = $rpQuery->prefix . "rs_planning_and_discount";

$planning_discount = $rpQuery->get_results("SELECT * FROM $rs_planning_and_discount");

$time_slots = $planning_discount[0]->booking_slots_length;

$time_slots = str_replace(strtolower(' Minutes (Default)'), '', strtolower($time_slots));

$time_slots = trim(str_replace('minutes', '', strtolower($time_slots)));

$time_slots = (int) $time_slots; // 30

// get all times between 12:00 AM and 11:30 PM
$all_times = array();
$startTime = strtotime('12:00 AM');
$endTime = strtotime('11:59 AM');
$addMins = $time_slots * 60;

while ($startTime < $endTime) {
	$all_times[] = date('h:i', $startTime);
	$startTime += $addMins;
}

$all_times = array_unique($all_times);

$all_times = array_values($all_times);

$rs_company_location = $rpQuery->prefix . "rs_company_location";

$company_locations = $rpQuery->get_results("SELECT * FROM $rs_company_location");

$company_locations = rp_sanitize_output($company_locations);

$selected_location_timings = array();

$rs_special_timing = $rpQuery->prefix . "rs_special_timing";

$selected_location_timings = $rpQuery->get_results("SELECT * FROM `$rs_special_timing` ORDER BY `cs_day` ASC");

if( !empty($selected_location_timings) ) {

	$selected_location_timings = rp_sanitize_output($selected_location_timings);

}

$coupons = $rpQuery->prefix . "rs_coupons";
$localization = $rpQuery->prefix . "rs_localization";
$coupons_result = $rpQuery->get_results("SELECT * FROM $coupons");
$localization_data = $rpQuery->get_results("SELECT * FROM $localization");
$decimal = $localization_data[0]->set_decimals;

if (isset($_POST['month'])) {

	rp_verify_csrf_token_for_simple_form('special_opening_times');

	$month = $_POST['month']; // January
	$day_of_month = $_POST['days_of_month']; // 02
	$opening_time = $_POST['opening_time'] ?? ''; // 10:00
	$opening_time_am_pm = $_POST['opening_time_am_pm'] ?? ''; // AM
	$closing_time = $_POST['closing_time'] ?? ''; // 10:00
	$closing_time_am_pm = $_POST['closing_time_am_pm'] ?? ''; // PM
	$reminder_name = $_POST['day_name'] ?? ''; // Easter
	$location_ids = $_POST['location_ids'] ?? array();

	$cs_day = date('m-d', strtotime($day_of_month . ' ' . $month)); // 01-02
	$is_closed = '0';

	if( empty( $opening_time ) || empty( $closing_time ) ) {

		$cs_open_timing = '00:00';
		$cs_close_timing = '00:00';
		$is_closed = '1';
		
	} else {

		$cs_open_timing = date('H:i', strtotime($opening_time . ' ' . $opening_time_am_pm)); // 10:00
		$cs_close_timing = date('H:i', strtotime($closing_time . ' ' . $closing_time_am_pm)); // 22:00

	}

	$rs_special_timing = $rpQuery->prefix . "rs_special_timing";

	$everything_good = TRUE;

	$error_location = '';

	foreach($location_ids as $_loc_id) {

		if( rp_check_if_special_timing_exists( $cs_day, $_loc_id ) === TRUE ) {

			$everything_good = FALSE;

			$error_location = $_loc_id;

		}

	}

	$error_message = '';

	if($everything_good === TRUE) {

		$location_id_fk = join(',', $location_ids);

		$rpQuery->query("INSERT INTO $rs_special_timing (cs_day, cs_open_timing, cs_close_timing, reminder_name, location_id_fk, is_closed) VALUES ('".rp_escape_sql($cs_day)."', '".rp_escape_sql($cs_open_timing)."', '".rp_escape_sql($cs_close_timing)."', '".rp_escape_sql($reminder_name)."', '".rp_escape_sql($location_id_fk)."', '".rp_escape_sql($is_closed)."')");

	} else {

		$error_message = '&error_message=already_exists&error_location='.$error_location;

	}

    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=special_opening_times".$error_message."');</script>";
}
if (isset($_POST['delete_special_timing_id'])) {

	rp_verify_csrf_token_for_simple_form('special_opening_times');

	$cs_id = (int) trim($_POST['delete_special_timing_id'] ?? '0');

	$cs_id_key = trim($_POST['delete_special_timing_id_key'] ?? '');

	if( !empty($cs_id) && $cs_id_key === md5($cs_id) ) {

		$rs_special_timing = $rpQuery->prefix . "rs_special_timing";

		$rpQuery->query("DELETE FROM `$rs_special_timing` WHERE `cs_id` = '$cs_id' LIMIT 1;");

	}

    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=special_opening_times');</script>";
}
?>
<script src="https://cdnjs.cloudflare.com/ajax/libs/selectize.js/0.12.6/js/standalone/selectize.min.js" type="text/javascript"></script>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/selectize.js/0.12.6/css/selectize.bootstrap3.min.css" integrity="sha512-nATinx3+kN7dKuXEB0XLIpTd7j8QahdyJjE24jTJf4HASidUCFFN/TkSVn3CifGmWwfC2mO/VmFQ6hRn2IcAwg==" crossorigin="anonymous" />
<style type="text/css">
	.bg-with-border{
		padding: 3% !important;
	}
	.add-coupon button{
	  	font-weight: 700;
	  	font-size: 12px;
		letter-spacing: 1px;
		margin: 0px;
		text-transform: uppercase;
		padding: 10px 10px;
		background: transparent;
		background-color: transparent;
		cursor: pointer;
		color: #1275c2;
		border: 2px solid #1275c2;
		border-radius: 8px;
		display: inline-block;
		top: -2px;
		left: 15px;
	}
	.wp-repair-input-group {
		position: relative;
		color: #61666b;
		margin-top: 20px;
	}
	.wp-repair-input-group label {
		position: absolute;
		font-size: 9px;
		text-transform: uppercase;
		/*font-weight: 600;*/
		letter-spacing: 1.5px;
		top: -5px;
		left: 18px;
		padding: 0px 6px;
		background: #fff;
		font-weight: bold;
	}
	.wp-repair-input-group input ,.wp-brand-input-group select,.wp-repair-input-group textarea {
		height: 42px;
		border: 2px solid #cfcfcf;
		box-shadow: none;
		outline: 0;
		box-sizing: border-box;
		width: 100%;
		font-size: 14px;
	    font-weight: 400 !important;
	    border-radius: 8px;
	    padding: 0px 12px;
	    color: #454545;
	}
	.fs-9{
		font-size: 9px;
	}
	.mb-15{
		margin-bottom: 14px !important;
	}
	.modal-body{
		padding: 20px 0px;
	}
	.c-type{
		text-transform: uppercase;
		margin: 1em 0;
		font-weight: bold;
		letter-spacing: 1.5px;
		text-align: left;
	}
	.table-responsive table.coupon-table {
		width: 100%;
	}
	.table-responsive .wp-repair-input-group input,
	.table-responsive .wp-repair-input-group select {
		font-size: 13px;
		height: 40px;
		padding: 8px !important;
	}
	.coupons_select {
		font-size: 13px !important;
		padding: 5px 23px 5px 10px !important;
	}
	.table-responsive td.code input, .table-responsive td.reference input {
		min-width: 110px;
	}
	.table-responsive td.amount input {
    min-width: 140px;
    max-width: 160px;
    font-weight: 700;
}
.table-responsive td select.coupon_type {
	width: 80px;
	font-weight: 400 !important;
}
.table-responsive td select.w_65 {
	width: 65px;
}
.p-right {
	padding-right: 20px;
}
form.selected_location {
	margin: 20px 0px;
}
form.selected_location label {
	display: inline-table;
	font-weight: 500;
	position: relative;
    top: -8px;
    left: 5px;
}
form.selected_location select {
	display: inline-table;
}
form.selected_location select.coupons_select {
	width: auto !important;
	min-width: 200px !important;
	max-width: 300px !important;
}
table.timing-show {
	margin-top: 30px;
}
table.timing-show td {
	font-weight: 500;
}
table.timing-show td,
table.timing-show th {
	text-align: left;
	padding: 20px 8px;
	border-bottom: 1px dashed #eee;
	line-height: 1.4em;
	word-break: break-word;
}
table.timing-show tr:nth-last-child(1) td,
table.timing-show tr:nth-last-child(1) th {
	border-bottom: 0px;
}
button.delete_special_timing {
	background: #404040;
    color: #fff;
    border-radius: 6px;
    padding: 6px 9px;
    font-size: 13px;
}
.rp-alert-danger {
	margin-top: 0px;
	margin-bottom: 12px;
	background: #f8d7da;
	color: #721c24;
	border-radius: 8px;
	border: 2px solid #f5c6cb;
	padding: 12px;
	font-size: 13px;
	width: calc(100% - 60px);
	line-height: 1.4em;
}
.coupons_select.coupon_type.w100 {
	width: 100%;
	max-width: 100%;
}
span.apply-on {
	font-size: 8px;
    text-transform: uppercase;
    font-weight: 600;
    letter-spacing: 1.5px;
    padding: 0px;
    text-align: left;
    margin: 8px 3px 8px 3px;
    /* padding-left: 10px; */
    color: #61666b;
}
</style>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('special_opening_times'); ?>
					<div class="wp-repair-col-8 bg-with-border main-section">
						<div class="table-responsive">
							<table class="table" style="width: 100%;">
								<tbody>
									<tr>
										<td style="display: inline-flex;width: 100%;">
											<div class="wp-repair-main-section-heading" style="width:100%">
												<h2>
													<span class="light">Special</span>
													<span class="bold">Opening Hours</span>
												</h2>
												<p class="more-info">Set opening and closing times for special days</p>
											</div>
										</td>
									</tr>
								</tbody>
							</table>
						</div>
						<div class="table-responsive">
							
						</div>
						<form action="" method="POST">
						<?php rp_csrf_token_input_field('special_opening_times'); ?>
						<div class="table-responsive">
							<p style="margin: 15px 0px 30px 0px; font-weight: 500; font-size: 12px;">
								When you're closed on certain day, just leave the hours blank.
								<br>
								Remember: 12PM is midday, 12AM is midnight.
							</p>
							<?php
							if(isset($_REQUEST['error_message']) && $_REQUEST['error_message'] === 'already_exists') {
								$error_location_text = '';
								if( !empty( $_REQUEST['error_location'] ?? '' ) ) {

									$error_location = trim( $_REQUEST['error_location'] ?? '' );

									if( $error_location === 'ps' ) {
										$error_location_text = 'Pickup service';
									} else if ( $error_location === 'rol' ) {
										$error_location_text = 'Repair on location';
									} else if( strpos( $error_location, 'sg_' ) === 0 ) {
										$error_location = (int) str_replace( 'sg_', '', $error_location );
										// get from rs_schedule_groups where id matches $error_location
										$rs_schedule_groups = $rpQuery->prefix . 'rs_schedule_groups';
										$group_row = $rpQuery->get_row( "SELECT `name` FROM `$rs_schedule_groups` WHERE `id` = {$error_location} LIMIT 1;" );
										$group_row = rp_sanitize_output( $group_row );
										if( !empty($group_row) ) {
											$error_location_text = $group_row->name . ' (Schedule Group)';
										}
									} else {
										$error_location = (int) $error_location;
										// get from rs_company_location where location_id matches $error_location
										$location_row = $rpQuery->get_row( "SELECT location_name FROM `$rs_company_location` WHERE location_id = {$error_location} LIMIT 1;" );
										$location_row = rp_sanitize_output( $location_row );
										if( !empty($location_row) ) {
											$error_location_text = $location_row->location_name;
										}
									}

								}
								if( !empty( $error_location_text ) ) {
									echo '<div class="rp-alert-danger" role="alert">Special timing already exists for this date at ' . $error_location_text . '.</div>';
								} else {
									echo '<div class="rp-alert-danger" role="alert">Special timing already exists for this date.</div>';
								}
							}
							?>
							<table class="table coupon-table">
								<thead>
									<tr class="headings">
										<th colspan="2" style="width:70px;">Date</th>
										<th style="width: 150px;" colspan="4">Hours</th>
										<th style="width: 100px;">Name</th>
									</tr>
								</thead>
								<tbody>
									<tr class="closed">
										<td class="reference">

											<span class="wp-repair-repair-card">
												<select class="coupons_select coupon_type w_65" name="month" required="">
													<?php
													$short_month_names = rp_get_short_names_of_months();
													$current_month_short = '';
													foreach($short_month_names as $m_short => $m_name) {
														$current_month = 'January';
														if($m_name === $current_month) {
															$current_month_short = $m_short;
															echo '<option data-days="'.rp_get_usual_days_of_month($m_short).'" value="'.$m_name.'" selected="selected">'.$m_short.'</option>';
														} else {
															echo '<option data-days="'.rp_get_usual_days_of_month($m_short).'" value="'.$m_name.'">'.$m_short.'</option>';
														}
													}
													?>
												</select>
											</span>
										</td>
										<td class="code">
											<span class="wp-repair-repair-card p-right">
												<select class="coupons_select coupon_type w_65" name="days_of_month" required="">
													<?php
													$current_month_days = rp_get_usual_days_of_month($current_month_short);
													$start = 1;
													$end = $current_month_days;
													for($i = $start; $i <= $end; $i++) {
														$x = $i;
														if($i < 10) {
															$x = '0'.$i;
														}
														echo '<option value="'.$x.'">'.$x.'</option>';
													}
													?>
												</select>
											</span>
										</td>
										<td>
											<span class="wp-repair-repair-card">
												<select class="coupons_select coupon_type" name="opening_time">
													<option value=""></option>
													<?php
													foreach($all_times as $_time) {
														echo '<option value="'.$_time.'">'.$_time.'</option>';
													}
													?>
												</select>
											</span>
										</td>
										<td>
											<span class="wp-repair-repair-card">
												<select class="coupons_select coupon_type am_pm w_65" name="opening_time_am_pm">
													<?php
													foreach(array('AM', 'PM') as $am_pm) {
														echo '<option value="'.$am_pm.'">'.$am_pm.'</option>';
													}
													?>
												</select>
											</span>
										</td>
										<td>
											<span class="wp-repair-repair-card">
												<select class="coupons_select coupon_type" name="closing_time">
													<option value=""></option>
													<?php
													foreach($all_times as $_time) {
														echo '<option value="'.$_time.'">'.$_time.'</option>';
													}
													?>
												</select>
											</span>
										</td>
										<td>
											<span class="wp-repair-repair-card p-right">
												<select class="coupons_select coupon_type am_pm w_65" name="closing_time_am_pm">
													<?php
													foreach(array('AM', 'PM') as $am_pm) {
														if($am_pm === 'PM') {
															echo '<option value="'.$am_pm.'" selected="selected">'.$am_pm.'</option>';
														} else {
															echo '<option value="'.$am_pm.'">'.$am_pm.'</option>';
														}
													}
													?>
												</select>
											</span>
										</td>
										<td class="amount">
											<div class="wp-repair-input-group">
												<input class="" type="text" name="day_name" placeholder="E.g. Easter" required="">
											</div>
										</td>
									</tr>
									<tr>
										<td colspan="7">
											<span class="apply-on">
												Apply On
											</span>
										</td>
									</tr>
									<tr class="closed">
										<td colspan="7">
											<span class="wp-repair-repair-card">
												<select class="coupons_select apply-on coupon_type w100" name="location_ids[]" multiple="multiple">
													<option value="">-- Select --</option>
													<?php
													if( rp_is_active_enhanced_locations_addon() === true ) {
														$options = array();
														$schedule_groups = rp_get_all_schedule_groups();
														foreach($schedule_groups as $schedule_group_row) {
															$option_value = 'sg_' . $schedule_group_row->id;
															$option_text = $schedule_group_row->name;
															$options[$option_text] = $option_value;
														}
														echo '<optgroup label="Schedule Groups">';
														foreach($options as $option_text => $option_value) {
															echo '<option value="'.$option_value.'">'.$option_text.'</option>';
														}
														echo '</optgroup>';
													}
													$options = array();
													foreach($company_locations as $company_location_row) {
														$option_value = $company_location_row->location_id;
														$option_text = $company_location_row->location_name;
														$options[$option_text] = $option_value;
													}
													echo '<optgroup label="Locations">';
													foreach($options as $option_text => $option_value) {
														echo '<option value="'.$option_value.'">'.$option_text.'</option>';
													}
													echo '</optgroup>';
													echo '<optgroup label="Delivery Methods">';
													$options = array();
													$options['Pickup service'] = 'ps';
													$options['Repair on location'] = 'rol';
													foreach($options as $option_text => $option_value) {
														echo '<option value="'.$option_value.'">'.$option_text.'</option>';
													}
													echo '</optgroup>';
													?>
												</select>
											</span>
										</td>
									</tr>
									<tr class="spacer"><td></td></tr>
										
								</tbody>
							</table>
							<div class="wp-repair-inner-col section-1">
								<div class="sec-3" style="float:right;">
									<button type="submit" name="add_timing" class="wp-general-info">
										Add Timing <i class="fas fa-chevron-right"></i>
									</button>
								</div>
							</div>
						</div>
						</form>
						<div class="table-responsive">
							<table class="table timing-show" style="width: 100%">
								<tbody>
									<?php
									if( !empty($selected_location_timings) ) {
										foreach($selected_location_timings as $row) {
											$date = date('M d', strtotime(date('Y').'-'.$row->cs_day));
											$name = $row->reminder_name;
											$open_timing = $row->cs_open_timing;
											// get opening time in g:i a
											$open_timing = date('g:i a', strtotime($open_timing));
											$close_timing = $row->cs_close_timing;
											// get closing time in g:i a
											$close_timing = date('g:i a', strtotime($close_timing));
											$desc = '';
											if($row->is_closed == '1') {
												$desc = 'Closed';
											} else {
												$open_timing = strtoupper($open_timing);
												$close_timing = strtoupper($close_timing);
												// replace white space with empty string
												$open_timing = str_replace(' ', '', $open_timing);
												$close_timing = str_replace(' ', '', $close_timing);
												$desc = $open_timing.' — '.$close_timing;
											}
											$related_locations = $row->location_id_fk;
											$related_locations = explode(',', $related_locations);
											$related_location_names = array();
											foreach($related_locations as $loc_id) {
												$loc_id = trim($loc_id);
												if(empty($loc_id)) {
													continue;
												}
												if($loc_id === 'ps') {
													$related_location_names[] = 'Pickup service';
												} else if ($loc_id === 'rol') {
													$related_location_names[] = 'Repair on location';
												} else if( strpos( $loc_id, 'sg_' ) === 0 ) {
													
													$fixed_loc_id = (int) str_replace('sg_', '', $loc_id);

													$rs_schedule_groups = $rpQuery->prefix . 'rs_schedule_groups';

													// select from rs_schedule_groups where id = $fixed_loc_id
													$sg_row = $rpQuery->get_row("SELECT * FROM `$rs_schedule_groups` WHERE id = {$fixed_loc_id}");

													$sg_row = rp_sanitize_output($sg_row);

													if( !empty($sg_row) ) {
														// add name with calendar icon
														$related_location_names[] = '<i class="fas fa-calendar-alt"></i> ' . $sg_row->name;
													}

												} else {
													// select from rs_company_location where location_id = $loc_id
													$loc_row = $rpQuery->get_row("SELECT * FROM `$rs_company_location` WHERE location_id = {$loc_id}");

													$loc_row = rp_sanitize_output($loc_row);

													if( !empty($loc_row) ) {
														$related_location_names[] = $loc_row->location_name;
													}
												}
											}
											?>
											<tr>
												<th style="width: 180px"><?php echo $date; ?> (<?php echo $name; ?>)</th>
												<td colspan="2" style="width: 180px">
													<?php echo $desc; ?>
												</td>
												<td colspan="2" style="width: 180px">
													<?php
													if( !empty($related_location_names) ) {
														$text = '';
														foreach($related_location_names as $loc_name) {
															$text .= $loc_name.'<br>';
														}
														$text = rtrim($text, '<br>');
														echo $text;
													} else {
														echo '--';
													}
													?>
												</td>
												<td>
													<form action="" method="POST">
														<?php rp_csrf_token_input_field('special_opening_times'); ?>
														<input type="hidden" name="delete_special_timing_id" value="<?php echo $row->cs_id; ?>">
														<input type="hidden" name="delete_special_timing_id_key" value="<?php echo md5($row->cs_id); ?>">
														<button type="submit" name="delete_special_timing" class="wp-repair-coupon-delete delete_special_timing">
															<i class="fas fa-times"></i>
														</button>
													</form>
												</td>
											</tr>
											<?php
										}
									}
									?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
?>
<script type="text/javascript">
	jQuery('select[name="month"]').on('change input', function(){
		let month = jQuery(this).val();
		let days_of_month;
		jQuery(this).find('option').each(function(){
			if(jQuery(this).val() === month) {
				days_of_month = jQuery(this).data('days');
			}
		});
		jQuery('select[name="days_of_month"]').html('');
		let start = 1;
		while(start <= days_of_month) {
			_start = start;
			if(_start < 10) {
				_start = '0'+_start;
			}
			jQuery('select[name="days_of_month"]').append('<option value="'+_start+'">'+_start+'</option>');
			start++;
		}
	});

</script>
<style>
	.selectize-control.apply-on {
		border: 0px !important;
		padding: 0px !important;
	}
	.selectize-input.focus {
		box-shadow: unset !important;
		border: 2px solid #1275c2;
	}
	.selectize-input .item.active,
	.selectize-input .item {
		background: #efefef !important;
		color: #333 !important;
    	border: 0 solid transparent !important;
		padding-left: 10px !important;
	}
</style>
<script type="text/javascript">
	jQuery(document).ready(function () {
		jQuery('select.apply-on').selectize({
			plugins: ['remove_button'],
			delimiter: ',',
			persist: false
		});
	});
</script>