<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;

$is_active_enhanced_locations = rp_is_active_enhanced_locations_addon();

$enhanced_locations_translations = array(
	'search_for_nearest_location',
	'approx_radius_distance',
	'browser_does_not_support_geolocation',
	'error_getting_geolocation',
	'address_is_too_short',
	'live_location_btn_text',
	'nearest_location_distance_unit_km',
	'nearest_location_distance_unit_miles'
);

global $wp_repair_lang;

$category_based = rp_get_static_translations_based_on_category();

$english_translations = rp_get_static_translations_of_language('English (United States)');


global $rpQuery;
$company_information = $rpQuery->prefix . "rs_company_information";
$company_location    = $rpQuery->prefix . "rs_company_location";
$company_schedules   = $rpQuery->prefix . "rs_company_schedules";

require_once( ABSPATH . 'wp-admin/includes/file.php' ); // require file.php

$c_results = $rpQuery->get_results("SELECT * FROM $company_information");
$company_id = $c_results[0]->company_id;

$location = $rpQuery->get_results("SELECT * FROM $company_location");
$count_locations = $rpQuery->get_var("SELECT COUNT(*) FROM $company_location");

$first_location_id = $location[0]->location_id;
$get_schedules = $rpQuery->get_results("SELECT * FROM $company_schedules WHERE location_id_fk = '".rp_escape_sql($first_location_id)."'");

$repair_subtext = rp_get_option('wp_repair_repair_subtext_setting', 'repair_info');

if (isset($_POST['update_company'])) {

	rp_verify_csrf_token_for_simple_form('styling');

	$uploadedfile = $_FILES['upload_image'];
	$upload_overrides = array( 'test_form' => false ); 
	$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
 	
    if(!isset($movefile) || !isset($movefile["url"]) || $movefile["url"] == "" || $movefile["url"] == null ){
		$logo = $_POST["c_logo"];
	}else{
		$logo = $movefile["url"];
	}

    $c_logo        = $logo;
    $c_theme_color = str_replace('#', '', $_POST['c_theme_color']);


    if(isset($_POST['repair_subtext']) && !empty($_POST['repair_subtext'])) {
    	if(rp_get_option('wp_repair_repair_subtext_setting', FALSE) === FALSE) {
    		rp_add_option('wp_repair_repair_subtext_setting', $_POST['repair_subtext']);
    	} else {
    		rp_update_option('wp_repair_repair_subtext_setting', $_POST['repair_subtext']);
    	}
    }

    if(isset($_POST['rp_whitelabel']) && $_POST['rp_whitelabel'] !== NULL && $_POST['rp_whitelabel'] !== '' && in_array($_POST['rp_whitelabel'], array('0', '1'))) {
    	if(rp_get_option('wp_repair_whitelabel', FALSE) === FALSE) {
    		rp_add_option('wp_repair_whitelabel', $_POST['rp_whitelabel']);
    	} else {
    		rp_update_option('wp_repair_whitelabel', $_POST['rp_whitelabel']);
    	}
    }

	//rp_hide_attribute_if_only_one
	if(isset($_POST['rp_hide_attribute_if_only_one']) && $_POST['rp_hide_attribute_if_only_one'] !== NULL && $_POST['rp_hide_attribute_if_only_one'] !== '' && in_array($_POST['rp_hide_attribute_if_only_one'], array('0', '1'))) {
		// reverse the value of posted value
		$_POST['rp_hide_attribute_if_only_one'] = ($_POST['rp_hide_attribute_if_only_one'] == '1') ? '0' : '1';
    	if(rp_get_option('rp_hide_attribute_if_only_one', FALSE) === FALSE) {
    		rp_add_option('rp_hide_attribute_if_only_one', $_POST['rp_hide_attribute_if_only_one']);
    	} else {
    		rp_update_option('rp_hide_attribute_if_only_one', $_POST['rp_hide_attribute_if_only_one']);
    	}
    }

	//rp_show_price_label_next_to_dm
	if(isset($_POST['rp_show_price_label_next_to_dm']) && $_POST['rp_show_price_label_next_to_dm'] !== NULL && $_POST['rp_show_price_label_next_to_dm'] !== '' && in_array($_POST['rp_show_price_label_next_to_dm'], array('0', '1'))) {
    	if(rp_get_option('rp_show_price_label_next_to_dm', FALSE) === FALSE) {
    		rp_add_option('rp_show_price_label_next_to_dm', $_POST['rp_show_price_label_next_to_dm']);
    	} else {
    		rp_update_option('rp_show_price_label_next_to_dm', $_POST['rp_show_price_label_next_to_dm']);
    	}
    }

	if(isset($_POST['rp_require_choosing_color']) && $_POST['rp_require_choosing_color'] !== NULL && $_POST['rp_require_choosing_color'] !== '' && in_array($_POST['rp_require_choosing_color'], array('0', '1'))) {
    	if(rp_get_option('wp_repair_require_choosing_color', FALSE) === FALSE) {
    		rp_add_option('wp_repair_require_choosing_color', $_POST['rp_require_choosing_color']);
    	} else {
    		rp_update_option('wp_repair_require_choosing_color', $_POST['rp_require_choosing_color']);
    	}
    }

	if(isset($_POST['rp_automatically_fix_mobile_styling']) && $_POST['rp_automatically_fix_mobile_styling'] !== NULL && $_POST['rp_automatically_fix_mobile_styling'] !== '' && in_array($_POST['rp_automatically_fix_mobile_styling'], array('0', '1'))) {
		if(rp_get_option('rp_automatically_fix_mobile_styling', FALSE) === FALSE) {
			rp_add_option('rp_automatically_fix_mobile_styling', $_POST['rp_automatically_fix_mobile_styling']);
		} else {
			rp_update_option('rp_automatically_fix_mobile_styling', $_POST['rp_automatically_fix_mobile_styling']);
		}
	}

    if(isset($_POST['rp_skip_steps']) && $_POST['rp_skip_steps'] !== NULL && $_POST['rp_skip_steps'] !== '' && in_array($_POST['rp_skip_steps'], array('0', '1'))) {
    	if(rp_get_option('wp_repair_skip_steps', FALSE) === FALSE) {
    		rp_add_option('wp_repair_skip_steps', $_POST['rp_skip_steps']);
    	} else {
    		rp_update_option('wp_repair_skip_steps', $_POST['rp_skip_steps']);
    	}
    }

    if(isset($_POST['repair_list_margin_top'])) {
    	if((float) $_POST['repair_list_margin_top'] > 120) {
    		$_POST['repair_list_margin_top'] = 120;
    	}
    	if(rp_get_option('repair_list_margin_top', FALSE) === FALSE) {
    		rp_add_option('repair_list_margin_top', (float) $_POST['repair_list_margin_top']);
    	} else {
    		rp_update_option('repair_list_margin_top', (float) $_POST['repair_list_margin_top']);
    	}
    }

	if(isset($_POST['rp_mobile_side_padding'])) {
    	if((float) $_POST['rp_mobile_side_padding'] > 25) {
    		$_POST['rp_mobile_side_padding'] = 25;
    	}
    	if(rp_get_option('rp_mobile_side_padding', FALSE) === FALSE) {
    		rp_add_option('rp_mobile_side_padding', (float) $_POST['rp_mobile_side_padding']);
    	} else {
    		rp_update_option('rp_mobile_side_padding', (float) $_POST['rp_mobile_side_padding']);
    	}
    }
   
    $rpQuery->query("UPDATE $company_information SET company_logo = '".rp_escape_sql($c_logo)."', company_theme_color = '".rp_escape_sql($c_theme_color)."' WHERE company_id='".rp_escape_sql($company_id)."'");
    echo "<script>location.replace('admin.php?page=wp_repair_settings&section=styling');</script>";
}
function wpRepairLoadSidebar($name = '') {
	$fileName = WP_REPAIR_PLUGIN_PATH.'html/sidebar.php';
	$fileName = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $fileName);
	require_once $fileName;
	wp_repair_admin_settings_sidebar($name);
}

$_rp_company_email = rp_get_settings_company_email();

?>
<style type="text/css">
	.bg-with-border{
		padding: 3%;
	}
	.wp-general-info{
		padding: 15px;
		font-size: 13px;
        margin-top: 25px;
    width: auto;
	}
	.wp-general-info.recaptcha-popup-btn {
		background-color: #fff;
		border: 2px solid #1275c2;
		color: #1275c2;
		width: 240px;
		box-sizing: border-box;
	}
	.wp-general-info.recaptcha-popup-btn.recaptcha-active {
		border-left: 12px solid #008000;
	}
	.wp-general-info.recaptcha-popup-btn img {
		max-width: 24px;
		max-height: 24px;
		vertical-align: middle;
		margin-right: 5px;
	}
	.rp_is_synced {
		margin-bottom: 0px;
	}
	.rp_is_synced small {
		display: table;
		font-size: 10px;
	}
	@media screen and (max-width: 768px) {
		.wp-repair-col-3 .main-section .section-two{
			margin-top: 0px;
			width: 100%;
		}
	}
	.wp-repair-col-3{
		margin-top: 220px;
		float: right;
	}
	.is_closed{
		width: 26px !important;
	}
	.wp-repair-col-4.main-section{
		padding: 20px 20px 20px 20px;
	}
	.wp-repair-col-4.main-section.section-two {
		padding: 20px 20px 30px 20px;
	}
	.days-setting-table input.has-breaktime-error {
		box-shadow: 0 0 0 1px #b12222;
	}
	.wp-repair-alert.error {
		margin-top: 0px;
		margin-bottom: 12px;
		background: #f8d7da;
		color: #721c24;
		border-radius: 8px;
		border: 2px solid #f5c6cb;
		padding: 12px;
		font-size: 13px;
		width: calc(100% - 60px);
		line-height: 1.4em;
	}
    .wp-repair-main-section-heading {
    height: 45px;
	}
	.clearfix {
		clear: both;
	}
	.clearfix::after {
		content: "";
		display: table;
		clear: both;
	}
	.wp-repair-special-col {
		padding: 0px 20px;
		padding-top: 20px;
		padding-bottom: 30px;
	}
	.nmb-0 {
		margin-bottom: 0px;
	}
	.sec-3.mobile {
		display: none;
	}
	.sec-3.desktop {
		display: block;
	}
	@media(max-width: 424px) {
		.wp-repair-special-col {
			padding-left: 15px;
			padding-right: 15px;
		}
	}
	@media(max-width: 1210px) {
		.sec-3.desktop {
			display: none;
		}
		.sec-3.mobile {
			display: block;
		}
		.wp-repair-col-4.main-section.section-two > .tax-fields.first.special-mobile {
			margin-top: 5px !important;
		}
		.wp-repair-col-4.main-section.section-two {
			padding-bottom: 0px;
		}
		.wp-repair-special-col {
			padding-top: 0px;
			position: relative;
			top: -20px;
		}
		.wp-repair-special-col h2 {
			margin-top: 0px;
		}
	}
</style>
<style type="text/css">
	.va-full-width-modal-main.trans-modal .wp-repair-input-group {
		margin-top: 10px;
	}
	.va-full-width-modal-main {
		max-width: 475px;
		max-height: 80%;
		overflow-y: auto;
	}
	.va-full-width-modal .flag-img {
		width: 36px;
		display: inline-block;
		position: relative;
		top: 9px;
	}
	.va-full-width-modal .input-cont {
		width: calc(100% - 40px);
		display: inline-block;
	}
	.va-full-width-modal .va-button.va-submit {
		margin-top: 12px;
		display: inline-table;
		float: right;
		margin-bottom: 15px;
		position: relative;
		right: 3px;
		min-width: 80px;
	}
	.va-full-width-modal.recaptcha-popup-modal .va-save-recaptcha {
		float: unset;
		background: #1275c2;
		color: #fff;
		font-weight: 500;
		border: 1px solid #1275c2;
		border-radius: 5px;
		padding: 8px 15px;
		cursor: pointer;
		font-size: 14px;
		margin-top: 25px;
	}
	.globe-icon-translation {
		cursor: pointer;
		width: calc(100% - 2px);
		height: 42px;
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
	}

	.clearfix {
		display: block;
	}

	.clearfix::after {
		content: "";
		clear: both;
		display: table;
	}
	.globe-icon-i {
		position: absolute;
		top: 50%;
		transform: translateY(-50%);
		right: 0px;
		line-height: 0em;
		background: #fff;
		padding: 0px 8px;
	}
.mce-panel.mce-floatpanel .mce-widget.mce-btn.mce-primary.mce-abs-layout-item.mce-first.mce-btn-has-text {
	background-color: #2d8ac7;
}
.mce-btn {
	background-color: #fff;
}
.mce-panel {
	background-color: #fff;
}
.wp-repair-input-group > .mce-panel.mce-container {
	border-width: 2px;
		border-radius: 8px;
		border: 2px solid #cfcfcf !important;
		box-sizing: border-box;
		padding: 0px 2px;
	transition: border-color 0.3s;
}
.mce-path {
	display: none;
}
.mce-statusbar.mce-container {
	border: 0px;
}
.mce-container-body .mce-resizehandle {
	right: 2px;
		bottom: 2px;
}
.mce-container-body.mce-stack-layout {
	padding: 1px;
}
.wp-repair-input-group label {
	z-index: 10;
}
.wp-repair-input-group > .mce-panel.mce-container:hover {
	border: 2px solid #2781c7 !important;
	box-shadow: none;
	outline: 0;
}
.mce-container,
.mce-content-body,
.mce-menubar .mce-menubtn button span,
.mce-menu-item,
.mce-menu-item .mce-ico, .mce-menu-item .mce-text  {
	color: #454545;
}
div.mce-edit-area {
	min-height: 200px;
}
div.mce-edit-area iframe {
	min-height: 200px;
}
/*.mce-container.mce-menubar.mce-toolbar {
	display: none;
}*/
iframe #tinymce {
	background-color: #000;
}
.wp-repair-col-4.pdf-offer.main-section.clearfix {
	padding-bottom: 15px;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	width: 300px;
}
.location-table {
	margin: 0px;
	padding: 15px;
	margin-bottom: 20px;
}
.location-table .ractions-td .switch {
	float: right;
}

.location-table .details-container .wp-repair-inner-col.section-1 {
	float: left;
	width: 55%;
	box-sizing: border-box;
}
.location-table .details-container .wp-repair-inner-col.section-2 {
	float: left;
	width: 45%;
	padding: 0px 20px;
	padding-top: 8px;
	box-sizing: border-box;
}

.location-table td.shortcode-heading {
	font-size: 9px;
	font-weight: 700;
	padding: 3px 0px;
	color: #61666b;
}

.location-table td.actual-shortcode {
	font-size: 9px;
	font-weight: 600;
	padding: 3px 0px;
	color: #61666b;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	font-size: 14px;
}

.table-responsive.location-table button.plus-icon.see-more {
	text-align: left;
}
.table-responsive.location-table button.plus-icon.see-more .text {
	width: 250px;
	vertical-align: middle;
	display: inline-table;
}
.table-responsive.location-table button.plus-icon.see-more .dropicon {
	vertical-align: middle;
}

@media(max-width: 1140px) {
	.location-table .details-container .wp-repair-inner-col.section-1 {
		width: 100%;
	}
	.location-table .details-container .wp-repair-inner-col.section-2 {
		width: 100%;
		padding: 0px;
		padding-top: 8px;
	}
}

@media(max-width: 500px) {
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 200px;
	}
}


@media(max-width: 420px) {
	.table-responsive.location-table .wp-repair-input-group {
	    left: 0px;
	}
	.apply-tax-rate .td.text {
		width: 70%;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 140px;
	}
	.wp-repair-input-group input {
		width: 99%;
	}
}
@media(max-width: 370px) {
	.location-table {
		padding: 10px;
	}
	.table-responsive.location-table button.plus-icon.see-more .text {
		width: 100px;
		font-size: 13px;
	}
}
/* Customised Modal */


.va-modal-container {
	position: fixed;
	bottom: 85px;
	left: 30px;
	background: rgba(0,0,0,0.3);
	z-index: 99999;
	width: 300px;
}

.va-modal-main {
	border-radius: 8px;
	width: 100%;
	max-width: 450px;
	height: auto;
	background: #fff;
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	box-shadow: 0px 0px 5px rgb(0 0 0 / 30%);
}

.va-modal-container.unsaved .va-modal-main {
	background: #a81019;
}

.va-modal-container.saved .va-modal-main {
	background: var(--west--wales--maincolor);
}

.va-modal-inner {
	padding: 15px;
}

.va-modal-inner p {
	font-size: 18px;
	display: table;
	margin: 0px;
	color: var(--west--wales--maincolor);
	max-width: 240px;
	font-weight: 400;
}

.va-modal-container.unsaved .va-modal-inner p,
.va-modal-container.saved .va-modal-inner p {
	color: #fff;
}

.va-modal-inner a {
	display: table;
	margin-top: 8px;
}

.va-modal-container .va-close-modal,
.va-full-width-modal .va-close-modal {
	position: absolute;
	top: 8px;
	right: 8px;
	background: #efefef;
	padding: 8px;
	line-height: 1em;
	cursor: pointer;
	border: 1px solid #aaaa;
	background: #efefef;
	border-radius: 4px;
	outline: 0 !important;
	box-shadow: unset !important;
	transition: all 0.3s;
}

.va-modal-container .va-close-modal:hover,
.va-modal-container .va-close-modal:active,
.va-modal-container .va-close-modal:focus,
.va-full-width-modal .va-close-modal:hover,
.va-full-width-modal .va-close-modal:active,
.va-full-width-modal .va-close-modal:focus  {
	background: #fafafa;
}

.va-full-width-modal .va-modal-title {
	font-weight: 400;
    max-width: 93%;
    font-size: 18px;
    margin-top: 0px;
    margin-bottom: 10px;
    color: #1275c2;
}

.va-full-width-modal .va-modal-title b {
	font-weight: 700;
}

.va-modal-container.saved .va-modal-inner a:hover,
.va-modal-container.saved .va-modal-inner a:active,
.va-modal-container.saved .va-modal-inner a:focus {
	background: #fafafa;
	color: var(--west--wales--maincolor);
}

.va-container.property-details .va-content-box .call-to-action .va-button-default {
	background: #fafafa;
	border: 1px solid #fafafa;
	color: var(--west--wales--maincolor);
	font-weight: 400;
}

.va-container.property-details .va-content-box .call-to-action .va-button-default:hover,
.va-container.property-details .va-content-box .call-to-action .va-button-default:active,
.va-container.property-details .va-content-box .call-to-action .va-button-default:focus {
	background: #fff;
	color: var(--west--wales--maincolor);
	border: 1px solid #fafafa;
}

.va-container.property-details .va-content-box .call-to-action .va-button.va-fav-icon-details-page.prop-already-saved {
	color: #a81019;
	background: rgb(168 16 25 / 10%);
}

.va-container.property-details .va-content-box .call-to-action .va-button.va-fav-icon-details-page .fa-spinner {
	font-size: 20px;
}

.va-container .set-alert-buttons {
	margin: 0px;
}

.va-col-md-12.alert-btn-cols {
	padding: 15px;
}

.va-full-width-modal {
	position: fixed;
	top: 0px;
	left: 0px;
	width: 100%;
	height: 100%;
	z-index: 10000;
	background: rgba(0,0,0,0.3);
}

.va-full-width-modal-main {
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	background: #fff;
	box-shadow: 0px 0px 5px rgb(0 0 0 / 30%);
	width: 100%;
	max-width: 450px;
	border-radius: 8px;
}

.va-full-width-modal-main p {
	font-size: 14px;
}

.va-full-width-modal-inner {
	padding: 15px; 
}

.va-full-width-modal .va-form-group label {
	display: table;
}

.va-full-width-modal .va-form-group input {
	width: 100%;
	border-radius: 5px;
	display: table;
	margin-bottom: 8px;
}

.va-button.va-submit,
.va-button.va-submit:hover,
.va-button.va-submit:active,
.va-button.va-submit:focus {
	background: #1275c2;
	color: #fff;
	font-weight: 500;
	border: 1px solid #1275c2;
	border-radius: 5px;
	padding: 8px 15px;
	cursor: pointer;
	font-size: 14px;
}

button.va-button-primary,
button.va-button-primary:hover,
button.va-button-primary:active,
button.va-button-primary:focus {
	border-color: #1275c2 !important;
	background: #1275c2 !important;
	background-color: #1275c2 !important;
}

.va-modal-title.blue-color {
	color:  #1275c2 !important;
	font-weight: 500;
}

</style>
<form method="post" action="" enctype="multipart/form-data">
<?php
rp_csrf_token_input_field('styling');
?>
<div class="wp-repair-container">
	<div class="wp-repair-row">
		<div class="wp-repair-col-12 settings">
			<div class="repair-dl-rounded-container">
				<div class="wp-repair-row">
					<?php wpRepairLoadSidebar('styling'); ?>
					<div class="bg-with-border">
						<?php
						$breakTimeErrors = get_invalid_breaktimes_errors();
						if(!empty($breakTimeErrors)) {
							?>
							<div class="wp-repair-col-8 main-section">
								<?php
								if(in_array('invalid_break_time', $breakTimeErrors)) {
									?>
									<div class="wp-repair-alert error">Invalid time format for breaktime is detected in one or more locations.<br><b>Hint for fixing this issue:</b> Use <b>01:00 PM</b> or <b>13:00</b></div>
									<?php
								}
								?>
								<?php
								if(in_array('mistake_in_am_pm', $breakTimeErrors)) {
									?>
									<div class="wp-repair-alert error">Invalid use of breaktime is detected for one or more locations.<br><b>Hint for fixing this issue:</b> Breaktime must be between opening and closing hours.</div>
									<?php
								}
								?>
								<?php
								if(in_array('break_start_is_greater', $breakTimeErrors)) {
									?>
									<div class="wp-repair-alert error">Invalid use of breaktime is detected for one or more locations.<br><b>Hint for fixing this issue:</b> Breaktime end must be greater than breaktime start.</div>
									<?php
								}
								?>
							</div>
							<?php
						}
						?>
						<div class="wp-repair-col-4 main-section section-one">
							<div class="wp-repair-main-section-heading">
								<h2>
									<span class="light">Steps</span>
									<span class="bold">Styling</span>
								</h2>
								<p class="more-info">Customize the styling as you need</p>
							</div>
							<p class="company-logo-theme-color ptop-30">Company Logo</p>
							<div class="wp-repair-inner-col">
								<div class="sec-1">
									<div class="tr">
										<input type="text" name="c_logo" id="img-input" class="wp-repair-category-image-url" value="<?php echo $c_results[0]->company_logo?>" required readonly>
										<button type="button" class="wp-repair-cancel-link clear_img_input"><i class="fas fa-times"></i></button>
									</div>
									<div class="tr mt-10">
										<label for="upload_image" class="wp-repair-category-image-upload-button">Upload Picture <i class="fas fa-plus"></i></label>
              							<input type="file" onchange="readURL(this)" id="upload_image" style="display: none;" name="upload_image">					
									</div>
								</div>
								<div class="sec-2">
									<img class="current_img" src="<?php echo $c_results[0]->company_logo; ?>">
									<img class="new_image" src="">
								</div>
							</div>
							<p class="company-logo-theme-color ptop-30">Choose a theme color</p>
							<span class="wp-repair-repair-card theme-color">
								<div id="select-custom-color">
									<div class="wp-repair-input-group">
										<input class="color-text" type="text" name="" value="#<?php echo $c_results[0]->company_theme_color?>" maxlength="7">
									</div>
									<input id="c_theme_color" type="color" name="c_theme_color" value="#<?php echo $c_results[0]->company_theme_color?>" class="c_theme_color" required>
								</div>
							</span>
							<p class="company-logo-theme-color">Select Styling for Repair Box on Front-End</p>
							<span class="wp-repair-repair-card">
								<select class="coupons_select" name="repair_subtext" required>
									<?php
									$subTextoptions = array(
										'repair_duration' => 'Minimized',
										'repair_info' => 'Extended'
									);
									foreach ($subTextoptions as $optKey => $optValue) {
										?>
										<option <?php if(trim($repair_subtext) === $optKey) { echo 'selected="selected"'; } ?> value="<?php echo $optKey; ?>"><?php echo $optValue; ?></option>
										<?php
									}
									?>
								</select>
							</span>
							<div class="wp-repair-input-group">
								<p class="company-logo-theme-color">Margin-Top in Pixels for Fixed Repairs List on Front-End</p>
								<input type="number" min="0" max="120" class="user-info" name="repair_list_margin_top" value="<?php echo rp_get_option('repair_list_margin_top', 30); ?>" required>
							</div>
							<div class="tax-fields first" style="margin-top: 25px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  <input type="hidden" name="rp_automatically_fix_mobile_styling" value="0">
										  <input type="checkbox" name="rp_automatically_fix_mobile_styling" <?php if(rp_get_option('rp_automatically_fix_mobile_styling', '1') === '1') { echo 'checked="checked"'; } ?> value="1">
										  <span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Try to get 100% width for Front-End Shortcode (Mobile)</span>
									</div>
								</div>
							</div>
							<div class="wp-repair-input-group" style="<?php if(rp_get_option('rp_automatically_fix_mobile_styling', '1') === '1') { echo 'display:none;'; } ?>">
								<p class="company-logo-theme-color">Side padding in pixels for Front-End Shortcode (mobile)</p>
								<input type="number" min="0" max="25" class="user-info" name="rp_mobile_side_padding" value="<?php echo rp_get_option('rp_mobile_side_padding', '0'); ?>" required>
							</div>
                            <div class="sec-3 desktop">
								<button type="submit" name="update_company" id="update_company" class="wp-general-info">Save All Settings</button>
							</div>
						</div>
                        <div class="wp-repair-col-4 main-section section-two">
							<div class="wp-repair-main-section-heading" style="visibility: hidden;">
								<h2>
									<span class="light">Other</span>
									<span class="bold">Settings</span>
								</h2>
								<p class="more-info">Customize the front-end experience</p>
							</div>
							<div class="tax-fields first special-mobile" style="margin-top: 25px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  <input type="hidden" name="rp_skip_steps" value="0">
										  <input type="checkbox" name="rp_skip_steps" <?php if(rp_get_option('wp_repair_skip_steps', '1') === '1') { echo 'checked="checked"'; } ?> value="1">
										  <span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Skip a step if there is only 1 entry active</span>
									</div>
								</div>
							</div>
							<div class="tax-fields first" style="margin-top: 25px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  <input type="hidden" name="rp_require_choosing_color" value="0">
										  <input type="checkbox" name="rp_require_choosing_color" <?php if(rp_get_option('wp_repair_require_choosing_color', '1') === '1') { echo 'checked="checked"'; } ?> value="1">
										  <span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Require choosing color</span>
									</div>
								</div>
							</div>
							<div class="tax-fields first" style="margin-top: 25px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  <input type="hidden" name="rp_hide_attribute_if_only_one" value="0">
										  <input type="checkbox" name="rp_hide_attribute_if_only_one" <?php if(rp_get_option('rp_hide_attribute_if_only_one', '1') === '0') { echo 'checked="checked"'; } ?> value="1">
										  <span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Show repair attribute information if there is only one attribute</span>
									</div>
								</div>
							</div>
							<div class="tax-fields first" style="margin-top: 25px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  <input type="hidden" name="rp_show_price_label_next_to_dm" value="0">
										  <input type="checkbox" name="rp_show_price_label_next_to_dm" <?php if(rp_get_option('rp_show_price_label_next_to_dm', '1') === '1') { echo 'checked="checked"'; } ?> value="1">
										  <span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Show price label next to delivery methods</span>
									</div>
								</div>
							</div>
							<div class="tax-fields first" style="margin-top: 25px;">
								<div class="apply-tax-rate">
									<div class="td select">
										<label class="switch">
										  <input type="hidden" name="rp_whitelabel" value="0">
										  <input type="checkbox" name="rp_whitelabel" <?php if(rp_get_option('wp_repair_whitelabel', '0') === '1') { echo 'checked="checked"'; } ?> value="1">
										  <span class="slider round"></span>				
										</label>
									</div>
									<div class="td text">
										<span class="text">Whitelabel</span>
									</div>
								</div>
							</div>
							<button type="button" id="setup_google_recaptcha" class="wp-general-info recaptcha-popup-btn <?php if(rp_is_recaptcha_correctly_configured() === TRUE) { echo 'recaptcha-active'; } ?>">
								<img src="<?php echo WP_REPAIR_PLUGIN_URL; ?>assets/images/grecaptcha.png" />
							Google ReCaptcha
							</button>
							<div class="sec-3 mobile">
								<button type="submit" name="update_company" id="update_company" class="wp-general-info">Save All Settings</button>
							</div>
                        </div>
						<div class="wp-repair-special-col clearfix">
							<div class="wp-repair-main-section-heading" style="margin-bottom: 25px;">
								<h2>
									<span class="light">Steps</span>
									<span class="bold">Translations</span>
								</h2>
								<p class="more-info">Customize your customer interactions</p>
							</div>
							<?php
							$allowed = array(
								'Step 1',
								'Step 2',
								'Step 3',
								'Step 4',
								'Offer Popup',
								'Step 5',
								'Step 6',
								'Step wizard',
								'Searchbar',
								'Canceled Page'
							);
							foreach($category_based as $category => $keys) {
								if( !in_array($category, $allowed) ) {
									continue;
								}
							?>
								<div class="table-responsive location-table">
										<table class="table">
											<tbody>
												<tr class="closed">
													<td colspan="2">
														<button type="button" class="plus-icon see-more">
															<span class="dropicon">
																<i class="fas fa-plus"></i>
															</span>
															<span class="text"><?php echo $category; ?></span>
														</button>
													</td>
												</tr>
												<tr class="more-details">
													<td colspan="7">
														<div class="details-container">
															<div class="wp-repair-inner-col">
																<?php
																	foreach($keys as $lang_key) {

																		if( in_array( $lang_key, $enhanced_locations_translations ) && !$is_active_enhanced_locations ) {
																			continue;
																		}

																		if( in_array( $lang_key, array('the_price_was_updated_on') ) ) {
																			if( apply_filters('rp_dp_show_price_was_updated_on', FALSE) === FALSE ) {
																				continue;
																			}
																		}
																		$lang_value = $english_translations[$lang_key] ?? '';
																		$lang_value_translated = $wp_repair_lang[$lang_key] ?? '';

																		$lang_value_translated = str_replace('&quot;', '"', $lang_value_translated);

																		// limit $lang_value to only 8 words and add ... if more than 8 words
																		$words = explode(' ', $lang_value);
																		if( count($words) > 8 ) {
																			$words = array_slice($words, 0, 8);
																			$lang_value = implode(' ', $words) . '...';
																		}

																		?>
																		<div class="wp-repair-input-group">
																			<label><?php echo $lang_value; ?></label>
																			<input type="text" class="user-info" name="laltname[]" value="<?php echo htmlspecialchars($lang_value_translated);?>">
																			<div data-lang-key="<?php echo $lang_key; ?>" class="globe-icon-translation clearfix">
																				<div class="globe-icon-i">
																					<i class="fas fa-globe"></i>
																				</div>
																			</div>
																		</div>
																		<?php
																	}
																?>
															</div>
														</div>
													</td>
												</tr>
											</tbody>
										</table>
									</div>
								<?php
								}
								?>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
</form>
<?php
wp_enqueue_script('wp-repair-plugin-js', WP_REPAIR_PLUGIN_URL.'assets/js/main.js?what='.uniqid());
wp_enqueue_style('wp-repair-plugin-ui-css', WP_REPAIR_PLUGIN_URL.'assets/css/ui-by-zahran.css?what='.uniqid());
wp_enqueue_script('wp-repair-plugin-ui-js', WP_REPAIR_PLUGIN_URL.'assets/js/ui-by-zahran.js?what='.uniqid());
?>

<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/tinymce.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tinymce/4.5.6/jquery.tinymce.min.js"></script>
<script type="text/javascript">
	jQuery(document).on("keypress", "input", function(e){
		if(e.which == 13){
			e.preventDefault();
		}
	});
</script>

<?php
require_once WP_REPAIR_PLUGIN_PATH . 'html/translation-js.php';
?>
<script type="text/javascript">
	(function(window,document,$,undefined){
		jQuery(document).on("wpRepairReady", function(){
			let colorInputBindTimeout = false;
			jQuery("#select-custom-color input[name='c_theme_color']").on("change", function(){
				if(colorInputBindTimeout === false) {
					colorInputBindTimeout = true;
					jQuery(this).parent().find(".color-text").val(jQuery(this).val()).change();
					window.setTimeout(function(){
						colorInputBindTimeout = false;
					}, 100);
				}
			});
			jQuery("#select-custom-color .color-text").on("change", function(){
				let x = $(this).val();
				if(colorInputBindTimeout === false) {
					colorInputBindTimeout = true;
					jQuery("#select-custom-color input[name='c_theme_color']").val(x).change();
					window.setTimeout(function(){
						colorInputBindTimeout = false;
					}, 100);
				}
			});
			jQuery(".checkbox-custom").each(function(){
				$(this).on("click", function(){
					$(this).toggleClass('active');
				});
			});
			jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
				var parentCont = this;
			    jQuery(this).parent().on("click", function(){
			    	handleShowingOptions(this);
			    });
			    jQuery(this).find("li").on("click", function(){
			    	handleTheSelect(this, parentCont);
			    });
			});
			function closeAllOpenedSelectBoxes() {
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			}
			isCurrentElClicked(['.wp-repair-repair-card'], function(){
				jQuery(".wp-repair-repair-card > .more-card-options").each(function(){
					jQuery(this).hide();
					jQuery(this).parent().removeClass('active');
				});
			});
			window.canShowTheOptions = true;
			function canShowTheOptions() {
				if(window.canShowTheOptions === false) {
					window.canShowTheOptions = true;
					return false;
				}
				return true;
			}
			function isCurrentElClicked(el, func) {
				$("body").click(function(event) {
					result = false;
					el.forEach(function(ell){
						if(($(event.target).is(ell) || $(event.target).parents(ell).length !== 0)) {
							result = true;
						}
					});
					if(result === false) {
						func();
					}
				});
			}
			function handleShowingOptions(currentEl) {
				if(canShowTheOptions() === true) {
					jQuery(".wp-repair-repair-card").each(function(){
						if(this !== currentEl) {
							$(this).find(".more-card-options").hide();
						}
					});
					jQuery(currentEl).toggleClass('active');
					jQuery(currentEl).find(".more-card-options").toggle();
				}
			}
			function handleTheDeselect(currentEl, parentCont) {
				$(parentCont).parent().removeClass("active");
				$(parentCont).parent().find('.wp-repair-cselected-item i').remove();
				$(parentCont).parent().find('.wp-repair-cselected-item').append('<i class="fas fa-chevron-down"></i>');
				$(parentCont).parent().find('.text-all .selected-text').remove();
				$(parentCont).hide();
				$(parentCont).find("li").each(function(){
					$(this).removeClass("active");
				});
				window.canShowTheOptions = false;
			}
			function handleTheSelect(currentEl, parentCont) {
				var val = $(currentEl).find(".name").html();
				$(parentCont).parent().find('.wp-repair-cselected-item .name').html(val);
				var color_code = $(currentEl).find(".name .color-hex").html();
				$('.c_theme_color').val();
				$('.c_theme_color').val(color_code);
			}
		});
	}(window,document,jQuery));

	function readURL(input){
		jQuery("#img-input").val('');
		if(input.files && input.files[0]){
			var fi = input.files[0];
			var file_name = fi.name;
			jQuery("#img-input").val(file_name);
			var reader = new FileReader();
			reader.onload = function (e){
			//console.log(img);
			jQuery(".sec-2 .current_img").remove();
			jQuery(".sec-2 img").attr('src',e.target.result);
			}
			reader.readAsDataURL(input.files[0]);
		}
	}

	jQuery('.clear_img_input').on('click', function(){
		jQuery('#img-input').val('');
	});
</script>
<script type="text/javascript">
	jQuery("input[name='rp_automatically_fix_mobile_styling']").on('change', function(){
		if(jQuery(this).is(':checked')){
			jQuery("input[name='rp_mobile_side_padding']").parent().hide();
		}else{
			jQuery("input[name='rp_mobile_side_padding']").parent().show();
		}
	});
  	jQuery(".update_location").click(function(){
		var loc_id           = jQuery(this).data('id');
		var location_name    = jQuery("#location_name"+loc_id).val();
		var location_address = jQuery("#location_address"+loc_id).val();
		var location_city    = jQuery("#location_city"+loc_id).val();
		var google_maps_link    = jQuery("#google_maps_link"+loc_id).val();
		var location_email    = jQuery("#location_email"+loc_id).val();
		var cs_id =[];
	    jQuery('input[id^=cs_id'+loc_id+']').each(function(){
	      cs_id.push(jQuery(this).val());
	    });
		var cs_day =[];
	    jQuery('input[id^=cs_day'+loc_id+']').each(function(){
	      cs_day.push(jQuery(this).val());
	    });
		var cs_open_timing =[];
	    jQuery('input[id^=cs_open_timing'+loc_id+']').each(function(){
	      cs_open_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				open_time_length= cs_open_timing.length;
			}
	    });
		var cs_close_timing =[];
	    jQuery('input[id^=cs_close_timing'+loc_id+']').each(function(){
	      cs_close_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				close_time_length= cs_close_timing.length;
			}
	    });
		var cs_breaktime_from =[];
	    jQuery('input[id^=cs_breaktime_from'+loc_id+']').each(function(){
	      cs_breaktime_from.push(jQuery(this).val());
	    });
		var cs_breaktime_to =[];
	    jQuery('input[id^=cs_breaktime_to'+loc_id+']').each(function(){
	      cs_breaktime_to.push(jQuery(this).val());
	    });
		var is_closed =[];
	    jQuery('input[id^=is_closed'+loc_id+']').each(function(){
	      	is_closed.push(jQuery(this).is(':checked')); 
	    });
	    if(loc_id != '' && location_name != '' && location_address != '' && location_city != '' &&
			cs_id != '' && cs_day != '' && open_time_length == '7' && close_time_length == '7'){
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'update_locations',location_name:location_name,location_address:location_address,location_city:location_city,google_maps_link:google_maps_link,location_email:location_email,cs_id:cs_id,cs_day:cs_day,cs_open_timing:cs_open_timing,cs_close_timing:cs_close_timing,cs_breaktime_from:cs_breaktime_from,cs_breaktime_to:cs_breaktime_to,is_closed:is_closed,loc_id:loc_id},
				success: function(data) {
		      		location.reload();
		      	}
			});
		}else{
			alert('Please add location detail and write open and close timings for all days.');
		}
	});
</script>
<script type="text/javascript">
  	jQuery(".add_location").click(function(){
		var loc_name    = jQuery(".loc_name").val();
		var loc_address = jQuery(".loc_address").val();
		var loc_address = jQuery(".loc_address").val();
		var loc_city    = jQuery(".loc_city").val();
		var loc_google_map    = jQuery(".loc_google_map").val();
		var loc_email    = jQuery(".loc_email").val();
		var cs_day =[];
	    jQuery('input[class^=csday]').each(function(){
	      cs_day.push(jQuery(this).val());
	    });
		var cs_open_timing =[];
	    jQuery('input[class^=csopen_timing]').each(function(){
	      cs_open_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				open_time_length= cs_open_timing.length;
			}
	    });
		var cs_close_timing =[];
	    jQuery('input[class^=csclose_timing]').each(function(){
	      cs_close_timing.push(jQuery(this).val());
	      	if (jQuery(this).val() != '') {
				close_time_length= cs_close_timing.length;
			}
	    });
		var cs_breaktime_from =[];
	    jQuery('input[class^=csbreaktime_from]').each(function(){
	      cs_breaktime_from.push(jQuery(this).val());
	    });
		var cs_breaktime_to =[];
	    jQuery('input[class^=csbreaktime_to]').each(function(){
	      cs_breaktime_to.push(jQuery(this).val());
	    });
		var is_closed =[];
	    jQuery('input[class^=is_closed]').each(function(){
	      	is_closed.push(jQuery(this).is(':checked')); 
	    });
	    if(loc_name != '' && loc_address != '' && loc_city != '' && cs_day != '' && open_time_length == '7' && close_time_length == '7'){
			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'add_location',loc_name:loc_name,loc_google_map:loc_google_map,loc_email:loc_email,loc_address:loc_address,loc_city:loc_city,cs_day:cs_day,cs_open_timing:cs_open_timing,cs_close_timing:cs_close_timing,cs_breaktime_from:cs_breaktime_from,cs_breaktime_to:cs_breaktime_to,is_closed:is_closed},
				success: function(data) {
		      		location.reload();
		      	}
			});
		}else{
			alert('Please add location detail and write open and close timings for all days.');
		}
	});
</script>
<script type="text/javascript">
	jQuery(".delete_location").click(function(){
		if(confirm('Are you sure you want to delete this location?')) {
			var loc_id = jQuery(this).data("id");
			repairPluginUI.ajax({
	          	type:'POST',
	          	url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
		      	data: {action:'delete_location',loc_id:loc_id},
	      		success: function(data) {
		      		location.reload();
		      	}
		    });
		}
	});
	jQuery(document).on('input', '.days-setting-table input.has-breaktime-error', function(){
		jQuery(this).removeClass('has-breaktime-error');
	});

	jQuery("#setup_google_recaptcha").on('click', function(){

		var btn = this;
		jQuery(btn).addClass("processing");
		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i class="fas fa-spinner fa-spin"></i>');

		repairPluginUI.ajax({
			type:'GET',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {
				action:'rp_get_recaptcha_info',
			},
			success: function(data) {
				var response = '';
				try {
					response = JSON.parse(data);
				} catch (e) {
					
				}
				if(response && response.success) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					let rp_enable_recaptcha = '';
					if(response.enable_protection == 1) {
						rp_enable_recaptcha = 'checked="checked"';
					}
					let hide_recaptcha_badge = '';
					if(response.hide_recaptcha_badge == 1) {
						hide_recaptcha_badge = 'checked="checked"';
					}
					window._showFullWidthModal(
						`<p class="va-modal-title">Setup Google reCAPTCHA</p>
						<p class="va-modal-subtitle">Enter your Google reCAPTCHA v3 API keys to protect the appointment system from spam.</p>
						<div class="wp-repair-input-group">
							<p class="company-logo-theme-color">Site Key</p>
							<input type="text" class="user-info" name="recaptcha_site_key" value="${response.site_key}">
						</div>
						<div class="wp-repair-input-group">
							<p class="company-logo-theme-color">Secret Key</p>
							<input type="text" class="user-info" name="recaptcha_secret_key" value="${response.secret_key}">
						</div>
						<div class="tax-fields first" style="margin-top: 20px;">
							<div class="apply-tax-rate">
								<div class="td select">
									<label class="switch">
										<input type="hidden" name="rp_enable_recaptcha" value="0">
										<input type="checkbox" name="rp_enable_recaptcha" value="1" ${rp_enable_recaptcha}>
										<span class="slider round"></span>				
									</label>
								</div>
								<div class="td text">
									<span class="text">Enable Protection</span>
								</div>
							</div>
						</div>
						<div class="tax-fields first" style="margin-top: 20px;">
							<div class="apply-tax-rate">
								<div class="td select">
									<label class="switch">
										<input type="hidden" name="hide_recaptcha_badge" value="0">
										<input type="checkbox" name="hide_recaptcha_badge" value="1" ${hide_recaptcha_badge}>
										<span class="slider round"></span>				
									</label>
								</div>
								<div class="td text">
									<span class="text">Hide reCAPTCHA Badge</span>
								</div>
							</div>
						</div>
						<input type="hidden" name="alert" value="1">
						<button type="submit" class="va-save-recaptcha">
							Save Changes
						</button>`,
						'recaptcha-popup-modal'
					);
				} else {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			},
			error: function(response) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});
	});

	jQuery(document).on('click', 'button.va-save-recaptcha', function(){
		var btn = this;
		jQuery(btn).addClass("processing");
		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i class="fas fa-spinner fa-spin"></i>');
		let rp_enable_recaptcha = jQuery('input[name="rp_enable_recaptcha"]').is(':checked') ? 1 : 0;
		let hide_recaptcha_badge = jQuery('input[name="hide_recaptcha_badge"]').is(':checked') ? 1 : 0;
		let recaptcha_site_key = jQuery('input[name="recaptcha_site_key"]').val();
		let recaptcha_secret_key = jQuery('input[name="recaptcha_secret_key"]').val();
		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {
				action:'rp_save_recaptcha_info',
				rp_enable_recaptcha: rp_enable_recaptcha,
				hide_recaptcha_badge: hide_recaptcha_badge,
				recaptcha_site_key: recaptcha_site_key,
				recaptcha_secret_key: recaptcha_secret_key
			},
			success: function(data) {
				var response = '';
				try {
					response = JSON.parse(data);
				} catch (e) {
					
				}
				if(response && response.success) {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					repairPluginUI.alert_success('reCaptcha settings updated successfully.');
					if( response.correctly_configured && response.correctly_configured == 1 ) {
						jQuery(".recaptcha-popup-btn").addClass("recaptcha-active");
					} else {
						jQuery(".recaptcha-popup-btn").removeClass("recaptcha-active");
					}
					jQuery(".va-close-modal").click();
				} else {
					jQuery(btn).html(btndata);
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			},
			error: function(response) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});
	});
</script>
