<?php
// Exit if accessed directly
defined( 'ABSPATH' ) || exit;
?>
<script>

window.rp_init_tiny_mce = function(selector = '', noti_type = '') {

	if( jQuery(selector).length == 0 ) {
		return;
	}

	jQuery(selector).parents('.va-full-width-modal-main').css({'max-width': '725px', 'width': '90%'});

	if(noti_type != 'offer' && noti_type != 'pickup_service' && noti_type != 'repair_on_location' && noti_type != 'ship_device_instructions') {
		tinymce.init({
			selector: selector,
			menubar: ['newmenu', 'tools'],
			convert_urls: false,
			menu: {
				newmenu: {title: 'Dynamic Order Information', items: 'customername customeremail customerphone customernotes newmenuitemdeliverydate newmenuitemdeliverytime newmenuitem2 newmenuitem newmenuitemdeliverymethod newmenuitem5 newmenuitem4 newmenuitem3 newmenuitemcolor ordersummary shopname newmenuitem6 <?php if( rp_is_active_enhanced_locations_addon() === true ) { echo 'locationtelephone '; } ?>locationaddress locationzipcodecity newmenuitem8 newmenuitem7'},
				tools: {title: 'Inspect', items: 'code'}
			},
			plugins: ['link','code'],
			setup: function (editor) {
				editor.addMenuItem('customername', {
					text:  'Customer Name',
					context: 'newmenu',
					onselect: function () { marker =editor.insertContent(createVariableLook('$CustomerName$')); }
				});
				editor.addMenuItem('customeremail', {
					text:  'Customer Email',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerEmail$')); }
				});
				editor.addMenuItem('customerphone', {
					text:  'Customer Phone',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerPhone$')); }
				});
				editor.addMenuItem('customernotes', {
					text:  'Customer Notes',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerNotes$')); }
				});
				editor.addMenuItem('newmenuitem', {
					text:  'Created Time',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CreatedTime$')); }
				});
				editor.addMenuItem('newmenuitem2', {
					text: 'Created Date',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CreatedDate$')); }
				});
				editor.addMenuItem('newmenuitem3', {
					text: 'Model',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Model$')); }
				});
				editor.addMenuItem('newmenuitemcolor', {
					text: 'Color',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Color$')); }
				});
				editor.addMenuItem('newmenuitem4', {
					text: 'Brand',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Brand$')); }
				});
				editor.addMenuItem('newmenuitem5', {
					text: 'Category',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Category$')); }
				});
				editor.addMenuItem('ordersummary', {
					text: 'Order Summary',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$OrderSummary$')); }
				});
				editor.addMenuItem('shopname', {
					text: 'Shop Name',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$ShopName$')); }
				});
				editor.addMenuItem('newmenuitem6', {
					text: 'Location Name',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationName$')); }
				});
				editor.addMenuItem('locationaddress', {
					text: 'Location Address',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationAddress$')); }
				});
				editor.addMenuItem('locationzipcodecity', {
					text: 'Location Zipcode + City',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationZipcodeCity$')); }
				});
				<?php
				if( rp_is_active_enhanced_locations_addon() === true ) {
					?>
					editor.addMenuItem('locationtelephone', {
						text: 'Location Telephone',
						context: 'newmenu',
						onselect: function () { editor.insertContent(createVariableLook('$LocationTelephone$')); }
					});
					<?php
				}
				?>
				editor.addMenuItem('newmenuitemdeliverymethod', {
					text: 'Delivery Method',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$DeliveryMethod$')); }
				});
				editor.addMenuItem('newmenuitemdeliverytime', {
					text: 'Appointment Time',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$AppointmentTime$')); }
				});
				editor.addMenuItem('newmenuitemdeliverydate', {
					text: 'Appointment Date',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$AppointmentDate$')); }
				});
				editor.addMenuItem('newmenuitem7', {
					text: 'Cancel Link',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('[cancel="Cancel Appointment"]')); }
				});
				editor.addMenuItem('newmenuitem8', {
					text: 'Reschedule Link',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('[RescheduleLink="Click here to reschedule your appointment"]')); }
				});
			}
		});
	} else if(noti_type === 'pickup_service' || noti_type === 'repair_on_location') {
		tinymce.init({
			selector: selector,
			menubar: ['newmenu', 'tools'],
			convert_urls: false,
			menu: {
				newmenu: {title: 'Dynamic Order Information', items: 'customername customeremail customerphone customerhouseno customerstreetaddress customercity customerzipcode customernotes newmenuitemdeliverydate newmenuitemdeliverytime newmenuitem2 newmenuitem newmenuitemdeliverymethod newmenuitem5 newmenuitem4 newmenuitem3 newmenuitemcolor ordersummary shopname newmenuitem6 <?php if( rp_is_active_enhanced_locations_addon() === true ) { echo 'locationtelephone '; } ?>locationaddress locationzipcodecity newmenuitem8 newmenuitem7'},
				tools: {title: 'Inspect', items: 'code'}
			},
			plugins: ['link','code'],
			setup: function (editor) {
				editor.addMenuItem('customername', {
					text:  'Customer Name',
					context: 'newmenu',
					onselect: function () { marker =editor.insertContent(createVariableLook('$CustomerName$')); }
				});
				editor.addMenuItem('customeremail', {
					text:  'Customer Email',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerEmail$')); }
				});
				editor.addMenuItem('customerphone', {
					text:  'Customer Phone',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerPhone$')); }
				});
				editor.addMenuItem('customerhouseno', {
					text:  'Customer House No',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerHouseNo$')); }
				});
				editor.addMenuItem('customerstreetaddress', {
					text:  'Customer Street Address',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerStreetAddress$')); }
				});
				editor.addMenuItem('customercity', {
					text:  'Customer City',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerCity$')); }
				});
				editor.addMenuItem('customerzipcode', {
					text:  'Customer Zipcode',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerZipcode$')); }
				});
				editor.addMenuItem('customernotes', {
					text:  'Customer Notes',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerNotes$')); }
				});
				editor.addMenuItem('newmenuitem', {
					text:  'Created Time',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CreatedTime$')); }
				});
				editor.addMenuItem('newmenuitem2', {
					text: 'Created Date',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CreatedDate$')); }
				});
				editor.addMenuItem('newmenuitem3', {
					text: 'Model',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Model$')); }
				});
				editor.addMenuItem('newmenuitemcolor', {
					text: 'Color',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Color$')); }
				});
				editor.addMenuItem('newmenuitem4', {
					text: 'Brand',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Brand$')); }
				});
				editor.addMenuItem('newmenuitem5', {
					text: 'Category',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Category$')); }
				});
				editor.addMenuItem('ordersummary', {
					text: 'Order Summary',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$OrderSummary$')); }
				});
				editor.addMenuItem('shopname', {
					text: 'Shop Name',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$ShopName$')); }
				});
				editor.addMenuItem('newmenuitem6', {
					text: 'Location Name',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationName$')); }
				});
				editor.addMenuItem('locationaddress', {
					text: 'Location Address',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationAddress$')); }
				});
				editor.addMenuItem('locationzipcodecity', {
					text: 'Location Zipcode + City',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationZipcodeCity$')); }
				});
				<?php
				if( rp_is_active_enhanced_locations_addon() === true ) {
					?>
					editor.addMenuItem('locationtelephone', {
						text: 'Location Telephone',
						context: 'newmenu',
						onselect: function () { editor.insertContent(createVariableLook('$LocationTelephone$')); }
					});
					<?php
				}
				?>
				editor.addMenuItem('newmenuitemdeliverymethod', {
					text: 'Delivery Method',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$DeliveryMethod$')); }
				});
				editor.addMenuItem('newmenuitemdeliverytime', {
					text: 'Appointment Time',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$AppointmentTime$')); }
				});
				editor.addMenuItem('newmenuitemdeliverydate', {
					text: 'Appointment Date',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$AppointmentDate$')); }
				});
				editor.addMenuItem('newmenuitem7', {
					text: 'Cancel Link',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('[cancel="Cancel Appointment"]')); }
				});
				editor.addMenuItem('newmenuitem8', {
					text: 'Reschedule Link',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('[RescheduleLink="Click here to reschedule your appointment"]')); }
				});
			}
		});
	} else if(noti_type === 'ship_device_instructions') {
		tinymce.init({
			selector: selector,
			menubar: ['newmenu', 'tools'],
			convert_urls: false,
			menu: {
				newmenu: {title: 'Dynamic Order Information', items: 'shipdeviceaddress'},
				tools: {title: 'Inspect', items: 'code'}
			},
			plugins: ['link','code'],
			setup: function (editor) {
				editor.addMenuItem('shipdeviceaddress', {
					text:  'Ship Device Address',
					context: 'newmenu',
					onselect: function () { marker =editor.insertContent(createVariableLook('$ShipDeviceAddress$')); }
				});
			}
		});		
	} else {
		tinymce.init({
			selector: selector,
			menubar: ['newmenu', 'tools'],
			convert_urls: false,
			menu: {
				newmenu: {title: 'Dynamic Order Information', items: 'customername customeremail customerphone customernotes newmenuitemdeliverydate newmenuitemdeliverytime newmenuitem2 newmenuitem newmenuitemdeliverymethod newmenuitem5 newmenuitem4 newmenuitem3 newmenuitemcolor ordersummary shopname newmenuitem6 <?php if( rp_is_active_enhanced_locations_addon() === true ) { echo 'locationtelephone '; } ?>locationaddress locationzipcodecity finalize_button newmenuitem7'},
				tools: {title: 'Inspect', items: 'code'}
			},
			plugins: ['link','code'],
			setup: function (editor) {
				editor.addMenuItem('customername', {
					text:  'Customer Name',
					context: 'newmenu',
					onselect: function () { marker =editor.insertContent(createVariableLook('$CustomerName$')); }
				});
				editor.addMenuItem('customeremail', {
					text:  'Customer Email',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerEmail$')); }
				});
				editor.addMenuItem('customerphone', {
					text:  'Customer Phone',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerPhone$')); }
				});
				editor.addMenuItem('customernotes', {
					text:  'Customer Notes',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CustomerNotes$')); }
				});
				editor.addMenuItem('newmenuitem', {
					text:  'Created Time',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CreatedTime$')); }
				});
				editor.addMenuItem('newmenuitem2', {
					text: 'Created Date',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$CreatedDate$')); }
				});
				editor.addMenuItem('newmenuitem3', {
					text: 'Model',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Model$')); }
				});
				editor.addMenuItem('newmenuitemcolor', {
					text: 'Color',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Color$')); }
				});
				editor.addMenuItem('newmenuitem4', {
					text: 'Brand',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Brand$')); }
				});
				editor.addMenuItem('newmenuitem5', {
					text: 'Category',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$Category$')); }
				});
				editor.addMenuItem('ordersummary', {
					text: 'Order Summary',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$OrderSummary$')); }
				});
				editor.addMenuItem('shopname', {
					text: 'Shop Name',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$ShopName$')); }
				});
				editor.addMenuItem('newmenuitem6', {
					text: 'Location Name',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationName$')); }
				});
				editor.addMenuItem('locationaddress', {
					text: 'Location Address',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationAddress$')); }
				});
				editor.addMenuItem('locationzipcodecity', {
					text: 'Location Zipcode + City',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$LocationZipcodeCity$')); }
				});
				<?php
				if( rp_is_active_enhanced_locations_addon() === true ) {
					?>
					editor.addMenuItem('locationtelephone', {
						text: 'Location Telephone',
						context: 'newmenu',
						onselect: function () { editor.insertContent(createVariableLook('$LocationTelephone$')); }
					});
					<?php
				}
				?>
				editor.addMenuItem('newmenuitemdeliverymethod', {
					text: 'Delivery Method',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$DeliveryMethod$')); }
				});
				editor.addMenuItem('newmenuitemdeliverytime', {
					text: 'Appointment Time',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$AppointmentTime$')); }
				});
				editor.addMenuItem('newmenuitemdeliverydate', {
					text: 'Appointment Date',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('$AppointmentDate$')); }
				});
				editor.addMenuItem('finalize_button', {
					text: 'Finalize Button',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('[finalize="Finalize Booking"]')); }
				});
				editor.addMenuItem('newmenuitem7', {
					text: 'Cancel Link',
					context: 'newmenu',
					onselect: function () { editor.insertContent(createVariableLook('[cancel="Cancel Appointment"]')); }
				});
			}
		});
	}

}

	function uniqid(){
		return Math.random().toString(16).slice(2)+(new Date()).getTime()+Math.random().toString(16).slice(2);
	}

	function ucwords (str) {
		return str.toUpperCase();
		return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
			return $1.toUpperCase();
		});
	}

	function createVariableLook(value) {
		return value;
		value = value.replace('$', '').replace('$', '');
		return '$<span style="border-radius:5px; padding: 2px; background-color: #dbdbdb; color: #333;">'+value+'</span>$';
	}

	(function($){
	function showFullWidthModal(content = '', sepcial_cls = '') {
		$(".va-full-width-modal").remove();
		let html = `
			<div class="va-full-width-modal ${sepcial_cls}">
				<div class="va-full-width-modal-main trans-modal clearfix">
					<div class="va-full-width-modal-inner">
						${content}
					</div>
					<button class="va-button va-button-default va-close-modal">
						<i class="fas fa-times"></i>
					</button>
				</div>
			</div>
		`;
		$("body").append(html);
		$(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
		$(".va-full-width-modal .va-close-modal").on("click", function(){
			$(this).parent().animate({'top': '-50%'}, 400, function(){
				$(this).parent().remove();
			});
		});
		$(document).on("mouseup", handOutsideClick);
		// $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
	}

	window._showFullWidthModal = function(content = '', sepcial_cls = '') {
		showFullWidthModal(content, sepcial_cls);
	}

	function handOutsideClick(e) {
		var container = $('.va-full-width-modal-main');
		var container2 = $('.mce-container');
		// if the target of the click isn't the container nor a descendant of the container
		if ((!container.is(e.target) && container.has(e.target).length === 0) && (!container2.is(e.target) && container2.has(e.target).length === 0))
		{
		    container.find(".va-close-modal").click();
		    $(document).off("mouseup", handOutsideClick);
		}
	}
	
	jQuery(document).on('click', '.globe-icon-translation', function(){

			let lang_key = jQuery(this).data('lang-key');

			if(jQuery('.globe-icon-translation').hasClass("processing")) {
				return;
			}
			let btn = this;

			var btndata = jQuery(btn).html();
			jQuery(btn).html('<div class="globe-icon-i"><i class="fas fa-spinner fa-spin"></i></div>');

			jQuery('.globe-icon-translation').addClass("processing");

			repairPluginUI.ajax({
				type:'POST',
				url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
				data: {action:'rp_get_related_translations',key:lang_key},
				success: function(data) {

					jQuery(btn).html(btndata);

					jQuery('.globe-icon-translation').removeClass("processing");
					
					try {
		      			
		      			data = JSON.parse(data);

		      		} catch(e) {

		      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
		      			return;

		      		}
					
					let rows = '';

					let isEmailTemplate = (lang_key.indexOf('_email_template') > -1 || lang_key.indexOf('ship_device_instructions') > -1);

					let offer = false;

					let pickup_service = false;

					let repair_on_location = false;

					let ship_device_instructions = false;

					data.translations.forEach(function(row){

						let _input = `<input type="text" class="user-info" data-lang-name="${row.name}" name="translations[]" value="${row.t_value}" required="">`;

						if(lang_key === 'ship_device_instructions') {

							ship_device_instructions = true;

						}

						if(isEmailTemplate) {

							if(lang_key.indexOf('offer') > -1) {

								offer = true;

							}

							if(lang_key.indexOf('pickup_service') > -1) {

								pickup_service = true;

							}

							if(lang_key.indexOf('repair_on_location') > -1) {

								repair_on_location = true;

							}

							_input = `<textarea class="mytextarea" data-lang-name="${row.name}" name="translations[]">${row.t_value}</textarea>`;
						}

						rows += `
							<tr>
								<td width="300">
									<div class="flag-img">
										<img width="28px" height="28px" src="${row.image}">
									</div>
									<div class="input-cont">
										<div class="wp-repair-input-group">
											<label>${row.alt_name}</label>
											${_input}
										</div>
									</div>
								</td>
							</tr>
						`;

					});

					showFullWidthModal(`
						<p class="va-modal-title">Update Translations</p>
						<table style="width:100%;">
							<tbody>
								${rows}
							</tbody>
						</table>
						<input type="hidden" name="alert" value="1">
						<input type="hidden" name="lang_key" value="${lang_key}">
						<button type="submit" class="va-button va-submit">
							Update
						</button>
					`);

					if( offer != false ) {
						window.rp_init_tiny_mce('.mytextarea', offer ? 'offer' : '');	
					} else if( pickup_service != false ) {
						window.rp_init_tiny_mce('.mytextarea', pickup_service ? 'pickup_service' : '');	
					} else if( repair_on_location != false ) {
						window.rp_init_tiny_mce('.mytextarea', repair_on_location ? 'repair_on_location' : '');
					} else if( ship_device_instructions != false ) {
						window.rp_init_tiny_mce('.mytextarea', ship_device_instructions ? 'ship_device_instructions' : '');
					} else {
						window.rp_init_tiny_mce('.mytextarea', '');
					}

				},
				error: function(response) {
					jQuery(btn).html(btndata);
					jQuery('.globe-icon-translation').removeClass("processing");
					jQuery(btn).removeClass("processing");
					if( response && response.rp_validation_error != '' ) {

					} else {
						repairPluginUI.alert_danger('Something went wrong, please try again later.');
					}
				}
			});

	});

	jQuery(document).on('click', '.va-full-width-modal-inner .va-button.va-submit', function(){

		if(jQuery(this).hasClass("processing")) {
			return;
		}

		let btn = this;

		jQuery(btn).addClass("processing");

		var btndata = jQuery(btn).html();
		jQuery(btn).html('<i style="position:relative; top: -2px;" class="fas fa-spinner fa-spin"></i>');

		let keys = [];
		let values = [];

		let translation_key = jQuery('.va-full-width-modal-inner input[name^="lang_key"]').val();

		jQuery('.va-full-width-modal-inner input[name^="translations["]').each(function(){
			keys.push(jQuery(this).data('lang-name'));
			values.push(jQuery(this).val());
		});

		if(keys.length == 0 && values.length == 0) {

			jQuery('.va-full-width-modal-inner textarea[name^="translations["]').each(function(){
				keys.push(jQuery(this).data('lang-name'));
				// get tiny mce value
				values.push(tinyMCE.get(jQuery(this).attr('id')).getContent());
			});

		}

		repairPluginUI.ajax({
			type:'POST',
			url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
			data: {
				action:'rp_update_translations',
				keys:keys,
				values:values,
				translation_key: translation_key
			},
			success: function(data) {

				jQuery(btn).html(btndata);

				jQuery(btn).removeClass("processing");

				try {
	      			
	      			data = JSON.parse(data);

	      		} catch(e) {

	      			repairPluginUI.alert_danger('Something went wrong, please try again later.');	
	      			return;

	      		}

	      		if(data.status == true || data.status == 'true') {
					jQuery(".va-close-modal").click();
					let globe_icon = jQuery('.globe-icon-translation[data-lang-key="'+translation_key+'"]');
					jQuery(globe_icon).parents('.wp-repair-input-group').find('input[name^="laltname["]').val(data.default_translation);
	      			repairPluginUI.alert_success('Translations updated successfully.');
	      		} else {
	      			repairPluginUI.alert_danger('Something went wrong, please try again later.');
	      		}

			},
			error: function( response ) {
				jQuery(btn).html(btndata);
				jQuery(btn).removeClass("processing");
				if( response && response.rp_validation_error != '' ) {

				} else {
					repairPluginUI.alert_danger('Something went wrong, please try again later.');
				}
			}
		});

	});

}(jQuery));
</script>