<?php
// Exit if accessed directly

defined( 'ABSPATH' ) || exit;

$outgoing_triggers = rp_get_all_outgoing_triggers();

$outgoing_triggers = rp_sanitize_output( $outgoing_triggers );

?>
<style>
    .table-action-btn {
        display: inline-table;
        margin-right: 3px;
        padding: 4px 10px;
        font-size: 12px;
        border: unset;
        box-shadow: 0px 0px 2px rgba(0,0,0,0.2);
        outline: 0;
        border-radius: 5px;
        cursor: pointer;
    }
    .table-action-btn.btn-create-new {
        background: #1275c2;
        color: #fff;
        font-weight: 600;
        text-transform: uppercase;
        cursor: pointer;
        border-radius: 5px;
        padding: 6px 10px;
        font-size: 11.5px;
        letter-spacing: 1px;
    }
    .table-action-btn.btn-primary {
        background-color: #008ce4;
        color: #fff;
    }
    .table-action-btn.btn-primary:hover {
        background-color: #0077b3;
        color: #fff;
    }
    .table-action-btn.btn-dark {
        background-color: #343a40;
        color: #fff;
    }
    .table-action-btn.btn-dark:hover {
        background-color: #23272b;
        color: #fff;
    }
    .table-action-btn.btn-light {
        background-color: #efefef;
        color: #212529;
    }
    .table-action-btn.btn-light:hover {
        background-color: #e2e2e2;
        color: #212529;
    }
    .table-action-btn.btn-danger {
        background-color: #dc3545;
        color: #fff;
    }
    .table-action-btn.btn-danger:hover {
        background-color: #c82333;
        color: #fff;
    }
    .rp-pagination ul {
        list-style: none;
        padding: 0;
        margin: 0;
    }
    .rp-pagination ul li {
        display: inline-block;
        margin-right: 5px;
    }
    .rp-pagination ul li a {
        display: inline-table;
    padding: 5px 10px;
    width: 35px;
    box-sizing: border-box;
    border: 1px solid #eee;
    text-decoration: none;
    color: #333;
    box-shadow: unset;
    outline: 0;
    border-radius: 5px;
    background-color: #eee;
    text-align: center;
    }
    .rp-pagination ul li a.active {
        background-color: #0077c2;
        color: #fff;
    }
    table {
        width: 100%;
    }
    table tr th,
    table tr td {
        padding: 5px 5px 5px 5px;
        text-align: left;
        vertical-align: top;
        border-bottom: 1px dashed #eee;
    }
    .location-name {
        margin-bottom: 15px;
        font-weight: 600;
    }
    .location-email {
        margin-bottom: 15px;
    }
    .location-address {
        line-height: 1.5em !important;
    }
    .location-photo {
        width: 100px;
        height: 25px;
        overflow: hidden;
        position: relative;
        display: block;
        border-radius: 3px;
    }
    .location-photo img {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 100%;
        height: auto;
    }
    select.schedule-select {
        width: 120px;
        min-height: 28px;
        font-size: 13px;
        font-weight: 400 !important;
        border-radius: 6px !important;
    }
    .va-full-width-modal *:not(i) {
        font-family: 'Montserrat', sans-serif;
    }
    .va-full-width-modal .wp-repair-repair-card {
        width: 100%;
        max-width: 100%;
        margin-bottom: 0px !important;
    }
    .va-full-width-modal .wp-repair-repair-card select {
        width: 100%;
        font-size: 13px;
        max-width: 100%;
        font-weight: 400 !important;
        border-radius: 8px !important;
    }
    .va-full-width-modal-main {
        max-height: 90%;
    }
    .va-full-width-modal-main p.company-logo-theme-color {
        margin-top: 15px;
        font-size: 8px;
        text-transform: uppercase;
        font-weight: 600;
        letter-spacing: 1.5px;
    }
    .wp-repair-location-image-upload-button {
        font-size: 13px;
        width: 170px;
        font-weight: 600;
        text-transform: uppercase;
        border: 2px solid #1275c2;
        background: #fff;
        margin: 0px;
        padding: 3px 8px;
        cursor: pointer;
        margin-top: 5px;
        border-radius: 5px;
        color: #1275c2;
        text-align: left;
    }
    .wp-repair-location-image-upload-button:hover {
        background: #1275c2;
        color: #fff;
    }
    .va-full-width-modal-main p.company-logo-theme-color.recommended-size {
        margin-top: 0px;
    }
    .va-full-width-modal .va-button.va-submit {
        right: unset;
        float: left;
    }
    .wp-repair-input-group label {
        top: -6px;
    }
    .va-full-width-modal .va-button.va-submit {
        margin-bottom: 8px;
    }
    .rp_is_synced {
        margin-top: 6px;
        margin-bottom: 4px;
    }
    .va-full-width-modal-main.location-modal-delete .va-modal-title.danger-color.blue-color {
        color: #b50000 !important;
    }
    .va-full-width-modal-main.location-modal-delete .btn-delete-item-confirm {
        background: #b50000 !important;
        border: 1px solid #b50000 !important;
    }
    .uploaded_img.hasImage {
        display: block;
        position: relative;
        width: 100%;
        height: auto;
        overflow: hidden;
        transition: all 0.2s ease-in-out;
        padding-bottom: 25%;
        border-radius: 8px;
    }
    .uploaded_img.hasImage:hover {
        background: #000;
    }
    .uploaded_img img {
        position: absolute;
        width: 100%;
        height: auto;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        transition: all 0.2s ease-in-out;
    }
    .uploaded_img .remove-uploaded-image {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
    }
    .uploaded_img .remove-uploaded-image .clear-image {
        cursor: pointer;
        background: transparent;
        color: #fff;
        padding: 0px;
        box-shadow: 0px 0px 3px #000000;
        border: 0px;
        font-size: 20px;
        outline: 0;
        box-shadow: unset;
        transition: all 0.2s ease-in-out;
        transform: scale(0);
    }
    .uploaded_img:hover .remove-uploaded-image .clear-image {
        transform: scale(1);
    }
    .uploaded_img:hover img {
        opacity: 0.5;
    }
    .rp-filters {
        margin-bottom: 25px;
    }
    .rp-filters .wp-repair-input-group {
        width: 250px;
        display: inline-table;
    }
    .rp-filters .wp-repair-input-group input {
        height: 32px;
        border-radius: 6px;
        font-size: 13px;
        padding-left: 10px !important;
    }
    .rp-filters .search-button,
    .rp-filters .clear-search-button {
        display: inline-table;
    }
    .rp-filters .search-button,
    .rp-filters .clear-search-button,
    .rp-filters .wp-repair-repair-card {
        padding-left: 5px;
    }

    .rp-filters .btn-search,
    .rp-filters .btn-clear-search {
        background: #efefef;
        color: #404040;
        font-weight: 600;
        text-transform: uppercase;
        cursor: pointer;
        border-radius: 5px;
        padding: 7px 10px;
        font-size: 11.5px;
        letter-spacing: 1px;
        border: 2px solid #d9d9d9;
        text-align: center;
        display: table;
        vertical-align: middle;
        height: 32px;
    }
    .rp-filters .wp-repair-repair-card {
        display: inline-table;
        width: 170px;
    }
    .rp-filters .wp-repair-repair-card select.coupons_select {
        font-size: 13px;
        font-weight: 400 !important;
        padding: 4px 10px !important;
        height: 32px;
        display: table;
        border-radius: 7px !important;
        line-height: 1.15em;
        padding-right: 24px !important;
    }
    .badge-main-location {
        padding: 3px 5px;
        line-height: 1em;
        border-radius: 5px;
        background: #efefef;
        color: #404040;
        font-size: 9px;
    }
    .va-full-width-modal .wp-repair-input-group {
        max-width: 100%;
    }
    .va-full-width-modal-main {
        width: 90%;
    }
    .full-width-wp-repair {
        display: block;
    }
    .full-width-wp-repair .table-responsive {
        display: block;
        width: 100%;
        overflow-x: auto;
    }
    .full-width-wp-repair .table-responsive table.table {
        width: 100%;
        min-width: 635px;
    }
    .wp-repair-container,
    .wp-repair-row,
    .wp-repair-col-12.settings,
    .repair-dl-rounded-container {
        display: block;
        width: 100%;
        box-sizing: border-box;
    }
    .location-phone {
        margin-bottom: 5px;
    }
    @media(max-width: 600px) {
        .rp-dynamic-pricing-settings-nav a {
		margin: 3px;
	}
        .full-width-wp-repair {
            padding: 0px;
        }
        .rp-filters .wp-repair-input-group,
        .rp-filters .wp-repair-repair-card {
            width: 100%;
            display: block;
            margin-bottom: 10px;
            padding: 0px;
            max-width: 100%;
        }
        .rp-filters .wp-repair-repair-card select {
            max-width: 100%;
        }
        .rp-filters .search-button {
            width: 100%;
            padding: 0px;
            text-align: center;
        }
        .rp-filters .search-button button {
            width: 100%;
        }
    }
    pre.payload {
        background: #fbfbfb;
        border: 1px solid #aaa;
        border-radius: 8px;
        padding: 15px;
        color: #404040;
        line-height: 2em;
        font-size: 14px;
    }
    pre.payload .key {
        color: #404040;
        font-weight: 600;
    }
    pre.payload .string {
        color: #404040;
        font-weight: 400;
        padding-left: 5px;
    }
</style>
<div class="table-responsive">
    <table class="table">
        <thead>
            <tr>
                <th width="400px">Trigger</th>
                <th width="200px"></th>
            </tr>
        </thead>
        <tbody>
            <?php
            if( !empty( $outgoing_triggers ) ) {

                foreach($outgoing_triggers as $trigger) {
                    ?>
                    <tr>
                        <td>
                            <b><?php echo ucwords(str_replace('_', ' ', $trigger->trigger)); ?></b>
                            <br>
                            <br>
                            <?php echo $trigger->url; ?>
                        </td>
                        <td>
                            <button type="button" class="btn table-action-btn btn-dark rp_view_the_payload btn-sm" data-id="<?php echo $trigger->id; ?>" data-name="<?php echo $trigger->trigger; ?>">
                                Example Payload
                            </button>
                            <button type="button" class="btn table-action-btn btn-primary edit-entry btn-sm" data-id="<?php echo $trigger->id; ?>" data-name="<?php echo $trigger->trigger; ?>">
                                <i class="fa fa-edit"></i>
                            </button>
                            <button type="button" class="btn table-action-btn btn-danger btn-delete-item btn-sm" data-id="<?php echo $trigger->id; ?>" data-name="<?php echo $trigger->trigger; ?>">
                                <i class="fa fa-trash-alt"></i>
                            </button>
                        </td>
                    </tr>
                    <?php
                }

            } else {

                ?>
                <tr>
                    <td colspan="3">No triggers configured.</td>
                </tr>
                <?php

            }
            ?>
        </tbody>
    </table>
</div>
<button style="margin-top: 15px;" type="button" class="btn table-action-btn btn-create-new btn-sm">
    Create New
</button>

<script>
(function($){

    function syntaxHighlight(json) {
    if (typeof json != 'string') {
         json = JSON.stringify(json, undefined, 2);
    }
    json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
    return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
        var cls = 'number';
        if (/^"/.test(match)) {
            if (/:$/.test(match)) {
                cls = 'key';
            } else {
                cls = 'string';
            }
        } else if (/true|false/.test(match)) {
            cls = 'boolean';
        } else if (/null/.test(match)) {
            cls = 'null';
        }
        return '<span class="' + cls + '">' + match + '</span>';
    });
}

    function rp_view_the_payload(that, id = null) {

        // check if has class processing
        if( jQuery(that).hasClass('processing') ) {
            return false;
        }

        // add class processing
        jQuery(that).addClass('processing');

        let btn = that;
        let originalHTML = jQuery(that).html();

        // width of button
        let btnWidth = jQuery(that).outerWidth();
        // apply width to button
        jQuery(that).css('width', Math.ceil(btnWidth) + 'px');

        // show loading icon
        jQuery(that).html('<i class="fa fa-spinner fa-spin"></i>');

        repairPluginUI.ajax({
            type:'POST',
            url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
            data: {action:'rp_get_payload_of_outgoing_trigger',id:id},
            success: function(data) {

                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");

                // blur
                jQuery(that).blur();

                try {
                    data = JSON.parse(data);
                } catch(e) {
                    data = {};
                }
                if( data && data.payload ) {

                    let modal_heading = 'Example Payload';

                    showFullWidthModal(`
                        <p class="va-modal-title blue-color">${modal_heading}</p>
                        <pre class="payload">${syntaxHighlight(JSON.stringify(data.payload, null, 2))}</pre>
                    `, 'schedule-group-modal-view payload-modal');

                } else {

                    // something went wrong
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');

                }
            },
            error: function(response) {
                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");
                if( response && response.rp_validation_error != '' ) {
                    
                } else {
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');
                }
            }
        });

    }

    jQuery(document).on('ready', function(){

        jQuery(document).on('click', '.rp_view_the_payload', function(){
            rp_view_the_payload(this, jQuery(this).attr('data-id'));
        });

    });
    
    function showFullWidthModal(content = '', additional_cls = '') {
        $(".va-full-width-modal").remove();
        let html = `
            <div class="va-full-width-modal">
                <div class="va-full-width-modal-main ${additional_cls}">
                    <div class="va-full-width-modal-inner clearfix">
                        ${content}
                    </div>
                    <button class="va-button va-button-default va-close-modal">
                        <i class="fas fa-times"></i>
                    </button>
                </div>
            </div>
        `;
        $("body").append(html);
        $(".va-full-width-modal .va-full-width-modal-main").css({'top': '-50%'}).animate({'top': '50%'}, 400);
        $(".va-full-width-modal .va-close-modal").on("click", function(){
            $(this).parent().animate({'top': '-50%'}, 400, function(){
                $(this).parent().remove();
            });
        });
        $(document).on("mouseup", handOutsideClick);
        // $(".va-full-width-modal .va-submit").on("click", setAlertFormHandler);
    }
    function handOutsideClick(e) {
        var container = $('.va-full-width-modal-main');
        if( !$(container).hasClass('justUploadedImage') ) {
         
            // if the target of the click isn't the container nor a descendant of the container
            if (!container.is(e.target) && container.has(e.target).length === 0) 
            {
                container.find(".va-close-modal").click();
                $(document).off("mouseup", handOutsideClick);
            }

        }
    }

    function create_needed_input( key, readable_key, value = '', data = {} ) {
        form_html = '';

        if( key == 'id' ) {

            form_html += '<input type="hidden" name="'+ key +'" value="'+ value +'">';

        } else if( key == 'available_options' ) {

            form_html = '';

        } else if( key == 'trigger' ) {

            form_html += '<p class="company-logo-theme-color">'+readable_key+'</p>';
            form_html += '<div class="wp-repair-repair-card">';
            // select
            form_html += '<select class="form-control coupons_select" name="'+ key +'">';
            form_html += '<option value="">-- Select --</option>';
            data.available_options.forEach(function(item){
                let selected = '';
                if( item == value ) {
                    selected = 'selected="selected"';
                }
                let item_name = item.replaceAll('_', ' ');
                // upper case all words
                item_name = item_name.replace(/\w\S*/g, function(txt){
                    return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
                });
                form_html += '<option '+selected+' value="'+ item +'">'+ item_name +'</option>';
            });
            form_html += '</select>';
            form_html += '</div>';

        } else {

            form_html += '<div class="form-group wp-repair-input-group">';
            form_html += '<label for="location_'+ key +'">'+ readable_key +'</label>';
            form_html += '<input type="text" class="form-control" id="location_'+ key +'" name="'+ key +'" value="'+ value +'">';
            form_html += '</div>';

        }

        return form_html;
    }

    function create_or_edit_entry(that, id = null, is_clone = false) {

        // check if has class processing
        if( jQuery(that).hasClass('processing') ) {
            return false;
        }

        // add class processing
        jQuery(that).addClass('processing');

        let btn = that;
        let originalHTML = jQuery(that).html();

        // width of button
        let btnWidth = jQuery(that).outerWidth();
        // round
        btnWidth = Math.round(btnWidth);
        // apply width to button
        jQuery(that).css('width', btnWidth);

        // show loading icon
        jQuery(that).html('<i class="fa fa-spinner fa-spin"></i>');

        if(is_clone) {
            is_clone = 1;
        } else {
            is_clone = 0;
        }

        repairPluginUI.ajax({
            type:'POST',
            url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
            data: {action:'rp_get_outgoing_triggers_data_for_edit',id:id,is_clone:is_clone},
            success: function(data) {

                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");

                // blur
                jQuery(that).blur();

                try {
                    data = JSON.parse(data);
                } catch(e) {
                    data = {};
                }
                if( data && data.data ) {

                    let form_type = 'create';

                    if( data.data.id != 0 ) {

                        form_type = 'edit';

                    }

                    let modal_heading = 'Create New';
                    let modal_button = 'Create New';

                    if( form_type == 'edit' ) {

                        modal_heading = 'Edit Location';
                        modal_button = 'Update';

                    }

                    let form_html = '';

                    // multipart
                    form_html += '<form action="" method="POST" enctype="multipart/form-data">';

                    for( var key in data. data ) {

                        let value = data.data[key];

                        let readable_key = key.replace(/_/g, ' ');

                        // replace _+_ in key with single _
                        key = key.replace(/_\+_/g, '_');

                        // create input
                        form_html += create_needed_input(key, readable_key, value, data.data);

                    }

                    // close
                    form_html += '</form>';

                    showFullWidthModal(`
                        <p class="va-modal-title blue-color">${modal_heading}</p>
                        ${form_html}
                        <button type="button" class="va-button va-button-primary va-submit btn-create-edit-actual">
                            ${modal_button}
                        </button>
                    `);

                } else {

                    // something went wrong
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');

                }
            },
            error: function(response) {
                jQuery(that).html(originalHTML);
                jQuery(that).removeClass("processing");
                if( response && response.rp_validation_error != '' ) {
                    
                } else {
                    repairPluginUI.alert_danger('Something went wrong, please try again later.');
                }
            }
        });

    }

    jQuery(document).on('ready', function(){

        jQuery(document).on('click', '.btn-delete-item', function(){

            let id = jQuery(this).attr('data-id');
            let name = jQuery(this).attr('data-name');

            let readableTriggerName = name.replaceAll('_', ' ');
            // ucwords
            readableTriggerName = readableTriggerName.replace(/\w\S*/g, function(txt){
                return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
            });
            showFullWidthModal(`
                <p class="va-modal-title danger-color blue-color">Delete Trigger</p>
                <p>Are you sure you want to delete this trigger? (<strong>${readableTriggerName}</strong>)</p>
                <button data-id="${id}" data-name="${name}" type="submit" class="va-button va-button-danger va-submit btn-delete-item-confirm">
                    Delete
                </button>
            `, 'location-modal-delete');

        });

        jQuery(document).on('click', '.btn-delete-item-confirm', function(){

            // check if has class proccessing
            if( jQuery(this).hasClass('proccessing') ) {
                return false;
            }

            let id = jQuery(this).attr('data-id');
            let name = jQuery(this).attr('data-name');

            // add class proccessing
            jQuery(this).addClass('proccessing');

            let btn = this;
            let originalHTML = jQuery(this).html();

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin"></i>');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                data: {action:'rp_delete_outgoing_trigger',id:id},
                success: function(data) {
                    window.location.reload();
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

        jQuery(document).on('click', '.btn-create-new', function(){

            create_or_edit_entry(this);

        });

        jQuery(document).on('click', '.table-action-btn.edit-entry', function(){

            create_or_edit_entry(this, jQuery(this).data('id'));

        });

        jQuery(document).on('click', '.btn-create-edit-actual', function(){

            // make sure all fields are filled up
            let allFieldsFilledUp = true;

            let parent = jQuery(this).parents('.va-full-width-modal');

            jQuery(parent).find('.wp-repair-input-group').each(function(){
                let input = jQuery(this).find('input');
                // if name === google_map_link, skip
                if( input.attr('type') != 'hidden' ) {
                    
                    if( input.val() == '' ) {
                        allFieldsFilledUp = false;
                    }

                }

            });

            // make sure select field is selected
            let selectField = jQuery(parent).find('select');
            if( selectField.length > 0 ) {
                if( selectField.val() == '' ) {
                    allFieldsFilledUp = false;
                }
            }

            if( !allFieldsFilledUp ) {
                alert('Please fill up all fields.');
                return false;
            }

            // check if has class processing
            if( jQuery(this).hasClass('processing') ) {
                return false;
            }

            // add class processing
            jQuery(this).addClass('processing');
            
            let btn = this;
            let originalHTML = jQuery(this).html();

            // width of button
            let btnWidth = jQuery(this).outerWidth();
            // apply width to button
            jQuery(this).css('width', btnWidth);

            // show loading icon
            jQuery(this).html('<i class="fa fa-spinner fa-spin" style="position: relative; top: -1px;"></i>');

            let form = jQuery(parent).find('form');

            let form_data = new FormData(form[0]);

            // append action
            form_data.append('action', 'rp_create_or_edit_outgoing_trigger');

            repairPluginUI.ajax({
                type:'POST',
                url: "<?php echo get_site_url().'/wp-admin/admin-ajax.php'?>",
                cache: false,
                contentType: false,
                processData: false,
                data: form_data,
                success: function(data) {
                    window.location.reload();
                },
                error: function(response) {
                    jQuery(btn).html(originalHTML);
                    jQuery(btn).removeClass("processing");
                    if( response && response.rp_validation_error != '' ) {
                        
                    } else {
                        repairPluginUI.alert_danger('Something went wrong, please try again later.');
                    }
                }
            });

        });

    });
    
}(jQuery));

</script>