<?php

namespace RepairPluginPro;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

class RP_Trigger_Payload {

    public static function order_details( $o_id = 0 ) {

        if( empty( $o_id ) ) {

            return array();

        }

        global $rpQuery;

        global $wp_repair_lang;

        $rs_orders    = $rpQuery->prefix . "rs_orders";

        $rs_customer    = $rpQuery->prefix . "rs_customer";

        $rs_coupons    = $rpQuery->prefix . "rs_coupons";

        $rs_customer_business    = $rpQuery->prefix . "rs_customer_business";

        $rs_company_location    = $rpQuery->prefix . "rs_company_location";

        $rs_order_upsales    = $rpQuery->prefix . "rs_order_upsales";

        $rs_upsales    = $rpQuery->prefix . "rs_upsales";

        $rs_order_repairs    = $rpQuery->prefix . "rs_order_repairs";

        $rs_repair    = $rpQuery->prefix . "rs_repair";

        $rs_repair_attr    = $rpQuery->prefix . "rs_repair_attr";

        $rs_order_repair_attr    = $rpQuery->prefix . "rs_order_repair_attr";

        $rs_category    = $rpQuery->prefix . "rs_category";

        $rs_brand    = $rpQuery->prefix . "rs_brand";

        $rs_model    = $rpQuery->prefix . "rs_model";

        $rs_localization = $rpQuery->prefix . "rs_localization";

        $order_id = $o_id;

	    $orders = $rpQuery->get_results("SELECT o.*, cu.*, c.*,cb.*,loc.* FROM $rs_orders as o LEFT JOIN $rs_customer as cu ON o.customer_id_fk = cu.customer_id LEFT JOIN $rs_coupons as c ON c.coupons_id = o.coupon_id_fk LEFT JOIN $rs_customer_business as cb ON cu.customer_id = cb.customer_id_fk LEFT JOIN $rs_company_location as loc ON loc.location_id = o.location_id_fk WHERE o_id = '".rp_escape_sql($o_id)."' ORDER BY o.o_date_time DESC");

        $order = null;

        if(!empty($orders)) {
            $order = $orders[0];
        } else {
            return '';
        }

        $localization = $rpQuery->prefix . "rs_localization";
        $localization_data = $rpQuery->get_results("SELECT * FROM $localization");
        $decimal = $localization_data[0]->set_decimals;
        $currency_symbol = $localization_data[0]->set_currency;

        $o_upsales = $rpQuery->get_results("SELECT * FROM $rs_order_upsales WHERE o_id_fk = '".rp_escape_sql($o_id)."'");
        $order_repairs = $rpQuery->get_results("SELECT * FROM $rs_order_repairs WHERE o_id_fk = '".rp_escape_sql($o_id)."'");
        $or_attr = $rpQuery->get_results("SELECT * FROM $rs_order_repair_attr WHERE o_id_fk = '".rp_escape_sql($o_id)."'");

        // Has Saved Price on Appointment Creation
        $hasSaved = FALSE;
        if(!empty($o_upsales)) {
            if(!empty($o_upsales[0]->upsale_name ?? '')) {
                $hasSaved = TRUE;
            }
        }
        if(!empty($order_repairs)) {
            if(!empty($order_repairs[0]->repair_name ?? '')) {
                $hasSaved = TRUE;
            }
        }
        if(!empty($or_attr)) {
            if(!empty($or_attr[0]->repair_attr_name ?? '')) {
                $hasSaved = TRUE;
            }
        }
        if($hasSaved === FALSE) {
            $o_upsales = $rpQuery->get_results("SELECT * FROM $rs_order_upsales AS o_up JOIN $rs_upsales AS up ON o_up.upsales_id_fk = up.upsales_id WHERE o_up.o_id_fk = '".rp_escape_sql($o_id)."'");
            $order_repairs = $rpQuery->get_results("SELECT * FROM $rs_order_repairs AS o_r JOIN $rs_repair AS r ON r.r_id = o_r.r_id_fk WHERE o_id_fk = '".rp_escape_sql($o_id)."'");
            $or_attr = $rpQuery->get_results("SELECT * FROM $rs_order_repair_attr AS o_ra JOIN  $rs_repair_attr AS ra ON ra.a_id = o_ra.ra_id_fk WHERE o_id_fk = '".rp_escape_sql($o_id)."'");
        }

        list($order_repairs, $or_attr) = rp_translate_locked_repairs_and_attributes($order_repairs, $or_attr);

        $o_upsales = rp_translate_locked_upsales($o_upsales);

        $m_id = $order->m_id_fk;
        $models = $rpQuery->get_results("SELECT * FROM $rs_model WHERE m_id = '".rp_escape_sql($m_id)."'");
        $b_id = $models[0]->brand_id_fk;
        $brands = $rpQuery->get_results("SELECT * FROM $rs_brand WHERE b_id = '".rp_escape_sql($b_id)."'");
        $c_id = $models[0]->device_type; 
        $cats = $rpQuery->get_results("SELECT * FROM $rs_category WHERE c_id = '".rp_escape_sql($c_id)."'");

        $por_repairs = rp_get_por_repairs_by_order_id( $o_id );

        $por_repair_attrs = rp_get_por_repair_attr_by_order_id( $o_id );

        $items = array();

        list( $rpCart, $calculations ) = rp_get_latest_order_calculations( $o_id );

        if(!empty( $order_repairs )){
            foreach($order_repairs as $rp){
                $rid = $rp->r_id_fk;
                $is_por = FALSE;
                if( rp_check_is_por_repair( $rid, $por_repairs ) === TRUE ) {
                    $is_por = TRUE;
                }
                $itReallyWorked = FALSE;
                if($or_attr){ 
                    foreach($or_attr as $ra){
                        $r_id = $ra->r_id_fk;
                        if($rid == $r_id){ 
                            $itReallyWorked = TRUE; 
                            $repairName = ($rp->repair_name ?? $rp->r_name) .' - '. ($ra->repair_attr_name ?? $ra->a_name);
                            $is_discounted_price = '';
                            if( property_exists( $ra, 'repair_attr_price' ) ) {
                                list($is_discounted_price, $discounted_price) = $rpCart->showable_repair_price( $ra->ra_id_fk, 'attr' );
                                $repairPrice = $discounted_price;
                            } else {
                                $repairPrice = $ra->a_price;
                            }
                            if(rp_check_is_por_repair_attr( $ra->ra_id_fk, $por_repair_attrs )) {
                                $is_por = TRUE;
                            }
                            if($decimal == 'comma'){
                                $a_price = str_replace('.',',',$repairPrice);
                            }else{
                                $a_price = $repairPrice;					
                            }
                            if( $is_por === TRUE ) {
                                $formatted_price = $wp_repair_lang['price_on_request_text'];
                            } else {
                                $formatted_price = rp_handle_currency_position($a_price, $currency_symbol, TRUE);
                            }
                            $items[] = array(
                                'name' => $repairName,
                                'type' => 'repair',
                                'price' => ((float) str_replace(',', '.', $repairPrice))
                                // 'formatted_price' => $formatted_price
                            );
                        }
                    }
                    if($itReallyWorked === FALSE) {
                        $itReallyWorked = TRUE;
                        $repairName = $rp->repair_name ?? $rp->r_name;
                        $is_discounted_price = '';
                        if( property_exists( $rp, 'repair_price' ) ) {
                            list($is_discounted_price, $discounted_price) = $rpCart->showable_repair_price( $rp->r_id_fk, 'repair' );
                            $repairPrice = $discounted_price;
                        } else {
                            $repairPrice = $rp->r_price;
                        }
                        if($decimal == 'comma'){
                            $r_price = str_replace('.',',',$repairPrice);
                        }else{
                            $r_price = $repairPrice;					
                        }
                        if( $is_por === TRUE ) {
                            $formatted_price = $wp_repair_lang['price_on_request_text'];
                        } else {
                            $formatted_price = rp_handle_currency_position($r_price, $currency_symbol, TRUE);
                        }
                        $items[] = array(
                            'name' => $repairName,
                            'type' => 'repair',
                            'price' => ((float) str_replace(',', '.', $repairPrice))
                            // 'formatted_price' => $formatted_price
                        );
                    }
                }else{
                    if($itReallyWorked === FALSE) {
                        $itReallyWorked = TRUE;
                        $repairName = $rp->repair_name ?? $rp->r_name;
                        $is_discounted_price = '';
                        if( property_exists( $rp, 'repair_price' ) ) {
                            list($is_discounted_price, $discounted_price) = $rpCart->showable_repair_price( $rp->r_id_fk, 'repair' );
                            $repairPrice = $discounted_price;
                        } else {
                            $repairPrice = $rp->r_price;
                        }
                        if($decimal == 'comma'){
                            $r_price = str_replace('.',',',$repairPrice);
                        }else{
                            $r_price = $repairPrice;					
                        }
                        if( $is_por === TRUE ) {
                            $formatted_price = $wp_repair_lang['price_on_request_text'];
                        } else {
                            $formatted_price = rp_handle_currency_position($r_price, $currency_symbol, TRUE);
                        }
                        $items[] = array(
                            'name' => $repairName,
                            'type' => 'repair',
                            'price' => ((float) str_replace(',', '.', $repairPrice))
                            // 'formatted_price' => $formatted_price
                        );
                    }
                } 
            }
        }

        if(!empty( $o_upsales )){

            foreach($o_upsales as $up){

                $upsaleName = $up->upsale_name ?? $up->us_name;

                $upsalePrice = $up->upsale_price ?? $up->us_new_price;

                if($decimal == 'comma'){

                    $up_price = str_replace('.',',',$upsalePrice);

                }else{

                    $up_price = $upsalePrice;					

                }

                $formatted_price = rp_handle_currency_position($up_price, $currency_symbol, TRUE);
                
                $items[] = array(
                    'name' => $upsaleName,
                    'type' => 'upsale',
                    'price' => ((float) str_replace(',', '.', $upsalePrice))
                    // 'formatted_price' => $formatted_price
                );

            }

        }

        $result = array(
            'items' => $items
        );

        if(($order->dm_cost ?? 0) != 0 && ($order->dm_cost ?? 0) != 0.00) {
            $translated_delivery_method = '';
            $dm_tkey = rp_get_delivery_method_translation_key($order->delivery_method);
            if( !empty( $dm_tkey ) && !empty( $wp_repair_lang[$dm_tkey] ?? '' ) ) {
                $translated_delivery_method = $wp_repair_lang[$dm_tkey];
            } else {
                $translated_delivery_method = str_replace('_', ' ', $order->delivery_method);
            }
            $dm_cost = $order->dm_cost ?? 0;
            if($decimal == 'comma'){
                $dm_cost = str_replace('.',',',$dm_cost);
            }else{
                $dm_cost = $dm_cost;					
            }
            $dm_cost_unformatted = (float) str_replace(',', '.', $order->dm_cost ?? 0);
            $formatted_dm_cost = rp_handle_currency_position($dm_cost, $currency_symbol, TRUE);

            // $result['delivery_method_translated'] = $translated_delivery_method;
            $result['delivery_method_cost'] = $dm_cost_unformatted;
            // $result['delivery_method_cost_formatted'] = $formatted_dm_cost;
        } else {
            $translated_delivery_method = '';
            $dm_tkey = rp_get_delivery_method_translation_key($order->delivery_method);
            if( !empty( $dm_tkey ) && !empty( $wp_repair_lang[$dm_tkey] ?? '' ) ) {
                $translated_delivery_method = $wp_repair_lang[$dm_tkey];
            } else {
                $translated_delivery_method = str_replace('_', ' ', $order->delivery_method);
            }
            // $result['delivery_method_translated'] = $translated_delivery_method;
            $result['delivery_method_cost'] = '';
            // $result['delivery_method_cost_formatted'] = '';
        }

        $sub_total  = $calculations['sub_total'];

        $sub_total_unformatted = (float) str_replace(',', '.', $sub_total);

        $sub_total_formatted = rp_handle_currency_position($sub_total, $currency_symbol, TRUE);

        $result['sub_total'] = $sub_total_unformatted;
        
        // $result['sub_total_formatted'] = $sub_total_formatted;

        if( !empty( $order->combo_discount ) && ((float) $order->combo_discount != 0 ) ) {

            if($decimal == 'comma'){
                $combo = str_replace('.',',',$order->combo_discount);
            }else{
                $combo = $order->combo_discount;					
            }
            $formatted_combo_discount = rp_handle_currency_position($combo, $currency_symbol, TRUE);
            $unformatted_combo_discount = (float) str_replace(',', '.', $order->combo_discount);

            $result['combo_discount'] = $unformatted_combo_discount;
            // $result['combo_discount_formatted'] = $formatted_combo_discount;

        } else {

            $result['combo_discount'] = '';
            // $result['combo_discount_formatted'] = '';

        }

        if( !empty( $order->coupons_amount ) && ((float) $order->coupons_amount != 0 ) ) {
            
            if($decimal == 'comma'){
                $coupon = str_replace('.',',',$order->coupons_amount);
            }else{
                $coupon = $order->coupons_amount;					
            }
            if($order->coupons_type == 'percent'){
                $coupon = $order->coupon_amount; // this is saved in rs_orders
            }
            if(!empty(trim($coupon))) {
                $unformatted_coupon_amount = (float) str_replace(',', '.', $coupon);
                $formatted_coupon_amount = rp_handle_currency_position($coupon, $currency_symbol, TRUE);
            } else {
                $unformatted_coupon_amount = '';
                $formatted_coupon_amount = '';
            }

            $result['coupon_code'] = $order->coupons_code ?? '';

            if(($order->coupons_type ?? '') == 'percent'){
                $result['coupon_type'] = 'percent';
            } else {
                $result['coupon_type'] = 'fixed';
            }

            $result['coupon_amount'] = $unformatted_coupon_amount;
            // $result['coupon_amount_formatted'] = $formatted_coupon_amount;

        } else {
            $result['coupon_code'] = '';
            $result['coupon_type'] = '';
            $result['coupon_amount'] = '';
            // $result['coupon_amount_formatted'] = '';
        }

        $tax_row = $rpQuery->get_row("SELECT * FROM $rs_localization LIMIT 1;");

        if( !empty( $tax_row ) ) {

            $tax = $tax_row->tax ?? 0;

        } else {

            $tax = 0;

        }

        $result['tax_percentage'] = $tax;

        $etp = 1 + (((float)$tax * 1) / 100);
        $ex_tax_price = ((float) str_replace(',', '.', $order->total_price))/$etp;
        $ex_tax_price = round( ((float)$ex_tax_price), 2 );
        $ex_tax_price_unformatted = (float) $ex_tax_price;
        if($decimal == 'comma'){
            $ex_tax_price = str_replace('.', ',', $ex_tax_price_unformatted);
        }
        $ex_tax_price_formatted = rp_handle_currency_position($ex_tax_price, $currency_symbol, TRUE);

        $result['excluding_tax_price'] = $ex_tax_price_unformatted;
        // $result['excluding_tax_price_formatted'] = $ex_tax_price_formatted;

        $the_tax_price = ((float) str_replace(',', '.', $order->total_price)) - $ex_tax_price_unformatted;

        $the_tax_price = round( ((float)$the_tax_price), 2 );

        $the_tax_price_unformatted = (float) $the_tax_price;

        if($decimal == 'comma'){
            $the_tax_price = str_replace('.', ',', $the_tax_price_unformatted);
        }

        $the_tax_price_formatted = rp_handle_currency_position($the_tax_price, $currency_symbol, TRUE);

        $result['tax_price'] = $the_tax_price_unformatted;
        // $result['tax_price_formatted'] = $the_tax_price_formatted;

        if($decimal == 'comma'){
            $total_p = str_replace('.',',',$order->total_price);
        }else{
            $total_p = $order->total_price;		
        }
        $total_price_unformatted = (float) str_replace(',', '.', $order->total_price);
        $total_price_formatted = rp_handle_currency_position($total_p, $currency_symbol, TRUE);

        $result['total_price'] = $total_price_unformatted;
        // $result['total_price_formatted'] = $total_price_formatted;

        return $result;

    }

    public static function prepare( $o_id = 0, $action = '' ) {

        global $rpQuery;

        $rs_orders    = $rpQuery->prefix . "rs_orders";

        $rs_customer    = $rpQuery->prefix . "rs_customer";

        $rs_coupons    = $rpQuery->prefix . "rs_coupons";

        $rs_customer_business    = $rpQuery->prefix . "rs_customer_business";

        $rs_company_location    = $rpQuery->prefix . "rs_company_location";

        $rs_category    = $rpQuery->prefix . "rs_category";

        $rs_brand    = $rpQuery->prefix . "rs_brand";

        $rs_model    = $rpQuery->prefix . "rs_model";

        $orders = $rpQuery->get_results("SELECT o.*, cu.*, c.*,cb.*,loc.*, o.customer_id_fk AS customer_id_fk FROM $rs_orders as o LEFT JOIN $rs_customer as cu ON o.customer_id_fk = cu.customer_id LEFT JOIN $rs_coupons as c ON c.coupons_id = o.coupon_id_fk LEFT JOIN $rs_customer_business as cb ON cu.customer_id = cb.customer_id_fk LEFT JOIN $rs_company_location as loc ON loc.location_id = o.location_id_fk WHERE o_id = '".rp_escape_sql($o_id)."' ORDER BY o.o_date_time DESC");

        $order = null;

        if(!empty($orders)) {
            $order = $orders[0];
        } else {
            return array();
        }

        $_delivery_method = str_replace(' ', '_', strtolower(trim($order->delivery_method)));
        if( $_delivery_method === 'ship_device' ) {
            $order->delivery_date = date('d-m-Y', strtotime($order->created_time));
            $order->delivery_time = date('H:i', strtotime($order->created_time));
        }

        $m_id = $order->m_id_fk;
        $models = $rpQuery->get_results("SELECT * FROM `$rs_model` WHERE m_id = '".rp_escape_sql($m_id)."'");
        $b_id = $models[0]->brand_id_fk;
        $brands = $rpQuery->get_results("SELECT * FROM `$rs_brand` WHERE b_id = '".rp_escape_sql($b_id)."'");
        $c_id = $models[0]->device_type; 
        $cats = $rpQuery->get_results("SELECT * FROM `$rs_category` WHERE c_id = '".rp_escape_sql($c_id)."'");

        $model = '';
        if(!empty($models)) {
            $model = $models[0]->m_name;
        }
        $brand = '';
        if(!empty($brands)) {
            $brand = $brands[0]->b_name;
        }
        $category = '';
        if(!empty($cats)) {
            $category = $cats[0]->c_name;
        }

        $company_information = $rpQuery->prefix . "rs_company_information";
	    $c_results = $rpQuery->get_results("SELECT * FROM `$company_information`");

        $shop_name = $c_results[0]->company_name ?? '';

        $cancel_link = '';

        $shortcode_page_link = rp_get_cancel_link_by_order_id( $order->o_id );

        if( empty( $shortcode_page_link ) ) {

            $shortcode_page_link = rp_get_shortcode_page_link();

        }

        if( empty( $shortcode_page_link ) ) {

            $m_id = $order->m_id_fk;

            $_model = $rpQuery->get_row("SELECT m_uq_id FROM $rs_model WHERE m_id = '".rp_escape_sql($m_id)." LIMIT 1;'");

            if( !empty( $_model ) ) {

                $shortcode_page_link = rp_get_specific_shortcode_page_link( $_model->m_uq_id );

            }

        }

        $order_id = $o_id;

        $cancel_link = $shortcode_page_link;

        $cancel_link .= '?selected=cancel&id='.$order_id.'&secret_key='.md5($order->o_id.$order->customer_id_fk);

        $order_delivery_date = date('d-m-Y', strtotime( ($order->delivery_date ?? '') ) );

        $delivery_time = $order->delivery_time ?? '';

        if( !empty( $delivery_time ) ) {

            $localization = $rpQuery->prefix . "rs_localization";
            $localization_data = $rpQuery->get_results("SELECT * FROM $localization");

            if( strpos( $delivery_time, ' — ' ) === FALSE ) {

                if( $localization_data[0]->set_time_format == '24 hours (e.g. 15:00)' ) {

                    $delivery_time = date('H:i', strtotime( $delivery_time ) );

                } else {

                    $delivery_time = date('g:i a', strtotime( $delivery_time ) );

                }

            } else {

                $DateTime = explode(' — ', $delivery_time);

                if( $localization_data[0]->set_time_format == '24 hours (e.g. 15:00)' ) {
                    $newDateTime1 = date('H:i', strtotime($DateTime[0]));
                    $newDateTime2 = date('H:i', strtotime($DateTime[1]));
                    $newDateTime = $newDateTime1 . ' — ' . $newDateTime2;
                } else {
                    $newDateTime1 = date('g:i a', strtotime($DateTime[0]));
                    $newDateTime2 = date('g:i a', strtotime($DateTime[1]));
                    $newDateTime = $newDateTime1 . ' — ' . $newDateTime2;
                }

                $delivery_time = $newDateTime;

            }

        } else {

            $delivery_time = '--';

        }

        $o_date_time_exploded = explode(' ', $order->o_date_time);

        $o_date = '';

        $o_time = '';

        if(!empty($o_date_time_exploded) && count($o_date_time_exploded) >= 1) {
            $o_date = $o_date_time_exploded[0];
        }
        if(!empty($o_date_time_exploded) && count($o_date_time_exploded) >= 2) {
            $o_time = $o_date_time_exploded[1];
        }

        if( !empty( $o_date ) ) {
            $o_date = date('d-m-Y', strtotime($o_date));
        }

        $statuses = array(
            '1' => 'Pending',
            '2' => 'Offered',
            '3' => 'Approved',
            '4' => 'Cancelled'
        );

        $the_status = '--';

        foreach( $statuses as $skey => $svalue ) {

            if( $skey == $order->status_id_fk ) {

                $the_status = $svalue;

            }

        }

        if( trim( $action ) === 'deleted' ) {

            $the_status = 'Deleted';

        }

        $allowed_dmethods = array('come by our store', 'pickup service', 'repair on location');

        if( !in_array( strtolower($order->delivery_method), $allowed_dmethods ) ) {

            $order->reschedule_link = '';

        }

        $rs_planning_and_discount = $rpQuery->prefix . "rs_planning_and_discount";

        $planning_discount = $rpQuery->get_results("SELECT * FROM $rs_planning_and_discount");

        $time_slots = $planning_discount[0]->booking_slots_length;

        $time_slots = str_replace(strtolower(' Minutes (Default)'), '', strtolower($time_slots));

        $time_slots = trim(str_replace('minutes', '', strtolower($time_slots)));

        $time_slots = (int) $time_slots;

        if( strpos( $order->delivery_time, ' — ' ) === FALSE ) {

            if( strtolower($order->delivery_method) == 'ship device' ) {

                $start_time = date('Y-m-d H:i', strtotime($order->delivery_date . ' '. $order->delivery_time));

                $end_time = $start_time;

            } else {

                $start_time = date('Y-m-d H:i', strtotime($order->delivery_date . ' '. $order->delivery_time));

                $end_time = date('Y-m-d H:i', strtotime($order->delivery_date . ' '. $order->delivery_time . ' +'.$time_slots.' minutes'));

            }

        } else {

            $exploded_time = explode(' — ', $order->delivery_time);

            $start_time = date('Y-m-d H:i', strtotime($order->delivery_date . ' '. $exploded_time[0]));

            $end_time = date('Y-m-d H:i', strtotime($order->delivery_date . ' '. $exploded_time[1]));

        }

        $start_time = str_replace(' ', 'T', $start_time);

        $end_time = str_replace(' ', 'T', $end_time);

        $result_arr =  array(

            'action' => $action,

            'event_start_datetime' => $start_time,

            'event_end_datetime' => $end_time,

            'delivery_method' => $order->delivery_method,

            'appointment_date' => ($order_delivery_date ?? ''),

            'appointment_time' => $delivery_time,

            'appointment_number' => $order->appointment_number,

            'appointment_status' => $the_status,

            'created_date' => ($o_date ?? '--'),

            'created_time' => ($o_time ?? '--'),

            'customer_name' => $order->customer_name,

            'customer_email' => $order->customer_email,

            'customer_phone' => $order->customer_phone,

            'customer_house_no' => $order->customer_house_no,

            'customer_street_address' => $order->customer_street_address,

            'customer_city' => $order->customer_city,

            'customer_zipcode' => $order->customer_zipcode,

            'customer_notes' => $order->notes,

            'category' => $category,

            'brand' => $brand,

            'model' => $model,

            'color' => $order->color,

            'shop_name' => $shop_name,

            'location_name' => $order->location_name,

            'location_telephone' => $order->location_telephone,

            'location_address' => $order->location_address,

            'location_zipcode_city' => $order->location_city_district,

            'reschedule_link' => ($order->reschedule_link ?? ''),

            'cancel_link' => $cancel_link

        );

        $order_details = self::order_details( $o_id );

        foreach( $order_details as $key => $value ) {

            $result_arr[$key] = $value;

        }

        return $result_arr;

    }

}
